/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/platform","vs/base/common/errors","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/network","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/resources","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","os","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(_){for(var t=[],N=0,D=_.length;N<D;N++)t[N]=ee[_[N]];return t};define(ee[57],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function N(D,b){if(!D)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=N}),define(ee[44],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function N(C){return(T,u,m)=>{let p=null,I=null;if(typeof m.value=="function"?(p="value",I=m.value):typeof m.get=="function"&&(p="get",I=m.get),!I)throw new Error("not supported");m[p]=C(I,u)}}t.createDecorator=N;function D(C,T,u){let m=null,p=null;if(typeof u.value=="function"?(m="value",p=u.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(m="get",p=u.get),!p)throw new Error("not supported");const I=`$memoize$${T}`;u[m]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,g)}),this[I]}}t.memoize=D;function b(C,T,u){return N((m,p)=>{const I=`$debounce$${p}`,g=`$debounce$result$${p}`;return function(...R){this[g]||(this[g]=u?u():void 0),clearTimeout(this[I]),T&&(this[g]=T(this[g],...R),R=[this[g]]),this[I]=setTimeout(()=>{m.apply(this,R),this[g]=u?u():void 0},C)}})}t.debounce=b;function F(C,T,u){return N((m,p)=>{const I=`$throttle$timer$${p}`,g=`$throttle$result$${p}`,R=`$throttle$lastRun$${p}`,a=`$throttle$pending$${p}`;return function(...c){if(this[g]||(this[g]=u?u():void 0),(this[R]===null||this[R]===void 0)&&(this[R]=-Number.MAX_VALUE),T&&(this[g]=T(this[g],...c)),this[a])return;const w=this[R]+C;w<=Date.now()?(this[R]=Date.now(),m.apply(this,[this[g]]),this[g]=u?u():void 0):(this[a]=!0,this[I]=setTimeout(()=>{this[a]=!1,this[R]=Date.now(),m.apply(this,[this[g]]),this[g]=u?u():void 0},w-Date.now()))}})}t.throttle=F}),define(ee[18],te([0,1,9]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function D(L,y=0){return L[L.length-(1+y)]}t.tail=D;function b(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}t.tail2=b;function F(L,y,d=(A,k)=>A===k){if(L===y)return!0;if(!L||!y||L.length!==y.length)return!1;for(let A=0,k=L.length;A<k;A++)if(!d(L[A],y[A]))return!1;return!0}t.equals=F;function C(L,y,d){let A=0,k=L.length-1;for(;A<=k;){const V=(A+k)/2|0,j=d(L[V],y);if(j<0)A=V+1;else if(j>0)k=V-1;else return V}return-(A+1)}t.binarySearch=C;function T(L,y){let d=0,A=L.length;if(A===0)return 0;for(;d<A;){const k=Math.floor((d+A)/2);y(L[k])?A=k:d=k+1}return d}t.findFirstInSorted=T;function u(L,y,d){if(L=L|0,L>=y.length)throw new TypeError("invalid index");let A=y[Math.floor(y.length*Math.random())],k=[],V=[],j=[];for(let X of y){const G=d(X,A);G<0?k.push(X):G>0?V.push(X):j.push(X)}return L<k.length?u(L,k,d):L<k.length+j.length?j[0]:u(L-(k.length+j.length),V,d)}t.quickSelect=u;function m(L,y){const d=[];let A;for(const k of L.slice(0).sort(y))!A||y(A[0],k)!==0?(A=[k],d.push(A)):A.push(k);return d}t.groupBy=m;function p(L,y,d){const A=[];function k(X,G,ne){if(G===0&&ne.length===0)return;const se=A[A.length-1];se&&se.start+se.deleteCount===X?(se.deleteCount+=G,se.toInsert.push(...ne)):A.push({start:X,deleteCount:G,toInsert:ne})}let V=0,j=0;for(;;){if(V===L.length){k(V,0,y.slice(j));break}if(j===y.length){k(V,L.length-V,[]);break}const X=L[V],G=y[j],ne=d(X,G);ne===0?(V+=1,j+=1):ne<0?(k(V,1,[]),V+=1):ne>0&&(k(V,0,[G]),j+=1)}return A}t.sortedDiff=p;function I(L,y,d){const A=p(L,y,d),k=[],V=[];for(const j of A)k.push(...L.slice(j.start,j.start+j.deleteCount)),V.push(...j.toInsert);return{removed:k,added:V}}t.delta=I;function g(L,y,d){if(d===0)return[];const A=L.slice(0,d).sort(y);return a(L,y,A,d,L.length),A}t.top=g;function R(L,y,d,A,k){return d===0?Promise.resolve([]):new Promise((V,j)=>{(async()=>{const X=L.length,G=L.slice(0,d).sort(y);for(let ne=d,se=Math.min(d+A,X);ne<X;ne=se,se=Math.min(se+A,X)){if(ne>d&&await new Promise(le=>setTimeout(le)),k&&k.isCancellationRequested)throw(0,N.canceled)();a(L,y,G,ne,se)}return G})().then(V,j)})}t.topAsync=R;function a(L,y,d,A,k){for(const V=d.length;A<k;A++){const j=L[A];if(y(j,d[V-1])<0){d.pop();const X=T(d,G=>y(j,G)<0);d.splice(X,0,j)}}}function c(L){return L.filter(y=>!!y)}t.coalesce=c;function w(L){let y=0;for(let d=0;d<L.length;d++)L[d]&&(L[y]=L[d],y+=1);L.length=y}t.coalesceInPlace=w;function f(L,y,d){L.splice(d,0,L.splice(y,1)[0])}t.move=f;function v(L){return!Array.isArray(L)||L.length===0}t.isFalsyOrEmpty=v;function h(L){return Array.isArray(L)&&L.length>0}t.isNonEmptyArray=h;function o(L,y){if(!y)return L.filter((A,k)=>L.indexOf(A)===k);const d=Object.create(null);return L.filter(A=>{const k=y(A);return d[k]?!1:(d[k]=!0,!0)})}t.distinct=o;function s(L){const y=new Set;return L.filter(d=>y.has(d)?!1:(y.add(d),!0))}t.distinctES6=s;function e(L){const y=Object.create(null);return d=>{const A=L(d);return y[A]?!1:(y[A]=!0,!0)}}t.uniqueFilter=e;function n(L,y){for(let d=L.length-1;d>=0;d--){const A=L[d];if(y(A))return d}return-1}t.lastIndex=n;function i(L,y){return L.length>0?L[0]:y}t.firstOrDefault=i;function r(L,y,d=(A,k)=>A===k){let A=0;for(let k=0,V=Math.min(L.length,y.length);k<V&&d(L[k],y[k]);k++)A++;return A}t.commonPrefixLength=r;function l(L){return[].concat(...L)}t.flatten=l;function E(L,y){let d=typeof y=="number"?L:0;typeof y=="number"?d=L:(d=0,y=L);const A=[];if(d<=y)for(let k=d;k<y;k++)A.push(k);else for(let k=d;k>y;k--)A.push(k);return A}t.range=E;function P(L,y,d){return L.reduce((A,k)=>(A[y(k)]=d?d(k):k,A),Object.create(null))}t.index=P;function U(L,y){return L.push(y),()=>S(L,y)}t.insert=U;function S(L,y){const d=L.indexOf(y);if(d>-1)return L.splice(d,1),y}t.remove=S;function O(L,y,d){const A=L.slice(0,y),k=L.slice(y);return A.concat(d,k)}t.arrayInsert=O;function x(L,y){let d;if(typeof y=="number"){let A=y;d=()=>{const k=Math.sin(A++)*179426549;return k-Math.floor(k)}}else d=Math.random;for(let A=L.length-1;A>0;A-=1){const k=Math.floor(d()*(A+1)),V=L[A];L[A]=L[k],L[k]=V}}t.shuffle=x;function B(L,y){const d=L.indexOf(y);d>-1&&(L.splice(d,1),L.unshift(y))}t.pushToStart=B;function J(L,y){const d=L.indexOf(y);d>-1&&(L.splice(d,1),L.push(y))}t.pushToEnd=J;function ie(L,y){return Array.isArray(L)?L.map(y):y(L)}t.mapArrayOrNot=ie;function oe(L){return Array.isArray(L)?L:[L]}t.asArray=oe;function Z(L){return L[Math.floor(Math.random()*L.length)]}t.getRandomElement=Z;function H(L,y){for(const d of L){const A=y(d);if(A!==void 0)return A}}t.mapFind=H;function Q(L,y,d){const A=re(L,y),k=L.length,V=d.length;L.length=k+V;for(let j=k-1;j>=A;j--)L[j+V]=L[j];for(let j=0;j<V;j++)L[j+A]=d[j]}t.insertInto=Q;function Y(L,y,d,A){const k=re(L,y),V=L.splice(k,d);return Q(L,k,A),V}t.splice=Y;function re(L,y){return y<0?Math.max(y+L.length,0):Math.min(y,L.length)}function $(L,y){let d=Number.MAX_SAFE_INTEGER,A=0;return L.forEach((k,V)=>{const j=y(k);j<d&&(d=j,A=V)}),A}t.minIndex=$;function M(L,y){let d=Number.MIN_SAFE_INTEGER,A=0;return L.forEach((k,V)=>{const j=y(k);j>d&&(d=j,A=V)}),A}t.maxIndex=M;class W{constructor(y){this.items=y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(y){let d=this.firstIdx;for(;d<this.items.length&&y(this.items[d]);)d++;const A=d===this.firstIdx?null:this.items.slice(this.firstIdx,d);return this.firstIdx=d,A}takeFromEndWhile(y){let d=this.lastIdx;for(;d>=0&&y(this.items[d]);)d--;const A=d===this.lastIdx?null:this.items.slice(d+1,this.lastIdx+1);return this.lastIdx=d,A}}t.ArrayQueue=W}),define(ee[58],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var N;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(N=t.ScanError||(t.ScanError={}));var D;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var F;(function(e){e.DEFAULT={allowTrailingComma:!0}})(F=t.ParseOptions||(t.ParseOptions={}));function C(e,n=!1){let i=0,r=e.length,l="",E=0,P=16,U=0;function S(Z){let H=0,Q=0;for(;H<Z;){const Y=e.charCodeAt(i);if(Y>=48&&Y<=57)Q=Q*16+Y-48;else if(Y>=65&&Y<=70)Q=Q*16+Y-65+10;else if(Y>=97&&Y<=102)Q=Q*16+Y-97+10;else break;i++,H++}return H<Z&&(Q=-1),Q}function O(Z){i=Z,l="",E=0,P=16,U=0}function x(){const Z=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&m(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&m(e.charCodeAt(i)))for(i++;i<e.length&&m(e.charCodeAt(i));)i++;else return U=3,e.substring(Z,i);let H=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&m(e.charCodeAt(i))){for(i++;i<e.length&&m(e.charCodeAt(i));)i++;H=i}else U=3;return e.substring(Z,H)}function B(){let Z="",H=i;for(;;){if(i>=r){Z+=e.substring(H,i),U=2;break}const Q=e.charCodeAt(i);if(Q===34){Z+=e.substring(H,i),i++;break}if(Q===92){if(Z+=e.substring(H,i),i++,i>=r){U=2;break}switch(e.charCodeAt(i++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const re=S(4);re>=0?Z+=String.fromCharCode(re):U=4;break;default:U=5}H=i;continue}if(Q>=0&&Q<=31)if(u(Q)){Z+=e.substring(H,i),U=2;break}else U=6;i++}return Z}function J(){if(l="",U=0,E=i,i>=r)return E=r,P=17;let Z=e.charCodeAt(i);if(T(Z)){do i++,l+=String.fromCharCode(Z),Z=e.charCodeAt(i);while(T(Z));return P=15}if(u(Z))return i++,l+=String.fromCharCode(Z),Z===13&&e.charCodeAt(i)===10&&(i++,l+=`
`),P=14;switch(Z){case 123:return i++,P=1;case 125:return i++,P=2;case 91:return i++,P=3;case 93:return i++,P=4;case 58:return i++,P=6;case 44:return i++,P=5;case 34:return i++,l=B(),P=10;case 47:const H=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<r&&!u(e.charCodeAt(i));)i++;return l=e.substring(H,i),P=12}if(e.charCodeAt(i+1)===42){i+=2;const Q=r-1;let Y=!1;for(;i<Q;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,Y=!0;break}i++}return Y||(i++,U=1),l=e.substring(H,i),P=13}return l+=String.fromCharCode(Z),i++,P=16;case 45:if(l+=String.fromCharCode(Z),i++,i===r||!m(e.charCodeAt(i)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=x(),P=11;default:for(;i<r&&ie(Z);)i++,Z=e.charCodeAt(i);if(E!==i){switch(l=e.substring(E,i),l){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return l+=String.fromCharCode(Z),i++,P=16}}function ie(Z){if(T(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let Z;do Z=J();while(Z>=12&&Z<=15);return Z}return{setPosition:O,getPosition:()=>i,scan:n?oe:J,getToken:()=>P,getTokenValue:()=>l,getTokenOffset:()=>E,getTokenLength:()=>i-E,getTokenError:()=>U}}t.createScanner=C;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function m(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function I(e,n){const i=[],r=new Object;let l;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function U(S,O,x,B){E.value=S,E.offset=O,E.length=x,E.type=B,E.colonOffset=void 0,l=E}try{h(e,{onObjectBegin:(S,O)=>{if(n<=S)throw r;l=void 0,P=n>S,i.push("")},onObjectProperty:(S,O,x)=>{if(n<O||(U(S,O,x,"property"),i[i.length-1]=S,n<=O+x))throw r},onObjectEnd:(S,O)=>{if(n<=S)throw r;l=void 0,i.pop()},onArrayBegin:(S,O)=>{if(n<=S)throw r;l=void 0,i.push(0)},onArrayEnd:(S,O)=>{if(n<=S)throw r;l=void 0,i.pop()},onLiteralValue:(S,O,x)=>{if(n<O||(U(S,O,x,s(S)),n<=O+x))throw r},onSeparator:(S,O,x)=>{if(n<=O)throw r;if(S===":"&&l&&l.type==="property")l.colonOffset=O,P=!1,l=void 0;else if(S===","){const B=i[i.length-1];typeof B=="number"?i[i.length-1]=B+1:(P=!0,i[i.length-1]=""),l=void 0}}})}catch(S){if(S!==r)throw S}return{path:i,previousNode:l,isAtPropertyKey:P,matches:S=>{let O=0;for(let x=0;O<S.length&&x<i.length;x++)if(S[O]===i[x]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}t.getLocation=I;function g(e,n=[],i=F.DEFAULT){let r=null,l=[];const E=[];function P(S){Array.isArray(l)?l.push(S):r!==null&&(l[r]=S)}return h(e,{onObjectBegin:()=>{const S={};P(S),E.push(l),l=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const S=[];P(S),E.push(l),l=S,r=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:P,onError:(S,O,x)=>{n.push({error:S,offset:O,length:x})}},i),l[0]}t.parse=g;function R(e,n=[],i=F.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){r.type==="property"&&(r.length=S-r.offset,r=r.parent)}function E(S){return r.children.push(S),S}h(e,{onObjectBegin:S=>{r=E({type:"object",offset:S,length:-1,parent:r,children:[]})},onObjectProperty:(S,O,x)=>{r=E({type:"property",offset:O,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:S,offset:O,length:x,parent:r})},onObjectEnd:(S,O)=>{r.length=S+O-r.offset,r=r.parent,l(S+O)},onArrayBegin:(S,O)=>{r=E({type:"array",offset:S,length:-1,parent:r,children:[]})},onArrayEnd:(S,O)=>{r.length=S+O-r.offset,r=r.parent,l(S+O)},onLiteralValue:(S,O,x)=>{E({type:s(S),offset:O,length:x,parent:r,value:S}),l(O+x)},onSeparator:(S,O,x)=>{r.type==="property"&&(S===":"?r.colonOffset=O:S===","&&l(O))},onError:(S,O,x)=>{n.push({error:S,offset:O,length:x})}},i);const U=r.children[0];return U&&delete U.parent,U}t.parseTree=R;function a(e,n){if(!e)return;let i=e;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const E of i.children)if(Array.isArray(E.children)&&E.children[0].value===r){i=E.children[1],l=!0;break}if(!l)return}else{const l=r;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}t.findNodeAtLocation=a;function c(e){if(!e.parent||!e.parent.children)return[];const n=c(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;n.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&n.push(i)}return n}t.getNodePath=c;function w(e){switch(e.type){case"array":return e.children.map(w);case"object":const n=Object.create(null);for(let i of e.children){const r=i.children[1];r&&(n[i.children[0].value]=w(r))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=w;function f(e,n,i=!1){return n>=e.offset&&n<e.offset+e.length||i&&n===e.offset+e.length}t.contains=f;function v(e,n,i=!1){if(f(e,n,i)){const r=e.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=n;l++){const E=v(r[l],n,i);if(E)return E}return e}}t.findNodeAtOffset=v;function h(e,n,i=F.DEFAULT){const r=C(e,!1);function l(d){return d?()=>d(r.getTokenOffset(),r.getTokenLength()):()=>!0}function E(d){return d?A=>d(A,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=l(n.onObjectBegin),U=E(n.onObjectProperty),S=l(n.onObjectEnd),O=l(n.onArrayBegin),x=l(n.onArrayEnd),B=E(n.onLiteralValue),J=E(n.onSeparator),ie=l(n.onComment),oe=E(n.onError),Z=i&&i.disallowComments,H=i&&i.allowTrailingComma;function Q(){for(;;){const d=r.scan();switch(r.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:Z||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(d){case 12:case 13:Z?Y(10):ie();break;case 16:Y(1);break;case 15:case 14:break;default:return d}}}function Y(d,A=[],k=[]){if(oe(d),A.length+k.length>0){let V=r.getToken();for(;V!==17;){if(A.indexOf(V)!==-1){Q();break}else if(k.indexOf(V)!==-1)break;V=Q()}}}function re(d){const A=r.getTokenValue();return d?B(A):U(A),Q(),!0}function $(){switch(r.getToken()){case 11:let d=0;try{d=JSON.parse(r.getTokenValue()),typeof d!="number"&&(Y(2),d=0)}catch(A){Y(2)}B(d);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return Q(),!0}function M(){return r.getToken()!==10?(Y(3,[],[2,5]),!1):(re(!1),r.getToken()===6?(J(":"),Q(),y()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function W(){P(),Q();let d=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(d||Y(4,[],[]),J(","),Q(),r.getToken()===2&&H)break}else d&&Y(6,[],[]);M()||Y(4,[],[2,5]),d=!0}return S(),r.getToken()!==2?Y(7,[2],[]):Q(),!0}function L(){O(),Q();let d=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(d||Y(4,[],[]),J(","),Q(),r.getToken()===4&&H)break}else d&&Y(6,[],[]);y()||Y(4,[],[4,5]),d=!0}return x(),r.getToken()!==4?Y(8,[4],[]):Q(),!0}function y(){switch(r.getToken()){case 3:return L();case 1:return W();case 10:return re(!0);default:return $()}}return Q(),r.getToken()===17?i.allowEmptyContent?!0:(Y(4,[],[]),!1):y()?(r.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}t.visit=h;function o(e,n){let i=C(e),r=[],l,E=0,P;do switch(P=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:E!==P&&r.push(e.substring(E,P)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),E=i.getPosition();break}while(l!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function _(b){const F=[];typeof b=="number"&&F.push("code/timeOrigin",b);function C(u){F.push(u,Date.now())}function T(){const u=[];for(let m=0;m<F.length;m+=2)u.push({name:F[m],startTime:F[m+1]});return u}return{mark:C,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const C of performance.getEntriesByType("mark"))F.push({name:C.name,startTime:Math.round(b+C.startTime)});return F}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function N(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var N=t();for(var D in N)(typeof exports=="object"?exports:_)[D]=N[D]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function N(D){if(t[D])return t[D].exports;var b=t[D]={i:D,l:!1,exports:{}};return _[D].call(b.exports,b,b.exports,N),b.l=!0,b.exports}return N.m=_,N.c=t,N.d=function(D,b,F){N.o(D,b)||Object.defineProperty(D,b,{enumerable:!0,get:F})},N.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,b){if(1&b&&(D=N(D)),8&b||4&b&&typeof D=="object"&&D&&D.__esModule)return D;var F=Object.create(null);if(N.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:D}),2&b&&typeof D!="string")for(var C in D)N.d(F,C,function(T){return D[T]}.bind(null,C));return F},N.n=function(D){var b=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(b,"a",b),b},N.o=function(D,b){return Object.prototype.hasOwnProperty.call(D,b)},N.p="",N(N.s=0)}([function(_,t,N){(function(D){var b;t=_.exports=k,b=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var F=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],u=t.src=[],m=0,p=m++;u[p]="0|[1-9]\\d*";var I=m++;u[I]="[0-9]+";var g=m++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var R=m++;u[R]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var a=m++;u[a]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var c=m++;u[c]="(?:"+u[p]+"|"+u[g]+")";var w=m++;u[w]="(?:"+u[I]+"|"+u[g]+")";var f=m++;u[f]="(?:-("+u[c]+"(?:\\."+u[c]+")*))";var v=m++;u[v]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var h=m++;u[h]="[0-9A-Za-z-]+";var o=m++;u[o]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var s=m++,e="v?"+u[R]+u[f]+"?"+u[o]+"?";u[s]="^"+e+"$";var n="[v=\\s]*"+u[a]+u[v]+"?"+u[o]+"?",i=m++;u[i]="^"+n+"$";var r=m++;u[r]="((?:<|>)?=?)";var l=m++;u[l]=u[I]+"|x|X|\\*";var E=m++;u[E]=u[p]+"|x|X|\\*";var P=m++;u[P]="[v=\\s]*("+u[E]+")(?:\\.("+u[E]+")(?:\\.("+u[E]+")(?:"+u[f]+")?"+u[o]+"?)?)?";var U=m++;u[U]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[v]+")?"+u[o]+"?)?)?";var S=m++;u[S]="^"+u[r]+"\\s*"+u[P]+"$";var O=m++;u[O]="^"+u[r]+"\\s*"+u[U]+"$";var x=m++;u[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=m++;u[B]="(?:~>?)";var J=m++;u[J]="(\\s*)"+u[B]+"\\s+",T[J]=new RegExp(u[J],"g");var ie=m++;u[ie]="^"+u[B]+u[P]+"$";var oe=m++;u[oe]="^"+u[B]+u[U]+"$";var Z=m++;u[Z]="(?:\\^)";var H=m++;u[H]="(\\s*)"+u[Z]+"\\s+",T[H]=new RegExp(u[H],"g");var Q=m++;u[Q]="^"+u[Z]+u[P]+"$";var Y=m++;u[Y]="^"+u[Z]+u[U]+"$";var re=m++;u[re]="^"+u[r]+"\\s*("+n+")$|^$";var $=m++;u[$]="^"+u[r]+"\\s*("+e+")$|^$";var M=m++;u[M]="(\\s*)"+u[r]+"\\s*("+n+"|"+u[P]+")",T[M]=new RegExp(u[M],"g");var W=m++;u[W]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var L=m++;u[L]="^\\s*("+u[U]+")\\s+-\\s+("+u[U]+")\\s*$";var y=m++;u[y]="(<|>)?=?\\s*\\*";for(var d=0;d<35;d++)b(d,u[d]),T[d]||(T[d]=new RegExp(u[d]));function A(z,q){if(z instanceof k)return z;if(typeof z!="string"||z.length>F||!(q?T[i]:T[s]).test(z))return null;try{return new k(z,q)}catch(K){return null}}function k(z,q){if(z instanceof k){if(z.loose===q)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof k))return new k(z,q);b("SemVer",z,q),this.loose=q;var K=z.trim().match(q?T[i]:T[s]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var ce=+ae;if(ce>=0&&ce<C)return ce}return ae}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=A,t.valid=function(z,q){var K=A(z,q);return K?K.version:null},t.clean=function(z,q){var K=A(z.trim().replace(/^[=v]+/,""),q);return K?K.version:null},t.SemVer=k,k.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},k.prototype.toString=function(){return this.version},k.prototype.compare=function(z){return b("SemVer.compare",this.version,this.loose,z),z instanceof k||(z=new k(z,this.loose)),this.compareMain(z)||this.comparePre(z)},k.prototype.compareMain=function(z){return z instanceof k||(z=new k(z,this.loose)),j(this.major,z.major)||j(this.minor,z.minor)||j(this.patch,z.patch)},k.prototype.comparePre=function(z){if(z instanceof k||(z=new k(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],ae=z.prerelease[q];if(b("prerelease compare",q,K,ae),K===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(K===void 0)return-1;if(K!==ae)return j(K,ae)}while(++q)},k.prototype.inc=function(z,q){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,q,K,ae){typeof K=="string"&&(ae=K,K=void 0);try{return new k(z,K).inc(q,ae).version}catch(ce){return null}},t.diff=function(z,q){if(se(z,q))return null;var K=A(z),ae=A(q);if(K.prerelease.length||ae.prerelease.length){for(var ce in K)if((ce==="major"||ce==="minor"||ce==="patch")&&K[ce]!==ae[ce])return"pre"+ce;return"prerelease"}for(var ce in K)if((ce==="major"||ce==="minor"||ce==="patch")&&K[ce]!==ae[ce])return ce},t.compareIdentifiers=j;var V=/^[0-9]+$/;function j(z,q){var K=V.test(z),ae=V.test(q);return K&&ae&&(z=+z,q=+q),K&&!ae?-1:ae&&!K?1:z<q?-1:z>q?1:0}function X(z,q,K){return new k(z,K).compare(new k(q,K))}function G(z,q,K){return X(z,q,K)>0}function ne(z,q,K){return X(z,q,K)<0}function se(z,q,K){return X(z,q,K)===0}function le(z,q,K){return X(z,q,K)!==0}function pe(z,q,K){return X(z,q,K)>=0}function Ie(z,q,K){return X(z,q,K)<=0}function ye(z,q,K,ae){var ce;switch(q){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ce=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),ce=z!==K;break;case"":case"=":case"==":ce=se(z,K,ae);break;case"!=":ce=le(z,K,ae);break;case">":ce=G(z,K,ae);break;case">=":ce=pe(z,K,ae);break;case"<":ce=ne(z,K,ae);break;case"<=":ce=Ie(z,K,ae);break;default:throw new TypeError("Invalid operator: "+q)}return ce}function me(z,q){if(z instanceof me){if(z.loose===q)return z;z=z.value}if(!(this instanceof me))return new me(z,q);b("comparator",z,q),this.loose=q,this.parse(z),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(z,q){return j(q,z)},t.major=function(z,q){return new k(z,q).major},t.minor=function(z,q){return new k(z,q).minor},t.patch=function(z,q){return new k(z,q).patch},t.compare=X,t.compareLoose=function(z,q){return X(z,q,!0)},t.rcompare=function(z,q,K){return X(q,z,K)},t.sort=function(z,q){return z.sort(function(K,ae){return t.compare(K,ae,q)})},t.rsort=function(z,q){return z.sort(function(K,ae){return t.rcompare(K,ae,q)})},t.gt=G,t.lt=ne,t.eq=se,t.neq=le,t.gte=pe,t.lte=Ie,t.cmp=ye,t.Comparator=me;var Fe={};function Ee(z,q){if(z instanceof Ee)return z.loose===q?z:new Ee(z.raw,q);if(z instanceof me)return new Ee(z.value,q);if(!(this instanceof Ee))return new Ee(z,q);if(this.loose=q,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function We(z,q,K,ae,ce,Pe,ge,Ce,Se,Te,ke,be,De){return((q=Re(K)?"":Re(ae)?">="+K+".0.0":Re(ce)?">="+K+"."+ae+".0":">="+q)+" "+(Ce=Re(Se)?"":Re(Te)?"<"+(+Se+1)+".0.0":Re(ke)?"<"+Se+"."+(+Te+1)+".0":be?"<="+Se+"."+Te+"."+ke+"-"+be:"<="+Ce)).trim()}function je(z,q){for(var K=0;K<z.length;K++)if(!z[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<z.length;K++)if(b(z[K].semver),z[K].semver!==Fe&&z[K].semver.prerelease.length>0){var ae=z[K].semver;if(ae.major===q.major&&ae.minor===q.minor&&ae.patch===q.patch)return!0}return!1}return!0}function xe(z,q,K){try{q=new Ee(q,K)}catch(ae){return!1}return q.test(z)}function ze(z,q,K,ae){var ce,Pe,ge,Ce,Se;switch(z=new k(z,ae),q=new Ee(q,ae),K){case">":ce=G,Pe=Ie,ge=ne,Ce=">",Se=">=";break;case"<":ce=ne,Pe=pe,ge=G,Ce="<",Se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(z,q,ae))return!1;for(var Te=0;Te<q.set.length;++Te){var ke=q.set[Te],be=null,De=null;if(ke.forEach(function(Oe){Oe.semver===Fe&&(Oe=new me(">=0.0.0")),be=be||Oe,De=De||Oe,ce(Oe.semver,be.semver,ae)?be=Oe:ge(Oe.semver,De.semver,ae)&&(De=Oe)}),be.operator===Ce||be.operator===Se||(!De.operator||De.operator===Ce)&&Pe(z,De.semver)||De.operator===Se&&ge(z,De.semver))return!1}return!0}me.prototype.parse=function(z){var q=this.loose?T[re]:T[$],K=z.match(q);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new k(K[2],this.loose):this.semver=Fe},me.prototype.toString=function(){return this.value},me.prototype.test=function(z){return b("Comparator.test",z,this.loose),this.semver===Fe||(typeof z=="string"&&(z=new k(z,this.loose)),ye(z,this.operator,this.semver,this.loose))},me.prototype.intersects=function(z,q){if(!(z instanceof me))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new Ee(z.value,q),xe(this.value,K,q);if(z.operator==="")return K=new Ee(this.value,q),xe(z.semver,K,q);var ae=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ce=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Pe=this.semver.version===z.semver.version,ge=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=ye(this.semver,"<",z.semver,q)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Se=ye(this.semver,">",z.semver,q)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ae||ce||Pe&&ge||Ce||Se},t.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(z){var q=this.loose;z=z.trim(),b("range",z,q);var K=q?T[L]:T[W];z=z.replace(K,We),b("hyphen replace",z),z=z.replace(T[M],"$1$2$3"),b("comparator trim",z,T[M]),z=(z=(z=z.replace(T[J],"$1~")).replace(T[H],"$1^")).split(/\s+/).join(" ");var ae=q?T[re]:T[$],ce=z.split(" ").map(function(Pe){return function(ge,Ce){return b("comp",ge),ge=function(Se,Te){return Se.trim().split(/\s+/).map(function(ke){return function(be,De){b("caret",be,De);var Oe=De?T[Y]:T[Q];return be.replace(Oe,function(Ae,ue,de,ve,we){var Le;return b("caret",be,Ae,ue,de,ve,we),Re(ue)?Le="":Re(de)?Le=">="+ue+".0.0 <"+(+ue+1)+".0.0":Re(ve)?Le=ue==="0"?">="+ue+"."+de+".0 <"+ue+"."+(+de+1)+".0":">="+ue+"."+de+".0 <"+(+ue+1)+".0.0":we?(b("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),Le=ue==="0"?de==="0"?">="+ue+"."+de+"."+ve+we+" <"+ue+"."+de+"."+(+ve+1):">="+ue+"."+de+"."+ve+we+" <"+ue+"."+(+de+1)+".0":">="+ue+"."+de+"."+ve+we+" <"+(+ue+1)+".0.0"):(b("no pr"),Le=ue==="0"?de==="0"?">="+ue+"."+de+"."+ve+" <"+ue+"."+de+"."+(+ve+1):">="+ue+"."+de+"."+ve+" <"+ue+"."+(+de+1)+".0":">="+ue+"."+de+"."+ve+" <"+(+ue+1)+".0.0"),b("caret return",Le),Le})}(ke,Te)}).join(" ")}(ge,Ce),b("caret",ge),ge=function(Se,Te){return Se.trim().split(/\s+/).map(function(ke){return function(be,De){var Oe=De?T[oe]:T[ie];return be.replace(Oe,function(Ae,ue,de,ve,we){var Le;return b("tilde",be,Ae,ue,de,ve,we),Re(ue)?Le="":Re(de)?Le=">="+ue+".0.0 <"+(+ue+1)+".0.0":Re(ve)?Le=">="+ue+"."+de+".0 <"+ue+"."+(+de+1)+".0":we?(b("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),Le=">="+ue+"."+de+"."+ve+we+" <"+ue+"."+(+de+1)+".0"):Le=">="+ue+"."+de+"."+ve+" <"+ue+"."+(+de+1)+".0",b("tilde return",Le),Le})}(ke,Te)}).join(" ")}(ge,Ce),b("tildes",ge),ge=function(Se,Te){return b("replaceXRanges",Se,Te),Se.split(/\s+/).map(function(ke){return function(be,De){be=be.trim();var Oe=De?T[O]:T[S];return be.replace(Oe,function(Ae,ue,de,ve,we,Le){b("xRange",be,Ae,ue,de,ve,we,Le);var Ve=Re(de),Me=Ve||Re(ve),Ue=Me||Re(we);return ue==="="&&Ue&&(ue=""),Ve?Ae=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ue?(Me&&(ve=0),Ue&&(we=0),ue===">"?(ue=">=",Me?(de=+de+1,ve=0,we=0):Ue&&(ve=+ve+1,we=0)):ue==="<="&&(ue="<",Me?de=+de+1:ve=+ve+1),Ae=ue+de+"."+ve+"."+we):Me?Ae=">="+de+".0.0 <"+(+de+1)+".0.0":Ue&&(Ae=">="+de+"."+ve+".0 <"+de+"."+(+ve+1)+".0"),b("xRange return",Ae),Ae})}(ke,Te)}).join(" ")}(ge,Ce),b("xrange",ge),ge=function(Se,Te){return b("replaceStars",Se,Te),Se.trim().replace(T[y],"")}(ge,Ce),b("stars",ge),ge}(Pe,q)}).join(" ").split(/\s+/);return this.loose&&(ce=ce.filter(function(Pe){return!!Pe.match(ae)})),ce=ce.map(function(Pe){return new me(Pe,q)})},Ee.prototype.intersects=function(z,q){if(!(z instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ae){return z.set.some(function(ce){return ce.every(function(Pe){return ae.intersects(Pe,q)})})})})},t.toComparators=function(z,q){return new Ee(z,q).set.map(function(K){return K.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new k(z,this.loose));for(var q=0;q<this.set.length;q++)if(je(this.set[q],z))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(z,q,K){var ae=null,ce=null;try{var Pe=new Ee(q,K)}catch(ge){return null}return z.forEach(function(ge){Pe.test(ge)&&(ae&&ce.compare(ge)!==-1||(ce=new k(ae=ge,K)))}),ae},t.minSatisfying=function(z,q,K){var ae=null,ce=null;try{var Pe=new Ee(q,K)}catch(ge){return null}return z.forEach(function(ge){Pe.test(ge)&&(ae&&ce.compare(ge)!==1||(ce=new k(ae=ge,K)))}),ae},t.validRange=function(z,q){try{return new Ee(z,q).range||"*"}catch(K){return null}},t.ltr=function(z,q,K){return ze(z,q,"<",K)},t.gtr=function(z,q,K){return ze(z,q,">",K)},t.outside=ze,t.prerelease=function(z,q){var K=A(z,q);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,q,K){return z=new Ee(z,K),q=new Ee(q,K),z.intersects(q)},t.coerce=function(z){if(z instanceof k)return z;if(typeof z!="string")return null;var q=z.match(T[x]);return q==null?null:A((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,N(1))},function(_,t){var N,D,b=_.exports={};function F(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function T(w){if(N===setTimeout)return setTimeout(w,0);if((N===F||!N)&&setTimeout)return N=setTimeout,setTimeout(w,0);try{return N(w,0)}catch(f){try{return N.call(null,w,0)}catch(v){return N.call(this,w,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:F}catch(w){N=F}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch(w){D=C}})();var u,m=[],p=!1,I=-1;function g(){p&&u&&(p=!1,u.length?m=u.concat(m):I=-1,m.length&&R())}function R(){if(!p){var w=T(g);p=!0;for(var f=m.length;f;){for(u=m,m=[];++I<f;)u&&u[I].run();I=-1,f=m.length}u=null,p=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch(h){try{return D.call(null,v)}catch(o){return D.call(this,v)}}}(w)}}function a(w,f){this.fun=w,this.array=f}function c(){}b.nextTick=function(w){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];m.push(new a(w,f)),m.length!==1||p||T(R)},a.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=c,b.addListener=c,b.once=c,b.off=c,b.removeListener=c,b.removeAllListeners=c,b.emit=c,b.prependListener=c,b.prependOnceListener=c,b.listeners=function(w){return[]},b.binding=function(w){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(w){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(ee[36],te([0,1,9,2]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=b;function F(h){const o=h;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=F;function C(h,o){return new T(h,o)}t.newWriteableStream=C;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,N.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const n=e.indexOf(s);n>=0&&e.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=u;function m(h,o,s){const e=[];let n;for(;(n=h.read())!==null&&e.length<s;)e.push(n);return n===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return h.read()}}}t.peekReadable=m;function p(h,o){return new Promise((s,e)=>{const n=[];I(h,{onData:i=>{o&&n.push(i)},onError:i=>{o?e(i):s(void 0)},onEnd:()=>{s(o?o(n):void 0)}})})}t.consumeStream=p;function I(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=I;function g(h,o){return new Promise((s,e)=>{const n=new D.DisposableStore,i=[],r=P=>{if(i.push(P),i.length>o)return n.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},l=P=>e(P),E=()=>s({stream:h,buffer:i,ended:!0});n.add((0,D.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),n.add((0,D.toDisposable)(()=>h.removeListener("end",E))),h.on("end",E),n.add((0,D.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=g;function R(h,o){const s=C(o);return s.end(h),s}t.toStream=R;function a(){const h=C(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=a;function c(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=c;function w(h,o,s){const e=C(s);return I(h,{onData:n=>e.write(o.data(n)),onError:n=>e.error(o.error?o.error(n):n),onEnd:()=>e.end()}),e}t.transform=w;function f(h,o,s){let e=!1;return{read:()=>{const n=o.read();return e?n:(e=!0,n!==null?s([h,n]):h)}}}t.prefixedReadable=f;function v(h,o,s){let e=!1;const n=C(s);return I(o,{onData:i=>e?n.write(i):(e=!0,n.write(s([h,i]))),onError:i=>n.error(i),onEnd:()=>{e||(e=!0,n.write(h)),n.end()}}),n}t.prefixedStream=v}),define(ee[16],te([0,1,36]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let b,F;class C{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return D?new C(Buffer.allocUnsafe(r)):new C(new Uint8Array(r))}static wrap(r){return D&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new C(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&D?new C(Buffer.from(r)):(b||(b=new TextEncoder),new C(b.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let U=0,S=r.length;U<S;U++)l+=r[U].byteLength}const E=C.alloc(l);let P=0;for(let U=0,S=r.length;U<S;U++){const O=r[U];E.set(O,P),P+=O.byteLength}return E}toString(){return D?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(r,l){return new C(this.buffer.subarray(r,l))}set(r,l){r instanceof C?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return m(this.buffer,r)}writeUInt32BE(r,l){p(this.buffer,r,l)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,l){g(this.buffer,r,l)}readUInt8(r){return R(this.buffer,r)}writeUInt8(r,l){a(this.buffer,r,l)}}t.VSBuffer=C;function T(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}t.readUInt16LE=T;function u(i,r,l){i[l+0]=r&255,r=r>>>8,i[l+1]=r&255}t.writeUInt16LE=u;function m(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}t.readUInt32BE=m;function p(i,r,l){i[l+3]=r,r=r>>>8,i[l+2]=r,r=r>>>8,i[l+1]=r,r=r>>>8,i[l]=r}t.writeUInt32BE=p;function I(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}t.readUInt32LE=I;function g(i,r,l){i[l+0]=r&255,r=r>>>8,i[l+1]=r&255,r=r>>>8,i[l+2]=r&255,r=r>>>8,i[l+3]=r&255}t.writeUInt32LE=g;function R(i,r){return i[r]}t.readUInt8=R;function a(i,r,l){i[l]=r}t.writeUInt8=a;function c(i){return N.consumeReadable(i,r=>C.concat(r))}t.readableToBuffer=c;function w(i){return N.toReadable(i)}t.bufferToReadable=w;function f(i){return N.consumeStream(i,r=>C.concat(r))}t.streamToBuffer=f;async function v(i){return i.ended?C.concat(i.buffer):C.concat([...i.buffer,await f(i.stream)])}t.bufferedStreamToBuffer=v;function h(i){return N.toStream(i,r=>C.concat(r))}t.bufferToStream=h;function o(i){return N.transform(i,{data:r=>typeof r=="string"?C.fromString(r):C.wrap(r)},r=>C.concat(r))}t.streamToBufferReadableStream=o;function s(i){return N.newWriteableStream(r=>C.concat(r),i)}t.newWriteableBufferStream=s;function e(i,r){return N.prefixedReadable(i,r,l=>C.concat(l))}t.prefixedBufferReadable=e;function n(i,r){return N.prefixedStream(i,r,l=>C.concat(l))}t.prefixedBufferStream=n}),define(ee[19],te([0,1,12]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const w=Array.isArray(c)?[]:{};return Object.keys(c).forEach(f=>{c[f]&&typeof c[f]=="object"?w[f]=D(c[f]):w[f]=c[f]}),w}t.deepClone=D;function b(c){if(!c||typeof c!="object")return c;const w=[c];for(;w.length>0;){const f=w.shift();Object.freeze(f);for(const v in f)if(F.call(f,v)){const h=f[v];typeof h=="object"&&!Object.isFrozen(h)&&w.push(h)}}return c}t.deepFreeze=b;const F=Object.prototype.hasOwnProperty;function C(c,w){return T(c,w,new Set)}t.cloneAndChange=C;function T(c,w,f){if((0,N.isUndefinedOrNull)(c))return c;const v=w(c);if(typeof v!="undefined")return v;if((0,N.isArray)(c)){const h=[];for(const o of c)h.push(T(o,w,f));return h}if((0,N.isObject)(c)){if(f.has(c))throw new Error("Cannot clone recursive data-structure");f.add(c);const h={};for(let o in c)F.call(c,o)&&(h[o]=T(c[o],w,f));return f.delete(c),h}return c}function u(c,w,f=!0){return(0,N.isObject)(c)?((0,N.isObject)(w)&&Object.keys(w).forEach(v=>{v in c?f&&((0,N.isObject)(c[v])&&(0,N.isObject)(w[v])?u(c[v],w[v],f):c[v]=w[v]):c[v]=w[v]}),c):w}t.mixin=u;function m(c,w){if(c===w)return!0;if(c==null||w===null||w===void 0||typeof c!=typeof w||typeof c!="object"||Array.isArray(c)!==Array.isArray(w))return!1;let f,v;if(Array.isArray(c)){if(c.length!==w.length)return!1;for(f=0;f<c.length;f++)if(!m(c[f],w[f]))return!1}else{const h=[];for(v in c)h.push(v);h.sort();const o=[];for(v in w)o.push(v);if(o.sort(),!m(h,o))return!1;for(f=0;f<h.length;f++)if(!m(c[h[f]],w[h[f]]))return!1}return!0}t.equals=m;function p(c){const w=new Set;return JSON.stringify(c,(f,v)=>{if((0,N.isObject)(v)||Array.isArray(v)){if(w.has(v))return"[Circular]";w.add(v)}return v})}t.safeStringify=p;function I(c,w,f){const v=w(c);return typeof v=="undefined"?f:v}t.getOrDefault=I;function g(c,w){const f=Object.create(null);return!c||!w||Object.keys(w).forEach(h=>{const o=c[h],s=w[h];m(o,s)||(f[h]=s)}),f}t.distinct=g;function R(c,w){const f=w.toLowerCase(),v=Object.keys(c).find(h=>h.toLowerCase()===f);return v?c[v]:c[w]}t.getCaseInsensitive=R;function a(c,w){const f=Object.create(null);for(const v of Object.keys(c))w(v,c[v])&&(f[v]=c[v]);return f}t.filter=a}),define(ee[59],te([0,1,7]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(m){const p=m;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=D;function b(m){const p=[];let I;try{const g=JSON.parse(m.arguments),R=g[g.length-1];R&&R.__$stack&&(g.pop(),I=R.__$stack),p.push(...g)}catch(g){p.push("Unable to log remote console arguments",m.arguments)}return{args:p,stack:I}}t.parse=b;function F(m){if(typeof m!="string")return F(b(m).stack);const p=m;if(p){const I=C(p),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:N.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=F;function C(m){if(!m)return m;const p=m.indexOf(`
`);return p===-1?m:m.substring(0,p)}function T(m,p){const{args:I,stack:g}=b(m),R=typeof I[0]=="string"&&I.length===1;let a=C(g);a&&(a=`(${a.trim()})`);let c=[];if(typeof I[0]=="string"?a&&R?c=[`%c[${p}] %c${I[0]} %c${a}`,u("blue"),u(""),u("grey")]:c=[`%c[${p}] %c${I[0]}`,u("blue"),u(""),...I.slice(1)]:c=[`%c[${p}]%`,u("blue"),...I],a&&!R&&c.push(a),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,c)}t.log=T;function u(m){return`color: ${m}`}}),define(ee[60],te([0,1,16,21,7]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function F(p){return JSON.stringify(p,u)}t.stringify=F;function C(p){let I=JSON.parse(p);return I=m(I),I}t.parse=C;var T;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function u(p,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,D.regExpFlags)(I)}:I}function m(p,I=0){if(!p||I>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof N.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let g=0;g<p.length;++g)p[g]=m(p[g],I+1);else for(const g in p)Object.hasOwnProperty.call(p,g)&&(p[g]=m(p[g],I+1))}return p}t.revive=m}),define(ee[61],te([0,1,3,31,45,4,21]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const u="**",m="/",p="[/\\\\]",I="[^/\\\\]",g=/\//g;function R(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${p}|${I}+${p}|${p}${I}+)*?`}}function a(M,W){if(!M)return[];const L=[];let y=!1,d=!1,A="";for(const k of M){switch(k){case W:if(!y&&!d){L.push(A),A="";continue}break;case"{":y=!0;break;case"}":y=!1;break;case"[":d=!0;break;case"]":d=!1;break}A+=k}return A&&L.push(A),L}t.splitGlobAware=a;function c(M){if(!M)return"";let W="";const L=a(M,m);if(L.every(y=>y===u))W=".*";else{let y=!1;L.forEach((d,A)=>{if(d===u){y||(W+=R(2),y=!0);return}let k=!1,V="",j=!1,X="";for(const G of d){if(G!=="}"&&k){V+=G;continue}if(j&&(G!=="]"||!X)){let ne;G==="-"?ne=G:(G==="^"||G==="!")&&!X?ne="^":G===m?ne="":ne=C.escapeRegExpCharacters(G),X+=ne;continue}switch(G){case"{":k=!0;continue;case"[":j=!0;continue;case"}":W+=`(?:${a(V,",").map(le=>c(le)).join("|")})`,k=!1,V="";break;case"]":W+="["+X+"]",j=!1,X="";break;case"?":W+=I;continue;case"*":W+=R(1);continue;default:W+=C.escapeRegExpCharacters(G)}}A<L.length-1&&(L[A+1]!==u||A+2<L.length)&&(W+=p),y=!1})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new b.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(M,W){if(!M)return i;let L;typeof M!="string"?L=M.pattern:L=M,L=L.trim();const y=`${L}_${!!W.trimForExclusions}`;let d=e.get(y);if(d)return l(d,M);let A;if(w.test(L)){const k=L.substr(4);d=function(V,j){return typeof V=="string"&&V.endsWith(k)?L:null}}else(A=f.exec(E(L,W)))?d=P(A[1],L):(W.trimForExclusions?h:v).test(L)?d=U(L,W):(A=o.exec(E(L,W)))?d=S(A[1].substr(1),L,!0):(A=s.exec(E(L,W)))?d=S(A[1],L,!1):d=O(L);return e.set(y,d),l(d,M)}function l(M,W){return typeof W=="string"?M:function(L,y){return D.isEqualOrParent(L,W.base)?M(F.relative(W.base,L),y):null}}function E(M,W){return W.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function P(M,W){const L=`/${M}`,y=`\\${M}`,d=function(k,V){return typeof k!="string"?null:V?V===M?W:null:k===M||k.endsWith(L)||k.endsWith(y)?W:null},A=[M];return d.basenames=A,d.patterns=[W],d.allBasenames=A,d}function U(M,W){const L=$(M.slice(1,-1).split(",").map(V=>r(V,W)).filter(V=>V!==i),M),y=L.length;if(!y)return i;if(y===1)return L[0];const d=function(V,j){for(let X=0,G=L.length;X<G;X++)if(L[X](V,j))return M;return null},A=L.find(V=>!!V.allBasenames);A&&(d.allBasenames=A.allBasenames);const k=L.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return k.length&&(d.allPaths=k),d}function S(M,W,L){const y=F.sep===F.posix.sep,d=y?M:M.replace(g,F.sep),A=F.sep+d,k=F.posix.sep+M,V=L?function(j,X){return typeof j=="string"&&(j===d||j.endsWith(A)||!y&&(j===M||j.endsWith(k)))?W:null}:function(j,X){return typeof j=="string"&&(j===d||!y&&j===M)?W:null};return V.allPaths=[(L?"*/":"./")+M],V}function O(M){try{const W=new RegExp(`^${c(M)}$`);return function(L){return W.lastIndex=0,typeof L=="string"&&W.test(L)?M:null}}catch(W){return i}}function x(M,W,L){return!M||typeof W!="string"?!1:B(M)(W,void 0,L)}t.match=x;function B(M,W={}){if(!M)return n;if(typeof M=="string"||Z(M)){const L=r(M,W);if(L===i)return n;const y=function(d,A){return!!L(d,A)};return L.allBasenames&&(y.allBasenames=L.allBasenames),L.allPaths&&(y.allPaths=L.allPaths),y}return Y(M,W)}t.parse=B;function J(M){if(!M)return;let W;return L=>(W||(W=(M()||Promise.resolve([])).then(y=>y?oe(y):{})),W.then(y=>!!y[L]))}t.hasSiblingPromiseFn=J;function ie(M){if(!M)return;let W;return L=>{if(!W){const y=M();W=y?oe(y):{}}return!!W[L]}}t.hasSiblingFn=ie;function oe(M){const W={};for(const L of M)W[L]=!0;return W}function Z(M){const W=M;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}t.isRelativePattern=Z;function H(M){return M.allBasenames||[]}t.getBasenameTerms=H;function Q(M){return M.allPaths||[]}t.getPathTerms=Q;function Y(M,W){const L=$(Object.getOwnPropertyNames(M).map(V=>re(V,M[V],W)).filter(V=>V!==i)),y=L.length;if(!y)return i;if(!L.some(V=>!!V.requiresSiblings)){if(y===1)return L[0];const V=function(G,ne){for(let se=0,le=L.length;se<le;se++){const pe=L[se](G,ne);if(pe)return pe}return null},j=L.find(G=>!!G.allBasenames);j&&(V.allBasenames=j.allBasenames);const X=L.reduce((G,ne)=>ne.allPaths?G.concat(ne.allPaths):G,[]);return X.length&&(V.allPaths=X),V}const d=function(V,j,X){let G;for(let ne=0,se=L.length;ne<se;ne++){const le=L[ne];le.requiresSiblings&&X&&(j||(j=F.basename(V)),G||(G=j.substr(0,j.length-F.extname(V).length)));const pe=le(V,j,G,X);if(pe)return pe}return null},A=L.find(V=>!!V.allBasenames);A&&(d.allBasenames=A.allBasenames);const k=L.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return k.length&&(d.allPaths=k),d}function re(M,W,L){if(W===!1)return i;const y=r(M,L);if(y===i)return i;if(typeof W=="boolean")return y;if(W){const d=W.when;if(typeof d=="string"){const A=(k,V,j,X)=>{if(!X||!y(k,V))return null;const G=d.replace("$(basename)",j),ne=X(G);return(0,N.isThenable)(ne)?ne.then(se=>se?M:null):ne?M:null};return A.requiresSiblings=!0,A}}return y}function $(M,W){const L=M.filter(V=>!!V.basenames);if(L.length<2)return M;const y=L.reduce((V,j)=>{const X=j.basenames;return X?V.concat(X):V},[]);let d;if(W){d=[];for(let V=0,j=y.length;V<j;V++)d.push(W)}else d=L.reduce((V,j)=>{const X=j.patterns;return X?V.concat(X):V},[]);const A=function(V,j){if(typeof V!="string")return null;if(!j){let G;for(G=V.length;G>0;G--){const ne=V.charCodeAt(G-1);if(ne===47||ne===92)break}j=V.substr(G)}const X=y.indexOf(j);return X!==-1?d[X]:null};A.basenames=y,A.patterns=d,A.allBasenames=y;const k=M.filter(V=>!V.basenames);return k.push(A),k}}),define(ee[62],te([0,1,31,13,4,8,22,21,7]),function(_,t,N,D,b,F,C,T,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function m(r,l,E){if(typeof r=="string"&&(r=u.URI.file(r)),E){const U=E.getWorkspaceFolder(r);if(U){const S=E.getWorkspace().folders.length>1;let O;if((0,C.isEqual)(U.uri,r)?O="":O=(0,C.relativePath)(U.uri,r),S){const x=U.name?U.name:(0,C.basename)(U.uri);O=O?x+" \u2022 "+O:x}return O}}if(r.scheme!==D.Schemas.file&&r.scheme!==D.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,N.hasDriveLetter)(r.fsPath))return(0,b.normalize)(I(r.fsPath));let P=(0,b.normalize)(r.fsPath);return!F.isWindows&&l?.userHome&&(P=R(P,l.userHome.fsPath)),P}t.getPathLabel=m;function p(r){if(!r)return;typeof r=="string"&&(r=u.URI.file(r));const l=(0,C.basename)(r)||(r.scheme===D.Schemas.file?r.fsPath:r.path);return F.isWindows&&(0,N.isRootOrDriveLetter)(l)?I(l):l}t.getBaseLabel=p;function I(r){return(0,N.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=I;let g=Object.create(null);function R(r,l){if(F.isWindows||!r||!l)return r;let E=g.original===l?g.normalized:void 0;return E||(E=`${(0,T.rtrim)(l,b.posix.sep)}${b.posix.sep}`,g={original:l,normalized:E}),(F.isLinux?r.startsWith(E):(0,T.startsWithIgnoreCase)(r,E))&&(r=`~/${r.substr(E.length)}`),r}t.tildify=R;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=a;const c="\u2026",w="\\\\",f="~";function v(r,l=b.sep){const E=new Array(r.length);let P=!1;for(let U=0;U<r.length;U++){let S=r[U];if(S===""){E[U]=`.${l}`;continue}if(!S){E[U]=S;continue}P=!0;let O="";S.indexOf(w)===0?(O=S.substr(0,S.indexOf(w)+w.length),S=S.substr(S.indexOf(w)+w.length)):S.indexOf(l)===0?(O=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const x=S.split(l);for(let B=1;P&&B<=x.length;B++)for(let J=x.length-B;P&&J>=0;J--){P=!1;let ie=x.slice(J,J+B).join(l);for(let oe=0;!P&&oe<r.length;oe++)if(oe!==U&&r[oe]&&r[oe].indexOf(ie)>-1){const Z=J+B===x.length,H=J>0&&r[oe].indexOf(l)>-1?l+ie:ie,Q=r[oe].endsWith(H);P=!Z||Q}if(!P){let oe="";(x[0].endsWith(":")||O!=="")&&(J===1&&(J=0,B++,ie=x[0]+l+ie),J>0&&(oe=x[0]+l),oe=O+oe),J>0&&(oe=oe+c+l),oe=oe+ie,J+B<x.length&&(oe=oe+l+c),E[U]=oe}}P&&(E[U]=S)}return E}t.shorten=v;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,l=Object.create(null)){const E=[];let P=!1,U="";for(const S of r)if(S==="$"||P&&S==="{")U&&E.push({value:U,type:h.TEXT}),U="",P=!0;else if(S==="}"&&P){const O=l[U];if(typeof O=="string")O.length&&E.push({value:O,type:h.VARIABLE});else if(O){const x=E[E.length-1];(!x||x.type!==h.SEPARATOR)&&E.push({value:O.label,type:h.SEPARATOR})}U="",P=!1}else U+=S;return U&&!P&&E.push({value:U,type:h.TEXT}),E.filter((S,O)=>{if(S.type===h.SEPARATOR){const x=E[O-1],B=E[O+1];return[x,B].every(J=>J&&(J.type===h.VARIABLE||J.type===h.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}t.template=o;function s(r,l){return F.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):r.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,l){return F.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):F.isWindows?r.replace(/&&|&/g,E=>E==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=n;function i(r){const l=r.indexOf("/")!==-1?b.posix:b.win32,E=l.basename(r),P=l.dirname(r);return E.length?{name:E,parentPath:P}:{name:P,parentPath:""}}t.splitName=i}),define(ee[46],te([0,1,124]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(F="utf8"){this.stringDecoder=new N.StringDecoder(F),this.remaining=null}write(F){const C=[],T=this.remaining?this.remaining+this.stringDecoder.write(F):this.stringDecoder.write(F);if(T.length<1)return C;let u=0,m,p=u;for(;p<T.length;)if(m=T.charCodeAt(p),m===13||m===10){if(C.push(T.substring(u,p)),p++,p<T.length){const I=m;m=T.charCodeAt(p),(I===13&&m===10||I===10&&m===13)&&p++}u=p}else p++;return this.remaining=u<T.length?T.substr(u):null,C}end(){return this.remaining}}t.LineDecoder=D}),define(ee[63],te([0,1,37,4,21,10]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function C(p){const I=(0,D.dirname)(p);if(p===I)return p;const g=((0,D.basename)(p)||p).toLowerCase();try{const a=(0,F.readdirSync)(I).filter(c=>c.toLowerCase()===g);if(a.length===1){const c=C(I);if(c)return(0,D.join)(c,a[0])}else if(a.length>1){const c=a.indexOf(g);if(c>=0){const w=C(I);if(w)return(0,D.join)(w,a[c])}}}catch(R){}return null}t.realcaseSync=C;async function T(p){try{return await F.Promises.realpath(p)}catch(I){const g=m(p);return await F.Promises.access(g,N.constants.R_OK),g}}t.realpath=T;function u(p){try{return N.realpathSync(p)}catch(I){const g=m(p);return N.accessSync(g,N.constants.R_OK),g}}t.realpathSync=u;function m(p){return(0,b.rtrim)((0,D.normalize)(p),D.sep)}}),define(ee[64],te([0,1,38,4,10]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const F=/^\d+$/,C=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var u;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(u||(u={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class I{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?m===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function R({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const n=D.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const P of await b.Promises.readdir(n)){let U=-1;if(s){const O=P.indexOf("-");if(O<0)continue;const x=P.substring(0,O);if(!F.test(x)||P.substring(O+1)!=="preview")continue;U=parseInt(x,10)}else{if(!F.test(P))continue;U=parseInt(P,10)}if(U<=i)continue;const S=D.join(n,P,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(r=S,i=U)}if(!r)return null;const l=e.includes("x86")?" (x86)":"",E=s?" Preview":"";return new I(r,`PowerShell${E}${l}`,!0)}async function a({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(s))if(e.test(i)){const r=D.join(s,i,"pwsh.exe");return new I(r,n)}return null}function c(){const o=D.join(N.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function w(){const o=D.join(process.env.windir,m===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*f(){let o=await R();o&&(yield o),o=await R({useAlternateBitness:!0}),o&&(yield o),o=await a(),o&&(yield o),o=c(),o&&(yield o),o=await R({findPreview:!0}),o&&(yield o),o=await a({findPreview:!0}),o&&(yield o),o=await R({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=w(),o&&(yield o)}async function*v(){for await(const o of f())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=v;async function h(){for await(const o of v())return o;return null}t.getFirstAvailablePowerShellInstallation=h}),define(ee[65],te([0,1,37,31,2,125,4,8,10]),function(_,t,N,D,b,F,C,T,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function m(g,R,a){return I({path:g,isDirectory:!1},R,a)}t.watchFile=m;function p(g,R,a){return I({path:g,isDirectory:!0},R,a)}t.watchFolder=p,t.CHANGE_BUFFER_DELAY=100;function I(g,R,a){if(T.isMacintosh&&(0,D.isEqualOrParent)(g.path,"/Volumes/"))return a(`Refusing to watch ${g.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),b.Disposable.None;const c=(0,C.basename)(g.path),w=new Map;let f=!1,v=[(0,b.toDisposable)(()=>{w.forEach(h=>(0,b.dispose)(h)),w.clear()})];try{const h=(0,N.watch)(g.path);v.push((0,b.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;g.isDirectory&&u.Promises.readdir(g.path).then(s=>s.forEach(e=>o.add(e))),h.on("error",(s,e)=>{f||a(`Failed to watch ${g.path} for changes using fs.watch() (${s}, ${e})`)}),h.on("change",(s,e)=>{if(f)return;let n="";if(e&&(n=e.toString(),T.isMacintosh&&(n=(0,F.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const i=g.isDirectory?(0,C.join)(g.path,n):g.path;if(g.isDirectory)if(s==="rename"){const r=w.get(i);r&&(0,b.dispose)(r);const l=setTimeout(async()=>{w.delete(i);const E=await u.Promises.exists(i);if(f)return;let P;E?o.has(n)?P="changed":(P="added",o.add(n)):(o.delete(n),P="deleted"),R(P,i)},t.CHANGE_BUFFER_DELAY);w.set(i,(0,b.toDisposable)(()=>clearTimeout(l)))}else{let r;o.has(n)?r="changed":(r="added",o.add(n)),R(r,i)}else if(s==="rename"||n!==c){const r=setTimeout(async()=>{const l=await u.Promises.exists(i);f||(l?(R("changed",i),v=[I(g,R,a)]):R("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,b.dispose)(v),v=[(0,b.toDisposable)(()=>clearTimeout(r))]}else R("changed",i)})}catch(h){u.Promises.exists(g.path).then(o=>{o&&!f&&a(`Failed to watch ${g.path} for changes using fs.watch() (${h.toString()})`)})}return(0,b.toDisposable)(()=>{f=!0,v=(0,b.dispose)(v)})}});var fe=this&&this.__decorate||function(_,t,N,D){var b=arguments.length,F=b<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,N):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(_,t,N,D);else for(var T=_.length-1;T>=0;T--)(C=_[T])&&(F=(b<3?C(F):b>3?C(t,N,F):C(t,N))||F);return b>3&&F&&Object.defineProperty(t,N,F),F};define(ee[39],te([0,1,18,3,16,26,44,9,14,2,60,21,12]),function(_,t,N,D,b,F,C,T,u,m,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var R;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(R=t.RequestType||(t.RequestType={}));function a($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function w($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(f||(f={}));class v{constructor(M){this.buffer=M,this.pos=0}read(M){const W=this.buffer.slice(this.pos,this.pos+M);return this.pos+=W.byteLength,W}}class h{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var o;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(o||(o={}));function s($){const M=b.VSBuffer.alloc(4);return M.writeUInt32BE($,0),M}function e($){return $.read(4).readUInt32BE(0)}function n($){const M=b.VSBuffer.alloc(1);return M.writeUInt8($,0),M}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},r=typeof Buffer!="undefined";function l($,M){if(typeof M=="undefined")$.write(i.Undefined);else if(typeof M=="string"){const W=b.VSBuffer.fromString(M);$.write(i.String),$.write(s(W.byteLength)),$.write(W)}else if(r&&Buffer.isBuffer(M)){const W=b.VSBuffer.wrap(M);$.write(i.Buffer),$.write(s(W.byteLength)),$.write(W)}else if(M instanceof b.VSBuffer)$.write(i.VSBuffer),$.write(s(M.byteLength)),$.write(M);else if(Array.isArray(M)){$.write(i.Array),$.write(s(M.length));for(const W of M)l($,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(M));$.write(i.Object),$.write(s(W.byteLength)),$.write(W)}}function E($){switch($.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return $.read(e($)).toString();case o.Buffer:return $.read(e($)).buffer;case o.VSBuffer:return $.read(e($));case o.Array:{const W=e($),L=[];for(let y=0;y<W;y++)L.push(E($));return L}case o.Object:return JSON.parse($.read(e($)).toString())}}class P{constructor(M,W,L=null,y=1e3){this.protocol=M,this.ctx=W,this.logger=L,this.timeoutDelay=y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(d=>this.onRawMessage(d)),this.sendResponse({type:200})}registerChannel(M,W){this.channels.set(M,W),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const W=this.send([M.type]);this.logger&&this.logger.logOutgoing(W,0,1,w(M.type));return}case 201:case 202:case 204:case 203:{const W=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(W,M.id,1,w(M.type),M.data);return}}}send(M,W=void 0){const L=new h;return l(L,M),l(L,W),this.sendBuffer(L.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onRawMessage(M){const W=new v(M),L=E(W),y=E(W),d=L[0];switch(d){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,L[1],1,`${a(d)}: ${L[2]}.${L[3]}`,y),this.onPromise({type:d,id:L[1],channelName:L[2],name:L[3],arg:y});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,L[1],1,`${a(d)}: ${L[2]}.${L[3]}`,y),this.onEventListen({type:d,id:L[1],channelName:L[2],name:L[3],arg:y});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,L[1],1,`${a(d)}`),this.disposeActiveRequest({type:d,id:L[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,L[1],1,`${a(d)}`),this.disposeActiveRequest({type:d,id:L[1]})}}onPromise(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const L=new F.CancellationTokenSource;let y;try{y=W.call(this.ctx,M.name,M.arg,L.token)}catch(k){y=Promise.reject(k)}const d=M.id;y.then(k=>{this.sendResponse({id:d,data:k,type:201}),this.activeRequests.delete(M.id)},k=>{k instanceof Error?this.sendResponse({id:d,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:d,data:k,type:203}),this.activeRequests.delete(M.id)});const A=(0,m.toDisposable)(()=>L.cancel());this.activeRequests.set(M.id,A)}onEventListen(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const L=M.id,d=W.listen(this.ctx,M.name,M.arg)(A=>this.sendResponse({id:L,data:A,type:204}));this.activeRequests.set(M.id,d)}disposeActiveRequest(M){const W=this.activeRequests.get(M.id);W&&(W.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let W=this.pendingRequests.get(M.channelName);W||(W=[],this.pendingRequests.set(M.channelName,W));const L=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:M,timeoutTimer:L})}flushPendingRequests(M){const W=this.pendingRequests.get(M);if(W){for(const L of W)switch(clearTimeout(L.timeoutTimer),L.request.type){case 100:this.onPromise(L.request);break;case 102:this.onEventListen(L.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var U;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class S{constructor(M,W=null){this.protocol=M,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(L=>this.onBuffer(L)),this.logger=W}getChannel(M){const W=this;return{call(L,y,d){return W.isDisposed?Promise.reject(T.canceled()):W.requestPromise(M,L,y,d)},listen(L,y){return W.isDisposed?Promise.reject(T.canceled()):W.requestEvent(M,L,y)}}}requestPromise(M,W,L,y=F.CancellationToken.None){const d=this.lastRequestId++,k={id:d,type:100,channelName:M,name:W,arg:L};if(y.isCancellationRequested)return Promise.reject(T.canceled());let V;return new Promise((X,G)=>{if(y.isCancellationRequested)return G(T.canceled());const ne=()=>{const Ie=ye=>{switch(ye.type){case 201:this.handlers.delete(d),X(ye.data);break;case 202:this.handlers.delete(d);const me=new Error(ye.data.message);me.stack=ye.data.stack,me.name=ye.data.name,G(me);break;case 203:this.handlers.delete(d),G(ye.data);break}};this.handlers.set(d,Ie),this.sendRequest(k)};let se=null;this.state===f.Idle?ne():(se=(0,D.createCancelablePromise)(Ie=>this.whenInitialized()),se.then(()=>{se=null,ne()}));const le=()=>{se?(se.cancel(),se=null):this.sendRequest({id:d,type:101}),G(T.canceled())},pe=y.onCancellationRequested(le);V=(0,m.combinedDisposable)((0,m.toDisposable)(le),pe),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(M,W,L){const y=this.lastRequestId++,A={id:y,type:102,channelName:M,name:W,arg:L};let k=null;const V=new u.Emitter({onFirstListenerAdd:()=>{k=(0,D.createCancelablePromise)(X=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(V),this.sendRequest(A)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(V),this.sendRequest({id:y,type:103}))}}),j=X=>V.fire(X.data);return this.handlers.set(y,j),V.event}sendRequest(M){switch(M.type){case 100:case 102:{const W=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(W,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const W=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(W,M.id,0,a(M.type));return}}}send(M,W=void 0){const L=new h;return l(L,M),l(L,W),this.sendBuffer(L.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onBuffer(M){const W=new v(M),L=E(W),y=E(W),d=L[0];switch(d){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,w(d)),this.onResponse({type:L[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,L[1],0,w(d),y),this.onResponse({type:L[0],id:L[1],data:y})}}onResponse(M){if(M.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(M.id);W&&W(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}fe([C.memoize],S.prototype,"onDidInitializePromise",null),t.ChannelClient=S;class O{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:W,onDidClientDisconnect:L})=>{u.Event.once(W.onMessage)(d=>{const A=new v(d),k=E(A),V=new P(W,k),j=new S(W);this.channels.forEach((G,ne)=>V.registerChannel(ne,G));const X={channelServer:V,channelClient:j,ctx:k};this._connections.add(X),this._onDidAddConnection.fire(X),L(()=>{V.dispose(),j.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const M=[];return this._connections.forEach(W=>M.push(W)),M}getChannel(M,W){const L=this;return{call(y,d,A){let k;if((0,g.isFunction)(W)){let j=(0,N.getRandomElement)(L.connections.filter(W));k=j?Promise.resolve(j):u.Event.toPromise(u.Event.filter(L.onDidAddConnection,W))}else k=W.routeCall(L,y,d);const V=k.then(j=>j.channelClient.getChannel(M));return B(V).call(y,d,A)},listen(y,d){if((0,g.isFunction)(W))return L.getMulticastEvent(M,W,y,d);const A=W.routeEvent(L,y,d).then(k=>k.channelClient.getChannel(M));return B(A).listen(y,d)}}}getMulticastEvent(M,W,L,y){const d=this;let A=new m.DisposableStore;const k=new u.Emitter({onFirstListenerAdd:()=>{A=new m.DisposableStore;const V=new u.EventMultiplexer,j=new Map,X=ne=>{const le=ne.channelClient.getChannel(M).listen(L,y),pe=V.add(le);j.set(ne,pe)},G=ne=>{const se=j.get(ne);!se||(se.dispose(),j.delete(ne))};d.connections.filter(W).forEach(X),u.Event.filter(d.onDidAddConnection,W)(X,void 0,A),d.onDidRemoveConnection(G,void 0,A),V.event(k.fire,k,A),A.add(V)},onLastListenerRemove:()=>{A.dispose()}});return k.event}registerChannel(M,W){this.channels.set(M,W),this._connections.forEach(L=>{L.channelServer.registerChannel(M,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class x{constructor(M,W,L=null){const y=new h;l(y,W),M.send(y.buffer),this.channelClient=new S(M,L),this.channelServer=new P(M,W,L)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,W){this.channelServer.registerChannel(M,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=x;function B($){return{call(M,W,L){return $.then(y=>y.call(M,W,L))},listen(M,W){const L=new u.Relay;return $.then(y=>L.input=y.listen(M,W)),L.event}}}t.getDelayedChannel=B;function J($){let M=!1;return{call(W,L,y){return M?$.call(W,L,y):(0,D.timeout)(0).then(()=>M=!0).then(()=>$.call(W,L,y))},listen(W,L){if(M)return $.listen(W,L);const y=new u.Relay;return(0,D.timeout)(0).then(()=>M=!0).then(()=>y.input=$.listen(W,L)),y.event}}}t.getNextTickChannel=J;class ie{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const W of M.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(M.onDidAddConnection),await this.route(M)}}t.StaticRouter=ie;var oe;(function($){function M(y,d){const A=y,k=d&&d.disableMarshalling,V=new Map;for(const j in A)L(j)&&V.set(j,u.Event.buffer(A[j],!0));return new class{listen(j,X){const G=V.get(X);if(G)return G;throw new Error(`Event not found: ${X}`)}call(j,X,G){const ne=A[X];if(typeof ne=="function"){if(!k&&Array.isArray(G))for(let se=0;se<G.length;se++)G[se]=(0,p.revive)(G[se]);return ne.apply(A,G)}throw new Error(`Method not found: ${X}`)}}}$.fromService=M;function W(y,d){const A=d&&d.disableMarshalling;return new Proxy({},{get(k,V){if(typeof V=="string")return d?.properties?.has(V)?d.properties.get(V):L(V)?y.listen(V):async function(...j){let X;d&&!(0,g.isUndefinedOrNull)(d.context)?X=[d.context,...j]:X=j;const G=await y.call(V,X);return A?G:(0,p.revive)(G)};throw new Error(`Property not found: ${String(V)}`)}})}$.toService=W;function L(y){return y[0]==="o"&&y[1]==="n"&&I.isUpperAsciiLetter(y.charCodeAt(2))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let M=$.toString();if(M!=="[object Object]")return M}return $}function Q($){return Array.isArray($)?$.map(H):H($)}function Y($,M,W,L,y,d,A){A=Q(A);const k=Z[y],V=k[L%k.length];let j=[`%c[${$}]%c[${String(M).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(L).padStart(5," ")} - ${d}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(d)?(j=j.concat(A),j.push(")")):j.push(A),console.log.apply(console,j)}t.logWithColors=Y;class re{constructor(M,W){this._outgoingPrefix=M,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,W,L,y,d){this._totalOutgoing+=M,Y(this._outgoingPrefix,this._totalOutgoing,M,W,L,y,d)}logIncoming(M,W,L,y,d){this._totalIncoming+=M,Y(this._incomingPrefix,this._totalIncoming,M,W,L,y,d)}}t.IPCLogger=re}),define(ee[66],te([0,1,3,14,2,12]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var C;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=t.StorageHint||(t.StorageHint={}));var T;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(T||(T={}));class u extends b.Disposable{constructor(I,g=Object.create(null)){super();this.database=I,this.options=g,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new N.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((g,R)=>this.accept(R,g)),I.deleted?.forEach(g=>this.accept(g,void 0))}accept(I,g){if(this.state===T.Closed)return;let R=!1;(0,F.isUndefinedOrNull)(g)?R=this.cache.delete(I):this.cache.get(I)!==g&&(this.cache.set(I,g),R=!0),R&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,g){const R=this.cache.get(I);return(0,F.isUndefinedOrNull)(R)?g:R}getBoolean(I,g){const R=this.get(I);return(0,F.isUndefinedOrNull)(R)?g:R==="true"}getNumber(I,g){const R=this.get(I);return(0,F.isUndefinedOrNull)(R)?g:parseInt(R,10)}async set(I,g){if(this.state===T.Closed)return;if((0,F.isUndefinedOrNull)(g))return this.delete(I);const R=String(g);if(this.cache.get(I)!==R)return this.cache.set(I,R),this.pendingInserts.set(I,R),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===T.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((g,R)=>this.items.set(R,g)),I.delete&&I.delete.forEach(g=>this.items.delete(g))}async close(){}}t.InMemoryStorageDatabase=m}),define(ee[67],te([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(ee[68],te([0,1,67]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,b=D*60,F=b*24,C=F*7,T=F*30,u=F*365;function m(I,g){typeof I!="number"&&(I=I.getTime());const R=Math.round((new Date().getTime()-I)/1e3);if(R<-30)return(0,N.localize)(0,null,m(new Date().getTime()+R*1e3,!1));if(R<30)return(0,N.localize)(1,null);let a;return R<D?(a=R,g?a===1?(0,N.localize)(2,null,a):(0,N.localize)(3,null,a):a===1?(0,N.localize)(4,null,a):(0,N.localize)(5,null,a)):R<b?(a=Math.floor(R/D),g?a===1?(0,N.localize)(6,null,a):(0,N.localize)(7,null,a):a===1?(0,N.localize)(8,null,a):(0,N.localize)(9,null,a)):R<F?(a=Math.floor(R/b),g?a===1?(0,N.localize)(10,null,a):(0,N.localize)(11,null,a):a===1?(0,N.localize)(12,null,a):(0,N.localize)(13,null,a)):R<C?(a=Math.floor(R/F),g?a===1?(0,N.localize)(14,null,a):(0,N.localize)(15,null,a):a===1?(0,N.localize)(16,null,a):(0,N.localize)(17,null,a)):R<T?(a=Math.floor(R/C),g?a===1?(0,N.localize)(18,null,a):(0,N.localize)(19,null,a):a===1?(0,N.localize)(20,null,a):(0,N.localize)(21,null,a)):R<u?(a=Math.floor(R/T),g?a===1?(0,N.localize)(22,null,a):(0,N.localize)(23,null,a):a===1?(0,N.localize)(24,null,a):(0,N.localize)(25,null,a)):(a=Math.floor(R/u),g?a===1?(0,N.localize)(26,null,a):(0,N.localize)(27,null,a):a===1?(0,N.localize)(28,null,a):(0,N.localize)(29,null,a))}t.fromNow=m;function p(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(ee[69],te([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(ee[28],te([0,1,18,12,69]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function F(m,p){return p&&(m.stack||m.stacktrace)?b.localize(0,null,T(m),C(m.stack)||C(m.stacktrace)):T(m)}function C(m){return Array.isArray(m)?m.join(`
`):m}function T(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?b.localize(1,null,m.message):m.message||b.localize(2,null)}function u(m=null,p=!1){if(!m)return b.localize(3,null);if(Array.isArray(m)){const I=N.coalesce(m),g=u(I[0],p);return I.length>1?b.localize(4,null,g,I.length):g}if(D.isString(m))return m;if(m.detail){const I=m.detail;if(I.error)return F(I.error,p);if(I.exception)return F(I.exception,p)}return m.stack?F(m,p):m.message?m.message:b.localize(5,null)}t.toErrorMessage=u}),define(ee[70],te([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(ee[47],te([0,1,32,31,13,19,4,8,33,12,46,10,70]),function(_,t,N,D,b,F,C,T,u,m,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function R(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(o,s){if(T.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const n=N.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,l)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?R(e.status):1})}else if(T.isLinux||T.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(n=>{N.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,r,l)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function c(o=u.env){return o.comspec||"cmd.exe"}t.getWindowsShell=c;class w{constructor(s,e,n,i){if(e!==void 0&&n!==void 0&&i!==void 0)this.cmd=s,this.args=e,this.shell=n,this.options=i;else{const r=s;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(u.env).forEach(l=>{r[l]=u.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(C.sep);return e!==-1&&(s=s.substring(e+1)),w.WellKnowCommands[s]?s:"other"}start(s){return T.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(u.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(e=>{let n,i;const r=new Promise((l,E)=>{n=l,i=E});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=N.exec(l,this.options,(E,P,U)=>{this.childProcess=null;const S=E;S&&S.killed?i({killed:this.terminateRequested,stdout:P.toString(),stderr:U.toString()}):this.handleExec(n,s,E,P,U)})}else{let l=null;const E=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,n,s,i);const U={terminated:this.terminateRequested};m.isNumber(P)&&(U.cmdCode=P),n(U)};if(this.shell&&T.isWindows){const P=F.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let U=!1,S=!1;const O=[];let x=this.ensureQuotes(this.cmd);O.push(x.value),U=x.quoted,this.args&&this.args.forEach(J=>{x=this.ensureQuotes(J),O.push(x.value),S=S&&x.quoted});const B=["/s","/c"];U?S?B.push('"'+O.join(" ")+'"'):O.length>1?B.push('"'+O[0]+'" '+O.slice(1).join(" ")):B.push('"'+O[0]+'"'):B.push(O.join(" ")),l=N.spawn(c(),B,P)}else this.cmd&&(l=N.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(m.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",P=>{this.childProcess=null,i({terminated:this.terminateRequested,error:P})}),l.pid&&(this.childProcess.on("close",E),this.handleSpawn(l,n,s,i,!0)))}return r})}handleClose(s,e,n,i){}ensureQuotes(s){return w.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,a(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!T.isWindows)return s(!1);const e=N.spawn(c(),["/s","/c"]);e.on("error",n=>s(!0)),e.on("exit",n=>s(!1))})}}t.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class f extends w{constructor(s,e,n,i){super(s,e,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,n,i,r){[i,r].forEach((l,E)=>{const P=new p.LineDecoder;P.write(l).forEach(O=>{e({line:O,source:E===0?0:1})});const S=P.end();S&&e({line:S,source:E===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,e,n,i,r){const l=new p.LineDecoder,E=new p.LineDecoder;s.stdout.on("data",P=>{l.write(P).forEach(S=>n({line:S,source:0}))}),s.stderr.on("data",P=>{E.write(P).forEach(S=>n({line:S,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=E}handleClose(s,e,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}t.LineProcess=f;function v(o){let s=[],e=!1;const n=function(i){if(e){s.push(i);return}(!o.send(i,l=>{if(l&&console.error(l),e=!1,s.length>0){const E=s.slice(0);s=[],E.forEach(P=>n(P))}})||T.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=v;var h;(function(o){async function s(e,n,i){if(C.isAbsolute(e))return e;if(n===void 0&&(n=u.cwd()),C.dirname(e)!=="."||(i===void 0&&m.isString(u.env.PATH)&&(i=u.env.PATH.split(C.delimiter)),i===void 0||i.length===0))return C.join(n,e);async function l(E){if(await I.Promises.exists(E)){let P;try{P=await I.Promises.stat(E)}catch(U){U.message.startsWith("EACCES")&&(P=await I.Promises.lstat(E))}return P?!P.isDirectory():!1}return!1}for(let E of i){let P;if(C.isAbsolute(E)?P=C.join(E,e):P=C.join(n,E,e),await l(P))return P;let U=P+".com";if(await l(U)||(U=P+".exe",await l(U)))return U}return C.join(n,e)}o.findExecutable=s})(h=t.win32||(t.win32={}))}),define(ee[71],te([0,1,38,8,64,47]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function C(R,a){return R===1?D.isWindows?I():F.getWindowsShell(a):m(R,a)}t.getSystemShell=C;function T(R,a){return R===1?D.isWindows?g(a):F.getWindowsShell(a):m(R,a)}t.getSystemShellSync=T;let u=null;function m(R,a){if(D.isLinux&&R===2||D.isMacintosh&&R===3)return"/bin/bash";if(!u){let c;if(D.isWindows)c="/bin/bash";else{if(c=a.SHELL,!c)try{c=(0,N.userInfo)().shell}catch(w){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}u=c}return u}let p=null;async function I(){return p||(p=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),p}function g(R){if(p)return p;const a=D.isWindows&&parseFloat((0,N.release)())>=10,c=R.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${R.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?w:F.getWindowsShell(R)}}),define(ee[48],te([0,1,32,3,16,26,59,9,14,2,19,8,47,39]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends R.ChannelServer{constructor(f){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(h){}},onMessage:u.Event.fromNodeEventEmitter(process,"message",v=>b.VSBuffer.wrap(Buffer.from(v,"base64")))},f);process.once("disconnect",()=>this.dispose())}}t.Server=a;class c{constructor(f,v){this.modulePath=f,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new D.Delayer(h),this.child=null,this._client=null}getChannel(f){const v=this;return{call(h,o,s){return v.requestPromise(f,h,o,s)},listen(h,o){return v.requestEvent(f,h,o)}}}requestPromise(f,v,h,o=F.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),e=(0,D.createCancelablePromise)(r=>s.call(v,h,r)),n=o.onCancellationRequested(()=>e.cancel()),i=(0,m.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(f,v,h){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let o;const s=new u.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(f).listen(v,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),I.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,N.fork)(this.modulePath,f,v);const h=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,C.isRemoteConsoleLog)(l)){(0,C.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(b.VSBuffer.wrap(Buffer.from(l,"base64")))});const s=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&s.send(l.buffer.toString("base64")),n=h.event,i={send:e,onMessage:n};this._client=new R.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,E)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,m.dispose)(P)),this.activeRequests.clear(),l!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:E})})}return this._client}getCachedChannel(f){let v=this.channels.get(f);return v||(v=this.client.getChannel(f),this.channels.set(f,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(ee[72],te([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(ee[73],te([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(ee[74],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(ee[75],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(ee[76],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(ee[77],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(ee[78],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(ee[79],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(ee[80],te([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(ee[81],te([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(ee[82],te([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(ee[83],te([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(ee[84],te([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(ee[85],te([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(ee[86],te([0,1,68,44,13,4,33,22,7]),function(_,t,N,D,b,F,C,T,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class m{constructor(a,c,w){this._args=a,this.paths=c,this.productService=w}get appRoot(){return(0,F.dirname)(b.FileAccess.asFileUri("",_).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,F.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,F.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,F.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(u.URI.file((0,F.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=C.env.VSCODE_PORTABLE;return a?u.URI.file((0,F.join)(a,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,F.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,F.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,F.resolve)(a):(0,F.normalize)((0,F.join)(b.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,F.resolve)(a):(0,F.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,F.resolve)(a);const c=C.env.VSCODE_EXTENSIONS;if(c)return c;const w=C.env.VSCODE_PORTABLE;return w?(0,F.join)(w,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?u.URI.parse(c):u.URI.file((0,F.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?u.URI.parse(a):u.URI.file((0,F.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,F.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([D.memoize],m.prototype,"appRoot",null),fe([D.memoize],m.prototype,"userHome",null),fe([D.memoize],m.prototype,"userDataPath",null),fe([D.memoize],m.prototype,"appSettingsHome",null),fe([D.memoize],m.prototype,"tmpDir",null),fe([D.memoize],m.prototype,"userRoamingDataHome",null),fe([D.memoize],m.prototype,"settingsResource",null),fe([D.memoize],m.prototype,"userDataSyncHome",null),fe([D.memoize],m.prototype,"userDataSyncLogResource",null),fe([D.memoize],m.prototype,"sync",null),fe([D.memoize],m.prototype,"machineSettingsResource",null),fe([D.memoize],m.prototype,"globalStorageHome",null),fe([D.memoize],m.prototype,"workspaceStorageHome",null),fe([D.memoize],m.prototype,"keybindingsResource",null),fe([D.memoize],m.prototype,"keyboardLayoutResource",null),fe([D.memoize],m.prototype,"argvResource",null),fe([D.memoize],m.prototype,"snippetsHome",null),fe([D.memoize],m.prototype,"isExtensionDevelopment",null),fe([D.memoize],m.prototype,"untitledWorkspacesHome",null),fe([D.memoize],m.prototype,"installSourcePath",null),fe([D.memoize],m.prototype,"builtinExtensionsPath",null),fe([D.memoize],m.prototype,"extensionsPath",null),fe([D.memoize],m.prototype,"extensionDevelopmentLocationURI",null),fe([D.memoize],m.prototype,"extensionDevelopmentKind",null),fe([D.memoize],m.prototype,"extensionTestsLocationURI",null),fe([D.memoize],m.prototype,"debugExtensionHost",null),fe([D.memoize],m.prototype,"serviceMachineIdResource",null),fe([D.memoize],m.prototype,"telemetryLogResource",null),fe([D.memoize],m.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=m;function p(R,a){return g(R["inspect-extensions"],R["inspect-brk-extensions"],5870,a,R.debugId)}t.parseExtensionHostPort=p;function I(R,a){return g(R["inspect-search"],R["inspect-brk-search"],5876,a)}t.parseSearchPort=I;function g(R,a,c,w,f){const h=Number(a||R)||(w?null:c),o=h?Boolean(!!a):!1;return{port:h,break:o,debugId:f}}}),define(ee[87],te([0,1,38,86,126]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class F extends D.AbstractNativeEnvironmentService{constructor(T,u){super(T,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,b.getUserDataPath)(T)},u)}}t.NativeEnvironmentService=F}),define(ee[88],te([0,1,19]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function b(F,C){const T=u=>{if(typeof u!="string")return;const m=D.exec(u);if(!m)return;const p=C[m[1]]??u;return typeof p=="string"?p:typeof p.message=="string"?p.message:u};return(0,N.cloneAndChange)(F,T)}t.localizeManifest=b}),define(ee[49],te([0,1,80]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function F(g){return g=g.trim(),g==="*"||D.test(g)}t.isValidVersionStr=F;function C(g){if(!F(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let R=g.match(D);return R?{hasCaret:R[1]==="^",hasGreaterEquals:R[1]===">=",majorBase:R[2]==="x"?0:parseInt(R[2],10),majorMustEqual:R[2]!=="x",minorBase:R[4]==="x"?0:parseInt(R[4],10),minorMustEqual:R[4]!=="x",patchBase:R[6]==="x"?0:parseInt(R[6],10),patchMustEqual:R[6]!=="x",preRelease:R[8]||null}:null}t.parseVersion=C;function T(g){if(!g)return null;let R=g.majorBase,a=g.majorMustEqual,c=g.minorBase,w=g.minorMustEqual,f=g.patchBase,v=g.patchMustEqual;g.hasCaret&&(R===0||(w=!1),v=!1);let h=0;if(g.preRelease){const o=b.exec(g.preRelease);if(o){const[,s,e,n]=o;h=Date.UTC(Number(s),Number(e)-1,Number(n))}}return{majorBase:R,majorMustEqual:a,minorBase:c,minorMustEqual:w,patchBase:f,patchMustEqual:v,isMinimum:g.hasGreaterEquals,notBefore:h}}t.normalizeVersion=T;function u(g,R,a){let c;typeof g=="string"?c=T(C(g)):c=g;let w;R instanceof Date?w=R.getTime():typeof R=="string"&&(w=new Date(R).getTime());let f;if(typeof a=="string"?f=T(C(a)):f=a,!c||!f)return!1;let v=c.majorBase,h=c.minorBase,o=c.patchBase,s=f.majorBase,e=f.minorBase,n=f.patchBase,i=f.notBefore,r=f.majorMustEqual,l=f.minorMustEqual,E=f.patchMustEqual;return f.isMinimum?v>s?!0:v<s?!1:h>e?!0:h<e||w&&w<i?!1:o>=n:(v===1&&s===0&&(!r||!l||!E)&&(s=1,e=0,n=0,r=!0,l=!1,E=!1),v<s?!1:v>s?!r:h<e?!1:h>e?!l:o<n?!1:o>n?!E:!(w&&w<i))}t.isValidVersion=u;function m(g,R,a,c){return a.isBuiltin||typeof a.main=="undefined"?!0:I(g,R,a.engines.vscode,c)}t.isValidExtensionVersion=m;function p(g,R,a){return g==="*"||I(R,a,g)}t.isEngineValid=p;function I(g,R,a,c=[]){let w=T(C(a));if(!w)return c.push(N.localize(0,null,a)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return c.push(N.localize(1,null,a)),!1}else if(!w.majorMustEqual)return c.push(N.localize(2,null,a)),!1;return u(g,R,w)?!0:(c.push(N.localize(3,null,g,a)),!1)}}),define(ee[89],te([0,1,2,13,39,48]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends N.Disposable{constructor(u,m,p,I){super();this.folders=u,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new F.Client(D.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C,C.MAX_RESTARTS=5}),define(ee[90],te([0,1,2,13,39,48]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends N.Disposable{constructor(u,m,p,I,g={}){super();this.folders=u,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=I,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new F.Client(D.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C,C.MAX_RESTARTS=5}),define(ee[91],te([0,1,32,61,13,46]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class C{constructor(u,m,p,I,g){this.watchedFolder=u,this.eventCallback=p,this.logCallback=I,this.verboseLogging=g,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(R=>(0,D.parse)(R)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${m.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,N.spawn)(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,u);const m=new F.LineDecoder;this.handle.stdout.on("data",p=>{const I=[];for(const g of m.write(p)){const R=g.split("|");if(R.length===2){const a=Number(R[0]),c=R[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(w=>w(c))){this.verboseLogging&&this.log(c);continue}I.push({type:C.changeTypeMap[a],path:c})}else this.log(R[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",p=>this.onError(p)),this.handle.stderr.on("data",p=>this.onError(p)),this.handle.on("exit",(p,I)=>this.onExit(p,I))}onError(u){this.error("process error: "+u.toString())}onExit(u,m){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${m})`),this.restartCounter<=C.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=C,C.MAX_RESTARTS=5,C.changeTypeMap=[0,1,2]}),define(ee[92],te([0,1,4,21,91]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F{constructor(T,u,m,p){this.onDidFilesChange=u,this.onLogMessage=m,this.verboseLogging=p,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(N.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,N.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new b.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=F}),define(ee[50],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class N{constructor(b,F=[],C=!1){this.ctor=b,this.staticArguments=F,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=N}),define(ee[93],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class N{constructor(F){this.incoming=new Map,this.outgoing=new Map,this.data=F}}t.Node=N;class D{constructor(F){this._hashFn=F,this._nodes=new Map}roots(){const F=[];for(let C of this._nodes.values())C.outgoing.size===0&&F.push(C);return F}insertEdge(F,C){const T=this.lookupOrInsertNode(F),u=this.lookupOrInsertNode(C);T.outgoing.set(this._hashFn(C),u),u.incoming.set(this._hashFn(F),T)}removeNode(F){const C=this._hashFn(F);this._nodes.delete(C);for(let T of this._nodes.values())T.outgoing.delete(C),T.incoming.delete(C)}lookupOrInsertNode(F){const C=this._hashFn(F);let T=this._nodes.get(C);return T||(T=new N(F),this._nodes.set(C,T)),T}lookup(F){return this._nodes.get(this._hashFn(F))}isEmpty(){return this._nodes.size===0}toString(){let F=[];for(let[C,T]of this._nodes)F.push(`${C}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return F.join(`
`)}findCycleSlow(){for(let[F,C]of this._nodes){const T=new Set([F]),u=this._findCycle(C,T);if(u)return u}}_findCycle(F,C){for(let[T,u]of F.outgoing){if(C.has(T))return[...C,T].join(" -> ");C.add(T);const m=this._findCycle(u,C);if(m)return m;C.delete(T)}}}t.Graph=D}),define(ee[94],te([0,1,11]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,N.createDecorator)("downloadService")}),define(ee[20],te([0,1,11]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,N.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,N.refineServiceDecorator)(t.IEnvironmentService)}),define(ee[23],te([0,1,13,8,33,75,11]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.CURRENT_TARGET_PLATFORM=t.getTargetPlatform=t.getTargetPlatformFromOS=t.toTargetPlatform=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var T;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(T=t.TargetPlatform||(t.TargetPlatform={}));function u(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=u;function m(f,v){let h;switch(f){case 1:h=3;break;case 3:h=2;break;case 2:h=1;break}return p(h,v)}t.getTargetPlatformFromOS=m;function p(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=p,t.CURRENT_TARGET_PLATFORM=D.isWeb?"web":p(D.platform,b.arch);function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=I;var g;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(g=t.SortBy||(t.SortBy={}));var R;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var a;(function(f){f.Install="install",f.Uninstall="uninstall"})(a=t.StatisticType||(t.StatisticType={}));var c;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(c=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(v,h){super(v);this.code=h,this.name=h}}t.ExtensionManagementError=w,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=N.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,F.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,F.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(ee[40],te([0,1,21,11]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}t.getWorkspaceSupportTypeMessage=b;function F(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=F,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(C=t.ExtensionType||(t.ExtensionType={}));class T{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,g){if(typeof I=="undefined"||I===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof I=="string"||typeof g=="string"){let R=typeof I=="string"?I:I.value,a=typeof g=="string"?g:g.value;return N.equalsIgnoreCase(R,a)}return I._lower===g._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=T;function u(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=m,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[24],te([0,1,21,40]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,N.compareIgnoreCase)(a.id,c.id)===0}t.areSameExtensions=b;class F{constructor(c,w){this.version=w,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof F?b(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=F;function C(a,c){return`${a}.${c}`}t.getExtensionId=C;function T(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function u(a,c){return T(C(a,c))}t.getGalleryExtensionId=u;function m(a,c){const w=[],f=v=>{for(const h of w)if(h.some(o=>b(c(o),c(v))))return h;return null};for(const v of a){const h=f(v);h?h.push(v):w.push([v])}return w}t.groupByExtension=m;function p(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function I(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function g(a){const c=new Set;for(const w of a)w.malicious&&c.add(w.id.id);return c}t.getMaliciousExtensionsSet=g;function R(a,c){const w=[],f=c.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const v=f.shift();if(v&&w.every(h=>!b(h.identifier,{id:v}))){const h=a.filter(o=>b(o.identifier,{id:v}));h.length===1&&(w.push(h[0]),f.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}t.getExtensionDependencies=R});var he=this&&this.__param||function(_,t){return function(N,D){t(N,D,_)}};define(ee[95],te([0,1,26,9,62,13,41,7,76,23,24,40]),function(_,t,N,D,b,F,C,T,u,m,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=v=>(0,u.localize)(0,null,v),R=(0,u.localize)(1,null,"ms-dotnettools.csharp");function a(v,h){return h?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(v){const h=c.exec(v);return h&&h[1]?[(0,p.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,p.adoptToGalleryExtensionId)(v),void 0]}t.getIdAndVersion=w;let f=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const n=I.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(n.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),n.forEach(r=>{s.log(r)});return}this.location&&s.log((0,u.localize)(2,null,this.location)),e=e.sort((r,l)=>r.identifier.id.localeCompare(l.identifier.id));let i;for(let r of e)i!==r.identifier.id&&(i=r.identifier.id,s.log(a(r.manifest,h)))}async installExtensions(h,o,s,e,n=console){const i=[],r=[];h.length&&n.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),E=(S,O)=>{const x=l.find(B=>(0,p.areSameExtensions)(B.identifier,{id:S}));if(x){if(!O&&!e)return n.log((0,u.localize)(5,null,S,x.manifest.version,S)),!1;if(O&&x.manifest.version===O)return n.log((0,u.localize)(6,null,`${S}@${O}`)),!1}return!0},P=[],U=[];for(const S of h)if(S instanceof T.URI)P.push(S);else{const[O,x]=w(S);E(O,x)&&U.push({id:O,version:x,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const S of o){const[O,x]=w(S);E(O,x)&&U.push({id:O,version:x,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async S=>{try{const O=await this.installVSIX(S,{isBuiltin:!1,isMachineScoped:s},e,n);O&&r.push(O)}catch(O){n.error(O.message||O.stack||O),i.push(S.toString())}})),U.length){const S=await this.getGalleryExtensions(U);await Promise.all(U.map(async O=>{const x=S.get(O.id.toLowerCase());if(x)try{const B=await this.installFromGallery(O,x,l,e,n);B&&r.push(B)}catch(B){n.error(B.message||B.stack||B),i.push(O.id)}else n.error(`${g(O.version?`${O.id}@${O.version}`:O.id)}
${R}`),i.push(O.id)}))}if(i.length)throw new Error((0,u.localize)(7,null,i.join(", ")))}async installVSIX(h,o,s,e){const n=await this.extensionManagementService.getManifest(h);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,u.localize)(8,null,(0,b.getBaseLabel)(h))),n}catch(r){if((0,D.isPromiseCanceledError)(r))return e.log((0,u.localize)(9,null,(0,b.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,N.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,n,i,r){const l=await this.extensionGalleryService.getManifest(e,N.CancellationToken.None);if(l&&!this.validateExtensionKind(l,r))return null;const E=n.find(P=>(0,p.areSameExtensions)(P.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return r.log((0,u.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,u.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,u.localize)(12,null,h,o):(0,u.localize)(13,null,h)):r.log(o?(0,u.localize)(14,null,h,o):(0,u.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,u.localize)(16,null,h,e.version)),l}catch(P){if((0,D.isPromiseCanceledError)(P))return r.log((0,u.localize)(17,null,h)),null;throw P}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,p.getGalleryExtensionId)(h.publisher,h.name)},i=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,p.areSameExtensions)(e,r.identifier)&&(0,C.gt)(r.manifest.version,h.version));return i&&!o?(s.log((0,u.localize)(18,null,i.identifier.id,i.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async i=>{if(i instanceof T.URI){const r=await this.extensionManagementService.getManifest(i);return a(r)}return i},n=[];for(const i of h){const r=await e(i),E=(await this.extensionManagementService.getInstalled()).filter(P=>(0,p.areSameExtensions)(P.identifier,{id:r}));if(!E.length)throw new Error(`${this.notInstalled(r)}
${R}`);if(E.some(P=>P.type===0)){s.log((0,u.localize)(19,null,r));return}if(!o&&E.some(P=>P.isBuiltin)){s.log((0,u.localize)(20,null,r));return}s.log((0,u.localize)(21,null,r));for(const P of E)await this.extensionManagementService.uninstall(P),n.push(P);this.location?s.log((0,u.localize)(22,null,r,this.location)):s.log((0,u.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===F.Schemas.file){o.log(n.location.fsPath);return}})})}notInstalled(h){return this.location?(0,u.localize)(24,null,h,this.location):(0,u.localize)(25,null,h)}};f=fe([he(0,m.IExtensionManagementService),he(1,m.IExtensionGalleryService)],f),t.ExtensionManagementCLIService=f}),define(ee[96],te([0,1,2,4,10,40]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class C extends N.Disposable{constructor(u,m){super();this.environmentService=u,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,F.MANIFEST_CACHE_FOLDER,F.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(m.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(u){u.some(m=>!!m.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=C}),define(ee[97],te([0,1,32,127,26,28,9,8,29,71,128]),function(_,t,N,D,b,F,C,T,u,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function I(a,c,w){return c["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(w)&&!c["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(w)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async f=>{const v=new b.CancellationTokenSource,h=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),v.dispose(!0),f({})},1e4);try{const o=await R(a,v.token);f(o)}catch(o){(0,C.isPromiseCanceledError)(o)||a.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),f({})}finally{clearTimeout(h),v.dispose()}})),g)}t.resolveShellEnv=I;let g;async function R(a,c){const w=new Promise(async(f,v)=>{const h=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",o);const s=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",n);const i=await(0,m.getSystemShell)(T.OS,n);if(a.trace("getUnixShellEnvironment#shell",i),c.isCancellationRequested)return v(C.canceled);const r=D.basename(i);let l,E;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,E=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,E=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),l);const P=(0,N.spawn)(i,[...E,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(P.kill(),v(C.canceled))),P.on("error",O=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,F.toErrorMessage)(O)),f({})});const U=[];P.stdout.on("data",O=>U.push(O));const S=[];P.stderr.on("data",O=>S.push(O)),P.on("close",(O,x)=>{const B=Buffer.concat(U).toString("utf8");a.trace("getUnixShellEnvironment#raw",B);const J=Buffer.concat(S).toString("utf8");if(J.trim()&&a.trace("getUnixShellEnvironment#stderr",J),O||x)return v(new Error(`Failed to get environment (code ${O}, signal ${x})`));const ie=e.exec(B),oe=ie?ie[1]:"{}";try{const Z=JSON.parse(oe);h?Z.ELECTRON_RUN_AS_NODE=h:delete Z.ELECTRON_RUN_AS_NODE,o?Z.ELECTRON_NO_ATTACH_CONSOLE=o:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Z),f(Z)}catch(Z){a.error("getUnixShellEnvironment#errorCaught",(0,F.toErrorMessage)(Z)),v(Z)}})});try{return await w}catch(f){return a.error("getUnixShellEnvironment#error",(0,F.toErrorMessage)(f)),{}}}}),define(ee[51],te([0,1,8,7,17]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function F(u){return u.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}t.toFileChanges=F;function C(u){const m=new T;for(const p of u)m.processEvent(p);return m.normalize()}t.normalizeFileChanges=C;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const p=this.mapPathToChange.get(m.path);if(p){const I=p.type,g=m.type;I===1&&g===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(p),1)):I===2&&g===1?p.type=0:I===1&&g===0||(p.type=g)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],p=[];return this.normalized.filter(I=>I.type!==2?(m.push(I),!1):!0).sort((I,g)=>I.path.length-g.path.length).filter(I=>p.some(g=>(0,b.isParent)(I.path,g,!N.isLinux))?!1:(p.push(I.path),!0)).concat(m)}}}),define(ee[98],te([0,1,3,2,4,63,10,65,51]),function(_,t,N,D,b,F,C,T,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class m extends D.Disposable{constructor(I,g,R,a){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=R,this.verboseLogging=a,this.fileChangesDelayer=this._register(new N.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await C.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let R=this.path;if(g)try{R=await(0,F.realpath)(R)}catch(a){if(this.onError(a),g.dangling)return}I.isDirectory()?this._register((0,T.watchFolder)(R,(a,c)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(c))})},a=>this.onError(a))):this._register((0,T.watchFile)(R,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const R=(0,u.normalizeFileChanges)(g);if(this.verboseLogging)for(const a of R)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);R.length>0&&this.onDidFilesChange(R)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=m}),define(ee[52],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class N{constructor(...b){this._entries=new Map;for(let[F,C]of b)this.set(F,C)}set(b,F){const C=this._entries.get(b);return this._entries.set(b,F),C}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=N}),define(ee[99],te([0,1,3,9,50,93,11,52]),function(_,t,N,D,b,F,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class m extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class p{constructor(a=new T.ServiceCollection,c=!1,w){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=w,this._services.set(C.IInstantiationService,this)}createChild(a){return new p(a,this._strict,this)}invokeFunction(a,...c){let w=g.traceInvocation(a),f=!1;try{return a({get:(h,o)=>{if(f)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,w);if(!s&&o!==C.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...c)}finally{f=!0,w.stop()}}createInstance(a,...c){let w,f;return a instanceof b.SyncDescriptor?(w=g.traceCreation(a.ctor),f=this._createInstance(a.ctor,a.staticArguments.concat(c),w)):(w=g.traceCreation(a),f=this._createInstance(a,c,w)),w.stop(),f}_createInstance(a,c=[],w){let f=C._util.getServiceDependencies(a).sort((o,s)=>o.index-s.index),v=[];for(const o of f){let s=this._getOrCreateServiceInstance(o.id,w);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);v.push(s)}let h=f.length>0?f[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${c.length} static arguments`);let o=h-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,h)}return new a(...[...c,...v])}_setServiceInstance(a,c){if(this._services.get(a)instanceof b.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let w=this._getServiceInstanceOrDescriptor(a);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,w,c.branch(a,!0)):(c.branch(a,!1),w)}_safeCreateAndCacheServiceInstance(a,c,w){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,w)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,w){const f=new F.Graph(o=>o.id.toString());let v=0;const h=[{id:a,desc:c,_trace:w}];for(;h.length;){const o=h.pop();if(f.lookupOrInsertNode(o),v++>1e3)throw new m(f);for(let s of C._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const n={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};f.insertEdge(o,n),h.push(n)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new m(f);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,w=[],f,v){if(this._services.get(a)instanceof b.SyncDescriptor)return this._createServiceInstance(c,w,f,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,w,f,v);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],w,f){if(w){const v=new N.IdleValue(()=>this._createInstance(a,c,f));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=v.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return v.value[o]=s,!0}})}else return this._createInstance(a,c,f)}}t.InstantiationService=p;var I;(function(R){R[R.Creation=0]="Creation",R[R.Invocation=1]="Invocation",R[R.Branch=2]="Branch"})(I||(I={}));class g{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return u?new g(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(a){return u?new g(0,a.name):g._None}branch(a,c){let w=new g(2,a.toString());return this._dep.push([a,c,w]),w}stop(){let a=Date.now()-this._start;g._totals+=a;let c=!1;function w(v,h){let o=[],s=new Array(v+1).join("	");for(const[e,n,i]of h._dep)if(n&&i){c=!0,o.push(`${s}CREATES -> ${e}`);let r=w(v+1,i);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(f.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(ee[53],te([0,1,11]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,N.createDecorator)("localizationsService");function D(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const F of b.translations)if(typeof F.id!="string"||typeof F.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=D}),define(ee[15],te([0,1,28,14,2,8,11]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,C.createDecorator)("logService"),t.ILoggerService=(0,C.createDecorator)("loggerService");function T(){return new Date().toISOString()}var u;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class m extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=m;class p extends m{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...n]))}debug(e,...n){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...n]))}info(e,...n){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...n]))}warn(e,...n){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...n]))}error(e,...n){if(this.checkLogLevel(u.Error))if(e instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=e.stack,this.log(u.Error,this.format(i))}else this.log(u.Error,this.format([e,...n]))}critical(e,...n){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...n]))}flush(){}format(e){let n="";for(let i=0;i<e.length;i++){let r=e[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}n+=(i>0?" ":"")+r}return n}}t.AbstractMessageLogger=p;class I extends m{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!F.isWindows}trace(e,...n){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...n):console.log(`[main ${T()}]`,e,...n))}debug(e,...n){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...n):console.log(`[main ${T()}]`,e,...n))}info(e,...n){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...n):console.log(`[main ${T()}]`,e,...n))}warn(e,...n){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...n):console.warn(`[main ${T()}]`,e,...n))}error(e,...n){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...n):console.error(`[main ${T()}]`,e,...n))}critical(e,...n){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...n):console.error(`[main ${T()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class g extends m{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=g;class R extends m{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,N.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=R;class a extends m{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const i of this.logServices)i.trace(e,...n)}debug(e,...n){for(const i of this.logServices)i.debug(e,...n)}info(e,...n){for(const i of this.logServices)i.info(e,...n)}warn(e,...n){for(const i of this.logServices)i.warn(e,...n)}error(e,...n){for(const i of this.logServices)i.error(e,...n)}critical(e,...n){for(const i of this.logServices)i.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class c extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=c;class w extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let i=this.loggers.get(e.toString());return i||(i=this.doCreateLogger(e,n?.always?u.Trace:this.logLevel,n),this.loggers.set(e.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=w;class f{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=f;function v(s){if(s.verbose)return u.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=v;function h(s){switch(s){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=h;function o(s){switch(s){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=o}),define(ee[100],te([0,1,3,9,2,8,22,41,7,29,10,20,23,24,17,15]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=u.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,C.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const n=(0,C.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(h,n,o);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,n.path),i}}return e}async delete(h){}async rename(h,o,s){try{await p.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(F.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const i of h.children){const r=this.parse(i.name);r&&s.push([r,i])}const e=(0,R.groupByExtension)(s,([i])=>i),n=[];for(const i of e)i.sort((r,l)=>T.rcompare(r[0].version,l[0].version)),o.push(...i.slice(1).map(r=>r[1].resource)),n.push(i[0][1]);n.sort((i,r)=>i.mtime-r.mtime),o.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(i=>i.resource)),await N.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?new R.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase():(0,m.generateUuid)()}parse(h){const o=w.exec(h);return o&&o[1]&&o[2]?new R.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};f=fe([he(0,I.INativeEnvironmentService),he(1,a.IFileService),he(2,g.IExtensionGalleryService),he(3,c.ILogService)],f),t.ExtensionsDownloader=f}),define(ee[101],te([0,1,32,3,28,14,2,13,4,10,20,15]),function(_,t,N,D,b,F,C,T,u,m,p,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends C.Disposable{constructor(a,c){super();this.environmentService=a,this.logService=c,this.processesLimiter=new D.Limiter(5)}async postUninstall(a){const c=this.parseScript(a,"uninstall");return c&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${w}`)))),m.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(a,c){const w=`vscode:${c}`;if(a.location.scheme===T.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[w]=="string"){const f=a.manifest.scripts[w].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${w} should be a node script`),null):{script:(0,u.join)(a.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(a,c,w,f,v){return new Promise((h,o)=>{const s=this.start(a,c,w,v);let e;const n=i=>{e&&(clearTimeout(e),e=null),i?o(i):h(void 0)};s.on("error",i=>{n((0,b.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${c} process exited with code ${i}`:void 0)}),f&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(a,c,w,f){const v={silent:!0,execArgv:void 0},h=(0,N.fork)(a,[`--type=extension-post-${c}`,...w],v);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=F.Event.fromNodeEventEmitter(h.stdout,"data"),s=F.Event.fromNodeEventEmitter(h.stderr,"data");o(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${c}`,i)),s(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${c}`,i));const e=F.Event.any(F.Event.map(o,i=>({data:`%c${i}`,format:[""]})),F.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return F.Event.debounce(e,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),h}getExtensionStoragePath(a){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};g=fe([he(0,p.IEnvironmentService),he(1,I.ILogService)],g),t.ExtensionsLifecycle=g}),define(ee[102],te([0,1,14,2,22,7,20,24,17,15]),function(_,t,N,D,b,F,C,T,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends D.Disposable{constructor(g,R,a,c){super();this.extensionsManagementService=g,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(v=>this.onInstallExtension(v))),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const w=F.URI.file(a.extensionsPath),f=new b.ExtUri(v=>!R.hasCapability(v,1024));this._register(R.watch(w)),this._register(N.Event.filter(R.onDidChangeFilesRaw,v=>v.changes.some(h=>this.doesChangeAffects(h,w,f)))(()=>this.onDidChange()))}doesChangeAffects(g,R,a){return a.isEqual(a.dirname(g.resource),R)?a.isEqual(g.resource,a.joinPath(R,".obsolete"))?!0:!(g.type!==1&&g.type!==2||a.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const R of g)this.removeInstallingExtension(R.identifier),R.local&&this.addInstalledExtension(R.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(R=>!(0,T.areSameExtensions)(R,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(R=>!(0,T.areSameExtensions)(R,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),R=g.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,T.areSameExtensions)(w,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),a=this.installedExtensions.filter(c=>this.installingExtensions.some(w=>(0,T.areSameExtensions)(w,c))?!1:g.every(w=>!(0,T.areSameExtensions)(w.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=g.map(c=>c.identifier),(R.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:R,removed:a})}}};p=fe([he(1,u.IFileService),he(2,C.INativeEnvironmentService),he(3,m.ILogService)],p),t.ExtensionsWatcher=p}),define(ee[103],te([0,1,129,18,3,2,13,4,10,20,23,24,53,15]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let a=class extends F.Disposable{constructor(f,v,h){super();this.extensionManagementService=f,this.logService=h,this.cache=this._register(new c(v,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),v=["en",...Object.keys(f)];return(0,D.distinct)(v)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const v=await this.cache.getLanguagePacks();Object.keys(v).some(h=>v[h]&&v[h].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(v);return!(0,D.equals)(Object.keys(f),Object.keys(h))}};a=fe([he(0,p.IExtensionManagementService),he(1,m.INativeEnvironmentService),he(2,R.ILogService)],a),t.LocalizationsService=a;let c=class extends F.Disposable{constructor(f,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(v=>{Object.keys(v).forEach(h=>delete v[h]),this.createLanguagePacksFromExtensions(v,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...v){for(const h of v)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,h);Object.keys(f).forEach(h=>this.updateHash(f[h]))}createLanguagePacksFromExtension(f,v){const h=v.identifier,o=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const s of o)if(v.location.scheme===C.Schemas.file&&(0,g.isValidLocalization)(s)){let e=f[s.languageId];e||(e={hash:"",extensions:[],translations:{}},f[s.languageId]=e);let n=e.extensions.filter(i=>(0,I.areSameExtensions)(i.extensionIdentifier,h))[0];n?n.version=v.manifest.version:e.extensions.push({extensionIdentifier:h,version:v.manifest.version});for(const i of s.translations)e.translations[i.id]=(0,T.join)(v.location.fsPath,i.path)}}updateHash(f){if(f){const v=(0,N.createHash)("md5");for(const h of f.extensions)v.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);f.hash=v.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(v=f(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),u.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>v,h=>this.logService.error(h))})}};c=fe([he(0,m.INativeEnvironmentService),he(1,R.ILogService)],c)}),define(ee[104],te([0,1,17,15]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(u,m,p,I){try{const g=await new Promise((R,a)=>{_(["spdlog"],R,a)});return g.setFlushOn(D.LogLevel.Trace),g.createAsyncRotatingLogger(u,m,p,I)}catch(g){console.error(g)}return null}function F(u,m,p,I){const g=_.__$__nodeRequire("spdlog");return g.setFlushOn(D.LogLevel.Trace),g.createRotatingLogger(u,m,p,I)}t.createRotatingLogger=F;function C(u,m,p){switch(m){case D.LogLevel.Trace:u.trace(p);break;case D.LogLevel.Debug:u.debug(p);break;case D.LogLevel.Info:u.info(p);break;case D.LogLevel.Warning:u.warn(p);break;case D.LogLevel.Error:u.error(p);break;case D.LogLevel.Critical:u.critical(p);break;default:throw new Error("Invalid log level")}}class T extends D.AbstractMessageLogger{constructor(m,p,I,g){super();this.name=m,this.filepath=p,this.rotating=I,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(R=>{this._logger&&this._logger.setLevel(R)}))}_createSpdLogLogger(){const m=this.rotating?6:1,p=30/m*N.ByteSize.MB;return b(this.name,this.filepath,p,m).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:g,message:R}of this.buffer)C(this._logger,g,R);this.buffer=[]}})}log(m,p){this._logger?C(this._logger,m,p):this.getLevel()<=m&&this.buffer.push({level:m,message:p})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(ee[54],te([0,1,16,9,82,17,34]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(I,g,R,a,c,w){let f;try{await u(I,g,R,a,c,w)}catch(v){f=v}finally{f&&c.errorTransformer&&(f=c.errorTransformer(f)),typeof f!="undefined"&&R.error(f),R.end()}}t.readFileIntoStream=T;async function u(I,g,R,a,c,w){m(w);const f=await I.open(g,{create:!1});try{m(w);let v=0,h=0,o=c&&typeof c.length=="number"?c.length:void 0,s=N.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,n=0;do h=await I.read(f,e,s.buffer,n,s.byteLength-n),e+=h,n+=h,v+=h,typeof o=="number"&&(o-=h),n===s.byteLength&&(await R.write(a(s)),s=N.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),n=0);while(h>0&&(typeof o!="number"||o>0)&&m(w)&&p(v,c));if(n>0){let i=n;typeof o=="number"&&(i=Math.min(n,o)),R.write(a(s.slice(0,i)))}}catch(v){throw(0,F.ensureFileSystemProviderError)(v)}finally{await I.close(f)}}function m(I){if(I.isCancellationRequested)throw(0,D.canceled)();return!0}function p(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,F.createFileSystemProviderError)((0,b.localize)(0,null,C.default.nameShort),F.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,F.createFileSystemProviderError)((0,b.localize)(1,null),F.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[105],te([0,1,18,3,16,26,14,130,2,45,13,131,22,36,81,17,54,15]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let v=class Ne extends u.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=m.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new u.DisposableStore;return e.add(s.onDidChangeFile(n=>this.onDidChangeFile(n,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,u.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await D.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new c.FileOperationError((0,a.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,a.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,a.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),i=s?.resolveTo,r=s?.resolveSingleChildDescendants,l=s?.resolveMetadata,E=await e.stat(o);let P;return this.toFileStat(e,o,E,void 0,!!l,(U,S)=>{if(!P&&(P=m.TernarySearchTree.forUris(()=>!n),P.set(o,!0),i))for(const O of i)P.set(O,!0);return P.get(U.resource)||P.findSuperstr(U.resource.with({query:null,fragment:null}))?!0:U.isDirectory&&r?S===1:!1})}async toFileStat(o,s,e,n,i,r){const{providerExtUri:l}=this.getExtUri(o),E={resource:s,name:l.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&r(E,n)){try{const P=await o.readdir(s),U=await D.Promises.settled(P.map(async([S,O])=>{try{const x=l.joinPath(s,S),B=i?await o.stat(x):{type:O};return await this.toFileStat(o,x,B,P.length,i,r)}catch(x){return this.logService.trace(x),null}}));E.children=(0,N.coalesce)(U)}catch(P){this.logService.trace(P),E.children=[]}return E}return E}async resolveAll(o){return D.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,a.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=b.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,n)),n}async writeFile(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,i.dirname(o));let l;if((0,c.hasReadWriteCapability)(n)&&!(s instanceof b.VSBuffer))if((0,R.isReadableStream)(s)){const E=await(0,R.peekStream)(s,3);E.ended?l=b.VSBuffer.concat(E.buffer):l=E}else l=(0,R.peekReadable)(s,E=>b.VSBuffer.concat(E),3);else l=s;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&l instanceof b.VSBuffer?await this.doWriteUnbuffered(n,o,e,l):await this.doWriteBuffered(n,o,e,l instanceof b.VSBuffer?(0,b.bufferToReadable)(l):l)}catch(r){throw new c.FileOperationError((0,a.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,a.localize)(5,null,this.resourceForError(s)));let i;try{i=await o.stat(s)}catch(r){return}if((i.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,a.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:i.size}))throw new c.FileOperationError((0,a.localize)(7,null),3,e);return i}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((n,i)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);n(r)}catch(r){i(r)}})})}async doReadFile(o,s,e){const n=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const n=new F.CancellationTokenSource,i=this.validateReadFile(s,e).then(l=>l,l=>{throw n.cancel(),l});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await i,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,n.token,e):r=this.readFileBuffered(o,s,n.token,e),{...await i,value:r}}catch(l){r&&await(0,R.consumeStream)(r);const E=(0,a.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(l).toString());throw l instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(E,l.stat,e):new c.FileOperationError(E,(0,c.toFileOperationResult)(l),e)}}readFileStreamed(o,s,e,n=Object.create(null)){const i=o.readFileStream(s,n,e);return(0,R.transform)(i,{data:r=>r instanceof b.VSBuffer?r:b.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,a.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),n)},r=>b.VSBuffer.concat(r))}readFileBuffered(o,s,e,n=Object.create(null)){const i=(0,b.newWriteableBufferStream)();return(0,w.readFileIntoStream)(o,s,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,a.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),n)},e),i}readFileUnbuffered(o,s,e){const n=(0,R.newWriteableStream)(i=>b.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(s);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(s,i.byteLength,e),n.end(b.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,a.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,a.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let n;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&s>e.limits.size&&(n=7),typeof n=="number")throw new c.FileOperationError((0,a.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,n){if(o.toString()!==s.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,o,r,s,e,n)}catch(i){return i}return!0}async move(o,s,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"move",!!e),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,l)),l}async copy(o,s,e){const n=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,o,i,s,"copy",!!e),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,l)),l}async doMoveCopy(o,s,e,n,i,r){if(s.toString()===n.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,s,e,n,i,r);if(l&&!E&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),i==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:r});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,e,n):await this.doCopyFile(o,s,e,n)}return i}else return o===e?(await o.rename(s,n,{overwrite:r}),i):(await this.doMoveCopy(o,s,e,n,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,n){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,n);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,n);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,n);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,n)}async doCopyFolder(o,s,e,n){await e.mkdir(n),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async i=>{const r=this.getExtUri(e).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),e,r):this.doCopyFile(o,i.resource,e,r)}))}async doValidateMoveCopy(o,s,e,n,i,r){let l=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(l=P.isEqual(s,n)),l&&i==="copy")throw new Error((0,a.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!l&&P.isEqualOrParent(n,s))throw new Error((0,a.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const E=await this.exists(n);if(E&&!l){if(!r)throw new c.FileOperationError((0,a.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,n))throw new Error((0,a.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,a.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,c.toFileSystemProviderErrorCode)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(n.basename(s)),s=n.dirname(s)}for(let i=e.length-1;i>=0;i--){s=n.joinPath(s,e[i]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,a.localize)(19,null,this.resourceForError(o)));let i;try{i=await e.stat(o)}catch(l){}if(i)this.throwIfFileIsReadonly(o,i);else throw new c.FileOperationError((0,a.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,a.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),n=!!s?.useTrash,i=!!s?.recursive;await e.delete(o,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,n;{for(const i of o)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(n||(n=[]),n.push(i));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(n){const i=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(n)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new u.DisposableStore;{let n=!1,i=()=>{n=!0};e.add((0,u.toDisposable)(()=>i())),this.doWatch(o,s).then(r=>{n?(0,u.dispose)(r):i=()=>(0,u.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,u.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),n=this.toWatchKey(e,o,s),i=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,i),i.count+=1,(0,u.toDisposable)(()=>{i.count--,i.count===0&&((0,u.dispose)(i.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,s,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,u.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,R.isReadableStream)(n)||(0,R.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,i,n):await this.doWriteReadableBufferedQueued(o,i,n)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,s,e){let n=0,i;if((0,R.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=b.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,n,0),n+=r.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(r,l)=>{(0,R.listenStream)(i,{onData:async E=>{i.pause();try{await this.doWriteBuffer(o,s,E,E.byteLength,n,0)}catch(P){return l(P)}n+=E.byteLength,setTimeout(()=>i.resume())},onError:E=>l(E),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let n=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(o,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(o,s,e,n,i,r){let l=0;for(;l<n;)l+=await o.write(s,i+l,e.buffer,r+l,n-l)}async doWriteUnbuffered(o,s,e,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,n))}async doWriteUnbufferedQueued(o,s,e,n){let i;n instanceof b.VSBuffer?i=n:(0,R.isReadableStream)(n)?i=await(0,b.streamToBuffer)(n):(0,R.isReadableBufferedStream)(n)?i=await(0,b.bufferedStreamToBuffer)(n):i=(0,b.readableToBuffer)(n),await o.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,n))}async doPipeBufferedQueued(o,s,e,n){let i,r;try{i=await o.open(s,{create:!1}),r=await e.open(n,{create:!0,unlock:!1});const l=b.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,P=0,U=0;do U=await o.read(i,E,l.buffer,P,l.byteLength-P),await this.doWriteBuffer(e,r,l,U,E,P),E+=U,P+=U,P===l.byteLength&&(P=0);while(U>0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,n))}async doPipeUnbufferedQueued(o,s,e,n){return e.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,n))}async doPipeUnbufferedToBufferedQueued(o,s,e,n){const i=await e.open(n,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,i,b.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(o,s,e,n){const i=await(0,b.streamToBuffer)(this.readFileBuffered(o,s,F.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,i)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,a.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,a.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=fe([he(0,f.ILogService)],v),t.FileService=v}),define(ee[106],te([0,1,18,3,16,14,31,2,4,8,22,36,10,83,17,54,98,89,90,51,92,15]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f,v,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends T.Disposable{constructor(i,r){super();this.logService=i,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async E=>{try{let P;E.isSymbolicLink()?P=(await this.stat((0,p.joinPath)(i,E.name))).type:P=this.toType(E),l.push([E.name,P])}catch(P){this.logService.trace(P)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let l;return r?.dangling?l=a.FileType.Unknown:i.isFile()?l=a.FileType.File:i.isDirectory()?l=a.FileType.Directory:l=a.FileType.Unknown,r&&(l|=a.FileType.SymbolicLink),l}async readFile(i){try{const r=this.toFilePath(i);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(i,r,l){const E=(0,I.newWriteableStream)(P=>b.VSBuffer.concat(P.map(U=>b.VSBuffer.wrap(U))).buffer);return(0,c.readFileIntoStream)(this,i,E,P=>P.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),E}async writeFile(i,r,l){let E;try{const P=this.toFilePath(i);if(!l.create||!l.overwrite){if(await g.Promises.exists(P)){if(!l.overwrite)throw(0,a.createFileSystemProviderError)((0,R.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,a.createFileSystemProviderError)((0,R.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(E,0,r,0,r.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(i,P)}finally{typeof E=="number"&&await this.close(E)}}async open(i,r){try{const l=this.toFilePath(i);if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:U}=await g.SymlinkSupport.stat(l);U.mode&128||await g.Promises.chmod(l,U.mode|128)}catch(U){this.logService.trace(U)}let E;if((0,a.isFileOpenForWriteOptions)(r)){if(m.isWindows)try{await g.Promises.truncate(l,0),E="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}E||(E="w")}else E="r";const P=await g.Promises.open(l,E);return this.mapHandleToPos.set(P,0),(0,a.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(P,i),P}catch(l){throw(0,a.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await g.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await g.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}}async read(i,r,l,E,P){const U=this.normalizePos(i,r);let S=null;try{const O=await g.Promises.read(i,l,E,P,U);return typeof O=="number"?S=O:S=O.bytesRead,S}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(i,U,S)}}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,l){const E=this.mapHandleToPos.get(i);typeof E=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,E+l):this.mapHandleToPos.delete(i)))}async write(i,r,l,E,P){return(0,D.retry)(()=>this.doWrite(i,r,l,E,P),100,3)}async doWrite(i,r,l,E,P){const U=this.normalizePos(i,r);let S=null;try{const O=await g.Promises.write(i,l,E,P,U);return typeof O=="number"?S=O:S=O.bytesWritten,S}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),O)}finally{this.updatePos(i,U,S)}}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const l=this.toFilePath(i);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(i,r){r.recursive?await g.Promises.rm(i,g.RimRafMode.MOVE):await g.Promises.unlink(i)}async rename(i,r,l){const E=this.toFilePath(i),P=this.toFilePath(r);if(E!==P)try{await this.validateTargetDeleted(i,r,"move",l.overwrite),await g.Promises.move(E,P)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,R.localize)(2,null,(0,u.basename)(E),(0,u.basename)((0,u.dirname)(P)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(i,r,l){const E=this.toFilePath(i),P=this.toFilePath(r);if(E!==P)try{await this.validateTargetDeleted(i,r,"copy",l.overwrite),await g.Promises.copy(E,P,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,R.localize)(3,null,(0,u.basename)(E),(0,u.basename)((0,u.dirname)(P)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(i,r,l,E){const P=this.toFilePath(i),U=this.toFilePath(r);let S=!1;if(!!(this.capabilities&1024)||(S=(0,C.isEqual)(P,U,!0)),S&&l==="copy")throw(0,a.createFileSystemProviderError)((0,R.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!S&&await g.Promises.exists(U)){if(!E)throw(0,a.createFileSystemProviderError)((0,R.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(i,r){return r.recursive?this.watchRecursive(i,r.excludes):this.watchNonRecursive(i)}watchRecursive(i,r){const l={path:this.toFilePath(i),excludes:r},E=(0,N.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,r;this.options?.watcher?.usePolling?(i=v.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?m.isWindows?i=o.FileWatcher:i=v.FileWatcher:i=f.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,h.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===s.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(i){const r=new w.FileWatcher(this.toFilePath(i),E=>this._onDidChangeFile.fire((0,h.toFileChanges)(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===s.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(r,l)}toFilePath(i){return(0,u.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof a.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let l=this.toFileSystemProviderError(r);if(i&&l.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await g.SymlinkSupport.stat(this.toFilePath(i));E.mode&128||(l=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return l}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(ee[42],te([0,1,11]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,N.createDecorator)("productService")}),define(ee[25],te([0,1,57,12]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(C,T){N.ok(D.isString(C)),N.ok(D.isObject(T)),N.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,T)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new b}),define(ee[107],te([0,1,14,25]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class F{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,m){this.schemasById[b(u)]=m,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new F;D.Registry.add(t.Extensions.JSONContribution,C)}),define(ee[30],te([0,1,14,12,73,107,25]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var T;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(T=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=C.Registry.as(F.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new N.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new N.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,h=!0){this.registerConfigurations([v],h)}registerConfigurations(v,h=!0){const o=[];v.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(v){const h=[],o=s=>{if(s.properties)for(const e in s.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of v){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}m.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(v){const h=[],o=[];for(const s of v)for(const e in s)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const n={type:"object",default:this.defaultValues[e],description:b.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(g(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{this.defaultValues[e]=s[e];const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(v){const h=[];for(const o of v)for(const s in o)if(h.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const h of v)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,h=!0,o,s=3){s=D.isUndefinedOrNull(v.scope)?s:v.scope;let e=[],n=v.properties;if(n)for(let r in n){if(h&&c(r)){delete n[r];continue}const l=n[r];if(this.updatePropertyDefaultValue(r,l),t.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(r):l.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),e.push(r)}let i=v.allOf;if(i)for(let r of i)e.push(...this.validateAndRegisterProperties(r,h,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const h=o=>{let s=o.properties;if(s)for(const n in s)this.updateSchema(n,s[n]);let e=o.allOf;e&&e.forEach(h)};h(v)}updateSchema(v,h){switch(t.allSettings.properties[v]=h,h.scope){case 1:t.applicationSettings.properties[v]=h;break;case 2:t.machineSettings.properties[v]=h;break;case 6:t.machineOverridableSettings.properties[v]=h;break;case 3:t.windowSettings.properties[v]=h;break;case 4:t.resourceSettings.properties[v]=h;break;case 5:t.resourceSettings.properties[v]=h,this.resourceLanguageSettingsSchema.properties[v]=h;break}}removeFromSchema(v,h){switch(delete t.allSettings.properties[v],h.scope){case 1:delete t.applicationSettings.properties[v];break;case 2:delete t.machineSettings.properties[v];break;case 6:delete t.machineOverridableSettings.properties[v];break;case 3:delete t.windowSettings.properties[v];break;case 4:case 5:delete t.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const h=`[${v}]`,o={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,h){let o=this.defaultValues[v];D.isUndefined(o)&&(o=h.default),D.isUndefined(o)&&(o=R(h.type)),h.default=o}}const I="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function g(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=g;function R(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=R;const a=new p;C.Registry.add(t.Extensions.Configuration,a);function c(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?b.localize(5,null,f):a.getConfigurationProperties()[f]!==void 0?b.localize(6,null,f):null:b.localize(4,null)}t.validateProperty=c;function w(){const f=[],v=a.getConfigurationProperties();for(const h of Object.keys(v))f.push([h,v[h].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=w}),define(ee[27],te([0,1,19,12,7,30,11,25]),function(_,t,N,D,b,F,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,C.createDecorator)("configurationService");function u(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof b.URI)}t.isConfigurationOverrides=u;var m;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(m=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function I(n,i){const r=i?n?i.keys.filter(x=>n.keys.indexOf(x)===-1):[...i.keys]:[],l=n?i?n.keys.filter(x=>i.keys.indexOf(x)===-1):[...n.keys]:[],E=[];if(i&&n){for(const x of n.keys)if(i.keys.indexOf(x)!==-1){const B=f(n.contents,x),J=f(i.contents,x);N.equals(B,J)||E.push(x)}}const P=[],U=x=>{const B={};for(const J of x)for(const ie of J.identifiers)B[s(ie)]=J;return B},S=i?U(i.overrides):{},O=n?U(n.overrides):{};if(Object.keys(S).length)for(const x of r){const B=S[x];B&&P.push([(0,F.overrideIdentifierFromKey)(x),B.keys])}if(Object.keys(O).length)for(const x of l){const B=O[x];B&&P.push([(0,F.overrideIdentifierFromKey)(x),B.keys])}if(Object.keys(S).length&&Object.keys(O).length)for(const x of E){const B=O[x],J=S[x];if(B&&J){const ie=I({contents:B.contents,keys:B.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});P.push([(0,F.overrideIdentifierFromKey)(x),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:l,updated:E,overrides:P}}t.compare=I;function g(n,i){const r=[];for(const l of Object.keys(n))if(F.OVERRIDE_PROPERTY_PATTERN.test(l)){const E={};for(const P in n[l])E[P]=n[l][P];r.push({identifiers:[(0,F.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(E),contents:R(E,i)})}return r}t.toOverrides=g;function R(n,i){const r=Object.create(null);for(let l in n)a(r,l,n[l],i);return r}t.toValuesTree=R;function a(n,i,r,l){const E=i.split("."),P=E.pop();let U=n;for(let S=0;S<E.length;S++){let O=E[S],x=U[O];switch(typeof x){case"undefined":x=U[O]=Object.create(null);break;case"object":break;default:l(`Ignoring ${i} as ${E.slice(0,S+1).join(".")} is ${JSON.stringify(x)}`);return}U=x}if(typeof U=="object"&&U!==null)try{U[P]=r}catch(S){l(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(U)}`)}else l(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=a;function c(n,i){const r=i.split(".");w(n,r)}t.removeFromValueTree=c;function w(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const l=n[r];typeof l=="object"&&!Array.isArray(l)&&(w(l,i),Object.keys(l).length===0&&delete n[r])}}function f(n,i,r){function l(U,S){let O=U;for(const x of S){if(typeof O!="object"||O===null)return;O=O[x]}return O}const E=i.split("."),P=l(n,E);return typeof P=="undefined"?r:P}t.getConfigurationValue=f;function v(n,i,r){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in n?D.isObject(n[l])&&D.isObject(i[l])?v(n[l],i[l],r):r&&(n[l]=i[l]):n[l]=i[l])})}t.merge=v;function h(){const n=T.Registry.as(F.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=h;function o(){const n=Object.create(null),i=T.Registry.as(F.Extensions.Configuration).getConfigurationProperties();for(let r in i){let l=i[r].default;a(n,r,l,E=>console.error(`Conflict in default settings: ${E}`))}return n}t.getDefaultValues=o;function s(n){return`[${n}]`}t.keyFromOverrideIdentifier=s;function e(n,i,r){const l=n.inspect(i),E=n.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:l.defaultValue}t.getMigratedSettingValue=e}),define(ee[108],te([0,1,18,14,58,2,45,19,12,7,27,30,25]),function(_,t,N,D,b,F,C,T,u,m,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class R{constructor(e={},n=[],i=[]){this._contents=e,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const i=this.getContentsForOverrideIdentifer(n);return i?e?(0,p.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of N.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],E=n[r];E&&(typeof l=="object"&&typeof E=="object"?(l=T.deepClone(l),this.mergeContents(l,E)):l=E),i[r]=l}return new R(i,this.keys,this.overrides)}merge(...e){const n=T.deepClone(this.contents),i=T.deepClone(this.overrides),r=[...this.keys];for(const l of e){this.mergeContents(n,l.contents);for(const E of l.overrides){const[P]=i.filter(U=>N.equals(U.identifiers,E.identifiers));P?this.mergeContents(P.contents,E.contents):i.push(T.deepClone(E))}for(const E of l.keys)r.indexOf(E)===-1&&r.push(E)}return new R(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const i of Object.keys(n)){if(i in e&&u.isObject(e[i])&&u.isObject(n[i])){this.mergeContents(e[i],n[i]);continue}e[i]=T.deepClone(n[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,p.addToValueTree)(this.contents,e,n,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let i=0;i<n;i++)e.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=R;class a extends R{constructor(){const e=(0,p.getDefaultValues)(),n=(0,p.getConfigurationKeys)(),i=[];for(const r of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,p.toValuesTree)(e[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,n,i)}}t.DefaultConfigurationModel=a;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new R}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!u.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:i,keys:r,overrides:l,restricted:E}=this.doParseRaw(e,n);this._configurationModel=new R(i,r,l),this._restrictedConfigurations=E||[]}doParseContent(e){let n={},i=null,r=[],l=[],E=[];function P(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}let U={onObjectBegin:()=>{let S={};P(S),l.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let S=[];P(S),l.push(r),r=S,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:P,onError:(S,O,x)=>{E.push({error:S,offset:O,length:x})}};if(e)try{b.visit(e,U),n=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return n}doParseRaw(e,n){const i=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,i,!0,n);e=r.raw;const l=(0,p.toValuesTree)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),E=Object.keys(e),P=(0,p.toOverrides)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:l,keys:E,overrides:P,restricted:r.restricted}}filter(e,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const l={},E=[];for(let P in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(P)&&i){const U=this.filter(e[P],n,!1,r);l[P]=U.raw,E.push(...U.restricted)}else{const U=n[P],S=U?typeof U.scope!="undefined"?U.scope:3:void 0;U?.restricted&&E.push(P),(S===void 0||r.scopes===void 0||r.scopes.includes(S))&&(r.skipRestricted&&U?.restricted||(l[P]=e[P]))}return{raw:l,restricted:E}}}t.ConfigurationModelParser=c;class w extends F.Disposable{constructor(e,n,i,r){super();this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new R}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=w;class f{constructor(e,n,i=new R,r=new R,l=new C.ResourceMap,E=new R,P=new C.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=E,this._memoryConfigurationByResource=P,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(e)}updateValue(e,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new R,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,i){const r=this.getConsolidateConfigurationModel(n,i),l=this.getFolderConfigurationModelForResource(n.resource,i),E=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,P=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),S=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),x=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,B=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,J=n.overrideIdentifier?E.override(n.overrideIdentifier).getValue(e):E.getValue(e),ie=r.getValue(e),oe=N.distinct(N.flatten(r.overrides.map(Z=>Z.identifiers))).filter(Z=>r.getOverrideValue(e,Z)!==void 0);return{defaultValue:P,userValue:U,userLocalValue:S,userRemoteValue:O,workspaceValue:x,workspaceFolderValue:B,memoryValue:J,value:ie,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:l?.freeze().getValue(e),override:n.overrideIdentifier?l?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:E.getValue(e),override:n.overrideIdentifier?E.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const i=n.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,I.overrideIdentifierFromKey)(r),E=this._defaultConfiguration.getKeysForOverrideIdentifier(l),P=e.getKeysForOverrideIdentifier(l),U=[...P.filter(S=>E.indexOf(S)===-1),...E.filter(S=>P.indexOf(S)===-1),...E.filter(S=>!T.equals(this._defaultConfiguration.override(l).getValue(S),e.override(l).getValue(S)))];return[l,U]});return this.updateDefaultConfiguration(e),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,p.compare)(this.localUserConfiguration,e),E=[...n,...i,...r];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,p.compare)(this.remoteUserConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:i,removed:r,overrides:l}=(0,p.compare)(this.workspaceConfiguration,e);let E=[...n,...i,...r];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(e,n){const i=this.folderConfigurations.get(e),{added:r,updated:l,removed:E,overrides:P}=(0,p.compare)(i,n);let U=[...r,...l,...E];return(U.length||!i)&&this.updateFolderConfiguration(e,n),{keys:U,overrides:P}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:l,overrides:E}=(0,p.compare)(n,void 0);return{keys:[...i,...r,...l],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let i=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const l=this._memoryConfigurationByResource.get(e);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=i}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const i=n.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:i,overrides:r,keys:l}=this._folderConfigurations.get(n);return e.push([n,{contents:i,overrides:r,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((E,P)=>(E.set(m.URI.revive(P[0]),this.parseConfigurationModel(P[1])),E),new C.ResourceMap);return new f(n,i,new R,r,l,new R,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new R(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(l=>e.add(l)),r.overrides.forEach(([l,E])=>{const P=(0,C.getOrSet)(n,l,new Set);E.forEach(U=>P.add(U))});const i=[];return n.forEach((r,l)=>i.push([l,[...r.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=v;class h{constructor(e,n,i,r){this.change=e,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(P=>l.add(P)),e.overrides.forEach(([,P])=>P.forEach(U=>l.add(U))),this.affectedKeys=[...l.values()];const E=new R;this.affectedKeys.forEach(P=>E.setValue(P,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!T.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let i=(0,p.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(e=e[r],!e)return!1;i=i[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,n,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=i,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(ee[109],te([0,1,3,14,2,22,27,108,30,25]),function(_,t,N,D,b,F,C,T,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends b.Disposable{constructor(g,R){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,F.extUriBiasedIgnorePathCase,R)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,R){const a=typeof g=="string"?g:void 0,c=(0,C.isConfigurationOverrides)(g)?g:(0,C.isConfigurationOverrides)(R)?R:{};return this.configuration.getValue(a,c,void 0)}updateValue(g,R,a,c){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const R=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(a,R,1)}onDidDefaultConfigurationChange(g){const R=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,g);this.trigger(a,R,6)}trigger(g,R,a){const c=new T.ConfigurationChangeEvent(g,{data:R},this.configuration);c.source=a,c.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(ee[55],te([0,1,16,84,30,11,25]),function(_,t,N,D,b,F,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,F.createDecorator)("requestService");function T(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=T;function u(a){return a.res.statusCode===204}async function m(a){if(!T(a))throw new Error("Server returned "+a.res.statusCode);return u(a)?null:(await(0,N.streamToBuffer)(a.stream)).toString()}t.asText=m;async function p(a){if(!T(a))throw new Error("Server returned "+a.res.statusCode);if(u(a))return null;const w=(await(0,N.streamToBuffer)(a.stream)).toString();try{return JSON.parse(w)}catch(f){throw f.message+=`:
`+w,f}}t.asJson=p;function I(a){R(a)}t.updateProxyConfigurationsScope=I;let g;function R(a){const c=C.Registry.as(b.Extensions.Configuration);g&&c.deregisterConfigurations([g]),g={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},c.registerConfiguration(g)}R(2)}),define(ee[110],te([0,1,111,12]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(C,T){return C.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:C.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function F(C,T,u={}){const m=(0,N.parse)(C),p=u.proxyUrl||b(m,T);if(!p)return null;const I=(0,N.parse)(p);if(!/^https?:$/.test(I.protocol||""))return null;const g={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((R,a)=>{_(["http-proxy-agent"],R,a)}))(g):new(await new Promise((R,a)=>{_(["https-proxy-agent"],R,a)}))(g)}t.getProxyAgent=F}),define(ee[112],te([0,1,16,29]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(F,C,T){let u=T&&T.get("storage.serviceMachineId",0)||null;if(u)return u;try{const p=(await C.readFile(F.serviceMachineIdResource)).value.toString();u=(0,D.isUUID)(p)?p:null}catch(m){u=null}if(!u){u=(0,D.generateUuid)();try{await C.writeFile(F.serviceMachineIdResource,N.VSBuffer.fromString(u))}catch(m){}}return T&&T.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=b}),define(ee[113],te([0,1,3,14,2,12,66,11]),function(_,t,N,D,b,F,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var m;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(m=t.WillSaveStateReason||(t.WillSaveStateReason={}));var p;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(p=t.StorageScope||(t.StorageScope={}));var I;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class g extends b.Disposable{constructor(w={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,f){f===u?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:f,target:this.getKeyTargets(w)[f]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,f,v){return this.getStorage(f)?.get(w,v)}getBoolean(w,f,v){return this.getStorage(f)?.getBoolean(w,v)}getNumber(w,f,v){return this.getStorage(f)?.getNumber(w,v)}store(w,f,v,h){if((0,F.isUndefinedOrNull)(f)){this.remove(w,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,v,h),this.getStorage(v)?.set(w,f)})}remove(w,f){this.withPausedEmitters(()=>{this.updateKeyTarget(w,f,void 0),this.getStorage(f)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,f){const v=[],h=this.getKeyTargets(w);for(const o of Object.keys(h))h[o]===f&&v.push(o);return v}updateKeyTarget(w,f,v){const h=this.getKeyTargets(f);typeof v=="number"?h[w]!==v&&(h[w]=v,this.getStorage(f)?.set(u,JSON.stringify(h))):typeof h[w]=="number"&&(delete h[w],this.getStorage(f)?.set(u,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const f=this.get(u,w);if(f)try{return JSON.parse(f)}catch(v){}return Object.create(null)}isNew(w){return this.getBoolean(t.IS_NEW_KEY,w)===!0}async flush(w=m.NONE){this._onWillSaveState.fire({reason:w}),await N.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const w=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return a(w,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class R extends g{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}t.InMemoryStorageService=R;async function a(c,w,f,v){const h=l=>{try{return JSON.parse(l)}catch(E){return l}},o=new Map,s=new Map;c.forEach((l,E)=>{o.set(E,l),s.set(E,h(l))});const e=new Map,n=new Map;w.forEach((l,E)=>{e.set(E,l),n.set(E,h(l))}),console.group(`Storage: Global (path: ${f})`);let i=[];o.forEach((l,E)=>{i.push({key:E,value:l})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${v})`);let r=[];e.forEach((l,E)=>{r.push({key:E,value:l})}),console.table(r),console.groupEnd(),console.log(n)}t.logStorage=a}),define(ee[114],te([0,1,8,33,7,29]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function C(m){if(N.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function T(m,p,I,g,R,a,c,w,f,v){const h=Object.create(null);h["common.machineId"]=c,h.sessionID=(0,F.generateUuid)()+Date.now(),h.commitHash=R,h.version=a,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,N.PlatformToString)(N.platform),h["common.nodePlatform"]=D.platform,h["common.nodeArch"]=g,h["common.product"]=v||"desktop";const o=u(w||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),N.isLinuxSnap&&(h["common.snap"]="true");const n=C(I);n&&(h["common.platformDetail"]=n);try{const i=await m.readFile(b.URI.file(f));h["common.source"]=i.value.toString().slice(0,30)}catch(i){}return h}t.resolveCommonProperties=T;function u(m){const p=D.env.USERDNSDOMAIN;if(!p)return!1;const I=p.toLowerCase();return m.some(g=>I===g)}t.verifyMicrosoftInternalDomain=u}),define(ee[35],te([0,1,11]),function(_,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,N.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(ee[115],te([0,1,18,3,26,9,14,2,8,7,74,23,24,15,34,35]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let w=class extends T.Disposable{constructor(s,e,n){super();this.galleryService=s,this.telemetryService=e,this.logService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(p.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(i){throw this.logService.error((0,F.getErrorMessage)(i)),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new I.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,i),i}const n=await this.galleryService.getManifest(s,b.CancellationToken.None);if(n===null){const i=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(n.version!==s.version){const i=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(n,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(p.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,n){if(!m.URI.isUri(e)){let P=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],l=this.createInstallExtensionTask(s,e,n);m.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(l.identifier,s.version).key(),l),this._onInstallExtension.fire({identifier:l.identifier,source:e}),this.logService.info("Installing extension:",l.identifier.id),i.push({task:l,manifest:s});let E=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const U=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:S,manifest:O}of U)if(E=E||!!O.extensionDependencies?.some(x=>(0,g.areSameExtensions)({id:x},l.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(S.identifier,S.version).key()))this.logService.info("Extension is already requested to install",S.identifier.id);else{const x=this.createInstallExtensionTask(O,S,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(x.identifier,O.version).key(),x),this._onInstallExtension.fire({identifier:x.identifier,source:S}),this.logService.info("Installing extension:",x.identifier.id),i.push({task:x,manifest:O})}}catch(U){if(m.URI.isUri(l.source))(0,N.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,U.message),(0,N.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),this.logService.error(U),U}const P=i.reduce((U,{task:S,manifest:O})=>(U.set(S.identifier.id.toLowerCase(),{task:S,manifest:O}),U),new Map);for(;P.size;){let U;const S=[...P.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(x=>P.has(x.toLowerCase())));S.length?U=P.size===1?S:S.filter(({task:O})=>!(O===l&&!E)):(this.logService.info("Found extensions with circular dependencies",S.map(({task:O})=>O.identifier.id)),U=[...P.values()]),await this.joinAllSettled(U.map(async({task:O})=>{const x=new Date().getTime();try{const B=await O.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(B,O.source,n,b.CancellationToken.None))),!m.URI.isUri(O.source)&&(v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-x,void 0),u.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch(J){}r.push({local:B,identifier:O.identifier,operation:O.operation,source:O.source})}catch(B){throw m.URI.isUri(O.source)||v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-x,B),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(B),B}finally{P.delete(O.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:U})=>this.logService.info("Extension installed successfully:",U.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:U})=>(0,g.areSameExtensions)(U,l.identifier))[0].local}catch(P){if(i.forEach(({task:U})=>U.cancel()),r.length)try{const U=await Promise.allSettled(r.map(({local:S})=>this.createUninstallExtensionTask(S,{versionOnly:!0}).run()));for(let S=0;S<U.length;S++){const O=U[S],{identifier:x}=r[S];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",x.id):this.logService.warn("Rollback: Error while uninstalling extension",x.id,(0,F.getErrorMessage)(O.reason))}}catch(U){this.logService.warn("Error while rolling back extensions",(0,F.getErrorMessage)(U),r.map(({identifier:S})=>S.id))}throw this.logService.error("Failed to install extension:",l.identifier.id,(0,F.getErrorMessage)(P)),this._onDidInstallExtensions.fire(i.map(({task:U})=>({identifier:U.identifier,operation:1,source:U.source}))),P instanceof Error&&(P.name=P&&P.code?P.code:t.ERROR_UNKNOWN),P}finally{for(const{task:P,manifest:U}of i)if(!m.URI.isUri(P.source)){const S=new g.ExtensionIdentifierWithVersion(P.identifier,U.version).key();this.installingExtensions.delete(S)||this.logService.warn("Installation task is not found in the cache",S)}}}async joinAllSettled(s){const e=[],n=[],i=await Promise.allSettled(s);for(const r of i)r.status==="fulfilled"?e.push(r.value):n.push(r.reason);if(n.length)throw f(n);return e}async getAllDepsAndPackExtensionsToInstall(s,e,n){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[s,...i.map(P=>P.identifier)],l=[],E=async(P,U)=>{const S=U.extensionDependencies||[],O=[...S];if(U.extensionPack){const x=n?i.find(B=>(0,g.areSameExtensions)(B.identifier,P)):void 0;for(const B of U.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(J=>(0,g.areSameExtensions)({id:J},{id:B}))||O.every(J=>!(0,g.areSameExtensions)({id:J},{id:B}))&&O.push(B)}if(O.length){const x=[...r,...l.map(J=>J.gallery.identifier)],B=O.filter(J=>x.every(ie=>!(0,g.areSameExtensions)(ie,{id:J})));if(B.length){const J=await this.galleryService.query({names:B,pageSize:O.length},b.CancellationToken.None);for(const ie of J.firstPage){if(x.find(Q=>(0,g.areSameExtensions)(Q,ie.identifier)))continue;if(!S.some(Q=>(0,g.areSameExtensions)({id:Q},ie.identifier))&&!await this.canInstall(ie)){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}const Z=await this.checkAndGetCompatibleVersion(ie,!0),H=await this.galleryService.getManifest(Z,b.CancellationToken.None);if(H===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${Z.identifier.id}`,t.INSTALL_ERROR_VALIDATING);l.push({gallery:Z,manifest:H}),await E(Z.identifier,H)}}}};return await E(s,e),i=await this.getInstalled(),l.filter(P=>!i.some(U=>(0,g.areSameExtensions)(U.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new I.ExtensionManagementError(p.localize(3,null,s.identifier.id),I.INSTALL_ERROR_MALICIOUS);let n=null;if(await this.galleryService.isExtensionCompatible(s,I.CURRENT_TARGET_PLATFORM)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,I.CURRENT_TARGET_PLATFORM)),!n)throw new I.ExtensionManagementError(p.localize(4,null,s.identifier.id,a.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const i=(P,U)=>{const S=this.createUninstallExtensionTask(P,U);return this.uninstallingExtensions.set(S.extension.identifier.id.toLowerCase(),S),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),S},r=(P,U)=>{U?this.logService.error("Failed to uninstall extension:",P.identifier.id,U.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(P),void 0,U),this._onDidUninstallExtension.fire({identifier:P.identifier,error:U?.code})},l=[],E=[];try{l.push(i(s,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const U=this.getAllPackExtensionsToUninstall(s,P);for(const S of U)this.uninstallingExtensions.has(S.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",S.identifier.id):l.push(i(S,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(l.map(U=>U.extension),P,s),await this.joinAllSettled(l.map(async U=>{try{if(await U.run(),await this.joinAllSettled(this.participants.map(S=>S.postUninstall(U.extension,e,b.CancellationToken.None))),U.extension.identifier.uuid)try{await this.galleryService.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch(S){}r(U.extension)}catch(S){const O=S instanceof I.ExtensionManagementError?S:new I.ExtensionManagementError((0,F.getErrorMessage)(S),t.ERROR_UNKNOWN);throw r(U.extension,O),O}finally{E.push(U)}}))}catch(P){const U=P instanceof I.ExtensionManagementError?P:new I.ExtensionManagementError((0,F.getErrorMessage)(P),t.ERROR_UNKNOWN);for(const S of l){try{S.cancel()}catch(O){}E.includes(S)||r(S.extension,U)}throw U}finally{for(const P of l)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(s,e,n){for(const i of s){const r=this.getDependents(i,e);if(r.length){const l=r.filter(E=>!s.some(P=>(0,g.areSameExtensions)(P.identifier,E.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(i,l,n))}}}getDependentsErrorMessage(s,e,n){return n===s?e.length===1?p.localize(5,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(6,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(7,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?p.localize(8,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(9,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(10,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const r=e.filter(E=>!E.isBuiltin&&i.some(P=>(0,g.areSameExtensions)({id:P},E.identifier))),l=[];for(const E of r)l.push(...this.getAllPackExtensionsToUninstall(E,e,n));return[...r,...l]}return[]}getDependents(s,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(i=>(0,g.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};w=fe([he(0,I.IExtensionGalleryService),he(1,c.ITelemetryService),he(2,R.ILogService)],w),t.AbstractExtensionManagementService=w;function f(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=f;function v(o,s,e,n,i){const r=i?i instanceof I.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!i,duration:n,errorcode:r})}t.reportTelemetry=v;class h{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(s=>new Promise((e,n)=>{const i=s.onCancellationRequested(()=>{i.dispose(),n((0,F.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(ee[116],te([0,1,18,26,9,19,8,7,20,23,24,49,17,11,15,42,55,112,113,35]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f,v,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var o;(function(y){y[y.None=0]="None",y[y.IncludeVersions=1]="IncludeVersions",y[y.IncludeFiles=2]="IncludeFiles",y[y.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",y[y.IncludeSharedAccounts=8]="IncludeSharedAccounts",y[y.IncludeVersionProperties=16]="IncludeVersionProperties",y[y.ExcludeNonValidated=32]="ExcludeNonValidated",y[y.IncludeInstallationTargets=64]="IncludeInstallationTargets",y[y.IncludeAssetUri=128]="IncludeAssetUri",y[y.IncludeStatistics=256]="IncludeStatistics",y[y.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",y[y.Unpublished=4096]="Unpublished"})(o||(o={}));function s(...y){return String(y.reduce((d,A)=>d|A,0))}var e;(function(y){y[y.Tag=1]="Tag",y[y.ExtensionId=4]="ExtensionId",y[y.Category=5]="Category",y[y.ExtensionName=7]="ExtensionName",y[y.Target=8]="Target",y[y.Featured=9]="Featured",y[y.SearchText=10]="SearchText",y[y.ExcludeWithFlags=12]="ExcludeWithFlags"})(e||(e={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class E{constructor(d=l){this.state=d}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(d,A=this.state.pageSize){return new E({...this.state,pageNumber:d,pageSize:A})}withFilter(d,...A){const k=[...this.state.criteria,...A.length?A.map(V=>({filterType:d,value:V})):[{filterType:d}]];return new E({...this.state,criteria:k})}withSortBy(d){return new E({...this.state,sortBy:d})}withSortOrder(d){return new E({...this.state,sortOrder:d})}withFlags(...d){return new E({...this.state,flags:d.reduce((A,k)=>A|k,0)})}withAssetTypes(...d){return new E({...this.state,assetTypes:d})}get raw(){const{criteria:d,pageNumber:A,pageSize:k,sortBy:V,sortOrder:j,flags:X,assetTypes:G}=this.state;return{filters:[{criteria:d,pageNumber:A,pageSize:k,sortBy:V,sortOrder:j}],assetTypes:G,flags:X}}get searchText(){const d=this.state.criteria.filter(A=>A.filterType===e.SearchText)[0];return d&&d.value?d.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(d=>String(d.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function P(y,d){const A=(y||[]).filter(k=>k.statisticName===d)[0];return A?A.value:0}function U(y){const d="Microsoft.VisualStudio.Code.Translation.";return y.files.filter(k=>k.assetType.indexOf(d)===0).reduce((k,V)=>{const j=B(y,V.assetType);return j&&k.push([V.assetType.substring(d.length),j]),k},[])}function S(y){if(y.properties){const d=y.properties.filter(V=>V.key===n.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),k=d.filter(V=>A.test(V.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return B(y,n.Repository)}function O(y){return{uri:`${y.fallbackAssetUri}/${n.VSIX}?redirect=true${y.targetPlatform?`&targetPlatform=${y.targetPlatform}`:""}`,fallbackUri:`${y.fallbackAssetUri}/${n.VSIX}${y.targetPlatform?`?targetPlatform=${y.targetPlatform}`:""}`}}function x(y){const d=B(y,n.Icon);if(d)return d;const A=m.DefaultIconPath;return{uri:A,fallbackUri:A}}function B(y,d){return y.files.filter(k=>k.assetType===d)[0]?{uri:`${y.assetUri}/${d}`,fallbackUri:`${y.fallbackAssetUri}/${d}`}:null}function J(y,d){const A=y.properties?y.properties.filter(V=>V.key===d):[],k=A.length>0&&A[0].value;return k?k.split(",").map(V=>(0,p.adoptToGalleryExtensionId)(V)):[]}function ie(y){const d=y.properties?y.properties.filter(A=>A.key===i.Engine):[];return d.length>0&&d[0].value||""}function oe(y){const d=y.properties?y.properties.filter(k=>k.key===i.LocalizedLanguages):[],A=d.length>0&&d[0].value||"";return A?A.split(","):[]}function Z(y){return y.indexOf("preview")!==-1}function H(y){return y.targetPlatform?(0,m.toTargetPlatform)(y.targetPlatform):"undefined"}function Q(y){const d=(0,N.distinct)(y.versions.map(H)),A=!!y.tags?.includes(m.WEB_EXTENSION_TAG),k=d.indexOf("web");return A?k===-1&&d.push("web"):k!==-1&&d.splice(k,1),d}function Y(y,d){return d==="web"&&!y.includes("web")}function re(y,d,A){if(Y(d,A))return!1;if(y==="undefined"||y==="universal")return!0;if(y==="unknown")return!1;if(y===A)return!0;switch(A){case"win32-x64":return y==="win32-ia32";case"win32-arm64":return y==="win32-ia32";default:return!1}}function $(y,d,A,k){const V=Q(y);let j=y.versions[0];return j=y.versions.find(X=>X.version===j.version&&re(H(X),V,m.CURRENT_TARGET_PLATFORM))||j,M(y,j,V,d,A,k)}function M(y,d,A,k,V,j){const X={manifest:B(d,n.Manifest),readme:B(d,n.Details),changelog:B(d,n.Changelog),license:B(d,n.License),repository:S(d),download:O(d),icon:x(d),coreTranslations:U(d)};return{identifier:{id:(0,p.getGalleryExtensionId)(y.publisher.publisherName,y.extensionName),uuid:y.extensionId},name:y.extensionName,version:d.version,displayName:y.displayName,publisherId:y.publisher.publisherId,publisher:y.publisher.publisherName,publisherDisplayName:y.publisher.displayName,description:y.shortDescription||"",installCount:P(y.statistics,"install"),rating:P(y.statistics,"averagerating"),ratingCount:P(y.statistics,"ratingcount"),categories:y.categories||[],tags:y.tags||[],releaseDate:Date.parse(y.releaseDate),lastUpdated:Date.parse(y.lastUpdated),allTargetPlatforms:A,assets:X,properties:{dependencies:J(d,i.Dependency),extensionPack:J(d,i.ExtensionPack),engine:ie(d),localizedLanguages:oe(d),targetPlatform:H(d)},preview:Z(y.flags),telemetryData:{index:(V.pageNumber-1)*V.pageSize+k,querySource:j}}}let W=class{constructor(d,A,k,V,j,X,G){this.requestService=d,this.logService=A,this.environmentService=k,this.telemetryService=V,this.fileService=j,this.productService=X;const ne=X.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=L(X.version,this.environmentService,this.fileService,G)}api(d=""){return`${this.extensionsGalleryUrl}${d}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(d,A){const k=[];let V=new E().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,d.length).withFilter(e.Target,"Microsoft.VisualStudio.Code").withFilter(e.ExtensionName,...d.map(({id:X})=>X.toLowerCase()));d.every(X=>!X.version)&&(V=V.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:j}=await this.queryGallery(V,D.CancellationToken.None);for(let X=0;X<j.length;X++){const G=j[X];if(!G.versions.length)continue;const ne=(0,p.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),se=d.find(le=>(0,p.areSameExtensions)(le,{id:ne}))?.version;if(se){const le=G.versions.find(pe=>pe.version===se);le&&k.push(M(G,le,Q(G),X,V))}else k.push($(G,X,V))}return k}async getCompatibleExtension(d,A){const k=(0,m.isIExtensionIdentifier)(d)?null:d;if(k){if(Y(k.allTargetPlatforms,A))return null;if(await this.isExtensionCompatible(k,A))return k}const{id:V,uuid:j}=k?k.identifier:d;let X=new E().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(e.Target,"Microsoft.VisualStudio.Code");j?X=X.withFilter(e.ExtensionId,j):X=X.withFilter(e.ExtensionName,V);const{galleryExtensions:G}=await this.queryGallery(X,D.CancellationToken.None),[ne]=G;if(!ne||!ne.versions.length)return null;const se=Q(ne);if(Y(se,A))return null;for(let le of ne.versions){if(!ie(le)){const pe=await this.getEngine(le);le={...le,properties:[...le.properties||[],{key:i.Engine,value:pe}]}}if(await this.isRawExtensionVersionCompatible(le,se,A))return M(ne,le,se,0,X)}return null}async isExtensionCompatible(d,A){if(!re(d.properties.targetPlatform,d.allTargetPlatforms,A))return!1;let k=d.properties.engine;if(!k){const V=await this.getManifest(d,D.CancellationToken.None);if(!V)throw new Error("Manifest was not found");k=V.engines.vscode}return(0,I.isEngineValid)(k,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(d,A,k){if(!re(H(d),A,k))return!1;const V=await this.getEngine(d);return(0,I.isEngineValid)(V,this.productService.version,this.productService.date)}async query(d,A){const k=D.CancellationToken.isCancellationToken(d)?{}:d,V=D.CancellationToken.isCancellationToken(d)?d:A;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=k.text||"";const X=(0,F.getOrDefault)(k,Ie=>Ie.pageSize,50);let G=new E().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,X).withFilter(e.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,ye,me)=>(G=G.withFilter(e.Category,me||ye),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ie,ye,me)=>(G=G.withFilter(e.Tag,me||ye),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(e.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),G=G.withFilter(e.SearchText,j)),G=G.withSortBy(0)):k.ids?G=G.withFilter(e.ExtensionId,...k.ids):k.names?G=G.withFilter(e.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:ne,total:se}=await this.queryGallery(G,V),le=ne.map((Ie,ye)=>$(Ie,ye,G,k.source)),pe=async(Ie,ye)=>{if(ye.isCancellationRequested)throw(0,b.canceled)();const me=G.withPage(Ie+1),{galleryExtensions:Fe}=await this.queryGallery(me,ye);return Fe.map((Ee,Re)=>$(Ee,Re,me,k.source))};return{firstPage:le,total:se,pageSize:G.pageSize,getPage:pe}}async queryGallery(d,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");d=d.withFlags(d.flags,o.ExcludeNonValidated).withFilter(e.ExcludeWithFlags,s(o.Unpublished));const k=await this.commonHeadersPromise,V=JSON.stringify(d.raw),j={...k,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},X=new Date().getTime();let G,ne,se=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:j},A),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:se};const le=await(0,w.asJson)(G);if(le){const pe=le.results[0],Ie=pe.extensions,ye=pe.resultMetadata&&pe.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return se=ye&&ye.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:Ie,total:se}}return{galleryExtensions:[],total:se}}catch(le){throw ne=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...d.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-X,success:!!G&&(0,w.isSuccess)(G),responseBodySize:G?.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:ne?(0,b.isPromiseCanceledError)(ne)?"canceled":(0,b.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)})}}async reportStatistic(d,A,k,V){if(!this.isEnabled())return;const j=C.isWeb?this.api(`/itemName/${d}.${A}/version/${k}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${d}/extensions/${A}/${k}/stats?statType=${V}`),X=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:j,headers:ne},D.CancellationToken.None)}catch(se){}}async download(d,A,k){this.logService.trace("ExtensionGalleryService#download",d.identifier.id);const V=(0,p.getGalleryExtensionTelemetryData)(d),j=new Date().getTime(),X=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...V,duration:le}),G=k===1?"install":k===2?"update":"",ne=G?{uri:`${d.assets.download.uri}${T.URI.parse(d.assets.download.uri).query?"&":"?"}${G}=true`,fallbackUri:`${d.assets.download.fallbackUri}${T.URI.parse(d.assets.download.fallbackUri).query?"&":"?"}${G}=true`}:d.assets.download,se=await this.getAsset(ne);await this.fileService.writeFile(A,se.stream),X(new Date().getTime()-j)}async getReadme(d,A){if(d.assets.readme){const k=await this.getAsset(d.assets.readme,{},A);return await(0,w.asText)(k)||""}return""}async getManifest(d,A){if(d.assets.manifest){const k=await this.getAsset(d.assets.manifest,{},A),V=await(0,w.asText)(k);return V?JSON.parse(V):null}return null}async getManifestFromRawExtensionVersion(d,A){const k=B(d,n.Manifest);if(!k)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},j=await this.getAsset(k,{headers:V});return await(0,w.asJson)(j)}async getCoreTranslation(d,A){const k=d.assets.coreTranslations.filter(V=>V[0]===A.toUpperCase())[0];if(k){const V=await this.getAsset(k[1]),j=await(0,w.asText)(V);return j?JSON.parse(j):null}return null}async getChangelog(d,A){if(d.assets.changelog){const k=await this.getAsset(d.assets.changelog,{},A);return await(0,w.asText)(k)||""}return""}async getAllCompatibleVersions(d,A){let k=new E().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(e.Target,"Microsoft.VisualStudio.Code");d.identifier.uuid?k=k.withFilter(e.ExtensionId,d.identifier.uuid):k=k.withFilter(e.ExtensionName,d.identifier.id);const{galleryExtensions:V}=await this.queryGallery(k,D.CancellationToken.None);if(!V.length)return[];const j=Q(V[0]);if(Y(j,A))return[];const X=[];for(const G of V[0].versions)try{await this.isRawExtensionVersionCompatible(G,j,A)&&X.push({version:G.version,date:G.lastUpdated})}catch(ne){}return X}async getAsset(d,A={},k=D.CancellationToken.None){const V=await this.commonHeadersPromise,j={type:"GET"},X={...V,...A.headers||{}};A={...A,...j,headers:X};const G=d.uri,ne=d.fallbackUri,se={...A,url:G};try{const le=await this.requestService.request(se,k);if(le.res.statusCode===200)return le;const pe=await(0,w.asText)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${pe}`)}catch(le){if((0,b.isPromiseCanceledError)(le))throw le;const pe=(0,b.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:pe});const Ie={...A,url:ne};return this.requestService.request(Ie,k)}}async getEngine(d){let A=ie(d);if(!A){const k=await this.getManifestFromRawExtensionVersion(d,D.CancellationToken.None);if(!k)throw new Error("Manifest was not found");A=k.engines.vscode}return A}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const d=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(d.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await(0,w.asJson)(d),k=new Map;if(A)for(const V of A.malicious){const j=k.get(V)||{id:{id:V},malicious:!0,slow:!1};j.malicious=!0,k.set(V,j)}return[...k.values()]}};W=fe([he(0,w.IRequestService),he(1,a.ILogService),he(2,u.IEnvironmentService),he(3,h.ITelemetryService),he(4,g.IFileService),he(5,c.IProductService),he(6,(0,R.optional)(v.IStorageService))],W),t.ExtensionGalleryService=W;async function L(y,d,A,k){const V={"X-Market-Client-Id":`VSCode ${y}`,"User-Agent":`VSCode ${y}`},j=await(0,f.getServiceMachineId)(d,A,k);return V["X-Market-User-Id"]=j,V}t.resolveMarketplaceHeaders=L}),define(ee[117],te([0,1,2,19,21,85,27,30,11,34,25]),function(_,t,N,D,b,F,C,T,u,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let I=class{constructor(a,c){this._configurationService=c,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const f=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})}))}setExperimentProperty(a,c){this._experimentProperties[a]=c}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(g);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let c=a.sessionID,w=a["common.instanceId"],f=a["common.machineId"],v=a["common.firstSessionDate"],h=a["common.msftInternal"];return{sessionId:c,instanceId:w,machineId:f,firstSessionDate:v,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(a,c,w){return this.isOptedIn?this._commonProperties.then(f=>{c=(0,D.mixin)(c,f),c=(0,D.mixin)(c,this._experimentProperties),c=(0,D.cloneAndChange)(c,v=>{if(typeof v=="string")return this._cleanupInfo(v,w)}),this._appender.log(a,c)},f=>{console.error(f)}):Promise.resolve(void 0)}publicLog2(a,c,w){return this.publicLog(a,c,w)}publicLogError(a,c){return this.sendErrorTelemetry?this.publicLog(a,c,!0):Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}_cleanupInfo(a,c){let w=a;if(c){const f=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(a);if(!e)break;f.push([e.index,s.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(w="";;){const s=h.exec(a);if(!s)break;!v.test(s[0])&&f.every(([e,n])=>s.index<e||s.index>=n)&&(w+=a.substring(o,s.index)+"<REDACTED: user-file-path>",o=h.lastIndex)}o<a.length&&(w+=a.substr(o))}for(let f of this._cleanupPatterns)w=w.replace(f,"");return w}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=fe([he(1,(0,u.optional)(C.IConfigurationService))],I),t.TelemetryService=I;const g="telemetry";p.Registry.as(T.Extensions.Configuration).registerConfiguration({id:g,order:110,type:"object",title:(0,F.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,F.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,F.localize)(1,null,m.default.nameLong),default:!1,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[56],te([0,1,3,19,12,27]),function(_,t,N,D,b,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class C{async publicLog(c,w,f){}async publicLogError(c,w,f){}}t.NullEndpointTelemetryService=C;function T(...a){return{log:(c,w)=>a.forEach(f=>f.log(c,w)),flush:()=>N.Promises.settled(a.map(c=>c.flush()))}}t.combinedAppender=T,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(a,c){return c.onDidChangeConfiguration(w=>{w.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,F.ConfigurationTargetToString)(w.source),configurationKeys:g(w.sourceConfig)})})}t.configurationTelemetry=u;function m(a){const c=Object.create(null),w=Object.create(null),f=Object.create(null);I(a,f);for(let v in f){v=v.length>150?v.substr(v.length-149):v;const h=f[v];typeof h=="number"?w[v]=h:typeof h=="boolean"?w[v]=h?1:0:typeof h=="string"?c[v]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(c[v]=h)}return{properties:c,measurements:w}}t.validateTelemetryData=m;function p(a){if(!a)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{a.indexOf(`${f}+`)===0&&(c=f)}),c}t.cleanRemoteAuthority=p;function I(a,c,w=0,f){if(!!a)for(let v of Object.getOwnPropertyNames(a)){const h=a[v],o=f?f+v:v;Array.isArray(h)?c[o]=(0,D.safeStringify)(h):h instanceof Date?c[o]=h.toISOString():(0,b.isObject)(h)?w<2?I(h,c,w+1,o+"."):c[o]=(0,D.safeStringify)(h):c[o]=h}}function g(a){if(!a)return[];const c=[];return R(c,"",a),c}function R(a,c,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(f=>R(a,c?`${c}.${f}`:f,w[f])):a.push(c)}}),define(ee[118],te([0,1,9,19,56]),function(_,t,N,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function F(T){const u=await new Promise((p,I)=>{_(["applicationinsights"],p,I)});let m;return u.defaultClient?(m=new u.TelemetryClient(T),m.channel.setUseDiskRetryCaching(!0)):(u.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),m=u.defaultClient),T.indexOf("AIF-")===0&&(m.config.endpointUrl="https://0.0.0.0/collect/v1"),m}class C{constructor(u,m,p){this._eventPrefix=u,this._defaultData=m,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=F(this._aiClient)),this._asyncAIClient.then(m=>{u(m)},m=>{(0,N.onUnexpectedError)(m),console.error(m)})}}log(u,m){!this._aiClient||(m=(0,D.mixin)(m,this._defaultData),m=(0,b.validateTelemetryData)(m),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+u,properties:m.properties,measurements:m.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(m=>{m.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=C}),define(ee[119],te([0,1,4,10]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(F,C){const T=Object.create(null),u=(p,I)=>{const g=JSON.parse(p);T[I]=g};if(C){const p=[],I=await D.Promises.readdir(C);for(const R of I)try{(await D.Promises.stat((0,N.join)(C,R))).isDirectory()&&p.push(R)}catch{}const g=[];for(const R of p)(await D.Promises.readdir((0,N.join)(C,R))).filter(c=>c==="telemetry.json").length===1&&g.push(R);for(const R of g){const a=(await D.Promises.readFile((0,N.join)(C,R,"telemetry.json"))).toString();u(a,R)}}let m=(await D.Promises.readFile((0,N.join)(F,"telemetry-core.json"))).toString();return u(m,"vscode-core"),m=(await D.Promises.readFile((0,N.join)(F,"telemetry-extensions.json"))).toString(),u(m,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=b}),define(ee[43],te([0,1,37,3,4,12,10,72,132,133]),function(_,t,N,D,b,F,C,T,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,n){let i=n.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=n}}t.ExtractError=p;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,i)=>n+i,e&61440)}function g(s){if(s instanceof p)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new p(e,s)}function R(s,e,n,i,r,l){const E=b.dirname(e),P=b.join(i,E);if(!P.startsWith(i))return Promise.reject(new Error(T.localize(0,null,e)));const U=b.join(i,e);let S;return l.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(C.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((O,x)=>{if(!l.isCancellationRequested)try{S=(0,N.createWriteStream)(U,{mode:n}),S.once("close",()=>O()),S.once("error",x),s.once("error",x),s.pipe(S)}catch(B){x(B)}}))}function a(s,e,n,i){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((E,P)=>{const U=new D.Sequencer,S=O=>{O.isCancellationRequested||(l++,s.readEntry())};s.once("error",P),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===l?E():P(new p("Incomplete",new Error(T.localize(1,null,l,s.entryCount))))},P)),s.readEntry(),s.on("entry",O=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){S(i);return}const x=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(x)){const ie=b.join(e,x);r=(0,D.createCancelablePromise)(oe=>C.Promises.mkdir(ie,{recursive:!0}).then(()=>S(oe)).then(void 0,P));return}const B=w(s,O),J=I(O);r=(0,D.createCancelablePromise)(ie=>U.queue(()=>B.then(oe=>R(oe,x,J,e,n,ie).then(()=>S(ie)))).then(null,P))})})}function c(s,e=!1){return new Promise((n,i)=>{(0,u.open)(s,e?{lazyEntries:!0}:void 0,(r,l)=>{r?i(g(r)):n((0,F.assertIsDefined)(l))})})}function w(s,e){return new Promise((n,i)=>{s.openReadStream(e,(r,l)=>{r?i(g(r)):n((0,F.assertIsDefined)(l))})})}function f(s,e){return new Promise((n,i)=>{const r=new m.ZipFile;e.forEach(E=>{E.contents?r.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&r.addFile(E.localPath,E.path)}),r.end();const l=(0,N.createWriteStream)(s);r.outputStream.pipe(l),r.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>n(s))})}t.zip=f;function v(s,e,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let l=c(s,!0);return n.overwrite&&(l=l.then(E=>C.Promises.rm(e).then(()=>E))),l.then(E=>a(E,e,{sourcePathRegex:r},i))}t.extract=v;function h(s,e){return c(s).then(n=>new Promise((i,r)=>{n.on("entry",l=>{l.fileName===e&&w(n,l).then(E=>i(E),E=>r(E))}),n.once("close",()=>r(new Error(T.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(n=>new Promise((i,r)=>{const l=[];n.once("error",r),n.on("data",E=>l.push(E)),n.on("end",()=>i(Buffer.concat(l)))}))}t.buffer=o}),define(ee[120],te([0,1,43,78]),function(_,t,N,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(F){return(0,N.buffer)(F,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(T){throw new Error((0,D.localize)(0,null))}})}t.getManifest=b}),define(ee[121],te([0,1,18,3,9,2,13,4,8,22,41,7,29,10,43,79,20,23,24,88,17,15,42]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f,v,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",i="scanningUser",r="extracting",l="deleting",E="renaming";let P=class extends F.Disposable{constructor(S,O,x,B,J){super();this.beforeRemovingExtension=S,this.fileService=O,this.logService=x,this.environmentService=B,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=B.builtinExtensionsPath,this.extensionsPath=B.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const O=[];(S===null||S===0)&&O.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(x).message,n)))),(S===null||S===1)&&O.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(x).message,i))));try{const x=await Promise.all(O);return(0,N.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[O,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(B=>!O[new v.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]),S&&(x=(0,v.groupByExtension)(x,J=>J.identifier).map(J=>J.sort((ie,oe)=>p.rcompare(ie.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,O,x){const B=S.key(),J=T.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),ie=T.join(this.extensionsPath,B);try{await R.Promises.rm(ie)}catch(Z){try{await R.Promises.rm(ie)}catch(H){}throw new f.ExtensionManagementError((0,c.localize)(0,null,ie,S.id),l)}await this.extractAtLocation(S,O,J,x);let oe=await this.scanExtension(I.URI.file(J),1);if(!oe)throw new Error((0,c.localize)(1,null,J));await this.storeMetadata(oe,{installedTimestamp:Date.now()});try{await this.rename(S,J,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Z){try{await R.Promises.rm(J)}catch(H){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(Z)}. Deleted from extracted location`,J),Z}try{oe=await this.scanExtension(I.URI.file(ie),1)}catch(Z){}if(oe)return oe;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,O){return this.setMetadata(S,O),await this.storeMetadata(S,{...O,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,O){O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0;const x=T.join(S.location.fsPath,"package.json"),B=await R.Promises.readFile(x,"utf8"),{manifest:J}=await this.parseManifest(B);return J.__metadata=O,await R.Promises.writeFile(x,JSON.stringify(J,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const O=S.map(x=>new v.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{O.forEach(B=>x[B.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(B=>delete B[S.key()]);const x=(await this.scanExtensions(1)).find(B=>new v.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).equals(S))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await R.Promises.readFile(this.uninstalledPath,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let x={};if(O)try{x=JSON.parse(O)}catch(B){}return S&&(S(x),Object.keys(x).length?await R.Promises.writeFile(this.uninstalledPath,JSON.stringify(x)):await R.Promises.rm(this.uninstalledPath)),x})}async removeExtension(S,O){this.logService.trace(`Deleting ${O} extension from disk`,S.identifier.id,S.location.fsPath),await R.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[new v.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,O,x,B){this.logService.trace(`Started extracting the extension from ${O} to ${x}`);try{await R.Promises.rm(x)}catch(J){throw new f.ExtensionManagementError(this.joinErrors(J).message,l)}try{await(0,a.extract)(O,x,{sourcePath:"extension",overwrite:!0},B),this.logService.info(`Extracted extension to ${x}:`,S.id)}catch(J){try{await R.Promises.rm(x)}catch(ie){}throw new f.ExtensionManagementError(J.message,J instanceof a.ExtractError&&J.type?J.type:r)}}async rename(S,O,x,B){try{await R.Promises.rename(O,x)}catch(J){if(u.isWindows&&J&&J.code==="EPERM"&&Date.now()<B)return this.logService.info(`Failed renaming ${O} to ${x} with 'EPERM' error. Trying again...`,S.id),this.rename(S,O,x,B);throw new f.ExtensionManagementError(J.message||(0,c.localize)(3,null,O,x),J.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const O=this.scanDevSystemExtensions(),[x,B]=await Promise.all([S,O]);return[...x,...B]}async scanExtensionsInDir(S,O){const x=new D.Limiter(10),B=await this.fileService.resolve(I.URI.file(S));return B.children?(await Promise.all(B.children.filter(ie=>ie.isDirectory).map(ie=>x.queue(async()=>O===1&&(0,m.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,O))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(S,O){try{const x=await this.fileService.resolve(S);if(x.children){const{manifest:B,metadata:J}=await this.readManifest(S.fsPath),ie=x.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,oe=x.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource,Z={id:(0,v.getGalleryExtensionId)(B.publisher,B.name)},H={type:O,identifier:Z,manifest:B,location:S,readmeUrl:ie,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:O===0};return J&&(this.setMetadata(H,J),H.installedTimestamp=J.installedTimestamp),H}}catch(x){O!==0&&this.logService.trace(x)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const O=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",O.length),O.filter(x=>S.some(B=>(0,v.areSameExtensions)(x.identifier,{id:B})))}else return[]}setMetadata(S,O){S.publisherDisplayName=O.publisherDisplayName||null,S.publisherId=O.publisherId||null,S.identifier.uuid=O.id,S.isMachineScoped=!!O.isMachineScoped,S.isBuiltin=S.type===0||!!O.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),O=await this.scanAllUserExtensions(),x=new Set;for(const ie of O)S[new v.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||x.add(ie.identifier.id.toLowerCase());const B=(0,v.groupByExtension)(O,ie=>ie.identifier);await D.Promises.settled(B.map(async ie=>{const oe=ie.sort((Z,H)=>p.rcompare(Z.manifest.version,H.manifest.version))[0];x.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const J=O.filter(ie=>S[new v.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await D.Promises.settled(J.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),O=[],x=(0,v.groupByExtension)(S,B=>B.identifier);O.push(...(0,N.flatten)(x.map(B=>B.sort((J,ie)=>p.rcompare(J.manifest.version,ie.manifest.version)).slice(1)))),await D.Promises.settled(O.map(B=>this.removeExtension(B,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const O=Array.isArray(S)?S:[S];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((x,B)=>new Error(`${x.message}${x.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(C.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const O=[R.Promises.readFile(T.join(S,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),R.Promises.readFile(T.join(S,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:x,metadata:B},J]=await Promise.all(O);return{manifest:(0,h.localizeManifest)(x,J),metadata:B}}parseManifest(S){return new Promise((O,x)=>{try{const B=JSON.parse(S),J=B.__metadata||null;O({manifest:B,metadata:J})}catch(B){x(new Error((0,c.localize)(4,null)))}})}};P=fe([he(1,o.IFileService),he(2,s.ILogService),he(3,w.INativeEnvironmentService),he(4,e.IProductService)],P),t.ExtensionsScanner=P}),define(ee[122],te([0,1,28,13,4,8,22,41,7,29,10,43,77,94,20,115,23,24,100,101,120,96,121,102,49,17,11,15,34,35]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f,v,h,o,s,e,n,i,r,l,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const S="unsetUninstalled",O="downloading";let x=class extends c.AbstractExtensionManagementService{constructor(H,Q,Y,re,$,M,W){super(H,Q,Y);this.environmentService=re,this.downloadService=$;const L=this._register(M.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(e.ExtensionsScanner,d=>L.postUninstall(d))),this.manifestCache=this._register(new s.ExtensionsManifestCache(re,this)),this.extensionsDownloader=this._register(M.createInstance(v.ExtensionsDownloader));const y=this._register(new n.ExtensionsWatcher(this,W,re,Y));this._register(y.onDidChangeExtensionsByAnotherSource(({added:d,removed:A})=>{d.length&&this._onDidInstallExtensions.fire(d.map(k=>({identifier:k.identifier,operation:0,local:k}))),A.forEach(k=>this._onDidUninstallExtension.fire({identifier:k}))}))}async zip(H){this.logService.trace("ExtensionManagementService#zip",H.identifier.id);const Q=await this.collectFiles(H),Y=await(0,I.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,m.generateUuid)()).fsPath,Q);return u.URI.file(Y)}async unzip(H){return this.logService.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const Q=await this.downloadVsix(H),Y=b.resolve(Q.fsPath);return(0,o.getManifest)(Y)}getInstalled(H=null){return this.extensionsScanner.scanExtensions(H)}async canInstall(H){return!0}async install(H,Q={}){this.logService.trace("ExtensionManagementService#install",H.toString());const Y=await this.downloadVsix(H),re=await(0,o.getManifest)(b.resolve(Y.fsPath));if(re.engines&&re.engines.vscode&&!(0,i.isEngineValid)(re.engines.vscode,P.default.version,P.default.date))throw new Error(g.localize(0,null,(0,f.getGalleryExtensionId)(re.publisher,re.name),P.default.version));return this.installExtension(re,Y,Q)}async updateMetadata(H,Q){return this.logService.trace("ExtensionManagementService#updateMetadata",H.identifier.id),H=await this.extensionsScanner.saveMetadataForLocalExtension(H,{...H.manifest.__metadata||{},...Q}),this.manifestCache.invalidate(),H}async updateExtensionScope(H,Q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",H.identifier.id),H=await this.extensionsScanner.saveMetadataForLocalExtension(H,{...H.manifest.__metadata||{},isMachineScoped:Q}),this.manifestCache.invalidate(),H}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(H){if(H.scheme===D.Schemas.file)return H;if(!this.downloadService)throw new Error("Download service is not available");const Q=(0,C.joinPath)(this.environmentService.tmpDir,(0,m.generateUuid)());return await this.downloadService.download(H,Q),Q}createInstallExtensionTask(H,Q,Y){return u.URI.isUri(Q)?new ie(H,Q,Y,this.galleryService,this.extensionsScanner,this.logService):new J(Q,Y,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(H,Q){return new oe(H,Q,this.extensionsScanner)}async collectFiles(H){const Q=async re=>{let $=await p.Promises.readdir(re);$=$.map(L=>b.join(re,L));const M=await Promise.all($.map(L=>p.Promises.stat(L)));let W=Promise.resolve([]);return M.forEach((L,y)=>{const d=$[y];L.isFile()&&(W=W.then(A=>[...A,d])),L.isDirectory()&&(W=W.then(A=>Q(d).then(k=>[...A,...k])))}),W};return(await Q(H.location.fsPath)).map(re=>({path:`extension/${b.relative(H.location.fsPath,re)}`,localPath:re}))}};x=fe([he(0,w.IExtensionGalleryService),he(1,U.ITelemetryService),he(2,E.ILogService),he(3,a.INativeEnvironmentService),he(4,(0,l.optional)(R.IDownloadService)),he(5,l.IInstantiationService),he(6,r.IFileService)],x),t.ExtensionManagementService=x;class B extends c.AbstractExtensionTask{constructor(H,Q,Y,re){super();this.identifier=H,this.source=Q,this.extensionsScanner=Y,this.logService=re,this._operation=1}get operation(){return this._operation}async installExtension(H,Q){try{const Y=await this.unsetUninstalledAndGetLocal(H.identifierWithVersion);if(Y)return H.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Y,H.metadata):Y}catch(Y){throw F.isMacintosh?new w.ExtensionManagementError(g.localize(1,null),S):new w.ExtensionManagementError(g.localize(2,null),S)}return this.extract(H,Q)}async unsetUninstalledAndGetLocal(H){if(!await this.isUninstalled(H))return null;this.logService.trace("Removing the extension from uninstalled list:",H.id);const Y=await this.extensionsScanner.setInstalled(H);return this.logService.info("Removed the extension from uninstalled list:",H.id),Y}async isUninstalled(H){return!!(await this.extensionsScanner.getUninstalledExtensions())[H.key()]}async extract({zipPath:H,identifierWithVersion:Q,metadata:Y},re){let $=await this.extensionsScanner.extractUserExtension(Q,H,re);return this.logService.info("Extracting completed.",Q.id),Y&&($=await this.extensionsScanner.saveMetadataForLocalExtension($,Y)),$}}class J extends B{constructor(H,Q,Y,re,$){super(H.identifier,H,re,$);this.gallery=H,this.options=Q,this.extensionsDownloader=Y}async doRun(H){const Y=(await this.extensionsScanner.scanExtensions(null)).find(M=>(0,f.areSameExtensions)(M.identifier,this.gallery.identifier));Y&&(this._operation=2);const re=await this.downloadInstallableExtension(this.gallery,this._operation);re.metadata.isMachineScoped=this.options.isMachineScoped||Y?.isMachineScoped,re.metadata.isBuiltin=this.options.isBuiltin||Y?.isBuiltin;const $=await this.installExtension(re,H);Y&&T.neq(Y.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Y);try{await this.extensionsDownloader.delete(u.URI.file(re.zipPath))}catch(M){}return $}async downloadInstallableExtension(H,Q){const Y={id:H.identifier.uuid,publisherId:H.publisherId,publisherDisplayName:H.publisherDisplayName};let re;try{this.logService.trace("Started downloading extension:",H.identifier.id),re=(await this.extensionsDownloader.downloadExtension(H,Q)).fsPath,this.logService.info("Downloaded extension:",H.identifier.id,re)}catch($){throw new w.ExtensionManagementError((0,c.joinErrors)($).message,O)}try{const $=await(0,o.getManifest)(re);return{zipPath:re,identifierWithVersion:new f.ExtensionIdentifierWithVersion(H.identifier,$.version),metadata:Y}}catch($){throw new w.ExtensionManagementError((0,c.joinErrors)($).message,c.INSTALL_ERROR_VALIDATING)}}}class ie extends B{constructor(H,Q,Y,re,$,M){super({id:(0,f.getGalleryExtensionId)(H.publisher,H.name)},Q,$,M);this.manifest=H,this.location=Q,this.options=Y,this.galleryService=re}async doRun(H){const Q=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),re=(await this.extensionsScanner.scanExtensions(1)).find(M=>(0,f.areSameExtensions)(this.identifier,M.identifier)),$=await this.getMetadata(this.identifier.id,H);if(re)if($.isMachineScoped=this.options.isMachineScoped||re.isMachineScoped,$.isBuiltin=this.options.isBuiltin||re.isBuiltin,this._operation=2,Q.equals(new f.ExtensionIdentifierWithVersion(re.identifier,re.manifest.version)))try{await this.extensionsScanner.removeExtension(re,"existing")}catch(M){throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else T.gt(re.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(re);else{const M=await this.unsetUninstalledAndGetLocal(Q);if(M)try{await this.extensionsScanner.removeExtension(M,"existing")}catch(W){throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:b.resolve(this.location.fsPath),identifierWithVersion:Q,metadata:$},H)}async getMetadata(H,Q){try{const Y=(await this.galleryService.query({names:[H],pageSize:1},Q)).firstPage[0];if(Y)return{id:Y.identifier.uuid,publisherDisplayName:Y.publisherDisplayName,publisherId:Y.publisherId}}catch(Y){}return{}}}class oe extends c.AbstractExtensionTask{constructor(H,Q,Y){super();this.extension=H,this.options=Q,this.extensionsScanner=Y}async doRun(H){const Q=[],Y=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const re=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Q.push(...Y.filter($=>re.equals(new f.ExtensionIdentifierWithVersion($.identifier,$.manifest.version))))}else Q.push(...Y.filter(re=>(0,f.areSameExtensions)(re.identifier,this.extension.identifier)));if(!Q.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Q),this.options.remove)for(const re of Q)try{H.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(re)}catch($){throw new Error(g.localize(6,null,(0,N.toErrorMessage)($)))}}}}),define(ee[123],te([0,1,111,16,9,2,12,27,20,97,15,110,134]),function(_,t,N,D,b,F,C,T,u,m,p,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let R=class extends F.Disposable{constructor(c,w,f){super();this.environmentService=w,this.logService=f,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,w){this.logService.trace("RequestService#request",c.url);const{proxyUrl:f,strictSSL:v}=this,h={...process.env,...await(0,m.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=c.agent?c.agent:await(0,I.getProxyAgent)(c.url||"",h,{proxyUrl:f,strictSSL:v});return c.agent=o,c.strictSSL=v,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,w)}async getNodeRequest(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((v,h)=>{_(["https"],v,h)}):await new Promise((v,h)=>{_(["http"],v,h)})).request}_request(c,w){return new Promise(async(f,v)=>{let h;const o=(0,N.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,C.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),h=s(e,n=>{const i=(0,C.isNumber)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...c,url:n.headers.location,followRedirects:i-1},w).then(f,v);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,g.createGunzip)())),f({res:n,stream:(0,D.streamToBufferReadableStream)(r)})}}),h.on("error",v),c.timeout&&h.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&h.write(c.data),h.end(),w.onCancellationRequested(()=>{h.abort(),v((0,b.canceled)())})})}async resolveProxy(c){}};R=fe([he(0,T.IConfigurationService),he(1,u.INativeEnvironmentService),he(2,p.ILogService)],R),t.RequestService=R}),define(ee[135],te([0,1,37,136,38,3,16,28,9,2,13,4,33,7,10,27,109,20,87,116,23,95,122,17,105,106,50,99,52,53,103,15,104,34,42,55,123,114,35,117,56,118,119]),function(_,t,N,D,b,F,C,T,u,m,p,I,g,R,a,c,w,f,v,h,o,s,e,n,i,r,l,E,P,U,S,O,x,B,J,ie,oe,Z,H,Q,Y,re,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class M extends m.Disposable{constructor(y){super();this.argv=y,(0,D.gracefulify)(N),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[y,d]=await this.initServices();return y.invokeFunction(async A=>{const k=A.get(O.ILogService),V=A.get(n.IFileService),j=A.get(f.INativeEnvironmentService),X=A.get(o.IExtensionManagementCLIService);return k.info("CLI main",this.argv),this.registerErrorHandler(k),await this.doRun(j,X,V),(0,F.raceTimeout)((0,Y.combinedAppender)(...d).flush(),1e3)})}async initServices(){const y=new P.ServiceCollection,d={_serviceBrand:void 0,...B.default};y.set(J.IProductService,d);const A=new v.NativeEnvironmentService(this.argv,d);y.set(f.INativeEnvironmentService,A),await Promise.all([A.appSettingsHome.fsPath,A.extensionsPath].map(le=>le?a.Promises.mkdir(le,{recursive:!0}):void 0));const k=(0,O.getLogLevel)(A),V=[];V.push(new x.SpdLogLogger("cli",(0,I.join)(A.logsPath,"cli.log"),!0,k)),k===O.LogLevel.Trace&&V.push(new O.ConsoleLogger(k));const j=this._register(new O.MultiplexLogService(V));y.set(O.ILogService,j);const X=this._register(new i.FileService(j));y.set(n.IFileService,X);const G=this._register(new r.DiskFileSystemProvider(j));X.registerProvider(p.Schemas.file,G);const ne=this._register(new w.ConfigurationService(A.settingsResource,X));y.set(c.IConfigurationService,ne),await ne.initialize(),y.set(ie.IRequestService,new l.SyncDescriptor(oe.RequestService)),y.set(o.IExtensionManagementService,new l.SyncDescriptor(e.ExtensionManagementService)),y.set(o.IExtensionGalleryService,new l.SyncDescriptor(h.ExtensionGalleryService)),y.set(o.IExtensionManagementCLIService,new l.SyncDescriptor(s.ExtensionManagementCLIService)),y.set(U.ILocalizationsService,new l.SyncDescriptor(S.LocalizationsService));const se=[];if(A.isBuilt&&!A.isExtensionDevelopment&&!A.disableTelemetry&&d.enableTelemetry){d.aiConfig&&d.aiConfig.asimovKey&&se.push(new re.AppInsightsAppender("monacoworkbench",null,d.aiConfig.asimovKey));const{appRoot:le,extensionsPath:pe,installSourcePath:Ie}=A,ye={appender:(0,Y.combinedAppender)(...se),sendErrorTelemetry:!1,commonProperties:(async()=>{let me;try{const Fe=await a.Promises.readFile((0,I.join)(A.userDataPath,"storage.json"));me=JSON.parse(Fe.toString())[H.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&j.error(Fe)}return(0,Z.resolveCommonProperties)(X,(0,b.release)(),(0,b.hostname)(),process.arch,d.commit,d.version,me,d.msftInternalDomains,Ie)})(),piiPaths:[le,pe]};y.set(H.ITelemetryService,new l.SyncDescriptor(Q.TelemetryService,[ye]))}else y.set(H.ITelemetryService,Y.NullTelemetryService);return[new E.InstantiationService(y),se]}registerErrorHandler(y){(0,u.setUnexpectedErrorHandler)(d=>{const A=(0,T.toErrorMessage)(d,!0);!A||y.error(`[uncaught exception in CLI]: ${A}`)}),process.on("uncaughtException",d=>(0,u.onUnexpectedError)(d)),process.on("unhandledRejection",d=>(0,u.onUnexpectedError)(d))}async doRun(y,d,A){if(this.argv["install-source"])return this.setInstallSource(y,A,this.argv["install-source"]);if(this.argv["list-extensions"])return d.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return d.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return d.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return d.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,$.buildTelemetryMessage)(y.appRoot,y.extensionsPath))}asExtensionIdOrVSIX(y){return y.map(d=>/\.vsix$/i.test(d)?R.URI.file((0,I.isAbsolute)(d)?d:(0,I.join)((0,g.cwd)(),d)):d)}async setInstallSource(y,d,A){await d.writeFile(R.URI.file(y.installSourcePath),C.VSBuffer.fromString(A.slice(0,30)))}}async function W(L){const y=new M(L);try{await y.run()}finally{y.dispose()}}t.main=W})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/83bd43bc519d15e50c4272c6cf5c1479df196a4d/core/vs/code/node/cliProcessMain.js.map
