/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/process","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","os","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/environment/node/userDataPath","path","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],f=0,L=J.length;f<L;f++)e[f]=me[J[f]];return e};define(me[54],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(me[55],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function L(n){const T=[];for(let c in n)f.call(n,c)&&T.push(n[c]);return T}e.values=L;function I(n,T){for(let c in n)if(f.call(n,c)&&T({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=I;function k(n,T){const c=Object.create(null);for(const h of n){const o=T(h);let v=c[o];v||(v=c[o]=[]),v.push(h)}return c}e.groupBy=k;function R(n){const T=Object.create(null);return n&&n.forEach((c,h)=>{T[h]=c}),T}e.fromMap=R;function C(n,T){const c=[],h=[];for(let o of n)T.has(o)||c.push(o);for(let o of T)n.has(o)||h.push(o);return{removed:c,added:h}}e.diffSets=C;function y(n,T){const c=[],h=[];for(let[o,v]of n)T.has(o)||c.push(v);for(let[o,v]of T)n.has(o)||h.push(v);return{removed:c,added:h}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(T,c){let h=this.map.get(T);h||(h=new Set,this.map.set(T,h)),h.add(c)}delete(T,c){const h=this.map.get(T);!h||(h.delete(c),h.size===0&&this.map.delete(T))}forEach(T,c){const h=this.map.get(T);!h||h.forEach(c)}}e.SetMap=P}),define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(R){return(C,y,P)=>{let n=null,T=null;if(typeof P.value=="function"?(n="value",T=P.value):typeof P.get=="function"&&(n="get",T=P.get),!T)throw new Error("not supported");P[n]=R(T,y)}}e.createDecorator=f;function L(R,C,y){let P=null,n=null;if(typeof y.value=="function"?(P="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",n=y.get),!n)throw new Error("not supported");const T=`$memoize$${C}`;y[P]=function(...c){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[T]}}e.memoize=L;function I(R,C,y){return f((P,n)=>{const T=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...h){this[c]||(this[c]=y?y():void 0),clearTimeout(this[T]),C&&(this[c]=C(this[c],...h),h=[this[c]]),this[T]=setTimeout(()=>{P.apply(this,h),this[c]=y?y():void 0},R)}})}e.debounce=I;function k(R,C,y){return f((P,n)=>{const T=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,o=`$throttle$pending$${n}`;return function(...v){if(this[c]||(this[c]=y?y():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),C&&(this[c]=C(this[c],...v)),this[o])return;const _=this[h]+R;_<=Date.now()?(this[h]=Date.now(),P.apply(this,[this[c]]),this[c]=y?y():void 0):(this[o]=!0,this[T]=setTimeout(()=>{this[o]=!1,this[h]=Date.now(),P.apply(this,[this[c]]),this[c]=y?y():void 0},_-Date.now()))}})}e.throttle=k}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=f,e.errorHandler=new f;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function I(p){y(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=I;function k(p){y(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=k;function R(p){if(p instanceof Error){let{name:t,message:r}=p;const s=p.stacktrace||p.stack;return{$isError:!0,name:t,message:r,stack:s}}return p}e.transformErrorForSerialization=R;const C="Canceled";function y(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=y;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function n(){const p=new Error(C);return p.name=p.message,p}e.canceled=n;function T(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=T;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function h(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function o(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class A extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=A;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function l(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function a(p,t=Object.create(null)){const r=new Error(p);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(me[20],ge([0,1,16]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,Q=0){return H[H.length-(1+Q)]}e.tail=L;function I(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=I;function k(H,Q,X=(fe,_e)=>fe===_e){if(H===Q)return!0;if(!H||!Q||H.length!==Q.length)return!1;for(let fe=0,_e=H.length;fe<_e;fe++)if(!X(H[fe],Q[fe]))return!1;return!0}e.equals=k;function R(H,Q,X){let fe=0,_e=H.length-1;for(;fe<=_e;){const ye=(fe+_e)/2|0,Le=X(H[ye],Q);if(Le<0)fe=ye+1;else if(Le>0)_e=ye-1;else return ye}return-(fe+1)}e.binarySearch=R;function C(H,Q){let X=0,fe=H.length;if(fe===0)return 0;for(;X<fe;){const _e=Math.floor((X+fe)/2);Q(H[_e])?fe=_e:X=_e+1}return X}e.findFirstInSorted=C;function y(H,Q,X){if(H=H|0,H>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],_e=[],ye=[],Le=[];for(let ze of Q){const xe=X(ze,fe);xe<0?_e.push(ze):xe>0?ye.push(ze):Le.push(ze)}return H<_e.length?y(H,_e,X):H<_e.length+Le.length?Le[0]:y(H-(_e.length+Le.length),ye,X)}e.quickSelect=y;function P(H,Q){const X=[];let fe;for(const _e of H.slice(0).sort(Q))!fe||Q(fe[0],_e)!==0?(fe=[_e],X.push(fe)):fe.push(_e);return X}e.groupBy=P;function n(H,Q,X){const fe=[];function _e(ze,xe,Ge){if(xe===0&&Ge.length===0)return;const z=fe[fe.length-1];z&&z.start+z.deleteCount===ze?(z.deleteCount+=xe,z.toInsert.push(...Ge)):fe.push({start:ze,deleteCount:xe,toInsert:Ge})}let ye=0,Le=0;for(;;){if(ye===H.length){_e(ye,0,Q.slice(Le));break}if(Le===Q.length){_e(ye,H.length-ye,[]);break}const ze=H[ye],xe=Q[Le],Ge=X(ze,xe);Ge===0?(ye+=1,Le+=1):Ge<0?(_e(ye,1,[]),ye+=1):Ge>0&&(_e(ye,0,[xe]),Le+=1)}return fe}e.sortedDiff=n;function T(H,Q,X){const fe=n(H,Q,X),_e=[],ye=[];for(const Le of fe)_e.push(...H.slice(Le.start,Le.start+Le.deleteCount)),ye.push(...Le.toInsert);return{removed:_e,added:ye}}e.delta=T;function c(H,Q,X){if(X===0)return[];const fe=H.slice(0,X).sort(Q);return o(H,Q,fe,X,H.length),fe}e.top=c;function h(H,Q,X,fe,_e){return X===0?Promise.resolve([]):new Promise((ye,Le)=>{(async()=>{const ze=H.length,xe=H.slice(0,X).sort(Q);for(let Ge=X,z=Math.min(X+fe,ze);Ge<ze;Ge=z,z=Math.min(z+fe,ze)){if(Ge>X&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,f.canceled)();o(H,Q,xe,Ge,z)}return xe})().then(ye,Le)})}e.topAsync=h;function o(H,Q,X,fe,_e){for(const ye=X.length;fe<_e;fe++){const Le=H[fe];if(Q(Le,X[ye-1])<0){X.pop();const ze=C(X,xe=>Q(Le,xe)<0);X.splice(ze,0,Le)}}}function v(H){return H.filter(Q=>!!Q)}e.coalesce=v;function _(H){let Q=0;for(let X=0;X<H.length;X++)H[X]&&(H[Q]=H[X],Q+=1);H.length=Q}e.coalesceInPlace=_;function A(H,Q,X){H.splice(X,0,H.splice(Q,1)[0])}e.move=A;function E(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=E;function l(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=l;function a(H,Q){if(!Q)return H.filter((fe,_e)=>H.indexOf(fe)===_e);const X=Object.create(null);return H.filter(fe=>{const _e=Q(fe);return X[_e]?!1:(X[_e]=!0,!0)})}e.distinct=a;function p(H){const Q=new Set;return H.filter(X=>Q.has(X)?!1:(Q.add(X),!0))}e.distinctES6=p;function t(H){const Q=Object.create(null);return X=>{const fe=H(X);return Q[fe]?!1:(Q[fe]=!0,!0)}}e.uniqueFilter=t;function r(H,Q){for(let X=H.length-1;X>=0;X--){const fe=H[X];if(Q(fe))return X}return-1}e.lastIndex=r;function s(H,Q){return H.length>0?H[0]:Q}e.firstOrDefault=s;function i(H,Q,X=(fe,_e)=>fe===_e){let fe=0;for(let _e=0,ye=Math.min(H.length,Q.length);_e<ye&&X(H[_e],Q[_e]);_e++)fe++;return fe}e.commonPrefixLength=i;function g(H){return[].concat(...H)}e.flatten=g;function u(H,Q){let X=typeof Q=="number"?H:0;typeof Q=="number"?X=H:(X=0,Q=H);const fe=[];if(X<=Q)for(let _e=X;_e<Q;_e++)fe.push(_e);else for(let _e=X;_e>Q;_e--)fe.push(_e);return fe}e.range=u;function d(H,Q,X){return H.reduce((fe,_e)=>(fe[Q(_e)]=X?X(_e):_e,fe),Object.create(null))}e.index=d;function w(H,Q){return H.push(Q),()=>D(H,Q)}e.insert=w;function D(H,Q){const X=H.indexOf(Q);if(X>-1)return H.splice(X,1),Q}e.remove=D;function m(H,Q,X){const fe=H.slice(0,Q),_e=H.slice(Q);return fe.concat(X,_e)}e.arrayInsert=m;function S(H,Q){let X;if(typeof Q=="number"){let fe=Q;X=()=>{const _e=Math.sin(fe++)*179426549;return _e-Math.floor(_e)}}else X=Math.random;for(let fe=H.length-1;fe>0;fe-=1){const _e=Math.floor(X()*(fe+1)),ye=H[fe];H[fe]=H[_e],H[_e]=ye}}e.shuffle=S;function b(H,Q){const X=H.indexOf(Q);X>-1&&(H.splice(X,1),H.unshift(Q))}e.pushToStart=b;function F(H,Q){const X=H.indexOf(Q);X>-1&&(H.splice(X,1),H.push(Q))}e.pushToEnd=F;function N(H,Q){return Array.isArray(H)?H.map(Q):Q(H)}e.mapArrayOrNot=N;function G(H){return Array.isArray(H)?H:[H]}e.asArray=G;function K(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=K;function M(H,Q){for(const X of H){const fe=Q(X);if(fe!==void 0)return fe}}e.mapFind=M;function U(H,Q,X){const fe=$(H,Q),_e=H.length,ye=X.length;H.length=_e+ye;for(let Le=_e-1;Le>=fe;Le--)H[Le+ye]=H[Le];for(let Le=0;Le<ye;Le++)H[Le+fe]=X[Le]}e.insertInto=U;function O(H,Q,X,fe){const _e=$(H,Q),ye=H.splice(_e,X);return U(H,_e,fe),ye}e.splice=O;function $(H,Q){return Q<0?Math.max(Q+H.length,0):Math.min(Q,H.length)}function B(H,Q){let X=Number.MAX_SAFE_INTEGER,fe=0;return H.forEach((_e,ye)=>{const Le=Q(_e);Le<X&&(X=Le,fe=ye)}),fe}e.minIndex=B;function x(H,Q){let X=Number.MIN_SAFE_INTEGER,fe=0;return H.forEach((_e,ye)=>{const Le=Q(_e);Le>X&&(X=Le,fe=ye)}),fe}e.maxIndex=x;class j{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let X=this.firstIdx;for(;X<this.items.length&&Q(this.items[X]);)X++;const fe=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,fe}takeFromEndWhile(Q){let X=this.lastIdx;for(;X>=0&&Q(this.items[X]);)X--;const fe=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,fe}}e.ArrayQueue=j}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(L){const I=this;let k=!1,R;return function(){return k||(k=!0,R=L.apply(I,arguments)),R}}e.once=f}),define(me[76],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(me[77],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(L){function I(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=I;const k=Object.freeze([]);function R(){return k}L.empty=R;function*C(p){yield p}L.single=C;function y(p){return p||k}L.from=y;function P(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=P;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function T(p,t){for(const r of p)if(t(r))return!0;return!1}L.some=T;function c(p,t){for(const r of p)if(t(r))return r}L.find=c;function*h(p,t){for(const r of p)t(r)&&(yield r)}L.filter=h;function*o(p,t){let r=0;for(const s of p)yield t(s,r++)}L.map=o;function*v(...p){for(const t of p)for(const r of t)yield r}L.concat=v;function*_(p){for(const t of p)for(const r of t)yield r}L.concatNested=_;function A(p,t,r){let s=r;for(const i of p)s=t(s,i);return s}L.reduce=A;function*E(p,t,r=p.length){for(t<0&&(t+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);t<r;t++)yield p[t]}L.slice=E;function l(p,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,p];const s=p[Symbol.iterator]();for(let i=0;i<t;i++){const g=s.next();if(g.done)return[r,L.empty()];r.push(g.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=l;function a(p,t,r=(s,i)=>s===i){const s=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const g=s.next(),u=i.next();if(g.done!==u.done)return!1;if(g.done)return!0;if(!r(g.value,u.value))return!1}}L.equals=a})(f=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function R(t,r=!1){let s=0,i=t.length,g="",u=0,d=16,w=0;function D(K){let M=0,U=0;for(;M<K;){const O=t.charCodeAt(s);if(O>=48&&O<=57)U=U*16+O-48;else if(O>=65&&O<=70)U=U*16+O-65+10;else if(O>=97&&O<=102)U=U*16+O-97+10;else break;s++,M++}return M<K&&(U=-1),U}function m(K){s=K,g="",u=0,d=16,w=0}function S(){const K=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return w=3,t.substring(K,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;M=s}else w=3;return t.substring(K,M)}function b(){let K="",M=s;for(;;){if(s>=i){K+=t.substring(M,s),w=2;break}const U=t.charCodeAt(s);if(U===34){K+=t.substring(M,s),s++;break}if(U===92){if(K+=t.substring(M,s),s++,s>=i){w=2;break}switch(t.charCodeAt(s++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const $=D(4);$>=0?K+=String.fromCharCode($):w=4;break;default:w=5}M=s;continue}if(U>=0&&U<=31)if(y(U)){K+=t.substring(M,s),w=2;break}else w=6;s++}return K}function F(){if(g="",w=0,u=s,s>=i)return u=i,d=17;let K=t.charCodeAt(s);if(C(K)){do s++,g+=String.fromCharCode(K),K=t.charCodeAt(s);while(C(K));return d=15}if(y(K))return s++,g+=String.fromCharCode(K),K===13&&t.charCodeAt(s)===10&&(s++,g+=`
`),d=14;switch(K){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,g=b(),d=10;case 47:const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(t.charCodeAt(s));)s++;return g=t.substring(M,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const U=i-1;let O=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,O=!0;break}s++}return O||(s++,w=1),g=t.substring(M,s),d=13}return g+=String.fromCharCode(K),s++,d=16;case 45:if(g+=String.fromCharCode(K),s++,s===i||!P(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=S(),d=11;default:for(;s<i&&N(K);)s++,K=t.charCodeAt(s);if(u!==s){switch(g=t.substring(u,s),g){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return g+=String.fromCharCode(K),s++,d=16}}function N(K){if(C(K)||y(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:m,getPosition:()=>s,scan:r?G:F,getToken:()=>d,getTokenValue:()=>g,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>w}}e.createScanner=R;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function T(t,r){const s=[],i=new Object;let g;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function w(D,m,S,b){u.value=D,u.offset=m,u.length=S,u.type=b,u.colonOffset=void 0,g=u}try{l(t,{onObjectBegin:(D,m)=>{if(r<=D)throw i;g=void 0,d=r>D,s.push("")},onObjectProperty:(D,m,S)=>{if(r<m||(w(D,m,S,"property"),s[s.length-1]=D,r<=m+S))throw i},onObjectEnd:(D,m)=>{if(r<=D)throw i;g=void 0,s.pop()},onArrayBegin:(D,m)=>{if(r<=D)throw i;g=void 0,s.push(0)},onArrayEnd:(D,m)=>{if(r<=D)throw i;g=void 0,s.pop()},onLiteralValue:(D,m,S)=>{if(r<m||(w(D,m,S,p(D)),r<=m+S))throw i},onSeparator:(D,m,S)=>{if(r<=m)throw i;if(D===":"&&g&&g.type==="property")g.colonOffset=m,d=!1,g=void 0;else if(D===","){const b=s[s.length-1];typeof b=="number"?s[s.length-1]=b+1:(d=!0,s[s.length-1]=""),g=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:g,isAtPropertyKey:d,matches:D=>{let m=0;for(let S=0;m<D.length&&S<s.length;S++)if(D[m]===s[S]||D[m]==="*")m++;else if(D[m]!=="**")return!1;return m===D.length}}}e.getLocation=T;function c(t,r=[],s=k.DEFAULT){let i=null,g=[];const u=[];function d(D){Array.isArray(g)?g.push(D):i!==null&&(g[i]=D)}return l(t,{onObjectBegin:()=>{const D={};d(D),u.push(g),g=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{g=u.pop()},onArrayBegin:()=>{const D=[];d(D),u.push(g),g=D,i=null},onArrayEnd:()=>{g=u.pop()},onLiteralValue:d,onError:(D,m,S)=>{r.push({error:D,offset:m,length:S})}},s),g[0]}e.parse=c;function h(t,r=[],s=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}l(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,m,S)=>{i=u({type:"property",offset:m,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:m,length:S,parent:i})},onObjectEnd:(D,m)=>{i.length=D+m-i.offset,i=i.parent,g(D+m)},onArrayBegin:(D,m)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,m)=>{i.length=D+m-i.offset,i=i.parent,g(D+m)},onLiteralValue:(D,m,S)=>{u({type:p(D),offset:m,length:S,parent:i,value:D}),g(m+S)},onSeparator:(D,m,S)=>{i.type==="property"&&(D===":"?i.colonOffset=m:D===","&&g(m))},onError:(D,m,S)=>{r.push({error:D,offset:m,length:S})}},s);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=h;function o(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let g=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],g=!0;break}if(!g)return}else{const g=i;if(s.type!=="array"||g<0||!Array.isArray(s.children)||g>=s.children.length)return;s=s.children[g]}return s}e.findNodeAtLocation=o;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=_(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function A(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=A;function E(t,r,s=!1){if(A(t,r,s)){const i=t.children;if(Array.isArray(i))for(let g=0;g<i.length&&i[g].offset<=r;g++){const u=E(i[g],r,s);if(u)return u}return t}}e.findNodeAtOffset=E;function l(t,r,s=k.DEFAULT){const i=R(t,!1);function g(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(X){return X?fe=>X(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=g(r.onObjectBegin),w=u(r.onObjectProperty),D=g(r.onObjectEnd),m=g(r.onArrayBegin),S=g(r.onArrayEnd),b=u(r.onLiteralValue),F=u(r.onSeparator),N=g(r.onComment),G=u(r.onError),K=s&&s.disallowComments,M=s&&s.allowTrailingComma;function U(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:K||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(X){case 12:case 13:K?O(10):N();break;case 16:O(1);break;case 15:case 14:break;default:return X}}}function O(X,fe=[],_e=[]){if(G(X),fe.length+_e.length>0){let ye=i.getToken();for(;ye!==17;){if(fe.indexOf(ye)!==-1){U();break}else if(_e.indexOf(ye)!==-1)break;ye=U()}}}function $(X){const fe=i.getTokenValue();return X?b(fe):w(fe),U(),!0}function B(){switch(i.getToken()){case 11:let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(O(2),X=0)}catch(fe){O(2)}b(X);break;case 7:b(null);break;case 8:b(!0);break;case 9:b(!1);break;default:return!1}return U(),!0}function x(){return i.getToken()!==10?(O(3,[],[2,5]),!1):($(!1),i.getToken()===6?(F(":"),U(),Q()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function j(){d(),U();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||O(4,[],[]),F(","),U(),i.getToken()===2&&M)break}else X&&O(6,[],[]);x()||O(4,[],[2,5]),X=!0}return D(),i.getToken()!==2?O(7,[2],[]):U(),!0}function H(){m(),U();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||O(4,[],[]),F(","),U(),i.getToken()===4&&M)break}else X&&O(6,[],[]);Q()||O(4,[],[4,5]),X=!0}return S(),i.getToken()!==4?O(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return H();case 1:return j();case 10:return $(!0);default:return B()}}return U(),i.getToken()===17?s.allowEmptyContent?!0:(O(4,[],[]),!1):Q()?(i.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=l;function a(t,r){let s=R(t),i=[],g,u=0,d;do switch(d=s.getPosition(),g=s.scan(),g){case 12:case 13:case 17:u!==d&&i.push(t.substring(u,d)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),u=s.getPosition();break}while(g!==17);return i.join("")}e.stripComments=a;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,57]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,P,n){let T,c,h,o,v;if(P){for(o=P.offset,v=o+P.length,h=o;h>0&&!C(y,h-1);)h--;let u=v;for(;u<y.length&&!C(y,u);)u++;c=y.substring(h,u),T=k(c,n)}else c=y,T=0,h=0,o=0,v=y.length;const _=R(n,y);let A=!1,E=0,l;n.insertSpaces?l=I(" ",n.tabSize||4):l="	";const a=(0,f.createScanner)(c,!1);let p=!1;function t(){return _+I(l,T+E)}function r(){let u=a.scan();for(A=!1;u===15||u===14;)A=A||u===14,u=a.scan();return p=u===16||a.getTokenError()!==0,u}const s=[];function i(u,d,w){!p&&d<v&&w>o&&y.substring(d,w)!==u&&s.push({offset:d,length:w-d,content:u})}let g=r();if(g!==17){const u=a.getTokenOffset()+h,d=I(l,T);i(d,h,u)}for(;g!==17;){let u=a.getTokenOffset()+a.getTokenLength()+h,d=r(),w="";for(;!A&&(d===12||d===13);){const m=a.getTokenOffset()+h;i(" ",u,m),u=a.getTokenOffset()+a.getTokenLength()+h,w=d===12?t():"",d=r()}if(d===2)g!==1&&(E--,w=t());else if(d===4)g!==3&&(E--,w=t());else{switch(g){case 3:case 1:E++,w=t();break;case 5:case 12:w=t();break;case 13:A?w=t():w=" ";break;case 6:w=" ";break;case 10:if(d===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?w=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}A&&(d===12||d===13)&&(w=t())}const D=a.getTokenOffset()+h;i(w,u,D),g=d}return s}e.format=L;function I(y,P){let n="";for(let T=0;T<P;T++)n+=y;return n}function k(y,P){let n=0,T=0;const c=P.tabSize||4;for(;n<y.length;){const h=y.charAt(n);if(h===" ")T++;else if(h==="	")T+=c;else break;n++}return Math.floor(T/c)}function R(y,P){for(let n=0;n<P.length;n++){const T=P.charAt(n);if(T==="\r")return n+1<P.length&&P.charAt(n+1)===`
`?`\r
`:"\r";if(T===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=R;function C(y,P){return`\r
`.indexOf(y.charAt(P))!==-1}e.isEOL=C}),define(me[138],ge([0,1,57,137]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,n,T){return k(P,n,void 0,T)}e.removeProperty=I;function k(P,n,T,c,h){const o=n.slice(),v=[],_=(0,f.parseTree)(P,v);let A,E;for(;o.length>0&&(E=o.pop(),A=(0,f.findNodeAtLocation)(_,o),A===void 0&&T!==void 0);)typeof E=="string"?T={[E]:T}:T=[T];if(A)if(A.type==="object"&&typeof E=="string"&&Array.isArray(A.children)){const l=(0,f.findNodeAtLocation)(A,[E]);if(l!==void 0)if(T===void 0){if(!l.parent)throw new Error("Malformed AST");const a=A.children.indexOf(l.parent);let p,t=l.parent.offset+l.parent.length;if(a>0){const r=A.children[a-1];p=r.offset+r.length}else p=A.offset+1,A.children.length>1&&(t=A.children[1].offset);return R(P,{offset:p,length:t-p,content:""},c)}else return R(P,{offset:l.offset,length:l.length,content:JSON.stringify(T)},c);else{if(T===void 0)return[];const a=`${JSON.stringify(E)}: ${JSON.stringify(T)}`,p=h?h(A.children.map(r=>r.children[0].value)):A.children.length;let t;if(p>0){const r=A.children[p-1];t={offset:r.offset+r.length,length:0,content:","+a}}else A.children.length===0?t={offset:A.offset+1,length:0,content:a}:t={offset:A.offset+1,length:0,content:a+","};return R(P,t,c)}}else if(A.type==="array"&&typeof E=="number"&&Array.isArray(A.children))if(T!==void 0){const l=`${JSON.stringify(T)}`;let a;if(A.children.length===0||E===0)a={offset:A.offset+1,length:0,content:A.children.length===0?l:l+","};else{const p=E===-1||E>A.children.length?A.children.length:E,t=A.children[p-1];a={offset:t.offset+t.length,length:0,content:","+l}}return R(P,a,c)}else{const l=E,a=A.children[l];let p;if(A.children.length===1)p={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===l){const t=A.children[l-1],r=t.offset+t.length,s=A.offset+A.length;p={offset:r,length:s-2-r,content:""}}else p={offset:a.offset,length:A.children[l+1].offset-a.offset,content:""};return R(P,p,c)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${A.type}`);else{if(T===void 0)throw new Error("Can not delete in empty document");return R(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(T)},c)}}e.setProperty=k;function R(P,n,T){let c=C(P,n),h=n.offset,o=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;h>0&&!(0,L.isEOL)(c,h-1);)h--;for(;o<c.length&&!(0,L.isEOL)(c,o);)o++}const v=(0,L.format)(c,{offset:h,length:o-h},T);for(let A=v.length-1;A>=0;A--){const E=v[A];c=C(c,E),h=Math.min(h,E.offset),o=Math.max(o,E.offset+E.length),o+=E.content.length-E.length}const _=P.length-(c.length-o)-h;return[{offset:h,length:_,content:c.substring(h,o)}]}e.withFormatting=R;function C(P,n){return P.substring(0,n.offset)+n.content+P.substring(n.offset+n.length)}e.applyEdit=C;function y(P,n){let T=n.slice(0).sort((h,o)=>{const v=h.offset-o.offset;return v===0?h.length-o.length:v}),c=P.length;for(let h=T.length-1;h>=0;h--){let o=T[h];if(o.offset+o.length<=c)P=C(P,o);else throw new Error("Overlapping edit");c=o.offset}return P}e.applyEdits=y}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(me[6],ge([0,1,75,77]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let k=null;function R(s){k=s}if(e.setDisposableTracker=R,I){const s="__is_disposable_tracked__";R(new class{trackDisposable(i){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(g)},3e3)}setParent(i,g){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function C(s){return k?.trackDisposable(s),s}function y(s){k?.markAsDisposed(s)}function P(s,i){k?.setParent(s,i)}function n(s,i){if(!!k)for(const g of s)k.setParent(g,i)}function T(s){return k?.markAsSingleton(s),s}e.markAsSingleton=T;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=h;function o(s){if(L.Iterable.is(s)){let i=[];for(const g of s)if(g)try{g.dispose()}catch(u){i.push(u)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=o;function v(...s){const i=_(()=>o(s));return n(s,i),i}e.combinedDisposable=v;function _(s){const i=C({dispose:(0,f.once)(()=>{y(i),s()})});return i}e.toDisposable=_;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{o(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return P(i,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new A,C(this),P(this._store,this)}dispose(){y(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&P(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&P(i,null),i}}e.MutableDisposable=l;class a{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class p{constructor(){this.references=new Map}acquire(i,...g){let u=this.references.get(i);u||(u={counter:0,object:this.createReferencedObject(i,...g)},this.references.set(i,u));const{object:d}=u,w=(0,f.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(i,u.object),this.references.delete(i))});return u.counter++,{object:d,dispose:w}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...g){const u=this.referenceCollection.acquire(i,...g);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(k){this.element=k,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class L{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let k=this._first;for(;k!==f.Undefined;){const R=k.next;k.prev=f.Undefined,k.next=f.Undefined,k=R}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,R){const C=new f(k);if(this._first===f.Undefined)this._first=C,this._last=C;else if(R){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(C))}}shift(){if(this._first!==f.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==f.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==f.Undefined&&k.next!==f.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===f.Undefined&&k.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):k.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):k.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==f.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Re,De){for(var ke=0;ke<De.length;ke++){var ne=De[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Re,ne.key,ne)}}function e(Re,De,ke){return De&&J(Re.prototype,De),ke&&J(Re,ke),Re}function f(Re,De){if(!!Re){if(typeof Re=="string")return L(Re,De);var ke=Object.prototype.toString.call(Re).slice(8,-1);if(ke==="Object"&&Re.constructor&&(ke=Re.constructor.name),ke==="Map"||ke==="Set")return Array.from(Re);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Re,De)}}function L(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var ke=0,ne=new Array(De);ke<De;ke++)ne[ke]=Re[ke];return ne}function I(Re,De){var ke=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(ke)return(ke=ke.call(Re)).next.bind(ke);if(Array.isArray(Re)||(ke=f(Re))||De&&Re&&typeof Re.length=="number"){ke&&(Re=ke);var ne=0;return function(){return ne>=Re.length?{done:!0}:{done:!1,value:Re[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var k={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Re){k.exports.defaults=Re}k.exports={defaults:R(),getDefaults:R,changeDefaults:C};var y=/[&<>"']/,P=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(De){return c[De]};function o(Re,De){if(De){if(y.test(Re))return Re.replace(P,h)}else if(n.test(Re))return Re.replace(T,h);return Re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(v,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var A=/(^|[^\[])\^/g;function E(Re,De){Re=Re.source||Re,De=De||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(A,"$1"),Re=Re.replace(de,be),ke},getRegex:function(){return new RegExp(Re,De)}};return ke}var l=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Re,De,ke){if(Re){var ne;try{ne=decodeURIComponent(_(ke)).replace(l,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!a.test(ke)&&(ke=g(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(Re,De){t[" "+Re]||(r.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=D(Re,"/",!0)),Re=t[" "+Re];var ke=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Re.replace(s,"$1")+De:De.charAt(0)==="/"?ke?De:Re.replace(i,"$1")+De:Re+De}var u={exec:function(){}};function d(Re){for(var De=1,ke,ne;De<arguments.length;De++){ke=arguments[De];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Re[ne]=ke[ne])}return Re}function w(Re,De){var ke=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,$e=we;--$e>=0&&Fe[$e]==="\\";)qe=!qe;return qe?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function D(Re,De,ke){var ne=Re.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Re.charAt(ne-de-1);if(be===De&&!ke)de++;else if(be!==De&&ke)de++;else break}return Re.substr(0,ne-de)}function m(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var ke=Re.length,ne=0,de=0;de<ke;de++)if(Re[de]==="\\")de++;else if(Re[de]===De[0])ne++;else if(Re[de]===De[1]&&(ne--,ne<0))return de;return-1}function S(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(Re,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Re),De>>=1,Re+=Re;return ke+Re}var F={escape:o,unescape:_,edit:E,cleanUrl:p,resolveUrl:g,noopTest:u,merge:d,splitCells:w,rtrim:D,findClosingBracket:m,checkSanitizeDeprecation:S,repeatString:b},N=k.exports.defaults,G=F.rtrim,K=F.splitCells,M=F.escape,U=F.findClosingBracket;function O(Re,De,ke,ne){var de=De.href,be=De.title?M(De.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");return Re[0].charAt(0)!=="!"?(ne.state.inLink=!0,{type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])}):{type:"image",raw:ke,href:de,title:be,text:M(we)}}function $(Re,De){var ke=Re.match(/^(\s+)(?:```)/);if(ke===null)return De;var ne=ke[1];return De.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var B=function(){function Re(ke){this.options=ke||N}var De=Re.prototype;return De.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},De.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},De.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=$(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},De.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},De.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},De.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,qe,$e,Je,tt,le,Ee,ce,q=de[1].trim(),Ae=q.length>1,Pe={type:"list",raw:"",ordered:Ae,start:Ae?+q.slice(0,-1):"",loose:!1,items:[]};q=Ae?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Ae?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(qe=2,ce=Ee[0].trimLeft()):(qe=de[2].search(/[^ ]/),qe=de[1].length+(qe>4?1:qe),ce=Ee[0].slice(qe-de[1].length)),Je=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<Ee.length;$e++){if(le=Ee[$e],this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(le)){be=de[1]+Ee.slice(0,$e).join(`
`)+`
`;break}if(!Je){le.trim()||(Je=!0),le.search(/[^ ]/)>=qe?ce+=`
`+le.slice(qe):ce+=`
`+le;continue}if(le.search(/[^ ]/)>=qe||!le.trim()){ce+=`
`+le.slice(qe);continue}else{be=de[1]+Ee.slice(0,$e).join(`
`)+`
`;break}}Pe.loose||(tt?Pe.loose=!0:/\n *\n *$/.test(be)&&(tt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var ot=Pe.items.length;for($e=0;$e<ot;$e++)this.lexer.state.top=!1,Pe.items[$e].tokens=this.lexer.blockTokens(Pe.items[$e].text,[]),Pe.items[$e].tokens.some(function(vt){return vt.type==="space"})&&(Pe.loose=!0,Pe.items[$e].loose=!0);return Pe}},De.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},De.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},De.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(tt){return{text:tt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,qe,$e,Je;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(tt){return{text:tt}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Je=be.rows[qe],$e=0;$e<Je.length;$e++)Je[$e].tokens=[],this.lexer.inlineTokens(Je[$e].text,Je[$e].tokens);return be}}},De.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},De.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:M(de[1])}},De.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]):de[0]}},De.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=U(de[2],"()");if(Fe>-1){var qe=de[0].indexOf("!")===0?5:4,$e=qe+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,$e).trim(),de[3]=""}}var Je=de[2],tt="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Je);le&&(Je=le[1],tt=le[3])}else tt=de[3]?de[3].slice(1,-1):"";return Je=Je.trim(),/^</.test(Je)&&(this.options.pedantic&&!/>$/.test(be)?Je=Je.slice(1):Je=Je.slice(1,-1)),O(de,{href:Je&&Je.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},De.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(be,we,be[0],this.lexer)}},De.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,$e,Je,tt=qe,le=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+qe);(we=Ee.exec(de))!=null;)if($e=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!$e){if(Je=$e.length,we[3]||we[4]){tt+=Je;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Je)%3)){le+=Je;continue}if(tt-=Je,!(tt>0)){if(Je=Math.min(Je,Je+tt+le),Math.min(qe,Je)%2){var ce=ne.slice(1,qe+we.index+Je);return{type:"em",raw:ne.slice(0,qe+we.index+Je+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,qe+we.index+Je-1);return{type:"strong",raw:ne.slice(0,qe+we.index+Je+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},De.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=M(be,!0),{type:"codespan",raw:de[0],text:be}}},De.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},De.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},De.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=M(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=M(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=M(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=M(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):M(be[0]):be[0]:we=M(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),x=F.noopTest,j=F.edit,H=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=j(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=j(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=j(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=j(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=j(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=j(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=H({},Q),Q.gfm=H({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=j(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=H({},Q.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:j(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=j(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=j(Q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=j(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=j(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=j(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=j(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=j(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=j(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=j(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=j(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=H({},X),X.pedantic=H({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=H({},X.normal,{escape:j(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=j(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=H({},X.gfm,{br:j(X.br).replace("{2,}","*").getRegex(),text:j(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:Q,inline:X},_e=B,ye=k.exports.defaults,Le=fe.block,ze=fe.inline,xe=F.repeatString;function Ge(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Re){var De="",ke,ne,de=Re.length;for(ke=0;ke<de;ke++)ne=Re.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var ee=function(){function Re(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Le.normal,inline:ze.normal};this.options.pedantic?(ne.block=Le.pedantic,ne.inline=ze.pedantic):this.options.gfm&&(ne.block=Le.gfm,this.options.breaks?ne.inline=ze.breaks:ne.inline=ze.gfm),this.tokenizer.rules=ne}Re.lex=function(ne,de){var be=new Re(de);return be.lex(ne)},Re.lexInline=function(ne,de){var be=new Re(de);return be.inlineTokens(ne)};var De=Re.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},De.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,qe,$e;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(we=tt.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=Infinity,le=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},le),typeof Ee=="number"&&Ee>=0&&(tt=Math.min(tt,Ee))}),tt<Infinity&&tt>=0&&(qe=ne.substring(0,tt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=de[de.length-1],$e&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),$e=qe.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Je="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Je);break}else throw new Error(Je)}}return this.state.top=!0,de},De.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},De.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,qe,$e=ne,Je,tt,le;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Je=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)Ee.includes(Je[0].slice(Je[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Je=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Je.index)+"["+xe("a",Je[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Je=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Je.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(tt||(le=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,$e,le)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,z)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,z))){ne=ne.substring(we.raw.length),de.push(we);continue}if(qe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Ae=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Ae),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(qe=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(qe,Ge)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(le=we.raw.slice(-1)),tt=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:Le,inline:ze}}}]),Re}(),re=k.exports.defaults,ae=F.cleanUrl,Y=F.escape,oe=function(){function Re(ke){this.options=ke||re}var De=Re.prototype;return De.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Y(we,!0)+'">'+(be?ne:Y(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Y(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Y(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},De.image=function(ne,de,be){if(ne=ae(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},De.text=function(ne){return ne},Re}(),ve=function(){function Re(){}var De=Re.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,de,be){return""+be},De.image=function(ne,de,be){return""+be},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},De.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Re}(),je=oe,Ke=ve,Se=Me,nt=k.exports.defaults,Z=F.unescape,te=function(){function Re(ke){this.options=ke||nt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Se}Re.parse=function(ne,de){var be=new Re(de);return be.parse(ne)},Re.parseInline=function(ne,de){var be=new Re(de);return be.parseInline(ne)};var De=Re.prototype;return De.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,qe,$e,Je,tt,le,Ee,ce,q,Ae,Pe,Ze,Xe,ot,vt,Et,lt,dt,mt=ne.length;for(we=0;we<mt;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(dt=this.options.extensions.renderers[q.type].call({parser:this},q),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=dt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,Z(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",le="",$e=q.header.length,Fe=0;Fe<$e;Fe++)le+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(le),ce="",$e=q.rows.length,Fe=0;Fe<$e;Fe++){for(tt=q.rows[Fe],le="",Je=tt.length,qe=0;qe<Je;qe++)le+=this.renderer.tablecell(this.parseInline(tt[qe].tokens),{header:!1,align:q.align[qe]});ce+=this.renderer.tablerow(le)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Ae=q.ordered,Pe=q.start,Ze=q.loose,$e=q.items.length,ce="",Fe=0;Fe<$e;Fe++)ot=q.items[Fe],vt=ot.checked,Et=ot.task,Xe="",ot.task&&(lt=this.renderer.checkbox(vt),Ze?ot.tokens.length>0&&ot.tokens[0].type==="paragraph"?(ot.tokens[0].text=lt+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=lt+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:lt}):Xe+=lt),Xe+=this.parse(ot.tokens,Ze),ce+=this.renderer.listitem(Xe,Et,vt);be+=this.renderer.list(ce,Ae,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<mt&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Lt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Lt);return}else throw new Error(Lt)}}}return be},De.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,qe,$e=ne.length;for(we=0;we<$e;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Je='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return be},Re}(),pe=ee,Ue=te,Ye=B,it=oe,ft=ve,pt=Me,St=F.merge,Ct=F.checkSanitizeDeprecation,ue=F.escape,Ie=k.exports.getDefaults,Ne=k.exports.changeDefaults,Qe=k.exports.defaults;function We(Re,De,ke){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=St({},We.defaults,De||{}),Ct(De),ke){var ne=De.highlight,de;try{de=pe.lex(Re,De)}catch(qe){return ke(qe)}var be=function($e){var Je;if(!$e)try{De.walkTokens&&We.walkTokens(de,De.walkTokens),Je=Ue.parse(de,De)}catch(tt){$e=tt}return De.highlight=ne,$e?ke($e):ke(null,Je)};if(!ne||ne.length<3||(delete De.highlight,!de.length))return be();var we=0;We.walkTokens(de,function(qe){qe.type==="code"&&(we++,setTimeout(function(){ne(qe.text,qe.lang,function($e,Je){if($e)return be($e);Je!=null&&Je!==qe.text&&(qe.text=Je,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=pe.lex(Re,De);return De.walkTokens&&We.walkTokens(Fe,De.walkTokens),Ue.parse(Fe,De)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(qe.message+"",!0)+"</pre>";throw qe}}We.options=We.setOptions=function(Re){return St(We.defaults,Re),Ne(We.defaults),We},We.getDefaults=Ie,We.defaults=Qe,We.use=function(){for(var Re=this,De=arguments.length,ke=new Array(De),ne=0;ne<De;ne++)ke[ne]=arguments[ne];var de=St.apply(void 0,[{}].concat(ke)),be=We.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Je=be.renderers?be.renderers[$e.name]:null;Je?be.renderers[$e.name]=function(){for(var tt=arguments.length,le=new Array(tt),Ee=0;Ee<tt;Ee++)le[Ee]=arguments[Ee];var ce=$e.renderer.apply(this,le);return ce===!1&&(ce=Je.apply(this,le)),ce}:be.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[$e.level]?be[$e.level].unshift($e.tokenizer):be[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?be.startBlock?be.startBlock.push($e.start):be.startBlock=[$e.start]:$e.level==="inline"&&(be.startInline?be.startInline.push($e.start):be.startInline=[$e.start]))}$e.childTokens&&(be.childTokens[$e.name]=$e.childTokens)})),Fe.renderer&&function(){var $e=We.defaults.renderer||new it,Je=function(Ee){var ce=$e[Ee];$e[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply($e,Ae);return Ze===!1&&(Ze=ce.apply($e,Ae)),Ze}};for(var tt in Fe.renderer)Je(tt);de.renderer=$e}(),Fe.tokenizer&&function(){var $e=We.defaults.tokenizer||new Ye,Je=function(Ee){var ce=$e[Ee];$e[Ee]=function(){for(var q=arguments.length,Ae=new Array(q),Pe=0;Pe<q;Pe++)Ae[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply($e,Ae);return Ze===!1&&(Ze=ce.apply($e,Ae)),Ze}};for(var tt in Fe.tokenizer)Je(tt);de.tokenizer=$e}(),Fe.walkTokens){var qe=We.defaults.walkTokens;de.walkTokens=function($e){Fe.walkTokens.call(Re,$e),qe&&qe($e)}}we&&(de.extensions=be),We.setOptions(de)})},We.walkTokens=function(Re,De){for(var ke=function(){var we=de.value;switch(De(we),we.type){case"table":{for(var Fe=I(we.header),qe;!(qe=Fe()).done;){var $e=qe.value;We.walkTokens($e.tokens,De)}for(var Je=I(we.rows),tt;!(tt=Je()).done;)for(var le=tt.value,Ee=I(le),ce;!(ce=Ee()).done;){var q=ce.value;We.walkTokens(q.tokens,De)}break}case"list":{We.walkTokens(we.items,De);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[we.type]?We.defaults.extensions.childTokens[we.type].forEach(function(Ae){We.walkTokens(we[Ae],De)}):we.tokens&&We.walkTokens(we.tokens,De)}},ne=I(Re),de;!(de=ne()).done;)ke()},We.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=St({},We.defaults,De||{}),Ct(De);try{var ke=pe.lexInline(Re,De);return De.walkTokens&&We.walkTokens(ke,De.walkTokens),Ue.parseInline(ke,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},We.Parser=Ue,We.parser=Ue.parse,We.Renderer=it,We.TextRenderer=ft,We.Lexer=pe,We.lexer=pe.lex,We.Tokenizer=Ye,We.Slugger=pt,We.parse=We;var at=We;return at}),define(me[78],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(R,C,y){return Math.min(Math.max(R,C),y)}e.clamp=f;function L(R,C){return(C+R%C)%C}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class k{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=k}),function(){function J(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function R(y){k.push(y,Date.now())}function C(){const y=[];for(let P=0;P<k.length;P+=2)y.push({name:k[P],startTime:k[P+1]});return y}return{mark:R,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(I+R.startTime)});return k}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=f(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let L=!1,I=!1,k=!1,R=!1,C=!1,y=!1,P=!1,n,T=f,c,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const v=typeof o?.versions?.electron=="string"&&o.type==="renderer";if(e.isElectronSandboxed=v&&o?.sandboxed,typeof navigator=="object"&&!v)h=navigator.userAgent,L=h.indexOf("Windows")>=0,I=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=h.indexOf("Linux")>=0,y=!0,n=navigator.language,T=n;else if(typeof o=="object"){L=o.platform==="win32",I=o.platform==="darwin",k=o.platform==="linux",R=k&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,n=f,T=f;const s=o.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),g=i.availableLanguages["*"];n=i.locale,T=g||f,c=i._translationsConfigFile}catch(i){}C=!0}else console.error("Unable to resolve platform.");var _;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function A(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let E=0;I?E=1:L?E=3:k&&(E=2),e.isWindows=L,e.isMacintosh=I,e.isLinux=k,e.isLinuxSnap=R,e.isNative=C,e.isWeb=y,e.isIOS=P,e.platform=E,e.userAgent=h,e.language=T;var l;(function(s){function i(){return e.language}s.value=i;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=g;function u(){return e.language==="en"}s.isDefault=u})(l=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,D=g.length;w<D;w++){const m=g[w];if(m.id===d.data.vscodeSetImmediateId){g.splice(w,1),m.callback();return}}});let u=0;return d=>{const w=++u;g.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof o?.nextTick=="function")return o.nextTick.bind(o);const i=Promise.resolve();return g=>i.then(g)}();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||P?2:L?1:3;let p=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,p=new Uint16Array(s.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=r}),define(me[32],ge([0,1,11]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;L={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()},nextTick(k){return(0,f.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},nextTick(I){return(0,f.setImmediate)(I)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,32]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,k=90,R=122,C=46,y=47,P=92,n=58,T=63;class c extends Error{constructor(a,p,t){let r;typeof p=="string"&&p.indexOf("not ")===0?(r="must not be",p=p.replace(/^not /,"")):r="must be";const s=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${s} ${r} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(l,a){if(typeof l!="string")throw new c(a,"string",l)}function o(l){return l===y||l===P}function v(l){return l===y}function _(l){return l>=L&&l<=k||l>=I&&l<=R}function A(l,a,p,t){let r="",s=0,i=-1,g=0,u=0;for(let d=0;d<=l.length;++d){if(d<l.length)u=l.charCodeAt(d);else{if(t(u))break;u=y}if(t(u)){if(!(i===d-1||g===1))if(g===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const w=r.lastIndexOf(p);w===-1?(r="",s=0):(r=r.slice(0,w),s=r.length-1-r.lastIndexOf(p)),i=d,g=0;continue}else if(r.length!==0){r="",s=0,i=d,g=0;continue}}a&&(r+=r.length>0?`${p}..`:"..",s=2)}else r.length>0?r+=`${p}${l.slice(i+1,d)}`:r=l.slice(i+1,d),s=d-i-1;i=d,g=0}else u===C&&g!==-1?++g:g=-1}return r}function E(l,a){if(a===null||typeof a!="object")throw new c("pathObject","Object",a);const p=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return p?p===a.root?`${p}${t}`:`${p}${l}${t}`:t}e.win32={resolve(...l){let a="",p="",t=!1;for(let r=l.length-1;r>=-1;r--){let s;if(r>=0){if(s=l[r],h(s,"path"),s.length===0)continue}else a.length===0?s=f.cwd():(s=f.env[`=${a}`]||f.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${a}\\`));const i=s.length;let g=0,u="",d=!1;const w=s.charCodeAt(0);if(i===1)o(w)&&(g=1,d=!0);else if(o(w))if(d=!0,o(s.charCodeAt(1))){let D=2,m=D;for(;D<i&&!o(s.charCodeAt(D));)D++;if(D<i&&D!==m){const S=s.slice(m,D);for(m=D;D<i&&o(s.charCodeAt(D));)D++;if(D<i&&D!==m){for(m=D;D<i&&!o(s.charCodeAt(D));)D++;(D===i||D!==m)&&(u=`\\\\${S}\\${s.slice(m,D)}`,g=D)}}}else g=1;else _(w)&&s.charCodeAt(1)===n&&(u=s.slice(0,2),g=2,i>2&&o(s.charCodeAt(2))&&(d=!0,g=3));if(u.length>0)if(a.length>0){if(u.toLowerCase()!==a.toLowerCase())continue}else a=u;if(t){if(a.length>0)break}else if(p=`${s.slice(g)}\\${p}`,t=d,d&&a.length>0)break}return p=A(p,!t,"\\",o),t?`${a}\\${p}`:`${a}${p}`||"."},normalize(l){h(l,"path");const a=l.length;if(a===0)return".";let p=0,t,r=!1;const s=l.charCodeAt(0);if(a===1)return v(s)?"\\":l;if(o(s))if(r=!0,o(l.charCodeAt(1))){let g=2,u=g;for(;g<a&&!o(l.charCodeAt(g));)g++;if(g<a&&g!==u){const d=l.slice(u,g);for(u=g;g<a&&o(l.charCodeAt(g));)g++;if(g<a&&g!==u){for(u=g;g<a&&!o(l.charCodeAt(g));)g++;if(g===a)return`\\\\${d}\\${l.slice(u)}\\`;g!==u&&(t=`\\\\${d}\\${l.slice(u,g)}`,p=g)}}}else p=1;else _(s)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),p=2,a>2&&o(l.charCodeAt(2))&&(r=!0,p=3));let i=p<a?A(l.slice(p),!r,"\\",o):"";return i.length===0&&!r&&(i="."),i.length>0&&o(l.charCodeAt(a-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(l){h(l,"path");const a=l.length;if(a===0)return!1;const p=l.charCodeAt(0);return o(p)||a>2&&_(p)&&l.charCodeAt(1)===n&&o(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let a,p;for(let s=0;s<l.length;++s){const i=l[s];h(i,"path"),i.length>0&&(a===void 0?a=p=i:a+=`\\${i}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof p=="string"&&o(p.charCodeAt(0))){++r;const s=p.length;s>1&&o(p.charCodeAt(1))&&(++r,s>2&&(o(p.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&o(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(l,a){if(h(l,"from"),h(a,"to"),l===a)return"";const p=e.win32.resolve(l),t=e.win32.resolve(a);if(p===t||(l=p.toLowerCase(),a=t.toLowerCase(),l===a))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===P;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===P;)s--;const i=s-r;let g=0;for(;g<a.length&&a.charCodeAt(g)===P;)g++;let u=a.length;for(;u-1>g&&a.charCodeAt(u-1)===P;)u--;const d=u-g,w=i<d?i:d;let D=-1,m=0;for(;m<w;m++){const b=l.charCodeAt(r+m);if(b!==a.charCodeAt(g+m))break;b===P&&(D=m)}if(m!==w){if(D===-1)return t}else{if(d>w){if(a.charCodeAt(g+m)===P)return t.slice(g+m+1);if(m===2)return t.slice(g+m)}i>w&&(l.charCodeAt(r+m)===P?D=m:m===2&&(D=3)),D===-1&&(D=0)}let S="";for(m=r+D+1;m<=s;++m)(m===s||l.charCodeAt(m)===P)&&(S+=S.length===0?"..":"\\..");return g+=D,S.length>0?`${S}${t.slice(g,u)}`:(t.charCodeAt(g)===P&&++g,t.slice(g,u))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const a=e.win32.resolve(l);if(a.length<=2)return l;if(a.charCodeAt(0)===P){if(a.charCodeAt(1)===P){const p=a.charCodeAt(2);if(p!==T&&p!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===P)return`\\\\?\\${a}`;return l},dirname(l){h(l,"path");const a=l.length;if(a===0)return".";let p=-1,t=0;const r=l.charCodeAt(0);if(a===1)return o(r)?l:".";if(o(r)){if(p=t=1,o(l.charCodeAt(1))){let g=2,u=g;for(;g<a&&!o(l.charCodeAt(g));)g++;if(g<a&&g!==u){for(u=g;g<a&&o(l.charCodeAt(g));)g++;if(g<a&&g!==u){for(u=g;g<a&&!o(l.charCodeAt(g));)g++;if(g===a)return l;g!==u&&(p=t=g+1)}}}}else _(r)&&l.charCodeAt(1)===n&&(p=a>2&&o(l.charCodeAt(2))?3:2,t=p);let s=-1,i=!0;for(let g=a-1;g>=t;--g)if(o(l.charCodeAt(g))){if(!i){s=g;break}}else i=!1;if(s===-1){if(p===-1)return".";s=p}return l.slice(0,s)},basename(l,a){a!==void 0&&h(a,"ext"),h(l,"path");let p=0,t=-1,r=!0,s;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(p=2),a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let i=a.length-1,g=-1;for(s=l.length-1;s>=p;--s){const u=l.charCodeAt(s);if(o(u)){if(!r){p=s+1;break}}else g===-1&&(r=!1,g=s+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=g))}return p===t?t=g:t===-1&&(t=l.length),l.slice(p,t)}for(s=l.length-1;s>=p;--s)if(o(l.charCodeAt(s))){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(p,t)},extname(l){h(l,"path");let a=0,p=-1,t=0,r=-1,s=!0,i=0;l.length>=2&&l.charCodeAt(1)===n&&_(l.charCodeAt(0))&&(a=t=2);for(let g=l.length-1;g>=a;--g){const u=l.charCodeAt(g);if(o(u)){if(!s){t=g+1;break}continue}r===-1&&(s=!1,r=g+1),u===C?p===-1?p=g:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===t+1?"":l.slice(p,r)},format:E.bind(null,"\\"),parse(l){h(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const p=l.length;let t=0,r=l.charCodeAt(0);if(p===1)return o(r)?(a.root=a.dir=l,a):(a.base=a.name=l,a);if(o(r)){if(t=1,o(l.charCodeAt(1))){let D=2,m=D;for(;D<p&&!o(l.charCodeAt(D));)D++;if(D<p&&D!==m){for(m=D;D<p&&o(l.charCodeAt(D));)D++;if(D<p&&D!==m){for(m=D;D<p&&!o(l.charCodeAt(D));)D++;D===p?t=D:D!==m&&(t=D+1)}}}}else if(_(r)&&l.charCodeAt(1)===n){if(p<=2)return a.root=a.dir=l,a;if(t=2,o(l.charCodeAt(2))){if(p===3)return a.root=a.dir=l,a;t=3}}t>0&&(a.root=l.slice(0,t));let s=-1,i=t,g=-1,u=!0,d=l.length-1,w=0;for(;d>=t;--d){if(r=l.charCodeAt(d),o(r)){if(!u){i=d+1;break}continue}g===-1&&(u=!1,g=d+1),r===C?s===-1?s=d:w!==1&&(w=1):s!==-1&&(w=-1)}return g!==-1&&(s===-1||w===0||w===1&&s===g-1&&s===i+1?a.base=a.name=l.slice(i,g):(a.name=l.slice(i,s),a.base=l.slice(i,g),a.ext=l.slice(s,g))),i>0&&i!==t?a.dir=l.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let a="",p=!1;for(let t=l.length-1;t>=-1&&!p;t--){const r=t>=0?l[t]:f.cwd();h(r,"path"),r.length!==0&&(a=`${r}/${a}`,p=r.charCodeAt(0)===y)}return a=A(a,!p,"/",v),p?`/${a}`:a.length>0?a:"."},normalize(l){if(h(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===y,p=l.charCodeAt(l.length-1)===y;return l=A(l,!a,"/",v),l.length===0?a?"/":p?"./":".":(p&&(l+="/"),a?`/${l}`:l)},isAbsolute(l){return h(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let a;for(let p=0;p<l.length;++p){const t=l[p];h(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(l,a){if(h(l,"from"),h(a,"to"),l===a||(l=e.posix.resolve(l),a=e.posix.resolve(a),l===a))return"";const p=1,t=l.length,r=t-p,s=1,i=a.length-s,g=r<i?r:i;let u=-1,d=0;for(;d<g;d++){const D=l.charCodeAt(p+d);if(D!==a.charCodeAt(s+d))break;D===y&&(u=d)}if(d===g)if(i>g){if(a.charCodeAt(s+d)===y)return a.slice(s+d+1);if(d===0)return a.slice(s+d)}else r>g&&(l.charCodeAt(p+d)===y?u=d:d===0&&(u=0));let w="";for(d=p+u+1;d<=t;++d)(d===t||l.charCodeAt(d)===y)&&(w+=w.length===0?"..":"/..");return`${w}${a.slice(s+u)}`},toNamespacedPath(l){return l},dirname(l){if(h(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===y;let p=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===y){if(!t){p=r;break}}else t=!1;return p===-1?a?"/":".":a&&p===1?"//":l.slice(0,p)},basename(l,a){a!==void 0&&h(a,"ext"),h(l,"path");let p=0,t=-1,r=!0,s;if(a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let i=a.length-1,g=-1;for(s=l.length-1;s>=0;--s){const u=l.charCodeAt(s);if(u===y){if(!r){p=s+1;break}}else g===-1&&(r=!1,g=s+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=g))}return p===t?t=g:t===-1&&(t=l.length),l.slice(p,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===y){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(p,t)},extname(l){h(l,"path");let a=-1,p=0,t=-1,r=!0,s=0;for(let i=l.length-1;i>=0;--i){const g=l.charCodeAt(i);if(g===y){if(!r){p=i+1;break}continue}t===-1&&(r=!1,t=i+1),g===C?a===-1?a=i:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===p+1?"":l.slice(a,t)},format:E.bind(null,"/"),parse(l){h(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const p=l.charCodeAt(0)===y;let t;p?(a.root="/",t=1):t=0;let r=-1,s=0,i=-1,g=!0,u=l.length-1,d=0;for(;u>=t;--u){const w=l.charCodeAt(u);if(w===y){if(!g){s=u+1;break}continue}i===-1&&(g=!1,i=u+1),w===C?r===-1?r=u:d!==1&&(d=1):r!==-1&&(d=-1)}if(i!==-1){const w=s===0&&p?1:s;r===-1||d===0||d===1&&r===i-1&&r===s+1?a.base=a.name=l.slice(w,i):(a.name=l.slice(w,r),a.base=l.slice(w,i),a.ext=l.slice(r,i))}return s>0?a.dir=l.slice(0,s-1):p&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(k,...R){const C=R.reduce((n,T)=>(n[T]=!0,n),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(n=>!C[n]).forEach(n=>{for(let T=0;T<y.length;T++)if(n.search(y[T])!==-1){delete k[n];break}})}e.sanitizeProcessEnvironment=I}),define(me[46],ge([0,1,11]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new I(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,16,75,6,95,46]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(l){l.None=()=>I.Disposable.None;function a(K){return(M,U=null,O)=>{let $=!1,B;return B=K(x=>{if(!$)return B?B.dispose():$=!0,M.call(U,x)},null,O),$&&B.dispose(),B}}l.once=a;function p(K,M){return u((U,O=null,$)=>K(B=>U.call(O,M(B)),null,$))}l.map=p;function t(K,M){return u((U,O=null,$)=>K(B=>{M(B),U.call(O,B)},null,$))}l.forEach=t;function r(K,M){return u((U,O=null,$)=>K(B=>M(B)&&U.call(O,B),null,$))}l.filter=r;function s(K){return K}l.signal=s;function i(...K){return(M,U=null,O)=>(0,I.combinedDisposable)(...K.map($=>$(B=>M.call(U,B),null,O)))}l.any=i;function g(K,M,U){let O=U;return p(K,$=>(O=M(O,$),O))}l.reduce=g;function u(K){let M;const U=new c({onFirstListenerAdd(){M=K(U.fire,U)},onLastListenerRemove(){M.dispose()}});return U.event}function d(K,M,U=100,O=!1,$){let B,x,j,H=0;const Q=new c({leakWarningThreshold:$,onFirstListenerAdd(){B=K(X=>{H++,x=M(x,X),O&&!j&&(Q.fire(x),x=void 0),clearTimeout(j),j=setTimeout(()=>{const fe=x;x=void 0,j=void 0,(!O||H>1)&&Q.fire(fe),H=0},U)})},onLastListenerRemove(){B.dispose()}});return Q.event}l.debounce=d;function w(K,M=(U,O)=>U===O){let U=!0,O;return r(K,$=>{const B=U||!M($,O);return U=!1,O=$,B})}l.latch=w;function D(K,M){return[l.filter(K,M),l.filter(K,U=>!M(U))]}l.split=D;function m(K,M=!1,U=[]){let O=U.slice(),$=K(j=>{O?O.push(j):x.fire(j)});const B=()=>{O&&O.forEach(j=>x.fire(j)),O=null},x=new c({onFirstListenerAdd(){$||($=K(j=>x.fire(j)))},onFirstListenerDidAdd(){O&&(M?setTimeout(B):B())},onLastListenerRemove(){$&&$.dispose(),$=null}});return x.event}l.buffer=m;class S{constructor(M){this.event=M}map(M){return new S(p(this.event,M))}forEach(M){return new S(t(this.event,M))}filter(M){return new S(r(this.event,M))}reduce(M,U){return new S(g(this.event,M,U))}latch(){return new S(w(this.event))}debounce(M,U=100,O=!1,$){return new S(d(this.event,M,U,O,$))}on(M,U,O){return this.event(M,U,O)}once(M,U,O){return a(this.event)(M,U,O)}}function b(K){return new S(K)}l.chain=b;function F(K,M,U=O=>O){const O=(...j)=>x.fire(U(...j)),$=()=>K.on(M,O),B=()=>K.removeListener(M,O),x=new c({onFirstListenerAdd:$,onLastListenerRemove:B});return x.event}l.fromNodeEventEmitter=F;function N(K,M,U=O=>O){const O=(...j)=>x.fire(U(...j)),$=()=>K.addEventListener(M,O),B=()=>K.removeEventListener(M,O),x=new c({onFirstListenerAdd:$,onLastListenerRemove:B});return x.event}l.fromDOMEventEmitter=N;function G(K){return new Promise(M=>a(K)(M))}l.toPromise=G})(C=e.Event||(e.Event={}));class y{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${y._idPool++}`}start(a){this._stopWatch=new R.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let P=-1;function n(l){const a=P;return P=l,{dispose(){P=a}}}e.setGlobalLeakWarningThreshold=n;class T{constructor(a,p=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let p=P;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||a<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let s,i=0;for(const[g,u]of this._stacks)(!s||i<u)&&(s=g,i=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class c{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=P>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(a,p,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(p?[a,p]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,p);const i=this._leakageMon?.check(this._listeners.size),g=(0,I.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(g):Array.isArray(t)&&t.push(g),g}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class h extends c{async fireAsync(a,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],g={...s,waitUntil:u=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(u=t(u,typeof r=="function"?r:r[0])),i.push(u)}};try{typeof r=="function"?r.call(void 0,g):r[0].call(r[1],g)}catch(u){(0,f.onUnexpectedError)(u);continue}Object.freeze(i),await Promise.allSettled(i).then(u=>{for(const d of u)d.status==="rejected"&&(0,f.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=h;class o extends c{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=o;class v extends o{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const p={event:a,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const r=this.events.indexOf(p);this.events.splice(r,1)};return(0,I.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(p=>this.emitter.fire(p))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class A{constructor(){this.buffers=[]}wrapEvent(a){return(p,t,r)=>a(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,s)):p.call(t,s)},void 0,r)}bufferEvents(a){const p=[];this.buffers.push(p);const t=a();return this.buffers.pop(),p.forEach(r=>r()),t}}e.EventBufferer=A;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,y){const P=setTimeout(C.bind(y),0);return{dispose(){clearTimeout(P)}}});var I;(function(C){function y(P){return P===C.None||P===C.Cancelled||P instanceof k?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=y,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=I.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new f.Emitter}add(T){const c=this._icons.get(T.id);c?T.description?c.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function k(n,T){return new C(n,T)}e.registerCodicon=k;function R(n){return n?n.replace(/\$\((.*?)\)/g,(T,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=R;class C{constructor(T,c,h){this.id=T,this.definition=c,this.description=h,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function y(n,T){const c=["codicon","codicon-"+n];return T&&c.push("codicon-modifier-"+T),c}e.getClassNamesArray=y;var P;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(v){if(v instanceof C)return["codicon","codicon-"+v.id];const _=T.exec(v.id);if(!_)return c(C.error);let[,A,E]=_;const l=["codicon","codicon-"+A];return E&&l.push("codicon-modifier-"+E.substr(1)),l}n.asClassNameArray=c;function h(v){return c(v).join(" ")}n.asClassName=h;function o(v){return"."+c(v).join(".")}n.asCSSSelector=o})(P=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(l){const a=l;return a?[a.on,a.pause,a.resume,a.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=I;function k(l){const a=l;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function R(l,a){return new C(l,a)}e.newWriteableStream=R;class C{constructor(a,p){this.reducer=a,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(p=>p(a))}emitError(a){this.listeners.error.length===0?(0,f.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(p=>p(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,p){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(a,p){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(p);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(l,a){const p=[];let t;for(;(t=l.read())!==null;)p.push(t);return a(p)}e.consumeReadable=y;function P(l,a,p){const t=[];let r;for(;(r=l.read())!==null&&t.length<p;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=P;function n(l,a){return new Promise((p,t)=>{const r=[];T(l,{onData:s=>{a&&r.push(s)},onError:s=>{a?t(s):p(void 0)},onEnd:()=>{p(a?a(r):void 0)}})})}e.consumeStream=n;function T(l,a){l.on("error",p=>a.onError(p)),l.on("end",()=>a.onEnd()),l.on("data",p=>a.onData(p))}e.listenStream=T;function c(l,a){return new Promise((p,t)=>{const r=new L.DisposableStore,s=[],i=d=>{if(s.push(d),s.length>a)return r.dispose(),l.pause(),p({stream:l,buffer:s,ended:!1})},g=d=>t(d),u=()=>p({stream:l,buffer:s,ended:!0});r.add((0,L.toDisposable)(()=>l.removeListener("error",g))),l.on("error",g),r.add((0,L.toDisposable)(()=>l.removeListener("end",u))),l.on("end",u),r.add((0,L.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=c;function h(l,a){const p=R(a);return p.end(l),p}e.toStream=h;function o(){const l=R(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=o;function v(l){let a=!1;return{read:()=>a?null:(a=!0,l)}}e.toReadable=v;function _(l,a,p){const t=R(p);return T(l,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function A(l,a,p){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?p([l,r]):l)}}}e.prefixedReadable=A;function E(l,a,p){let t=!1;const r=R(p);return T(a,{onData:s=>t?r.write(s):(t=!0,r.write(p([l,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(l)),r.end()}}),r}e.prefixedStream=E}),define(me[23],ge([0,1,96]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let I,k;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,g){return!(g?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(I||(I=new TextEncoder),new R(I.encode(i)))}static concat(i,g){if(typeof g=="undefined"){g=0;for(let w=0,D=i.length;w<D;w++)g+=i[w].byteLength}const u=R.alloc(g);let d=0;for(let w=0,D=i.length;w<D;w++){const m=i[w];u.set(m,d),d+=m.byteLength}return u}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,g){return new R(this.buffer.subarray(i,g))}set(i,g){i instanceof R?this.buffer.set(i.buffer,g):this.buffer.set(i,g)}readUInt32BE(i){return P(this.buffer,i)}writeUInt32BE(i,g){n(this.buffer,i,g)}readUInt32LE(i){return T(this.buffer,i)}writeUInt32LE(i,g){c(this.buffer,i,g)}readUInt8(i){return h(this.buffer,i)}writeUInt8(i,g){o(this.buffer,i,g)}}e.VSBuffer=R;function C(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=C;function y(s,i,g){s[g+0]=i&255,i=i>>>8,s[g+1]=i&255}e.writeUInt16LE=y;function P(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=P;function n(s,i,g){s[g+3]=i,i=i>>>8,s[g+2]=i,i=i>>>8,s[g+1]=i,i=i>>>8,s[g]=i}e.writeUInt32BE=n;function T(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=T;function c(s,i,g){s[g+0]=i&255,i=i>>>8,s[g+1]=i&255,i=i>>>8,s[g+2]=i&255,i=i>>>8,s[g+3]=i&255}e.writeUInt32LE=c;function h(s,i){return s[i]}e.readUInt8=h;function o(s,i,g){s[g]=i}e.writeUInt8=o;function v(s){return f.consumeReadable(s,i=>R.concat(i))}e.readableToBuffer=v;function _(s){return f.toReadable(s)}e.bufferToReadable=_;function A(s){return f.consumeStream(s,i=>R.concat(i))}e.streamToBuffer=A;async function E(s){return s.ended?R.concat(s.buffer):R.concat([...s.buffer,await A(s.stream)])}e.bufferedStreamToBuffer=E;function l(s){return f.toStream(s,i=>R.concat(i))}e.bufferToStream=l;function a(s){return f.transform(s,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=a;function p(s){return f.newWriteableStream(i=>R.concat(i),s)}e.newWriteableBufferStream=p;function t(s,i){return f.prefixedReadable(s,i,g=>R.concat(g))}e.prefixedBufferReadable=t;function r(s,i){return f.prefixedStream(s,i,g=>R.concat(g))}e.prefixedBufferStream=r}),define(me[9],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function f(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=f;const L=/{(\d+)}/g;function I(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Ne,Qe){const We=parseInt(Qe,10);return isNaN(We)||We<0||We>=Ie.length?Ne:Ie[We]})}e.format=I;const k=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(k,(Ne,Qe)=>Ie[Qe]??Ne)}e.format2=R;function C(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=C;function y(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function P(ue,Ie){let Ne=0;const Qe=Ie.charCodeAt(0);for(let We=ue.length-1;We>=0;We--)ue.charCodeAt(We)===Qe&&Ne++;return Ne}e.count=P;function n(ue,Ie,Ne="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ne}`}e.truncate=n;function T(ue,Ie=" "){const Ne=c(ue,Ie);return h(Ne,Ie)}e.trim=T;function c(ue,Ie){if(!ue||!Ie)return ue;const Ne=Ie.length;if(Ne===0||ue.length===0)return ue;let Qe=0;for(;ue.indexOf(Ie,Qe)===Qe;)Qe=Qe+Ne;return ue.substring(Qe)}e.ltrim=c;function h(ue,Ie){if(!ue||!Ie)return ue;const Ne=Ie.length,Qe=ue.length;if(Ne===0||Qe===0)return ue;let We=Qe,at=-1;for(;at=ue.lastIndexOf(Ie,We-1),!(at===-1||at+Ne!==We);){if(at===0)return"";We=at}return ue.substring(0,We)}e.rtrim=h;function o(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function _(ue,Ie,Ne={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=y(ue)),Ne.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Qe="";return Ne.global&&(Qe+="g"),Ne.matchCase||(Qe+="i"),Ne.multiline&&(Qe+="m"),Ne.unicode&&(Qe+="u"),new RegExp(ue,Qe)}e.createRegExp=_;function A(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=A;function E(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function l(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=l;function a(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=a;function p(ue){for(let Ie=0,Ne=ue.length;Ie<Ne;Ie++){const Qe=ue.charCodeAt(Ie);if(Qe!==32&&Qe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function t(ue,Ie=0,Ne=ue.length){for(let Qe=Ie;Qe<Ne;Qe++){const We=ue.charCodeAt(Qe);if(We!==32&&We!==9)return ue.substring(Ie,Qe)}return ue.substring(Ie,Ne)}e.getLeadingWhitespace=t;function r(ue,Ie=ue.length-1){for(let Ne=Ie;Ne>=0;Ne--){const Qe=ue.charCodeAt(Ne);if(Qe!==32&&Qe!==9)return Ne}return-1}e.lastNonWhitespaceIndex=r;function s(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=s;function i(ue,Ie,Ne=0,Qe=ue.length,We=0,at=Ie.length){for(;Ne<Qe&&We<at;Ne++,We++){let ke=ue.charCodeAt(Ne),ne=Ie.charCodeAt(We);if(ke<ne)return-1;if(ke>ne)return 1}const Re=Qe-Ne,De=at-We;return Re<De?-1:Re>De?1:0}e.compareSubstring=i;function g(ue,Ie){return u(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=g;function u(ue,Ie,Ne=0,Qe=ue.length,We=0,at=Ie.length){for(;Ne<Qe&&We<at;Ne++,We++){let ke=ue.charCodeAt(Ne),ne=Ie.charCodeAt(We);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&w(ne))&&!(de===-32&&w(ke)))return d(ke)&&d(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Ne,Qe,We,at)}const Re=Qe-Ne,De=at-We;return Re<De?-1:Re>De?1:0}e.compareSubstringIgnoreCase=u;function d(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=d;function w(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=w;function D(ue){return d(ue)||w(ue)}function m(ue,Ie){return ue.length===Ie.length&&S(ue,Ie)}e.equalsIgnoreCase=m;function S(ue,Ie,Ne=ue.length){for(let Qe=0;Qe<Ne;Qe++){const We=ue.charCodeAt(Qe),at=Ie.charCodeAt(Qe);if(We!==at){if(D(We)&&D(at)){const Re=Math.abs(We-at);if(Re!==0&&Re!==32)return!1}else if(String.fromCharCode(We).toLowerCase()!==String.fromCharCode(at).toLowerCase())return!1}}return!0}function b(ue,Ie){const Ne=Ie.length;return Ie.length>ue.length?!1:S(ue,Ie,Ne)}e.startsWithIgnoreCase=b;function F(ue,Ie){let Ne,Qe=Math.min(ue.length,Ie.length);for(Ne=0;Ne<Qe;Ne++)if(ue.charCodeAt(Ne)!==Ie.charCodeAt(Ne))return Ne;return Qe}e.commonPrefixLength=F;function N(ue,Ie){let Ne,Qe=Math.min(ue.length,Ie.length);const We=ue.length-1,at=Ie.length-1;for(Ne=0;Ne<Qe;Ne++)if(ue.charCodeAt(We-Ne)!==Ie.charCodeAt(at-Ne))return Ne;return Qe}e.commonSuffixLength=N;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function M(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=M;function U(ue,Ie,Ne){const Qe=ue.charCodeAt(Ne);if(G(Qe)&&Ne+1<Ie){const We=ue.charCodeAt(Ne+1);if(K(We))return M(Qe,We)}return Qe}e.getNextCodePoint=U;function O(ue,Ie){const Ne=ue.charCodeAt(Ie-1);if(K(Ne)&&Ie>1){const Qe=ue.charCodeAt(Ie-2);if(G(Qe))return M(Qe,Ne)}return Ne}function $(ue,Ie){const Ne=Ue.getInstance(),Qe=Ie,We=ue.length,at=U(ue,We,Ie);Ie+=at>=65536?2:1;let Re=Ne.getGraphemeBreakType(at);for(;Ie<We;){const De=U(ue,We,Ie),ke=Ne.getGraphemeBreakType(De);if(te(Re,ke))break;Ie+=De>=65536?2:1,Re=ke}return Ie-Qe}e.nextCharLength=$;function B(ue,Ie){const Ne=Ue.getInstance(),Qe=Ie,We=O(ue,Ie);Ie-=We>=65536?2:1;let at=Ne.getGraphemeBreakType(We);for(;Ie>0;){const Re=O(ue,Ie),De=Ne.getGraphemeBreakType(Re);if(te(De,at))break;Ie-=Re>=65536?2:1,at=De}return Qe-Ie}e.prevCharLength=B;function x(ue,Ie){const Ne=Ue.getInstance(),Qe=ue.length,We=Ie,at=U(ue,Qe,Ie),Re=Ne.getGraphemeBreakType(at);Ie+=at>=65536?2:1;let De=Re;for(;Ie<Qe;){const ne=U(ue,Qe,Ie),de=Ne.getGraphemeBreakType(ne);if(te(De,de))break;Ie+=ne>=65536?2:1,De=de}const ke=Ie;for(Ie=We,De=Re;Ie>0;){const ne=O(ue,Ie),de=Ne.getGraphemeBreakType(ne);if(te(de,De))break;Ie-=ne>=65536?2:1,De=de}return[Ie,ke]}function j(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?x(ue,Ie-1):x(ue,Ie)}e.getCharContainingOffset=j;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return H.test(ue)}e.containsRTL=Q;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function fe(ue){return X.test(ue)}e.containsEmoji=fe;const _e=/^[\t\n\r\x20-\x7E]*$/;function ye(ue){return _e.test(ue)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Le;function ze(ue){for(let Ie=0,Ne=ue.length;Ie<Ne;Ie++)if(xe(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=ze;function xe(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=xe;function Ge(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=Ge;function z(ue,Ie){if(ue.length<Ie)return ue;const Ne=/\b/g;let Qe=0;for(;Ne.test(ue)&&!(ue.length-Ne.lastIndex<Ie);)Qe=Ne.lastIndex,Ne.lastIndex+=1;return ue.substring(Qe).replace(/^\s/,"")}e.lcut=z;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(ae,"")),ue}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ne=Ie.length,Qe=ue.toLowerCase();let We=0,at=-1;for(;We<Ne;){const Re=Qe.indexOf(Ie[We],at+1);if(Re<0)return!1;at=Re,We++}return!0}e.fuzzyContains=Me;function je(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=je;function Ke(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Ke;function Se(ue,Ie=1){if(Ie===0)return"";let Ne=-1;do Ne=ue.indexOf(`
`,Ne+1),Ie--;while(Ie>0&&Ne>=0);return Ne===-1?ue:(ue[Ne-1]==="\r"&&Ne--,ue.substr(0,Ne))}e.getNLines=Se;function nt(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=nt;function Z(ue){return Ue.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Z;function te(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=te;var pe;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ye()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ne=this._data,Qe=Ne.length/3;let We=1;for(;We<=Qe;)if(Ie<Ne[3*We])We=2*We;else if(Ie>Ne[3*We+1])We=2*We+1;else return Ne[3*We+2];return 0}}Ue._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function it(ue,Ie){if(ue===0)return 0;const Ne=ft(ue,Ie);if(Ne!==void 0)return Ne;const Qe=O(Ie,ue);return ue-=pt(Qe),ue}e.getLeftDeleteOffset=it;function ft(ue,Ie){let Ne=O(Ie,ue);for(ue-=pt(Ne);St(Ne)||Ne===65039||Ne===8419;){if(ue===0)return;Ne=O(Ie,ue),ue-=pt(Ne)}if(!!Ge(Ne)){if(ue>=0){const Qe=O(Ie,ue);Qe===8205&&(ue-=pt(Qe))}return ue}}function pt(ue){return ue>=65536?2:1}function St(ue){return 127995<=ue&&ue<=127999}var Ct;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Ct||(Ct={}))}),define(me[58],ge([0,1,9]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(A){return I(A,0)}e.hash=L;function I(A,E){switch(typeof A){case"object":return A===null?k(349,E):Array.isArray(A)?y(A,E):P(A,E);case"string":return C(A,E);case"boolean":return R(A,E);case"number":return k(A,E);case"undefined":return k(937,E);default:return k(617,E)}}e.doHash=I;function k(A,E){return(E<<5)-E+A|0}function R(A,E){return k(A?433:863,E)}function C(A,E){E=k(149417,E);for(let l=0,a=A.length;l<a;l++)E=k(A.charCodeAt(l),E);return E}e.stringHash=C;function y(A,E){return E=k(104579,E),A.reduce((l,a)=>I(a,l),E)}function P(A,E){return E=k(181387,E),Object.keys(A).sort().reduce((l,a)=>(l=C(a,l),I(A[a],l)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=I(E,this._value),this._value}}e.Hasher=n;var T;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function c(A,E,l=32){const a=l-E,p=~((1<<a)-1);return(A<<E|(p&A)>>>a)>>>0}function h(A,E=0,l=A.byteLength,a=0){for(let p=0;p<l;p++)A[E+p]=a}function o(A,E,l="0"){for(;A.length<E;)A=l+A;return A}function v(A,E=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(l=>l.toString(16).padStart(2,"0")).join(""):o((A>>>0).toString(16),E/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const l=E.length;if(l===0)return;const a=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=E.charCodeAt(0),s=0);;){let i=r;if(f.isHighSurrogate(r))if(s+1<l){const g=E.charCodeAt(s+1);f.isLowSurrogate(g)?(s++,i=f.computeCodePoint(r,g)):i=65533}else{t=r;break}else f.isLowSurrogate(r)&&(i=65533);if(p=this._push(a,p,i),s++,s<l)r=E.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(E,l,a){return a<128?E[l++]=a:a<2048?(E[l++]=192|(a&1984)>>>6,E[l++]=128|(a&63)>>>0):a<65536?(E[l++]=224|(a&61440)>>>12,E[l++]=128|(a&4032)>>>6,E[l++]=128|(a&63)>>>0):(E[l++]=240|(a&1835008)>>>18,E[l++]=128|(a&258048)>>>12,E[l++]=128|(a&4032)>>>6,E[l++]=128|(a&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,l=this._buffDV;for(let d=0;d<64;d+=4)E.setUint32(d,l.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)E.setUint32(d,c(E.getUint32(d-12,!1)^E.getUint32(d-32,!1)^E.getUint32(d-56,!1)^E.getUint32(d-64,!1),1),!1);let a=this._h0,p=this._h1,t=this._h2,r=this._h3,s=this._h4,i,g,u;for(let d=0;d<80;d++)d<20?(i=p&t|~p&r,g=1518500249):d<40?(i=p^t^r,g=1859775393):d<60?(i=p&t|p&r|t&r,g=2400959708):(i=p^t^r,g=3395469782),u=c(a,5)+i+s+g+E.getUint32(d*4,!1)&4294967295,s=r,r=t,t=c(p,30),p=a,a=u;this._h0=this._h0+a&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,9]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const k="error",R="warning",C="warn",y="info",P="ignore";function n(c){return c?f.equalsIgnoreCase(k,c)?I.Error:f.equalsIgnoreCase(R,c)||f.equalsIgnoreCase(C,c)?I.Warning:f.equalsIgnoreCase(y,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=n;function T(c){switch(c){case I.Error:return k;case I.Warning:return R;case I.Info:return y;default:return P}}I.toString=T}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(w){return Array.isArray(w)}e.isArray=f;function L(w){return typeof w=="string"}e.isString=L;function I(w){return Array.isArray(w)&&w.every(D=>L(D))}e.isStringArray=I;function k(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=k;function R(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=R;function C(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=C;function y(w){return w===!0||w===!1}e.isBoolean=y;function P(w){return typeof w=="undefined"}e.isUndefined=P;function n(w){return!T(w)}e.isDefined=n;function T(w){return P(w)||w===null}e.isUndefinedOrNull=T;function c(w,D){if(!w)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=c;function h(w){if(T(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=h;function o(...w){const D=[];for(let m=0;m<w.length;m++){const S=w[m];if(T(S))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);D.push(S)}return D}e.assertAllDefined=o;const v=Object.prototype.hasOwnProperty;function _(w){if(!k(w))return!1;for(let D in w)if(v.call(w,D))return!1;return!0}e.isEmptyObject=_;function A(w){return typeof w=="function"}e.isFunction=A;function E(...w){return w.length>0&&w.every(A)}e.areFunctions=E;function l(w,D){const m=Math.min(w.length,D.length);for(let S=0;S<m;S++)a(w[S],D[S])}e.validateConstraints=l;function a(w,D){if(L(D)){if(typeof w!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(A(D)){try{if(w instanceof D)return}catch{}if(!T(w)&&w.constructor===D||D.length===1&&D.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function p(w){let D=[],m=Object.getPrototypeOf(w);for(;Object.prototype!==m;)D=D.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return D}e.getAllPropertyNames=p;function t(w){const D=[];for(const m of p(w))typeof w[m]=="function"&&D.push(m);return D}e.getAllMethodNames=t;function r(w,D){const m=b=>function(){const F=Array.prototype.slice.call(arguments,0);return D(b,F)};let S={};for(const b of w)S[b]=m(b);return S}e.createProxyObject=r;function s(w){return w===null?void 0:w}e.withNullAsUndefined=s;function i(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=i;function g(w){return class{constructor(){return new Proxy({},{get(D,m){if(D[m])return D[m];throw new Error(`Not Implemented: ${w}->${String(m)}`)}})}}}e.NotImplementedProxy=g;function u(w,D="Unreachable"){throw new Error(D)}e.assertNever=u;function d(w){return!!w&&typeof w.then=="function"&&typeof w.catch=="function"}e.isPromise=d}),define(me[29],ge([0,1,8,11,9,13]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(s){return s===47||s===92}e.isPathSeparator=R;function C(s){return s.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=C;function y(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function P(s,i=f.posix.sep){if(!s)return"";const g=s.length,u=s.charCodeAt(0);if(R(u)){if(R(s.charCodeAt(1))&&!R(s.charCodeAt(2))){let w=3;const D=w;for(;w<g&&!R(s.charCodeAt(w));w++);if(D!==w&&!R(s.charCodeAt(w+1))){for(w+=1;w<g;w++)if(R(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(A(u)&&s.charCodeAt(1)===58)return R(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<g;d++)if(R(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=P;function n(s){if(!L.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let g=2;const u=g;for(;g<s.length&&(i=s.charCodeAt(g),i!==92);g++);return!(u===g||(i=s.charCodeAt(g+1),isNaN(i)||i===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(s,i=L.isWindows){const g=i?T:c;return!(!s||s.length===0||/^\s+$/.test(s)||(g.lastIndex=0,g.test(s))||i&&h.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=o;function v(s,i,g){const u=s===i;return!g||u?u:!s||!i?!1:(0,I.equalsIgnoreCase)(s,i)}e.isEqual=v;function _(s,i,g,u=f.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(g){if(!(0,I.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let w=i.length;return i.charAt(i.length-1)===u&&w--,s.charAt(w)===u}return i.charAt(i.length-1)!==u&&(i+=u),s.indexOf(i)===0}e.isEqualOrParent=_;function A(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=A;function E(s,i){return L.isWindows&&s.endsWith(":")&&(s+=f.sep),(0,f.isAbsolute)(s)||(s=(0,f.join)(i,s)),s=(0,f.normalize)(s),L.isWindows?(s=(0,I.rtrim)(s,f.sep),s.endsWith(":")&&(s+=f.sep)):(s=(0,I.rtrim)(s,f.sep),s||(s=f.sep)),s}e.sanitizeFilePath=E;function l(s){const i=(0,f.normalize)(s);return L.isWindows?s.length>3?!1:a(i)&&(s.length===2||i.charCodeAt(2)===92):i===f.posix.sep}e.isRootOrDriveLetter=l;function a(s){return L.isWindows?A(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function p(s){return a(s)?s[0]:void 0}e.getDriveLetter=p;function t(s,i,g){return i.length>s.length?-1:s===i?0:(g&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let g,u,d;if(i.forEach(w=>{const D=Number(w);(0,k.isNumber)(D)?u===void 0?u=D:d===void 0&&(d=D):g=g?[g,w].join(":"):w}),!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:u!==void 0?u:void 0,column:d!==void 0?d:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[25],ge([0,1,13]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(A=>{v[A]&&typeof v[A]=="object"?_[A]=L(v[A]):_[A]=v[A]}),_}e.deepClone=L;function I(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const A=_.shift();Object.freeze(A);for(const E in A)if(k.call(A,E)){const l=A[E];typeof l=="object"&&!Object.isFrozen(l)&&_.push(l)}}return v}e.deepFreeze=I;const k=Object.prototype.hasOwnProperty;function R(v,_){return C(v,_,new Set)}e.cloneAndChange=R;function C(v,_,A){if((0,f.isUndefinedOrNull)(v))return v;const E=_(v);if(typeof E!="undefined")return E;if((0,f.isArray)(v)){const l=[];for(const a of v)l.push(C(a,_,A));return l}if((0,f.isObject)(v)){if(A.has(v))throw new Error("Cannot clone recursive data-structure");A.add(v);const l={};for(let a in v)k.call(v,a)&&(l[a]=C(v[a],_,A));return A.delete(v),l}return v}function y(v,_,A=!0){return(0,f.isObject)(v)?((0,f.isObject)(_)&&Object.keys(_).forEach(E=>{E in v?A&&((0,f.isObject)(v[E])&&(0,f.isObject)(_[E])?y(v[E],_[E],A):v[E]=_[E]):v[E]=_[E]}),v):_}e.mixin=y;function P(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let A,E;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(A=0;A<v.length;A++)if(!P(v[A],_[A]))return!1}else{const l=[];for(E in v)l.push(E);l.sort();const a=[];for(E in _)a.push(E);if(a.sort(),!P(l,a))return!1;for(A=0;A<l.length;A++)if(!P(v[l[A]],_[l[A]]))return!1}return!0}e.equals=P;function n(v){const _=new Set;return JSON.stringify(v,(A,E)=>{if((0,f.isObject)(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=n;function T(v,_,A){const E=_(v);return typeof E=="undefined"?A:E}e.getOrDefault=T;function c(v,_){const A=Object.create(null);return!v||!_||Object.keys(_).forEach(l=>{const a=v[l],p=_[l];P(a,p)||(A[l]=p)}),A}e.distinct=c;function h(v,_){const A=_.toLowerCase(),E=Object.keys(v).find(l=>l.toLowerCase()===A);return E?v[E]:v[_]}e.getCaseInsensitive=h;function o(v,_){const A=Object.create(null);for(const E of Object.keys(v))_(E,v[E])&&(A[E]=v[E]);return A}e.filter=o}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function L(k){return k<0?0:k>255?255:k|0}e.toUint8=L;function I(k){return k<0?0:k>4294967295?4294967295:k|0}e.toUint32=I}),define(me[2],ge([0,1,8,11]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,k=/^\//,R=/^\/\//;function C(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!k.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,i){return!s&&!i?"file":s}function P(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==T&&(i=T+i):i=T;break}return i}const n="",T="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,g,u,d,w,D=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=y(i,D),this.authority=g||n,this.path=P(this.scheme,u||n),this.query=d||n,this.fragment=w||n,C(this,D))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:g,authority:u,path:d,query:w,fragment:D}=i;return g===void 0?g=this.scheme:g===null&&(g=n),u===void 0?u=this.authority:u===null&&(u=n),d===void 0?d=this.path:d===null&&(d=n),w===void 0?w=this.query:w===null&&(w=n),D===void 0?D=this.fragment:D===null&&(D=n),g===this.scheme&&u===this.authority&&d===this.path&&w===this.query&&D===this.fragment?this:new v(g,u,d,w,D)}static parse(i,g=!1){const u=c.exec(i);return u?new v(u[2]||n,r(u[4]||n),r(u[5]||n),r(u[7]||n),r(u[9]||n),g):new v(n,n,n,n,n)}static file(i){let g=n;if(L.isWindows&&(i=i.replace(/\\/g,T)),i[0]===T&&i[1]===T){const u=i.indexOf(T,2);u===-1?(g=i.substring(2),i=T):(g=i.substring(2,u),i=i.substring(u)||T)}return new v("file",g,i,n,n)}static from(i){const g=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return C(g,!0),g}static joinPath(i,...g){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return L.isWindows&&i.scheme==="file"?u=h.file(f.win32.join(l(i,!0),...g)).path:u=f.posix.join(i.path,...g),i.with({path:u})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const g=new v(i);return g._formatted=i.external,g._fsPath=i._sep===o?i.fsPath:null,g}}else return i}}e.URI=h;const o=L.isWindows?1:void 0;class v extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=o),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(s,i){let g,u=-1;for(let d=0;d<s.length;d++){const w=s.charCodeAt(d);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)u!==-1&&(g+=encodeURIComponent(s.substring(u,d)),u=-1),g!==void 0&&(g+=s.charAt(d));else{g===void 0&&(g=s.substr(0,d));const D=_[w];D!==void 0?(u!==-1&&(g+=encodeURIComponent(s.substring(u,d)),u=-1),g+=D):u===-1&&(u=d)}}return u!==-1&&(g+=encodeURIComponent(s.substring(u))),g!==void 0?g:s}function E(s){let i;for(let g=0;g<s.length;g++){const u=s.charCodeAt(g);u===35||u===63?(i===void 0&&(i=s.substr(0,g)),i+=_[u]):i!==void 0&&(i+=s[g])}return i!==void 0?i:s}function l(s,i){let g;return s.authority&&s.path.length>1&&s.scheme==="file"?g=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?g=s.path.substr(1):g=s.path[1].toLowerCase()+s.path.substr(2):g=s.path,L.isWindows&&(g=g.replace(/\//g,"\\")),g}e.uriToFsPath=l;function a(s,i){const g=i?E:A;let u="",{scheme:d,authority:w,path:D,query:m,fragment:S}=s;if(d&&(u+=d,u+=":"),(w||d==="file")&&(u+=T,u+=T),w){let b=w.indexOf("@");if(b!==-1){const F=w.substr(0,b);w=w.substr(b+1),b=F.indexOf(":"),b===-1?u+=g(F,!1):(u+=g(F.substr(0,b),!1),u+=":",u+=g(F.substr(b+1),!1)),u+="@"}w=w.toLowerCase(),b=w.indexOf(":"),b===-1?u+=g(w,!1):(u+=g(w.substr(0,b),!1),u+=w.substr(b))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const b=D.charCodeAt(1);b>=65&&b<=90&&(D=`/${String.fromCharCode(b+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const b=D.charCodeAt(0);b>=65&&b<=90&&(D=`${String.fromCharCode(b+32)}:${D.substr(2)}`)}u+=g(D,!0)}return m&&(u+="?",u+=g(m,!1)),S&&(u+="#",u+=i?S:A(S,!1)),u}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>p(i)):s}});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[24],ge([0,1,9,2]),function(J,e,f,L){"use strict";var I,k,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=C;function y(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function P(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,f.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,f.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class c{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,f.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,f.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class o{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,f.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,f.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,f.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,f.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new o(r))}static forPaths(){return new _(new c)}static forStrings(){return new _(new n)}static forConfigKeys(){return new _(new T)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let g;for(this._root||(this._root=new v,this._root.segment=i.value()),g=this._root;;){const d=i.cmp(g.segment);if(d>0)g.left||(g.left=new v,g.left.segment=i.value()),g=g.left;else if(d<0)g.right||(g.right=new v,g.right.segment=i.value()),g=g.right;else if(i.hasNext())i.next(),g.mid||(g.mid=new v,g.mid.segment=i.value()),g=g.mid;else break}const u=g.value;return g.value=s,g.key=r,u}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const g=s.cmp(i.segment);if(g>0)i=i.left;else if(g<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),g=[];let u=this._root;for(;u;){const d=i.cmp(u.segment);if(d>0)g.push([1,u]),u=u.left;else if(d<0)g.push([-1,u]),u=u.right;else if(i.hasNext())i.next(),g.push([0,u]),u=u.mid;else{for(s?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;g.length>0&&u.isEmpty();){let[w,D]=g.pop();switch(w){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}u=D}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,g;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),g=i.value||g,i=i.mid;else break}return i&&i.value||g}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const g=s.cmp(i.segment);if(g>0)i=i.left;else if(g<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=_;class A{constructor(r,s){this[I]="ResourceMap",r instanceof A?(this.map=new Map(r.map),this.toKey=s??A.defaultToKey):(this.map=new Map,this.toKey=r??A.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,g]of this.map)r(g,L.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=A,A.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class l{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let g=this._map.get(r);if(g)g.value=s,i!==0&&this.touch(g,i);else{switch(g={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(r,g),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let g=this._head;for(;g;){if(s?r.bind(s)(g.value,g.key,this):r(g.value,g.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const r=this,s=this._state;let i=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const u={value:i.key,done:!1};return i=i.next,u}else return{value:void 0,done:!0}}};return g}values(){const r=this,s=this._state;let i=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const u={value:i.value,done:!1};return i=i.next,u}else return{value:void 0,done:!0}}};return g}entries(){const r=this,s=this._state;let i=this._head;const g={[Symbol.iterator](){return g},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const u={value:[i.key,i.value],done:!1};return i=i.next,u}else return{value:void 0,done:!0}}};return g}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,g=r.previous;r===this._tail?(g.next=void 0,this._tail=g):(i.previous=g,g.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,g=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=g,g.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=l;class a extends l{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class p{constructor(r){R.set(this,void 0),st(this,R,r,"f")}get size(){return He(this,R,"f").size}forEach(r,s){He(this,R,"f").forEach(r,s)}get(r){return He(this,R,"f").get(r)}has(r){return He(this,R,"f").has(r)}entries(){return He(this,R,"f").entries()}keys(){return He(this,R,"f").keys()}values(){return He(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return He(this,R,"f").entries()}}e.ReadonlyMapView=p}),define(me[98],ge([0,1,24,9]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...Y){return function(oe,ve){for(let Me=0,je=Y.length;Me<je;Me++){const Ke=Y[Me](oe,ve);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(Y,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Y,oe){const ve=oe.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=R;function C(Y,oe){return y(Y.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function y(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]===oe[Me]){let je=null;return(je=y(Y,oe,ve+1,Me+1))?A({start:Me,end:Me+1},je):null}return y(Y,oe,ve,Me+1)}function P(Y){return 97<=Y&&Y<=122}function n(Y){return 65<=Y&&Y<=90}e.isUpper=n;function T(Y){return 48<=Y&&Y<=57}function c(Y){return Y===32||Y===9||Y===10||Y===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>h.add(Y.charCodeAt(0)));function o(Y){return c(Y)||h.has(Y)}function v(Y,oe){return Y===oe||o(Y)&&o(oe)}function _(Y){return P(Y)||n(Y)||T(Y)}function A(Y,oe){return oe.length===0?oe=[Y]:Y.end===oe[0].start?oe[0].start=Y.start:oe.unshift(Y),oe}function E(Y,oe){for(let ve=oe;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(n(Me)||T(Me)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function l(Y,oe,ve,Me){if(ve===Y.length)return[];if(Me===oe.length)return null;if(Y[ve]!==oe[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=l(Y,oe,ve+1,Me+1);!je&&(Ke=E(oe,Ke))<oe.length;)je=l(Y,oe,ve+1,Ke),Ke++;return je===null?null:A({start:Me,end:Me+1},je)}}function a(Y){let oe=0,ve=0,Me=0,je=0,Ke=0;for(let pe=0;pe<Y.length;pe++)Ke=Y.charCodeAt(pe),n(Ke)&&oe++,P(Ke)&&ve++,_(Ke)&&Me++,T(Ke)&&je++;const Se=oe/Y.length,nt=ve/Y.length,Z=Me/Y.length,te=je/Y.length;return{upperPercent:Se,lowerPercent:nt,alphaPercent:Z,numericPercent:te}}function p(Y){const{upperPercent:oe,lowerPercent:ve}=Y;return ve===0&&oe>.6}function t(Y){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:je}=Y;return ve>.2&&oe<.8&&Me>.6&&je<.2}function r(Y){let oe=0,ve=0,Me=0,je=0;for(let Ke=0;Ke<Y.length;Ke++)Me=Y.charCodeAt(Ke),n(Me)&&oe++,P(Me)&&ve++,c(Me)&&je++;return(oe===0||ve===0)&&je===0?Y.length<=30:oe<=5}function s(Y,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(Y)||oe.length>60)return null;const ve=a(oe);if(!t(ve)){if(!p(ve))return null;oe=oe.toLowerCase()}let Me=null,je=0;for(Y=Y.toLowerCase();je<oe.length&&(Me=l(Y,oe,0,je))===null;)je=E(oe,je+1);return Me}e.matchesCamelCase=s;function i(Y,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,je=0;for(Y=Y.toLowerCase(),oe=oe.toLowerCase();je<oe.length&&(Me=g(Y,oe,0,je,ve))===null;)je=u(oe,je+1);return Me}e.matchesWords=i;function g(Y,oe,ve,Me,je){if(ve===Y.length)return[];if(Me===oe.length)return null;if(v(Y.charCodeAt(ve),oe.charCodeAt(Me))){let Ke=null,Se=Me+1;if(Ke=g(Y,oe,ve+1,Me+1,je),!je)for(;!Ke&&(Se=u(oe,Se))<oe.length;)Ke=g(Y,oe,ve+1,Se,je),Se++;return Ke===null?null:A({start:Me,end:Me+1},Ke)}else return null}function u(Y,oe){for(let ve=oe;ve<Y.length;ve++)if(o(Y.charCodeAt(ve))||ve>0&&o(Y.charCodeAt(ve-1)))return ve;return Y.length}const d=I(e.matchesPrefix,s,R),w=I(e.matchesPrefix,s,C),D=new f.LRUCache(1e4);function m(Y,oe,ve=!1){if(typeof Y!="string"||typeof oe!="string")return null;let Me=D.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),D.set(Y,Me));const je=Me.exec(oe);return je?[{start:je.index,end:je.index+je[0].length}]:ve?w(Y,oe):d(Y,oe)}e.matchesFuzzy=m;function S(Y,oe){const ve=ze(Y,Y.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=S;function b(Y,oe,ve,Me,je,Ke){const Se=Math.min(13,Y.length);for(;ve<Se;ve++){const nt=ze(Y,oe,ve,Me,je,Ke,!1);if(nt)return nt}return[0,Ke]}e.anyScore=b;function F(Y){if(typeof Y=="undefined")return[];const oe=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const je=Y[Me]+ve,Ke=oe[oe.length-1];Ke&&Ke.end===je?Ke.end=je+1:oe.push({start:je,end:je+1})}return oe}e.createMatches=F;const N=128;function G(){const Y=[],oe=[];for(let ve=0;ve<=N;ve++)oe[ve]=0;for(let ve=0;ve<=N;ve++)Y.push(oe.slice(0));return Y}function K(Y){const oe=[];for(let ve=0;ve<=Y;ve++)oe[ve]=0;return oe}const M=K(2*N),U=K(2*N),O=G(),$=G(),B=G(),x=!1;function j(Y,oe,ve,Me,je){function Ke(nt,Z,te=" "){for(;nt.length<Z;)nt=te+nt;return nt}let Se=` |   |${Me.split("").map(nt=>Ke(nt,3)).join("|")}
`;for(let nt=0;nt<=ve;nt++)nt===0?Se+=" |":Se+=`${oe[nt-1]}|`,Se+=Y[nt].slice(0,je+1).map(Z=>Ke(Z.toString(),3)).join("|")+`
`;return Se}function H(Y,oe,ve,Me){Y=Y.substr(oe),ve=ve.substr(Me),console.log(j($,Y,Y.length,ve,ve.length)),console.log(j(B,Y,Y.length,ve,ve.length)),console.log(j(O,Y,Y.length,ve,ve.length))}function Q(Y,oe){if(oe<0||oe>=Y.length)return!1;const ve=Y.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function X(Y,oe){if(oe<0||oe>=Y.length)return!1;switch(Y.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function fe(Y,oe,ve){return oe[Y]!==ve[Y]}function _e(Y,oe,ve,Me,je,Ke,Se=!1){for(;oe<ve&&je<Ke;)Y[oe]===Me[je]&&(Se&&(M[oe]=je),oe+=1),je+=1;return oe===ve}e.isPatternInWord=_e;var ye;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Le;(function(Y){Y.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=oe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function ze(Y,oe,ve,Me,je,Ke,Se){const nt=Y.length>N?N:Y.length,Z=Me.length>N?N:Me.length;if(ve>=nt||Ke>=Z||nt-ve>Z-Ke||!_e(oe,ve,nt,je,Ke,Z,!0))return;xe(nt,Z,ve,Ke,oe,je);let te=1,pe=1,Ue=ve,Ye=Ke;const it=[!1];for(te=1,Ue=ve;Ue<nt;te++,Ue++){const ue=M[Ue],Ie=U[Ue],Ne=Ue+1<nt?U[Ue+1]:Z;for(pe=ue-Ke+1,Ye=ue;Ye<Ne;pe++,Ye++){let Qe=Number.MIN_SAFE_INTEGER,We=!1;Ye<=Ie&&(Qe=Ge(Y,oe,Ue,ve,Me,je,Ye,Z,Ke,O[te-1][pe-1]===0,it));let at=0;Qe!==Number.MAX_SAFE_INTEGER&&(We=!0,at=Qe+$[te-1][pe-1]);const Re=Ye>ue,De=Re?$[te][pe-1]+(O[te][pe-1]>0?-5:0):0,ke=Ye>ue+1&&O[te][pe-1]>0,ne=ke?$[te][pe-2]+(O[te][pe-2]>0?-5:0):0;if(ke&&(!Re||ne>=De)&&(!We||ne>=at))$[te][pe]=ne,B[te][pe]=3,O[te][pe]=0;else if(Re&&(!We||De>=at))$[te][pe]=De,B[te][pe]=2,O[te][pe]=0;else if(We)$[te][pe]=at,B[te][pe]=1,O[te][pe]=O[te-1][pe-1]+1;else throw new Error("not possible")}}if(x&&H(Y,ve,Me,Ke),!it[0]&&!Se)return;te--,pe--;const ft=[$[te][pe],Ke];let pt=0,St=0;for(;te>=1;){let ue=pe;do{const Ie=B[te][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);pt>1&&oe[ve+te-1]===je[Ke+pe-1]&&!fe(ue+Ke-1,Me,je)&&pt+1>O[te][ue]&&(ue=pe),ue===pe?pt++:pt=1,St||(St=ue),te--,pe=ue-1,ft.push(pe)}Z===nt&&(ft[0]+=2);const Ct=St-nt;return ft[0]-=Ct,ft}e.fuzzyScore=ze;function xe(Y,oe,ve,Me,je,Ke){let Se=Y-1,nt=oe-1;for(;Se>=ve&&nt>=Me;)je[Se]===Ke[nt]&&(U[Se]=nt,Se--),nt--}function Ge(Y,oe,ve,Me,je,Ke,Se,nt,Z,te,pe){if(oe[ve]!==Ke[Se])return Number.MIN_SAFE_INTEGER;let Ue=1,Ye=!1;return Se===ve-Me?Ue=Y[ve]===je[Se]?7:5:fe(Se,je,Ke)&&(Se===0||!fe(Se-1,je,Ke))?(Ue=Y[ve]===je[Se]?7:5,Ye=!0):Q(Ke,Se)&&(Se===0||!Q(Ke,Se-1))?Ue=5:(Q(Ke,Se-1)||X(Ke,Se-1))&&(Ue=5,Ye=!0),Ue>1&&ve===Me&&(pe[0]=!0),Ye||(Ye=fe(Se,je,Ke)||Q(Ke,Se-1)||X(Ke,Se-1)),ve===Me?Se>Z&&(Ue-=Ye?3:5):te?Ue+=Ye?2:0:Ue+=Ye?0:1,Se+1===nt&&(Ue-=Ye?3:5),Ue}function z(Y,oe,ve,Me,je,Ke,Se){return re(Y,oe,ve,Me,je,Ke,!0,Se)}e.fuzzyScoreGracefulAggressive=z;function ee(Y,oe,ve,Me,je,Ke,Se){return re(Y,oe,ve,Me,je,Ke,!1,Se)}e.fuzzyScoreGraceful=ee;function re(Y,oe,ve,Me,je,Ke,Se,nt){let Z=ze(Y,oe,ve,Me,je,Ke,nt);if(Z&&!Se)return Z;if(Y.length>=3){const te=Math.min(7,Y.length-1);for(let pe=ve+1;pe<te;pe++){const Ue=ae(Y,pe);if(Ue){const Ye=ze(Ue,Ue.toLowerCase(),ve,Me,je,Ke,nt);Ye&&(Ye[0]-=3,(!Z||Ye[0]>Z[0])&&(Z=Ye))}}}return Z}function ae(Y,oe){if(oe+1>=Y.length)return;const ve=Y[oe],Me=Y[oe+1];if(ve!==Me)return Y.slice(0,oe)+Me+ve+Y.slice(oe+2)}}),define(me[141],ge([0,1,47,98,9]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${k.source}`,"g");function C(v){return v.replace(R,(_,A)=>A?_:`\\${_}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${k.source}`,"g");function P(v){return v.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const n=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function T(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(n,(_,A,E,l)=>E?_:A||l||"")}e.stripIcons=T;function c(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:h(v,_)}e.parseLabelWithIcons=c;function h(v,_){const A=[];let E="";function l(u){if(u){E+=u;for(const d of u)A.push(t)}}let a=-1,p="",t=0,r,s,i=_;const g=v.length;for(l(v.substr(0,_));i<g;)r=v[i],s=v[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(a=i,l(p),p=e.iconStartMarker,i++):r===")"&&a!==-1?(t+=i-a+1,a=-1,p=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?p+=r:(l(p),a=-1,p=""):l(r),i++;return l(p),{text:E,iconOffsets:A}}function o(v,_,A=!1){const{text:E,iconOffsets:l}=_;if(!l||l.length===0)return(0,L.matchesFuzzy)(v,E,A);const a=(0,I.ltrim)(E," "),p=E.length-a.length,t=(0,L.matchesFuzzy)(v,a,A);if(t)for(const r of t){const s=l[r.start+p]+p;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=o}),define(me[99],ge([0,1,16,141]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(h="",o=!1){if(this.value=h,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1)}appendText(h,o=0){return this.value+=P(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,o){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=k;function R(c){return C(c)?!c.value:Array.isArray(c)?c.every(R):!0}e.isEmptyMarkdownString=R;function C(c){return c instanceof k?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function y(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=y;function P(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function T(c){const h=[],o=c.split("|").map(_=>_.trim());c=o[0];const v=o[1];if(v){const _=/height=(\d+)/.exec(v),A=/width=(\d+)/.exec(v),E=_?_[1]:"",l=A?A[1]:"",a=isFinite(parseInt(l)),p=isFinite(parseInt(E));a&&h.push(`width="${l}"`),p&&h.push(`height="${E}"`)}return{href:c,dimensions:h}}e.parseHrefAndDimensions=T}),define(me[59],ge([0,1,23,9,2]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,y)}e.stringify=k;function R(n){let T=JSON.parse(n);return T=P(T),T}e.parse=R;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function y(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,L.regExpFlags)(T)}:T}function P(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return I.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof f.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=P(n[c],T+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=P(n[c],T+1))}return n}e.revive=P}),define(me[10],ge([0,1,11,2]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,n){this._hosts[y]=P,this._ports[y]=n}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let n=this._hosts[P];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const T=this._ports[P],c=this._connectionTokens[P];let h=`path=${encodeURIComponent(y.path)}`;return typeof c=="string"&&(h+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${n}:${T}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new k;class R{asBrowserUri(y,P){const n=this.toUri(y,P);return n.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===I.file&&typeof f.globals.importScripts=="function"&&f.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`?n.with({scheme:I.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,P){const n=this.toUri(y,P);return n.scheme===I.vscodeFileResource?n.with({scheme:I.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,P){return L.URI.isUri(y)?y:L.URI.parse(P.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[79],ge([0,1,24]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new f.LRUCache(1e4);function I(P){return y(P,"NFC",L)}e.normalizeNFC=I;const k=new f.LRUCache(1e4);function R(P){return y(P,"NFD",k)}e.normalizeNFD=R;const C=/[^\u0000-\u0080]/;function y(P,n,T){if(!P)return P;const c=T.get(P);if(c)return c;let h;return C.test(P)?h=P.normalize(n):h=P,T.set(P,h),h}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(n){return R(n).replace(P,"")}}()}),define(me[22],ge([0,1,29,10,8,11,9,2]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,C.uriToFsPath)(h,!0)}e.originalFSPath=y;class P{constructor(o){this._ignorePathCasing=o}compare(o,v,_=!1){return o===v?0:(0,R.compare)(this.getComparisonKey(o,_),this.getComparisonKey(v,_))}isEqual(o,v,_=!1){return o===v?!0:!o||!v?!1:this.getComparisonKey(o,_)===this.getComparisonKey(v,_)}getComparisonKey(o,v=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,v,_=!1){if(o.scheme===v.scheme){if(o.scheme===L.Schemas.file)return f.isEqualOrParent(y(o),y(v),this._ignorePathCasing(o))&&o.query===v.query&&(_||o.fragment===v.fragment);if((0,e.isEqualAuthority)(o.authority,v.authority))return f.isEqualOrParent(o.path,v.path,this._ignorePathCasing(o),"/")&&o.query===v.query&&(_||o.fragment===v.fragment)}return!1}joinPath(o,...v){return C.URI.joinPath(o,...v)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return I.posix.basename(o.path)}extname(o){return I.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let v;return o.scheme===L.Schemas.file?v=C.URI.file(I.dirname(y(o))).path:(v=I.posix.dirname(o.path),o.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),v="/")),o.with({path:v})}normalizePath(o){if(!o.path.length)return o;let v;return o.scheme===L.Schemas.file?v=C.URI.file(I.normalize(y(o))).path:v=I.posix.normalize(o.path),o.with({path:v})}relativePath(o,v){if(o.scheme!==v.scheme||!(0,e.isEqualAuthority)(o.authority,v.authority))return;if(o.scheme===L.Schemas.file){const E=I.relative(y(o),y(v));return k.isWindows?f.toSlashes(E):E}let _=o.path||"/",A=v.path||"/";if(this._ignorePathCasing(o)){let E=0;for(const l=Math.min(_.length,A.length);E<l&&!(_.charCodeAt(E)!==A.charCodeAt(E)&&_.charAt(E).toLowerCase()!==A.charAt(E).toLowerCase());E++);_=A.substr(0,E)+_.substr(E)}return I.posix.relative(_,A)}resolvePath(o,v){if(o.scheme===L.Schemas.file){const _=C.URI.file(I.resolve(y(o),v));return o.with({authority:_.authority,path:_.path})}return v=f.toPosixPath(v),o.with({path:I.posix.resolve(o.path,v)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,v){return o===v||(0,R.equalsIgnoreCase)(o,v)}hasTrailingPathSeparator(o,v=I.sep){if(o.scheme===L.Schemas.file){const _=y(o);return _.length>f.getRoot(_).length&&_[_.length-1]===v}else{const _=o.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,v=I.sep){return(0,e.hasTrailingPathSeparator)(o,v)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,v=I.sep){let _=!1;if(o.scheme===L.Schemas.file){const A=y(o);_=A!==void 0&&A.length===f.getRoot(A).length&&A[A.length-1]===v}else{v="/";const A=o.path;_=A.length===1&&A.charCodeAt(A.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(o,v)?o.with({path:o.path+"/"}):o}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(h=>h.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,o){const v=[];for(let _=0;_<h.length;_++){const A=o(h[_]);h.some((E,l)=>l===_?!1:(0,e.isEqualOrParent)(A,o(E)))||v.push(h[_])}return v}e.distinctParents=n;var T;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function o(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[a,p]=l.split(":");a&&p&&_.set(a,p)});const E=v.path.substring(0,v.path.indexOf(";"));return E&&_.set(h.META_DATA_MIME,E),_}h.parseMetaData=o})(T=e.DataUri||(e.DataUri={}));function c(h,o,v){if(o){let _=h.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),h.with({scheme:v,authority:o,path:_})}return h.with({scheme:v})}e.toLocalResource=c}),define(me[17],ge([0,1,21,16,3,6,22]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(U){return!!U&&typeof U.then=="function"}e.isThenable=C;function y(U){const O=new f.CancellationTokenSource,$=U(O.token),B=new Promise((x,j)=>{const H=O.token.onCancellationRequested(()=>{H.dispose(),O.dispose(),j((0,L.canceled)())});Promise.resolve($).then(Q=>{H.dispose(),O.dispose(),x(Q)},Q=>{H.dispose(),O.dispose(),j(Q)})});return new class{cancel(){O.cancel()}then(x,j){return B.then(x,j)}catch(x){return this.then(void 0,x)}finally(x){return B.finally(x)}}}e.createCancelablePromise=y;function P(U,O,$){return Promise.race([U,new Promise(B=>O.onCancellationRequested(()=>B($)))])}e.raceCancellation=P;async function n(U){let O=-1;const $=U.map((x,j)=>x.then(H=>(O=j,H))),B=await Promise.race($);return U.forEach((x,j)=>{j!==O&&x.cancel()}),B}e.raceCancellablePromises=n;function T(U,O,$){let B;const x=setTimeout(()=>{B?.(void 0),$?.()},O);return Promise.race([U.finally(()=>clearTimeout(x)),new Promise(j=>B=j)])}e.raceTimeout=T;function c(U){return new Promise((O,$)=>{const B=U();C(B)?B.then(O,$):O(B)})}e.asPromise=c;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then($,$).then(B)})}return new Promise(($,B)=>{this.queuedPromise.then($,B)})}return this.activePromise=O(),new Promise(($,B)=>{this.activePromise.then(x=>{this.activePromise=null,$(x)},x=>{this.activePromise=null,B(x)})})}}e.Throttler=h;class o{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=o;class v{constructor(){this.promiseMap=new Map}queue(O,$){const x=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(O)===x&&this.promiseMap.delete(O)});return this.promiseMap.set(O,x),x}}e.SequencerByKey=v;class _{constructor(O){this.defaultDelay=O,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,$=this.defaultDelay){return this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,x)=>{this.doResolve=B,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class A{constructor(O){this.delayer=new _(O),this.throttler=new h}trigger(O,$){return this.delayer.trigger(()=>this.throttler.queue(O),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=A;class E{constructor(){this._isOpen=!1,this._promise=new Promise((O,$)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class l extends E{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function a(U,O){return O?new Promise(($,B)=>{const x=setTimeout(()=>{j.dispose(),$()},U),j=O.onCancellationRequested(()=>{clearTimeout(x),j.dispose(),B((0,L.canceled)())})}):y($=>a(U,$))}e.timeout=a;function p(U,O=0){const $=setTimeout(U,O);return(0,k.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=p;function t(U){const O=[];let $=0;const B=U.length;function x(){return $<B?U[$++]():null}function j(H){H!=null&&O.push(H);const Q=x();return Q?Q.then(j):Promise.resolve(O)}return Promise.resolve(null).then(j)}e.sequence=t;function r(U,O=B=>!!B,$=null){let B=0;const x=U.length,j=()=>{if(B>=x)return Promise.resolve($);const H=U[B++];return Promise.resolve(H()).then(X=>O(X)?Promise.resolve(X):j())};return j()}e.first=r;function s(U,O=B=>!!B,$=null){if(U.length===0)return Promise.resolve($);let B=U.length;const x=()=>{B=-1;for(const j of U)j.cancel?.()};return new Promise((j,H)=>{for(const Q of U)Q.then(X=>{--B>=0&&O(X)?(x(),j(X)):B===0&&j($)}).catch(X=>{--B>=0&&(x(),H(X))})})}e.firstParallel=s;class i{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise(($,B)=>{this.outstandingPromises.push({factory:O,c:$,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const $=O.factory();$.then(O.c,O.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class g extends i{constructor(){super(1)}}e.Queue=g;class u{constructor(){this.queues=new Map}queueFor(O,$=R.extUri){const B=$.getComparisonKey(O);let x=this.queues.get(B);return x||(x=new g,I.Event.once(x.onFinished)(()=>{x?.dispose(),this.queues.delete(B)}),this.queues.set(B,x)),x}dispose(){this.queues.forEach(O=>O.dispose()),this.queues.clear()}}e.ResourceQueue=u;class d{constructor(O,$){this._token=-1,typeof O=="function"&&typeof $=="number"&&this.setIfNotSet(O,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},$)}setIfNotSet(O,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},$))}}e.TimeoutTimer=d;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,$){this.cancel(),this._token=setInterval(()=>{O()},$)}}e.IntervalTimer=w;class D{constructor(O,$){this.timeoutToken=-1,this.runner=O,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=D;class m extends D{constructor(O,$){super(O,$);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=m;class S extends k.Disposable{constructor(O,$,B,x){super();this.maxWorkChunkSize=O,this.maxPendingWork=$,this.throttleDelay=B,this.handler=x,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.maxPendingWork)return!1}else if(this.pending+O.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new D(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=S,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=O=>{const $=setTimeout(()=>O(U));let B=!1;return{dispose(){B||(B=!0,clearTimeout($))}}}}else e.runWhenIdle=(U,O)=>{const $=requestIdleCallback(U,typeof O=="number"?{timeout:O}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback($))}}}}();class b{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=b;async function F(U,O,$){let B;for(let x=0;x<$;x++)try{return await U()}catch(j){B=j,await a(O)}throw B}e.retry=F;class N{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,$,B){return this._pending={taskId:O,cancel:()=>B?.(),promise:$},$.then(()=>this.donePending(O),()=>this.donePending(O)),$}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let $,B;const x=new Promise((j,H)=>{$=j,B=H});this._next={run:O,promise:x,promiseResolve:$,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=N;class G{constructor(O){this.interval=O,this.lastIncrementTime=0,this.value=0}increment(){const O=Date.now();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,$)=>{this.completeCallback=O,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise($=>{this.completeCallback(O),this.resolved=!0,$()})}error(O){return new Promise($=>{this.errorCallback(O),this.rejected=!0,$()})}cancel(){new Promise(O=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,O()})}}e.DeferredPromise=K;var M;(function(U){async function O($){let B;const x=await Promise.all($.map(j=>j.then(H=>H,H=>{B||(B=H)})));if(typeof B!="undefined")throw B;return x}U.settled=O})(M=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,17,8]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),k=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(D,m,S=!1){const b=D||"",F=m||"",N=I.value.collator.compare(b,F);return I.value.collatorIsNumeric&&N===0&&b!==F?b<F?-1:1:N}e.compareFileNames=C;function y(D,m){const S=k.value.collator;return D=D||"",m=m||"",p(S,D,m)}e.compareFileNamesDefault=y;function P(D,m){const S=k.value.collator;return D=D||"",m=m||"",i(D,m)||p(S,D,m)}e.compareFileNamesUpper=P;function n(D,m){const S=k.value.collator;return D=D||"",m=m||"",s(D,m)||p(S,D,m)}e.compareFileNamesLower=n;function T(D,m){return D=D||"",m=m||"",D===m?0:D<m?-1:1}e.compareFileNamesUnicode=T;function c(D,m,S=!1){S||(D=D&&D.toLowerCase(),m=m&&m.toLowerCase());const[b,F]=l(D),[N,G]=l(m);return b!==N?b<N?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=c;function h(D,m){const[S,b]=l(D),[F,N]=l(m);let G=I.value.collator.compare(b,N);if(G===0){if(I.value.collatorIsNumeric&&b!==N)return b<N?-1:1;if(G=I.value.collator.compare(S,F),I.value.collatorIsNumeric&&G===0&&S!==F)return S<F?-1:1}return G}e.compareFileExtensions=h;function o(D,m){D=D||"",m=m||"";const S=a(D),b=a(m),F=k.value.collator,N=R.value.collator;return p(N,S,b)||p(F,D,m)}e.compareFileExtensionsDefault=o;function v(D,m){D=D||"",m=m||"";const S=a(D),b=a(m),F=k.value.collator,N=R.value.collator;return p(N,S,b)||i(D,m)||p(F,D,m)}e.compareFileExtensionsUpper=v;function _(D,m){D=D||"",m=m||"";const S=a(D),b=a(m),F=k.value.collator,N=R.value.collator;return p(N,S,b)||s(D,m)||p(F,D,m)}e.compareFileExtensionsLower=_;function A(D,m){D=D||"",m=m||"";const S=a(D).toLowerCase(),b=a(m).toLowerCase();return S!==b?S<b?-1:1:D!==m?D<m?-1:1:0}e.compareFileExtensionsUnicode=A;const E=/^(.*?)(\.([^.]*))?$/;function l(D,m=!1){const S=D?E.exec(D):[];let b=[S&&S[1]||"",S&&S[3]||""];return m&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function a(D){const m=D?E.exec(D):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function p(D,m,S){let b=D.compare(m,S);return b!==0?b:m.length!==S.length?m.length<S.length?-1:1:0}function t(D){const m=D.charAt(0);return m.toLocaleUpperCase()!==m}function r(D){const m=D.charAt(0);return m.toLocaleLowerCase()!==m}function s(D,m){return t(D)&&r(m)?-1:r(D)&&t(m)?1:0}function i(D,m){return r(D)&&t(m)?-1:t(D)&&r(m)?1:0}function g(D,m,S=!1){return S||(D=D&&D.toLowerCase(),m=m&&m.toLowerCase()),D===m?0:D<m?-1:1}function u(D,m,S=!1){const b=D.split(L.sep),F=m.split(L.sep),N=b.length-1,G=F.length-1;let K,M;for(let U=0;;U++){if(K=N===U,M=G===U,K&&M)return C(b[U],F[U],S);if(K)return-1;if(M)return 1;const O=g(b[U],F[U],S);if(O!==0)return O}}e.comparePaths=u;function d(D,m,S){const b=D.toLowerCase(),F=m.toLowerCase(),N=w(D,m,S);if(N)return N;const G=b.endsWith(S),K=F.endsWith(S);if(G!==K)return G?-1:1;const M=C(b,F);return M!==0?M:b.localeCompare(F)}e.compareAnything=d;function w(D,m,S){const b=D.toLowerCase(),F=m.toLowerCase(),N=b.startsWith(S),G=F.startsWith(S);if(N!==G)return N?-1:1;if(N&&G){if(b.length<F.length)return-1;if(b.length>F.length)return 1}return 0}e.compareByPrefix=w}),define(me[101],ge([0,1,100,98,8,11,9]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,y=[C,[]];function P(M,U,O,$){if(!M||!U)return y;const B=M.length,x=U.length;if(B<x)return y;const j=M.toLowerCase();return n(U,O,x,M,j,B,$)}e.scoreFuzzy=P;function n(M,U,O,$,B,x,j){const H=[],Q=[];for(let ye=0;ye<O;ye++){const Le=ye*x,ze=Le-x,xe=ye>0,Ge=M[ye],z=U[ye];for(let ee=0;ee<x;ee++){const re=ee>0,ae=Le+ee,Y=ae-1,oe=ze+ee-1,ve=re?H[Y]:0,Me=xe&&re?H[oe]:0,je=xe&&re?Q[oe]:0;let Ke;!Me&&xe?Ke=0:Ke=T(Ge,z,$,B,ee,je),Ke&&Me+Ke>=ve&&(j||xe||B.startsWith(U,ee))?(Q[ae]=je+1,H[ae]=Me+Ke):(Q[ae]=C,H[ae]=ve)}}const X=[];let fe=O-1,_e=x-1;for(;fe>=0&&_e>=0;){const ye=fe*x+_e;Q[ye]===C||(X.push(_e),fe--),_e--}return[H[O*x-1],X.reverse()]}function T(M,U,O,$,B,x){let j=0;if(!c(U,$[B]))return j;if(j+=1,x>0&&(j+=x*5),M===O[B]&&(j+=1),B===0)j+=8;else{const H=h(O.charCodeAt(B-1));H?j+=H:(0,L.isUpper)(O.charCodeAt(B))&&(j+=2)}return j}function c(M,U){return M===U?!0:M==="/"||M==="\\"?U==="/"||U==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const o=[void 0,[]];function v(M,U,O=0,$=0){const B=U;return B.values&&B.values.length>1?_(M,B.values,O,$):A(M,U,O,$)}e.scoreFuzzy2=v;function _(M,U,O,$){let B=0;const x=[];for(const j of U){const[H,Q]=A(M,j,O,$);if(typeof H!="number")return o;B+=H,x.push(...Q)}return[B,u(x)]}function A(M,U,O,$){const B=(0,L.fuzzyScore)(U.original,U.originalLowercase,O,M,M.toLowerCase(),$,!0);return B?[B[0],(0,L.createMatches)(B)]:o}const E=Object.freeze({score:0}),l=1<<18,a=1<<17,p=1<<16;function t(M,U,O,$,B){if(!M||!U.normalized)return E;const x=$.getItemLabel(M);if(!x)return E;const j=$.getItemDescription(M);let H="",Q="";Array.isArray(U.values)?(H+=U.values.length,U.values.forEach(ye=>{Q+=ye.expectContiguousMatch})):Q+=U.expectContiguousMatch;let X;j?X=`${x}${j}${U.normalized}${H}${O}${Q}`:X=`${x}${U.normalized}${H}${O}${Q}`;const fe=B[X];if(fe)return fe;const _e=r(x,j,$.getItemPath(M),U,O);return B[X]=_e,_e}e.scoreItemFuzzy=t;function r(M,U,O,$,B){const x=!O||!$.containsPathSeparator;return O&&(k.isLinux?$.pathNormalized===O:(0,R.equalsIgnoreCase)($.pathNormalized,O))?{score:l,labelMatch:[{start:0,end:M.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:$.values&&$.values.length>1?s(M,U,O,$.values,x,B):i(M,U,O,$,x,B)}function s(M,U,O,$,B,x){let j=0;const H=[],Q=[];for(const X of $){const{score:fe,labelMatch:_e,descriptionMatch:ye}=i(M,U,O,X,B,x);if(fe===C)return E;j+=fe,_e&&H.push(..._e),ye&&Q.push(...ye)}return{score:j,labelMatch:u(H),descriptionMatch:u(Q)}}function i(M,U,O,$,B,x){if(B||!U){const[j,H]=P(M,$.normalized,$.normalizedLowercase,x&&!$.expectContiguousMatch);if(j){const Q=(0,L.matchesPrefix)($.normalized,M);let X;return Q?(X=a,X+=Math.round($.normalized.length/M.length*100)):X=p,{score:X+j,labelMatch:Q||g(H)}}}if(U){let j=U;O&&(j=`${U}${I.sep}`);const H=j.length,Q=`${j}${M}`,[X,fe]=P(Q,$.normalized,$.normalizedLowercase,x&&!$.expectContiguousMatch);if(X){const _e=g(fe),ye=[],Le=[];return _e.forEach(ze=>{ze.start<H&&ze.end>H?(ye.push({start:0,end:ze.end-H}),Le.push({start:ze.start,end:H})):ze.start>=H?ye.push({start:ze.start-H,end:ze.end-H}):Le.push(ze)}),{score:X,labelMatch:ye,descriptionMatch:Le}}}return E}function g(M){const U=[];if(!M)return U;let O;for(const $ of M)O&&O.end===$?O.end+=1:(O={start:$,end:$+1},U.push(O));return U}function u(M){const U=M.sort((B,x)=>B.start-x.start),O=[];let $;for(const B of U)!$||!d($,B)?($=B,O.push(B)):($.start=Math.min($.start,B.start),$.end=Math.max($.end,B.end));return O}function d(M,U){return!(M.end<U.start||U.end<M.start)}function w(M,U,O,$,B,x){const j=t(M,O,$,B,x),H=t(U,O,$,B,x),Q=j.score,X=H.score;if((Q===l||X===l)&&Q!==X)return Q===l?-1:1;if(Q>p||X>p){if(Q!==X)return Q>X?-1:1;if(Q<a&&X<a){const Ge=m(j.labelMatch,H.labelMatch);if(Ge!==0)return Ge}const ze=B.getItemLabel(M)||"",xe=B.getItemLabel(U)||"";if(ze.length!==xe.length)return ze.length-xe.length}if(Q!==X)return Q>X?-1:1;const fe=Array.isArray(j.labelMatch)&&j.labelMatch.length>0,_e=Array.isArray(H.labelMatch)&&H.labelMatch.length>0;if(fe&&!_e)return-1;if(_e&&!fe)return 1;const ye=D(M,j,B),Le=D(U,H,B);return ye&&Le&&ye!==Le?Le>ye?-1:1:S(M,U,O,B)}e.compareItemsByFuzzyScore=w;function D(M,U,O){let $=-1,B=-1;if(U.descriptionMatch&&U.descriptionMatch.length?$=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&($=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(B=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const x=O.getItemDescription(M);x&&(B+=x.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(B=U.descriptionMatch[U.descriptionMatch.length-1].end);return B-$}function m(M,U){if(!M&&!U||(!M||!M.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!M||!M.length)return 1;const O=M[0].start,B=M[M.length-1].end-O,x=U[0].start,H=U[U.length-1].end-x;return B===H?0:H<B?1:-1}function S(M,U,O,$){const B=$.getItemLabel(M)||"",x=$.getItemLabel(U)||"",j=$.getItemDescription(M),H=$.getItemDescription(U),Q=B.length+(j?j.length:0),X=x.length+(H?H.length:0);if(Q!==X)return Q-X;const fe=$.getItemPath(M),_e=$.getItemPath(U);return fe&&_e&&fe.length!==_e.length?fe.length-_e.length:B!==x?(0,f.compareAnything)(B,x,O.normalized):j&&H&&j!==H?(0,f.compareAnything)(j,H,O.normalized):fe&&_e&&fe!==_e?(0,f.compareAnything)(fe,_e,O.normalized):0}function b(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function N(M){typeof M!="string"&&(M="");const U=M.toLowerCase(),{pathNormalized:O,normalized:$,normalizedLowercase:B}=G(M),x=O.indexOf(I.sep)>=0,j=b(M);let H;const Q=M.split(F);if(Q.length>1)for(const X of Q){const fe=b(X),{pathNormalized:_e,normalized:ye,normalizedLowercase:Le}=G(X);ye&&(H||(H=[]),H.push({original:X,originalLowercase:X.toLowerCase(),pathNormalized:_e,normalized:ye,normalizedLowercase:Le,expectContiguousMatch:fe}))}return{original:M,originalLowercase:U,pathNormalized:O,normalized:$,normalizedLowercase:B,values:H,containsPathSeparator:x,expectContiguousMatch:j}}e.prepareQuery=N;function G(M){let U;k.isWindows?U=M.replace(/\//g,I.sep):U=M.replace(/\\/g,I.sep);const O=(0,R.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:O,normalizedLowercase:O.toLowerCase()}}function K(M){return Array.isArray(M)?N(M.map(U=>U.original).join(F)):N(M.original)}e.pieceToQuery=K}),define(me[30],ge([0,1,17,29,24,8,9]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",P="/",n="[/\\\\]",T="[^/\\\\]",c=/\//g;function h(x){switch(x){case 0:return"";case 1:return`${T}*?`;default:return`(?:${n}|${T}+${n}|${n}${T}+)*?`}}function o(x,j){if(!x)return[];const H=[];let Q=!1,X=!1,fe="";for(const _e of x){switch(_e){case j:if(!Q&&!X){H.push(fe),fe="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":X=!0;break;case"]":X=!1;break}fe+=_e}return fe&&H.push(fe),H}e.splitGlobAware=o;function v(x){if(!x)return"";let j="";const H=o(x,P);if(H.every(Q=>Q===y))j=".*";else{let Q=!1;H.forEach((X,fe)=>{if(X===y){Q||(j+=h(2),Q=!0);return}let _e=!1,ye="",Le=!1,ze="";for(const xe of X){if(xe!=="}"&&_e){ye+=xe;continue}if(Le&&(xe!=="]"||!ze)){let Ge;xe==="-"?Ge=xe:(xe==="^"||xe==="!")&&!ze?Ge="^":xe===P?Ge="":Ge=R.escapeRegExpCharacters(xe),ze+=Ge;continue}switch(xe){case"{":_e=!0;continue;case"[":Le=!0;continue;case"}":j+=`(?:${o(ye,",").map(ee=>v(ee)).join("|")})`,_e=!1,ye="";break;case"]":j+="["+ze+"]",Le=!1,ze="";break;case"?":j+=T;continue;case"*":j+=h(1);continue;default:j+=R.escapeRegExpCharacters(xe)}}fe<H.length-1&&(H[fe+1]!==y||fe+2<H.length)&&(j+=n),Q=!1})}return j}const _=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(x,j){if(!x)return s;let H;typeof x!="string"?H=x.pattern:H=x,H=H.trim();const Q=`${H}_${!!j.trimForExclusions}`;let X=t.get(Q);if(X)return g(X,x);let fe;if(_.test(H)){const _e=H.substr(4);X=function(ye,Le){return typeof ye=="string"&&ye.endsWith(_e)?H:null}}else(fe=A.exec(u(H,j)))?X=d(fe[1],H):(j.trimForExclusions?l:E).test(H)?X=w(H,j):(fe=a.exec(u(H,j)))?X=D(fe[1].substr(1),H,!0):(fe=p.exec(u(H,j)))?X=D(fe[1],H,!1):X=m(H);return t.set(Q,X),g(X,x)}function g(x,j){return typeof j=="string"?x:function(H,Q){return L.isEqualOrParent(H,j.base)?x(k.relative(j.base,H),Q):null}}function u(x,j){return j.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function d(x,j){const H=`/${x}`,Q=`\\${x}`,X=function(_e,ye){return typeof _e!="string"?null:ye?ye===x?j:null:_e===x||_e.endsWith(H)||_e.endsWith(Q)?j:null},fe=[x];return X.basenames=fe,X.patterns=[j],X.allBasenames=fe,X}function w(x,j){const H=B(x.slice(1,-1).split(",").map(ye=>i(ye,j)).filter(ye=>ye!==s),x),Q=H.length;if(!Q)return s;if(Q===1)return H[0];const X=function(ye,Le){for(let ze=0,xe=H.length;ze<xe;ze++)if(H[ze](ye,Le))return x;return null},fe=H.find(ye=>!!ye.allBasenames);fe&&(X.allBasenames=fe.allBasenames);const _e=H.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function D(x,j,H){const Q=k.sep===k.posix.sep,X=Q?x:x.replace(c,k.sep),fe=k.sep+X,_e=k.posix.sep+x,ye=H?function(Le,ze){return typeof Le=="string"&&(Le===X||Le.endsWith(fe)||!Q&&(Le===x||Le.endsWith(_e)))?j:null}:function(Le,ze){return typeof Le=="string"&&(Le===X||!Q&&Le===x)?j:null};return ye.allPaths=[(H?"*/":"./")+x],ye}function m(x){try{const j=new RegExp(`^${v(x)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?x:null}}catch(j){return s}}function S(x,j,H){return!x||typeof j!="string"?!1:b(x)(j,void 0,H)}e.match=S;function b(x,j={}){if(!x)return r;if(typeof x=="string"||K(x)){const H=i(x,j);if(H===s)return r;const Q=function(X,fe){return!!H(X,fe)};return H.allBasenames&&(Q.allBasenames=H.allBasenames),H.allPaths&&(Q.allPaths=H.allPaths),Q}return O(x,j)}e.parse=b;function F(x){if(!x)return;let j;return H=>(j||(j=(x()||Promise.resolve([])).then(Q=>Q?G(Q):{})),j.then(Q=>!!Q[H]))}e.hasSiblingPromiseFn=F;function N(x){if(!x)return;let j;return H=>{if(!j){const Q=x();j=Q?G(Q):{}}return!!j[H]}}e.hasSiblingFn=N;function G(x){const j={};for(const H of x)j[H]=!0;return j}function K(x){const j=x;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=K;function M(x){return x.allBasenames||[]}e.getBasenameTerms=M;function U(x){return x.allPaths||[]}e.getPathTerms=U;function O(x,j){const H=B(Object.getOwnPropertyNames(x).map(ye=>$(ye,x[ye],j)).filter(ye=>ye!==s)),Q=H.length;if(!Q)return s;if(!H.some(ye=>!!ye.requiresSiblings)){if(Q===1)return H[0];const ye=function(xe,Ge){for(let z=0,ee=H.length;z<ee;z++){const re=H[z](xe,Ge);if(re)return re}return null},Le=H.find(xe=>!!xe.allBasenames);Le&&(ye.allBasenames=Le.allBasenames);const ze=H.reduce((xe,Ge)=>Ge.allPaths?xe.concat(Ge.allPaths):xe,[]);return ze.length&&(ye.allPaths=ze),ye}const X=function(ye,Le,ze){let xe;for(let Ge=0,z=H.length;Ge<z;Ge++){const ee=H[Ge];ee.requiresSiblings&&ze&&(Le||(Le=k.basename(ye)),xe||(xe=Le.substr(0,Le.length-k.extname(ye).length)));const re=ee(ye,Le,xe,ze);if(re)return re}return null},fe=H.find(ye=>!!ye.allBasenames);fe&&(X.allBasenames=fe.allBasenames);const _e=H.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return _e.length&&(X.allPaths=_e),X}function $(x,j,H){if(j===!1)return s;const Q=i(x,H);if(Q===s)return s;if(typeof j=="boolean")return Q;if(j){const X=j.when;if(typeof X=="string"){const fe=(_e,ye,Le,ze)=>{if(!ze||!Q(_e,ye))return null;const xe=X.replace("$(basename)",Le),Ge=ze(xe);return(0,f.isThenable)(Ge)?Ge.then(z=>z?x:null):Ge?x:null};return fe.requiresSiblings=!0,fe}}return Q}function B(x,j){const H=x.filter(ye=>!!ye.basenames);if(H.length<2)return x;const Q=H.reduce((ye,Le)=>{const ze=Le.basenames;return ze?ye.concat(ze):ye},[]);let X;if(j){X=[];for(let ye=0,Le=Q.length;ye<Le;ye++)X.push(j)}else X=H.reduce((ye,Le)=>{const ze=Le.patterns;return ze?ye.concat(ze):ye},[]);const fe=function(ye,Le){if(typeof ye!="string")return null;if(!Le){let xe;for(xe=ye.length;xe>0;xe--){const Ge=ye.charCodeAt(xe-1);if(Ge===47||Ge===92)break}Le=ye.substr(xe)}const ze=Q.indexOf(Le);return ze!==-1?X[ze]:null};fe.basenames=Q,fe.patterns=X,fe.allBasenames=Q;const _e=x.filter(ye=>!ye.basenames);return _e.push(fe),_e}}),define(me[80],ge([0,1,29,10,8,11,22,9,2]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,g,u){if(typeof i=="string"&&(i=y.URI.file(i)),u){const w=u.getWorkspaceFolder(i);if(w){const D=u.getWorkspace().folders.length>1;let m;if((0,R.isEqual)(w.uri,i)?m="":m=(0,R.relativePath)(w.uri,i),D){const S=w.name?w.name:(0,R.basename)(w.uri);m=m?S+" \u2022 "+m:S}return m}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,I.normalize)(T(i.fsPath));let d=(0,I.normalize)(i.fsPath);return!k.isWindows&&g?.userHome&&(d=h(d,g.userHome.fsPath)),d}e.getPathLabel=P;function n(i){if(!i)return;typeof i=="string"&&(i=y.URI.file(i));const g=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,f.isRootOrDriveLetter)(g)?T(g):g}e.getBaseLabel=n;function T(i){return(0,f.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=T;let c=Object.create(null);function h(i,g){if(k.isWindows||!i||!g)return i;let u=c.original===g?c.normalized:void 0;return u||(u=`${(0,C.rtrim)(g,I.posix.sep)}${I.posix.sep}`,c={original:g,normalized:u}),(k.isLinux?i.startsWith(u):(0,C.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=h;function o(i,g){return i.replace(/^~($|\/|\\)/,`${g}$1`)}e.untildify=o;const v="\u2026",_="\\\\",A="~";function E(i,g=I.sep){const u=new Array(i.length);let d=!1;for(let w=0;w<i.length;w++){let D=i[w];if(D===""){u[w]=`.${g}`;continue}if(!D){u[w]=D;continue}d=!0;let m="";D.indexOf(_)===0?(m=D.substr(0,D.indexOf(_)+_.length),D=D.substr(D.indexOf(_)+_.length)):D.indexOf(g)===0?(m=D.substr(0,D.indexOf(g)+g.length),D=D.substr(D.indexOf(g)+g.length)):D.indexOf(A)===0&&(m=D.substr(0,D.indexOf(A)+A.length),D=D.substr(D.indexOf(A)+A.length));const S=D.split(g);for(let b=1;d&&b<=S.length;b++)for(let F=S.length-b;d&&F>=0;F--){d=!1;let N=S.slice(F,F+b).join(g);for(let G=0;!d&&G<i.length;G++)if(G!==w&&i[G]&&i[G].indexOf(N)>-1){const K=F+b===S.length,M=F>0&&i[G].indexOf(g)>-1?g+N:N,U=i[G].endsWith(M);d=!K||U}if(!d){let G="";(S[0].endsWith(":")||m!=="")&&(F===1&&(F=0,b++,N=S[0]+g+N),F>0&&(G=S[0]+g),G=m+G),F>0&&(G=G+v+g),G=G+N,F+b<S.length&&(G=G+g+v),u[w]=G}}d&&(u[w]=D)}return u}e.shorten=E;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function a(i,g=Object.create(null)){const u=[];let d=!1,w="";for(const D of i)if(D==="$"||d&&D==="{")w&&u.push({value:w,type:l.TEXT}),w="",d=!0;else if(D==="}"&&d){const m=g[w];if(typeof m=="string")m.length&&u.push({value:m,type:l.VARIABLE});else if(m){const S=u[u.length-1];(!S||S.type!==l.SEPARATOR)&&u.push({value:m.label,type:l.SEPARATOR})}w="",d=!1}else w+=D;return w&&!d&&u.push({value:w,type:l.TEXT}),u.filter((D,m)=>{if(D.type===l.SEPARATOR){const S=u[m-1],b=u[m+1];return[S,b].every(F=>F&&(F.type===l.VARIABLE||F.type===l.TEXT)&&F.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=a;function p(i,g){return k.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,g){return k.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const g=i.indexOf("/")!==-1?I.posix:I.win32,u=g.basename(i),d=g.dirname(i);return u.length?{name:u,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(me[102],ge([0,1,30,10,8,22,9]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let y=[],P=[],n=[];function T(i,g=!1){const u=c(i);y.push(u),u.userConfigured?n.push(u):P.push(u),g&&!u.userConfigured&&y.forEach(d=>{d.mime===u.mime||d.userConfigured||(u.extension&&d.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&d.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&d.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&d.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=T;function c(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,f.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(I.posix.sep)>=0:!1}}function h(i){i?(y=y.filter(g=>!g.userConfigured),n=[]):(y=[],P=[],n=[])}e.clearTextMimes=h;function o(i,g){let u;if(i)switch(i.scheme){case L.Schemas.file:u=i.fsPath;break;case L.Schemas.data:u=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:u=i.path}if(!u)return[C.unknown];u=u.toLowerCase();const d=(0,I.basename)(u),w=v(u,d,n);if(w)return[w,C.text];const D=v(u,d,P);if(D)return[D,C.text];if(g){const m=_(g);if(m)return[m,C.text]}return[C.unknown]}e.guessMimeTypes=o;function v(i,g,u){let d=null,w=null,D=null;for(let m=u.length-1;m>=0;m--){const S=u[m];if(g===S.filenameLowercase){d=S;break}if(S.filepattern&&(!w||S.filepattern.length>w.filepattern.length)){const b=S.filepatternOnPath?i:g;S.filepatternLowercase?.(b)&&(w=S)}S.extension&&(!D||S.extension.length>D.extension.length)&&g.endsWith(S.extensionLowercase)&&(D=S)}return d?d.mime:w?w.mime:D?D.mime:null}function _(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let g=y.length-1;g>=0;g--){const u=y[g];if(!u.firstline)continue;const d=i.match(u.firstline);if(d&&d.length>0)return u.mime}return null}function A(i){return i?typeof i=="string"?i===C.binary||i===C.text||i===C.unknown:i.length===1&&A(i[0]):!0}e.isUnspecific=A;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(i){const g=(0,I.extname)(i),u=E[g.toLowerCase()];return u!==void 0?u:p(i)}e.getMediaOrTextMime=a;function p(i){const g=(0,I.extname)(i);return l[g.toLowerCase()]}e.getMediaMime=p;function t(i){for(const g in l)if(l[g]===i)return g}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function s(i,g){const u=r.exec(i);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:g?void 0:i}e.normalizeMimeType=s}),define(me[103],ge([0,1,2]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class I{constructor(T){this._uriTransformer=T}transformIncoming(T){const c=this._uriTransformer.transformIncoming(T);return c===T?T:L(f.URI.from(c))}transformOutgoing(T){const c=this._uriTransformer.transformOutgoing(T);return c===T?T:L(f.URI.from(c))}transformOutgoingURI(T){const c=this._uriTransformer.transformOutgoing(T);return c===T?T:f.URI.from(c)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,T,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof f.URI)return T.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const o=k(n[h],T,c+1);o!==null&&(n[h]=o)}}return null}function R(n,T){const c=k(n,T,0);return c===null?n:c}e.transformOutgoingURIs=R;function C(n,T,c,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?f.URI.revive(T.transformIncoming(n)):T.transformIncoming(n);for(let o in n)if(Object.hasOwnProperty.call(n,o)){const v=C(n[o],T,c,h+1);v!==null&&(n[o]=v)}}return null}function y(n,T){const c=C(n,T,!1,0);return c===null?n:c}e.transformIncomingURIs=y;function P(n,T){const c=C(n,T,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=P}),define(me[33],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return f.test(y)}e.isUUID=L;const I=new Uint8Array(16),k=[];for(let y=0;y<256;y++)k.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function C(){R(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,P="";return P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P+="-",P+=k[I[y++]],P+=k[I[y++]],P+="-",P+=k[I[y++]],P+=k[I[y++]],P+="-",P+=k[I[y++]],P+=k[I[y++]],P+="-",P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P+=k[I[y++]],P}e.generateUuid=C}),define(me[142],ge([0,1,104]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new f.StringDecoder(k),this.remaining=null}write(k){const R=[],C=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(C.length<1)return R;let y=0,P,n=y;for(;n<C.length;)if(P=C.charCodeAt(n),P===13||P===10){if(R.push(C.substring(y,n)),n++,n<C.length){const T=P;P=C.charCodeAt(n),(T===13&&P===10||T===10&&P===13)&&n++}y=n}else n++;return this.remaining=y<C.length?C.substr(y):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,49,60,293,17,29,79,8,11,22,2,33]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function o(M,U=h.UNLINK){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return U===h.UNLINK?_(M):v(M)}async function v(M){try{const U=(0,y.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(M,U)}catch(O){return _(M)}_(U).catch(O=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function A(M){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(M,{recursive:!0})}e.rimrafSync=A;async function E(M,U){return p(await(U?l(M):(0,I.promisify)(f.readdir)(M)))}async function l(M){try{return await(0,I.promisify)(f.readdir)(M,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const U=[],O=await E(M);for(const $ of O){let B=!1,x=!1,j=!1;try{const H=await e.Promises.lstat((0,y.join)(M,$));B=H.isFile(),x=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}U.push({name:$,isFile:()=>B,isDirectory:()=>x,isSymbolicLink:()=>j})}return U}function a(M){return p(f.readdirSync(M))}e.readdirSync=a;function p(M){return M.map(U=>typeof U=="string"?P.isMacintosh?(0,C.normalizeNFC)(U):U:(U.name=P.isMacintosh?(0,C.normalizeNFC)(U.name):U.name,U))}async function t(M){const U=await E(M),O=[];for(const $ of U)await s.existsDirectory((0,y.join)(M,$))&&O.push($);return O}function r(M,U=1e3){return new Promise(O=>{let $=!1;const B=setInterval(()=>{$||($=!0,f.access(M,x=>{$=!1,x&&(clearInterval(B),O(void 0))}))},U)})}e.whenDeleted=r;var s;(function(M){async function U(B){let x;try{if(x=await e.Promises.lstat(B),!x.isSymbolicLink())return{stat:x}}catch(j){}try{return{stat:await e.Promises.stat(B),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(P.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=U;async function O(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isFile()&&j?.dangling!==!0}catch(x){}return!1}M.existsFile=O;async function $(B){try{const{stat:x,symbolicLink:j}=await M.stat(B);return x.isDirectory()&&j?.dangling!==!0}catch(x){}return!1}M.existsDirectory=$})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function g(M,U,O){return i.queueFor(T.URI.file(M),n.extUriBiasedIgnorePathCase).queue(()=>{const $=D(O);return new Promise((B,x)=>d(M,U,$,j=>j?x(j):B()))})}let u=!0;function d(M,U,O,$){if(!u)return f.writeFile(M,U,{mode:O.mode,flag:O.flag},$);f.open(M,O.flag,O.mode,(B,x)=>{if(B)return $(B);f.writeFile(x,U,j=>{if(j)return f.close(x,()=>$(j));f.fdatasync(x,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),u=!1),f.close(x,Q=>$(Q))))})})}function w(M,U,O){const $=D(O);if(!u)return f.writeFileSync(M,U,{mode:$.mode,flag:$.flag});const B=f.openSync(M,$.flag,$.mode);try{f.writeFileSync(B,U);try{f.fdatasyncSync(B)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),u=!1}}finally{f.closeSync(B)}}e.writeFileSync=w;function D(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function m(M,U){if(M===U)return;async function O($){try{const B=await e.Promises.lstat($);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes($,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(M,U),await O(U)}catch($){if(M.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||M.endsWith("."))await S(M,U,{preserveSymlinks:!1}),await o(M,h.MOVE),await O(U);else throw $}}async function S(M,U,O){return F(M,U,{root:{source:M,target:U},options:O,handledSourcePaths:new Set})}const b=511;async function F(M,U,O){if(O.handledSourcePaths.has(M))return;O.handledSourcePaths.add(M);const{stat:$,symbolicLink:B}=await s.stat(M);if(B){if(O.options.preserveSymlinks)try{return await K(M,U,O)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(B.dangling)return}return $.isDirectory()?N(M,U,$.mode&b,O):G(M,U,$.mode&b)}async function N(M,U,O,$){await e.Promises.mkdir(U,{recursive:!0,mode:O});const B=await E(M);for(const x of B)await F((0,y.join)(M,x),(0,y.join)(U,x),$)}async function G(M,U,O){await e.Promises.copyFile(M,U),await e.Promises.chmod(U,O)}async function K(M,U,O){let $=await e.Promises.readlink(M);(0,R.isEqualOrParent)($,O.root.source,!P.isLinux)&&($=(0,y.join)(O.root.target,$.substr(O.root.source.length+1))),await e.Promises.symlink($,U)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(0,I.promisify)(f.read)}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(0,I.promisify)(f.write)}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return g}get rm(){return o}get move(){return m}get copy(){return S}}}),define(me[105],ge([0,1,49,8,9,28]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const T=(0,L.dirname)(n);if(n===T)return n;const c=((0,L.basename)(n)||n).toLowerCase();try{const o=(0,k.readdirSync)(T).filter(v=>v.toLowerCase()===c);if(o.length===1){const v=R(T);if(v)return(0,L.join)(v,o[0])}else if(o.length>1){const v=o.indexOf(c);if(v>=0){const _=R(T);if(_)return(0,L.join)(_,o[v])}}}catch(h){}return null}e.realcaseSync=R;async function C(n){try{return await k.Promises.realpath(n)}catch(T){const c=P(n);return await k.Promises.access(c,f.constants.R_OK),c}}e.realpath=C;function y(n){try{return f.realpathSync(n)}catch(T){const c=P(n);return f.accessSync(c,f.constants.R_OK),c}}e.realpathSync=y;function P(n){return(0,I.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(J,e,f,L){var I=arguments.length,k=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,f):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,f,L);else for(var C=J.length-1;C>=0;C--)(R=J[C])&&(k=(I<3?R(k):I>3?R(e,f,k):R(e,f))||k);return I>3&&k&&Object.defineProperty(e,f,k),k};define(me[106],ge([0,1,20,17,23,21,56,16,3,6,59,9,13]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function o(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(A||(A={}));class E{constructor(x){this.buffer=x,this.pos=0}read(x){const j=this.buffer.slice(this.pos,this.pos+x);return this.pos+=j.byteLength,j}}class l{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(a||(a={}));function p(B){const x=I.VSBuffer.alloc(4);return x.writeUInt32BE(B,0),x}function t(B){return B.read(4).readUInt32BE(0)}function r(B){const x=I.VSBuffer.alloc(1);return x.writeUInt8(B,0),x}const s={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},i=typeof Buffer!="undefined";function g(B,x){if(typeof x=="undefined")B.write(s.Undefined);else if(typeof x=="string"){const j=I.VSBuffer.fromString(x);B.write(s.String),B.write(p(j.byteLength)),B.write(j)}else if(i&&Buffer.isBuffer(x)){const j=I.VSBuffer.wrap(x);B.write(s.Buffer),B.write(p(j.byteLength)),B.write(j)}else if(x instanceof I.VSBuffer)B.write(s.VSBuffer),B.write(p(x.byteLength)),B.write(x);else if(Array.isArray(x)){B.write(s.Array),B.write(p(x.length));for(const j of x)g(B,j)}else{const j=I.VSBuffer.fromString(JSON.stringify(x));B.write(s.Object),B.write(p(j.byteLength)),B.write(j)}}function u(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(t(B)).toString();case a.Buffer:return B.read(t(B)).buffer;case a.VSBuffer:return B.read(t(B));case a.Array:{const j=t(B),H=[];for(let Q=0;Q<j;Q++)H.push(u(B));return H}case a.Object:return JSON.parse(B.read(t(B)).toString())}}class d{constructor(x,j,H=null,Q=1e3){this.protocol=x,this.ctx=j,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(x,j){this.channels.set(x,j),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const j=this.send([x.type]);this.logger&&this.logger.logOutgoing(j,0,1,_(x.type));return}case 201:case 202:case 204:case 203:{const j=this.send([x.type,x.id],x.data);this.logger&&this.logger.logOutgoing(j,x.id,1,_(x.type),x.data);return}}}send(x,j=void 0){const H=new l;return g(H,x),g(H,j),this.sendBuffer(H.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(j){return 0}}onRawMessage(x){const j=new E(x),H=u(j),Q=u(j),X=H[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${o(X)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:X,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${o(X)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:X,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${o(X)}`),this.disposeActiveRequest({type:X,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],1,`${o(X)}`),this.disposeActiveRequest({type:X,id:H[1]})}}onPromise(x){const j=this.channels.get(x.channelName);if(!j){this.collectPendingRequest(x);return}const H=new k.CancellationTokenSource;let Q;try{Q=j.call(this.ctx,x.name,x.arg,H.token)}catch(_e){Q=Promise.reject(_e)}const X=x.id;Q.then(_e=>{this.sendResponse({id:X,data:_e,type:201}),this.activeRequests.delete(x.id)},_e=>{_e instanceof Error?this.sendResponse({id:X,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:X,data:_e,type:203}),this.activeRequests.delete(x.id)});const fe=(0,P.toDisposable)(()=>H.cancel());this.activeRequests.set(x.id,fe)}onEventListen(x){const j=this.channels.get(x.channelName);if(!j){this.collectPendingRequest(x);return}const H=x.id,X=j.listen(this.ctx,x.name,x.arg)(fe=>this.sendResponse({id:H,data:fe,type:204}));this.activeRequests.set(x.id,X)}disposeActiveRequest(x){const j=this.activeRequests.get(x.id);j&&(j.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let j=this.pendingRequests.get(x.channelName);j||(j=[],this.pendingRequests.set(x.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:x,timeoutTimer:H})}flushPendingRequests(x){const j=this.pendingRequests.get(x);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var w;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(x,j=null){this.protocol=x,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(x){const j=this;return{call(H,Q,X){return j.isDisposed?Promise.reject(C.canceled()):j.requestPromise(x,H,Q,X)},listen(H,Q){return j.isDisposed?Promise.reject(C.canceled()):j.requestEvent(x,H,Q)}}}requestPromise(x,j,H,Q=k.CancellationToken.None){const X=this.lastRequestId++,_e={id:X,type:100,channelName:x,name:j,arg:H};if(Q.isCancellationRequested)return Promise.reject(C.canceled());let ye;return new Promise((ze,xe)=>{if(Q.isCancellationRequested)return xe(C.canceled());const Ge=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(X),ze(Y.data);break;case 202:this.handlers.delete(X);const oe=new Error(Y.data.message);oe.stack=Y.data.stack,oe.name=Y.data.name,xe(oe);break;case 203:this.handlers.delete(X),xe(Y.data);break}};this.handlers.set(X,ae),this.sendRequest(_e)};let z=null;this.state===A.Idle?Ge():(z=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),z.then(()=>{z=null,Ge()}));const ee=()=>{z?(z.cancel(),z=null):this.sendRequest({id:X,type:101}),xe(C.canceled())},re=Q.onCancellationRequested(ee);ye=(0,P.combinedDisposable)((0,P.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(x,j,H){const Q=this.lastRequestId++,fe={id:Q,type:102,channelName:x,name:j,arg:H};let _e=null;const ye=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(ze=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(fe)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:Q,type:103}))}}),Le=ze=>ye.fire(ze.data);return this.handlers.set(Q,Le),ye.event}sendRequest(x){switch(x.type){case 100:case 102:{const j=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(j,x.id,0,`${o(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const j=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(j,x.id,0,o(x.type));return}}}send(x,j=void 0){const H=new l;return g(H,x),g(H,j),this.sendBuffer(H.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(j){return 0}}onBuffer(x){const j=new E(x),H=u(j),Q=u(j),X=H[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,_(X)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,H[1],0,_(X),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(x){if(x.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(x.id);j&&j(x)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}Ve([R.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class m{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:j,onDidClientDisconnect:H})=>{y.Event.once(j.onMessage)(X=>{const fe=new E(X),_e=u(fe),ye=new d(j,_e),Le=new D(j);this.channels.forEach((xe,Ge)=>ye.registerChannel(Ge,xe));const ze={channelServer:ye,channelClient:Le,ctx:_e};this._connections.add(ze),this._onDidAddConnection.fire(ze),H(()=>{ye.dispose(),Le.dispose(),this._connections.delete(ze),this._onDidRemoveConnection.fire(ze)})})})}get connections(){const x=[];return this._connections.forEach(j=>x.push(j)),x}getChannel(x,j){const H=this;return{call(Q,X,fe){let _e;if((0,c.isFunction)(j)){let Le=(0,f.getRandomElement)(H.connections.filter(j));_e=Le?Promise.resolve(Le):y.Event.toPromise(y.Event.filter(H.onDidAddConnection,j))}else _e=j.routeCall(H,Q,X);const ye=_e.then(Le=>Le.channelClient.getChannel(x));return b(ye).call(Q,X,fe)},listen(Q,X){if((0,c.isFunction)(j))return H.getMulticastEvent(x,j,Q,X);const fe=j.routeEvent(H,Q,X).then(_e=>_e.channelClient.getChannel(x));return b(fe).listen(Q,X)}}}getMulticastEvent(x,j,H,Q){const X=this;let fe=new P.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{fe=new P.DisposableStore;const ye=new y.EventMultiplexer,Le=new Map,ze=Ge=>{const ee=Ge.channelClient.getChannel(x).listen(H,Q),re=ye.add(ee);Le.set(Ge,re)},xe=Ge=>{const z=Le.get(Ge);!z||(z.dispose(),Le.delete(Ge))};X.connections.filter(j).forEach(ze),y.Event.filter(X.onDidAddConnection,j)(ze,void 0,fe),X.onDidRemoveConnection(xe,void 0,fe),ye.event(_e.fire,_e,fe),fe.add(ye)},onLastListenerRemove:()=>{fe.dispose()}});return _e.event}registerChannel(x,j){this.channels.set(x,j),this._connections.forEach(H=>{H.channelServer.registerChannel(x,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class S{constructor(x,j,H=null){const Q=new l;g(Q,j),x.send(Q.buffer),this.channelClient=new D(x,H),this.channelServer=new d(x,j,H)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,j){this.channelServer.registerChannel(x,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=S;function b(B){return{call(x,j,H){return B.then(Q=>Q.call(x,j,H))},listen(x,j){const H=new y.Relay;return B.then(Q=>H.input=Q.listen(x,j)),H.event}}}e.getDelayedChannel=b;function F(B){let x=!1;return{call(j,H,Q){return x?B.call(j,H,Q):(0,L.timeout)(0).then(()=>x=!0).then(()=>B.call(j,H,Q))},listen(j,H){if(x)return B.listen(j,H);const Q=new y.Relay;return(0,L.timeout)(0).then(()=>x=!0).then(()=>Q.input=B.listen(j,H)),Q.event}}}e.getNextTickChannel=F;class N{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const j of x.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await y.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=N;var G;(function(B){function x(Q,X){const fe=Q,_e=X&&X.disableMarshalling,ye=new Map;for(const Le in fe)H(Le)&&ye.set(Le,y.Event.buffer(fe[Le],!0));return new class{listen(Le,ze){const xe=ye.get(ze);if(xe)return xe;throw new Error(`Event not found: ${ze}`)}call(Le,ze,xe){const Ge=fe[ze];if(typeof Ge=="function"){if(!_e&&Array.isArray(xe))for(let z=0;z<xe.length;z++)xe[z]=(0,n.revive)(xe[z]);return Ge.apply(fe,xe)}throw new Error(`Method not found: ${ze}`)}}}B.fromService=x;function j(Q,X){const fe=X&&X.disableMarshalling;return new Proxy({},{get(_e,ye){if(typeof ye=="string")return X?.properties?.has(ye)?X.properties.get(ye):H(ye)?Q.listen(ye):async function(...Le){let ze;X&&!(0,c.isUndefinedOrNull)(X.context)?ze=[X.context,...Le]:ze=Le;const xe=await Q.call(ye,ze);return fe?xe:(0,n.revive)(xe)};throw new Error(`Property not found: ${String(ye)}`)}})}B.toService=j;function H(Q){return Q[0]==="o"&&Q[1]==="n"&&T.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let x=B.toString();if(x!=="[object Object]")return x}return B}function U(B){return Array.isArray(B)?B.map(M):M(B)}function O(B,x,j,H,Q,X,fe){fe=U(fe);const _e=K[Q],ye=_e[H%_e.length];let Le=[`%c[${B}]%c[${String(x).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(X)?(Le=Le.concat(fe),Le.push(")")):Le.push(fe),console.log.apply(console,Le)}e.logWithColors=O;class ${constructor(x,j){this._outgoingPrefix=x,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,j,H,Q,X){this._totalOutgoing+=x,O(this._outgoingPrefix,this._totalOutgoing,x,j,H,Q,X)}logIncoming(x,j,H,Q,X){this._totalIncoming+=x,O(this._incomingPrefix,this._totalIncoming,x,j,H,Q,X)}}e.IPCLogger=$}),define(me[107],ge([0,1,23,3,6,11,32,106]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function n(){return P||(P=f.VSBuffer.alloc(0)),P}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,g){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const D=this._chunks[0];return g&&(this._chunks.shift(),this._totalLength-=i),D}if(this._chunks[0].byteLength>i){const D=this._chunks[0].slice(0,i);return g&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),D}let u=f.VSBuffer.alloc(i),d=0,w=0;for(;i>0;){const D=this._chunks[w];if(D.byteLength>i){const m=D.slice(0,i);u.set(m,d),d+=i,g&&(this._chunks[w]=D.slice(i),this._totalLength-=i),i-=i}else u.set(D,d),d+=D.byteLength,g?(this._chunks.shift(),this._totalLength-=D.byteLength):w++,i-=D.byteLength}return u}}e.ChunkStream=T;var c;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(i,g,u,d){this.type=i,this.id=g,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const g=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=g.readUInt32BE(9),this._state.messageType=g.readUInt8(0),this._state.id=g.readUInt32BE(1),this._state.ack=g.readUInt32BE(5);else{const u=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new o(u,d,w,g)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=f.VSBuffer.alloc(13);g.writeUInt8(i.type,0),g.writeUInt32BE(i.id,1),g.writeUInt32BE(i.ack,5),g.writeUInt32BE(i.data.byteLength,9),this._writeSoon(g,i.data)}_bufferAdd(i,g){const u=this._totalLength===0;return this._data.push(i,g),this._totalLength+=i.byteLength+g.byteLength,u}_bufferTake(){const i=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,g){this._bufferAdd(i,g)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class A extends I.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(g=>{g.type===1&&this._onMessage.fire(g.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new o(1,0,0,i))}}e.Protocol=A;class E extends C.IPCClient{constructor(i,g,u=null){super(i,g,u);this.protocol=i}static fromSocket(i,g){return new E(new A(i),g)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=E;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class a{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],g=0,u=this._first;for(;u;)i[g++]=u.data,u=u.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const g=new a(i);if(!this._first){this._first=g,this._last=g;return}this._last.next=g,this._last=g}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let g=0;g<t._HISTORY_LENGTH;g++)this.lastRuns[g]=i-1e3*g;setInterval(()=>{for(let g=t._HISTORY_LENGTH;g>=1;g--)this.lastRuns[g]=this.lastRuns[g-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),g=(1+t._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<t._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=g&&u++;return 1-u/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(i,g=null,u=t.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),g&&this._socketReader.acceptChunk(g),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new o(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const g=new o(4,0,0,n());this._socketWriter.write(g),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,g){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(g)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let g=0,u=i.length;g<u;g++)this._socketWriter.write(i[g]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const g=this._outgoingUnackMsg.peek();if(g&&g.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const g=Date.now();g-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=g,this._socketWriter.write(new o(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const g=this._outgoingUnackMsg.toArray();for(let u=0,d=g.length;u<d;u++)this._socketWriter.write(g[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const g=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new o(1,g,this._incomingAckId,i);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(i){const g=new o(2,0,0,i);this._socketWriter.write(g)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),g=Date.now()-i.writtenTime;if(g>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-g,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new o(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let y=(0,f.toUint8)(C);this._defaultValue=y,this._asciiMap=L._createAsciiMap(y),this._map=new Map}static _createAsciiMap(C){let y=new Uint8Array(256);for(let P=0;P<256;P++)y[P]=C;return y}set(C,y){let P=(0,f.toUint8)(y);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(I||(I={}));class k{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=k}),define(me[143],ge([0,1,108]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(C){super(0);for(let y=0,P=C.length;y<P;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function k(R){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=R(y)),C[y])}e.getMapForWordSeparators=k(R=>new I(R))}),define(me[50],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,k){this.lineNumber=I,this.column=k}with(I=this.lineNumber,k=this.column){return I===this.lineNumber&&k===this.column?this:new f(I,k)}delta(I=0,k=0){return this.with(this.lineNumber+I,this.column+k)}equals(I){return f.equals(this,I)}static equals(I,k){return!I&&!k?!0:!!I&&!!k&&I.lineNumber===k.lineNumber&&I.column===k.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<k.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,k){return I.lineNumber<k.lineNumber?!0:k.lineNumber<I.lineNumber?!1:I.column<=k.column}static compare(I,k){let R=I.lineNumber|0,C=k.lineNumber|0;if(R===C){let y=I.column|0,P=k.column|0;return y-P}return R-C}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(me[41],ge([0,1,50]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(k,R,C,y){k>C||k===C&&R>y?(this.startLineNumber=C,this.startColumn=y,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=C,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return L.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}containsRange(k){return L.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return L.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return L.plusRange(this,k)}static plusRange(k,R){let C,y,P,n;return R.startLineNumber<k.startLineNumber?(C=R.startLineNumber,y=R.startColumn):R.startLineNumber===k.startLineNumber?(C=R.startLineNumber,y=Math.min(R.startColumn,k.startColumn)):(C=k.startLineNumber,y=k.startColumn),R.endLineNumber>k.endLineNumber?(P=R.endLineNumber,n=R.endColumn):R.endLineNumber===k.endLineNumber?(P=R.endLineNumber,n=Math.max(R.endColumn,k.endColumn)):(P=k.endLineNumber,n=k.endColumn),new L(C,y,P,n)}intersectRanges(k){return L.intersectRanges(this,k)}static intersectRanges(k,R){let C=k.startLineNumber,y=k.startColumn,P=k.endLineNumber,n=k.endColumn,T=R.startLineNumber,c=R.startColumn,h=R.endLineNumber,o=R.endColumn;return C<T?(C=T,y=c):C===T&&(y=Math.max(y,c)),P>h?(P=h,n=o):P===h&&(n=Math.min(n,o)),C>P||C===P&&y>n?null:new L(C,y,P,n)}equalsRange(k){return L.equalsRange(this,k)}static equalsRange(k,R){return!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(k){return new f.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(k){return new f.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new L(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new L(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(k){return new L(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,R=k){return new L(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new L(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const P=k.startLineNumber|0,n=R.startLineNumber|0;if(P===n){const T=k.startColumn|0,c=R.startColumn|0;if(T===c){const h=k.endLineNumber|0,o=R.endLineNumber|0;if(h===o){const v=k.endColumn|0,_=R.endColumn|0;return v-_}return h-o}return T-c}return P-n}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=L}),define(me[144],ge([0,1,50,41]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class k extends L.Range{constructor(C,y,P,n){super(C,y,P,n);this.selectionStartLineNumber=C,this.selectionStartColumn=y,this.positionLineNumber=P,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return k.selectionsEqual(this,C)}static selectionsEqual(C,y){return C.selectionStartLineNumber===y.selectionStartLineNumber&&C.selectionStartColumn===y.selectionStartColumn&&C.positionLineNumber===y.positionLineNumber&&C.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,y){return this.getDirection()===0?new k(this.startLineNumber,this.startColumn,C,y):new k(C,y,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,y){return this.getDirection()===0?new k(C,y,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,C,y)}static fromPositions(C,y=C){return new k(C.lineNumber,C.column,y.lineNumber,y.column)}static liftSelection(C){return new k(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,y){if(C&&!y||!C&&y)return!1;if(!C&&!y)return!0;if(C.length!==y.length)return!1;for(let P=0,n=C.length;P<n;P++)if(!this.selectionsEqual(C[P],y[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,y,P,n,T){return T===0?new k(C,y,P,n):new k(P,n,C,y)}}e.Selection=k}),define(me[109],ge([0,1,25]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(_,A){this._findMatchBrand=void 0,this.range=_,this.matches=A}}e.FindMatch=P;var n;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(T=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class h{constructor(_,A,E,l,a,p){this.identifier=_,this.range=A,this.text=E,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=a,this._isTracked=p}}e.ValidAnnotatedEditOperation=h;class o{constructor(_,A,E){this.reverseEdits=_,this.changes=A,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=o}),define(me[145],ge([0,1,9,143,50,41,109]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(l,a,p,t){this.searchString=l,this.isRegex=a,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=P(this.searchString):l=this.searchString.indexOf(`
`)>=0;let a=null;try{a=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let p=!this.isRegex&&!l;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(a,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=y;function P(E){if(!E||E.length===0)return!1;for(let l=0,a=E.length;l<a;l++)if(E.charCodeAt(l)===92){if(l++,l>=a)break;const t=E.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class n{constructor(l,a,p){this.regex=l,this.wordSeparators=a,this.simpleSearch=p}}e.SearchData=n;function T(E,l,a){if(!a)return new R.FindMatch(E,null);let p=[];for(let t=0,r=l.length;t<r;t++)p[t]=l[t];return new R.FindMatch(E,p)}e.createFindMatch=T;class c{constructor(l){let a=[],p=0;for(let t=0,r=l.length;t<r;t++)l.charCodeAt(t)===10&&(a[p++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(l){const a=this._lineFeedsOffsets;let p=0,t=a.length-1;if(t===-1||l<=a[0])return 0;for(;p<t;){const r=p+((t-p)/2>>0);a[r]>=l?t=r-1:a[r+1]>=l?(p=r,t=r):p=r+1}return p+1}}class h{static findMatches(l,a,p,t,r){const s=a.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,p,new A(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(l,p,s,t,r):[]}static _getMultilineMatchRange(l,a,p,t,r,s){let i,g=0;t?(g=t.findLineFeedCountBeforeOffset(r),i=a+r+g):i=a+r;let u;if(t){let m=t.findLineFeedCountBeforeOffset(r+s.length)-g;u=i+s.length+m}else u=i+s.length;const d=l.getPositionAt(i),w=l.getPositionAt(u);return new k.Range(d.lineNumber,d.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,a,p,t,r){const s=l.getOffsetAt(a.getStartPosition()),i=l.getValueInRange(a,1),g=l.getEOL()===`\r
`?new c(i):null,u=[];let d=0,w;for(p.reset(0);w=p.next(i);)if(u[d++]=T(this._getMultilineMatchRange(l,s,i,g,w.index,w[0]),w,t),d>=r)return u;return u}static _doFindMatchesLineByLine(l,a,p,t,r){const s=[];let i=0;if(a.startLineNumber===a.endLineNumber){const u=l.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return i=this._findMatchesInLine(p,u,a.startLineNumber,a.startColumn-1,i,s,t,r),s}const g=l.getLineContent(a.startLineNumber).substring(a.startColumn-1);i=this._findMatchesInLine(p,g,a.startLineNumber,a.startColumn-1,i,s,t,r);for(let u=a.startLineNumber+1;u<a.endLineNumber&&i<r;u++)i=this._findMatchesInLine(p,l.getLineContent(u),u,0,i,s,t,r);if(i<r){const u=l.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);i=this._findMatchesInLine(p,u,a.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(l,a,p,t,r,s,i,g){const u=l.wordSeparators;if(!i&&l.simpleSearch){const D=l.simpleSearch,m=D.length,S=a.length;let b=-m;for(;(b=a.indexOf(D,b+m))!==-1;)if((!u||_(u,a,S,b,m))&&(s[r++]=new R.FindMatch(new k.Range(p,b+1+t,p,b+1+m+t),null),r>=g))return r;return r}const d=new A(l.wordSeparators,l.regex);let w;d.reset(0);do if(w=d.next(a),w&&(s[r++]=T(new k.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,i),r>=g))return r;while(w);return r}static findNextMatch(l,a,p,t){const r=a.parseSearchRequest();if(!r)return null;const s=new A(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(l,p,s,t):this._doFindNextMatchLineByLine(l,p,s,t)}static _doFindNextMatchMultiline(l,a,p,t){const r=new I.Position(a.lineNumber,1),s=l.getOffsetAt(r),i=l.getLineCount(),g=l.getValueInRange(new k.Range(r.lineNumber,r.column,i,l.getLineMaxColumn(i)),1),u=l.getEOL()===`\r
`?new c(g):null;p.reset(a.column-1);let d=p.next(g);return d?T(this._getMultilineMatchRange(l,s,g,u,d.index,d[0]),d,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(l,new I.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(l,a,p,t){const r=l.getLineCount(),s=a.lineNumber,i=l.getLineContent(s),g=this._findFirstMatchInLine(p,i,s,a.column,t);if(g)return g;for(let u=1;u<=r;u++){const d=(s+u-1)%r,w=l.getLineContent(d+1),D=this._findFirstMatchInLine(p,w,d+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(l,a,p,t,r){l.reset(t-1);const s=l.next(a);return s?T(new k.Range(p,s.index+1,p,s.index+1+s[0].length),s,r):null}static findPreviousMatch(l,a,p,t){const r=a.parseSearchRequest();if(!r)return null;const s=new A(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(l,p,s,t):this._doFindPreviousMatchLineByLine(l,p,s,t)}static _doFindPreviousMatchMultiline(l,a,p,t){const r=this._doFindMatchesMultiline(l,new k.Range(1,1,a.lineNumber,a.column),p,t,10*C);if(r.length>0)return r[r.length-1];const s=l.getLineCount();return a.lineNumber!==s||a.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new I.Position(s,l.getLineMaxColumn(s)),p,t):null}static _doFindPreviousMatchLineByLine(l,a,p,t){const r=l.getLineCount(),s=a.lineNumber,i=l.getLineContent(s).substring(0,a.column-1),g=this._findLastMatchInLine(p,i,s,t);if(g)return g;for(let u=1;u<=r;u++){const d=(r+s-u-1)%r,w=l.getLineContent(d+1),D=this._findLastMatchInLine(p,w,d+1,t);if(D)return D}return null}static _findLastMatchInLine(l,a,p,t){let r=null,s;for(l.reset(0);s=l.next(a);)r=T(new k.Range(p,s.index+1,p,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=h;function o(E,l,a,p,t){if(p===0)return!0;const r=l.charCodeAt(p-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(p);if(E.get(s)!==0)return!0}return!1}function v(E,l,a,p,t){if(p+t===a)return!0;const r=l.charCodeAt(p+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(p+t-1);if(E.get(s)!==0)return!0}return!1}function _(E,l,a,p,t){return o(E,l,a,p,t)&&v(E,l,a,p,t)}e.isValidMatch=_;class A{constructor(l,a){this._wordSeparators=l,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const a=l.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(p=this._searchRegex.exec(l),!p))return null;const t=p.index,r=p[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){f.getNextCodePoint(l,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,l,a,t,r))return p}while(p);return null}}e.Searcher=A}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(C=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(y+="\\"+P);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=f();function L(C){let y=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)y=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),y=new RegExp(C.source,P)}return y.lastIndex=0,y}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function k(C,y,P,n,T=I){if(P.length>T.maxLen){let _=C-T.maxLen/2;return _<0?_=0:n+=_,P=P.substring(_,C+T.maxLen/2),k(C,y,P,n,T)}const c=Date.now(),h=C-1-n;let o=-1,v=null;for(let _=1;!(Date.now()-c>=T.timeBudget);_++){const A=h-T.windowSize*_;y.lastIndex=Math.max(0,A);const E=R(y,P,h,o);if(!E&&v||(v=E,A<=0))break;o=A}if(v){let _={word:v[0],startColumn:n+1+v.index,endColumn:n+1+v.index+v[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=k;function R(C,y,P,n){let T;for(;T=C.exec(y);){const c=T.index||0;if(c<=P&&C.lastIndex>=P)return T;if(n>0&&c>n)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,P=C.notIn.length;y<P;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)k(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),k(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),k(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),k(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&k(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function k(R,C,y){R.has(C)?R.get(C).push(y):R.set(C,[y])}}),define(me[81],ge([0,1,30,8]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(k,R,C,y){if(Array.isArray(k)){let P=0;for(const n of k){const T=I(n,R,C,y);if(T===10)return T;T>P&&(P=T)}return P}else{if(typeof k=="string")return y?k==="*"?5:k===C?10:0:0;if(k){const{language:P,pattern:n,scheme:T,hasAccessToAllModels:c}=k;if(!y&&!c)return 0;let h=0;if(T)if(T===R.scheme)h=10;else if(T==="*")h=5;else return 0;if(P)if(P===C)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(n){let o;if(typeof n=="string"?o=n:o={...n,base:(0,L.normalize)(n.base)},o===R.fsPath||(0,f.match)(o,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=I}),define(me[147],ge([0,1,108]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(o,v,_){const A=new Uint8Array(o*v);for(let E=0,l=o*v;E<l;E++)A[E]=_;this._data=A,this.rows=o,this.cols=v}get(o,v){return this._data[o*this.cols+v]}set(o,v,_){this._data[o*this.cols+v]=_}}e.Uint8Matrix=I;class k{constructor(o){let v=0,_=0;for(let E=0,l=o.length;E<l;E++){let[a,p,t]=o[E];p>v&&(v=p),a>_&&(_=a),t>_&&(_=t)}v++,_++;let A=new I(_,v,0);for(let E=0,l=o.length;E<l;E++){let[a,p,t]=o[E];A.set(a,p,t)}this._states=A,this._maxCharCode=v}nextState(o,v){return v<0||v>=this._maxCharCode?0:this._states.get(o,v)}}e.StateMachine=k;let R=null;function C(){return R===null&&(R=new k([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var y;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let P=null;function n(){if(P===null){P=new f.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<h.length;v++)P.set(h.charCodeAt(v),1);const o=".,;";for(let v=0;v<o.length;v++)P.set(o.charCodeAt(v),2)}return P}class T{static _createLink(o,v,_,A,E){let l=E-1;do{const a=v.charCodeAt(l);if(o.get(a)!==2)break;l--}while(l>A);if(A>0){const a=v.charCodeAt(A-1),p=v.charCodeAt(l);(a===40&&p===41||a===91&&p===93||a===123&&p===125)&&l--}return{range:{startLineNumber:_,startColumn:A+1,endLineNumber:_,endColumn:l+2},url:v.substring(A,l+1)}}static computeLinks(o,v=C()){const _=n();let A=[];for(let E=1,l=o.getLineCount();E<=l;E++){const a=o.getLineContent(E),p=a.length;let t=0,r=0,s=0,i=1,g=!1,u=!1,d=!1,w=!1;for(;t<p;){let D=!1;const m=a.charCodeAt(t);if(i===13){let S;switch(m){case 40:g=!0,S=0;break;case 41:S=g?0:1;break;case 91:d=!0,u=!0,S=0;break;case 93:d=!1,S=u?0:1;break;case 123:w=!0,S=0;break;case 125:S=w?0:1;break;case 39:S=s===34||s===96?0:1;break;case 34:S=s===39||s===96?0:1;break;case 96:S=s===39||s===34?0:1;break;case 42:S=s===42?1:0;break;case 124:S=s===124?1:0;break;case 32:S=d?0:1;break;default:S=_.get(m)}S===1&&(A.push(T._createLink(_,a,E,r,t)),D=!0)}else if(i===12){let S;m===91?(u=!0,S=0):S=_.get(m),S===1?D=!0:i=13}else i=v.nextState(i,m),i===0&&(D=!0);D&&(i=1,g=!1,u=!1,w=!1,r=t+1,s=m),t++}i===13&&A.push(T._createLink(_,a,E,r,p))}return A}}e.LinkComputer=T;function c(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:T.computeLinks(h)}e.computeLinks=c}),define(me[148],ge([0,1,3,6]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,C){return this._map.set(R,C),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===C&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,C){let y=null,P=!1;return this._promises.set(R,C.then(n=>{this._promises.delete(R),!(P||!n)&&(y=this.register(R,n))})),(0,L.toDisposable)(()=>{P=!0,y&&y.dispose()})}getPromise(R){const C=this.get(R);if(C)return Promise.resolve(C);const y=this._promises.get(R);return y?y.then(P=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[111],ge([0,1,23,11]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(I||(I={}));function k(T){for(let c=0,h=T.length;c<h;c+=4){const o=T[c+0],v=T[c+1],_=T[c+2],A=T[c+3];T[c+0]=A,T[c+1]=_,T[c+2]=v,T[c+3]=o}}function R(T){const c=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return L.isLittleEndian()||k(c),f.VSBuffer.wrap(c)}function C(T){const c=T.buffer;if(L.isLittleEndian()||k(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const h=new Uint8Array(c.byteLength);return h.set(c),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(T){const c=new Uint32Array(P(T));let h=0;if(c[h++]=T.id,T.type==="full")c[h++]=1,c[h++]=T.data.length,c.set(T.data,h),h+=T.data.length;else{c[h++]=2,c[h++]=T.deltas.length;for(const o of T.deltas)c[h++]=o.start,c[h++]=o.deleteCount,o.data?(c[h++]=o.data.length,c.set(o.data,h),h+=o.data.length):c[h++]=0}return R(c)}e.encodeSemanticTokensDto=y;function P(T){let c=0;if(c+=1+1,T.type==="full")c+=1+T.data.length;else{c+=1,c+=(1+1+1)*T.deltas.length;for(const h of T.deltas)h.data&&(c+=h.data.length)}return c}function n(T){const c=C(T);let h=0;const o=c[h++];if(c[h++]===1){const E=c[h++],l=c.subarray(h,h+E);return h+=E,{id:o,type:"full",data:l}}const _=c[h++];let A=[];for(let E=0;E<_;E++){const l=c[h++],a=c[h++],p=c[h++];let t;p>0&&(t=c.subarray(h,h+p),h+=p),A[E]={start:l,deleteCount:a,data:t}}return{id:o,type:"delta",deltas:A}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,C){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=C}}e.PrefixSumIndexOfResult=L;class I{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,C){R=(0,f.toUint32)(R);const y=this.values,P=this.prefixSum,n=C.length;return n===0?!1:(this.values=new Uint32Array(y.length+n),this.values.set(y.subarray(0,R),0),this.values.set(y.subarray(R),R+n),this.values.set(C,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,C){return R=(0,f.toUint32)(R),C=(0,f.toUint32)(C),this.values[R]===C?!1:(this.values[R]=C,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,C){R=(0,f.toUint32)(R),C=(0,f.toUint32)(C);const y=this.values,P=this.prefixSum;if(R>=y.length)return!1;let n=y.length-R;return C>=n&&(C=n),C===0?!1:(this.values=new Uint32Array(y.length-C),this.values.set(y.subarray(0,R),0),this.values.set(y.subarray(R+C),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,f.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),R>=this.values.length&&(R=this.values.length-1);for(let y=C;y<=R;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let C=0,y=this.values.length-1,P=0,n=0,T=0;for(;C<=y;)if(P=C+(y-C)/2|0,n=this.prefixSum[P],T=n-this.values[P],R<T)y=P-1;else if(R>=n)C=P+1;else break;return new L(P,R-T)}}e.PrefixSumComputer=I}),define(me[149],ge([0,1,9,50,112]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(C,y,P,n){this._uri=C,this._lines=y,this._eol=P,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const y=C.changes;for(const P of y)this._acceptDeleteRange(P.range),this._acceptInsertText(new L.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,y=this._lines.length,P=new Uint32Array(y);for(let n=0;n<y;n++)P[n]=this._lines[n].length+C;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(C,y){this._lines[C]=y,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,y){if(y.length===0)return;let P=(0,f.splitLines)(y);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let n=new Uint32Array(P.length-1);for(let T=1;T<P.length;T++)this._lines.splice(C.lineNumber+T-1,0,P[T]),n[T-1]=P[T].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,n)}}e.MirrorTextModel=k}),define(me[150],ge([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,k=I*24,R=k*7,C=k*30,y=k*365;function P(T,c){typeof T!="number"&&(T=T.getTime());const h=Math.round((new Date().getTime()-T)/1e3);if(h<-30)return(0,f.localize)(0,null,P(new Date().getTime()+h*1e3,!1));if(h<30)return(0,f.localize)(1,null);let o;return h<L?(o=h,c?o===1?(0,f.localize)(2,null,o):(0,f.localize)(3,null,o):o===1?(0,f.localize)(4,null,o):(0,f.localize)(5,null,o)):h<I?(o=Math.floor(h/L),c?o===1?(0,f.localize)(6,null,o):(0,f.localize)(7,null,o):o===1?(0,f.localize)(8,null,o):(0,f.localize)(9,null,o)):h<k?(o=Math.floor(h/I),c?o===1?(0,f.localize)(10,null,o):(0,f.localize)(11,null,o):o===1?(0,f.localize)(12,null,o):(0,f.localize)(13,null,o)):h<R?(o=Math.floor(h/k),c?o===1?(0,f.localize)(14,null,o):(0,f.localize)(15,null,o):o===1?(0,f.localize)(16,null,o):(0,f.localize)(17,null,o)):h<C?(o=Math.floor(h/R),c?o===1?(0,f.localize)(18,null,o):(0,f.localize)(19,null,o):o===1?(0,f.localize)(20,null,o):(0,f.localize)(21,null,o)):h<y?(o=Math.floor(h/C),c?o===1?(0,f.localize)(22,null,o):(0,f.localize)(23,null,o):o===1?(0,f.localize)(24,null,o):(0,f.localize)(25,null,o)):(o=Math.floor(h/y),c?o===1?(0,f.localize)(26,null,o):(0,f.localize)(27,null,o):o===1?(0,f.localize)(28,null,o):(0,f.localize)(29,null,o))}e.fromNow=P;function n(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[152],ge([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,20,13,152]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(P,n){return n&&(P.stack||P.stacktrace)?I.localize(0,null,C(P),R(P.stack)||R(P.stacktrace)):C(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function y(P=null,n=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const T=f.coalesce(P),c=y(T[0],n);return T.length>1?I.localize(4,null,c,T.length):c}if(L.isString(P))return P;if(P.detail){const T=P.detail;if(T.error)return k(T.error,n);if(T.exception)return k(T.exception,n)}return P.stack?k(P,n):P.message?P.message:I.localize(5,null)}e.toErrorMessage=y}),define(me[153],ge([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,32,13,142,28,153]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function o(a,p){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const r=f.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(s=>{r.once("error",i=>{s({success:!1,error:i})}),r.once("exit",(i,g)=>{s(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?h(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{f.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,i,g)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function v(a=y.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(p,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=p,this.args=t,this.shell=r,this.options=s;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(y.env).forEach(g=>{i[g]=y.env[g]}),Object.keys(this.options.env).forEach(g=>{i[g]=this.options.env[g]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(R.sep);return t!==-1&&(p=p.substring(t+1)),_.WellKnowCommands[p]?p:"other"}start(p){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let r,s;const i=new Promise((g,u)=>{r=g,s=u});if(t){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=f.exec(g,this.options,(u,d,w)=>{this.childProcess=null;const D=u;D&&D.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(r,p,u,d,w)})}else{let g=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,p,s);const w={terminated:this.terminateRequested};P.isNumber(d)&&(w.cmdCode=d),r(w)};if(this.shell&&C.isWindows){const d=k.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,D=!1;const m=[];let S=this.ensureQuotes(this.cmd);m.push(S.value),w=S.quoted,this.args&&this.args.forEach(F=>{S=this.ensureQuotes(F),m.push(S.value),D=D&&S.quoted});const b=["/s","/c"];w?D?b.push('"'+m.join(" ")+'"'):m.length>1?b.push('"'+m[0]+'" '+m.slice(1).join(" ")):b.push('"'+m[0]+'"'):b.push(m.join(" ")),g=f.spawn(v(),b,d)}else this.cmd&&(g=f.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(P.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),g.pid&&(this.childProcess.on("close",u),this.handleSpawn(g,r,p,s,!0)))}return i})}handleClose(p,t,r,s){}ensureQuotes(p){return _.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,o(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!C.isWindows)return p(!1);const t=f.spawn(v(),["/s","/c"]);t.on("error",r=>p(!0)),t.on("exit",r=>p(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class A extends _{constructor(p,t,r,s){super(p,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,r,s,i){[s,i].forEach((g,u)=>{const d=new n.LineDecoder;d.write(g).forEach(m=>{t({line:m,source:u===0?0:1})});const D=d.end();D&&t({line:D,source:u===0?0:1})}),p({terminated:this.terminateRequested,error:r})}handleSpawn(p,t,r,s,i){const g=new n.LineDecoder,u=new n.LineDecoder;p.stdout.on("data",d=>{g.write(d).forEach(D=>r({line:D,source:0}))}),p.stderr.on("data",d=>{u.write(d).forEach(D=>r({line:D,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=u}handleClose(p,t,r,s){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&r({line:g,source:1})}}e.LineProcess=A;function E(a){let p=[],t=!1;const r=function(s){if(t){p.push(s);return}(!a.send(s,g=>{if(g&&console.error(g),t=!1,p.length>0){const u=p.slice(0);p=[],u.forEach(d=>r(d))}})||C.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var l;(function(a){async function p(t,r,s){if(R.isAbsolute(t))return t;if(r===void 0&&(r=y.cwd()),R.dirname(t)!=="."||(s===void 0&&P.isString(y.env.PATH)&&(s=y.env.PATH.split(R.delimiter)),s===void 0||s.length===0))return R.join(r,t);async function g(u){if(await T.Promises.exists(u)){let d;try{d=await T.Promises.stat(u)}catch(w){w.message.startsWith("EACCES")&&(d=await T.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(let u of s){let d;if(R.isAbsolute(u)?d=R.join(u,t):d=R.join(r,u,t),await g(d))return d;let w=d+".com";if(await g(w)||(w=d+".exe",await g(w)))return w}return R.join(r,t)}a.findExecutable=p})(l=e.win32||(e.win32={}))}),define(me[154],ge([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=C;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class P{constructor(te,pe,Ue,Ye){this.id=te,this.name=pe,this.defaultValue=Ue,this.schema=Ye}compute(te,pe,Ue){return Ue}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class T{constructor(te,pe,Ue,Ye){this.id=te,this.name=pe,this.defaultValue=Ue,this.schema=Ye}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,Ue){return Ue}}function c(Z,te){return typeof Z=="undefined"?te:Z==="false"?!1:Boolean(Z)}e.boolean=c;class h extends T{constructor(te,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ue),super(te,pe,Ue,Ye)}validate(te){return c(te,this.defaultValue)}}class o extends T{constructor(te,pe,Ue,Ye,it,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=Ue,ft.minimum=Ye,ft.maximum=it),super(te,pe,Ue,ft),this.minimum=Ye,this.maximum=it}static clampedInt(te,pe,Ue,Ye){if(typeof te=="undefined")return pe;let it=parseInt(te,10);return isNaN(it)?pe:(it=Math.max(Ue,it),it=Math.min(Ye,it),it|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class v extends T{constructor(te,pe,Ue,Ye,it){typeof it!="undefined"&&(it.type="number",it.default=Ue),super(te,pe,Ue,it),this.validationFn=Ye}static clamp(te,pe,Ue){return te<pe?pe:te>Ue?Ue:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const Ue=parseFloat(te);return isNaN(Ue)?pe:Ue}validate(te){return this.validationFn(v.float(te,this.defaultValue))}}class _ extends T{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ue),super(te,pe,Ue,Ye)}validate(te){return _.string(te,this.defaultValue)}}function A(Z,te,pe){return typeof Z!="string"||pe.indexOf(Z)===-1?te:Z}e.stringSet=A;class E extends T{constructor(te,pe,Ue,Ye,it=void 0){typeof it!="undefined"&&(it.type="string",it.enum=Ye,it.default=Ue),super(te,pe,Ue,it),this._allowedValues=Ye}validate(te){return A(te,this.defaultValue,this._allowedValues)}}class l extends P{constructor(te,pe,Ue,Ye,it,ft,pt=void 0){typeof pt!="undefined"&&(pt.type="string",pt.enum=it,pt.default=Ye),super(te,pe,Ue,pt),this._allowedValues=it,this._convert=ft}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function a(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends P{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:f.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function g(Z){switch(Z){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function u(Z){switch(Z){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class d extends n{constructor(){super(127,[65,32])}compute(te,pe,Ue){const Ye=["monaco-editor"];return pe.get(32)&&Ye.push(pe.get(32)),te.extraEditorClassName&&Ye.push(te.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(100)&&Ye.push("showUnused"),pe.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class w extends h{constructor(){super(31,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(te,pe,Ue){return Ue&&te.emptySelectionClipboard}}class D extends P{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:f.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:f.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":A(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":A(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class m extends P{constructor(){super(43,"fontLigatures",m.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?m.OFF:te==="true"?m.ON:te:Boolean(te)?m.ON:m.OFF}}e.EditorFontLigatures=m,m.OFF='"liga" off, "calt" off',m.ON='"liga" on, "calt" on';class S extends n{constructor(){super(42)}compute(te,pe,Ue){return te.fontInfo}}class b extends T{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(te){let pe=v.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(te,pe,Ue){return te.fontInfo.fontSize}}class F extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class N extends P{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Ue,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Ue,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Ue,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Ue,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Ue,description:f.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:A(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??A(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??A(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??A(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??A(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??A(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends P{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:f.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky)}}}var K;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class M extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,Ue){return M.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?pe-1:0,Ye=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),it=Math.floor(te.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:it}}static _computeMinimapLayout(te,pe){const Ue=te.outerWidth,Ye=te.outerHeight,it=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ft=pe.stableMinimapLayoutInput,pt=ft&&te.outerHeight===ft.outerHeight&&te.lineHeight===ft.lineHeight&&te.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&te.pixelRatio===ft.pixelRatio&&te.scrollBeyondLastLine===ft.scrollBeyondLastLine&&te.minimap.enabled===ft.minimap.enabled&&te.minimap.side===ft.minimap.side&&te.minimap.size===ft.minimap.size&&te.minimap.showSlider===ft.minimap.showSlider&&te.minimap.renderCharacters===ft.minimap.renderCharacters&&te.minimap.maxColumn===ft.minimap.maxColumn&&te.minimap.scale===ft.minimap.scale&&te.verticalScrollbarWidth===ft.verticalScrollbarWidth&&te.isViewportWrapping===ft.isViewportWrapping,St=te.lineHeight,Ct=te.typicalHalfwidthCharacterWidth,ue=te.scrollBeyondLastLine,Ie=te.minimap.renderCharacters;let Ne=it>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const Qe=te.minimap.maxColumn,We=te.minimap.size,at=te.minimap.side,Re=te.verticalScrollbarWidth,De=te.viewLineCount,ke=te.remainingWidth,ne=te.isViewportWrapping,de=Ie?2:3;let be=Math.floor(it*Ye);const we=be/it;let Fe=!1,qe=!1,$e=de*Ne,Je=Ne/it,tt=1;if(We==="fill"||We==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:vt}=M.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:ue,height:Ye,lineHeight:St,pixelRatio:it});if(De/vt>1)Fe=!0,qe=!0,Ne=1,$e=1,Je=Ne/it;else{let lt=!1,dt=Ne+1;if(We==="fit"){const mt=Math.ceil((De+Xe)*$e);ne&&pt&&ke<=pe.stableFitRemainingWidth?(lt=!0,dt=pe.stableFitMaxMinimapScale):lt=mt>be}if(We==="fill"||lt){Fe=!0;const mt=Ne;$e=Math.min(St*it,Math.max(1,Math.floor(1/ot))),ne&&pt&&ke<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),Ne=Math.min(dt,Math.max(1,Math.floor($e/de))),Ne>mt&&(tt=Math.min(2,Ne/mt)),Je=Ne/it/tt,be=Math.ceil(Math.max(Ze,De+Xe)*$e),ne?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ke,pe.stableFitMaxMinimapScale=Ne):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const le=Math.floor(Qe*Je),Ee=Math.min(le,Math.max(0,Math.floor((ke-Re-2)*Je/(Ct+Je)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(it*Ee);const q=ce/it;ce=Math.floor(ce*tt);const Ae=Ie?1:2,Pe=at==="left"?0:Ue-Ee-Re;return{renderMinimap:Ae,minimapLeft:Pe,minimapWidth:Ee,minimapHeightIsEditorHeight:Fe,minimapIsSampling:qe,minimapScale:Ne,minimapLineHeight:$e,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:be,minimapCanvasOuterWidth:q,minimapCanvasOuterHeight:we}}static computeLayout(te,pe){const Ue=pe.outerWidth|0,Ye=pe.outerHeight|0,it=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,pt=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Ct=pe.pixelRatio,ue=pe.viewLineCount,Ie=te.get(122),Ne=Ie==="inherit"?te.get(121):Ie,Qe=Ne==="inherit"?te.get(117):Ne,We=te.get(120),at=te.get(2),Re=pe.isDominatedByLongLines,De=te.get(48),ke=te.get(59).renderType!==0,ne=te.get(60),de=te.get(94),be=te.get(64),we=te.get(92),Fe=we.verticalScrollbarSize,qe=we.verticalHasArrows,$e=we.arrowSize,Je=we.horizontalScrollbarSize,tt=te.get(57),le=te.get(36);let Ee;if(typeof tt=="string"&&/^\d+(\.\d+)?ch$/.test(tt)){const Nt=parseFloat(tt.substr(0,tt.length-2));Ee=o.clampedInt(Nt*pt,0,0,1e3)}else Ee=o.clampedInt(tt,0,0,1e3);le&&(Ee+=16);let ce=0;if(ke){const Nt=Math.max(ft,ne);ce=Math.round(Nt*St)}let q=0;De&&(q=it);let Ae=0,Pe=Ae+q,Ze=Pe+ce,Xe=Ze+Ee;const ot=Ue-q-ce-Ee;let vt=!1,Et=!1,lt=-1;at!==2&&(Ne==="inherit"&&Re?(vt=!0,Et=!0):Qe==="on"||Qe==="bounded"?Et=!0:Qe==="wordWrapColumn"&&(lt=We));const dt=M._computeMinimapLayout({outerWidth:Ue,outerHeight:Ye,lineHeight:it,typicalHalfwidthCharacterWidth:pt,pixelRatio:Ct,scrollBeyondLastLine:de,minimap:be,verticalScrollbarWidth:Fe,viewLineCount:ue,remainingWidth:ot,isViewportWrapping:Et},pe.memory||new y);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Ae+=dt.minimapWidth,Pe+=dt.minimapWidth,Ze+=dt.minimapWidth,Xe+=dt.minimapWidth);const mt=ot-dt.minimapWidth,Lt=Math.max(1,Math.floor((mt-Fe-2)/pt)),yt=qe?$e:0;return Et&&(lt=Math.max(1,Lt),Qe==="bounded"&&(lt=Math.min(lt,We))),{width:Ue,height:Ye,glyphMarginLeft:Ae,glyphMarginWidth:q,lineNumbersLeft:Pe,lineNumbersWidth:ce,decorationsLeft:Ze,decorationsWidth:Ee,contentLeft:Xe,contentWidth:mt,minimap:dt,viewportColumn:Lt,isWordWrapMinified:vt,isViewportWrapping:Et,wrappingColumn:lt,verticalScrollbarWidth:Fe,horizontalScrollbarHeight:Je,overviewRuler:{top:yt,width:Fe,height:Ye-2*yt,right:0}}}}e.EditorLayoutInfoComputer=M;class U extends P{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:f.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class O extends P{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:f.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:f.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class $ extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>v.clamp(te,0,150),{markdownDescription:f.localize(46,null)})}compute(te,pe,Ue){return te.fontInfo.lineHeight}}class B extends P{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:f.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(48,null),f.localize(49,null),f.localize(50,null)],default:te.size,description:f.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:f.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:f.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:f.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:f.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),size:A(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:A(pe.side,this.defaultValue.side,["right","left"]),showSlider:A(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(Z){return Z==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class H extends P{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:f.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Q extends n{constructor(){super(128)}compute(te,pe,Ue){return te.pixelRatio}}class X extends P{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:f.localize(61,null)},comments:{type:"boolean",default:te.comments,description:f.localize(62,null)},other:{type:"boolean",default:te.other,description:f.localize(63,null)}}}],default:te,description:f.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,Ue={other:c(pe.other,this.defaultValue.other),comments:c(pe.comments,this.defaultValue.comments),strings:c(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var fe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class _e extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(65,null),f.localize(66,null),f.localize(67,null),f.localize(68,null)],default:"on",description:f.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,Ue=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function ye(Z){const te=Z.get(87);return te==="editable"?Z.get(80):te!=="on"}e.filterValidationDecorations=ye;class Le extends P{constructor(){const te=[],pe={type:"number",description:f.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:f.localize(71,null),format:"color-hex"}}}]},default:te,description:f.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let Ue of te)if(typeof Ue=="number")pe.push({column:o.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ye=Ue;pe.push({column:o.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ue,Ye)=>Ue.column-Ye.column),pe}return this.defaultValue}}function ze(Z,te){if(typeof Z!="string")return te;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class xe extends P{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(73,null),f.localize(74,null),f.localize(75,null)],default:"auto",description:f.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)],default:"auto",description:f.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:f.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:f.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,Ue=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ze(pe.vertical,this.defaultValue.vertical),horizontal:ze(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends P{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:f.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[f.localize(85,null),f.localize(86,null),f.localize(87,null)],default:te.mode,description:f.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:A(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class z extends P{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:f.localize(89,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(90,null),f.localize(91,null)],default:te.insertMode,description:f.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:f.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:f.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:f.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:f.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:f.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:f.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:f.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[f.localize(100,null),f.localize(101,null),f.localize(102,null)],default:te.previewMode,description:f.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:f.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:A(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:A(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class re extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(136,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends n{constructor(){super(129,[80])}compute(te,pe,Ue){return pe.get(80)?!0:te.tabFocusMode}}var Y;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function oe(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends n{constructor(){super(131,[130])}compute(te,pe,Ue){const Ye=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Me="Consolas, 'Courier New', monospace",je="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?je:L.isLinux?Ke:Me,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Se(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var nt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.codeLens=13]="codeLens",Z[Z.codeLensFontFamily=14]="codeLensFontFamily",Z[Z.codeLensFontSize=15]="codeLensFontSize",Z[Z.colorDecorators=16]="colorDecorators",Z[Z.columnSelection=17]="columnSelection",Z[Z.comments=18]="comments",Z[Z.contextmenu=19]="contextmenu",Z[Z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=21]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=23]="cursorStyle",Z[Z.cursorSurroundingLines=24]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=26]="cursorWidth",Z[Z.disableLayerHinting=27]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",Z[Z.domReadOnly=29]="domReadOnly",Z[Z.dragAndDrop=30]="dragAndDrop",Z[Z.emptySelectionClipboard=31]="emptySelectionClipboard",Z[Z.extraEditorClassName=32]="extraEditorClassName",Z[Z.fastScrollSensitivity=33]="fastScrollSensitivity",Z[Z.find=34]="find",Z[Z.fixedOverflowWidgets=35]="fixedOverflowWidgets",Z[Z.folding=36]="folding",Z[Z.foldingStrategy=37]="foldingStrategy",Z[Z.foldingHighlight=38]="foldingHighlight",Z[Z.foldingImportsByDefault=39]="foldingImportsByDefault",Z[Z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=41]="fontFamily",Z[Z.fontInfo=42]="fontInfo",Z[Z.fontLigatures=43]="fontLigatures",Z[Z.fontSize=44]="fontSize",Z[Z.fontWeight=45]="fontWeight",Z[Z.formatOnPaste=46]="formatOnPaste",Z[Z.formatOnType=47]="formatOnType",Z[Z.glyphMargin=48]="glyphMargin",Z[Z.gotoLocation=49]="gotoLocation",Z[Z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",Z[Z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",Z[Z.hover=52]="hover",Z[Z.inDiffEditor=53]="inDiffEditor",Z[Z.inlineSuggest=54]="inlineSuggest",Z[Z.letterSpacing=55]="letterSpacing",Z[Z.lightbulb=56]="lightbulb",Z[Z.lineDecorationsWidth=57]="lineDecorationsWidth",Z[Z.lineHeight=58]="lineHeight",Z[Z.lineNumbers=59]="lineNumbers",Z[Z.lineNumbersMinChars=60]="lineNumbersMinChars",Z[Z.linkedEditing=61]="linkedEditing",Z[Z.links=62]="links",Z[Z.matchBrackets=63]="matchBrackets",Z[Z.minimap=64]="minimap",Z[Z.mouseStyle=65]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=67]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=69]="multiCursorModifier",Z[Z.multiCursorPaste=70]="multiCursorPaste",Z[Z.occurrencesHighlight=71]="occurrencesHighlight",Z[Z.overviewRulerBorder=72]="overviewRulerBorder",Z[Z.overviewRulerLanes=73]="overviewRulerLanes",Z[Z.padding=74]="padding",Z[Z.parameterHints=75]="parameterHints",Z[Z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=78]="quickSuggestions",Z[Z.quickSuggestionsDelay=79]="quickSuggestionsDelay",Z[Z.readOnly=80]="readOnly",Z[Z.renameOnType=81]="renameOnType",Z[Z.renderControlCharacters=82]="renderControlCharacters",Z[Z.renderIndentGuides=83]="renderIndentGuides",Z[Z.renderFinalNewline=84]="renderFinalNewline",Z[Z.renderLineHighlight=85]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=87]="renderValidationDecorations",Z[Z.renderWhitespace=88]="renderWhitespace",Z[Z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",Z[Z.roundedSelection=90]="roundedSelection",Z[Z.rulers=91]="rulers",Z[Z.scrollbar=92]="scrollbar",Z[Z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=94]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=95]="scrollPredominantAxis",Z[Z.selectionClipboard=96]="selectionClipboard",Z[Z.selectionHighlight=97]="selectionHighlight",Z[Z.selectOnLineNumbers=98]="selectOnLineNumbers",Z[Z.showFoldingControls=99]="showFoldingControls",Z[Z.showUnused=100]="showUnused",Z[Z.snippetSuggestions=101]="snippetSuggestions",Z[Z.smartSelect=102]="smartSelect",Z[Z.smoothScrolling=103]="smoothScrolling",Z[Z.stickyTabStops=104]="stickyTabStops",Z[Z.stopRenderingLineAfter=105]="stopRenderingLineAfter",Z[Z.suggest=106]="suggest",Z[Z.suggestFontSize=107]="suggestFontSize",Z[Z.suggestLineHeight=108]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",Z[Z.suggestSelection=110]="suggestSelection",Z[Z.tabCompletion=111]="tabCompletion",Z[Z.tabIndex=112]="tabIndex",Z[Z.unusualLineTerminators=113]="unusualLineTerminators",Z[Z.useShadowDOM=114]="useShadowDOM",Z[Z.useTabStops=115]="useTabStops",Z[Z.wordSeparators=116]="wordSeparators",Z[Z.wordWrap=117]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=120]="wordWrapColumn",Z[Z.wordWrapOverride1=121]="wordWrapOverride1",Z[Z.wordWrapOverride2=122]="wordWrapOverride2",Z[Z.wrappingIndent=123]="wrappingIndent",Z[Z.wrappingStrategy=124]="wrappingStrategy",Z[Z.showDeprecated=125]="showDeprecated",Z[Z.inlayHints=126]="inlayHints",Z[Z.editorClassName=127]="editorClassName",Z[Z.pixelRatio=128]="pixelRatio",Z[Z.tabFocusMode=129]="tabFocusMode",Z[Z.layoutInfo=130]="layoutInfo",Z[Z.wrappingInfo=131]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(137,null)})),acceptSuggestionOnEnter:Se(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(138,null),""],markdownDescription:f.localize(139,null)})),accessibilitySupport:Se(new p),accessibilityPageSize:Se(new o(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(140,null)})),ariaLabel:Se(new _(4,"ariaLabel",f.localize(141,null))),autoClosingBrackets:Se(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(142,null),f.localize(143,null),""],description:f.localize(144,null)})),autoClosingDelete:Se(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(145,null),""],description:f.localize(146,null)})),autoClosingOvertype:Se(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(147,null),""],description:f.localize(148,null)})),autoClosingQuotes:Se(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(149,null),f.localize(150,null),""],description:f.localize(151,null)})),autoIndent:Se(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[f.localize(152,null),f.localize(153,null),f.localize(154,null),f.localize(155,null),f.localize(156,null)],description:f.localize(157,null)})),automaticLayout:Se(new h(10,"automaticLayout",!1)),autoSurround:Se(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(158,null),f.localize(159,null),f.localize(160,null),""],description:f.localize(161,null)})),bracketPairColorization:Se(new z),stickyTabStops:Se(new h(104,"stickyTabStops",!1,{description:f.localize(162,null)})),codeLens:Se(new h(13,"codeLens",!0,{description:f.localize(163,null)})),codeLensFontFamily:Se(new _(14,"codeLensFontFamily","",{description:f.localize(164,null)})),codeLensFontSize:Se(new o(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(165,null)})),colorDecorators:Se(new h(16,"colorDecorators",!0,{description:f.localize(166,null)})),columnSelection:Se(new h(17,"columnSelection",!1,{description:f.localize(167,null)})),comments:Se(new t),contextmenu:Se(new h(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new h(20,"copyWithSyntaxHighlighting",!0,{description:f.localize(168,null)})),cursorBlinking:Se(new l(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:f.localize(169,null)})),cursorSmoothCaretAnimation:Se(new h(22,"cursorSmoothCaretAnimation",!1,{description:f.localize(170,null)})),cursorStyle:Se(new l(23,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:f.localize(171,null)})),cursorSurroundingLines:Se(new o(24,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(172,null)})),cursorSurroundingLinesStyle:Se(new E(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(173,null),f.localize(174,null)],description:f.localize(175,null)})),cursorWidth:Se(new o(26,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(176,null)})),disableLayerHinting:Se(new h(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new h(28,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new h(29,"domReadOnly",!1)),dragAndDrop:Se(new h(30,"dragAndDrop",!0,{description:f.localize(177,null)})),emptySelectionClipboard:Se(new w),extraEditorClassName:Se(new _(32,"extraEditorClassName","")),fastScrollSensitivity:Se(new v(33,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:f.localize(178,null)})),find:Se(new D),fixedOverflowWidgets:Se(new h(35,"fixedOverflowWidgets",!1)),folding:Se(new h(36,"folding",!0,{description:f.localize(179,null)})),foldingStrategy:Se(new E(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(180,null),f.localize(181,null)],description:f.localize(182,null)})),foldingHighlight:Se(new h(38,"foldingHighlight",!0,{description:f.localize(183,null)})),foldingImportsByDefault:Se(new h(39,"foldingImportsByDefault",!1,{description:f.localize(184,null)})),unfoldOnClickAfterEndOfLine:Se(new h(40,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(185,null)})),fontFamily:Se(new _(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(186,null)})),fontInfo:Se(new S),fontLigatures2:Se(new m),fontSize:Se(new b),fontWeight:Se(new F),formatOnPaste:Se(new h(46,"formatOnPaste",!1,{description:f.localize(187,null)})),formatOnType:Se(new h(47,"formatOnType",!1,{description:f.localize(188,null)})),glyphMargin:Se(new h(48,"glyphMargin",!0,{description:f.localize(189,null)})),gotoLocation:Se(new N),hideCursorInOverviewRuler:Se(new h(50,"hideCursorInOverviewRuler",!1,{description:f.localize(190,null)})),highlightActiveIndentGuide:Se(new h(51,"highlightActiveIndentGuide",!0,{description:f.localize(191,null)})),hover:Se(new G),inDiffEditor:Se(new h(53,"inDiffEditor",!1)),letterSpacing:Se(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:f.localize(192,null)})),lightbulb:Se(new U),lineDecorationsWidth:Se(new T(57,"lineDecorationsWidth",10)),lineHeight:Se(new $),lineNumbers:Se(new _e),lineNumbersMinChars:Se(new o(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new h(61,"linkedEditing",!1,{description:f.localize(193,null)})),links:Se(new h(62,"links",!0,{description:f.localize(194,null)})),matchBrackets:Se(new E(63,"matchBrackets","always",["always","near","never"],{description:f.localize(195,null)})),minimap:Se(new B),mouseStyle:Se(new E(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new v(66,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:f.localize(196,null)})),mouseWheelZoom:Se(new h(67,"mouseWheelZoom",!1,{markdownDescription:f.localize(197,null)})),multiCursorMergeOverlapping:Se(new h(68,"multiCursorMergeOverlapping",!0,{description:f.localize(198,null)})),multiCursorModifier:Se(new l(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[f.localize(199,null),f.localize(200,null)],markdownDescription:f.localize(201,null)})),multiCursorPaste:Se(new E(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(202,null),f.localize(203,null)],markdownDescription:f.localize(204,null)})),occurrencesHighlight:Se(new h(71,"occurrencesHighlight",!0,{description:f.localize(205,null)})),overviewRulerBorder:Se(new h(72,"overviewRulerBorder",!0,{description:f.localize(206,null)})),overviewRulerLanes:Se(new o(73,"overviewRulerLanes",3,0,3)),padding:Se(new j),parameterHints:Se(new H),peekWidgetDefaultFocus:Se(new E(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(207,null),f.localize(208,null)],description:f.localize(209,null)})),definitionLinkOpensInPeek:Se(new h(77,"definitionLinkOpensInPeek",!1,{description:f.localize(210,null)})),quickSuggestions:Se(new X),quickSuggestionsDelay:Se(new o(79,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(211,null)})),readOnly:Se(new h(80,"readOnly",!1)),renameOnType:Se(new h(81,"renameOnType",!1,{description:f.localize(212,null),markdownDeprecationMessage:f.localize(213,null)})),renderControlCharacters:Se(new h(82,"renderControlCharacters",!1,{description:f.localize(214,null)})),renderIndentGuides:Se(new h(83,"renderIndentGuides",!0,{description:f.localize(215,null)})),renderFinalNewline:Se(new h(84,"renderFinalNewline",!0,{description:f.localize(216,null)})),renderLineHighlight:Se(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(217,null)],description:f.localize(218,null)})),renderLineHighlightOnlyWhenFocus:Se(new h(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(219,null)})),renderValidationDecorations:Se(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(220,null),f.localize(221,null),f.localize(222,null),""],description:f.localize(223,null)})),revealHorizontalRightPadding:Se(new o(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new h(90,"roundedSelection",!0,{description:f.localize(224,null)})),rulers:Se(new Le),scrollbar:Se(new xe),scrollBeyondLastColumn:Se(new o(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(225,null)})),scrollBeyondLastLine:Se(new h(94,"scrollBeyondLastLine",!0,{description:f.localize(226,null)})),scrollPredominantAxis:Se(new h(95,"scrollPredominantAxis",!0,{description:f.localize(227,null)})),selectionClipboard:Se(new h(96,"selectionClipboard",!0,{description:f.localize(228,null),included:L.isLinux})),selectionHighlight:Se(new h(97,"selectionHighlight",!0,{description:f.localize(229,null)})),selectOnLineNumbers:Se(new h(98,"selectOnLineNumbers",!0)),showFoldingControls:Se(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(230,null),f.localize(231,null)],description:f.localize(232,null)})),showUnused:Se(new h(100,"showUnused",!0,{description:f.localize(233,null)})),showDeprecated:Se(new h(125,"showDeprecated",!0,{description:f.localize(234,null)})),inlayHints:Se(new O),snippetSuggestions:Se(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(235,null),f.localize(236,null),f.localize(237,null),f.localize(238,null)],description:f.localize(239,null)})),smartSelect:Se(new re),smoothScrolling:Se(new h(103,"smoothScrolling",!1,{description:f.localize(240,null)})),stopRenderingLineAfter:Se(new o(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),inlineSuggest:Se(new Ge),suggestFontSize:Se(new o(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(241,null)})),suggestLineHeight:Se(new o(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(242,null)})),suggestOnTriggerCharacters:Se(new h(109,"suggestOnTriggerCharacters",!0,{description:f.localize(243,null)})),suggestSelection:Se(new E(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(244,null),f.localize(245,null),f.localize(246,null)],description:f.localize(247,null)})),tabCompletion:Se(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(248,null),f.localize(249,null),f.localize(250,null)],description:f.localize(251,null)})),tabIndex:Se(new o(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new E(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(252,null),f.localize(253,null),f.localize(254,null)],description:f.localize(255,null)})),useShadowDOM:Se(new h(114,"useShadowDOM",!0)),useTabStops:Se(new h(115,"useTabStops",!0,{description:f.localize(256,null)})),wordSeparators:Se(new _(116,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(257,null)})),wordWrap:Se(new E(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null),f.localize(261,null)],description:f.localize(262,null)})),wordWrapBreakAfterCharacters:Se(new _(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new _(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new o(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(263,null)})),wordWrapOverride1:Se(new E(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new E(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new l(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[f.localize(264,null),f.localize(265,null),f.localize(266,null),f.localize(267,null)],description:f.localize(268,null)})),wrappingStrategy:Se(new E(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(269,null),f.localize(270,null)],description:f.localize(271,null)})),editorClassName:Se(new d),pixelRatio:Se(new Q),tabFocusMode:Se(new ae),layoutInfo:Se(new M),wrappingInfo:Se(new ve)}}),define(me[155],ge([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var I;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),function(){"use strict";function J(e,f,L,I){function k(C){const y=R(C),P=[y];return e.isAbsolute(y)||P.unshift(I),e.resolve(...P)}function R(C){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,L);const n=C["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(T,"AppData","Roaming")}break;case"darwin":P=e.join(f.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(f.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,L)}return{getUserDataPath:k}}if(typeof define=="function")define(me[179],ge([0,180,60,10,22,32]),function(e,f,L,I,k,R){const C=k.dirname(I.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(k.joinPath(C,"package.json").fsPath);return J(f,L,y.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),f=require("path"),L=require("os");module.exports=J(f,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(me[181],ge([0,1,157]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function k(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=k;function R(c){if(!k(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=c.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function C(c){if(!c)return null;let h=c.majorBase,o=c.majorMustEqual,v=c.minorBase,_=c.minorMustEqual,A=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(h===0||(_=!1),E=!1);let l=0;if(c.preRelease){const a=I.exec(c.preRelease);if(a){const[,p,t,r]=a;l=Date.UTC(Number(p),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:o,minorBase:v,minorMustEqual:_,patchBase:A,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:l}}e.normalizeVersion=C;function y(c,h,o){let v;typeof c=="string"?v=C(R(c)):v=c;let _;h instanceof Date?_=h.getTime():typeof h=="string"&&(_=new Date(h).getTime());let A;if(typeof o=="string"?A=C(R(o)):A=o,!v||!A)return!1;let E=v.majorBase,l=v.minorBase,a=v.patchBase,p=A.majorBase,t=A.minorBase,r=A.patchBase,s=A.notBefore,i=A.majorMustEqual,g=A.minorMustEqual,u=A.patchMustEqual;return A.isMinimum?E>p?!0:E<p?!1:l>t?!0:l<t||_&&_<s?!1:a>=r:(E===1&&p===0&&(!i||!g||!u)&&(p=1,t=0,r=0,i=!0,g=!1,u=!1),E<p?!1:E>p?!i:l<t?!1:l>t?!g:a<r?!1:a>r?!u:!(_&&_<s))}e.isValidVersion=y;function P(c,h,o,v){return o.isBuiltin||typeof o.main=="undefined"?!0:T(c,h,o.engines.vscode,v)}e.isValidExtensionVersion=P;function n(c,h,o){return c==="*"||T(h,o,c)}e.isEngineValid=n;function T(c,h,o,v=[]){let _=C(R(o));if(!_)return v.push(f.localize(0,null,o)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(f.localize(1,null,o)),!1}else if(!_.majorMustEqual)return v.push(f.localize(2,null,o)),!1;return y(c,h,_)?!0:(v.push(f.localize(3,null,c,o)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,k=[],R=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=f}),define(me[82],ge([0,1,115]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(R,C,y){C instanceof f.SyncDescriptor||(C=new f.SyncDescriptor(C,[],y)),L.push([R,C])}e.registerSingleton=I;function k(){return L}e.getSingletonServiceDescriptors=k}),define(me[182],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=f;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let R of this._nodes.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const C=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(R);C.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(k),C)}removeNode(k){const R=this._hashFn(k);this._nodes.delete(R);for(let C of this._nodes.values())C.outgoing.delete(R),C.incoming.delete(R)}lookupOrInsertNode(k){const R=this._hashFn(k);let C=this._nodes.get(R);return C||(C=new f(k),this._nodes.set(R,C)),C}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[R,C]of this._nodes)k.push(`${R}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,R]of this._nodes){const C=new Set([k]),y=this._findCycle(R,C);if(y)return y}}_findCycle(k,R){for(let[C,y]of k.outgoing){if(R.has(C))return[...R,C].join(" -> ");R.add(C);const P=this._findCycle(y,R);if(P)return P;R.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(C,y,P,n){y[f.DI_TARGET]===y?y[f.DI_DEPENDENCIES].push({id:C,index:P,optional:n}):(y[f.DI_DEPENDENCIES]=[{id:C,index:P,optional:n}],y[f.DI_TARGET]=y)}function I(C){if(f.serviceIds.has(C))return f.serviceIds.get(C);const y=function(P,n,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,P,T,!1)};return y.toString=()=>C,f.serviceIds.set(C,y),y}e.createDecorator=I;function k(C){return C}e.refineServiceDecorator=k;function R(C){return function(y,P,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,y,n,!0)}}e.optional=R}),define(me[183],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[184],ge([0,1,3,58,6,24,78,81,183]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(P):!!v.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(_,A){let E={selector:_,provider:A,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(E){let l=this._entries.indexOf(E);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const A=[];for(let E of this._entries)E._score>0&&A.push(E.provider);return A}ordered(_){const A=[];return this._orderedForEach(_,E=>A.push(E.provider)),A}orderedGroups(_){const A=[];let E,l;return this._orderedForEach(_,a=>{E&&l===a._score?E.push(a.provider):(l=a._score,E=[a.provider],A.push(E))}),A}_orderedForEach(_,A){if(!!_){this._updateScores(_);for(const E of this._entries)E._score>0&&A(E)}}_updateScores(_){let A={uri:_.uri.toString(),language:_.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let E of this._entries)if(E._score=(0,C.score)(E.selector,_.uri,_.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(_)),P(E.selector)&&E._score>0){for(let l of this._entries)l._score=0;E._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(_,A){return _._score<A._score?1:_._score>A._score?-1:_._time<A._time?1:_._time>A._time?-1:0}}e.LanguageFeatureRegistry=n;const T=new WeakMap;let c=0;function h(v){let _=T.get(v);return _===void 0&&(_=++c,T.set(v,_)),_}class o{constructor(_,A,E=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=A,this.max=E,this._cache=new k.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((A,E)=>(0,L.doHash)(h(E),A),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const A=this._key(_),E=this._cache.get(A);return this._clamp(E?.value)}update(_,A){const E=this._key(_);let l=this._cache.get(E);return l||(l=new R.MovingAverage,this._cache.set(E,l)),l.update(A),this.get(_)}}e.LanguageFeatureRequestDelays=o}),define(me[83],ge([0,1,2,41,184,148,47]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(S,b){this.language=S,this.id=b}}e.LanguageIdentifier=y;var P;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var n;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var T;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let b=this.getForeground(S),F="mtk"+b,N=this.getFontStyle(S);return N&1&&(F+=" mtki"),N&2&&(F+=" mtkb"),N&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(S,b){const F=this.getForeground(S),N=this.getFontStyle(S);let G=`color: ${b[F]};`;return N&1&&(G+="font-style: italic;"),N&2&&(G+="font-weight: bold;"),N&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=h;var o;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(S){const b=m[S];let F=b&&R.iconRegistry.get(b);return F||(console.info("No codicon found for CompletionItemKind "+S),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(S,b){let F=m[S];return typeof F=="undefined"&&!b&&(F=9),F}}();var v;(function(m){m[m.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var A;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(m){return m&&f.URI.isUri(m.uri)&&L.Range.isIRange(m.range)&&(L.Range.isIRange(m.originSelectionRange)||L.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=t;var r;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(m){m[m.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(m){const S=new Map;S.set("file",0),S.set("module",1),S.set("namespace",2),S.set("package",3),S.set("class",4),S.set("method",5),S.set("property",6),S.set("field",7),S.set("constructor",8),S.set("enum",9),S.set("interface",10),S.set("function",11),S.set("variable",12),S.set("constant",13),S.set("string",14),S.set("number",15),S.set("boolean",16),S.set("array",17),S.set("object",18),S.set("key",19),S.set("null",20),S.set("enum-member",21),S.set("struct",22),S.set("event",23),S.set("operator",24),S.set("type-parameter",25);const b=new Map;b.set(0,"file"),b.set(1,"module"),b.set(2,"namespace"),b.set(3,"package"),b.set(4,"class"),b.set(5,"method"),b.set(6,"property"),b.set(7,"field"),b.set(8,"constructor"),b.set(9,"enum"),b.set(10,"interface"),b.set(11,"function"),b.set(12,"variable"),b.set(13,"constant"),b.set(14,"string"),b.set(15,"number"),b.set(16,"boolean"),b.set(17,"array"),b.set(18,"object"),b.set(19,"key"),b.set(20,"null"),b.set(21,"enum-member"),b.set(22,"struct"),b.set(23,"event"),b.set(24,"operator"),b.set(25,"type-parameter");function F(K){return S.get(K)}m.fromString=F;function N(K){return b.get(K)}m.toString=N;function G(K,M){const U=b.get(K);let O=U&&R.iconRegistry.get("symbol-"+U);return O||(console.info("No codicon found for SymbolKind "+K),O=R.Codicon.symbolProperty),`${M?"inline":"block"} ${O.classNames}`}m.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class g{constructor(S){this.value=S}}e.FoldingRangeKind=g,g.Comment=new g("comment"),g.Imports=new g("imports"),g.Region=new g("region");var u;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var w;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistryImpl;var D;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[62],ge([0,1,11,9,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=f.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",f.isMacintosh),R.set("isLinux",f.isLinux),R.set("isWindows",f.isWindows),R.set("isWeb",f.isWeb),R.set("isMacNative",f.isMacintosh&&!f.isWeb),R.set("isEdge",k.indexOf("Edg/")>=0),R.set("isFirefox",k.indexOf("Firefox")>=0),R.set("isChrome",k.indexOf("Chrome")>=0),R.set("isSafari",k.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return T.INSTANCE}static true(){return c.INSTANCE}static has(b){return h.create(b)}static equals(b,F){return o.create(b,F)}static notEquals(b,F){return A.create(b,F)}static regex(b,F){return r.create(b,F)}static in(b,F){return v.create(b,F)}static not(b){return E.create(b)}static and(...b){return i.create(b,null)}static or(...b){return g.create(b,null,!0)}static greater(b,F){return l.create(b,F)}static less(b,F){return p.create(b,F)}static deserialize(b,F=!1){if(!!b)return this._deserializeOrExpression(b,F)}static _deserializeOrExpression(b,F){let N=b.split("||");return g.create(N.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(b,F){let N=b.split("&&");return i.create(N.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(b,F){if(b=b.trim(),b.indexOf("!=")>=0){let N=b.split("!=");return A.create(N[0].trim(),this._deserializeValue(N[1],F))}if(b.indexOf("==")>=0){let N=b.split("==");return o.create(N[0].trim(),this._deserializeValue(N[1],F))}if(b.indexOf("=~")>=0){let N=b.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(b.indexOf(" in ")>=0){let N=b.split(" in ");return v.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const N=b.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const N=b.split(">");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const N=b.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const N=b.split("<");return p.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(b)?E.create(b.substr(1).trim()):h.create(b)}static _deserializeValue(b,F){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let N=/^'([^']*)'$/.exec(b);return N?N[1].trim():b}static _deserializeRegexValue(b,F){if((0,L.isFalsyOrWhitespace)(b)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=b.indexOf("/"),G=b.lastIndexOf("/");if(N===G||N<0){if(F)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let K=b.slice(N+1,G),M=b[G+1]==="i"?"i":"";try{return new RegExp(K,M)}catch(U){if(F)throw new Error(`bad regexp-value '${b}', parse error: ${U}`);return console.warn(`bad regexp-value '${b}', parse error: ${U}`),null}}}e.ContextKeyExpr=P;function n(S,b){return S.cmp(b)}class T{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class c{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class h{constructor(b,F){this.key=b,this.negated=F,this.type=2}static create(b,F=null){const N=R.get(b);return typeof N=="boolean"?N?c.INSTANCE:T.INSTANCE:new h(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:d(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class o{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=4}static create(b,F,N=null){if(typeof F=="boolean")return F?h.create(b,N):E.create(b,N);const G=R.get(b);return typeof G=="boolean"?F===(G?"true":"false")?c.INSTANCE:T.INSTANCE:new o(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=o;class v{constructor(b,F){this.key=b,this.valueKey=F,this.type=10,this.negated=null}static create(b,F){return new v(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const F=b.getValue(this.valueKey),N=b.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?C.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this)),this.negated}}e.ContextKeyInExpr=v;class _{constructor(b){this._actual=b,this.type=11}static create(b){return new _(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new _(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class A{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=5}static create(b,F,N=null){if(typeof F=="boolean")return F?E.create(b,N):h.create(b,N);const G=R.get(b);return typeof G=="boolean"?F===(G?"true":"false")?T.INSTANCE:c.INSTANCE:new A(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class E{constructor(b,F){this.key=b,this.negated=F,this.type=3}static create(b,F=null){const N=R.get(b);return typeof N=="boolean"?N?T.INSTANCE:c.INSTANCE:new E(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:d(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class l{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=12}static create(b,F,N=null){return new l(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class a{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=13}static create(b,F,N=null){return new a(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class p{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=14}static create(b,F,N=null){return new p(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=p;class t{constructor(b,F,N){this.key=b,this.value=F,this.negated=N,this.type=15}static create(b,F,N=null){return new t(b,F,N)}cmp(b){return b.type!==this.type?this.type-b.type:w(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(b,F){this.key=b,this.regexp=F,this.type=7,this.negated=null}static create(b,F){return new r(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const F=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return F<N?-1:F>N?1:0}equals(b){if(b.type===this.type){const F=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return this.key===b.key&&F===N}return!1}evaluate(b){let F=b.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(b){this._actual=b,this.type=8}static create(b){return new s(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new s(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(b,F){this.expr=b,this.negated=F,this.type=6}static create(b,F){return i._normalizeArr(b,F)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],b.expr[F]);if(G!==0)return G}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(b))return!1;return!0}static _normalizeArr(b,F){const N=[];let G=!1;for(const K of b)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return T.INSTANCE;if(K.type===6){N.push(...K.expr);continue}N.push(K)}if(N.length===0&&G)return c.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(n);for(let K=1;K<N.length;K++)N[K-1].equals(N[K])&&(N.splice(K,1),K--);if(N.length===1)return N[0];for(;N.length>1;){const K=N[N.length-1];if(K.type!==9)break;N.pop();const M=N.pop(),U=N.length===0,O=g.create(K.expr.map($=>i.create([$,M],null)),null,U);O&&(N.push(O),N.sort(n))}return N.length===1?N[0]:new i(N,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new i(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){const b=[];for(let F of this.expr)b.push(F.negate());this.negated=g.create(b,this,!0)}return this.negated}}class g{constructor(b,F){this.expr=b,this.negated=F,this.type=9}static create(b,F,N){return g._normalizeArr(b,F,N)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const G=n(this.expr[F],b.expr[F]);if(G!==0)return G}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}evaluate(b){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(b))return!0;return!1}static _normalizeArr(b,F,N){let G=[],K=!1;if(b){for(let M=0,U=b.length;M<U;M++){const O=b[M];if(!!O){if(O.type===0){K=!0;continue}if(O.type===1)return c.INSTANCE;if(O.type===9){G=G.concat(O.expr);continue}G.push(O)}}if(G.length===0&&K)return T.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let M=1;M<G.length;M++)G[M-1].equals(G[M])&&(G.splice(M,1),M--);if(G.length===1)return G[0];if(N){for(let M=0;M<G.length;M++)for(let U=M+1;U<G.length;U++)D(G[M],G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0]}return new g(G,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let F of this.expr)b.push(...F.keys());return b}map(b){return new g(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.negated){let b=[];for(let F of this.expr)b.push(F.negate());for(;b.length>1;){const F=b.shift(),N=b.shift(),G=[];for(const M of m(F))for(const U of m(N))G.push(i.create([M,U],null));const K=b.length===0;b.unshift(g.create(G,null,K))}this.negated=b[0]}return this.negated}}class u extends h{constructor(b,F,N){super(b,null);this._defaultValue=F,typeof N=="object"?u._info.push({...N,key:b}):N!==!0&&u._info.push({key:b,description:N,type:F!=null?typeof F:void 0})}static all(){return u._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return o.create(this.key,b)}notEqualsTo(b){return A.create(this.key,b)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(S,b){return S<b?-1:S>b?1:0}function w(S,b,F,N){return S<F?-1:S>F?1:b<N?-1:b>N?1:0}function D(S,b){if(b.type===6&&S.type!==9&&S.type!==6){for(const G of b.expr)if(S.equals(G))return!0}const F=S.negate(),N=m(F).concat(m(b));N.sort(n);for(let G=0;G<N.length;G++){const M=N[G].negate();for(let U=G+1;U<N.length;U++){const O=N[U];if(M.equals(O))return!0}}return!1}e.implies=D;function m(S){return S.type===9?S.expr:[S]}}),define(me[185],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(me[186],ge([0,1,10,11,32,156,4]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(A){A.WIN32_X64="win32-x64",A.WIN32_IA32="win32-ia32",A.WIN32_ARM64="win32-arm64",A.LINUX_X64="linux-x64",A.LINUX_ARM64="linux-arm64",A.LINUX_ARMHF="linux-armhf",A.DARWIN_X64="darwin-x64",A.DARWIN_ARM64="darwin-arm64",A.WEB="web",A.UNIVERSAL="universal",A.UNKNOWN="unknown",A.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function y(A){switch(A){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=y;function P(A,E){let l;switch(A){case 1:l=3;break;case 3:l=2;break;case 2:l=1;break}return n(l,E)}e.getTargetPlatformFromOS=P;function n(A,E){switch(A){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=n,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":n(L.platform,I.arch);function T(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=T;var c;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(c=e.SortBy||(e.SortBy={}));var h;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var o;(function(A){A.Install="install",A.Uninstall="uninstall"})(o=e.StatisticType||(e.StatisticType={}));var v;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class _ extends Error{constructor(E,l){super(E);this.code=l,this.name=l}}e.ExtensionManagementError=_,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,c){if(typeof T=="undefined"||T===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof T=="string"||typeof c=="string"){let h=typeof T=="string"?T:T.value,o=typeof c=="string"?c:c.value;return f.equalsIgnoreCase(h,o)}return T._lower===c._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=C;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function P(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[187],ge([0,1,9,26]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(o,v){return o.uuid&&v.uuid?o.uuid===v.uuid:o.id===v.id?!0:(0,f.compareIgnoreCase)(o.id,v.id)===0}e.areSameExtensions=I;class k{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof k?I(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=k;function R(o,v){return`${o}.${v}`}e.getExtensionId=R;function C(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(o,v){return C(R(o,v))}e.getGalleryExtensionId=y;function P(o,v){const _=[],A=E=>{for(const l of _)if(l.some(a=>I(v(a),v(E))))return l;return null};for(const E of o){const l=A(E);l?l.push(E):_.push([E])}return _}e.groupByExtension=P;function n(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function T(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(o){const v=new Set;for(const _ of o)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=c;function h(o,v){const _=[],A=v.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const E=A.shift();if(E&&_.every(l=>!I(l.identifier,{id:E}))){const l=o.filter(a=>I(a.identifier,{id:E}));l.length===1&&(_.push(l[0]),A.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=h}),define(me[188],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(me[189],ge([0,1,39,10,8,11,140,28,113,158,188]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=P.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends c{openTerminal(a,p){return this.spawnTerminal(f,a,y.getWindowsShell(),p)}spawnTerminal(a,p,t,r){const s=p.windowsExec||h.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=I.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return s.indexOf(" ")>=0&&g.push('""'),g.push(s),(i==="wt"||i==="wt.exe")&&g.push("-d ."),new Promise((u,d)=>{const w=_(process),D=a.spawn(t,g,{cwd:r,env:w});D.on("error",d),D.on("exit",()=>u())})}runInTerminal(a,p,t,r,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((g,u)=>{const d=`"${p} - ${T}"`,w=`""${t.join('" "')}" & pause"`,D=["/c","start",d,"/wait",i,"/c",w],m=Object.assign({},_(process),r);Object.keys(m).filter(F=>m[F]===null).forEach(F=>delete m[F]);const S={cwd:p,env:m,windowsVerbatimArguments:!0};f.spawn(h.CMD,D,S).on("error",F=>{u(A(F))}),g(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class o extends c{openTerminal(a,p){return this.spawnTerminal(f,a,p)}runInTerminal(a,p,t,r,s){const i=s.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((g,u)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",a||T,"-w",p];for(let b of t)D.push("-a"),D.push(b);if(r){const b=Object.assign({},_(process),r);for(let F in b){const N=b[F];N===null?(D.push("-u"),D.push(F)):(D.push("-e"),D.push(`${F}=${N}`))}}let m="";const S=f.spawn(o.OSASCRIPT,D);S.on("error",b=>{u(A(b))}),S.stderr.on("data",b=>{m+=b.toString()}),S.on("exit",b=>{if(b===0)g(void 0);else if(m){const F=m.split(`
`,1);u(new Error(F[0]))}else u(new Error(P.localize(1,null,d,b)))})}else u(new Error(P.localize(2,null,i)))})}spawnTerminal(a,p,t){const r=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const g=["-a",r];t&&g.push(t);const u=_(process),d=a.spawn("/usr/bin/open",g,{cwd:t,env:u});d.on("error",i),d.on("exit",()=>s())})}}e.MacExternalTerminalService=o,o.OSASCRIPT="/usr/bin/osascript";class v extends c{openTerminal(a,p){return this.spawnTerminal(f,a,p)}runInTerminal(a,p,t,r,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((g,u)=>{let d=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const D=`${E(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;d.push(`''${D}''`);const m=Object.assign({},_(process),r);Object.keys(m).filter(N=>m[N]===null).forEach(N=>delete m[N]);const S={cwd:p,env:m};let b="";const F=f.spawn(w,d,S);F.on("error",N=>{u(A(N))}),F.stderr.on("data",N=>{b+=N.toString()}),F.on("exit",N=>{if(N===0)g(void 0);else if(b){const G=b.split(`
`,1);u(new Error(G[0]))}else u(new Error(P.localize(4,null,w,N)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{k.isLinux?await C.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,p,t){const r=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{r.then(g=>{const u=_(process),d=a.spawn(g,[],{cwd:t,env:u});d.on("error",i),d.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=P.localize(3,null);function _(l){const a={...l.env};return(0,R.sanitizeProcessEnvironment)(a),a}function A(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(P.localize(5,null,l.path)):l}function E(l){let a="";for(let p of l)p.indexOf(" ")>=0?a+='"'+p+'"':a+=p,a+=" ";return a}}),define(me[42],ge([0,1,24,8,9,13,2,159,4]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(M){return M.create===!0}e.isFileOpenForWriteOptions=P;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var T;(function(M){M[M.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var c;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=h;function o(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=o;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var A;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(U,O){super(U);this.code=O}}e.FileSystemProviderError=E;function l(M,U){const O=new E(M.toString(),U);return p(O,U),O}e.createFileSystemProviderError=l;function a(M){return M||l((0,C.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=a;function p(M,U){return M.name=U?`${U} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=p;function t(M){if(!M)return A.Unknown;if(M instanceof E)return M.code;const U=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!U)return A.Unknown;switch(U[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof w)return M.fileOperationResult;switch(t(M)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(U,O,$){this.resource=U,this.operation=O,this.target=$}isOperation(U){return this.operation===U}}e.FileOperationEvent=i;var g;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class u{constructor(U,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of U)switch($.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>O)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>O)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>O)),this.deleted.set($.resource,$);break}}contains(U,...O){return this.doContains(U,{includeChildren:!1},...O)}affects(U,...O){return this.doContains(U,{includeChildren:!0},...O)}doContains(U,O,...$){if(!U)return!1;const B=$.length>0;return!!((!B||$.includes(1))&&(this.added?.get(U)||O.includeChildren&&this.added?.findSuperstr(U))||(!B||$.includes(0))&&(this.updated?.get(U)||O.includeChildren&&this.updated?.findSuperstr(U))||(!B||$.includes(2))&&(this.deleted?.findSubstr(U)||O.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=u;function d(M,U,O){return!M||!U||M===U||U.length>M.length?!1:(U.charAt(U.length-1)!==L.sep&&(U+=L.sep),O?(0,I.startsWithIgnoreCase)(M,U):M.indexOf(U)===0)}e.isParent=d;class w extends Error{constructor(U,O,$){super(U);this.fileOperationResult=O,this.options=$}}e.FileOperationError=w;class D extends w{constructor(U,O,$){super(U,2,$);this.stat=O}}e.NotModifiedSinceFileOperationError=D;var m;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(m=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var S;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(S=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=b;async function F(M,U){if(!U.canHandleResource(R.URI.from({scheme:M.scheme})))return new Promise(O=>{const $=U.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===M.scheme&&B.added&&($.dispose(),O())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(U){return(0,k.isNumber)(U)||(U=0),U<N.KB?(0,C.localize)(1,null,U.toFixed(0)):U<N.MB?(0,C.localize)(2,null,(U/N.KB).toFixed(2)):U<N.GB?(0,C.localize)(3,null,(U/N.MB).toFixed(2)):U<N.TB?(0,C.localize)(4,null,(U/N.GB).toFixed(2)):(0,C.localize)(5,null,(U/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var G;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(M){return{maxFileSize:M===0?300*N.MB:16*N.GB,maxHeapSize:M===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[k,R]of I)this.set(k,R)}set(I,k){const R=this._entries.get(I);return this._entries.set(I,k),R}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(me[190],ge([0,1,17,16,115,182,4,84]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class n{constructor(o=new C.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=o,this._strict=v,this._parent=_,this._services.set(R.IInstantiationService,this)}createChild(o){return new n(o,this._strict,this)}invokeFunction(o,...v){let _=c.traceInvocation(o),A=!1;try{return o({get:(l,a)=>{if(A)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(l,_);if(!p&&a!==R.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return p}},...v)}finally{A=!0,_.stop()}}createInstance(o,...v){let _,A;return o instanceof I.SyncDescriptor?(_=c.traceCreation(o.ctor),A=this._createInstance(o.ctor,o.staticArguments.concat(v),_)):(_=c.traceCreation(o),A=this._createInstance(o,v,_)),_.stop(),A}_createInstance(o,v=[],_){let A=R._util.getServiceDependencies(o).sort((a,p)=>a.index-p.index),E=[];for(const a of A){let p=this._getOrCreateServiceInstance(a.id,_);if(!p&&this._strict&&!a.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${a.id}.`);E.push(p)}let l=A.length>0?A[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${v.length} static arguments`);let a=l-v.length;a>0?v=v.concat(new Array(a)):v=v.slice(0,l)}return new o(...[...v,...E])}_setServiceInstance(o,v){if(this._services.get(o)instanceof I.SyncDescriptor)this._services.set(o,v);else if(this._parent)this._parent._setServiceInstance(o,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let v=this._services.get(o);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):v}_getOrCreateServiceInstance(o,v){let _=this._getServiceInstanceOrDescriptor(o);return _ instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,_,v.branch(o,!0)):(v.branch(o,!1),_)}_safeCreateAndCacheServiceInstance(o,v,_){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,v,_)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,v,_){const A=new k.Graph(a=>a.id.toString());let E=0;const l=[{id:o,desc:v,_trace:_}];for(;l.length;){const a=l.pop();if(A.lookupOrInsertNode(a),E++>1e3)throw new P(A);for(let p of R._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const r={id:p.id,desc:t,_trace:a._trace.branch(p.id,!0)};A.insertEdge(a,r),l.push(r)}}}for(;;){const a=A.roots();if(a.length===0){if(!A.isEmpty())throw new P(A);break}for(const{data:p}of a){if(this._getServiceInstanceOrDescriptor(p.id)instanceof I.SyncDescriptor){const r=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,r)}A.removeNode(p)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,v,_=[],A,E){if(this._services.get(o)instanceof I.SyncDescriptor)return this._createServiceInstance(v,_,A,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,v,_,A,E);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(o,v=[],_,A){if(_){const E=new f.IdleValue(()=>this._createInstance(o,v,A));return new Proxy(Object.create(null),{get(l,a){if(a in l)return l[a];let p=E.value,t=p[a];return typeof t!="function"||(t=t.bind(p),l[a]=t),t},set(l,a,p){return E.value[a]=p,!0}})}else return this._createInstance(o,v,A)}}e.InstantiationService=n;var T;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(T||(T={}));class c{constructor(o,v){this.type=o,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return y?new c(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(o){return y?new c(0,o.name):c._None}branch(o,v){let _=new c(2,o.toString());return this._dep.push([o,v,_]),_}stop(){let o=Date.now()-this._start;c._totals+=o;let v=!1;function _(E,l){let a=[],p=new Array(E+1).join("	");for(const[t,r,s]of l._dep)if(r&&s){v=!0,a.push(`${p}CREATES -> ${t}`);let i=_(E+1,s);i&&a.push(i)}else a.push(`${p}uses -> ${t}`);return a.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(o>2||v)&&console.log(A.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,61,3,6,11,4]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class P extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class n extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(g){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class T extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class c extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=c;class h extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,f.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class o extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class v extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class _ extends I.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class A{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=A;function E(p){if(p.verbose)return y.Trace;if(typeof p.logLevel=="string"){const t=l(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function l(p){switch(p){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function a(p){switch(p){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(me[116],ge([0,1,42,12]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(y,P,n,T){try{const c=await new Promise((h,o)=>{J(["spdlog"],h,o)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(y,P,n,T)}catch(c){console.error(c)}return null}function k(y,P,n,T){const c=J.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(y,P,n,T)}e.createRotatingLogger=k;function R(y,P,n){switch(P){case L.LogLevel.Trace:y.trace(n);break;case L.LogLevel.Debug:y.debug(n);break;case L.LogLevel.Info:y.info(n);break;case L.LogLevel.Warning:y.warn(n);break;case L.LogLevel.Error:y.error(n);break;case L.LogLevel.Critical:y.critical(n);break;default:throw new Error("Invalid log level")}}class C extends L.AbstractMessageLogger{constructor(P,n,T,c){super();this.name=P,this.filepath=n,this.rotating=T,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const P=this.rotating?6:1,n=30/P*f.ByteSize.MB;return I(this.name,this.filepath,n,P).then(T=>{if(T){this._logger=T,this._logger.setLevel(this.getLevel());for(const{level:c,message:h}of this.buffer)R(this._logger,c,h);this.buffer=[]}})}log(P,n){this._logger?R(this._logger,P,n):this.getLevel()<=P&&this.buffer.push({level:P,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[117],ge([0,1,48,160,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(o,v){return v-o}y.compare=P;const n=Object.create(null);n[y.Error]=(0,L.localize)(0,null),n[y.Warning]=(0,L.localize)(1,null),n[y.Info]=(0,L.localize)(2,null);function T(o){return n[o]||""}y.toString=T;function c(o){switch(o){case f.default.Error:return y.Error;case f.default.Warning:return y.Warning;case f.default.Info:return y.Info;case f.default.Ignore:return y.Hint}}y.fromSeverity=c;function h(o){switch(o){case y.Error:return f.default.Error;case y.Warning:return f.default.Warning;case y.Info:return f.default.Info;case y.Hint:return f.default.Ignore}}y.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const P="";function n(c){return T(c,!0)}y.makeKey=n;function T(c,h){let o=[P];return c.source?o.push(c.source.replace("\xA6","\\\xA6")):o.push(P),c.code?typeof c.code=="string"?o.push(c.code.replace("\xA6","\\\xA6")):o.push(c.code.value.replace("\xA6","\\\xA6")):o.push(P),c.severity!==void 0&&c.severity!==null?o.push(R.toString(c.severity)):o.push(P),c.message&&h?o.push(c.message.replace("\xA6","\\\xA6")):o.push(P),c.startLineNumber!==void 0&&c.startLineNumber!==null?o.push(c.startLineNumber.toString()):o.push(P),c.startColumn!==void 0&&c.startColumn!==null?o.push(c.startColumn.toString()):o.push(P),c.endLineNumber!==void 0&&c.endLineNumber!==null?o.push(c.endLineNumber.toString()):o.push(P),c.endColumn!==void 0&&c.endColumn!==null?o.push(c.endColumn.toString()):o.push(P),o.push(P),o.join("\xA6")}y.makeKeyOptionalMessage=T})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(me[191],ge([0,1,3,48,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,I.createDecorator)("notificationService");var k;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=y}),define(me[192],ge([0,1,6,9,2,4]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function R(C,y){return I.URI.isUri(C)?(0,L.equalsIgnoreCase)(C.scheme,y):(0,L.startsWithIgnoreCase)(C,y+":")}e.matchesScheme=R}),define(me[193],ge([0,1,10,11,32,22,179]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const y=L.globals.vscode.context.configuration();if(y)C=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const y=(0,k.dirname)(f.FileAccess.asFileUri("",J));C=J.__$__nodeRequire((0,k.joinPath)(y,"product.json").fsPath);const P=J.__$__nodeRequire((0,k.joinPath)(y,"package.json").fsPath);try{const v=(...l)=>l.reduce((a,p)=>(Object.keys(p).forEach(t=>{Array.isArray(a[t])&&Array.isArray(p[t])?a[t]=p[t]:typeof a[t]=="object"&&typeof p[t]=="object"?a[t]=v(a[t],p[t]):a[t]=p[t]}),a),{}),_=(0,R.getUserDataPath)({}),A=L.isWindows?`file:///${_}/product.json`:`file://${_}/product.json`,E=J.__$__nodeRequire(f.FileAccess.asFileUri(A,J).fsPath);C=v(C,E)}catch(v){}I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`});const{serviceUrl:n,cacheUrl:T,itemUrl:c,controlUrl:h,recommendationsUrl:o}=C.extensionsGallery||{};Object.assign(C,{extensionsGallery:{serviceUrl:I.env.VSCODE_GALLERY_SERVICE_URL||n,cacheUrl:I.env.VSCODE_GALLERY_CACHE_URL||T,itemUrl:I.env.VSCODE_GALLERY_ITEM_URL||c,controlUrl:I.env.VSCODE_GALLERY_CONTROL_URL||h,recommendationsUrl:I.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||o}}),Object.assign(C,{version:P.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.60.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=C});var Be=this&&this.__param||function(J,e){return function(f,L){e(f,L,J)}};define(me[118],ge([0,1,17,21,6,4]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(T){this.callback=T}get value(){return this._value}report(T){this._value=T,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends I.Disposable{constructor(T,c){super();this.deferred=new f.DeferredPromise,c.withProgress(T,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(T){this.reporter?this.reporter.report(T):this.lastStep=T}};y=Ve([Be(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends I.Disposable{constructor(T){super();this.progressIndicator=T,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(T){this.stop();const c=++this.currentOperationId,h=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},T),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:h.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(T){this.currentOperationId===T&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(me[35],ge([0,1,54,13]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(R,C){f.ok(L.isString(R)),f.ok(L.isObject(C)),f.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,C)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new I}),define(me[119],ge([0,1,3,35]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class k{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[I(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new k;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,155,119,35]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(A){A.Multiline="multilineText",A.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(A){A[A.APPLICATION=1]="APPLICATION",A[A.MACHINE=2]="MACHINE",A[A.WINDOW=3]="WINDOW",A[A.RESOURCE=4]="RESOURCE",A[A.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",A[A.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=R.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new f.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new f.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,l=!0){this.registerConfigurations([E],l)}registerConfigurations(E,l=!0){const a=[];E.forEach(p=>{a.push(...this.validateAndRegisterProperties(p,l,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(E){const l=[],a=p=>{if(p.properties)for(const t in p.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>a(t))};for(const p of E){a(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(E){const l=[],a=[];for(const p of E)for(const t in p)if(l.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const r={type:"object",default:this.defaultValues[t],description:I.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(c(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=p[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(E){const l=[];for(const a of E)for(const p in a)if(l.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const l of E)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,l=!0,a,p=3){p=L.isUndefinedOrNull(E.scope)?p:E.scope;let t=[],r=E.properties;if(r)for(let i in r){if(l&&v(i)){delete r[i];continue}const g=r[i];if(this.updatePropertyDefaultValue(i,g),e.OVERRIDE_PROPERTY_PATTERN.test(i)?g.scope=void 0:(g.scope=L.isUndefinedOrNull(g.scope)?p:g.scope,g.restricted=L.isUndefinedOrNull(g.restricted)?!!a?.restrictedConfigurations?.includes(i):g.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=E.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,l,a,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const l=a=>{let p=a.properties;if(p)for(const r in p)this.updateSchema(r,p[r]);let t=a.allOf;t&&t.forEach(l)};l(E)}updateSchema(E,l){switch(e.allSettings.properties[E]=l,l.scope){case 1:e.applicationSettings.properties[E]=l;break;case 2:e.machineSettings.properties[E]=l;break;case 6:e.machineOverridableSettings.properties[E]=l;break;case 3:e.windowSettings.properties[E]=l;break;case 4:e.resourceSettings.properties[E]=l;break;case 5:e.resourceSettings.properties[E]=l,this.resourceLanguageSettingsSchema.properties[E]=l;break}}removeFromSchema(E,l){switch(delete e.allSettings.properties[E],l.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const l=`[${E}]`,a={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,a),e.allSettings.properties[l]=a,e.applicationSettings.properties[l]=a,e.machineSettings.properties[l]=a,e.machineOverridableSettings.properties[l]=a,e.windowSettings.properties[l]=a,e.resourceSettings.properties[l]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,l){let a=this.defaultValues[E];L.isUndefined(a)&&(a=l.default),L.isUndefined(a)&&(a=h(l.type)),l.default=a}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function c(A){return A.substring(1,A.length-1)}e.overrideIdentifierFromKey=c;function h(A){switch(Array.isArray(A)?A[0]:A){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const o=new n;R.Registry.add(e.Extensions.Configuration,o);function v(A){return A.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(A)?I.localize(5,null,A):o.getConfigurationProperties()[A]!==void 0?I.localize(6,null,A):null:I.localize(4,null)}e.validateProperty=v;function _(){const A=[],E=o.getConfigurationProperties();for(const l of Object.keys(E))A.push([l,E[l].scope]);return A.push(["launch",4]),A.push(["task",4]),A}e.getScopes=_}),define(me[120],ge([0,1,25,13,2,85,4,35]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}e.isConfigurationOverrides=y;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function T(r,s){const i=s?r?s.keys.filter(S=>r.keys.indexOf(S)===-1):[...s.keys]:[],g=r?s?r.keys.filter(S=>s.keys.indexOf(S)===-1):[...r.keys]:[],u=[];if(s&&r){for(const S of r.keys)if(s.keys.indexOf(S)!==-1){const b=A(r.contents,S),F=A(s.contents,S);f.equals(b,F)||u.push(S)}}const d=[],w=S=>{const b={};for(const F of S)for(const N of F.identifiers)b[p(N)]=F;return b},D=s?w(s.overrides):{},m=r?w(r.overrides):{};if(Object.keys(D).length)for(const S of i){const b=D[S];b&&d.push([(0,k.overrideIdentifierFromKey)(S),b.keys])}if(Object.keys(m).length)for(const S of g){const b=m[S];b&&d.push([(0,k.overrideIdentifierFromKey)(S),b.keys])}if(Object.keys(D).length&&Object.keys(m).length)for(const S of u){const b=m[S],F=D[S];if(b&&F){const N=T({contents:b.contents,keys:b.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});d.push([(0,k.overrideIdentifierFromKey)(S),[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:g,updated:u,overrides:d}}e.compare=T;function c(r,s){const i=[];for(const g of Object.keys(r))if(k.OVERRIDE_PROPERTY_PATTERN.test(g)){const u={};for(const d in r[g])u[d]=r[g][d];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(g).trim()],keys:Object.keys(u),contents:h(u,s)})}return i}e.toOverrides=c;function h(r,s){const i=Object.create(null);for(let g in r)o(i,g,r[g],s);return i}e.toValuesTree=h;function o(r,s,i,g){const u=s.split("."),d=u.pop();let w=r;for(let D=0;D<u.length;D++){let m=u[D],S=w[m];switch(typeof S){case"undefined":S=w[m]=Object.create(null);break;case"object":break;default:g(`Ignoring ${s} as ${u.slice(0,D+1).join(".")} is ${JSON.stringify(S)}`);return}w=S}if(typeof w=="object"&&w!==null)try{w[d]=i}catch(D){g(`Ignoring ${s} as ${u.join(".")} is ${JSON.stringify(w)}`)}else g(`Ignoring ${s} as ${u.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=o;function v(r,s){const i=s.split(".");_(r,i)}e.removeFromValueTree=v;function _(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const g=r[i];typeof g=="object"&&!Array.isArray(g)&&(_(g,s),Object.keys(g).length===0&&delete r[i])}}function A(r,s,i){function g(w,D){let m=w;for(const S of D){if(typeof m!="object"||m===null)return;m=m[S]}return m}const u=s.split("."),d=g(r,u);return typeof d=="undefined"?i:d}e.getConfigurationValue=A;function E(r,s,i){Object.keys(s).forEach(g=>{g!=="__proto__"&&(g in r?L.isObject(r[g])&&L.isObject(s[g])?E(r[g],s[g],i):i&&(r[g]=s[g]):r[g]=s[g])})}e.merge=E;function l(){const r=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function a(){const r=Object.create(null),s=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in s){let g=s[i].default;o(r,i,g,u=>console.error(`Conflict in default settings: ${u}`))}return r}e.getDefaultValues=a;function p(r){return`[${r}]`}e.keyFromOverrideIdentifier=p;function t(r,s,i){const g=r.inspect(s),u=r.inspect(i);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:g.defaultValue}e.getMigratedSettingValue=t}),define(me[194],ge([0,1,20,3,57,6,24,25,13,2,120,85,35]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,n.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of f.distinct([...Object.keys(this.contents),...Object.keys(r)])){let g=this.contents[i],u=r[i];u&&(typeof g=="object"&&typeof u=="object"?(g=C.deepClone(g),this.mergeContents(g,u)):g=u),s[i]=g}return new h(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),i=[...this.keys];for(const g of t){this.mergeContents(r,g.contents);for(const u of g.overrides){const[d]=s.filter(w=>f.equals(w.identifiers,u.identifiers));d?this.mergeContents(d.contents,u.contents):s.push(C.deepClone(u))}for(const u of g.keys)i.indexOf(u)===-1&&i.push(u)}return new h(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&y.isObject(t[s])&&y.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class o extends h{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))T.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,T.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],g=>console.error(`Conflict in default settings file: ${g}`))});super(t,r,s)}}e.DefaultConfigurationModel=o;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:g,restricted:u}=this.doParseRaw(t,r);this._configurationModel=new h(s,i,g),this._restrictedConfigurations=u||[]}doParseContent(t){let r={},s=null,i=[],g=[],u=[];function d(D){Array.isArray(i)?i.push(D):s!==null&&(i[s]=D)}let w={onObjectBegin:()=>{let D={};d(D),g.push(i),i=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{i=g.pop()},onArrayBegin:()=>{let D=[];d(D),g.push(i),i=D,s=null},onArrayEnd:()=>{i=g.pop()},onLiteralValue:d,onError:(D,m,S)=>{u.push({error:D,offset:m,length:S})}};if(t)try{I.visit(t,w),r=i[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return r}doParseRaw(t,r){const s=c.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const g=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),u=Object.keys(t),d=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:g,keys:u,overrides:d,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const g={},u=[];for(let d in t)if(T.OVERRIDE_PROPERTY_PATTERN.test(d)&&s){const w=this.filter(t[d],r,!1,i);g[d]=w.raw,u.push(...w.restricted)}else{const w=r[d],D=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&u.push(d),(D===void 0||i.scopes===void 0||i.scopes.includes(D))&&(i.skipRestricted&&w?.restricted||(g[d]=t[d]))}return{raw:g,restricted:u}}}e.ConfigurationModelParser=v;class _ extends k.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class A{constructor(t,r,s=new h,i=new h,g=new R.ResourceMap,u=new h,d=new R.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=g,this._memoryConfiguration=u,this._memoryConfigurationByResource=d,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new h,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),g=this.getFolderConfigurationModelForResource(r.resource,s),u=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),S=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,b=g?r.overrideIdentifier?g.freeze().override(r.overrideIdentifier).getValue(t):g.freeze().getValue(t):void 0,F=r.overrideIdentifier?u.override(r.overrideIdentifier).getValue(t):u.getValue(t),N=i.getValue(t),G=f.distinct(f.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:d,userValue:w,userLocalValue:D,userRemoteValue:m,workspaceValue:S,workspaceFolderValue:b,memoryValue:F,value:N,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:b!==void 0?{value:g?.freeze().getValue(t),override:r.overrideIdentifier?g?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:u.getValue(t),override:r.overrideIdentifier?u.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>T.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const g=(0,T.overrideIdentifierFromKey)(i),u=this._defaultConfiguration.getKeysForOverrideIdentifier(g),d=t.getKeysForOverrideIdentifier(g),w=[...d.filter(D=>u.indexOf(D)===-1),...u.filter(D=>d.indexOf(D)===-1),...u.filter(D=>!C.equals(this._defaultConfiguration.override(g).getValue(D),t.override(g).getValue(D)))];return[g,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:g}=(0,n.compare)(this.localUserConfiguration,t),u=[...r,...s,...i];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:g}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:g}=(0,n.compare)(this.remoteUserConfiguration,t);let u=[...r,...s,...i];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:g}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:g}=(0,n.compare)(this.workspaceConfiguration,t);let u=[...r,...s,...i];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:g}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:g,removed:u,overrides:d}=(0,n.compare)(s,r);let w=[...i,...g,...u];return(w.length||!s)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:g,overrides:u}=(0,n.compare)(r,void 0);return{keys:[...s,...i,...g],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const g=this._memoryConfigurationByResource.get(t);g&&(s=s.merge(g))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:g}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:g}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),g=t.folders.reduce((u,d)=>(u.set(P.URI.revive(d[0]),this.parseConfigurationModel(d[1])),u),new R.ResourceMap);return new A(r,s,new h,i,g,new h,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=A;function E(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,r=new Map;for(const i of p)i.keys.forEach(g=>t.add(g)),i.overrides.forEach(([g,u])=>{const d=(0,R.getOrSet)(r,g,new Set);u.forEach(w=>d.add(w))});const s=[];return r.forEach((i,g)=>s.push([g,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class l{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const g=new Set;t.keys.forEach(d=>g.add(d)),t.overrides.forEach(([,d])=>d.forEach(w=>g.add(w))),this.affectedKeys=[...g.values()];const u=new h;this.affectedKeys.forEach(d=>u.setValue(d,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,n.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=l;class a extends l{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=a}),define(me[121],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(R,C=L.Unknown,y){super(R);this._message=R,this._code=C,this._detail=y,this.isHandled=C===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(R){return R instanceof I&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof I&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof I&&R.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[86],ge([0,1,10]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(P){return P.scheme===f.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=L;function I(P){if(!P)return;const n=P.indexOf("+");return n<0?P:P.substr(0,n)}e.getRemoteName=I;function k(P){return P.scheme!==f.Schemas.file&&P.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=k;function R(P){if(P.folders.length)return P.folders.every(n=>k(n.uri))?P.folders[0].uri:void 0;if(P.configuration&&k(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function C(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=C;function y(P){return R(P)!==void 0}e.isVirtualWorkspace=y}),define(me[195],ge([0,1,3,11,4,12]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService");var R;(function(h){h.Http="http",h.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=n;function T(h,o){return o?o!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=T;let c=class{constructor(o){this.logService=o,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(o,v){return this._tunnelProvider=o,o?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async o=>{const v=[],_=Array.from(this._tunnels.values());for(let A of _){const E=Array.from(A.values());for(let l of E){const a=await l.value;a&&v.push(a)}}o(v)})}async dispose(){for(const o of this._tunnels.values()){for(const{value:v}of o.values())await v.then(_=>_?.dispose());o.clear()}this._tunnels.clear()}openTunnel(o,v,_,A,E=!1,l=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${A}.`),!o)return;v||(v="localhost");const p=this.retainOrCreateTunnel(o,v,_,A,E,l,a);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,public:o.public,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const v=this._tunnels.get(o.tunnelRemoteHost);if(v){const _=v.get(o.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,_))}}}}async tryDisposeTunnel(o,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${v}.`);const A=_.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(v),A}}async closeTunnel(o,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${v} `);const _=this._tunnels.get(o);if(_&&_.has(v)){const A=_.get(v);A.refcount=0,await this.tryDisposeTunnel(o,v,A)}}addTunnelToMap(o,v,_){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(o,v){const _=this._tunnels.get(o);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(o))}getTunnelFromMap(o,v){let _=[o];P(o)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):n(o)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const A=_.map(E=>this._tunnels.get(E));for(const E of A){const l=E?.get(v);if(l)return l}}canTunnel(o){return!!y(o)}createWithProvider(o,v,_,A,E,l,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${A}.`);const t={elevationRequired:E?T(A===void 0?_:A):!1},r={remoteAddress:{host:v,port:_},localAddressPort:A,public:l,protocol:a},s=o.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,_,s),s}};c=Ve([Be(0,k.ILogService)],c),e.AbstractTunnelService=c}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{vsda(){return new Promise((I,k)=>J(["vsda"],I,k))}async sign(I){try{const k=await this.vsda(),R=new k.signer;if(R)return R.sign(I)}catch(k){}return I}}e.SignService=f}),define(me[197],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(o){o.Shell="terminal.integrated.shell.",o.ShellArgs="terminal.integrated.shellArgs.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var I;(function(o){o.ShellLinux="terminal.integrated.shell.linux",o.ShellMacOs="terminal.integrated.shell.osx",o.ShellWindows="terminal.integrated.shell.windows",o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationShellLinux="terminal.integrated.automationShell.linux",o.AutomationShellMacOs="terminal.integrated.automationShell.osx",o.AutomationShellWindows="terminal.integrated.automationShell.windows",o.ShellArgsLinux="terminal.integrated.shellArgs.linux",o.ShellArgsMacOs="terminal.integrated.shellArgs.osx",o.ShellArgsWindows="terminal.integrated.shellArgs.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.TitleMode="terminal.integrated.titleMode",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",o.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",o.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",o.LocalEchoStyle="terminal.integrated.localEchoStyle",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.CustomGlyphs="terminal.integrated.customGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover"})(I=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(o){o.CommandPrompt="cmd",o.PowerShell="pwsh",o.Wsl="wsl",o.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.Log="log",o.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,f.createDecorator)("ptyService");var y;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(o){o.TerminalView="view",o.Editor="editor"})(n=e.TerminalLocationString||(e.TerminalLocationString={}));var T;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(T=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var c;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(c=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}))}),define(me[198],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,k,R=5){let C;return C=k(y=>{const P=typeof y=="string"?y:y.data;let n=this._terminalBufferMap.get(I);if(n){n.data.push(P);return}const T=setTimeout(()=>this.flushBuffer(I),R);n={data:[P],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(I),C.dispose()}},this._terminalBufferMap.set(I,n)}),C}stopBuffering(I){const k=this._terminalBufferMap.get(I);k&&k.dispose()}flushBuffer(I){const k=this._terminalBufferMap.get(I);k&&(this._terminalBufferMap.delete(I),this._callback(I,k.data.join("")))}}e.TerminalDataBufferer=f}),define(me[199],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(me[63],ge([0,1,47,3,6,4,35,199]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var y;(function(_){function A(E){return E&&typeof E=="object"&&typeof E.id=="string"}_.isThemeColor=A})(y=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var n;(function(_){function A(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}_.isThemeIcon=A;const E=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function l(r){const s=E.exec(r);if(!s)return;let[,i]=s;return{id:i}}_.fromString=l;function a(r,s){let i=r.id;const g=i.lastIndexOf("~");return g!==-1&&(i=i.substring(0,g)),s&&(i=`${i}~${s}`),{id:i}}_.modify=a;function p(r,s){return r.id===s.id&&r.color?.id===s.color?.id}_.isEqual=p;function t(r,s){return{id:r.id,color:s?P(s):void 0}}_.asThemeIcon=t,_.asClassNameArray=f.CSSIcon.asClassNameArray,_.asClassName=f.CSSIcon.asClassName,_.asCSSSelector=f.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function T(_){switch(_){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(A);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new c;R.Registry.add(e.Extensions.ThemingContribution,h);function o(_){return h.onColorThemeChange(_)}e.registerThemingParticipant=o;class v extends I.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,E){let l=this.theme.getColor(A);return l&&E&&(l=E(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(me[200],ge([0,1,17,47,3,161,119,35,63]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(A,E,l,a){const p=this.iconsById[A];if(p){if(l&&!p.description){p.description=l,this.iconSchema.properties[A].markdownDescription=`${l} $(${A})`;const s=this.iconReferenceSchema.enum.indexOf(A);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=l),this._onDidChange.fire()}return p}let t={id:A,description:l,defaults:E,deprecationMessage:a};this.iconsById[A]=t;let r={$ref:"#/definitions/icons"};return a&&(r.deprecationMessage=a),l&&(r.markdownDescription=`${l}: $(${A})`),this.iconSchema.properties[A]=r,this.iconReferenceSchema.enum.push(A),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:A}}deregisterIcon(A){delete this.iconsById[A],delete this.iconSchema.properties[A];const E=this.iconReferenceSchema.enum.indexOf(A);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(A=>this.iconsById[A])}getIcon(A){return this.iconsById[A]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(A,E){const l=this.iconFontsById[A];if(l)return l;let a={id:A,definition:E};return this.iconFontsById[A]=a,this._onDidChange.fire(),a}deregisterIconFont(A){delete this.iconFontsById[A]}getIconFonts(){return Object.keys(this.iconFontsById).map(A=>this.iconFontsById[A])}getIconFont(A){return this.iconFontsById[A]}toString(){const A=(p,t)=>p.id.localeCompare(t.id),E=p=>{for(;y.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of a.filter(t=>!!t.description).sort(A))l.push(`|<i class="${E(p)}"></i>|${p.id}|${y.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const p of a.filter(t=>!y.ThemeIcon.isThemeIcon(t.defaults)).sort(A))l.push(`|<i class="${E(p)}"></i>|${p.id}|`);return l.join(`
`)}}const n=new P;C.Registry.add(e.Extensions.IconContribution,n);function T(_,A,E,l){return n.registerIcon(_,A,E,l)}e.registerIcon=T;function c(){return n}e.getIconRegistry=c;function h(){for(const _ of L.iconRegistry.all)n.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>n.registerIcon(_.id,_.definition,_.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let o=C.Registry.as(R.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,n.getIconSchema());const v=new f.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=T("widget-close",L.Codicon.close,(0,k.localize)(2,null)),e.gotoPreviousLocation=T("goto-previous-location",L.Codicon.arrowUp,(0,k.localize)(3,null)),e.gotoNextLocation=T("goto-next-location",L.Codicon.arrowDown,(0,k.localize)(4,null)),e.syncing=y.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,22,2,4]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var R;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function C(c){const h=c;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=C;function y(c){const h=c;return!!(h&&typeof h=="object"&&I.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(h,o,v,_){this._id=h,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class n{constructor(h,o){this.raw=o,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,L.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function T(c){return new n({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=T}),define(me[201],ge([0,1,29,57,138,80,10,8,11,22,2,162,4,86,43]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,C.extname)(M):(0,P.extname)(M))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function A(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function E(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=E;function l(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=l;function a(M){const U=M;return typeof U?.id=="string"&&n.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=a;function p(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(M){const U=M;return typeof U?.id=="string"&&n.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function r(M){const U=M;if(U?.uri)return{id:U.id,uri:n.URI.revive(U.uri)};const O=M;if(O?.configPath)return{id:O.id,configPath:n.URI.revive(O.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=r;function s(M,U){return P.extUriBiasedIgnorePathCase.isEqualOrParent(M,U.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i(M){return g(M)||u(M)}e.isStoredWorkspaceFolder=i;function g(M){const U=M;return typeof U?.path=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=g;function u(M){const U=M;return typeof U?.uri=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=u;function d(M,U,O,$,B=!y.isWindows,x){if(M.scheme!==$.scheme)return{name:O,uri:M.toString(!0)};let j=U?void 0:x.relativePath($,M);if(j!==void 0)j.length===0?j=".":y.isWindows&&M.scheme===R.Schemas.file&&!B&&(j=j.replace(/\//g,"\\"));else if(M.scheme===R.Schemas.file)j=M.fsPath,y.isWindows&&(j=(0,k.normalizeDriveLetter)(j),B&&(j=(0,f.toSlashes)(j)));else{if(!x.isEqualAuthority(M.authority,$.authority))return{name:O,uri:M.toString(!0)};j=M.path}return{name:O,path:j}}e.getStoredWorkspaceFolder=d;function w(M,U,O){let $=[],B=new Set;const x=O.dirname(U);for(let j of M){let H;if(g(j))j.path&&(H=O.resolvePath(x,j.path));else if(u(j))try{H=n.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(Q){console.warn(Q)}if(H){let Q=O.getComparisonKey(H);if(!B.has(Q)){B.add(Q);const X=j.name||O.basenameOrAuthority(H);$.push(new o.WorkspaceFolder({uri:H,name:X,index:$.length},j))}}}return $}e.toWorkspaceFolders=w;function D(M,U,O,$,B){let x=m(U,M);const j=B.dirname(U),H=B.dirname($),Q=[],X=S(x.folders);for(const Le of x.folders){const ze=g(Le)?B.resolvePath(j,Le.path):n.URI.parse(Le.uri);let xe;O?xe=!1:xe=!g(Le)||(0,C.isAbsolute)(Le.path),Q.push(d(ze,xe,Le.name,H,X,B))}const fe={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=I.setProperty(M,["folders"],Q,fe);let ye=I.applyEdits(M,_e);return x.remoteAuthority===(0,h.getRemoteAuthority)($)&&(ye=I.applyEdits(ye,I.removeProperty(ye,["remoteAuthority"],fe))),ye}e.rewriteWorkspaceFileForNewLocation=D;function m(M,U){let O=L.parse(U);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter($=>i($));else throw new Error(`${M} looks like an invalid workspace file.`);return O}function S(M){return y.isWindows?M.some(U=>g(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=S;function b(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function N(M){return typeof M.fileUri=="string"}function G(M,U){const O={workspaces:[],files:[]};if(M){const $=function(x,j){for(let H=0;H<x.length;H++)try{j(x[H],H)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(x[H])}: ${Q.toString()}. Skip entry.`)}},B=M;if(Array.isArray(B.entries))$(B.entries,x=>{const j=x.label,H=x.remoteAuthority;b(x)?O.workspaces.push({label:j,remoteAuthority:H,workspace:{id:x.workspace.id,configPath:n.URI.parse(x.workspace.configPath)}}):F(x)?O.workspaces.push({label:j,remoteAuthority:H,folderUri:n.URI.parse(x.folderUri)}):N(x)&&O.files.push({label:j,remoteAuthority:H,fileUri:n.URI.parse(x.fileUri)})});else{const x=M;Array.isArray(x.workspaces3)&&$(x.workspaces3,(j,H)=>{const Q=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?O.workspaces.push({label:Q,workspace:{id:j.id,configPath:n.URI.parse(j.configURIPath)}}):typeof j=="string"&&O.workspaces.push({label:Q,folderUri:n.URI.parse(j)})}),Array.isArray(x.files2)&&$(x.files2,(j,H)=>{const Q=Array.isArray(x.fileLabels)&&x.fileLabels[H]||void 0;typeof j=="string"&&O.files.push({label:Q,fileUri:n.URI.parse(j)})})}}return O}e.restoreRecentlyOpened=G;function K(M){const U={entries:[]};for(const O of M.workspaces)E(O)?U.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):U.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of M.files)U.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return U}e.toStoreData=K}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const k=this._idPool++;return this._data.set(k,I),this.logDebugInfo(),k}get(I,k){return this._data.has(I)?this._data.get(I)[k]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class k{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(y=>({name:y.name,group:y.group,resource:f.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=k}),define(me[64],ge([0,1,10,4]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(R,C){C===null?this._providerInfo.delete(R):this._providerInfo.set(R,C)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(me[202],ge([0,1,17]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,C,y){this._deferredPromises=new Map,this._id=R,this._shared=C,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of P.values())n.complete()}catch(n){for(const T of P.values())T.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,C){let y=this._value[R];return typeof y=="undefined"&&(y=C),y}update(R,C){this._value[R]=C;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const P=new f.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(R,C){super(R.identifier.value,!0,C);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=I}),define(me[203],ge([0,1,3,2,12]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let k=class{constructor(C,y){this._logService=C,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,y,P){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(C,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,y);const P=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};k=Ve([Be(0,I.ILogService)],k),e.ExtHostNotebookDocuments=k}),define(me[14],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class L{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[204],ge([0,1,26,3]),function(J,e,f,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{constructor(C,y){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(C.identifier),st(this,I,y,"f"),He(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return He(this,I,"f").get(this._id,C)}store(C,y){return He(this,I,"f").store(this._id,C,y)}delete(C){return He(this,I,"f").delete(this._id,C)}}e.ExtensionSecrets=k,I=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(me[88],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,I=(E,l)=>{const a={controllerId:l};return L.set(E,a),a};e.createPrivateApiFor=I;const k=E=>L.get(E);e.getPrivateApiFor=k;const R=(E,l,a,p)=>{let t=a;return{enumerable:!0,configurable:!1,get(){return t},set(r){if(!p(t,r)){const s=t;t=r,E.listener?.({op:3,key:l,value:r,previous:s})}}}},C=(E,l)=>E===l,y={range:(E,l)=>E===l?!0:!E||!l?!1:E.isEqual(l),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(E,l)=>!(E.length!==l.length||E.some(a=>!l.find(p=>a.id===p.id)))},P=Object.keys(y),n=(E,l)=>({range:R(E,"range",void 0,y.range),label:R(E,"label",l,y.label),description:R(E,"description",void 0,y.description),canResolveChildren:R(E,"canResolveChildren",!1,y.canResolveChildren),busy:R(E,"busy",!1,y.busy),error:R(E,"error",void 0,y.error),tags:R(E,"tags",[],y.tags)}),T=(E,l)=>{const a=new Map;for(const p of P)y[p](E[p],l[p])||a.set(p,l[p]);return a};e.diffTestItems=T;class c extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=c;class h extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class o extends Error{constructor(l,a,p){super(`TestItem with ID "${l}" is from controller "${a}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const v=E=>{const l=(0,e.getPrivateApiFor)(E);let a=new Map;return{get size(){return a.size},forEach(p,t){for(const r of a.values())p.call(t,r,this)},replace(p){const t=new Map,r=new Set(a.keys()),s={op:4,ops:[]};for(const i of p){if(!(i instanceof _))throw new h(i.id);const g=(0,e.getPrivateApiFor)(i).controllerId;if(g!==l.controllerId)throw new o(i.id,g,l.controllerId);if(t.has(i.id))throw new c(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});l.listener?.(s),a=t},add(p){if(!(p instanceof _))throw new h(p.id);a.set(p.id,p),l.listener?.({op:0,item:p})},delete(p){a.delete(p)&&l.listener?.({op:1,id:p})},get(p){return a.get(p)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class _{constructor(l,a,p,t){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const r=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof A?void 0:r.parent}},children:{value:v(this),enumerable:!0,writable:!1},...n(r,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class A extends _{constructor(l,a){super(l,l,a,void 0)}}e.TestItemRootImpl=A}),define(me[52],ge([0,1,4,3,14]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(C){function y(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}C.fromApiTunnel=y;function P(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}C.fromServiceTunnel=P})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let R=class{constructor(y){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,P){return{dispose:()=>{}}}async $providePortAttributes(y,P,n,T,c){return[]}async $forwardPort(y,P){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([Be(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,20,16,99,24,102,13,2,33,42,121]),function(J,e,f,L,I,k,R,C,y,P,n,T){"use strict";var c,h,o,v,_,A,E,l,a,p,t,r,s,i,g,u,d,w,D,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function S(V){function W(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(W,V),Object.setPrototypeOf(W.prototype,V.prototype),W}let b=_=class{constructor(W){c.set(this,void 0),st(this,c,W,"f")}static from(...W){let se=W;return new _(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof He(this,c,"f")=="function"&&(He(this,c,"f").call(this),st(this,c,void 0,"f"))}};c=new WeakMap,b=_=Ve([S],b),e.Disposable=b;let F=A=class{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const et=W[Ce];et.isBefore(se)&&(se=et)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Ce=1;Ce<W.length;Ce++){const et=W[Ce];et.isAfter(se)&&(se=et)}return se}static isPosition(W){if(!W)return!1;if(W instanceof A)return!0;let{line:se,character:Ce}=W;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=0:typeof W=="number"?Ce=W:(Ce=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),Ce===0&&se===0?this:new A(this.line+Ce,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=this.line:typeof W=="number"?Ce=W:(Ce=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),Ce===this.line&&se===this.character?this:new A(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};F=A=Ve([S],F),e.Position=F;let N=E=class{constructor(W,se,Ce,et){let rt,ut;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(rt=new F(W,se),ut=new F(Ce,et)):W instanceof F&&se instanceof F&&(rt=W,ut=se),!rt||!ut)throw new Error("Invalid arguments");rt.isBefore(ut)?(this._start=rt,this._end=ut):(this._start=ut,this._end=rt)}static isRange(W){return W instanceof E?!0:W?F.isPosition(W.start)&&F.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof E?this.contains(W._start)&&this.contains(W._end):W instanceof F?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=F.Max(W.start,this._start),Ce=F.Min(W.end,this._end);if(!se.isAfter(Ce))return new E(se,Ce)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=F.Min(W.start,this._start),Ce=F.Max(W.end,this.end);return new E(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,L.illegalArgument)();let Ce;return W?F.isPosition(W)?Ce=W:(Ce=W.start||this.start,se=W.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new E(Ce,se)}toJSON(){return[this.start,this.end]}};N=E=Ve([S],N),e.Range=N;let G=l=class extends N{constructor(W,se,Ce,et){let rt,ut;if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"?(rt=new F(W,se),ut=new F(Ce,et)):W instanceof F&&se instanceof F&&(rt=W,ut=se),!rt||!ut)throw new Error("Invalid arguments");super(rt,ut);this._anchor=rt,this._active=ut}static isSelection(W){return W instanceof l?!0:W?N.isRange(W)&&F.isPosition(W.anchor)&&F.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=l=Ve([S],G),e.Selection=G;class K{constructor(W,se,Ce){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=K;class M extends Error{constructor(W,se=T.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(W);this._message=W,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(W,se){return new M(W,T.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new M(W,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var U;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var O;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=a=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof a?!0:W?N.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new a(W,se)}static insert(W,se){return a.replace(new N(W,W),se)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const se=new a(new N(new F(0,0),new F(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!N.isRange(W))throw(0,L.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=a=Ve([S],$),e.TextEdit=$;var B;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let x=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,Ce,et){this._edits.push({_type:1,from:W,to:se,options:Ce,metadata:et})}createFile(W,se,Ce){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:Ce})}deleteFile(W,se,Ce){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata(W,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,Ce,et,rt){let ut,ht,Dt=[],At;if(Wt.isNotebookRange(se)&&Rt.isNotebookCellDataArray(Ce)&&!Rt.isNotebookCellDataArray(et)?(ut=se.start,ht=se.end,Dt=Ce,At=et):typeof se=="number"&&typeof Ce=="number"&&Rt.isNotebookCellDataArray(et)&&(ut=se,ht=Ce,Dt=et,At=rt),ut===void 0||ht===void 0)throw new Error("Invalid arguments");(ut!==ht||Dt.length>0)&&this._edits.push({_type:5,uri:W,index:ut,count:ht-ut,cells:Dt,metadata:At})}replaceNotebookCellMetadata(W,se,Ce,et){this._edits.push({_type:3,metadata:et,uri:W,edit:{editType:8,index:se,metadata:Ce}})}replace(W,se,Ce,et){this._edits.push({_type:2,uri:W,edit:new $(se,Ce),metadata:et})}insert(W,se,Ce,et){this.replace(W,new N(se,se),Ce,et)}delete(W,se,Ce){this.replace(W,se,"",Ce)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:W,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const et=this._edits[Ce];et._type===2&&et.uri.toString()===W.toString()&&(this._edits[Ce]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===W.toString()&&se.push(Ce.edit);return se}entries(){const W=new k.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=W.get(se.uri);Ce||(Ce=[se.uri,[]],W.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};x=Ve([S],x),e.WorkspaceEdit=x;let j=p=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof p?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=p._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const Ce=new p;Ce._tabstop=this._tabstop,W(Ce),this._tabstop=Ce._tabstop,W=Ce.value}else W=p._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const Ce=W.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const Ce=new p;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};j=p=Ve([S],j),e.SnippetString=j;var H;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=t=class{constructor(W,se){if(this.uri=W,se)if(se instanceof N)this.range=se;else if(se instanceof F)this.range=new N(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof t?!0:W?N.isRange(W.range)&&y.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=t=Ve([S],X),e.Location=X;let fe=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&N.isRange(W.location.range)&&y.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};fe=Ve([S],fe),e.DiagnosticRelatedInformation=fe;let _e=class{constructor(W,se,Ce=Q.Error){if(!N.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=Ce}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,f.equals)(W.tags,se.tags)&&(0,f.equals)(W.relatedInformation,se.relatedInformation,fe.isEqual)}};_e=Ve([S],_e),e.Diagnostic=_e;let ye=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=se}};ye=Ve([S],ye),e.Hover=ye;var Le;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(W,se=Le.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:Le[this.kind]}}};ze=Ve([S],ze),e.DocumentHighlight=ze;var xe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(V){V[V.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let z=r=class{constructor(W,se,Ce,et,rt){this.name=W,this.kind=se,this.containerName=rt,typeof Ce=="string"&&(this.containerName=Ce),et instanceof X?this.location=et:Ce instanceof N&&(this.location=new X(et,Ce)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};z=r=Ve([S],z),e.SymbolInformation=z;let ee=s=class{constructor(W,se,Ce,et,rt){this.name=W,this.detail=se,this.kind=Ce,this.range=et,this.selectionRange=rt,this.children=[],s.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(s.validate)}};ee=s=Ve([S],ee),e.DocumentSymbol=ee;var re;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,se){this.title=W,this.kind=se}};ae=Ve([S],ae),e.CodeAction=ae;let Y=i=class{constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};Y.sep=".",Y=i=Ve([S],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let oe=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([S],oe),e.SelectionRange=oe;class ve{constructor(W,se,Ce,et,rt,ut){this.kind=W,this.name=se,this.detail=Ce,this.uri=et,this.range=rt,this.selectionRange=ut}}e.CallHierarchyItem=ve;class Me{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=Me;class je{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=je;var Ke;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};Se=Ve([S],Se),e.CodeLens=Se;let nt=g=class{constructor(W,se=!1){h.set(this,void 0),st(this,h,new I.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof g?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return He(this,h,"f").value}set value(W){He(this,h,"f").value=W}get isTrusted(){return He(this,h,"f").isTrusted}set isTrusted(W){He(this,h,"f").isTrusted=W}get supportThemeIcons(){return He(this,h,"f").supportThemeIcons}set supportThemeIcons(W){He(this,h,"f").supportThemeIcons=W}appendText(W){return He(this,h,"f").appendText(W),this}appendMarkdown(W){return He(this,h,"f").appendMarkdown(W),this}appendCodeblock(W,se){return He(this,h,"f").appendCodeblock(se??"",W),this}};h=new WeakMap,nt=g=Ve([S],nt),e.MarkdownString=nt;let Z=class{constructor(W,se){this.label=W,this.documentation=se}};Z=Ve([S],Z),e.ParameterInformation=Z;let te=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};te=Ve([S],te),e.SignatureInformation=te;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=Ve([S],pe),e.SignatureHelp=pe;var Ue;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ue=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ye;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Ye=e.InlayHintKind||(e.InlayHintKind={}));let it=class{constructor(W,se,Ce){this.text=W,this.position=se,this.kind=Ce}};it=Ve([S],it),e.InlayHint=it;var ft;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var pt;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(pt=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(V){V[V.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Ct=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ct=Ve([S],Ct),e.CompletionItem=Ct;let ue=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};ue=Ve([S],ue),e.CompletionList=ue;let Ie=class{constructor(W,se,Ce){this.text=W,this.range=se,this.command=Ce}};Ie=Ve([S],Ie),e.InlineSuggestion=Ie;let Ne=class{constructor(W){this.items=W}};Ne=Ve([S],Ne),e.InlineSuggestions=Ne;var Qe;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var We;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function W(se){switch(se){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(W,se){if(se&&!y.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!N.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=se}};be=Ve([S],be),e.DocumentLink=be;let we=class{constructor(W,se,Ce,et){this.red=W,this.green=se,this.blue=Ce,this.alpha=et}};we=Ve([S],we),e.Color=we;let Fe=class{constructor(W,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!N.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=se}};Fe=Ve([S],Fe),e.ColorInformation=Fe;let qe=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};qe=Ve([S],qe),e.ColorPresentation=qe;var $e;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})($e=e.ColorFormat||(e.ColorFormat={}));var Je;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class tt{constructor(W,se,Ce){if(this.startIndex=W,this.length=se,this.tooltip=Ce,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=tt;var le;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(W){this.options=W,typeof W!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ae=u=class{constructor(W,se){if(this.label=se,typeof W!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};Ae.Clean=new u("clean","Clean"),Ae.Build=new u("build","Build"),Ae.Rebuild=new u("rebuild","Rebuild"),Ae.Test=new u("test","Test"),Ae=u=Ve([S],Ae),e.TaskGroup=Ae;function Pe(V){let W="";for(let se=0;se<V.length;se++)W+=V[se].replace(/,/g,",,")+",";return W}let Ze=class{constructor(W,se,Ce){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return Pe(W)}};Ze=Ve([S],Ze),e.ProcessExecution=Ze;let Xe=class{constructor(W,se,Ce){if(this._args=[],Array.isArray(se)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W,this._args=se,this._options=Ce}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return Pe(W)}};Xe=Ve([S],Xe),e.ShellExecution=Xe;var ot;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Et{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Et;let lt=d=class{constructor(W,se,Ce,et,rt,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=et,ht=rt,this.__deprecated=!0):se===vt.Global||se===vt.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=rt,ht=ut):(this.target=se,this._name=this.name=Ce,this._source=this.source=et,this.execution=rt,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(d.EmptyType===se||d.ProcessType===se||d.ShellType===se||d.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=d=Ve([S],lt),e.Task=lt;var dt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(W,se=Lt.None){this.collapsibleState=se,y.URI.isUri(W)?this.resourceUri=W:this.label=W}};mt=Ve([S],mt),e.TreeItem=mt;var Lt;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Lt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(W,se){this.id=W,this.color=se}};yt=Ve([S],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Nt=class{constructor(W){this.id=W}};Nt=Ve([S],Nt),e.ThemeColor=Nt;var un;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(un=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(W,se){if(typeof W!="string"&&(!W||!y.URI.isUri(W)&&!y.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=y.URI.file(W),this.base=W):y.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};It=Ve([S],It),e.RelativePattern=It;let Bt=class{constructor(W,se,Ce,et){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Bt=Ve([S],Bt),e.Breakpoint=Bt;let en=class extends Bt{constructor(W,se,Ce,et,rt){super(se,Ce,et,rt);if(W===null)throw(0,L.illegalArgument)("location");this.location=W}};en=Ve([S],en),e.SourceBreakpoint=en;let wt=class extends Bt{constructor(W,se,Ce,et,rt){super(se,Ce,et,rt);this.functionName=W}};wt=Ve([S],wt),e.FunctionBreakpoint=wt;let Qt=class extends Bt{constructor(W,se,Ce,et,rt,ut,ht){super(et,rt,ut,ht);if(!se)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=Ce}};Qt=Ve([S],Qt),e.DataBreakpoint=Qt;let Ht=class{constructor(W,se,Ce){this.command=W,this.args=se||[],this.options=Ce}};Ht=Ve([S],Ht),e.DebugAdapterExecutable=Ht;let tn=class{constructor(W,se){this.port=W,this.host=se}};tn=Ve([S],tn),e.DebugAdapterServer=tn;let nn=class{constructor(W){this.path=W}};nn=Ve([S],nn),e.DebugAdapterNamedPipeServer=nn;let Pt=class{constructor(W){this.implementation=W}};Pt=Ve([S],Pt),e.DebugAdapterInlineImplementation=Pt;let Xt=class{constructor(W,se){this.range=W,this.expression=se}};Xt=Ve([S],Xt),e.EvaluatableExpression=Xt;var wn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(wn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let $t=class{constructor(W,se){this.range=W,this.text=se}};$t=Ve([S],$t),e.InlineValueText=$t;let gt=class{constructor(W,se,Ce=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=Ce}};gt=Ve([S],gt),e.InlineValueVariableLookup=gt;let rn=class{constructor(W,se){this.range=W,this.expression=se}};rn=Ve([S],rn),e.InlineValueEvaluatableExpression=rn;let Ft=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};Ft=Ve([S],Ft),e.InlineValueContext=Ft;var zt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(zt=e.FileChangeType||(e.FileChangeType={}));let Yt=w=class extends Error{constructor(W,se=n.FileSystemProviderErrorCode.Unknown,Ce){super(y.URI.isUri(W)?W.toString(!0):W);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(W){return new w(W,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(W){return new w(W,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(W){return new w(W,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(W){return new w(W,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Yt=w=Ve([S],Yt),e.FileSystemError=Yt;let sn=class{constructor(W,se,Ce){this.start=W,this.end=se,this.kind=Ce}};sn=Ve([S],sn),e.FoldingRange=sn;var dn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(dn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(hn=e.CommentMode||(e.CommentMode={}));class on{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=on;function En(V){return typeof V=="undefined"||(0,C.isStringArray)(V)}class Vt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,Ce=W.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,Ce=W.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,Ce,et,rt){if(typeof W=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof et=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(W,se,Ce,et,rt);if(N.isRange(W)&&typeof se=="string"&&En(Ce))return this._push(W,se,Ce);throw(0,L.illegalArgument)()}_push(W,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=W.start.line,rt=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(se);let Dt=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(At);Dt|=1<<Mt>>>0}this._pushEncoded(et,rt,ut,ht,Dt)}_pushEncoded(W,se,Ce,et,rt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Mt=0;for(let Ot=0;Ot<Dt;Ot++){let Ut=this._data[5*Ot],ln=this._data[5*Ot+1];Ut===0?(Ut=At,ln+=Mt):Ut+=At,this._data[5*Ot]=Ut,this._data[5*Ot+1]=ln,At=Ut,Mt=ln}}let ut=W,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=et,this._data[this._dataLen++]=rt,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const Ce=W.length/5|0;for(let ht=0;ht<Ce;ht++)se[ht]=ht;se.sort((ht,Dt)=>{const At=W[5*ht],Mt=W[5*Dt];if(At===Mt){const Ot=W[5*ht+1],Ut=W[5*Dt+1];return Ot-Ut}return At-Mt});const et=new Uint32Array(W.length);let rt=0,ut=0;for(let ht=0;ht<Ce;ht++){const Dt=5*se[ht],At=W[Dt+0],Mt=W[Dt+1],Ot=W[Dt+2],Ut=W[Dt+3],ln=W[Dt+4],xn=At-rt,Gn=xn===0?Mt-ut:Mt,cn=5*ht;et[cn+0]=xn,et[cn+1]=Gn,et[cn+2]=Ot,et[cn+3]=Ut,et[cn+4]=ln,rt=At,ut=Mt}return et}build(W){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),W):new jt(Vt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Vt;class jt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=jt;class _n{constructor(W,se,Ce){this.start=W,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=_n;class Sn{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=Sn;var qt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new yt("arrow-left")},Jt=Ve([S],Jt),e.QuickInputButtons=Jt;var Dn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,se,Ce){this.badge=W,this.tooltip=se,this.color=Ce}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let Gt=class{constructor(W){this.kind=W}};Gt=Ve([S],Gt),e.ColorTheme=Gt;var fn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(fn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(W,se){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");W<=se?(this._start=W,this._end=se):(this._start=se,this._end=W)}static isNotebookRange(W){return W instanceof Wt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,Ce=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(Ce=W.end),se===this._start&&Ce===this._end?this:new Wt(se,Ce)}}e.NotebookRange=Wt;class Rt{constructor(W,se,Ce,et,rt,ut,ht){this.kind=W,this.value=se,this.languageId=Ce,this.mime=et,this.outputs=rt??[],this.metadata=ut,this.executionSummary=ht,Rt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(se=>Rt.isNotebookCellData(se))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Rt;class Oe{constructor(W){this.cells=W}}e.NotebookData=Oe;class Tt{constructor(W,se){this.data=W,this.mime=se;const Ce=(0,R.normalizeMimeType)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(W){return W instanceof Tt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const se={name:W.name,message:W.message,stack:W.stack};return Tt.json(se,"application/vnd.code.notebook.error")}static stdout(W){return Tt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Tt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,se="application/octet-stream"){return new Tt(W,se)}static text(W,se=R.Mimes.text){const Ce=He(Tt,o,"f",v).encode(String(W));return new Tt(Ce,se)}static json(W,se="application/json"){const Ce=JSON.stringify(W,void 0,"	");return Tt.text(Ce,se)}}e.NotebookCellOutputItem=Tt,o=Tt,v={value:new TextEncoder};class Kt{constructor(W,se,Ce){this.items=Kt.ensureUniqueMimeTypes(W,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,P.generateUuid)(),this.metadata=se??Ce)}static isNotebookCellOutput(W){return W instanceof Kt?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,C.isArray)(W.items)}static ensureUniqueMimeTypes(W,se=!1){const Ce=new Set,et=new Set;for(let rt=0;rt<W.length;rt++){const ut=W[rt],ht=(0,R.normalizeMimeType)(ut.mime);if(!Ce.has(ht)){Ce.add(ht);continue}et.add(rt),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return et.size===0?W:W.filter((rt,ut)=>!et.has(ut))}}e.NotebookCellOutput=Kt;var bt;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor(W,se){this.text=W,this.alignment=se}}e.NotebookCellStatusBarItem=gn;var Pn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(W,se=[]){this.uri=W,this.provides=(0,f.asArray)(se)}}e.NotebookRendererScript=An;let an=class{constructor(W,se){this.label=W,this.timestamp=se}};an=Ve([S],an),e.TimelineItem=an;var Tn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var pn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor(W,se){this._port=W,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(W,se,Ce){this.include=W,this.exclude=se,this.profile=Ce}};ie=Ve([S],ie),e.TestRunRequest=ie;let he=D=class{constructor(W){this.message=W}static diff(W,se,Ce){const et=new D(W);return et.expectedOutput=se,et.actualOutput=Ce,et}};he=D=Ve([S],he),e.TestMessage=he;let Te=class{constructor(W,se){if(this.id=W,this.label=se,/\s/.test(W))throw new Error(`Test tag ID "${W}" may not include whitespace`)}};Te=Ve([S],Te),e.TestTag=Te;let ct=class{constructor(W,se){this.covered=W,this.total=se}};ct=Ve([S],ct),e.CoveredCount=ct;let _t=m=class{constructor(W,se,Ce,et){this.uri=W,this.statementCoverage=se,this.branchCoverage=Ce,this.functionCoverage=et}static fromDetails(W,se){const Ce=new ct(0,0),et=new ct(0,0),rt=new ct(0,0);for(const ht of se)if("branches"in ht){Ce.total+=1,Ce.covered+=ht.executionCount>0?1:0;for(const Dt of ht.branches)et.total+=1,et.covered+=Dt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const ut=new m(W,Ce,et.total>0?et:void 0,rt.total>0?rt:void 0);return ut.detailedCoverage=se,ut}};_t=m=Ve([S],_t),e.FileCoverage=_t;let kt=class{constructor(W,se,Ce=[]){this.executionCount=W,this.location=se,this.branches=Ce}};kt=Ve([S],kt),e.StatementCoverage=kt;let Nn=class{constructor(W,se){this.executionCount=W,this.location=se}};Nn=Ve([S],Nn),e.BranchCoverage=Nn;let Un=class{constructor(W,se){this.executionCount=W,this.location=se}};Un=Ve([S],Un),e.FunctionCoverage=Un;var zn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(W,se,Ce,et,rt,ut){this.kind=W,this.name=se,this.detail=Ce,this.uri=et,this.range=rt,this.selectionRange=ut}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,54,10,9,149,110,7,20]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function n(o,v){v?P.set(o,v):P.delete(o)}e.setWordDefinitionFor=n;function T(o){return P.get(o)}e.getWordDefinitionFor=T;class c extends k.MirrorTextModel{constructor(v,_,A,E,l,a,p,t){super(_,A,E,l);this._proxy=v,this._languageId=a,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,y.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,A){return v._getWordRangeAtPosition(_,A)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,f.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,f.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const A=this._eol,E=_.start.line,l=_.end.line,a=[];a.push(this._lines[E].substring(_.start.character));for(let p=E+1;p<l;p++)a.push(this._lines[p]);return a.push(this._lines[l].substring(0,_.end.character)),a.join(A)}_lineAt(v){let _;if(v instanceof C.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new h(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),A=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,A))}_validateRange(v){if(!(v instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),A=this._validatePosition(v.end);return _===v.start&&A===v.end?v:new C.Range(_.line,_.character,A.line,A.character)}_validatePosition(v){if(!(v instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:A}=v,E=!1;if(_<0)_=0,A=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,A=this._lines[_].length,E=!0;else{const l=this._lines[_].length;A<0?(A=0,E=!0):A>l&&(A=l,E=!0)}return E?new C.Position(_,A):v}_getWordRangeAtPosition(v,_){const A=this._validatePosition(v);if(!_)_=T(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(A.character+1,(0,R.ensureValidWordDefinition)(_),this._lines[A.line],0);if(E)return new C.Range(A.line,E.startColumn-1,A.line,E.endColumn-1)}}e.ExtHostDocumentData=c;class h{constructor(v,_,A){this._line=v,this._text=_,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(me[205],ge([0,1,7,3,112,6,81,24,2,33]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,h,o,v){this._notebook=o,this._selector=v,this._disposables=new k.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(A=>{const E=this._cellUris.get(A.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(A=>_(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const c=[],h=[];for(const o of this._notebook.getCells())o.kind===f.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),c.push(o.document.getText().length+1),h.push(o.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(c){if(!c){let E="";for(const l of this._cells)E+=l.document.getText()+`
`;return E=E.slice(0,-1),E}if(c.isEmpty)return"";const h=this.locationAt(c.start),o=this.locationAt(c.end),v=this._cellUris.get(h.uri),_=this._cellUris.get(o.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new f.Range(h.range.start,o.range.end));const A=[this._cells[v].document.getText(new f.Range(h.range.start,new f.Position(this._cells[v].document.lineCount,0)))];for(let E=v+1;E<_;E++)A.push(this._cells[E].document.getText());return A.push(this._cells[_].document.getText(new f.Range(new f.Position(0,0),o.range.end))),A.join(`
`)}offsetAt(c){const h=this._cellLines.getIndexOf(c.line),o=this._cellLengths.getPrefixSum(h.index-1),v=this._cells[h.index].document.offsetAt(c.with(h.remainder));return o+v}positionAt(c){if(typeof c=="number"){const o=this._cellLengths.getIndexOf(c),v=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(v)}const h=this._cellUris.get(c.uri);if(h!==void 0){const o=this._cellLines.getPrefixSum(h-1);return new f.Position(o+c.range.start.line,c.range.start.character)}return new f.Position(0,0)}locationAt(c){f.Range.isRange(c)||(c=new f.Range(c,c));const h=this._cellLines.getIndexOf(c.start.line);let o=h;c.isEmpty||(o=this._cellLines.getIndexOf(c.end.line));const v=new f.Position(h.remainder,c.start.character),_=new f.Position(o.remainder,c.end.character),A=new f.Range(v,_),E=this._cells[h.index];return new f.Location(E.document.uri,E.document.validateRange(A))}contains(c){return this._cellUris.has(c)}validateRange(c){const h=this.validatePosition(c.start),o=this.validatePosition(c.end);return c.with(h,o)}validatePosition(c){const h=this._cellLines.getIndexOf(c.line),o=new f.Position(h.remainder,c.character),v=this._cells[h.index].document.validatePosition(o),_=this._cellLines.getPrefixSum(h.index-1);return new f.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[206],ge([0,1,7,14,3]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(C){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?f.ColorThemeKind.Light:C==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};k=Ve([Be(0,L.IExtHostRpcService)],k),e.ExtHostTheming=k}),define(me[65],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class L{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[207],ge([0,1,23]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function I(C,y){if(y.serializeBuffersForPostMessage){const P=new L,n=(h,o)=>{if(o instanceof ArrayBuffer){const v=P.add(o);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(o)){const v=k(o);if(v){const _=P.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},T=JSON.stringify(C,n),c=P.buffers.map(h=>{const o=new Uint8Array(h);return f.VSBuffer.wrap(o)});return{message:T,buffers:c}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=I;function k(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(C,y){const P=y.map(c=>{const h=new ArrayBuffer(c.byteLength);return new Uint8Array(h).set(c.buffer),h}),n=y.length?(c,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const o=h,{index:v}=o,_=P[v];if(o.view)switch(o.view.type){case 1:return new Int8Array(_,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return h}:void 0;return{message:JSON.parse(C,n),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(me[208],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(L){function I(R){const C={items:new Map};return R.types.forEach((y,P)=>{C.items.set(y,{asString:async()=>R.items[P].asString})}),C}L.toITreeDataTransfer=I;async function k(R){const C={types:[],items:[]},y=Array.from(R.items.entries());for(const P of y)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}L.toTreeDataTransferDTO=k})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[89],ge([0,1,10,2]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(C,y){return C.scheme===f.Schemas.http||C.scheme===f.Schemas.https?C:(y&&y.authority&&y.isRemote&&C.scheme===f.Schemas.file&&(C=L.URI.from({scheme:f.Schemas.vscodeRemote,authority:y.authority,path:C.path})),L.URI.from({scheme:f.Schemas.https,authority:`${C.scheme}+${k(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=I;function k(C){return C.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function R(C){return C.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(me[209],ge([0,1,3,6,89]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(C,y,P){this._proxy=C,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const n=y.getVisibleTextEditors();for(const T of this._insets.values())n.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,y,P,n,T){let c;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===C){c=l;break}if(!c)throw new Error("not a visible editor");const h=this,o=this._handlePool++,v=new f.Emitter,_=new f.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,I.asWebviewUri)(l,h._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(l){this._options=l,h._proxy.$setOptions(o,l)}get options(){return this._options}set html(l){this._html=l,h._proxy.$setHtml(o,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return h._proxy.$postMessage(o,l)}},E=new class{constructor(){this.editor=C,this.line=y,this.height=P,this.webview=A,this.onDidDispose=_.event}dispose(){h._insets.has(o)&&(h._insets.delete(o),h._proxy.$disposeEditorInset(o),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(o,c.id,c.value.document.uri,y+1,P,n||{},T.identifier,T.extensionLocation),this._insets.set(o,{editor:C,inset:E,onDidReceiveMessage:v}),E}$onDidDispose(C){const y=this._insets.get(C);y&&y.inset.dispose()}$onDidReceiveMessage(C,y){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=k}),define(me[210],ge([0,1,171,13,2,6,4,62,35,20,10]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,f.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(14,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(15,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,f.localize)(17,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,f.localize)(18,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,f.localize)(19,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(20,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,f.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function T(m){return typeof m?.getViewState=="function"}e.isTextEditorPane=T;function c(m){if(l(m))return!1;const S=m;return I.URI.isUri(S?.resource)}e.isResourceEditorInput=c;function h(m){if(l(m))return!1;const S=m;return S?.original!==void 0&&S.modified!==void 0}e.isResourceDiffEditorInput=h;function o(m){if(l(m))return!1;const S=m;return S?S.resource===void 0||S.resource.scheme===n.Schemas.untitled||S.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=o;var v;(function(m){m[m.SHORT=0]="SHORT",m[m.MEDIUM=1]="MEDIUM",m[m.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(m){m[m.EXPLICIT=1]="EXPLICIT",m[m.AUTO=2]="AUTO",m[m.FOCUS_CHANGE=3]="FOCUS_CHANGE",m[m.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var A;(function(m){m[m.None=0]="None",m[m.Readonly=2]="Readonly",m[m.Untitled=4]="Untitled",m[m.Singleton=8]="Singleton",m[m.RequiresTrust=16]="RequiresTrust"})(A=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends k.Disposable{}e.AbstractEditorInput=E;function l(m){return m instanceof E}e.isEditorInput=l;function a(m){const S=m;return I.URI.isUri(S?.preferredResource)}function p(m){const S=m;return l(S?.primary)&&l(S?.secondary)}e.isSideBySideEditorInput=p;function t(m){return l(m?.editor)}e.isEditorInputWithOptions=t;function r(m){const S=m;return t(m)&&S?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(m){const S=m;return typeof S?.groupId=="number"&&l(S.editor)}e.isEditorIdentifier=s;var i;(function(m){m[m.PRIMARY=1]="PRIMARY",m[m.SECONDARY=2]="SECONDARY",m[m.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class g{getOriginalUri(S,b){if(!S)return;const F=p(S)?S.primary:h(S)?S.modified:void 0,N=p(S)?S.secondary:h(S)?S.original:void 0;if(b?.supportSideBySide&&F&&N){if(b?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(F,{filterByScheme:b.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:b.filterByScheme})};S=b.supportSideBySide===i.PRIMARY?F:N}if(h(S))return;const G=a(S)?S.preferredResource:S.resource;return!G||!b||!b.filterByScheme?G:this.filterUri(G,b.filterByScheme)}getCanonicalUri(S,b){if(!S)return;const F=p(S)?S.primary:h(S)?S.modified:void 0,N=p(S)?S.secondary:h(S)?S.original:void 0;if(b?.supportSideBySide&&F&&N){if(b?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(F,{filterByScheme:b.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:b.filterByScheme})};S=b.supportSideBySide===i.PRIMARY?F:N}if(h(S))return;const G=S.resource;return!G||!b||!b.filterByScheme?G:this.filterUri(G,b.filterByScheme)}filterUri(S,b){if(Array.isArray(b)){if(b.some(F=>S.scheme===F))return S}else if(b===S.scheme)return S}}e.EditorResourceAccessor=new g;var u;(function(m){m[m.LEFT=0]="LEFT",m[m.RIGHT=1]="RIGHT"})(u=e.CloseDirection||(e.CloseDirection={}));class d{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(S){const b=this.instantiationService=S.get(R.IInstantiationService);for(const[F,N]of this.editorSerializerConstructors)this.createEditorSerializer(F,N,b);this.editorSerializerConstructors.clear()}createEditorSerializer(S,b,F){const N=F.createInstance(b);this.editorSerializerInstances.set(S,N)}registerFileEditorFactory(S){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=S}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(S,b){if(this.editorSerializerConstructors.has(S)||this.editorSerializerInstances.has(S))throw new Error(`A editor serializer with type ID '${S}' was already registered.`);return this.instantiationService?this.createEditorSerializer(S,b,this.instantiationService):this.editorSerializerConstructors.set(S,b),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(S),this.editorSerializerInstances.delete(S)})}getEditorSerializer(S){return this.editorSerializerInstances.get(typeof S=="string"?S:S.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new d);async function w(m,S){if(!m||!m.length)return[];const b=await Promise.all(m.map(async F=>{const N=I.URI.revive(F.fileUri);if(!N||(await S.activateProvider(N.scheme),!S.canHandleResource(N)))return;const G=typeof F.exists=="boolean"?F.exists:await S.exists(N);if(!G&&F.openOnlyIfExists)return;const K=G&&!(0,L.isUndefined)(F.selection)?{selection:F.selection,pinned:!0,override:F.editorOverrideId}:{pinned:!0,override:F.editorOverrideId};let M;return G?M={resource:N,options:K,forceFile:!0}:M={resource:N,options:K,forceUntitled:!0},M}));return(0,P.coalesce)(b)}e.pathsToEditors=w;var D;(function(m){m[m.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",m[m.SEQUENTIAL=1]="SEQUENTIAL"})(D=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[211],ge([0,1,3,62,172,4,6,24,35,20,55,25,47,200]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",c.Codicon.window,(0,I.localize)(0,null));var o;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var v;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(g){switch(g){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function A(g){return`viewContainer.${g}.enabled`}e.getEnabledViewContainerContextKey=A;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new f.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new f.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(u,d,w){const D=this.get(u.id);if(D)return D;const m=u;return m.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,C.getOrSet)(this.viewContainers,d,[]).push(m),w?.isDefault&&this.defaultViewContainers.push(m),this._onDidRegister.fire({viewContainer:m,viewContainerLocation:d}),m}deregisterViewContainer(u){for(const d of this.viewContainers.keys()){const w=this.viewContainers.get(d),D=w?.indexOf(u);if(D!==-1){w?.splice(D,1),w.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(w=>w?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===u)}}y.Registry.add(o.ViewContainersRegistry,new E);var l;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function a(g,u){const d=g.group??l.More,w=u.group??l.More;return d!==w?d.localeCompare(w):(g.order??5)-(u.order??5)}class p extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new f.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new f.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new f.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new f.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:w})=>this.addViews(d,w)),this._onViewsRegistered.fire(u)}deregisterViews(u,d){const w=this.removeViews(u,d);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:d})}moveViews(u,d){for(const w of this._views.keys())if(w!==d){const D=this.removeViews(u,w);D.length&&(this.addViews(D,d),this._onDidChangeContainer.fire({views:D,from:w,to:d}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const d of this._viewContainers){const w=(this._views.get(d)||[]).filter(D=>D.id===u)[0];if(w)return w}return null}getViewContainer(u){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(D=>D.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this._viewWelcomeContents.add(u,d),this._onDidChangeViewWelcomeContent.fire(u),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,d),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,d){const w=new Map;for(const[D,m]of d)this._viewWelcomeContents.add(u,m),w.set(D,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,m),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),w}getViewWelcomeContent(u){const d=[];return this._viewWelcomeContents.forEach(u,w=>d.push(w)),d.sort(a)}addViews(u,d){let w=this._views.get(d);w||(w=[],this._views.set(d,w),this._viewContainers.push(d));for(const D of u){if(this.getView(D.id)!==null)throw new Error((0,I.localize)(1,null,D.id));w.push(D)}}removeViews(u,d){const w=this._views.get(d);if(!w)return[];const D=[],m=[];for(const S of w)u.includes(S)?D.push(S):m.push(S);return D.length&&(m.length?this._views.set(d,m):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),D}}y.Registry.add(o.ViewsRegistry,new p),e.IViewsService=(0,k.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(g){return`view.${g}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var r;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(u,d){this.resolved=!1,this._hasResolve=!1,(0,T.mixin)(this,u),this._hasResolve=!!d,this.resolve=async w=>{if(d&&!this.resolved){const D=await d(w);D&&(this.tooltip=this.tooltip??D.tooltip,this.command=this.command??D.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,17,173]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,P,n){const T={command:C};if(y&&Object.keys(y).length>0&&(T.arguments=y),this.internalSend("request",T),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const h=this.pendingRequests.get(T.seq);if(h){this.pendingRequests.delete(T.seq);const o={type:"response",seq:0,request_seq:T.seq,success:!1,command:C,message:(0,I.localize)(0,null,n,C)};h(o)}},n)}return P&&this.pendingRequests.set(T.seq,P),T.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,P)=>C.set(P,y)),await(0,L.timeout)(500),C.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(me[212],ge([0,1,9,2,8,25,10]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(s,i,g){return s.replace(C,function(u,d){return i&&d.length>0&&d[0]!=="_"?u:g&&g.hasOwnProperty(d)?g[d]:u})}e.formatPII=y;function P(s){const i={};for(const g of Object.keys(s))g.startsWith("!")||(i[g]=s[g]);return i}e.filterExceptionsFromTelemetry=P;function n(s){return s.configuration.request==="attach"&&!T(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function T(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?T(s.parentSession):void 0}e.getExtensionHostDebugSession=T;function c(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=c;function h(s,i,g){let u,d=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=w.exec(s);){let m=D.index+1,S=m+D[0].length;if(m<=i&&S>=g){u=D[0],d=m;break}}if(u){let m=/\w+/g,S=null;for(;(S=m.exec(u))&&!(S.index+1+d+S[0].length>=g););S&&(u=u.substring(0,m.lastIndex))}return u?{start:d,end:d+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(s){return!!(s&&s.match(o))}e.isUri=v;function _(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(v(s.path))return L.URI.parse(s.path);if((0,I.isAbsolute)(s.path))return L.URI.file(s.path)}return s.path}function A(s){if(typeof s.path=="object"){const i=L.URI.revive(s.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return s.path}function E(s,i){const g=i?_:A,u=(0,k.deepClone)(s);return a(u,(d,w)=>{d&&w&&(w.path=g(w))}),u}e.convertToDAPaths=E;function l(s,i){const g=i?_:A,u=(0,k.deepClone)(s);return a(u,(d,w)=>{!d&&w&&(w.path=g(w))}),u}e.convertToVSCPaths=l;function a(s,i){switch(s.type){case"event":const g=s;switch(g.event){case"output":i(!1,g.body.source);break;case"loadedSource":i(!1,g.body.source);break;case"breakpoint":i(!1,g.body.breakpoint.source);break;default:break}break;case"request":const u=s;switch(u.command){case"setBreakpoints":i(!0,u.arguments.source);break;case"breakpointLocations":i(!0,u.arguments.source);break;case"source":i(!0,u.arguments.source);break;case"gotoTargets":i(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const d=s;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":d.body.sources.forEach(w=>i(!1,w));break;case"scopes":d.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":d.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function p(s){return s.filter(i=>!i.presentation?.hidden).sort((i,g)=>i.presentation?g.presentation?i.presentation.group?g.presentation.group?i.presentation.group!==g.presentation.group?i.presentation.group.localeCompare(g.presentation.group):t(i.presentation.order,g.presentation.order):-1:g.presentation.group?1:t(i.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=p;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function r(s,i){const g=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(g!=="none"&&(await i.saveAll(),g==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&await i.save({editor:u.input,groupId:u.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(me[213],ge([0,1,28,39,174,125,8,9,25,11,186,124]),function(J,e,f,L,I,k,R,C,y,P,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends T.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",a=>this.handleData(a))}sendMessage(E){if(this.outputStream){const l=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${c.TWO_CRLF}${l}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+l))}continue}}else{const l=this.rawData.indexOf(c.TWO_CRLF);if(l!==-1){const p=this.rawData.toString("utf8",0,l).split(c.HEADER_LINESEPARATOR);for(const t of p){const r=t.split(c.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(l+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class h extends c{startSession(){return new Promise((E,l)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",p=>{a?this._onError.fire(p):l(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class o extends h{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=o;class v extends h{constructor(E){super();this.adapterServer=E}createConnection(E){return k.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=v;class _ extends c{constructor(E,l,a){super();this.adapterExecutable=E,this.debugType=l,this.outputService=a}async startSession(){const E=this.adapterExecutable.command,l=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(E)if(R.isAbsolute(E)){if(!await f.Promises.exists(E))throw new Error(I.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let p=process.env;if(a.env&&Object.keys(a.env).length>0&&(p=y.mixin(y.deepClone(process.env),a.env)),E==="node")if(Array.isArray(l)&&l.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:p,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(s.cwd=a.cwd);const i=L.fork(l[0],l.slice(1),s);if(!i.pid)throw new Error(I.localize(2,null,l[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const r={env:p};a.cwd&&(r.cwd=a.cwd),this.serverProcess=L.spawn(E,l,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,l)=>{const a=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,r){if(p)return l(p)});a.on("exit",E),a.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,l){if(!E)return;const a=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?a.runtime=R.join(l,E.runtime):a.runtime=E.runtime),E.runtimeArgs&&(a.runtimeArgs=E.runtimeArgs),E.program&&(R.isAbsolute(E.program)?a.program=E.program:a.program=R.join(l,E.program)),E.args&&(a.args=E.args);const p=E;return p.win&&(a.win=_.extract(p.win,l)),p.winx86&&(a.winx86=_.extract(p.winx86,l)),p.windows&&(a.windows=_.extract(p.windows,l)),p.osx&&(a.osx=_.extract(p.osx,l)),p.linux&&(a.linux=_.extract(p.linux,l)),a}static platformAdapterExecutable(E,l){let a=Object.create(null);l=l.toLowerCase();for(const g of E)if(g.contributes){const u=g.contributes.debuggers;u&&u.length>0&&u.filter(d=>typeof d.type=="string"&&C.equalsIgnoreCase(d.type,l)).forEach(d=>{const w=_.extract(d,g.extensionLocation.fsPath);a=y.mixin(a,w,g.isBuiltin)})}let p;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=a.winx86||a.win||a.windows:P.isWindows?p=a.win||a.windows:P.isMacintosh?p=a.osx:P.isLinux&&(p=a.linux),p=p||a;let t=p.program||a.program;const r=p.args||a.args;let s=p.runtime||a.runtime;const i=p.runtimeArgs||a.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[214],ge([0,1,39,11,29,189]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(c,h){return new Promise((o,v)=>{let _="";const A=f.spawn(c,h);A.pid&&A.stdout.on("data",E=>{_+=E.toString()}),A.on("error",E=>{v(E)}),A.on("close",E=>{o(_)})})}let C;function y(c,h){if(!C)if(L.isWindows)C=new k.WindowsExternalTerminalService;else if(L.isMacintosh)C=new k.MacExternalTerminalService;else if(L.isLinux)C=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=h.getConfiguration("terminal");return C.runInTerminal(c.title,c.cwd,c.args,c.env||{},o.external||{})}e.runInExternalTerminal=y;function P(c){return c?L.isWindows?new Promise(async h=>{(await new Promise((v,_)=>{J(["windows-process-tree"],v,_)})).getProcessTree(c,v=>{h(v.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(c)]).then(h=>{const o=h.trim();return!(o.length===0||o.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var n;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(n||(n={}));function T(c,h,o,v){c=c.trim().toLowerCase();let _;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?_=1:c.indexOf("cmd.exe")>=0?_=0:c.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let A,E=" ";switch(_){case 1:if(A=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),o){const a=(0,I.getDriveLetter)(o);a&&(E+=`${a}:; `),E+=`cd ${A(o)}; `}if(v)for(let a in v){const p=v[a];p===null?E+=`Remove-Item env:${a}; `:E+=`\${env:${a}}='${p}'; `}if(h.length>0){const a=A(h.shift());E+=a[0]==="'"?`& ${a} `:`${a} `;for(let p of h)E+=`${A(p)} `}break;case 0:if(A=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),o){const a=(0,I.getDriveLetter)(o);a&&(E+=`${a}: && `),E+=`cd ${A(o)} && `}if(v){E+='cmd /C "';for(let a in v){let p=v[a];p===null?E+=`set "${a}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${a}=${p}" && `)}}for(let a of h)E+=`${A(a)} `;v&&(E+='"');break;case 2:A=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const l=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(o&&(E+=`cd ${A(o)} ; `),v){E+="/usr/bin/env";for(let a in v){const p=v[a];p===null?E+=` -u ${l(a)}`:E+=` ${l(`${a}=${p}`)}`}E+=" "}for(let a of h)E+=`${A(a)} `;break}return E}e.prepareCommand=T}),define(me[126],ge([0,1,30,102,10,8,11,62]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(m){m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(m){m.scheme=I.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function b(M,U){return M.with({scheme:m.scheme,fragment:`ch${U.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}m.generate=b;function F(M){if(M.scheme!==m.scheme)return;const U=S.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}:void 0}m.parse=F;function N(M){if(M.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const U=S.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}:void 0}m.parseCellMetadataUri=N;function G(M,U,O){return M.with({scheme:O,fragment:`ch${U.toString().padStart(7,"0")}${M.scheme!==I.Schemas.file?M.scheme:""}`})}m.generateCellUri=G;function K(M,U){if(M.scheme!==U)return;const O=S.exec(M.fragment);return O?{handle:Number(O[1]),notebook:M.with({scheme:M.fragment.substr(O[0].length)||I.Schemas.file,fragment:null})}:void 0}m.parseCellUri=K})(_=e.CellUri||(e.CellUri={}));const A=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(m){return A.get(m)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function l(m){return A.get(m)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function a(m){return A.get(m)?.mergeable??!1}e.mimeTypeIsMergeable=a;function p(m,S){return R.isWindows&&(m=m.replace(/\//g,"\\"),S=S.replace(/\//g,"\\")),f.match(m,S)}function t(m,S,b){let F=0;for(let N=0;N<S.length;N++){if(p(S[N],m))return F;F++}for(let N=0;N<b.length;N++){if(p(b[N],m))return F;F++}return F}function r(m,S,b){return m.sort((F,N)=>t(F,S,b)-t(N,S,b))}e.sortMimeTypes=r;function s(m,S,b,F=(N,G)=>N===G){const N=[];function G(U,O,$){if(O===0&&$.length===0)return;const B=N[N.length-1];B&&B.start+B.deleteCount===U?(B.deleteCount+=O,B.toInsert.push(...$)):N.push({start:U,deleteCount:O,toInsert:$})}let K=0,M=0;for(;;){if(K===m.length){G(K,0,S.slice(M));break}if(M===S.length){G(K,m.length-K,[]);break}const U=m[K],O=S[M];if(F(U,O)){K+=1,M+=1;continue}b(O)?(G(K,1,[]),K+=1):(G(K,0,[O]),M+=1)}return N}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(m){m.default="default",m.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function g(m){const S=m;return!!((typeof S.include=="string"||f.isRelativePattern(S.include))&&(typeof S.exclude=="string"||f.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=g;function u(m,S,b){if(Array.isArray(m.viewType)&&m.viewType.indexOf(S)>=0||m.viewType===S)return!0;if(m.filenamePattern){let F=g(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,N=g(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(f.match(F,(0,k.basename)(b.fsPath).toLowerCase()))return!(N&&f.match(N,(0,k.basename)(b.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class d{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let b=0;b<this.textModel.cells.length;b++)S[b]=this.textModel.cells[b].getHashValue();return S}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(S){return`${D._prefix}${S}`}static parse(S){if(S.startsWith(D._prefix))return S.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(me[215],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState",I[I.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(me[216],ge([0,1,176,4,62]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[217],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var L;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(T){T[T.Error=0]="Error",T[T.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var k;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(k=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(T,c)=>{c.expand!==void 0&&(T.expand=c.expand),c.item!==void 0&&(T.item=T.item?Object.assign(T.item,c.item):c.item)};e.applyTestItemUpdate=R;var C;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var y;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.Remove=2]="Remove",T[T.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",T[T.Retire=4]="Retire",T[T.AddTag=5]="AddTag",T[T.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(c){}update(c){}remove(c,h){}complete(){}}e.IncrementalChangeCollector=P;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const h=this.createChangeCollector();for(const o of c)switch(o[0]){case 0:{const v=o[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const A=this.createItem(v,_);this.items.set(v.item.extId,A),h.add(A)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),h.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=o[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),h.update(_);break}case 2:{const v=this.items.get(o[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[o[1]]];for(;_.length;)for(const A of _.pop()){const E=this.items.get(A);E&&(_.push(E.children),this.items.delete(A),h.remove(E,E!==v),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}h.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=n}),define(me[90],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(k){k.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class I{constructor(R,C=R.length){if(this.path=R,this.viewEnd=C,R.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,C,y=R.parent){if(R.id===C)return new I([C]);let P=[R.id];for(let n=y;n&&n.id!==C;n=n.parent)P.push(n.id);return P.push(C),new I(P.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new I(R.split("\0"))}static join(R,C){return new I([...R.path,C])}static joinToString(R,C){return R.toString()+"\0"+C}static compare(R,C){return R===C?0:C.startsWith(R+"\0")?2:R.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let C=0;C<R.viewEnd&&C<this.viewEnd;C++)if(R.path[C]!==this.path[C])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=I}),define(me[218],ge([0,1,8,32,13,25,11,80,177]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(T,c,h){this._contributedVariables=new Map,this._context=T,this._labelService=c,h&&(this._envVariablesPromise=h.then(o=>this.prepareEnv(o)))}prepareEnv(T){if(R.isWindows){const c=Object.create(null);return Object.keys(T).forEach(h=>{c[h.toLowerCase()]=T[h]}),c}return T}resolveWithEnvironment(T,c,h){return this.recursiveResolve(this.prepareEnv(T),c?c.uri:void 0,h)}async resolveAsync(T,c){return this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,c)}async resolveAnyBase(T,c,h,o){const v=k.deepClone(c);return R.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):R.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):R.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,T?T.uri:void 0,v,h,o)}async resolveAnyAsync(T,c,h){return this.resolveAnyBase(T,c,h)}async resolveAnyMap(T,c,h){const o=new Map;return{newConfig:await this.resolveAnyBase(T,c,h,o),resolvedVariables:o}}resolveWithInteractionReplace(T,c,h,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,c,h,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,c){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,c)}recursiveResolve(T,c,h,o,v){if(I.isString(h))return this.resolveString(T,c,h,o,v);if(I.isArray(h))return h.map(_=>this.recursiveResolve(T,c,_,o,v));if(I.isObject(h)){let _=Object.create(null);return Object.keys(h).forEach(A=>{const E=this.resolveString(T,c,A,o,v);_[E]=this.recursiveResolve(T,c,h[A],o,v)}),_}return h}resolveString(T,c,h,o,v){return h.replace(P.VARIABLE_REGEXP,(A,E)=>{if(E.includes(P.VARIABLE_LHS))return A;let l=this.evaluateSingleVariable(T,A,E,c,o);return v&&v.set(E,l),l!==A&&I.isString(l)&&l.match(P.VARIABLE_REGEXP)&&(l=this.resolveString(T,c,l,o,v)),l})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,c,h,o,v){let _;const A=h.split(":");A.length>1&&(h=A[0],_=A[1]);const E=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,y.localize)(0,null,c))},l=()=>{const p=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,c,f.basename(p)))},a=()=>{if(_){const p=this._context.getFolderUri(_);if(p)return p;throw new Error((0,y.localize)(2,null,c,_))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,c)):new Error((0,y.localize)(4,null,c))};switch(h){case"env":if(_){if(T){const p=T[R.isWindows?_.toLowerCase():_];if(I.isString(p))return p}return""}throw new Error((0,y.localize)(5,null,c));case"config":if(_){const p=this._context.getConfigurationValue(o,_);if(I.isUndefinedOrNull(p))throw new Error((0,y.localize)(6,null,c,_));if(I.isObject(p))throw new Error((0,y.localize)(7,null,c,_));return p}throw new Error((0,y.localize)(8,null,c));case"command":return this.resolveFromMap(c,_,v,"command");case"input":return this.resolveFromMap(c,_,v,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return o||_?(0,C.normalizeDriveLetter)(this.fsPath(a())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(a()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,y.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,c));case"file":return E();case"fileWorkspaceFolder":return l();case"relativeFile":return o||_?f.relative(this.fsPath(a()),E()):E();case"relativeFileDirname":const r=f.dirname(E());if(o||_){const u=f.relative(this.fsPath(a()),r);return u.length===0?".":u}return r;case"fileDirname":return f.dirname(E());case"fileExtname":return f.extname(E());case"fileBasename":return f.basename(E());case"fileBasenameNoExtension":const s=f.basename(E());return s.slice(0,s.length-f.extname(s).length);case"fileDirnameBasename":return f.basename(f.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||c;case"execInstallFolder":const g=this._context.getAppRoot();return g||c;case"pathSeparator":return f.sep;default:try{const u=_?`${h}:${_}`:h;return this.resolveFromMap(c,u,v,void 0)}catch(u){return c}}}}resolveFromMap(T,c,h,o){if(c&&h){const v=o===void 0?h[c]:h[o+":"+c];if(typeof v=="string")return v;throw new Error((0,y.localize)(11,null,T))}return T}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,210]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var k;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var C;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(v){const _=v;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=P;var n;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(T=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function h(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=h;function o(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(me[219],ge([0,1,4,128]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(k){const R=k;return typeof k=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=I}),define(me[15],ge([0,1,20,23,99,294,59,25,13,2,41,83,178,117,88,126,90,219,7]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(le){function Ee(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,ot=new E.Position(Ae-1,Pe-1),vt=new E.Position(Ze-1,Xe-1);return new E.Selection(ot,vt)}le.to=Ee;function ce(q){const{anchor:Ae,active:Pe}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}le.from=ce})(l=e.Selection||(e.Selection={}));var a;(function(le){function Ee(q){if(!q)return;const{start:Ae,end:Pe}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}le.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Ae,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new E.Range(Ae-1,Pe-1,Ze-1,Xe-1)}le.to=ce})(a=e.Range||(e.Range={}));var p;(function(le){function Ee(ce){switch(ce){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}le.to=Ee})(p=e.TokenType||(e.TokenType={}));var t;(function(le){function Ee(q){return new E.Position(q.lineNumber-1,q.column-1)}le.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}le.from=ce})(t=e.Position||(e.Position={}));var r;(function(le){function Ee(q){switch(q){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}le.from=Ee;function ce(q){switch(q){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}le.to=ce})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(le){function Ee(q){let Ae;return q.code&&((0,y.isString)(q.code)||(0,y.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...a.from(q.range),message:q.message,source:q.source,code:Ae,severity:g.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,f.coalesce)(q.tags.map(r.from)):void 0}}le.from=Ee;function ce(q){const Ae=new E.Diagnostic(a.to(q),q.message,g.to(q.severity));return Ae.source=q.source,Ae.code=(0,y.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Ae.tags=q.tags&&(0,f.coalesce)(q.tags.map(r.to)),Ae}le.to=ce})(s=e.Diagnostic||(e.Diagnostic={}));var i;(function(le){function Ee(q){return{...a.from(q.location.range),message:q.message,resource:q.location.uri}}le.from=Ee;function ce(q){return new E.DiagnosticRelatedInformation(new E.Location(q.resource,a.to(q)),q.message)}le.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(le){function Ee(q){switch(q){case E.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}le.from=Ee;function ce(q){switch(q){case h.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}le.to=ce})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(le){function Ee(q){return typeof q=="number"&&q>=E.ViewColumn.One?q-1:q===E.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}le.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ce})(u=e.ViewColumn||(e.ViewColumn={}));function d(le){return typeof le.range!="undefined"}function w(le){return le.length===0?!0:!!d(le[0])}e.isDecorationOptionsArr=w;var D;(function(le){function Ee(Xe){return Xe.map(le.from)}le.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let ot;if(ce(Xe)){const{language:dt,value:mt}=Xe;ot={value:"```"+dt+`
`+mt+"\n```\n"}}else E.MarkdownString.isMarkdownString(Xe)?ot={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?ot={value:Xe}:ot={value:""};const vt=Object.create(null);ot.uris=vt;const Et=dt=>{try{let mt=P.URI.parse(dt,!0);mt=mt.with({query:Ae(mt.query,vt)}),vt[dt]=mt}catch(mt){}return""},lt=new k.Renderer;return lt.link=Et,lt.image=dt=>Et(I.parseHrefAndDimensions(dt).href),k(ot.value,{renderer:lt}),ot}le.from=q;function Ae(Xe,ot){if(!Xe)return Xe;let vt;try{vt=(0,R.parse)(Xe)}catch(lt){}if(!vt)return Xe;let Et=!1;return vt=(0,C.cloneAndChange)(vt,lt=>{if(P.URI.isUri(lt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[dt]=lt,Et=!0,dt}else return}),Et?JSON.stringify(vt):Xe}function Pe(Xe){const ot=new E.MarkdownString(Xe.value,Xe.supportThemeIcons);return ot.isTrusted=Xe.isTrusted,ot}le.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:le.from(Xe)}le.fromStrict=Ze})(D=e.MarkdownString||(e.MarkdownString={}));function m(le){return w(le)?le.map(Ee=>({range:a.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?D.fromMany(Ee.hoverMessage):Ee.hoverMessage?D.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):le.map(Ee=>({range:a.from(Ee)}))}e.fromRangeOrRangeWithMessage=m;function S(le){return typeof le=="undefined"?le:typeof le=="string"?P.URI.file(le):le}e.pathOrURIToURI=S;var b;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?S(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}le.from=Ee})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(le){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?b.from(ce.before):void 0,after:ce.after?b.from(ce.after):void 0}}le.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(le){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=Ee})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(le){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?N.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?S(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?b.from(ce.before):void 0,after:ce.after?b.from(ce.after):void 0}}le.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(le){function Ee(q){return{text:q.newText,eol:q.newEol&&pe.from(q.newEol),range:a.from(q.range)}}le.from=Ee;function ce(q){const Ae=new E.TextEdit(a.to(q.range),q.text);return Ae.newEol=typeof q.eol=="undefined"?void 0:pe.to(q.eol),Ae}le.to=ce})(K=e.TextEdit||(e.TextEdit={}));var M;(function(le){function Ee(q,Ae,Pe){const Ze={edits:[]};if(q instanceof E.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Ae?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:ot?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qe.from)}});return Ze}le.from=Ee;function ce(q){const Ae=new E.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ae.replace(P.URI.revive(Pe.resource),a.to(Pe.edit.range),Pe.edit.text):Ae.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Ae}le.to=ce})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(le){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof Ee[Ae]=="number"?Ee[Ae]:6}le.from=ce;function q(Ae){for(const Pe in Ee)if(Ee[Pe]===Ae)return Number(Pe);return E.SymbolKind.Property}le.to=q})(U=e.SymbolKind||(e.SymbolKind={}));var O;(function(le){function Ee(q){switch(q){case E.SymbolTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.SymbolTag.Deprecated}}le.to=ce})(O=e.SymbolTag||(e.SymbolTag={}));var $;(function(le){function Ee(q){return{name:q.name,kind:U.from(q.kind),tags:q.tags&&q.tags.map(O.from),containerName:q.containerName,location:Q.from(q.location)}}le.from=Ee;function ce(q){const Ae=new E.SymbolInformation(q.name,U.to(q.kind),q.containerName,Q.to(q.location));return Ae.tags=q.tags&&q.tags.map(O.to),Ae}le.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(le){function Ee(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:a.from(q.range),selectionRange:a.from(q.selectionRange),kind:U.from(q.kind),tags:q.tags?.map(O.from)??[]};return q.children&&(Ae.children=q.children.map(Ee)),Ae}le.from=Ee;function ce(q){const Ae=new E.DocumentSymbol(q.name,q.detail,U.to(q.kind),a.to(q.range),a.to(q.selectionRange));return(0,f.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(O.to)),q.children&&(Ae.children=q.children.map(ce)),Ae}le.to=ce})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(le){function Ee(q){const Ae=new E.CallHierarchyItem(U.to(q.kind),q.name,q.detail||"",P.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,name:q.name,detail:q.detail,kind:U.from(q.kind),uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}le.from=ce})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(le){function Ee(ce){return new E.CallHierarchyIncomingCall(x.to(ce.from),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var H;(function(le){function Ee(ce){return new E.CallHierarchyOutgoingCall(x.to(ce.to),ce.fromRanges.map(q=>a.to(q)))}le.to=Ee})(H=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(le){function Ee(q){return{range:q.range&&a.from(q.range),uri:q.uri}}le.from=Ee;function ce(q){return new E.Location(P.URI.revive(q.uri),a.to(q.range))}le.to=ce})(Q=e.location||(e.location={}));var X;(function(le){function Ee(q){const Ae=q,Pe=q;return{originSelectionRange:Ae.originSelectionRange?a.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Pe.uri,range:a.from(Ae.targetRange?Ae.targetRange:Pe.range),targetSelectionRange:Ae.targetSelectionRange?a.from(Ae.targetSelectionRange):void 0}}le.from=Ee;function ce(q){return{targetUri:P.URI.revive(q.uri),targetRange:a.to(q.range),targetSelectionRange:q.targetSelectionRange?a.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?a.to(q.originSelectionRange):void 0}}le.to=ce})(X=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(le){function Ee(q){return{range:a.from(q.range),contents:D.fromMany(q.contents)}}le.from=Ee;function ce(q){return new E.Hover(q.contents.map(D.to),a.to(q.range))}le.to=ce})(fe=e.Hover||(e.Hover={}));var _e;(function(le){function Ee(q){return{range:a.from(q.range),expression:q.expression}}le.from=Ee;function ce(q){return new E.EvaluatableExpression(a.to(q.range),q.expression)}le.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(le){function Ee(q){if(q instanceof E.InlineValueText)return{type:"text",range:a.from(q.range),text:q.text};if(q instanceof E.InlineValueVariableLookup)return{type:"variable",range:a.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}le.from=Ee;function ce(q){switch(q.type){case"text":return{range:a.to(q.range),text:q.text};case"variable":return{range:a.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:a.to(q.range),expression:q.expression}}}le.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Le;(function(le){function Ee(q){return{frameId:q.frameId,stoppedLocation:a.from(q.stoppedLocation)}}le.from=Ee;function ce(q){return new E.InlineValueContext(q.frameId,a.to(q.stoppedLocation))}le.to=ce})(Le=e.InlineValueContext||(e.InlineValueContext={}));var ze;(function(le){function Ee(q){return{range:a.from(q.range),kind:q.kind}}le.from=Ee;function ce(q){return new E.DocumentHighlight(a.to(q.range),q.kind)}le.to=ce})(ze=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(le){function Ee(ce){switch(ce){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}le.to=Ee})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(le){function Ee(ce){return{triggerKind:xe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}le.to=Ee})(Ge=e.CompletionContext||(e.CompletionContext={}));var z;(function(le){function Ee(q){switch(q){case E.CompletionItemTag.Deprecated:return 1}}le.from=Ee;function ce(q){switch(q){case 1:return E.CompletionItemTag.Deprecated}}le.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(le){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}le.from=ce;const q=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Ae(Pe){return q.get(Pe)??E.CompletionItemKind.Property}le.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(le){function Ee(ce,q){const Ae=new E.CompletionItem(ce.label);return Ae.insertText=ce.insertText,Ae.kind=ee.to(ce.kind),Ae.tags=ce.tags?.map(z.to),Ae.detail=ce.detail,Ae.documentation=I.isMarkdownString(ce.documentation)?D.to(ce.documentation):ce.documentation,Ae.sortText=ce.sortText,Ae.filterText=ce.filterText,Ae.preselect=ce.preselect,Ae.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Ae.range=a.to(ce.range):typeof ce.range=="object"&&(Ae.range={inserting:a.to(ce.range.insert),replacing:a.to(ce.range.replace)}),Ae.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Ae.insertText=new E.SnippetString(ce.insertText):(Ae.insertText=ce.insertText,Ae.textEdit=Ae.range instanceof E.Range?new E.TextEdit(Ae.range,Ae.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Ae.command=q&&ce.command?q.fromInternal(ce.command):void 0,Ae}le.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var ae;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?D.fromStrict(q.documentation):void 0}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?D.to(q.documentation):q.documentation}}le.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(le){function Ee(q){return{label:q.label,documentation:q.documentation?D.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.from):[],activeParameter:q.activeParameter}}le.from=Ee;function ce(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?D.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.to):[],activeParameter:q.activeParameter}}le.to=ce})(Y=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(le){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.from):[]}}le.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.to):[]}}le.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(le){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??E.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}le.from=Ee;function ce(q){const Ae=new E.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Ae.whitespaceAfter=q.whitespaceAfter,Ae.whitespaceBefore=q.whitespaceBefore,Ae}le.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(le){function Ee(q){return q}le.from=Ee;function ce(q){return q}le.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var je;(function(le){function Ee(q){return{range:a.from(q.range),url:q.target,tooltip:q.tooltip}}le.from=Ee;function ce(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?P.URI.parse(q.url,!0):P.URI.revive(q.url)}catch(Pe){}return new E.DocumentLink(a.to(q.range),Ae)}le.to=ce})(je=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(le){function Ee(q){const Ae=new E.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Ae}le.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>K.from(Ae)):void 0}}le.from=ce})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var Se;(function(le){function Ee(q){return new E.Color(q[0],q[1],q[2],q[3])}le.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}le.from=ce})(Se=e.Color||(e.Color={}));var nt;(function(le){function Ee(q){return{range:a.from(q.range)}}le.from=Ee;function ce(q){return new E.SelectionRange(a.to(q.range))}le.to=ce})(nt=e.SelectionRange||(e.SelectionRange={}));var Z;(function(le){function Ee(ce){switch(ce){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}le.to=Ee})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(le){function Ee(q){switch(q){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}le.from=Ee;function ce(q){switch(q){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}le.to=ce})(te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(le){function Ee(q){if(q===E.EndOfLine.CRLF)return 1;if(q===E.EndOfLine.LF)return 0}le.from=Ee;function ce(q){if(q===1)return E.EndOfLine.CRLF;if(q===0)return E.EndOfLine.LF}le.to=ce})(pe=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(le){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=Ee})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var Ye;(function(le){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=it.from(ce.kind)),q}le.from=Ee})(Ye=e.FoldingRange||(e.FoldingRange={}));var it;(function(le){function Ee(ce){if(ce)switch(ce){case E.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}le.from=Ee})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ft;(function(le){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?a.from(ce.selection):void 0,override:typeof ce.override=="boolean"?c.EditorResolution.DISABLED:void 0}}le.from=Ee})(ft=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pt;(function(le){function Ee(q){return q instanceof E.RelativePattern||typeof q=="string"?q:ce(q)?new E.RelativePattern(q.base,q.pattern):q}le.from=Ee;function ce(q){const Ae=q;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(pt=e.GlobPattern||(e.GlobPattern={}));var St;(function(le){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:pt.from(q.pattern),exclusive:q.exclusive}}}else return}le.from=Ee})(St=e.LanguageSelector||(e.LanguageSelector={}));var Ct;(function(le){function Ee(q){return{start:q.start,end:q.end}}le.from=Ee;function ce(q){return new E.NotebookRange(q.start,q.end)}le.to=ce})(Ct=e.NotebookRange||(e.NotebookRange={}));var ue;(function(le){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}le.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}le.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(le){function Ee(q){switch(q){case E.NotebookCellKind.Markup:return v.CellKind.Markup;case E.NotebookCellKind.Code:default:return v.CellKind.Code}}le.from=Ee;function ce(q){switch(q){case v.CellKind.Markup:return E.NotebookCellKind.Markup;case v.CellKind.Code:default:return E.NotebookCellKind.Code}}le.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Ne;(function(le){function Ee(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)E.NotebookCellData.validate(Pe),Ae.cells.push(Qe.from(Pe));return Ae}le.from=Ee;function ce(q){const Ae=new E.NotebookData(q.cells.map(Qe.to));return(0,y.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}le.to=ce})(Ne=e.NotebookData||(e.NotebookData={}));var Qe;(function(le){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}le.from=Ee;function ce(q){return new E.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}le.to=ce})(Qe=e.NotebookCellData||(e.NotebookCellData={}));var We;(function(le){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}le.from=Ee;function ce(q){return new E.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}le.to=ce})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(le){function Ee(q){return{outputId:q.id,items:q.items.map(We.from),metadata:q.metadata}}le.from=Ee;function ce(q){const Ae=q.items.map(We.to);return new E.NotebookCellOutput(Ae,q.outputId,q.metadata)}le.to=ce})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Re;(function(le){function Ee(Pe){if(Pe!=null){if(Pe instanceof E.RelativePattern||typeof Pe=="string")return Pe;if(Ae(Pe))return new E.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:pt.from(Pe.include)||void 0,exclude:pt.from(Pe.exclude)||void 0}}}le.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Ae(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}le.to=ce;function q(Pe){const Ze=Pe,Xe=pt.from(Ze.include);if(!(Xe&&Xe instanceof E.RelativePattern||typeof Xe=="string"))return!1;const ot=pt.from(Ze.exclude);return!!(ot&&ot instanceof E.RelativePattern||typeof ot=="string")}function Ae(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Re=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(le){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?b.from(ce.top):void 0}}le.from=Ee})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(le){function Ee(ce,q,Ae){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Ae),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}le.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(le){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}le.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(le){function Ee(q){return{uri:q.uri,provides:q.provides}}le.from=Ee;function ce(q){return new E.NotebookRendererScript(P.URI.revive(q.uri),q.provides)}le.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(le){function Ee(q){return{message:D.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}le.from=Ee;function ce(q){const Ae=new E.TestMessage(typeof q.message=="string"?q.message:D.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae}le.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(le){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),le.namespace=(ce,q)=>ce+"\0"+q,le.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(le){function Ee(Pe){const Ze=(0,o.getPrivateApiFor)(Pe).controllerId;return{extId:_.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:a.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&D.fromStrict(Pe.error)||null}}le.from=Ee;function ce(Pe){return{id:_.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:P.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new E.TestTag(Xe,Xe)}),range:a.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}le.toPlain=ce;function q(Pe){const Ze=_.TestId.fromString(Pe.extId),Xe=new o.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,P.URI.revive(Pe.uri));return Xe.range=a.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Ae(Pe){let Ze;for(const Xe of Pe.tests){const ot=q(Xe.item);(0,o.getPrivateApiFor)(ot).parent=Ze,Ze=ot}return Ze}le.toItemFromContext=Ae})(Fe=e.TestItem||(e.TestItem={})),function(le){function Ee(q){return{id:q.id,label:q.label}}le.from=Ee;function ce(q){return new E.TestTag(q.id,q.label)}le.to=ce}(we=e.TestTag||(e.TestTag={}));var qe;(function(le){const Ee=(q,Ae)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Ae.get(Ze)).filter(y.isDefined).map(Ze=>Ee(Ze,Ae))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Ae=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Ae.push(Ze);return{completedAt:q.completedAt,results:Ae.map(Ze=>Ee(Ze,Pe))}}le.to=ce})(qe=e.TestResults||(e.TestResults={}));var $e;(function(le){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):a.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}le.fromDetailed=q;function Ae(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}le.fromFile=Ae})($e=e.TestCoverage||(e.TestCoverage={}));var Je;(function(le){function Ee(ce){switch(ce){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}le.to=Ee})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var tt;(function(le){function Ee(q){const Ae=new E.TypeHierarchyItem(U.to(q.kind),q.name,q.detail||"",P.URI.revive(q.uri),a.to(q.range),a.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}le.to=Ee;function ce(q,Ae,Pe){if(Ae=Ae??q._sessionId,Pe=Pe??q._itemId,Ae===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Pe,kind:U.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:a.from(q.range),selectionRange:a.from(q.selectionRange),tags:q.tags?.map(O.from)}}le.from=ce})(tt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[220],ge([0,1,2,16,7,15,95]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,n,T,c={timeout:1500,errors:3}){this._logService=P,this._documents=n,this._mainThreadBulkEdits=T,this._thresholds=c,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(n,T,c)=>{const o={dispose:this._callbacks.push([n,T,P])};return Array.isArray(c)&&c.push(o),o}}async $participateInSave(P,n){const T=f.URI.revive(P);let c=!1;const h=setTimeout(()=>c=!0,this._thresholds.timeout),o=[];try{for(let v of[...this._callbacks]){if(c)break;const _=this._documents.getDocument(T),A=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:k.TextDocumentSaveReason.to(n)});o.push(A)}}finally{clearTimeout(h)}return o}_deliverEventAsyncAndBlameBadListeners([P,n,T],c){const h=this._badListeners.get(P);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(T,P,n,c).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const v=this._badListeners.get(P);this._badListeners.set(P,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,n,T,c){const h=[],o=Date.now(),{document:v,reason:_}=c,{version:A}=v,E=Object.freeze({document:v,reason:_,waitUntil(l){if(Object.isFrozen(h))throw(0,L.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(l))}});try{n.apply(T,[E])}catch(l){return Promise.reject(l)}return Object.freeze(h),new Promise((l,a)=>{const p=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(p),l(t)}).catch(t=>{clearTimeout(p),a(t)})}).then(l=>{const a={edits:[]};for(const p of l)if(Array.isArray(p)&&p.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:r,range:s}of p)a.edits.push({_type:2,resource:v.uri,edit:{range:s&&k.Range.from(s),text:t,eol:r&&k.EndOfLine.from(r)}});if(a.edits.length!==0)return A===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[221],ge([0,1,3,30,2,15,7]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(n,T,c,h,o){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter,this._config=0,c&&(this._config+=1),h&&(this._config+=2),o&&(this._config+=4);const v=(0,L.parse)(T),_=n(A=>{if(!c)for(let E of A.created){const l=I.URI.revive(E);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!h)for(let E of A.changed){const l=I.URI.revive(E);v(l.fsPath)&&this._onDidChange.fire(l)}if(!o)for(let E of A.deleted){const l=I.URI.revive(E);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(n,T,c){this._logService=T,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,T,c,h){return new C(this._onFileSystemEvent.event,n,T,c,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,T){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(c=>({oldUri:I.URI.revive(c.source),newUri:I.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(c=>I.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:T.map(c=>I.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,T){return(c,h,o)=>{const v=function(A){c.call(h,A)};return v.extension=n,T.event(v,void 0,o)}}async $onWillRunFileOperation(n,T,c,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))},c,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(o=>I.URI.revive(o.target))},c,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(o=>I.URI.revive(o.target))},c,h)}}async _fireWillEvent(n,T,c,h){const o=new Set,v=[];if(await n.fireAsync(T,h,async(A,E)=>{const l=Date.now(),a=await Promise.resolve(A);a instanceof R.WorkspaceEdit&&(v.push(a),o.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-l>c&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),h.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let A of v){let{edits:E}=k.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(E)}return{edit:_,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=y}),define(me[222],ge([0,1,10,25,2,15,7,126]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(c,h,o,v){this.start=c,this.deletedCount=h,this.deletedItems=o,this.items=v}static asApiEvents(c){return c.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(o=>o.apiCell)}))}}class P{constructor(c,h,o){this.notebook=c,this._extHostDocument=h,this._cellData=o,this.handle=o.handle,this.uri=I.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(c,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return c._mime},set mime(o){c._mime=o},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(k.NotebookCellOutput.to)}setOutputItems(c,h,o){const v=o.map(k.NotebookCellOutputItem.to),_=this._outputs.find(A=>A.id===c);_&&(h||(_.items.length=0),_.items.push(...v))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=P;class n{constructor(c,h,o,v,_,A){this._proxy=c,this._textDocumentsAndEditors=h,this._textDocuments=o,this._emitter=v,this.uri=_,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===f.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(h){return h=c._validateIndex(h),c._cells[h].apiCell},getCells(h){return(h?c._getCells(h):c._cells).map(v=>v.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,h){this._versionId=c.versionId,this._isDirty=h;for(const o of c.rawEvents)o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let h=c.start|0,o=c.end|0;return h<0&&(h=0),o>this._cells.length&&(o=this._cells.length),c.with({start:h,end:o})}_getCells(c){c=this._validateRange(c);const h=[];for(let o=c.start;o<c.end;o++)h.push(this._cells[o]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,h){if(this._disposed)return;const o=[],v=[],_=[];c.reverse().forEach(A=>{const l=A[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return h||v.push(P.asModelAddData(this.apiNotebook,t)),r}),a=new y(A[0],A[1],[],l),p=this._cells.splice(A[0],A[1],...l);for(const t of p)_.push(t.uri),a.deletedItems.push(t.apiCell);o.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),h||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(o)}))}_moveCell(c,h){const o=this._cells.splice(c,1);this._cells.splice(h,0,...o);const v=[new y(c,1,o.map(_=>_.apiCell),[]),new y(h,0,[],o)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(v)}))}_setCellOutputs(c,h){const o=this._cells[c];o.setOutputs(h),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(c,h,o,v){const _=this._cells[c];_.setOutputItems(h,o,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(c,h){const o=this._cells[c];o.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(o.uri,h)}_changeCellMime(c,h){const o=this._cells[c];o.apiCell.mime=h}_changeCellMetadata(c,h){const o=this._cells[c],v=o.apiCell.metadata;o.setMetadata(h);const _=o.apiCell.metadata;(0,L.equals)(v,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(c,h){const o=this._cells[c],v=o.internalMetadata;if(o.setInternalMetadata(h),v.runState!==h.runState){const _=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:_}))}}getCellFromApiCell(c){return this._cells.find(h=>h.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(h=>h.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,n){this._throwIfFinalized(),!(y===P&&n.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(y,P,n,T,c,h){this.id=y,this._proxy=P,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=T,this._viewColumn=h}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,n){y._proxy.$tryRevealRange(y.id,L.NotebookRange.from(P),n??f.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const n=new k(this.document.version);return P(n),y._applyEdit(n.finalize())},setDecorations(P,n){return y.setDecorations(P,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(L.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let n=-1;for(let T=0;T<y.cellEdits.length;T++){if(n<0){P.push(y.cellEdits[T]),n++;continue}const h=P[n],o=y.cellEdits[T];if(h.editType===1&&o.editType===1&&h.index===o.index){h.cells.push(...y.cellEdits[T].cells),h.count+=y.cellEdits[T].count;continue}P.push(y.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[223],ge([0,1,15,118,165,21,56]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(T){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=T}withProgress(T,c,h){const o=this._handles++,{title:v,location:_,cancellable:A}=c,E={label:(0,I.localize)(0,null,T.displayName||T.name),id:T.identifier.value};return this._proxy.$startProgress(o,{location:f.ProgressLocation.from(_),title:v,source:E,cancellable:A},T),this._withProgress(o,h,!!A)}_withProgress(T,c,h){let o;h&&(o=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(T,o));const v=A=>{this._proxy.$progressEnd(A),this._mapHandleToCancellationSource.delete(A),o&&o.dispose()};let _;try{_=c(new P(this._proxy,T),h&&o?o.token:k.CancellationToken.None)}catch(A){throw v(T),A}return _.then(A=>v(T),A=>v(T)),_}$acceptProgressCanceled(T){const c=this._mapHandleToCancellationSource.get(T);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(T))}}e.ExtHostProgress=C;function y(n,T){return n.message=T.message,typeof T.increment=="number"&&(typeof n.increment=="number"?n.increment+=T.increment:n.increment=T.increment),n}class P extends L.Progress{constructor(T,c){super(h=>this.throttledReport(h));this._proxy=T,this._handle=c}throttledReport(T){this._proxy.$progressReport(this._handle,T)}}Ve([(0,R.throttle)(100,(n,T)=>y(n,T),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[130],ge([0,1,54,16,76,15,7]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(c,h,o){const v=C._Keys.nextId();c.$registerTextEditorDecorationType(h.identifier,v,k.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:v,dispose(){c.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=C,C._Keys=new I.IdGenerator("TextEditorDecorationType");class y{constructor(c,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,h){this._throwIfFinalized();let o=null;if(c instanceof R.Position)o=new R.Range(c,c);else if(c instanceof R.Range)o=c;else throw new Error("Unrecognized location");this._pushEdit(o,h,!1)}insert(c,h){this._throwIfFinalized(),this._pushEdit(new R.Range(c,c),h,!0)}delete(c){this._throwIfFinalized();let h=null;if(c instanceof R.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(c,h,o){const v=this._document.validateRange(c);this._collectedEdits.push({range:v,text:h,forceMoveMarkers:o})}setEndOfLine(c){if(this._throwIfFinalized(),c!==R.EndOfLine.LF&&c!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=y;class P{constructor(c,h,o,v){this._proxy=c,this._id=h,this._accept(o),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(A){_._setTabSize(A)},get insertSpaces(){return _._insertSpaces},set insertSpaces(A){_._setInsertSpaces(A)},get cursorStyle(){return _._cursorStyle},set cursorStyle(A){_._setCursorStyle(A)},get lineNumbers(){return _._lineNumbers},set lineNumbers(A){_._setLineNumbers(A)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const h=Math.floor(c);return h>0?h:null}if(typeof c=="string"){const h=parseInt(c,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(c){const h=this._validateTabSize(c);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const h=this._validateInsertSpaces(c);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(c)})))}assign(c){const h={};let o=!1;if(typeof c.tabSize!="undefined"){const v=this._validateTabSize(c.tabSize);v==="auto"?(o=!0,h.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,o=!0,h.tabSize=v)}if(typeof c.insertSpaces!="undefined"){const v=this._validateInsertSpaces(c.insertSpaces);v==="auto"?(o=!0,h.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,o=!0,h.insertSpaces=v)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,o=!0,h.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,o=!0,h.lineNumbers=k.TextEditorLineNumbersStyle.from(c.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(c){c.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=P;class n{constructor(c,h,o,v,_,A,E,l){this.id=c,this._proxy=h,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,A,o),this._visibleRanges=E,this._viewColumn=l;const a=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,L.illegalArgument)("selection");a._selections=[p],a._trySetSelection()},get selections(){return a._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");a._selections=p,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return a._options.value},set options(p){a._disposed||a._options.assign(p)},get viewColumn(){return a._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(v.getValue(),t);return p(r),a._applyEdit(r)},insertSnippet(p,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=a._selections.map(i=>k.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:g}=k.Position.from(t);s=[{startLineNumber:i,startColumn:g,endLineNumber:i,endColumn:g}]}else if(t instanceof R.Range)s=[k.Range.from(t)];else{s=[];for(const i of t)if(i instanceof R.Range)s.push(k.Range.from(i));else{const{lineNumber:g,column:u}=k.Position.from(i);s.push({startLineNumber:g,startColumn:u,endLineNumber:g,endColumn:u})}}return h.$tryInsertSnippet(c,p.value,s,r)},setDecorations(p,t){const r=t.length===0;r&&!a._hasDecorationsForKey.has(p.key)||(r?a._hasDecorationsForKey.delete(p.key):a._hasDecorationsForKey.add(p.key),a._runOnProxy(()=>{if(k.isDecorationOptionsArr(t))return h.$trySetDecorations(c,p.key,k.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,g=t.length;i<g;i++){const u=t[i];s[4*i]=u.start.line+1,s[4*i+1]=u.start.character+1,s[4*i+2]=u.end.line+1,s[4*i+3]=u.end.character+1}return h.$trySetDecorationsFast(c,p.key,s)}}))},revealRange(p,t){a._runOnProxy(()=>h.$tryRevealRange(c,k.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){h.$tryShowEditor(c,k.ViewColumn.from(p))},hide(){h.$tryHideEditor(c)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,f.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,f.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,f.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,f.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const h=c.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const o=h.edits.map(_=>_.range);o.sort((_,A)=>_.end.line===A.end.line?_.end.character===A.end.character?_.start.line===A.start.line?_.start.character-A.start.character:_.start.line-A.start.line:_.end.character-A.end.character:_.end.line-A.end.line);for(let _=0,A=o.length-1;_<A;_++){const E=o[_].end;if(o[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=h.edits.map(_=>({range:k.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,v,{setEndOfLine:typeof h.setEndOfLine=="number"?k.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(me[224],ge([0,1,168,22,2,3,6,211,17,7,13,20,15,21,208]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(E,l){if((0,n.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let a;return Array.isArray(E.highlights)&&(a=E.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),a=a.length?a:void 0),{label:E.label,highlights:a}}}class _{constructor(l,a,p){this._proxy=l,this.commands=a,this.logService=p,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}a.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(l,a,p){const t=this.createTreeView(l,{treeDataProvider:a},p);return{dispose:()=>t.dispose()}}createTreeView(l,a,p){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(l,a,p);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,g)=>s.reveal(i,g),dispose:async()=>{await r,this.treeViews.delete(l),s.dispose()}}}$getChildren(l,a){const p=this.treeViews.get(l);return p?p.getChildren(a):Promise.reject(new Error((0,f.localize)(0,null,l)))}async $onDrop(l,a,p){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,f.localize)(1,null,l)));const r=o.TreeDataTransferConverter.toITreeDataTransfer(a);if(r.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(g=>t.getExtensionElement(g)).filter(g=>!!g);i.length>0?r.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,p)}async $hasResolve(l){const a=this.treeViews.get(l);if(!a)throw new Error((0,f.localize)(2,null,l));return a.hasResolve}$resolve(l,a,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,f.localize)(3,null,l));return t.resolveTreeItem(a,p)}$setExpanded(l,a,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,f.localize)(4,null,l));t.setExpanded(a,p)}$setSelection(l,a){const p=this.treeViews.get(l);if(!p)throw new Error((0,f.localize)(5,null,l));p.setSelection(a)}$setVisible(l,a){const p=this.treeViews.get(l);if(!p)throw new Error((0,f.localize)(6,null,l));p.setVisible(a)}createExtHostTreeView(l,a,p){const t=new A(l,a,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(l,t),t}convertArgument(l){const a=this.treeViews.get(l.$treeViewId);return a?a.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=_;class A extends R.Disposable{constructor(l,a,p,t,r,s){super();if(this.viewId=l,this.proxy=p,this.commands=t,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,s.contributes&&s.contributes.views)for(const u in s.contributes.views)for(const d of s.contributes.views[u])d.id===l&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let i,g;this._register(k.Event.debounce(this._onDidChangeData.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(w=>g=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0)(({message:u,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=g;return i=null,this.refresh(d).then(()=>w())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,n.isUndefinedOrNull)(l))}async getChildren(l){const a=l?this.getExtensionElement(l):void 0;if(l&&!a)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(l);return p||(p=await this.fetchChildrenNodes(a)),p?p.map(t=>t.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,a){a=a||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(a.select)?!0:a.select,t=(0,n.isUndefinedOrNull)(a.focus)?!1:a.focus,r=(0,n.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(s=>this.resolveTreeNode(l,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(g=>g.item)},{select:p,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:r})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,a){const p=this.getExtensionElement(l);p&&(a?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(l){(0,T.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,a){const p=this.getExtensionElement(a);if(!!p)return(0,y.asPromise)(()=>this.dndController?.onDrop(l,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,a){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(l);if(p){const t=this.nodes.get(p);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,p,a)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(a=>a?this.resolveUnknownParentChain(a).then(p=>this.resolveTreeNode(a,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(l){const a=this.nodes.get(l);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,a){const p=this.nodes.get(l);return p?Promise.resolve(p):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>this.createHandle(l,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(l){if(l){let a;if(typeof l=="string"){const p=this.getExtensionElement(l);a=p?this.nodes.get(p):void 0}else a=l;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const a=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=l?this.nodes.get(l):void 0,t=await this.dataProvider.getChildren(l);if(a.token.isCancellationRequested)return;const r=await Promise.all((0,T.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,p):null}));return a.token.isCancellationRequested?void 0:(0,T.coalesce)(r)}finally{a.dispose()}}refresh(l){if(l.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(l);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const a=new Set,p=l.map(r=>this.nodes.get(r));for(const r of p)if(r&&!a.has(r.item.handle)){let s=r;for(;s&&s.parent&&p.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&a.add(r.item.handle)}const t=[];return a.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!a.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(l){const a={};return Promise.all(l.map(p=>this.refreshNode(p).then(t=>{t&&(a[p]=t.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(l){const a=this.getExtensionElement(l);if(a){const p=this.nodes.get(a);if(p)return this.clearChildren(a),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>{if(t){const r=this.createTreeNode(a,t,p.parent);return this.updateNodeCache(a,r,p,p.parent),p.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,a,p){const t=this.createTreeNode(l,a,p);if(a.id&&this.elements.has(t.item.handle))throw new Error((0,f.localize)(7,null,a.id));return this.addNodeToCache(l,t),this.addNodeToParentCache(t,p),t}getTooltip(l){return P.MarkdownString.isMarkdownString(l)?c.MarkdownString.from(l):l}getCommand(l,a){return a?this.commands.toInternal(a,l):void 0}createTreeNode(l,a,p){const t=new R.DisposableStore,r=this.createHandle(l,a,p),s=this.getLightIconPath(a);return{item:{handle:r,parentHandle:p?p.item.handle:void 0,label:v(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(t,a.command),contextValue:a.contextValue,icon:s,iconDark:this.getDarkIconPath(a)||s,themeIcon:this.getThemeIcon(a),collapsibleState:(0,n.isUndefinedOrNull)(a.collapsibleState)?P.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(l){return l.iconPath instanceof P.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:a,label:p,resourceUri:t},r,s){if(a)return`${A.ID_HANDLE_PREFIX}/${a}`;const i=v(p,this.extension),g=r?r.item.handle:A.LABEL_HANDLE_PREFIX;let u=i?i.label:t?(0,L.basename)(t):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const d=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(r)||[];let D,m=0;do{if(D=`${g}/${m}:${u}`,s||!this.elements.has(D)||d===D)break;m++}while(m<=w.length);return D}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon))return typeof l.iconPath=="string"||I.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return I.URI.isUri(l)?l:I.URI.file(l)}addNodeToCache(l,a){this.elements.set(a.item.handle,l),this.nodes.set(l,a)}updateNodeCache(l,a,p,t){this.elements.delete(a.item.handle),this.nodes.delete(l),a.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(l,a);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===p.item.handle)[0];s&&r.splice(r.indexOf(s),1,a)}addNodeToParentCache(l,a){a?(a.children||(a.children=[]),a.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const a=this.nodes.get(l);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}a.children=void 0}}else this.clearAll()}clear(l){const a=this.nodes.get(l);if(a){if(a.children)for(const p of a.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(l),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}A.LABEL_HANDLE_PREFIX="0",A.ID_HANDLE_PREFIX="1"}),define(me[225],ge([0,1,17,3,6,13,88,15,127,90]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends I.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const h=this.diff[this.diff.length-1];if(h&&c[0]===1){if(h[0]===1&&h[1].extId===c[1].extId){(0,y.applyTestItemUpdate)(h[1],c[1]);return}if(h[0]===0&&h[1].item.extId===c[1].extId){(0,y.applyTestItemUpdate)(h[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,h){const o=this.tree.get(c);if(!!o){if((o.expandLevels===void 0||h>o.expandLevels)&&(o.expandLevels=h),o.expand===1){const v=this.resolveChildren(o);return v.isOpen()?this.expandChildren(o,h-1):v.wait().then(()=>this.expandChildren(o,h-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,h-1)):this.expandChildren(o,h-1)}}dispose(){for(const c of this.tree.values())(0,R.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,h){switch(h.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(c.fullId,h.id));break;case 0:this.upsertItem(h.item,c);break;case 4:for(const E of h.ops)this.onTestItemEvent(c,E);break;case 3:const{key:o,value:v,previous:_}=h,A=c.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(v,_,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[o]:v??null}}]);break}break;default:(0,k.assertNever)(h)}}upsertItem(c,h){if(!(c instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const o=P.TestId.fromExtHostTestItem(c,this.root.id,h?.actual),v=(0,R.getPrivateApiFor)(c);v.parent&&v.parent!==h?.actual&&v.parent.children.delete(c.id);let _=this.tree.get(o.toString());if(!_){_={fullId:o,actual:c,parent:h?o.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(c,h),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:C.TestItem.from(c)}]),this.connectItemAndChildren(c,_,h);return}if(_.actual===c){this.connectItem(c,_,h);return}const A=_.actual.children,E=_.actual,l=(0,R.diffTestItems)(E,c);(0,R.getPrivateApiFor)(E).listener=void 0,_.actual=c,_.expand=0;for(const[a,p]of l)this.onTestItemEvent(_,{op:3,key:a,value:p,previous:E[a]});this.connectItemAndChildren(c,_,h);for(const a of A)c.children.get(a.id)||this.removeItem(P.TestId.joinToString(o,a.id))}diffTagRefs(c,h,o){const v=new Set(h.map(_=>_.id));for(const _ of c)v.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:o,item:{tags:c.map(_=>C.TestTag.namespace(this.controllerId,_.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const h=this.tags.get(c.id);h?h.refCount++:(this.tags.set(c.id,{label:c.label,refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label,label:c.label}]))}decrementTagRefs(c){const h=this.tags.get(c);h&&!--h.refCount&&(this.tags.delete(c),this.pushDiff([6,C.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,h){(0,R.getPrivateApiFor)(c).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(c,h,o){this.setItemParent(c,o);const v=(0,R.getPrivateApiFor)(c);v.parent=o?.actual,v.listener=_=>this.onTestItemEvent(h,_),this.updateExpandability(h)}connectItemAndChildren(c,h,o){this.connectItem(c,h,o);for(const v of c.children)this.upsertItem(v,h)}updateExpandability(c){let h;this._resolveHandler?c.resolveBarrier?h=c.resolveBarrier.isOpen()?3:2:h=c.actual.canResolveChildren?1:0:h=0,h!==c.expand&&(c.expand=h,this.pushDiff([1,{extId:c.fullId.toString(),expand:h}]),h===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,h){if(h<0)return;const o=[];for(const v of c.actual.children){const _=this.expand(P.TestId.joinToString(c.fullId,v.id),h);(0,f.isThenable)(_)&&o.push(_)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const _=new f.Barrier;return _.open(),_}c.expand=2,this.pushExpandStateUpdate(c);const h=c.resolveBarrier=new f.Barrier,o=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(_){o(_)}return(0,f.isThenable)(v)?v.catch(o).then(()=>{h.open(),this.updateExpandability(c)}):(h.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const h=this.tree.get(c);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const o=[h];for(;o.length;){const v=o.pop();if(!!v){(0,R.getPrivateApiFor)(v.actual).listener=void 0;for(const _ of v.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)o.push(this.tree.get(P.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=n}),define(me[226],ge([0,1,4,185]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(L.IEnvironmentService)}),define(me[227],ge([0,1,26,3,8]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class k{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=k;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let T of n.activationEvents)T==="onUri"&&(T=`onUri:${f.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(T)||this._activationMap.set(T,[]),this._activationMap.get(T).push(n)}}keepOnly(n){const T=new Set;n.forEach(c=>T.add(f.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>T.has(f.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,T){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=R._findLoopingExtensions(this._extensionDescriptions);if(T=T.concat(c.map(h=>h.identifier)),T.length>0){const h=new Set;T.forEach(o=>h.add(f.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!h.has(f.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new k(c)}static _findLoopingExtensions(n){const T=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,A){this.addNode(_),this.addNode(A),this._arcs.has(_)?this._arcs.get(_).push(A):this._arcs.set(_,[A])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,A){const E=T.getArcs(_);for(let l=0;l<E.length;l++)if(!A.has(E[l]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let _ of n){const A=f.ExtensionIdentifier.toKey(_.identifier);if(c.set(A,_),_.extensionDependencies)for(let E of _.extensionDependencies){const l=f.ExtensionIdentifier.toKey(E);T.addArc(A,l)}}let h=new Set;T.getNodes().filter(_=>T.getArcs(_).length===0).forEach(_=>h.add(_));let o=T.getNodes().filter(_=>!h.has(_)),v;do{v=!1;for(let _=0;_<o.length;_++){const A=o[_];T.hasOnlyGoodArcs(A,h)&&(o.splice(_,1),_--,h.add(A),v=!0)}}while(v);return o.map(_=>c.get(_))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const T=this._activationMap.get(n);return T?T.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const T=this._extensionsMap.get(f.ExtensionIdentifier.toKey(n));return T||void 0}}e.ExtensionDescriptionRegistry=R;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function y(P,n){const T=P.isBuiltin?0:P.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(T!==c)return T-c;const h=I.posix.basename(P.extensionLocation.path),o=I.posix.basename(n.extensionLocation.path);return h<o?-1:h>o?1:0}}),define(me[228],ge([0,1,23]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function k(C){const y=f.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=k;function R(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(me[36],ge([0,1,3,2,4,26,187]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var C;(function(E){E[E.None=0]="None",E[E.LocalProcess=1]="LocalProcess",E[E.LocalWebWorker=2]="LocalWebWorker",E[E.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(l){this.dependency=l}}e.MissingExtensionDependency=y;var P;(function(E){E[E.LocalProcess=0]="LocalProcess",E[E.LocalWebWorker=1]="LocalWebWorker",E[E.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(l,a,p,t){this.codeLoadingTime=l,this.activateCallTime=a,this.activateResolvedTime=p,this.activationReason=t}}e.ActivationTimes=n;class T{constructor(l,a){this.description=l,this.value=a}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var c;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(c=e.ActivationKind||(e.ActivationKind={}));function h(E){E.enableProposedApi||o(E)}e.checkProposedApiEnabled=h;function o(E){throw new Error(`[${E.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.throwProposedApiError=o;function v(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation}}e.toExtension=v;function _(E,l){return{identifier:new k.ExtensionIdentifier(E.identifier.id),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!l,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid}}e.toExtensionDescription=_;class A{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(l){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(l,a){return Promise.resolve()}_onWillActivateExtension(l){}_onDidActivateExtension(l,a,p,t,r){}_onDidActivateExtensionError(l,a){}_onExtensionRuntimeError(l,a){}_onExtensionHostExit(l){}}e.NullExtensionService=A}),define(me[229],ge([0,1,26,36,12]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class R{constructor(o,v,_,A){this.startup=o,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=A}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,v){return o===-1||v===-1?-1:v-o}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class y{constructor(o,v,_,A,E,l){this.activationFailed=o,this.activationFailedError=v,this.activationTimes=_,this.module=A,this.exports=E,this.subscriptions=l}}e.ActivatedExtension=y;class P extends y{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class n extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class T extends y{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=T;let c=class{constructor(o,v,_,A,E){this._logService=E,this._registry=o,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(f.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,_.forEach(l=>this._hostExtensionsMap.set(f.ExtensionIdentifier.toKey(l),l)),this._host=A,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const v=f.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(v)}getActivatedExtension(o){const v=f.ExtensionIdentifier.toKey(o),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+o.value+"` is not known or not activated");return _}activateByEvent(o,v){if(this._alreadyActivatedEvents[o])return k;const _=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(_.map(A=>({id:A.identifier,reason:{startup:v,extensionId:A.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,v){const _=this._registry.getExtensionDescription(o);if(!_)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(o,v,_){if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(o.id))){v[f.ExtensionIdentifier.toKey(o.id)]=o;return}const A=this._registry.getExtensionDescription(o.id);if(!A){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,a,new L.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(o.id),new T(a));return}const E=typeof A.extensionDependencies=="undefined"?[]:A.extensionDependencies;let l=!0;for(let a=0,p=E.length;a<p;a++){const t=E[a];if(this._resolvedExtensionsSet.has(f.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(f.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const u=A.displayName||A.identifier.value,d=this._registry.getExtensionDescription(t),w=d&&d.displayName||t,D=new Error(`Cannot activate the '${u}' extension because its dependency '${w}' failed to activate`);D.detail=r.activationFailedError,this._host.onExtensionActivationError(A.identifier,D,null),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(A.identifier),new T(D));return}if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(t))){l=!1,v[f.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(f.ExtensionIdentifier.toKey(t)),reason:o.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,v[f.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:o.reason};continue}const i=A.displayName||A.identifier.value,g=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(A.identifier,g,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(A.identifier),new T(g));return}l?v[f.ExtensionIdentifier.toKey(A.identifier)]=o:_.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(E=>!this._activatedExtensions.has(f.ExtensionIdentifier.toKey(E.id))),o.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let E=0,l=o.length;E<l;E++)this._handleActivateRequest(o[E],v,_);for(let E=0,l=_.length;E<l;E++){const a=f.ExtensionIdentifier.toKey(_[E].id);v[a]&&delete v[a]}const A=Object.keys(v).map(E=>v[E]);return _.length===0?Promise.all(A.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(A).then(E=>this._activateExtensions(_))}_activateExtension(o,v){const _=f.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const A=this._activatingExtensions.get(_);if(A)return A;const E=this._host.actualActivateExtension(o,v).then(void 0,l=>{const a=new Error;return l&&l.name&&(a.name=l.name),l&&l.message?a.message=`Activating extension '${o.value}' failed: ${l.message}.`:a.message=`Activating extension '${o.value}' failed: ${l}.`,l&&l.stack&&(a.stack=l.stack),this._host.onExtensionActivationError(o,a,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(l),new T(l)}).then(l=>{this._activatedExtensions.set(_,l),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};c=Ve([Be(4,I.ILogService)],c),e.ExtensionsActivator=c}),define(me[230],ge([0,1,12,36,27,10,116]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends f.LogService{constructor(P){if(P.logFile.scheme!==k.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=Ve([Be(0,I.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[231],ge([0,1,16]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((k,R)=>{this._actualOk=k,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(k){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=k,this._actual&&this._actualOk(k))}resolveErr(k){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=k,this._actual?this._actualErr(k):(0,f.onUnexpectedError)(k))}then(k,R){return this._ensureActual().then(k,R)}catch(k){return this._ensureActual().then(void 0,k)}finally(k){return this._ensureActual().finally(k)}}e.LazyPromise=L}),define(me[66],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(P,n){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=n,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const L=[];function I(y){const P=new f(!0,y);return L[P.nid]=P,P}e.createMainContextProxyIdentifier=I;function k(y){const P=new f(!1,y);return L[P.nid]=P,P}e.createExtHostContextProxyIdentifier=k;function R(y){return L[y].sid}e.getStringIdentifierForProxy=R;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(me[5],ge([0,1,59,2,66]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var R;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(l){l.name="$ident";function a(t,r){return Object.defineProperty(t,l.name,{value:r,enumerable:!0}),t}l.mixin=a;function p(t){return t[l.name]}l.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(a){return a._id=h._n++,a}}e.IdObject=h,h._n=0;var o;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(l){if(l&&l.edits)for(const a of l.edits)typeof a.resource=="object"?a.resource=L.URI.revive(a.resource):(a.newUri=L.URI.revive(a.newUri),a.oldUri=L.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,f.revive)(a.metadata));return l}e.reviveWorkspaceEditDto=A;var E;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,P){return this._proxy.$setPassword(C,y,P)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,P,n){const T=this.getUsageKey(y,P);this._reportedUsages.has(T)||(this._reportedUsages.add(T),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};R=Ve([Be(0,k.IExtHostRpcService),Be(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,P){}})}),define(me[232],ge([0,1,3,5,7,26]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,n,T={}){const c=k.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(c)||[],o=[...n].sort().join(" ");let v=h.find(_=>_.scopes===o);if(v)return v.result;{const _=this._getSession(y,c,P,n,T);v={scopes:o,result:_},h.push(v),this._inFlightRequests.set(c,h);try{await _}finally{const A=h.findIndex(E=>E.scopes===o);A>-1&&(h.splice(A),this._inFlightRequests.set(c,h))}return _}}async _getSession(y,P,n,T,c={}){await this._proxy.$ensureProvider(n);const h=y.displayName||y.name;return this._proxy.$getSession(n,T,P,h,c)}async removeSession(y,P){const n=this._authenticationProviders.get(y);return n?n.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,n,T){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:n,options:T??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===y)||this._providers.push({id:y,label:P});const c=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(y,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,T?.supportsMultipleAccounts??!1),new I.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(y);const h=this._providers.findIndex(o=>o.id===y);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const n=this._authenticationProviders.get(y);if(n)return Promise.resolve(n.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[233],ge([0,1,5,14,15]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=I.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};k=Ve([Be(0,L.IExtHostRpcService)],k),e.ExtHostBulkEdits=k}),define(me[234],ge([0,1,5]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(k){const R=k.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(C){return R.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,20,12,59,41,50,2,6,4,14]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new A(this,s=>{const i=this._apiCommands.get(s);return i?.result===l.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,P.revive)(s)}},{processArgument(s){return(0,k.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return I.Range.to(i);if(T.Position.isIPosition(i))return I.Position.to(i);if(n.Range.isIRange(i.range)&&c.URI.isUri(i.uri))return I.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((u,d)=>{if(!u.validate(s[d]))throw new Error(`Invalid argument '${u.name}' when running '${t.id}', received: ${s[d]}`);return u.convert(s[d])}),g=await this.executeCommand(t.internalId,...i);return t.result.convert(g,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,g){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:g}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,k.cloneAndChange)(r,function(g){if(g instanceof L.Position)return I.Position.from(g);if(g instanceof L.Range)return I.Range.from(g);if(g instanceof L.Location)return I.location.from(g);if(L.NotebookRange.isNotebookRange(g))return I.NotebookRange.from(g);if(!Array.isArray(g))return g});try{const g=await this._proxy.$executeCommand(t,i,s);return(0,P.revive)(g)}catch(g){if(g instanceof Error&&g.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw g}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:g,description:u}=s;if(u)for(let d=0;d<u.args.length;d++)try{(0,f.validateConstraint)(r[d],u.args[d].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${u.args[d].name}' - ${u.args[d].description}`)}try{return await i.apply(g,r)}catch(d){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,g)=>g.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};_=Ve([Be(0,v.IExtHostRpcService),Be(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class A{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((g,u)=>g.convert(t.arguments&&t.arguments[u]));else if((0,C.isNonEmptyArray)(t.arguments)){const g=++this._cachIdPool;this._cache.set(g,t),r.add((0,h.toDisposable)(()=>{this._cache.delete(g),this._logService.trace("CommandsConverter#DISPOSE",g)})),s.$ident=g,s.id=this.delegatingCommandId,s.arguments=[g],this._logService.trace("CommandsConverter#CREATE",t.command,g)}return s}fromInternal(t){const r=R.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=A;class E{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",p=>c.URI.isUri(p),p=>p),E.Position=new E("position","A position in a text document",p=>L.Position.isPosition(p),I.Position.from),E.Range=new E("range","A range in a text document",p=>L.Range.isRange(p),I.Range.from),E.Selection=new E("selection","A selection in a text document",p=>L.Selection.isSelection(p),I.Selection.from),E.Number=new E("number","",p=>typeof p=="number",p=>p),E.String=new E("string","",p=>typeof p=="string",p=>p),E.CallHierarchyItem=new E("item","A call hierarchy item",p=>p instanceof L.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",p=>p instanceof L.TypeHierarchyItem,I.TypeHierarchyItem.from);class l{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=l,l.Void=new l("no result",p=>p);class a{constructor(t,r,s,i,g){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=g}}e.ApiCommand=a}),define(me[235],ge([0,1,15,7,83,44,20,111]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(f.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,h)=>{if((0,R.isFalsyOrEmpty)(c))return;class o extends L.SymbolInformation{static to(_){const A=new o(_.name,f.SymbolKind.to(_.kind),_.containerName||"",new L.Location(h[0],f.Range.to(_.range)));return A.detail=_.detail,A.range=A.location.range,A.selectionRange=f.Range.to(_.selectionRange),A.children=_.children?_.children.map(o.to):[],A}}return c.map(o.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new k.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",T)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(f.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(f.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(h=>L.Position.isPosition(h)),c=>c.map(f.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(h=>{let o;for(const v of h.reverse())o=new L.SelectionRange(f.Range.to(v),o);return o}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const h=[];if(Array.isArray(c))for(let o of c)h.push(...o[1].map(f.WorkspaceSymbol.to));return h})),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(f.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return f.WorkspaceEdit.to(c)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(f.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,C.decodeSemanticTokensDto)(c);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,C.decodeSemanticTokensDto)(c);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,h,o)=>{if(!c)return new L.CompletionList([]);const v=c.suggestions.map(_=>f.CompletionItem.to(_,o));return new L.CompletionList(v,c.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return f.SignatureHelp.to(c)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,h,o)=>n(v=>new L.CodeLens(f.Range.to(v.range),v.command&&o.fromInternal(v.command)))(c))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?f.Selection.from(c):f.Range.from(c)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,h,o)=>n(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(v.command)}else{const _=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=f.WorkspaceEdit.to(v.edit)),v.command&&(_.command=o.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(c))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(h=>new L.ColorInformation(f.Range.to(h.range),f.Color.to(h.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,f.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:f.Range.from(c.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(f.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(f.InlayHint.to))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(h=>f.NotebookExclusiveDocumentPattern.to(h))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(f.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[f.ViewColumn.from(c.viewColumn),f.TextEditorOpenOptions.from(c)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(f.TypeHierarchyItem.to)))];class P{static register(h){y.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=P;function n(c){return h=>{if(Array.isArray(h))return h.map(c)}}function T(c){if(!Array.isArray(c))return;const h=[];for(const o of c)I.isLocationLink(o)?h.push(f.DefinitionLink.to(o)):h.push(f.location.to(o));return h}}),define(me[236],ge([0,1,17,56,3,6,2,83,26,15,7,5]),function(J,e,f,L,I,k,R,C,y,P,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(h,o,v){const _=h.getProxy(T.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const g=this._commentControllers.get(i.handle);return g||i}else if(i&&i.$mid===7){const g=this._commentControllers.get(i.commentControlHandle);if(!g)return i;const u=g.getCommentThread(i.commentThreadHandle);return u||i}else if(i&&i.$mid===8){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const u=g.getCommentThread(i.thread.commentThreadHandle);return u?{thread:u,text:i.text}:i}else if(i&&i.$mid===9){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const u=g.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let d=i.commentUniqueId,w=u.getCommentByUniqueId(d);return w||i}else if(i&&i.$mid===10){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const u=g.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let d=i.text,w=i.commentUniqueId,D=u.getCommentByUniqueId(w);return D?(D.body=d,D):i}return i}})}createCommentController(i,g,u){const d=A.handlePool++,w=new l(i,d,g,u);this._commentControllers.set(w.handle,w);const D=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return D.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(i.identifier),D),w.value}$createCommentThreadTemplate(i,g,u){const d=this._commentControllers.get(i);!d||d.$createCommentThreadTemplate(g,u)}async $updateCommentThreadTemplate(i,g,u){const d=this._commentControllers.get(i);!d||d.$updateCommentThreadTemplate(g,u)}$deleteCommentThread(i,g){const u=this._commentControllers.get(i);u&&u.$deleteCommentThread(g)}$provideCommentingRanges(i,g,u){const d=this._commentControllers.get(i);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(R.URI.revive(g));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(w,u)).then(D=>D?D.map(m=>P.Range.from(m)):void 0)}$toggleReaction(i,g,u,d,w){const D=this._commentControllers.get(i);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const m=D.getCommentThread(g);if(m){const S=m.getCommentByUniqueId(d.uniqueIdInThread);if(D!==void 0&&S&&D.reactionHandler)return D.reactionHandler(S,t(w))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class E{constructor(i,g,u,d,w,D,m){this._commentControllerHandle=g,this._id=u,this._uri=d,this._range=w,this._comments=D,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),_.$createCommentThread(g,this.handle,this._id,this._uri,P.Range.from(this._range),m),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(g,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(b){S.range=b},get comments(){return S.comments},set comments(b){S.comments=b},get collapsibleState(){return S.collapsibleState},set collapsibleState(b){S.collapsibleState=b},get canReply(){return S.canReply},set canReply(b){S.canReply=b},get contextValue(){return S.contextValue},set contextValue(b){S.contextValue=b},get label(){return S.label},set label(b){S.label=b},dispose:()=>{S.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const i=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),g={};i("range")&&(g.range=P.Range.from(this._range)),i("label")&&(g.label=this.label),i("contextValue")&&(g.contextValue=this.contextValue),i("comments")&&(g.comments=this._comments.map(u=>a(this,u,this._commentsMap))),i("collapsibleState")&&(g.collapseState=r(this._collapseState)),i("canReply")&&(g.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(i){for(let g of this._commentsMap){let u=g[0],d=g[1];if(i===d)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}E._handlePool=0,Ve([(0,L.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(i,g,u,d){this._extension=i,this._handle=g,this._id=u,this._label=d,this._threads=new Map,_.$registerCommentController(this.handle,u,d);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(D){w.options=D},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(D){w.commentingRangeProvider=D},get reactionHandler(){return w.reactionHandler},set reactionHandler(D){w.reactionHandler=D},createCommentThread(D,m,S){return w.createCommentThread(D,m,S).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,g,u,d){if(typeof i=="string"){const w=new E(this.id,this.handle,i,g,u,d,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new E(this.id,this.handle,void 0,i,g,u,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,g){const u=new E(this.id,this.handle,void 0,R.URI.revive(i),P.Range.to(g),[],this._extension.identifier);return u.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(i,g){let u=this._threads.get(i);u&&(u.range=P.Range.to(g))}$deleteCommentThread(i){let g=this._threads.get(i);g&&g.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function a(s,i,g){let u=g.get(i);u||(u=++s.commentHandle,g.set(i,u));const d=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:u,body:P.MarkdownString.from(i.body),userName:i.author.name,userIconPath:d,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>p(w)):void 0}}function p(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?R.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=c}),define(me[131],ge([0,1,2,5,7,4,14,12,20,9,8]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let T=class vn{constructor(h,o){this._logService=o,this._provider=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,o){const v=vn._handlePool++;this._provider.set(v,{provider:h,extensionId:o}),this._proxy.$registerDecorationProvider(v,o.value);const _=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(v,null);return}let E=(0,y.asArray)(A);if(E.length<=vn._maxEventSize){this._proxy.$onDidChange(v,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,E.length);const l=E.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),a=(0,y.groupBy)(l,(t,r)=>t.rank-r.rank||(0,P.compare)(t.uri.path,r.uri.path));let p=[];e:for(let t of a){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,p.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new I.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(h,o,v){if(!this._provider.has(h))return Object.create(null);const _=Object.create(null),{provider:A,extensionId:E}=this._provider.get(h);return await Promise.all(o.map(async l=>{try{const{uri:a,id:p}=l,t=await Promise.resolve(A.provideFileDecoration(f.URI.revive(a),v));if(!t)return;try{I.FileDecoration.validate(t),_[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(a){this._logService.error(a)}})),_}};T._handlePool=0,T._maxEventSize=250,T=Ve([Be(0,R.IExtHostRpcService),Be(1,C.ILogService)],T),e.ExtHostDecorations=T,e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")}),define(me[237],ge([0,1,163,117,2,5,7,15,3,12,24]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class T{constructor(o,v,_,A,E){this._name=o,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=A,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,v){if(!o){this.clear();return}this._checkDisposed();let _=[];if(I.URI.isUri(o)){if(!v){this.delete(o);return}this._data.set(o,v.slice()),_=[o]}else if(Array.isArray(o)){_=[];let E;o=[...o].sort(T._compareIndexedTuplesByUri);for(const l of o){const[a,p]=l;if((!E||a.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=a,_.push(a),this._data.set(a,[])),p){const t=this._data.get(a);t&&t.push(...p)}else{const t=this._data.get(a);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const A=[];for(let E of _){let l=[];const a=this._data.get(E);if(a)if(a.length>this._maxDiagnosticsPerFile){l=[];const p=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of a)if(r.severity===p[t]&&l.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;l.push({severity:L.MarkerSeverity.Info,message:(0,f.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=a.map(p=>C.Diagnostic.from(p));A.push([E,l])}this._proxy.$changeMany(this._owner,A)}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,v){this._checkDisposed();for(let _ of this._data.keys())o.apply(v,[_,this.get(_),this])}get(o){this._checkDisposed();const v=this._data.get(o);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,v){return o[0].toString()<v[0].toString()?-1:o[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=T;let c=class Zt{constructor(o,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=o.getProxy(k.MainContext.MainThreadDiagnostics)}static _mapper(o){const v=new n.ResourceMap;for(const _ of o)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(o,v){const{_collections:_,_proxy:A,_onDidChangeDiagnostics:E,_logService:l}=this,a=new class{$changeMany(r,s){A.$changeMany(r,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,r,s.length===0?"CLEARING":s)}$clear(r){A.$clear(r),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,r)}dispose(){A.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Zt._idPool++,p=v;else if(!_.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Zt._idPool++;while(_.has(p))}return new class extends T{constructor(){super(v,p,Zt._maxDiagnosticsPerFile,a,E);_.set(p,this)}dispose(){super.dispose(),_.delete(p)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const v=new Map,_=[];for(const A of this._collections.values())A.forEach((E,l)=>{let a=v.get(E.toString());typeof a=="undefined"&&(a=_.length,v.set(E.toString(),a),_.push([E,[]])),_[a][1]=_[a][1].concat(...l)});return _}}_getDiagnostics(o){let v=[];for(let _ of this._collections.values())_.has(o)&&(v=v.concat(_.get(o)));return v}$acceptMarkersChange(o){if(!this._mirrorCollection){const v="_generated_mirror",_=new T(v,v,Zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of o)this._mirrorCollection.set(I.URI.revive(v),_.map(C.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ve([Be(1,P.ILogService)],c),e.ExtHostDiagnostics=c}),define(me[238],ge([0,1,2,5]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(C=>C?C.map(y=>f.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(C=>C?f.URI.revive(C):void 0)}}e.ExtHostDialogs=I}),define(me[239],ge([0,1,16,2,7,5,10,21,9]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(T,c,h){this._documentsAndEditors=c,this._logService=h,this._documentContentProviders=new Map,this._proxy=T.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,c){if(Object.keys(R.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const h=P._handlePool++;this._documentContentProviders.set(h,c),this._proxy.$registerTextContentProvider(h,T);let o;return typeof c.onDidChange=="function"&&(o=c.onDidChange(v=>{if(v.scheme!==T){this._logService.warn(`Provider for scheme '${T}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(h,v).then(_=>{if(!_&&typeof _!="string")return;const A=this._documentsAndEditors.getDocument(v);if(!A)return;const E=(0,y.splitLines)(_);if(!A.equalLines(E))return this._proxy.$onVirtualDocumentChange(v,_)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(T,c){const h=this._documentContentProviders.get(T);return h?Promise.resolve(h.provideTextDocumentContent(L.URI.revive(c),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[240],ge([0,1,3,6,2,5,123,15,13,25,7]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(h,o){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const o=this._documentsAndEditors.getDocument(h);if(o)return o}getDocument(h){const o=this.getDocumentData(h);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return o.document}ensureDocumentData(h){const o=this._documentsAndEditors.getDocument(h);if(o)return Promise.resolve(o);let v=this._documentLoader.get(h.toString());return v||(v=this._proxy.$tryOpenDocument(h).then(_=>{this._documentLoader.delete(h.toString());const A=I.URI.revive(_);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(A))},_=>(this._documentLoader.delete(h.toString()),Promise.reject(_))),this._documentLoader.set(h.toString(),v)),v}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(o=>I.URI.revive(o))}$acceptModelModeChanged(h,o){const v=I.URI.revive(h),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(o),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(h){const o=I.URI.revive(h),v=this._documentsAndEditors.getDocument(o);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(h,o){const v=I.URI.revive(h),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(o),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,o,v){const _=I.URI.revive(h),A=this._documentsAndEditors.getDocument(_);if(!A)throw new Error("unknown document");A._acceptIsDirty(v),A.onEvents(o);let E;o.isUndoing?E=n.TextDocumentChangeReason.Undo:o.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:A.document,contentChanges:o.changes.map(l=>({range:C.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:E}))}setWordDefinitionFor(h,o){(0,R.setWordDefinitionFor)(h,o)}}e.ExtHostDocuments=T}),define(me[45],ge([0,1,54,3,6,2,4,5,123,14,130,15,12,24,10,77,139]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(a,p){this._extHostRpc=a,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const p=[],t=[],r=[];if(a.removedDocuments)for(const s of a.removedDocuments){const i=k.URI.revive(s),g=this._documents.get(i);g?.unref()&&(this._documents.delete(i),p.push(g.value))}if(a.addedDocuments)for(const s of a.addedDocuments){const i=k.URI.revive(s.uri);let g=this._documents.get(i);if(g&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);g||(g=new A(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,g),t.push(g.value)),g.ref()}if(a.removedEditors)for(const s of a.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(a.addedEditors)for(const s of a.addedEditors){const i=k.URI.revive(s.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const g=this._documents.get(i).value,u=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>g.document),s.selections.map(T.Selection.to),s.options,s.visibleRanges.map(d=>T.Range.to(d)),typeof s.editorPosition=="number"?T.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,u)}a.newActiveEditor!==void 0&&(f.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,I.dispose)(p),(0,I.dispose)(r),a.removedDocuments&&this._onDidRemoveDocuments.fire(p),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return a?p:p?.value}allEditors(){return[...this._editors.values()]}};E=Ve([Be(0,P.IExtHostRpcService),Be(1,c.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[241],ge([0,1,2,5,6,7,15,147,9,23]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const o=this._schemes.indexOf(h);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),o=[];let v,_,A=14,E=14;for(const l of h){let a=v?(0,y.commonPrefixLength)(v,l):0;for(a===0?_=1:_=E;a<l.length;a++)a+1===l.length?(A=E,E=9):E+=1,o.push([_,l.toUpperCase().charCodeAt(a),E]),o.push([_,l.toLowerCase().charCodeAt(a),E]),_=E;v=l,E=A}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(h){this._initStateMachine();const o=[],v=C.LinkComputer.computeLinks({getLineContent(_){return h.lineAt(_-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const _ of v){const A=R.DocumentLink.to(_);A.target&&o.push(A)}return o}}class T{constructor(h,o){this._extHostLanguageFeatures=o,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,o,v,_={},A){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(E,v),this._enableProposedApi.set(E,A??!1);let l=2;_.isCaseSensitive&&(l+=1024),_.isReadonly&&(l+=2048),typeof v.copy=="function"&&(l+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(E,o,l).catch(p=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${o}`),console.error(p)});const a=v.onDidChangeFile(p=>{const t=[];for(const r of p){let{uri:s,type:i}=r;if(s.scheme!==o)continue;let g;switch(i){case k.FileChangeType.Changed:g=0;break;case k.FileChangeType.Created:g=1;break;case k.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:g})}this._proxy.$onFileSystemChange(E,t)});return(0,I.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(h,o){const{type:v,ctime:_,mtime:A,size:E,permissions:l}=h;return o?{type:v,ctime:_,mtime:A,size:E,permissions:l}:{type:v,ctime:_,mtime:A,size:E}}$stat(h,o){return Promise.resolve(this._getFsProvider(h).stat(f.URI.revive(o))).then(v=>T._asIStat(v,this._enableProposedApi.get(h)??!1))}$readdir(h,o){return Promise.resolve(this._getFsProvider(h).readDirectory(f.URI.revive(o)))}$readFile(h,o){return Promise.resolve(this._getFsProvider(h).readFile(f.URI.revive(o))).then(v=>P.VSBuffer.wrap(v))}$writeFile(h,o,v,_){return Promise.resolve(this._getFsProvider(h).writeFile(f.URI.revive(o),v.buffer,_))}$delete(h,o,v){return Promise.resolve(this._getFsProvider(h).delete(f.URI.revive(o),v))}$rename(h,o,v,_){return Promise.resolve(this._getFsProvider(h).rename(f.URI.revive(o),f.URI.revive(v),_))}$copy(h,o,v,_){const A=this._getFsProvider(h);if(!A.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(A.copy(f.URI.revive(o),f.URI.revive(v),_))}$mkdir(h,o){return Promise.resolve(this._getFsProvider(h).createDirectory(f.URI.revive(o)))}$watch(h,o,v,_){const A=this._getFsProvider(h).watch(f.URI.revive(v),_);this._watches.set(o,A)}$unwatch(h,o){const v=this._watches.get(o);v&&(v.dispose(),this._watches.delete(o))}$open(h,o,v){const _=this._getFsProvider(h);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(f.URI.revive(o),v))}$close(h,o){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(o))}$read(h,o,v,_){const A=this._getFsProvider(h);if(!A.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(_);return Promise.resolve(A.read(o,v,E.buffer,0,_)).then(l=>E.slice(0,l))}$write(h,o,v,_){const A=this._getFsProvider(h);if(!A.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(A.write(o,v,_.buffer,0,_.byteLength))}_getFsProvider(h){const o=this._fsProvider.get(h);if(!o){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return o}}e.ExtHostFileSystem=T}),define(me[92],ge([0,1,5,42,7,23,4,14,64]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class xt{constructor(T,c){const h=T.getProxy(f.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return h.$stat(o).catch(xt._handleError)},readDirectory(o){return h.$readdir(o).catch(xt._handleError)},createDirectory(o){return h.$mkdir(o).catch(xt._handleError)},async readFile(o){return h.$readFile(o).then(v=>v.buffer).catch(xt._handleError)},writeFile(o,v){return h.$writeFile(o,k.VSBuffer.wrap(v)).catch(xt._handleError)},delete(o,v){return h.$delete(o,{recursive:!1,useTrash:!1,...v}).catch(xt._handleError)},rename(o,v,_){return h.$rename(o,v,{overwrite:!1,..._}).catch(xt._handleError)},copy(o,v,_){return h.$copy(o,v,{overwrite:!1,..._}).catch(xt._handleError)},isWritableFileSystem(o){const v=c.getCapabilities(o);if(typeof v=="number")return!(v&2048)}})}static _handleError(T){if(!(T instanceof Error))throw new I.FileSystemError(String(T));if(T.name==="ENOPRO")throw I.FileSystemError.Unavailable(T.message);switch(T.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(T.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(T.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(T.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(T.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(T.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(T.message);default:throw new I.FileSystemError(T.message,T.name)}}};P=Ve([Be(0,C.IExtHostRpcService),Be(1,y.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[242],ge([0,1,2,44]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,C,y,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=y,this._commands=P;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",T=>!0,T=>T),new L.ApiCommandArgument("resource","Interactive resource Uri",T=>!0,T=>T),new L.ApiCommandArgument("controllerId","Notebook controller Id",T=>!0,T=>T),new L.ApiCommandArgument("title","Interactive editor title",T=>!0,T=>T)],new L.ApiCommandResult("Notebook and input URI",T=>{if(T.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(T.notebookEditorId);return{notebookUri:f.URI.revive(T.notebookUri),inputUri:f.URI.revive(T.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:f.URI.revive(T.notebookUri),inputUri:f.URI.revive(T.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,C,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(me[243],ge([0,1,6,5]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,R),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=I}),define(me[244],ge([0,1,2,25,15,7,5,9,41,20,13,144,6,111,76,87,46,16,3]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentSymbols(z,ee){const re=this._documents.getDocument(z),ae=await this._provider.provideDocumentSymbols(re,ee);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof k.DocumentSymbol?ae.map(I.DocumentSymbol.from):l._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((ae,Y)=>{let oe=ae.location.range.start.compareTo(Y.location.range.start);return oe===0&&(oe=Y.location.range.end.compareTo(ae.location.range.end)),oe});const ee=[],re=[];for(const ae of z){const Y={name:ae.name||"!!MISSING: name!!",kind:I.SymbolKind.from(ae.kind),tags:ae.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:I.Range.from(ae.location.range),selectionRange:I.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(Y),ee.push(Y);break}const oe=re[re.length-1];if(y.Range.containsRange(oe.range,Y.range)&&!y.Range.equalsRange(oe.range,Y.range)){oe.children&&oe.children.push(Y),re.push(Y);break}re.pop()}}return ee}}class a{constructor(z,ee,re){this._documents=z,this._commands=ee,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,ee){const re=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(re,ee);if(!ae||ee.isCancellationRequested)return;const Y=this._cache.add(ae),oe=new c.DisposableStore;this._disposables.set(Y,oe);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<ae.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:I.Range.from(ae[Me].range),command:this._commands.toInternal(ae[Me].command,oe)});return ve}async resolveCodeLens(z,ee){const re=z.cacheId&&this._cache.get(...z.cacheId);if(!re)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this._provider.resolveCodeLens(re,ee),ae||(ae=re),ee.isCancellationRequested)return;const Y=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Y)return z.command=this._commands.toInternal(ae.command??a._badCmd,Y),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Ge){return Array.isArray(Ge)?Ge.map(I.DefinitionLink.from):Ge?[I.DefinitionLink.from(Ge)]:[]}class t{constructor(z,ee){this._documents=z,this._provider=ee}async provideDefinition(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDefinition(ae,Y,re);return p(oe)}}class r{constructor(z,ee){this._documents=z,this._provider=ee}async provideDeclaration(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDeclaration(ae,Y,re);return p(oe)}}class s{constructor(z,ee){this._documents=z,this._provider=ee}async provideImplementation(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideImplementation(ae,Y,re);return p(oe)}}class i{constructor(z,ee){this._documents=z,this._provider=ee}async provideTypeDefinition(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideTypeDefinition(ae,Y,re);return p(oe)}}class g{constructor(z,ee){this._documents=z,this._provider=ee}async provideHover(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideHover(ae,Y,re);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(Y)),oe.range||(oe.range=new k.Range(Y,Y)),I.Hover.from(oe)}}class u{constructor(z,ee){this._documents=z,this._provider=ee}async provideEvaluatableExpression(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(ae,Y,re);if(oe)return I.EvaluatableExpression.from(oe)}}class d{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlineValues(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=await this._provider.provideInlineValues(Y,I.Range.to(ee),I.InlineValueContext.to(re),ae);if(Array.isArray(oe))return oe.map(ve=>I.InlineValue.from(ve))}}class w{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentHighlights(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideDocumentHighlights(ae,Y,re);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class D{constructor(z,ee){this._documents=z,this._provider=ee}async provideLinkedEditingRanges(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(ae,Y,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class m{constructor(z,ee){this._documents=z,this._provider=ee}async provideReferences(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideReferences(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.location.from)}}class S{constructor(z,ee,re,ae,Y,oe,ve){this._documents=z,this._commands=ee,this._diagnostics=re,this._provider=ae,this._logService=Y,this._extension=oe,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=T.Selection.isISelection(ee)?I.Selection.to(ee):I.Range.to(ee),ve=[];for(const Z of this._diagnostics.getDiagnostics(z))if(oe.intersection(Z.range)&&ve.push(Z)>S._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new k.CodeActionKind(re.only):void 0,triggerKind:I.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(Y,oe,Me,ae);if(!(0,P.isNonEmptyArray)(je)||ae.isCancellationRequested)return;const Ke=this._cache.add(je),Se=new c.DisposableStore;this._disposables.set(Ke,Se);const nt=[];for(let Z=0;Z<je.length;Z++){const te=je[Z];!te||(S._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Se)})):(Me.only&&(te.kind?Me.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),nt.push({cacheId:[Ke,Z],title:te.title,command:te.command&&this._commands.toInternal(te.command,Se),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:te.disabled?.reason})))}return{cacheId:Ke,actions:nt}}async resolveCodeAction(z,ee){const[re,ae]=z,Y=this._cache.get(re,ae);if(!Y||S._isCommand(Y)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Y,ee)??Y;return oe?.edit?I.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}S._maxCodeActionsPerFile=1e3;class b{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentFormattingEdits(z,ee,re){const ae=this._documents.getDocument(z),Y=await this._provider.provideDocumentFormattingEdits(ae,ee,re);if(Array.isArray(Y))return Y.map(I.TextEdit.from)}}class F{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeFormattingEdits(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,oe,re,ae);if(Array.isArray(ve))return ve.map(I.TextEdit.from)}}class N{constructor(z,ee){this._documents=z,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,ee,re,ae,Y){const oe=this._documents.getDocument(z),ve=I.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,ae,Y);if(Array.isArray(Me))return Me.map(I.TextEdit.from)}}class G{constructor(z,ee){this._provider=z,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,ee){const re=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(z,ee);if((0,P.isNonEmptyArray)(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const oe=R.IdObject.mixin(I.WorkspaceSymbol.from(Y));this._symbolCache.set(oe._id,Y),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(z,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const re=this._symbolCache.get(z._id);if(re){const ae=await this._provider.resolveWorkspaceSymbol(re,ee);return ae&&(0,L.mixin)(z,I.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const ee=this._resultCache.get(z);if(ee){for(let[re,ae]=ee;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(z)}}}class K{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Y,oe,re,ae);return ve?I.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(z,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),Y=I.Position.to(ee);try{const oe=await this._provider.prepareRename(ae,Y,re);let ve,Me;if(k.Range.isRange(oe)?(ve=oe,Me=ae.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class M{constructor(z,ee){this.resultId=z,this.tokens=ee}}class U{constructor(z,ee){this._documents=z,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,ee,re){const ae=this._documents.getDocument(z),Y=ee!==0?this._previousResults.get(ee):null;let oe=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,re):await this._provider.provideDocumentSemanticTokens(ae,re);return Y&&this._previousResults.delete(ee),oe?(oe=U._fixProvidedSemanticTokens(oe),this._send(U._convertToEdits(Y,oe),oe)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new k.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new k.SemanticTokensEdits(z.edits.map(ee=>new k.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const ee of z.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,ee){if(!U._isSemanticTokens(ee)||!z||!z.tokens)return ee;const re=z.tokens,ae=re.length,Y=ee.data,oe=Y.length;let ve=0;const Me=Math.min(ae,oe);for(;ve<Me&&re[ve]===Y[ve];)ve++;if(ve===ae&&ve===oe)return new k.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-ve;for(;je<Ke&&re[ae-je-1]===Y[oe-je-1];)je++;return new k.SemanticTokensEdits([{start:ve,deleteCount:ae-ve-je,data:Y.subarray(ve,oe-je)}],ee.resultId)}_send(z,ee){if(U._isSemanticTokens(z)){const re=this._nextResultId++;return this._previousResults.set(re,new M(z.resultId,z.data)),(0,h.encodeSemanticTokensDto)({id:re,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const re=this._nextResultId++;return U._isSemanticTokens(ee)?this._previousResults.set(re,new M(ee.resultId,ee.data)):this._previousResults.set(re,new M(z.resultId)),(0,h.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class O{constructor(z,ee){this._documents=z,this._provider=ee}async provideDocumentRangeSemanticTokens(z,ee,re){const ae=this._documents.getDocument(z),Y=await this._provider.provideDocumentRangeSemanticTokens(ae,I.Range.to(ee),re);return Y?this._send(Y):null}_send(z){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=O;class ${constructor(z,ee,re,ae,Y){this._documents=z,this._commands=ee,this._provider=re,this._apiDeprecation=ae,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=Y.getWordRangeAtPosition(oe)||new k.Range(oe,oe),Me=ve.with({end:oe}),je=new _.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Y,oe,ae,I.CompletionContext.to(re));if(!Ke||ae.isCancellationRequested)return;const Se=Array.isArray(Ke)?new k.CompletionList(Ke):Ke,nt=$.supportsResolving(this._provider)?this._cache.add(Se.items):this._cache.add([]),Z=new c.DisposableStore;this._disposables.set(nt,Z);const te=[],pe={x:nt,b:te,a:{replace:I.Range.from(ve),insert:I.Range.from(Me)},c:Se.isIncomplete||void 0,d:je.elapsed()};for(let Ue=0;Ue<Se.items.length;Ue++){const Ye=Se.items[Ue],it=this._convertCompletionItem(Ye,[nt,Ue],Me,ve);te.push(it)}return pe}async resolveCompletionItem(z,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...z);if(!re)return;const ae=await this._provider.resolveCompletionItem(re,ee);if(!!ae)return this._convertCompletionItem(ae,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,ee,re,ae){const Y=this._disposables.get(ee[0]);if(!Y)throw Error("DisposableStore is missing...");const oe={x:ee,a:z.label,b:z.kind!==void 0?I.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(I.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(z.command,Y)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=z.textEdit.newText):typeof z.insertText=="string"?oe.h=z.insertText:z.insertText instanceof k.SnippetString&&(oe.h=z.insertText.value,oe.i|=4);let ve;return z.textEdit?ve=z.textEdit.range:z.range&&(ve=z.range),k.Range.isRange(ve)?oe.j=I.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!ae?.isEqual(ve.replacing))&&(oe.j={insert:I.Range.from(ve.inserting),replace:I.Range.from(ve.replacing)}),oe}}class B{constructor(z,ee,re){this._documents=z,this._provider=ee,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Y,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:I.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},ae);if(!ve||ae.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Se,nt)=>{let Z;return Se.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(je,Ke)),Z=this._commands.toInternal(Se.command,Ke)),{text:Se.text,range:Se.range?I.Range.from(Se.range):void 0,command:Z,idx:nt}})}}disposeCompletions(z){this._cache.delete(z);const ee=this._disposables.get(z);ee&&ee.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,ee){const re=this._cache.get(z,ee);re&&x.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class x{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let ee=x.map.get(z);return ee||(ee=new x,x.map.set(z,ee)),ee}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=x,x.map=new WeakMap;class j{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(z,ee,re,ae){const Y=this._documents.getDocument(z),oe=I.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Y,oe,ae,ve);if(Me){const je=this._cache.add([Me]);return{...I.SignatureHelp.from(Me),id:je}}}reviveContext(z){let ee;if(z.activeSignatureHelp){const re=I.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(ee=ae,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...z,activeSignatureHelp:ee}}releaseSignatureHelp(z){this._cache.delete(z)}}class H{constructor(z,ee){this._documents=z,this._provider=ee}async provideInlayHints(z,ee,re){const ae=this._documents.getDocument(z),Y=await this._provider.provideInlayHints(ae,I.Range.to(ee),re);return Y?{hints:Y.map(I.InlayHint.from)}:void 0}}class Q{constructor(z,ee){this._documents=z,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(z,ee){const re=this._documents.getDocument(z),ae=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(ae)||ae.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Q._validateLink).map(I.DocumentLink.from)};{const Y=this._cache.add(ae),oe={links:[],id:Y};for(let ve=0;ve<ae.length;ve++){if(!Q._validateLink(ae[ve]))continue;const Me=I.DocumentLink.from(ae[ve]);Me.cacheId=[Y,ve],oe.links.push(Me)}return oe}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...z);if(!re)return;const ae=await this._provider.resolveDocumentLink(re,ee);if(!(!ae||!Q._validateLink(ae)))return I.DocumentLink.from(ae)}releaseLinks(z){this._cache.delete(z)}}class X{constructor(z,ee){this._documents=z,this._provider=ee}async provideColors(z,ee){const re=this._documents.getDocument(z),ae=await this._provider.provideDocumentColors(re,ee);return Array.isArray(ae)?ae.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Range.to(ee.range),oe=I.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:ae,range:Y},re);if(!!Array.isArray(ve))return ve.map(I.ColorPresentation.from)}}class fe{constructor(z,ee){this._documents=z,this._provider=ee}async provideFoldingRanges(z,ee,re){const ae=this._documents.getDocument(z),Y=await this._provider.provideFoldingRanges(ae,ee,re);if(!!Array.isArray(Y))return Y.map(I.FoldingRange.from)}}class _e{constructor(z,ee,re){this._documents=z,this._provider=ee,this._logService=re}async provideSelectionRanges(z,ee,re){const ae=this._documents.getDocument(z),Y=ee.map(I.Position.to),oe=await this._provider.provideSelectionRanges(ae,Y,re);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const je=[];ve.push(je);let Ke=Y[Me],Se=oe[Me];for(;;){if(!Se.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(I.SelectionRange.from(Se)),!Se.parent)break;Ke=Se.range,Se=Se.parent}}return ve}}class ye{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.prepareCallHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(z,ee,re){const ae=this._itemFromCache(z,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Y)return Y.map(oe=>({from:this._cacheAndConvertItem(z,oe.from),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}async provideCallsFrom(z,ee,re){const ae=this._itemFromCache(z,ee);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Y)return Y.map(oe=>({to:this._cacheAndConvertItem(z,oe.to),fromRanges:oe.fromRanges.map(ve=>I.Range.from(ve))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),ae=I.CallHierarchyItem.from(ee,z,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class Le{constructor(z,ee){this._documents=z,this._provider=ee,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(z,ee,re){const ae=this._documents.getDocument(z),Y=I.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(ae,Y,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(z,ee,re){const ae=this._itemFromCache(z,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(z,oe))}async provideSubtypes(z,ee,re){const ae=this._itemFromCache(z,ee);if(!ae)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(ae,re);if(!!Y)return Y.map(oe=>this._cacheAndConvertItem(z,oe))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,ee){const re=this._cache.get(z),ae=I.TypeHierarchyItem.from(ee,z,re.size.toString(36));return re.set(ae._itemId,ee),ae}_itemFromCache(z,ee){return this._cache.get(z)?.get(ee)}}class ze{constructor(z,ee){this.adapter=z,this.extension=ee}}class xe{constructor(z,ee,re,ae,Y,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=z.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Y,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(z){return(0,P.coalesce)((0,P.asArray)(z).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:I.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new k.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return xe._handlePool++}_withAdapter(z,ee,re,ae,Y=!1){const oe=this._adapter.get(z);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),je=oe.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ke=>{Y&&Ke instanceof A.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,ee){const re=this._nextHandle();return this._adapter.set(re,new ze(z,ee)),re}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,ee,re,ae){const Y=this._addNewAdapter(new l(this._documents,re),z),oe=ae&&ae.label||xe._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(ee),oe),this._createDisposable(Y)}$provideDocumentSymbols(z,ee,re){return this._withAdapter(z,l,ae=>ae.provideDocumentSymbols(f.URI.revive(ee),re),void 0)}registerCodeLensProvider(z,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new ze(new a(this._documents,this._commands.converter,re),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideCodeLenses(z,ee,re){return this._withAdapter(z,a,ae=>ae.provideCodeLenses(f.URI.revive(ee),re),void 0)}$resolveCodeLens(z,ee,re){return this._withAdapter(z,a,ae=>ae.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(z,ee){this._withAdapter(z,a,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(z,ee,re){const ae=this._addNewAdapter(new t(this._documents,re),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDefinition(z,ee,re,ae){return this._withAdapter(z,t,Y=>Y.provideDefinition(f.URI.revive(ee),re,ae),[])}registerDeclarationProvider(z,ee,re){const ae=this._addNewAdapter(new r(this._documents,re),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDeclaration(z,ee,re,ae){return this._withAdapter(z,r,Y=>Y.provideDeclaration(f.URI.revive(ee),re,ae),[])}registerImplementationProvider(z,ee,re){const ae=this._addNewAdapter(new s(this._documents,re),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideImplementation(z,ee,re,ae){return this._withAdapter(z,s,Y=>Y.provideImplementation(f.URI.revive(ee),re,ae),[])}registerTypeDefinitionProvider(z,ee,re){const ae=this._addNewAdapter(new i(this._documents,re),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideTypeDefinition(z,ee,re,ae){return this._withAdapter(z,i,Y=>Y.provideTypeDefinition(f.URI.revive(ee),re,ae),[])}registerHoverProvider(z,ee,re,ae){const Y=this._addNewAdapter(new g(this._documents,re),z);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideHover(z,ee,re,ae){return this._withAdapter(z,g,Y=>Y.provideHover(f.URI.revive(ee),re,ae),void 0)}registerEvaluatableExpressionProvider(z,ee,re,ae){const Y=this._addNewAdapter(new u(this._documents,re),z);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(ee)),this._createDisposable(Y)}$provideEvaluatableExpression(z,ee,re,ae){return this._withAdapter(z,u,Y=>Y.provideEvaluatableExpression(f.URI.revive(ee),re,ae),void 0)}registerInlineValuesProvider(z,ee,re,ae){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new d(this._documents,re),z);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Y);let ve=this._createDisposable(oe);if(Y!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Y));ve=k.Disposable.from(ve,Me)}return ve}$provideInlineValues(z,ee,re,ae,Y){return this._withAdapter(z,d,oe=>oe.provideInlineValues(f.URI.revive(ee),re,ae,Y),void 0)}registerDocumentHighlightProvider(z,ee,re){const ae=this._addNewAdapter(new w(this._documents,re),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentHighlights(z,ee,re,ae){return this._withAdapter(z,w,Y=>Y.provideDocumentHighlights(f.URI.revive(ee),re,ae),void 0)}registerLinkedEditingRangeProvider(z,ee,re){const ae=this._addNewAdapter(new D(this._documents,re),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,ee,re,ae){return this._withAdapter(z,D,async Y=>{const oe=await Y.provideLinkedEditingRanges(f.URI.revive(ee),re,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?xe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(z,ee,re){const ae=this._addNewAdapter(new m(this._documents,re),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideReferences(z,ee,re,ae,Y){return this._withAdapter(z,m,oe=>oe.provideReferences(f.URI.revive(ee),re,ae,Y),void 0)}registerCodeActionProvider(z,ee,re,ae){const Y=new c.DisposableStore,oe=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,re,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:ae?.providedCodeActionKinds?.map(ve=>ve.value),documentation:ae?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},xe._extLabel(z),Boolean(re.resolveCodeAction)),Y.add(this._createDisposable(oe)),Y}$provideCodeActions(z,ee,re,ae,Y){return this._withAdapter(z,S,oe=>oe.provideCodeActions(f.URI.revive(ee),re,ae,Y),void 0)}$resolveCodeAction(z,ee,re){return this._withAdapter(z,S,ae=>ae.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(z,ee){this._withAdapter(z,S,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(z,ee,re){const ae=this._addNewAdapter(new b(this._documents,re),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,ee,re,ae){return this._withAdapter(z,b,Y=>Y.provideDocumentFormattingEdits(f.URI.revive(ee),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,ee,re){const ae=this._addNewAdapter(new F(this._documents,re),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(ee),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,ee,re,ae,Y){return this._withAdapter(z,F,oe=>oe.provideDocumentRangeFormattingEdits(f.URI.revive(ee),re,ae,Y),void 0)}registerOnTypeFormattingEditProvider(z,ee,re,ae){const Y=this._addNewAdapter(new N(this._documents,re),z);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(ee),ae,z.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(z,ee,re,ae,Y,oe){return this._withAdapter(z,N,ve=>ve.provideOnTypeFormattingEdits(f.URI.revive(ee),re,ae,Y,oe),void 0)}registerWorkspaceSymbolProvider(z,ee){const re=this._addNewAdapter(new G(ee,this._logService),z);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(z,ee,re){return this._withAdapter(z,G,ae=>ae.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(z,ee,re){return this._withAdapter(z,G,ae=>ae.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(z,ee){this._withAdapter(z,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(z,ee,re){const ae=this._addNewAdapter(new K(this._documents,re,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(z,ee,re,ae,Y){return this._withAdapter(z,K,oe=>oe.provideRenameEdits(f.URI.revive(ee),re,ae,Y),void 0)}$resolveRenameLocation(z,ee,re,ae){return this._withAdapter(z,K,Y=>Y.resolveRenameLocation(f.URI.revive(ee),re,ae),void 0)}registerDocumentSemanticTokensProvider(z,ee,re,ae){const Y=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new ze(new U(this._documents,re),z)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae,oe);let ve=this._createDisposable(Y);if(oe){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=k.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(z,ee,re,ae){return this._withAdapter(z,U,Y=>Y.provideDocumentSemanticTokens(f.URI.revive(ee),re,ae),null,!0)}$releaseDocumentSemanticTokens(z,ee){this._withAdapter(z,U,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(z,ee,re,ae){const Y=this._addNewAdapter(new O(this._documents,re),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(ee),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(z,ee,re,ae){return this._withAdapter(z,O,Y=>Y.provideDocumentRangeSemanticTokens(f.URI.revive(ee),re,ae),null,!0)}registerCompletionItemProvider(z,ee,re,ae){const Y=this._addNewAdapter(new $(this._documents,this._commands.converter,re,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(ee),ae,$.supportsResolving(re),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(z,ee,re,ae,Y){return this._withAdapter(z,$,oe=>oe.provideCompletionItems(f.URI.revive(ee),re,ae,Y),void 0)}$resolveCompletionItem(z,ee,re){return this._withAdapter(z,$,ae=>ae.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(z,ee){this._withAdapter(z,$,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(z,ee,re){const ae=this._addNewAdapter(new B(this._documents,re,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideInlineCompletions(z,ee,re,ae,Y){return this._withAdapter(z,B,oe=>oe.provideInlineCompletions(f.URI.revive(ee),re,ae,Y),void 0)}$handleInlineCompletionDidShow(z,ee,re){this._withAdapter(z,B,async ae=>{ae.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(z,ee){this._withAdapter(z,B,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(z,ee,re,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new j(this._documents,re),z);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Y),this._createDisposable(oe)}$provideSignatureHelp(z,ee,re,ae,Y){return this._withAdapter(z,j,oe=>oe.provideSignatureHelp(f.URI.revive(ee),re,ae,Y),void 0)}$releaseSignatureHelp(z,ee){this._withAdapter(z,j,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(z,ee,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new H(this._documents,re),z);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(ee),ae);let oe=this._createDisposable(Y);if(ae!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ae));oe=k.Disposable.from(oe,ve)}return oe}$provideInlayHints(z,ee,re,ae){return this._withAdapter(z,H,Y=>Y.provideInlayHints(f.URI.revive(ee),re,ae),void 0)}registerDocumentLinkProvider(z,ee,re){const ae=this._addNewAdapter(new Q(this._documents,re),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,ee,re){return this._withAdapter(z,Q,ae=>ae.provideLinks(f.URI.revive(ee),re),void 0)}$resolveDocumentLink(z,ee,re){return this._withAdapter(z,Q,ae=>ae.resolveLink(ee,re),void 0)}$releaseDocumentLinks(z,ee){this._withAdapter(z,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(z,ee,re){const ae=this._addNewAdapter(new X(this._documents,re),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideDocumentColors(z,ee,re){return this._withAdapter(z,X,ae=>ae.provideColors(f.URI.revive(ee),re),[])}$provideColorPresentations(z,ee,re,ae){return this._withAdapter(z,X,Y=>Y.provideColorPresentations(f.URI.revive(ee),re,ae),void 0)}registerFoldingRangeProvider(z,ee,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new ze(new fe(this._documents,re),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(ee),Y);let oe=this._createDisposable(ae);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));oe=k.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(z,ee,re,ae){return this._withAdapter(z,fe,Y=>Y.provideFoldingRanges(f.URI.revive(ee),re,ae),void 0)}registerSelectionRangeProvider(z,ee,re){const ae=this._addNewAdapter(new _e(this._documents,re,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$provideSelectionRanges(z,ee,re,ae){return this._withAdapter(z,_e,Y=>Y.provideSelectionRanges(f.URI.revive(ee),re,ae),[])}registerCallHierarchyProvider(z,ee,re){const ae=this._addNewAdapter(new ye(this._documents,re),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareCallHierarchy(z,ee,re,ae){return this._withAdapter(z,ye,Y=>Promise.resolve(Y.prepareSession(f.URI.revive(ee),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,ee,re,ae){return this._withAdapter(z,ye,Y=>Y.provideCallsTo(ee,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,ee,re,ae){return this._withAdapter(z,ye,Y=>Y.provideCallsFrom(ee,re,ae),void 0)}$releaseCallHierarchy(z,ee){this._withAdapter(z,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(z,ee,re){const ae=this._addNewAdapter(new Le(this._documents,re),z);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(ee)),this._createDisposable(ae)}$prepareTypeHierarchy(z,ee,re,ae){return this._withAdapter(z,Le,Y=>Promise.resolve(Y.prepareSession(f.URI.revive(ee),re,ae)),void 0)}$provideTypeHierarchySupertypes(z,ee,re,ae){return this._withAdapter(z,Le,Y=>Y.provideSupertypes(ee,re,ae),void 0)}$provideTypeHierarchySubtypes(z,ee,re,ae){return this._withAdapter(z,Le,Y=>Y.provideSubtypes(ee,re,ae),void 0)}$releaseTypeHierarchy(z,ee){this._withAdapter(z,Le,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,C.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:xe._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?xe._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?xe._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:xe._serializeRegExp(z.beforeText),afterText:z.afterText?xe._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?xe._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(xe._serializeOnEnterRule)}setLanguageConfiguration(z,ee,re){let{wordPattern:ae}=re;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(ee,ae):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Y=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,ee,oe),this._createDisposable(Y)}$setWordDefinitions(z){for(const ee of z)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(me[245],ge([0,1,5,15,7,48,17]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(P,n){this._handlePool=0,this._proxy=P.getProxy(f.MainContext.MainThreadLanguages),this._documents=n}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,n){await this._proxy.$changeLanguage(P,n);const T=this._documents.getDocumentData(P);if(!T)throw new Error(`document '${P.toString}' NOT found`);return T.document}async tokenAtPosition(P,n){const T=P.version,c=L.Position.from(n),h=await this._proxy.$tokensAtPosition(P.uri,c),o={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(n)??new I.Range(n.line,n.character,n.line,n.character)};if(!h)return o;const v={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!v.range.contains(n)||T!==P.version?o:v}createLanguageStatusItem(P){const n=this._handlePool++,T=this._proxy,c={selector:P,text:"",detail:"",severity:I.LanguageStatusSeverity.Information};let h;const o=()=>{h?.dispose(),h=(0,R.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(n,{selector:c.selector,text:c.text,message:typeof c.detail=="string"?c.detail:L.MarkdownString.from(c.detail),severity:c.severity===I.LanguageStatusSeverity.Error?k.default.Error:c.severity===I.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info})},0)},v={get selector(){return c.selector},set selector(_){c.selector=_,o()},get text(){return c.text},set text(_){c.text=_,o()},get detail(){return c.detail},set detail(_){c.detail=_,o()},get severity(){return c.severity},set severity(_){c.severity=_,o()},dispose(){h?.dispose(),T.$removeLanguageStatus(n)}};return o(),v}}e.ExtHostLanguages=C}),define(me[246],ge([0,1,5,12,36]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(C){return C&&C.title}let R=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(f.MainContext.MainThreadMessageService)}showMessage(y,P,n,T,c){const h={extension:y};let o;typeof T=="string"||k(T)?o=[T,...c]:(h.modal=T?.modal,h.useCustom=T?.useCustom,h.detail=T?.detail,o=c),h.useCustom&&(0,I.checkProposedApiEnabled)(y);const v=[];for(let _=0;_<o.length;_++){const A=o[_];if(typeof A=="string")v.push({title:A,handle:_,isCloseAffordance:!1});else if(typeof A=="object"){let{title:E,isCloseAffordance:l}=A;v.push({title:E,isCloseAffordance:!!l,handle:_})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(P,n,h,v).then(_=>{if(typeof _=="number")return o[_]})}};R=Ve([Be(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[247],ge([0,1,23,3,58,6,24,9,13,2,87,5,15,7,66,222,129]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(l,a,p,t,r){this._textDocumentsAndEditors=p,this._textDocuments=t,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(T.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(T.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(T.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,g=s.cell.handle,d=this._documents.get(i)?.getCell(g);if(d)return d.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const a=this._editors.get(l);if(!a)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(l){for(const[a,p]of this._editors)if(p.apiEditor===l)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,a){const p=this._documents.get(l);if(!p&&!a)throw new Error(`NO notebook document for '${l}'`);return p}_getProviderData(l){const a=this._notebookContentProviders.get(l);if(!a)throw new Error(`NO provider for '${l}'`);return a}registerNotebookContentProvider(l,a,p,t,r){if((0,C.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:l,provider:p});let s;return p.onDidChangeNotebookContentOptions&&(s=p.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(a,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},a,c.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(l,r)),new h.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(l,a){if(!a)return;const p=a.filenamePattern.map(t=>c.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(a.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:a.displayName,filenamePattern:p,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,a,p){const t=A._notebookStatusBarItemProviderHandlePool++,r=typeof p.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,r,a);let s;return r!==void 0&&(s=p.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,r),s&&s.dispose()})}async createNotebookDocument(l){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&c.NotebookData.from(l.content)});return P.URI.revive(a)}async openNotebookDocument(l){const a=this._documents.get(l);if(a)return a.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(l),t=this._documents.get(P.URI.revive(p));return(0,y.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(l,a){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let p;typeof a=="object"?p={position:c.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(c.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,p),r=t&&this._editors.get(t)?.apiEditor;if(r)return r;throw t?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,a,p,t){const r=this._notebookStatusBarItemProviders.get(l),s=P.URI.revive(a),i=this._documents.get(s);if(!i||!r)return;const g=i.getCellFromIndex(p);if(!g)return;const u=await r.provideCellStatusBarItems(g.apiCell,t);if(!u)return;const d=new k.DisposableStore,w=this._statusBarCache.add([d]),m=(Array.isArray(u)?u:[u]).map(S=>c.NotebookStatusBarItem.from(S,this._commandsConverter,d));return{cacheId:w,items:m}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,a,p,t,r){if((0,C.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,p),this._notebookProxy.$registerNotebookSerializer(s,{id:l.identifier,location:l.extensionLocation},a,c.NotebookDocumentContentOptions.from(t),A._convertNotebookRegistrationData(l,r)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(l,a,p){const t=this._notebookSerializer.get(l);if(!t)throw new Error("NO serializer found");const r=await t.deserializeNotebook(a.buffer,p);return new o.SerializableObjectWithBuffers(c.NotebookData.from(r))}async $notebookToData(l,a,p){const t=this._notebookSerializer.get(l);if(!t)throw new Error("NO serializer found");const r=await t.serializeNotebook(c.NotebookData.to(a.value),p);return f.VSBuffer.wrap(r)}async $openNotebook(l,a,p,t,r){const{provider:s}=this._getProviderData(l),i=await s.openNotebook(P.URI.revive(a),{backupId:p,untitledDocumentData:t?.buffer},r);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(l,a,p){const t=this.getNotebookDocument(P.URI.revive(a)),{provider:r}=this._getProviderData(l);return await r.saveNotebook(t.apiNotebook,p),!0}async $saveNotebookAs(l,a,p,t){const r=this.getNotebookDocument(P.URI.revive(a)),{provider:s}=this._getProviderData(l);return await s.saveNotebookAs(P.URI.revive(p),r.apiNotebook,t),!0}async $backupNotebook(l,a,p){const t=this.getNotebookDocument(P.URI.revive(a)),r=this._getProviderData(l),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,I.hash)([t.uri.toString(),this._backupIdPool++])),g=P.URI.joinPath(s,i),u=await r.provider.backupNotebook(t.apiNotebook,{destination:g},p);return t.updateBackup(u),u.id}_createExtHostEditor(l,a,p){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const t=new _.ExtHostNotebookEditor(a,this._notebookEditorsProxy,l,p.visibleRanges.map(c.NotebookRange.to),p.selections.map(c.NotebookRange.to),typeof p.viewColumn=="number"?c.ViewColumn.to(p.viewColumn):void 0);this._editors.set(a,t)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const p of l.value.removedDocuments){const t=P.URI.revive(p),r=this._documents.get(t);r&&(r.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===t.toString()&&this._editors.delete(s.id)}if(l.value.addedDocuments){const p=[];for(const t of l.value.addedDocuments){const r=P.URI.revive(t.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=this,i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(g){s._onDidChangeNotebookCells.fire(g)},emitCellOutputsChange(g){s._onDidChangeCellOutputs.fire(g)},emitCellMetadataChange(g){s._onDidChangeCellMetadata.fire(g)},emitCellExecutionStateChange(g){s._onDidChangeCellExecutionState.fire(g)}},r,t);p.push(...t.cells.map(g=>v.ExtHostCell.asModelAddData(i.apiNotebook,g))),this._documents.get(r)?.dispose(),this._documents.set(r,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const p of l.value.addedEditors){if(this._editors.has(p.id))return;const t=P.URI.revive(p.documentUri),r=this._documents.get(t);r&&this._createExtHostEditor(r,p.id,p)}const a=[];if(l.value.removedEditors)for(const p of l.value.removedEditors){const t=this._editors.get(p);t&&(this._editors.delete(p),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),a.push(t))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const p=new Set;this._visibleNotebookEditors.forEach(t=>p.add(t.id));for(const t of this._editors.values()){const r=p.has(t.id);t._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(me[248],ge([0,1,3,76,12,5,14,15]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(T,c){const h=y._Keys.nextId();T.$registerNotebookEditorDecorationType(h,C.NotebookDecorationRenderOptions.from(c)),this.value={key:h,dispose(){T.$removeNotebookEditorDecorationType(h)}}}}y._Keys=new L.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(T,c,h){this._logService=T,this._extHostRpc=c,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(T){return new y(this._extHostRpc.getProxy(k.MainContext.MainThreadNotebookEditors),T).value}$acceptEditorPropertiesChanged(T,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,c);const h=this._notebooksAndEditors.getEditorById(T);c.visibleRanges&&h._acceptVisibleRanges(c.visibleRanges.ranges.map(C.NotebookRange.to)),c.selections&&h._acceptSelections(c.selections.selections.map(C.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const c in T)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(C.ViewColumn.to(T[c]))}};P=Ve([Be(0,I.ILogService),Be(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(me[249],ge([0,1,20,17,21,3,6,24,2,26,12,5,15,7,89,215,36,66]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(r,s,i,g){this._initData=s,this._extHostNotebook=i,this._logService=g,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(r,s,i,g,u,d){for(let x of this._kernelData.values())if(x.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,x.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const w=this._handlePool++,D=this;this._logService.trace(`NotebookController[${w}], CREATED by ${r.identifier.value}, ${s}`);const m=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let S=!1;const b=new R.DisposableStore,F=new k.Emitter,N=new k.Emitter,G={id:`${r.identifier.value}/${s}`,notebookType:i,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:g||r.identifier.value,preloads:d?d.map(c.NotebookRendererScript.from):[]};let K=u??m,M;this._proxy.$addKernel(w,G).catch(x=>{console.log(x),S=!0});let U=0;const O=()=>{if(S)return;const x=++U;Promise.resolve().then(()=>{x===U&&this._proxy.$updateKernel(w,G)})},$=new C.ResourceMap,B={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(x){G.label=x??r.displayName??r.name,O()},get detail(){return G.detail??""},set detail(x){G.detail=x,O()},get description(){return G.description??""},set description(x){G.description=x,O()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(x){G.supportedLanguages=x,O()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(x){G.supportsExecutionOrder=x,O()},get rendererScripts(){return G.preloads?G.preloads.map(c.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(x){K=x??m},get interruptHandler(){return M},set interruptHandler(x){M=x,G.supportsInterrupt=Boolean(x),O()},createNotebookCellExecution(x){if(S)throw new Error("notebook controller is DISPOSED");if(!$.has(x.notebook.uri))throw D._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return D._createNotebookCellExecution(x)},dispose:()=>{S||(this._logService.trace(`NotebookController[${w}], DISPOSED`),S=!0,this._kernelData.delete(w),b.dispose(),F.dispose(),N.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(x,j){D._proxy.$updateNotebookPriority(w,x.uri,j)},onDidReceiveMessage:N.event,postMessage(x,j){return(0,_.checkProposedApiEnabled)(r),D._proxy.$postMessage(w,j&&D._extHostNotebook.getIdByEditor(j),x)},asWebviewUri(x){return(0,_.checkProposedApiEnabled)(r),(0,o.asWebviewUri)(x,D._initData.remote)}};return this._kernelData.set(w,{extensionId:r.identifier,controller:B,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:$}),B}$acceptNotebookAssociation(r,s,i){const g=this._kernelData.get(r);if(g){const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));i?g.associatedNotebooks.set(u.uri,!0):g.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,u.uri.toString(),i),g.onDidChangeSelection.fire({selected:i,notebook:u.apiNotebook})}}async $executeCells(r,s,i){const g=this._kernelData.get(r);if(!g)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(s)),d=[];for(let w of i){const D=u.getCell(w);D&&d.push(D.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,u.uri.toString(),d.length),await g.controller.executeHandler.call(g.controller,d,u.apiNotebook,g.controller)}catch(w){this._logService.error(`NotebookController[${r}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(r,s,i){const g=this._kernelData.get(r);if(!g)return;const u=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,u.apiNotebook);else for(let d of i){const w=u.getCell(d);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,i){const g=this._kernelData.get(r);if(!g)return;const u=this._extHostNotebook.getEditorById(s);g.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:i}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const g=new a(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,g);const u=g.onDidChangeState(()=>{g.state===l.Resolved&&(g.dispose(),u.dispose(),this._activeExecutions.delete(i.uri))});return g.asApiObject()}};E=Ve([Be(3,n.ILogService)],E),e.ExtHostNotebookKernels=E;var l;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(l||(l={}));class a extends R.Disposable{constructor(r,s,i){super();this._document=r,this._cell=s,this._proxy=i,this._handle=a.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new p(10,g=>this.update(g)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new A.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const i=h.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?c.NotebookCellOutput.from(s):c.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,i){const g=this.cellIndexToHandle(s),u=this.validateAndConvertOutputs((0,f.asArray)(r));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:g,append:i,outputs:u})}async updateOutputItems(r,s,i){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(r),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(c.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(i){if(r._state===l.Resolved||r._state===l.Started)throw new Error("Cannot call start again");r._state=l.Started,r._onDidChangeState.fire(),r.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:i})},end(i,g){if(r._state===l.Resolved)throw new Error("Cannot call resolve twice");r._state=l.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:g,lastRunSuccess:i}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(i){return r.verifyStateForOutput(),r.updateOutputs([],i,!1)},appendOutput(i,g){return r.verifyStateForOutput(),r.updateOutputs(i,g,!0)},replaceOutput(i,g){return r.verifyStateForOutput(),r.updateOutputs(i,g,!1)},appendOutputItems(i,g){return r.verifyStateForOutput(),r.updateOutputItems(i,g,!0)},replaceOutputItems(i,g){return r.verifyStateForOutput(),r.updateOutputItems(i,g,!1)}})}}a.HANDLE=0;class p{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(me[250],ge([0,1,3,5,129]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(C,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,y,P){const n=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(y)?.fire({editor:n.apiEditor,message:P})}createRendererMessaging(C,y){if(!C.contributes?.notebookRenderer?.some(c=>c.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const P=!!C.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(c,h,o)=>{const v=P?c:_=>{const A={};n.set(A,_.editor),c({editor:A,message:_.message})};return this.getOrCreateEmitterFor(y).event(v,h,o)},postMessage:(c,h)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,h]=[h,c]);const o=P?h:n.get(h),v=o&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(v?.id,y,c)}}}getOrCreateEmitterFor(C){let y=this._rendererMessageEmitters.get(C);return y||(y=new f.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,y),y)}}e.ExtHostNotebookRenderers=k}),define(me[68],ge([0,1,5,3,6,23,4,14]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends I.Disposable{constructor(o,v,_,A,E){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=E,this._id=E.$register(this.name,v,_,A),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?k.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(v=>this._proxy.$clear(v,o))}show(o,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof o=="boolean"?o:v)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class P extends y{constructor(o,v,_){super(o,!1,void 0,v,_)}append(o){super.append(o),this._id.then(v=>this._proxy.$append(v,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class n extends y{constructor(o,v,_){super(o,!0,v,void 0,_)}append(o){throw new Error("Not supported")}}class T{constructor(o,v){this.name=o,this._channel=v}append(o){this._channel.then(v=>v.append(o))}appendLine(o){this._channel.then(v=>v.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,v){this._channel.then(_=>_.show(o,v))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=T;let c=class{constructor(o){this._proxy=o.getProxy(f.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,v){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new P(o,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,v){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new n(o,v,this._proxy)}};c=Ve([Be(0,C.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[251],ge([0,1,17,21,3,6,5,2,7,16,20,48,63]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(o,v,_){const A=o.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(u,d){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=d}showQuickPick(u,d,w,D=L.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(u),S=++this._instances,b=A.$show(S,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},D),F={},N=b.then(()=>F);return Promise.race([N,m]).then(G=>{if(G!==F)return m.then(K=>{const M=[];for(let U=0;U<K.length;U++){const O=K[U];let $,B,x,j,H;typeof O=="string"?$=O:($=O.label,B=O.description,x=O.detail,j=O.picked,H=O.alwaysShow),M.push({label:$,description:B,handle:U,detail:x,picked:j,alwaysShow:H})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{w.onDidSelectItem(K[U])}),A.$setItems(S,M),b.then(U=>{if(typeof U=="number")return K[U];if(Array.isArray(U))return U.map(O=>K[O])})})}).then(void 0,G=>{if(!(0,P.isPromiseCanceledError)(G))return A.$setError(S,G),Promise.reject(G)})}$onItemSelected(u){this._onDidSelectItem&&this._onDidSelectItem(u)}showInput(u,d=L.CancellationToken.None){return this._validateInput=u?u.validateInput:void 0,A.$input(u,typeof this._validateInput=="function",d).then(void 0,w=>{if(!(0,P.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(u){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(u)):Promise.resolve(void 0)}async showWorkspaceFolderPick(u,d=L.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!w)return;const D=await this._workspace.getWorkspaceFolders2();if(!!D)return D.find(m=>m.uri.toString()===w.uri.toString())}createQuickPick(u,d){const w=new s(u,d,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(u){const d=new i(u,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(u,d){const w=this._sessions.get(u);w&&w._fireDidChangeValue(d)}$onDidAccept(u){const d=this._sessions.get(u);d&&d._fireDidAccept()}$onDidChangeActive(u,d){const w=this._sessions.get(u);w instanceof s&&w._fireDidChangeActive(d)}$onDidChangeSelection(u,d){const w=this._sessions.get(u);w instanceof s&&w._fireDidChangeSelection(d)}$onDidTriggerButton(u,d){const w=this._sessions.get(u);w&&w._fireDidTriggerButton(d)}$onDidTriggerItemButton(u,d,w){const D=this._sessions.get(u);D instanceof s&&D._fireDidTriggerItemButton(d,w)}$onDidHide(u){const d=this._sessions.get(u);d&&d._fireDidHide()}}class l{constructor(u,d){this._extensionId=u,this._onDidDispose=d,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((d,w)=>{const D=d===y.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(D,d)}),this.update({buttons:u.map((d,w)=>({...r(d),tooltip:d.tooltip,handle:d===y.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const d=this._handlesToButtons.get(u);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),A.$dispose(this._id))}update(u){if(!this._disposed){for(const d of Object.keys(u)){const w=u[d];this._pendingUpdate[d]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){A.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function a(g){if(g instanceof y.ThemeIcon)return{id:g.id};const u=t(g),d=p(g);return{dark:typeof u=="string"?C.URI.file(u):u,light:typeof d=="string"?C.URI.file(d):d}}function p(g){return typeof g=="object"&&"light"in g?g.light:g}function t(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const u=a(g.iconPath);let d,w;return"id"in u?w=c.ThemeIcon.asClassName(u):d=u,{iconPath:d,iconClass:w}}class s extends l{constructor(u,d,w){super(u,w);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((d,w)=>{this._handlesToItems.set(w,d),this._itemsToHandles.set(d,w)}),this.update({items:u.map((d,w)=>({label:d.label,description:d.description,handle:w,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((D,m)=>({...r(D),tooltip:D.tooltip,handle:m})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(u){const d=(0,n.coalesce)(u.map(w=>this._handlesToItems.get(w)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(u){const d=(0,n.coalesce)(u.map(w=>this._handlesToItems.get(w)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(u,d){const w=this._handlesToItems.get(u);if(!w||!w.buttons||!w.buttons.length)return;const D=w.buttons[d];D&&this._onDidTriggerItemButtonEmitter.fire({button:D,item:w})}}class i extends l{constructor(u,d){super(u,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,this.update({validationMessage:u,severity:u?T.default.Error:T.default.Ignore})}}return new E(v,_)}e.createExtHostQuickOpen=h}),define(me[252],ge([0,1,2,3,56,6,17,5,20,100,12,26,36,63,15]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(u){if(u)return typeof u.iconPath=="string"?f.URI.file(u.iconPath):f.URI.isUri(u.iconPath)||h.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function _(u,d){if(!u.iconPath&&!d.iconPath)return 0;if(u.iconPath){if(!d.iconPath)return 1}else return-1;const w=typeof u.iconPath=="string"?u.iconPath:f.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,D=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,P.comparePaths)(w,D)}function A(u,d){let w=0;if(u.strikeThrough!==d.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==d.faded)return u.faded?1:-1;if(u.tooltip!==d.tooltip)return(u.tooltip||"").localeCompare(d.tooltip||"");if(w=_(u,d),w!==0)return w;if(u.light&&d.light)w=_(u.light,d.light);else{if(u.light)return 1;if(d.light)return-1}if(w!==0)return w;if(u.dark&&d.dark)w=_(u.dark,d.dark);else{if(u.dark)return 1;if(d.dark)return-1}return w}function E(u,d){if(u.command!==d.command)return u.command<d.command?-1:1;if(u.title!==d.title)return u.title<d.title?-1:1;if(u.tooltip!==d.tooltip){if(u.tooltip!==void 0&&d.tooltip!==void 0)return u.tooltip<d.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(u.arguments===d.arguments)return 0;if(u.arguments)if(d.arguments){if(u.arguments.length!==d.arguments.length)return u.arguments.length-d.arguments.length}else return 1;else return-1;for(let w=0;w<u.arguments.length;w++){const D=u.arguments[w],m=d.arguments[w];if(D!==m)return D<m?-1:1}return 0}function l(u,d){let w=(0,P.comparePaths)(u.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(w!==0)return w;if(u.command&&d.command)w=E(u.command,d.command);else{if(u.command)return 1;if(d.command)return-1}if(w!==0)return w;if(u.decorations&&d.decorations)w=A(u.decorations,d.decorations);else{if(u.decorations)return 1;if(d.decorations)return-1}return w}function a(u,d){for(let w=0;w<u.length;w++)if(u[w]!==d[w])return!1;return!0}function p(u,d){return u.command===d.command&&u.title===d.title&&u.tooltip===d.tooltip&&(u.arguments&&d.arguments?a(u.arguments,d.arguments):u.arguments===d.arguments)}function t(u,d){return(0,y.equals)(u,d,p)}class r{constructor(d,w,D){this._extension=d,this._proxy=w,this._sourceControlHandle=D,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,c.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,w){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,w)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=r;class s{constructor(d,w,D,m,S){this._proxy=d,this._commands=w,this._sourceControlHandle=D,this._id=m,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,w){const D=this._resourceStatesCommandsMap.get(d);return D?(0,R.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(l),D=(0,y.sortedDiff)(this._resourceSnapshot,d,l).map(b=>{const F=b.toInsert.map(N=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,N);const K=N.resourceUri;let M;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const fe=new k.DisposableStore;M=this._commands.converter.toInternal(N.command,fe),this._resourceStatesDisposablesMap.set(G,fe)}else this._resourceStatesCommandsMap.set(G,N.command);const U=v(N.decorations),O=N.decorations&&v(N.decorations.light)||U,$=N.decorations&&v(N.decorations.dark)||U,B=[O,$],x=N.decorations&&N.decorations.tooltip||"",j=N.decorations&&!!N.decorations.strikeThrough,H=N.decorations&&!!N.decorations.faded,Q=N.contextValue||"";return{rawResource:[G,K,B,x,j,H,Q,M],handle:G}});return{start:b.start,deleteCount:b.deleteCount,toInsert:F}}),m=D.map(({start:b,deleteCount:F,toInsert:N})=>[b,F,N.map(G=>G.rawResource)]),S=D.reverse();for(const{start:b,deleteCount:F,toInsert:N}of S){const G=N.map(M=>M.handle),K=this._handlesSnapshot.splice(b,F,...G);for(const M of K)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=d,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(d,w,D,m,S,b){this._proxy=w,this._commands=D,this._id=m,this._label=S,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,m,S,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=d;const w=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=d;const w=(d||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(d,w){const D=new s(this._proxy,this._commands,this.handle,d,w),m=L.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,m),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const d=[],w=[];for(const[D,m]of this.createdResourceGroups){m.dispose();const S=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});L.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),S.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),d.push([D.handle,D.id,D.label,D.features]);const b=D._takeResourceStateSnapshot();b.length>0&&w.push([D.handle,b]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,d,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(w=>{const D=w._takeResourceStateSnapshot();D.length!==0&&d.push([w.handle,D])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,I.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,I.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let g=class Bn{constructor(d,w,D){this._commands=w,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(C.MainContext.MainThreadSCM),this._telemetry=d.getProxy(C.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===3){const S=this._sourceControls.get(m.sourceControlHandle);if(!S)return m;const b=S.getResourceGroup(m.groupHandle);return b?b.getResourceState(m.handle):m}else if(m&&m.$mid===4){const S=this._sourceControls.get(m.sourceControlHandle);return S?S.getResourceGroup(m.groupHandle):m}else if(m&&m.$mid===5){const S=this._sourceControls.get(m.handle);return S||m}return m}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,w,D,m){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,w,D,m),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const S=Bn._handlePool++,b=new i(d,this._proxy,this._commands,w,D,m);this._sourceControls.set(S,b);const F=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier))||[];return F.push(b),this._sourceControlsByExtension.set(T.ExtensionIdentifier.toKey(d.identifier),F),b}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const w=this._sourceControlsByExtension.get(T.ExtensionIdentifier.toKey(d.identifier)),D=w&&w[w.length-1];return D&&D.inputBox}$provideOriginalResource(d,w,D){const m=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,m.toString());const S=this._sourceControls.get(d);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>S.quickDiffProvider.provideOriginalResource(m,D)).then(b=>b||null)}$onInputBoxValueChange(d,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const D=this._sourceControls.get(d);return D&&D.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(d,w,D,m){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,w,D);const S=this._sourceControls.get(d);if(!S)return Promise.resolve(void 0);const b=S.getResourceGroup(w);return b?b.$executeResourceCommand(D,m):Promise.resolve(void 0)}$validateInput(d,w,D){this.logService.trace("ExtHostSCM#$validateInput",d);const m=this._sourceControls.get(d);return!m||!m.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>m.inputBox.validateInput(w,D)).then(S=>{if(!S)return Promise.resolve(void 0);const b=o.MarkdownString.fromStrict(S.message);return b?Promise.resolve([b,S.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};g._handlePool=0,g=Ve([Be(2,n.ILogService)],g),e.ExtHostSCM=g});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[253],ge([0,1,7,5,166,6,15]),function(J,e,f,L,I,k,R){"use strict";var C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,o,v,_,A=f.StatusBarAlignment.Left,E){C.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new k.DisposableStore,st(this,C,h,"f"),st(this,y,o,"f"),this._entryId=P.ID_GEN++,this._extension=v,this._id=_,this._alignment=A,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:He(this,y,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:He(this,y,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let o;this._name?o=this._name:o=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;He(this,C,"f").$setEntry(this._entryId,h,o,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,C=new WeakMap,y=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const o={message:h};return this._messages.unshift(o),this._update(),new f.Disposable(()=>{const v=this._messages.indexOf(o);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(h,o){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=o,this._statusMessage=new n(this)}createStatusBarEntry(h,o,v,_){return new P(this._proxy,this._commands,h,o,v,_)}setStatusBarMessage(h,o){const v=this._statusMessage.setMessage(h);let _;return typeof o=="number"?_=setTimeout(()=>v.dispose(),o):typeof o!="undefined"&&o.then(()=>v.dispose(),()=>v.dispose()),new f.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=T}),define(me[93],ge([0,1,5,3,4]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,P){return this._proxy.$getValue(C,y).then(n=>n||P)}setValue(C,y,P){return this._proxy.$setValue(C,y,P)}$acceptValue(C,y,P){this._onDidChangeStorage.fire({shared:C,key:y,value:P})}}e.ExtHostStorage=k,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,92,2]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,n,T){this._logService=n,this._extHostFileSystem=T,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,n=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(T){this._logService.error("[ExtHostStorage]",T);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([Be(0,L.IExtHostInitDataService),Be(1,I.ILogService),Be(2,k.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[34],ge([0,1,3,5,4,2,14,6,7,167,16,217,21,33,197,198,63,13]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class E{constructor(u,d,w,D){this._proxy=u,this._id=d,this._creationOptions=w,this._name=D,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(S=>this._pidPromiseComplete=S);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},get state(){return m._state},sendText(S,b=!0){m._checkDisposed(),m._proxy.$sendText(m._id,S,b)},show(S){m._checkDisposed(),m._proxy.$show(m._id,S)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,A.withNullAsUndefined)(u.shellPath),shellArgs:(0,A.withNullAsUndefined)(u.shellArgs),cwd:(0,A.withNullAsUndefined)(u.cwd),env:(0,A.withNullAsUndefined)(u.env),icon:(0,A.withNullAsUndefined)(s(u.iconPath)),color:_.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,A.withNullAsUndefined)(u.message),strictEnv:(0,A.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,A.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,A.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,A.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(u.location,d?.resolvedExtHostIdentifier,d?.location)})}async createExtensionTerminal(u,d,w,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:_.ThemeColor.isThemeColor(D)?D.id:void 0,location:this._serializeParentTerminal(u,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,d,w){return typeof u=="object"&&"parentTerminal"in u?d?{parentTerminal:d}:void 0:(w&&(u=w),u)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,d){return u===this._cols&&d===this._rows||u===0||d===0?!1:(this._cols=u,this._rows=d,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=E;class l{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new f.Emitter,this._onProcessTitleChanged=new f.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new f.Emitter,this._onProcessShellTypeChanged=new f.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,d){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:d})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d&&{cols:d.columns,rows:d.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>this._onProcessTitleChanged.fire(d)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let a=1,p=class extends C.Disposable{constructor(u,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[w,D]of this._terminalProcesses)D.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,d){const w=new E(this._proxy,(0,h.generateUuid)(),u,u.name),D=new l(u.pty);return w.createExtensionTerminal(this._resolveLocation(u.location),d?.resolvedExtHostIdentifier,s(u.iconPath),i(u.color)).then(m=>{const S=this._setupExtHostProcessListeners(m,D);this._terminalProcessDisposables[m]=S}),this._terminals.push(w),w.value}_resolveLocation(u){return typeof u=="object"&&"viewColumn"in u&&u.viewColumn!==void 0?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:typeof u=="object"&&"parentTerminal"in u?void 0:(u===o.TerminalLocation.Editor||u===o.TerminalLocation.Panel,u)}attachPtyToTerminal(u,d){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const D=new l(d),m=this._setupExtHostProcessListeners(u,D);this._terminalProcessDisposables[u]=m}async $acceptActiveTerminalChanged(u){const d=this._activeTerminal;if(u===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(u);w&&(this._activeTerminal=w,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,d){const w=this._getTerminalById(u);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:d})}async $acceptTerminalDimensions(u,d,w){const D=this._getTerminalById(u);D&&D.setDimensions(d,w)&&this._onDidChangeTerminalDimensions.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptTerminalMaximumDimensions(u,d,w){this._terminalProcesses.get(u)?.resize(d,w)}async $acceptTerminalTitleChange(u,d){const w=this._getTerminalById(u);w&&(w.name=d)}async $acceptTerminalClosed(u,d){const w=this._getTerminalObjectIndexById(this._terminals,u);if(w!==null){const D=this._terminals.splice(w,1)[0];D.setExitCode(d),this._onDidCloseTerminal.fire(D.value)}}$acceptTerminalOpened(u,d,w,D){if(d){const b=this._getTerminalObjectIndexById(this._terminals,d);if(b!==null){this._terminals[b]._id=u,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const m={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:k.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},S=new E(this._proxy,u,m,w);this._terminals.push(S),this._onDidOpenTerminal.fire(S.value),S.isOpen=!0}async $acceptTerminalProcessId(u,d){const w=this._getTerminalById(u);w&&w._setProcessId(d)}async $startExtensionTerminal(u,d){const w=this._getTerminalById(u);if(!w)return{message:(0,P.localize)(0,null,u)};w.isOpen||await new Promise(m=>{const S=this.onDidOpenTerminal(async b=>{b===w.value&&(S.dispose(),m())})});const D=this._terminalProcesses.get(u);D?D.startSendingEvents(d):this._extensionTerminalAwaitingStart[u]={initialDimensions:d}}_setupExtHostProcessListeners(u,d){const w=new C.DisposableStore;w.add(d.onProcessReady(m=>this._proxy.$sendProcessReady(u,m.pid,m.cwd))),w.add(d.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(u,m))),this._bufferer.startBuffering(u,d.onProcessData),w.add(d.onProcessExit(m=>this._onProcessExit(u,m))),d.onProcessOverrideDimensions&&w.add(d.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(u,m))),this._terminalProcesses.set(u,d);const D=this._extensionTerminalAwaitingStart[u];return D&&d instanceof l&&(d.startSendingEvents(D.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),w}$acceptProcessAckDataEvent(u,d){this._terminalProcesses.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this._terminalProcesses.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this._getTerminalById(u);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(u,d,w){try{this._terminalProcesses.get(u)?.resize(d,w)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(u,d){this._terminalProcesses.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(u,d))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(d=>this._proxy.$sendProcessCwd(u,d))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,d,w){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,w),this._proxy.$registerProfileProvider(d,u.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(u,d){const w=new c.CancellationTokenSource().token,D=await this._profileProviders.get(u)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,d);return}this.createTerminalFromOptions(D.options,d)}}async $provideLinks(u,d){const w=this._getTerminalById(u);if(!w)return[];this._terminalLinkCache.delete(u);const D=this._terminalLinkCancellationSource.get(u);D&&D.dispose(!0);const m=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,m);const S=[],b={terminal:w.value,line:d},F=[];for(const K of this._linkProviders)F.push(new Promise(async M=>{m.token.onCancellationRequested(()=>M({provider:K,links:[]}));const U=await K.provideTerminalLinks(b,m.token)||[];m.token.isCancellationRequested||M({provider:K,links:U})}));const N=await Promise.all(F);if(m.token.isCancellationRequested)return[];const G=new Map;for(const K of N)K&&K.links.length>0&&S.push(...K.links.map(M=>{const U={id:a++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return G.set(U.id,{provider:K.provider,link:M}),U}));return this._terminalLinkCache.set(u,G),S}$activateLink(u,d){const w=this._terminalLinkCache.get(u)?.get(d);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(u,d){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const w=this._terminalProcessDisposables[u];w&&(w.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,d)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,d){const w=this._getTerminalObjectIndexById(u,d);return w!==null?u[w]:null}_getTerminalObjectIndexById(u,d){let w=null;return u.some((D,m)=>D._id===d?(w=m,!0):!1),w}getEnvironmentVariableCollection(u){let d=this._environmentVariableCollections.get(u.identifier.value);return d||(d=new t,this._setEnvironmentVariableCollection(u.identifier.value,d)),d}_syncEnvironmentVariableCollection(u,d){const w=(0,T.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(u,d.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const w=d[0],D=new t(d[1]);this._setEnvironmentVariableCollection(w,D)})}$acceptDefaultProfile(u,d){this._defaultProfile=u,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(u,d){this._environmentVariableCollections.set(u,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,d)})}};p=Ve([Be(1,R.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class t{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,d){this._setIfDiffers(u,{value:d,type:y.EnvironmentVariableMutatorType.Replace})}append(u,d){this._setIfDiffers(u,{value:d,type:y.EnvironmentVariableMutatorType.Append})}prepend(u,d){this._setIfDiffers(u,{value:d,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,d){const w=this.map.get(u);(!w||w.value!==d.value||w.type!==d.type)&&(this.map.set(u,d),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,d){this.map.forEach((w,D)=>u.call(d,D,w,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let r=class extends p{constructor(u){super(!1,u)}createTerminal(u,d,w){throw new n.NotSupportedError}createTerminalFromOptions(u,d){throw new n.NotSupportedError}};r=Ve([Be(0,R.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function s(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function i(g){return _.ThemeColor.isThemeColor(g)?g:void 0}});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[254],ge([0,1,23,21,3,75,58,77,6,25,13,33,5,14,88,15,7,225,127,90]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(b,F){this.resultsChangedEmitter=new I.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=b.getProxy(c.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),F.registerArgumentProcessor({processArgument:N=>N?.$mid===13?v.TestItem.toItemFromContext(N):N})}createTestController(b,F){if(this.controllers.has(b))throw new Error(`Attempt to insert a duplicate controller with ID "${b}"`);const N=new y.DisposableStore,G=N.add(new A.SingleUseTestCollection(b));G.root.label=F;const K=new Map,M=this.proxy,U={items:G.root.children,get label(){return F},set label($){F=$,G.root.label=$,M.$updateControllerLabel(b,F)},get id(){return b},createRunProfile:($,B,x,j,H)=>{let Q=(0,R.hash)($);for(;K.has(Q);)Q++;const X=new D(this.proxy,b,Q,$,B,x,j,H);return K.set(Q,X),X},createTestItem($,B,x){return new o.TestItemImpl(b,$,B,x)},createTestRun:($,B,x=!0)=>this.runTracker.createTestRun(b,G,$,B,x),set resolveHandler($){G.resolveHandler=$},get resolveHandler(){return G.resolveHandler},dispose:()=>{N.dispose()}};U.createRunConfiguration=U.createRunProfile,M.$registerTestController(b,F),N.add((0,y.toDisposable)(()=>M.$unregisterTestController(b)));const O={controller:U,collection:G,profiles:K};return this.controllers.set(b,O),N.add((0,y.toDisposable)(()=>this.controllers.delete(b))),N.add(G.onDidGenerateDiff($=>M.$publishDiff(b,$))),U}createTestObserver(){return this.observer.checkout()}async runTests(b,F=L.CancellationToken.None){const N=s(b);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(N.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:b.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:m[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:b.exclude?.map(K=>K.id)},F)}$provideFileCoverage(b,F,N){return C.Iterable.find(this.runTracker.trackers,G=>G.id===b)?.getCoverage(F)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(b,F,N,G){return C.Iterable.find(this.runTracker.trackers,K=>K.id===b)?.getCoverage(F)?.resolveFileCoverage(N,G)??Promise.resolve([])}$configureRunProfile(b,F){this.controllers.get(b)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(b){this.results=Object.freeze(b.map(F=>(0,P.deepFreeze)(v.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(b,F){const N=this.controllers.get(l.TestId.fromString(b).controllerId)?.collection;N&&(await N.expand(b,F<0?Infinity:F),N.flushDiff())}$acceptDiff(b){this.observer.applyDiff(b)}async $runControllerTests(b,F){const N=this.controllers.get(b.controllerId);if(!N)return;const{collection:G,profiles:K}=N,M=K.get(b.profileId);if(!M)return;const U=b.testIds.map(x=>G.tree.get(x)).filter(n.isDefined),O=b.excludeExtIds.map(x=>N.collection.tree.get(x)).filter(n.isDefined).filter(x=>U.some(j=>j.fullId.compare(x.fullId)===2));if(!U.length)return;const $=new _.TestRunRequest(U.some(x=>x.actual instanceof o.TestItemRootImpl)?void 0:U.map(x=>x.actual),O.map(x=>x.actual),M),B=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(b,N.collection),F);try{await M.runHandler($,F)}finally{B.isRunning&&!F.isCancellationRequested&&await I.Event.toPromise(B.onEnd),this.runTracker.cancelRunById(b.runId)}}$cancelExtensionTestRun(b){b===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(b)}};p=Ve([Be(0,h.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends y.Disposable{constructor(b,F,N){super();this.dto=b,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new I.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(b){return this.tasks.get(b)?.coverage}createRun(b){const F=this.dto.id,N=this.dto.controllerId,G=(0,T.generateUuid)(),K=new g(this.proxy,F,G),M=$=>(B,...x)=>{if(U){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),$(B,...x))};let U=!1;const O={isPersisted:this.dto.isPersisted,token:this.cts.token,name:b,get coverageProvider(){return K.coverageProvider},set coverageProvider($){K.coverageProvider=$},enqueued:M($=>{this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),1)}),skipped:M($=>{this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),5)}),started:M($=>{this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),2)}),errored:M(($,B,x)=>{this.proxy.$appendTestMessagesInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),B instanceof Array?B.map(v.TestMessage.from):[v.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),6,x)}),failed:M(($,B,x)=>{this.proxy.$appendTestMessagesInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),B instanceof Array?B.map(v.TestMessage.from):[v.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,N).toString(),4,x)}),passed:M(($,B)=>{this.proxy.$updateTestStateInRun(F,G,l.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,B)}),appendOutput:($,B,x)=>{U||(x&&(this.dto.isIncluded(x)?this.ensureTestIsKnown(x):x=void 0),this.proxy.$appendOutputToRun(F,G,f.VSBuffer.fromString($),B&&v.location.from(B),x&&l.TestId.fromExtHostTestItem(x,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:O,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:b,running:!0}),O}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(b){if(!(b instanceof o.TestItemImpl))throw new o.InvalidTestItemError(b.id);if(this.sharedTestIds.has(b.id))return;const F=[];for(;F.unshift(v.TestItem.from(b)),!(this.sharedTestIds.has(b.id)||(this.sharedTestIds.add(b.id),!b.parent));)b=b.parent;const N=this.dto.colllection.root;this.sharedTestIds.has(N.id)||(this.sharedTestIds.add(N.id),F.unshift(v.TestItem.from(N))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class r{constructor(b){this.proxy=b,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(b,F,N){return this.getTracker(b,F,N)}cancelRunById(b){for(const F of this.tracked.values())if(F.id===b){F.dispose();return}}cancelAllRuns(){for(const b of this.tracked.values())b.dispose()}createTestRun(b,F,N,G,K){const M=this.tracked.get(N);if(M)return M.createRun(G);const U=i.fromPublic(b,F,N,K),O=s(N);this.proxy.$startedExtensionTestRun({controllerId:b,profile:O&&{group:m[O.kind],id:O.profileId},exclude:N.exclude?.map(B=>B.id)??[],id:U.id,include:N.include?.map(B=>B.id)??[F.root.id],persist:K});const $=this.getTracker(N,U);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),$.createRun(G)}getTracker(b,F,N){const G=new t(F,this.proxy,N);return this.tracked.set(b,G),G.onEnd(()=>this.tracked.delete(b)),G}}e.TestRunCoordinator=r;const s=S=>{if(!!S.profile){if(!(S.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class i{constructor(b,F,N,G,K,M){this.controllerId=b,this.id=F,this.isPersisted=K,this.colllection=M,this.includePrefix=N.map(U=>U+"\0"),this.excludePrefix=G.map(U=>U+"\0")}static fromPublic(b,F,N,G){return new i(b,(0,T.generateUuid)(),N.include?.map(K=>l.TestId.fromExtHostTestItem(K,b).toString())??[b],N.exclude?.map(K=>l.TestId.fromExtHostTestItem(K,b).toString())??[],G,F)}static fromInternal(b,F){return new i(b.controllerId,b.runId,b.testIds,b.excludeExtIds,!0,F)}isIncluded(b){const F=l.TestId.fromExtHostTestItem(b,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(F===N||F.startsWith(N))return!1;for(const N of this.includePrefix)if(F===N||F.startsWith(N))return!0;return!1}}e.TestRunDto=i;class g{constructor(b,F,N){this.proxy=b,this.runId=F,this.taskId=N}set coverageProvider(b){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!b||(this._coverageProvider=b,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(b){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(b))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(b,F){const N=await this.fileCoverage;let G=N?.[b];return!this._coverageProvider||!N||!G?[]:(G.detailedCoverage||(G=N[b]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class u extends E.IncrementalChangeCollector{constructor(b){super();this.emitter=b,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(b){this.added.add(b)}update(b){Object.assign(b.revived,v.TestItem.toPlain(b.item)),this.added.has(b)||this.updated.add(b)}remove(b){if(this.added.has(b)){this.added.delete(b);return}if(this.updated.delete(b),b.parent&&this.alreadyRemoved.has(b.parent)){this.alreadyRemoved.add(b.item.extId);return}this.removed.add(b)}getChangeEvent(){const{added:b,updated:F,removed:N}=this;return{get added(){return[...b].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...N].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(b){return this.items.get(b)}getMirroredTestDataByReference(b){return this.items.get(b.id)}createItem(b,F){return{...b,revived:v.TestItem.toPlain(b.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=d;class w{constructor(b){this.proxy=b}checkout(){this.current||(this.current=this.createObserverData());const b=this.current;return b.observers++,{onDidChangeTest:b.tests.onDidChangeTests,get tests(){return[...b.tests.rootTests].map(F=>F.revived)},dispose:(0,k.once)(()=>{--b.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(b){return this.current?.tests.getMirroredTestDataByReference(b)}applyDiff(b){this.current?.tests.apply(b)}createObserverData(){const b=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:b}}}class D{constructor(b,F,N,G,K,M,U=!1,O=void 0){this.controllerId=F,this.profileId=N,this._label=G,this.kind=K,this.runHandler=M,this._isDefault=U,this._tag=O,a.set(this,void 0),st(this,a,b,"f");const $=m[K];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);He(this,a,"f").$publishTestRunProfile({profileId:N,controllerId:F,tag:O?v.TestTag.namespace(this.controllerId,O.id):null,label:G,group:$,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(b){b!==this._label&&(this._label=b,He(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:b}))}get isDefault(){return this._isDefault}set isDefault(b){b!==this._isDefault&&(this._isDefault=b,He(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:b}))}get tag(){return this._tag}set tag(b){b?.id!==this._tag?.id&&(this._tag=b,He(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:b?v.TestTag.namespace(this.controllerId,b.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(b){b!==this._configureHandler&&(this._configureHandler=b,He(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!b}))}dispose(){He(this,a,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=D,a=new WeakMap;const m={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[255],ge([0,1,3,20,5,130,15,7]),function(J,e,f,L,I,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(n,T){this._extHostDocumentsAndEditors=T,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const T=this._extHostDocumentsAndEditors.allEditors();return n?T:T.map(c=>c.value)}async showTextDocument(n,T,c){let h;typeof T=="number"?h={position:R.ViewColumn.from(T),preserveFocus:c}:typeof T=="object"?h={position:R.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?R.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:h={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(n.uri,h),v=o&&this._extHostDocumentsAndEditors.getEditor(o);if(v)return v.value;throw o?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,T){return new k.TextEditorDecorationType(this._proxy,n,T).value}$acceptEditorPropertiesChanged(n,T){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(T.options&&c._acceptOptions(T.options),T.selections){const h=T.selections.selections.map(R.Selection.to);c._acceptSelections(h)}if(T.visibleRanges){const h=L.coalesce(T.visibleRanges.map(R.Range.to));c._acceptVisibleRanges(h)}if(T.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...T.options,lineNumbers:R.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const h=C.TextEditorSelectionChangeKind.fromValue(T.selections.source),o=T.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:o,kind:h})}if(T.visibleRanges){const h=L.coalesce(T.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const T in n){const c=this._extHostDocumentsAndEditors.getEditor(T);if(!c)throw new Error("Unknown text editor");const h=R.ViewColumn.to(n[T]);c.value.viewColumn!==h&&(c._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=y}),define(me[256],ge([0,1,2,4,5,6,7]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(n,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const h=c.uri===void 0?void 0:f.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(y(h))?.get(c.handle)}return c}})}async $getTimeline(n,T,c,h,o){return this._providers.get(n)?.provideTimeline(f.URI.revive(T),c,h,o)}registerTimelineProvider(n,T,c,h){const o=new k.DisposableStore,v=this.convertTimelineItem(T.id,h,o).bind(this);let _;T.onDidChange&&(_=T.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:T.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:n,onDidChange:void 0,async provideTimeline(E,l,a,p){p?.resetCache&&(o.clear(),A.get(T.id)?.clear());const t=await T.provideTimeline(E,l,a);if(t==null)return;const r=v(E,p);return{...t,source:T.id,items:t.items.map(r)}},dispose(){for(const E of A.values())E.get(T.id)?.clear();_?.dispose(),o.dispose()}})}convertTimelineItem(n,T,c){return(h,o)=>{let v;if(o?.cacheResults){let _=this._itemsBySourceAndUriMap.get(n);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(n,_));const A=y(h);v=_.get(A),v===void 0&&(v=new Map,_.set(A,v))}return _=>{const{iconPath:A,...E}=_,l=`${n}|${_.id??_.timestamp}`;v?.set(l,_);let a,p,t;return _.iconPath&&(A instanceof R.ThemeIcon?t={id:A.id,color:A.color}:f.URI.isUri(A)?(a=A,p=A):{light:a,dark:p}=A),{...E,id:E.id??void 0,handle:l,source:n,command:_.command?T.toInternal(_.command,c):void 0,icon:a,iconDark:p,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,k.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=C;function y(P){return P?.toString()}}),define(me[257],ge([0,1,6,10,2,5]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,n,T){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const c=T.schemes.find(h=>!R.supportedSchemes.has(h));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,n),this._proxy.$registerUriOpener(P,T.schemes,y,T.label),(0,f.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,n){const T=this._openers.get(y);if(!T)throw new Error(`Unknown opener with id: ${y}`);const c=I.URI.revive(P);return T.canOpenExternalUri(c,n)}async $openUri(y,P,n){const T=this._openers.get(y);if(!T)throw new Error(`Unknown opener id: '${y}'`);return T.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[258],ge([0,1,5,2,6,16,26]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(P,n){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const T=C.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(T,n),this._proxy.$registerUriHandler(T,P),(0,I.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(T),this._proxy.$unregisterUriHandler(T)})}$handleExternalUri(P,n){const T=this.handlers.get(P);if(!T)return Promise.resolve(void 0);try{T.handleUri(L.URI.revive(n))}catch(c){(0,k.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(P){return L.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[70],ge([0,1,3,2,181,207,89,5]),function(J,e,f,L,I,k,R,C){"use strict";var y,P,n,T,c,h,o,v,_,A,E,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(d,w,D,m,S,b,F){y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),T.set(this,void 0),c.set(this,void 0),h.set(this,void 0),o.set(this,""),v.set(this,void 0),_.set(this,!1),A.set(this,!1),E.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new f.Emitter),this._onDidDispose=He(this,l,"f").event,st(this,y,d,"f"),st(this,P,w,"f"),st(this,v,D,"f"),st(this,T,m,"f"),st(this,c,S,"f"),st(this,h,b,"f"),st(this,E,p(b),"f"),st(this,n,F,"f")}dispose(){st(this,_,!0,"f"),He(this,l,"f").fire(),He(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return st(this,A,!0,"f"),(0,R.asWebviewUri)(d,He(this,T,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,o,"f")}set html(d){this.assertNotDisposed(),He(this,o,"f")!==d&&(st(this,o,d,"f"),!He(this,A,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(st(this,A,!0,"f"),He(this,n,"f").report("Webview vscode-resource: uris",He(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,P,"f").$setHtml(He(this,y,"f"),d))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(d){this.assertNotDisposed(),He(this,P,"f").$setOptions(He(this,y,"f"),s(He(this,h,"f"),He(this,c,"f"),d)),st(this,v,d,"f")}async postMessage(d){if(He(this,_,"f"))return!1;const w=(0,k.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:He(this,E,"f")});return He(this,P,"f").$postMessage(He(this,y,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=a,y=new WeakMap,P=new WeakMap,n=new WeakMap,T=new WeakMap,c=new WeakMap,h=new WeakMap,o=new WeakMap,v=new WeakMap,_=new WeakMap,A=new WeakMap,E=new WeakMap,l=new WeakMap;function p(u){try{const d=(0,I.normalizeVersion)((0,I.parseVersion)(u.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,w,D,m,S){this.initData=w,this.workspace=D,this._logService=m,this._deprecationService=S,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,w,...D){const m=this.getWebview(d);if(m){const{message:S}=(0,k.deserializeWebviewMessage)(w,D);m._onMessageEmitter.fire(S)}}$onMissingCsp(d,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,w,D){const m=new a(d,this._webviewProxy,i(w),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(d,m),m._onDidDispose(()=>{this._webviews.delete(d)}),m}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function r(u){return{id:u.identifier,location:u.extensionLocation}}e.toExtensionData=r;function s(u,d,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||g(u,d)}}e.serializeWebviewOptions=s;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=i;function g(u,d){return[...(d?.getWorkspaceFolders()||[]).map(w=>w.uri),u.extensionLocation]}}),define(me[259],ge([0,1,21,58,6,10,22,2,15,70,87,5,7]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class o{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const g=new h(r,s);return this._documents.set(i,g),g}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new c.Disposable(()=>this._providers.delete(r))}}class A{constructor(t,r,s,i,g){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=g,this._editorProviders=new _,this._documents=new o,this._proxy=t.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const g=new I.DisposableStore;return E(s)?(g.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(g.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&g.add(s.onDidChangeCustomDocument(u=>{const d=this.getCustomDocumentEntry(r,u.document.uri);if(l(u)){const w=d.addEdit(u);this._proxy.$onDidEdit(u.document.uri,r,w,u.label)}else this._proxy.$onContentChange(u.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(g,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,g){const u=this._editorProviders.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${r}'`);const d=C.URI.revive(t),w=await u.provider.openCustomDocument(d,{backupId:s,untitledDocumentData:i?.buffer},g);let D;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(r,w,D),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=C.URI.revive(t),{document:g}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,g),g.dispose()}async $resolveWebviewEditor(t,r,s,i,g,u){const d=this._editorProviders.get(s);if(!d)throw new Error(`No provider found for '${s}'`);const w=y.ViewColumn.to(g),D=this._extHostWebview.createNewWebview(r,i.webviewOptions,d.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,w,i.panelOptions,D),S=C.URI.revive(t);switch(d.type){case 1:{const{document:b}=this.getCustomDocumentEntry(s,S);return d.provider.resolveCustomEditor(b,m,u)}case 0:{const b=this._extHostDocuments.getDocument(S);return d.provider.resolveCustomTextEditor(b,m,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const g=this._extHostWebviewPanels.getWebviewPanel(t);if(!g)throw new Error("No webview found");const u=C.URI.revive(r),d=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(d,g,f.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const g=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(g.document,C.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),u=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(u),u.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,C.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function E(p){return typeof p.resolveCustomTextEditor=="function"}function l(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function a(p){const t=p.scheme===k.Schemas.file||p.scheme===k.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[260],ge([0,1,3,6,2,33,15,70,5,7]),function(J,e,f,L,I,k,R,C,y,P){"use strict";var n,T,c,h,o,v,_,A,E,l,a,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(u,d,w,D,m,S,b){super();n.set(this,void 0),T.set(this,void 0),c.set(this,void 0),h.set(this,void 0),o.set(this,void 0),v.set(this,void 0),_.set(this,void 0),A.set(this,void 0),E.set(this,!0),l.set(this,!0),a.set(this,!1),p.set(this,this._register(new f.Emitter)),this.onDidDispose=He(this,p,"f").event,t.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,st(this,n,u,"f"),st(this,T,d,"f"),st(this,c,w,"f"),st(this,o,S,"f"),st(this,A,m,"f"),st(this,v,D,"f"),st(this,h,b,"f")}dispose(){He(this,a,"f")||(st(this,a,!0,"f"),He(this,p,"f").fire(),He(this,T,"f").$disposeWebview(He(this,n,"f")),He(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,h,"f")}get viewType(){return this.assertNotDisposed(),He(this,c,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(u){this.assertNotDisposed(),He(this,v,"f")!==u&&(st(this,v,u,"f"),He(this,T,"f").$setTitle(He(this,n,"f"),u))}get iconPath(){return this.assertNotDisposed(),He(this,_,"f")}set iconPath(u){this.assertNotDisposed(),He(this,_,"f")!==u&&(st(this,_,u,"f"),He(this,T,"f").$setIconPath(He(this,n,"f"),I.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return He(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,A,"f")=="number"&&He(this,A,"f")<0))return He(this,A,"f")}get active(){return this.assertNotDisposed(),He(this,l,"f")}get visible(){return this.assertNotDisposed(),He(this,E,"f")}_updateViewState(u){He(this,a,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(st(this,l,u.active,"f"),st(this,E,u.visible,"f"),st(this,A,u.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(u,d){this.assertNotDisposed(),He(this,T,"f").$reveal(He(this,n,"f"),{viewColumn:u?R.ViewColumn.from(u):void 0,preserveFocus:!!d})}assertNotDisposed(){if(He(this,a,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,T=new WeakMap,c=new WeakMap,h=new WeakMap,o=new WeakMap,v=new WeakMap,_=new WeakMap,A=new WeakMap,E=new WeakMap,l=new WeakMap,a=new WeakMap,p=new WeakMap,t=new WeakMap;class s{constructor(u,d,w){this.webviews=d,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,k.generateUuid)()}createWebviewPanel(u,d,w,D,m={}){const S=typeof D=="object"?D.viewColumn:D,b={viewColumn:R.ViewColumn.from(S),preserveFocus:typeof D=="object"&&!!D.preserveFocus},F=(0,C.shouldSerializeBuffersForPostMessage)(u),N=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(u),N,d,{title:w,panelOptions:i(m),webviewOptions:(0,C.serializeWebviewOptions)(u,this.workspace,m),serializeBuffersForPostMessage:F},b);const G=this.webviews.createNewWebview(N,m,u);return this.createNewWebviewPanel(N,d,w,S,m,G)}$onDidChangeWebviewPanelViewStates(u){const d=Object.keys(u);d.sort((w,D)=>{const m=u[w],S=u[D];return m.active?1:S.active?-1:+m.visible-+S.visible});for(const w of d){const D=this.getWebviewPanel(w);if(!D)continue;const m=u[w];D._updateViewState({active:m.active,visible:m.visible,viewColumn:R.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,d,w){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:w,extension:u}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(u)}),new P.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(u,d,w,D){const m=this._serializers.get(d);if(!m)throw new Error(`No serializer found for '${d}'`);const{serializer:S,extension:b}=m,F=this.webviews.createNewWebview(u,w.webviewOptions,b),N=this.createNewWebviewPanel(u,d,w.title,D,w.panelOptions,F);await S.deserializeWebviewPanel(N,w.state)}createNewWebviewPanel(u,d,w,D,m,S){const b=new r(u,this._proxy,d,w,D,m,S);return this._webviewPanels.set(u,b),b}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=s;function i(g){return{enableFindWidget:g.enableFindWidget,retainContextWhenHidden:g.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[261],ge([0,1,3,6,70,5,7]),function(J,e,f,L,I,k,R){"use strict";var C,y,P,n,T,c,h,o,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends L.Disposable{constructor(a,p,t,r,s,i){super();C.set(this,void 0),y.set(this,void 0),P.set(this,void 0),n.set(this,void 0),T.set(this,!1),c.set(this,void 0),h.set(this,void 0),o.set(this,void 0),v.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,_.set(this,this._register(new f.Emitter)),this.onDidDispose=He(this,_,"f").event,st(this,P,t,"f"),st(this,h,r,"f"),st(this,C,a,"f"),st(this,y,p,"f"),st(this,n,s,"f"),st(this,c,i,"f")}dispose(){He(this,T,"f")||(st(this,T,!0,"f"),He(this,_,"f").fire(),He(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,h,"f")}set title(a){this.assertNotDisposed(),He(this,h,"f")!==a&&(st(this,h,a,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,C,"f"),a))}get description(){return this.assertNotDisposed(),He(this,o,"f")}set description(a){this.assertNotDisposed(),He(this,o,"f")!==a&&(st(this,o,a,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,C,"f"),a))}get visible(){return He(this,c,"f")}get webview(){return He(this,n,"f")}get viewType(){return He(this,P,"f")}_setVisible(a){a===He(this,c,"f")||He(this,T,"f")||(st(this,c,a,"f"),He(this,v,"f").fire())}show(a){this.assertNotDisposed(),He(this,y,"f").$show(He(this,C,"f"),!!a)}assertNotDisposed(){if(He(this,T,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,P=new WeakMap,n=new WeakMap,T=new WeakMap,c=new WeakMap,h=new WeakMap,o=new WeakMap,v=new WeakMap,_=new WeakMap;class E{constructor(a,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,p,t,r){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(a),p,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(a,p,t,r,s){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:g,extension:u}=i,d=this._extHostWebview.createNewWebview(a,{},u),w=new A(a,this._proxy,p,t,d,!0);this._webviewViews.set(a,w),await g.resolveWebviewView(w,{state:r},s)}async $onDidChangeWebviewViewVisibility(a,p){this.getWebviewView(a)._setVisible(p)}async $disposeWebviewView(a){const p=this.getWebviewView(a);this._webviewViews.delete(a),p.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const p=this._webviewViews.get(a);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=E}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $n{constructor(T){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=T.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(T){T!==this._state.focused&&(this._state={...this._state,focused:T},this._onDidChangeWindowState.fire(this._state))}openUri(T,c){let h;if(typeof T=="string"){h=T;try{T=I.URI.parse(T)}catch(o){return Promise.reject(`Invalid uri - '${T}'`)}}return(0,R.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this._proxy.$openUri(T,h,c)}async asExternalUri(T,c){if((0,R.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(T,c);return I.URI.from(h)}};P.InitialState={focused:!0},P=Ve([Be(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[262],ge([0,1,8,60,33,44,6,5,2,14]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(c,h){super();const o=c.getProxy(C.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=y.URI.file((0,f.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await o.$download(v,_),_})}};n=Ve([Be(0,P.IExtHostRpcService),Be(1,k.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[263],ge([0,1,2,8,151,28,68,27,14,6,12,116,42]),function(J,e,f,L,I,k,R,C,y,P,n,T,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class h{constructor(A,E,l){this.name=A,this.file=E,this.appender=l}static async create(A,E){const l=await(0,T.createRotatingLogger)(A,E,30*c.ByteSize.MB,1);return l.clearFormatters(),new h(A,E,l)}append(A){this.appender.critical(A)}flush(){this.appender.flush()}}class o extends R.AbstractExtHostOutputChannel{constructor(A,E,l,a){super(A,!1,f.URI.file(E.file),l,a);this._appender=E}append(A){super.append(A),this._appender.append(A),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(A,E){this._appender.flush(),super.show(A,E)}clear(){this._appender.flush(),super.clear()}}let v=class extends R.ExtHostOutputService{constructor(A,E,l){super(A);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(A){if(A){const E=this._channels.get(A);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(A,E){if(A=A.trim(),!A)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(A,E);return l.then(a=>a._id.then(p=>this._channels.set(p,a))),new R.LazyOutputChannel(A,l)}async _doCreateOutChannel(A,E){try{const l=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await k.SymlinkSupport.existsDirectory(l)||await k.Promises.mkdir(l,{recursive:!0});const p=`${this._namePool++}-${A.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=f.URI.file((0,L.join)(l,`${p}.log`)),r=await h.create(p,t.fsPath);return new o(A,r,E.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new R.ExtHostPushOutputChannel(A,E.identifier.value,this._proxy)}}};v=Ve([Be(0,y.IExtHostRpcService),Be(1,n.ILogService),Be(2,C.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[264],ge([0,1,49,180,2,69,6,10,17]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends k.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let s=0;do{let i;s===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await n(i);const g=L.join(i,"vscode.lock"),u=await o(this._logService,g,!1);if(u)return this._workspaceStorageLock=u,process.on("exit",()=>{u.dispose()}),I.URI.file(i);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function n(a){try{await f.promises.stat(a);return}catch{}try{await f.promises.mkdir(a,{recursive:!0})}catch{}}const T=1e3,c=10*60*1e3;class h extends R.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(p,t);(!r||r.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await f.promises.utimes(t,new Date,new Date)}catch(s){p.error(s),p.info(`Lock '${t}': Could not update mtime.`)}},T)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await f.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function o(a,p,t){try{const s={pid:process.pid,willReleaseAt:0};await f.promises.writeFile(p,JSON.stringify(s),{flag:"wx"})}catch(s){a.error(s)}const r=await v(a,p);return!r||r.pid!==process.pid?t?(a.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),E(a,p)):(a.info(`Lock '${p}': Lock acquired.`),new h(a,p))}async function v(a,p){let t;try{t=await f.promises.readFile(p)}catch(r){return a.error(r),null}try{return JSON.parse(String(t))}catch(r){return a.error(r),null}}async function _(a,p){let t;try{t=await f.promises.stat(p)}catch(r){return a.error(r),0}return t.mtime.getTime()}function A(a){try{return process.kill(a,0),!0}catch(p){return!1}}async function E(a,p){const t=await v(a,p);if(!t)return a.info(`Lock '${p}': Could not read pid of lock holder.`),l(a,p);if(t.willReleaseAt){let u=t.willReleaseAt-Date.now();if(u<5e3){for(u>0?a.info(`Lock '${p}': The lockfile is scheduled to be released in ${u} ms.`):a.info(`Lock '${p}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,y.timeout)(Math.min(100,u)),await _(a,p)===0)return l(a,p);u=t.willReleaseAt-Date.now()}return l(a,p)}}if(!A(t.pid))return a.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),l(a,p);const r=await _(a,p),s=Date.now()-r;if(s<=c)return a.info(`Lock '${p}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;a.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const i=await _(a,p),g=Date.now()-i;return g<=c?(a.info(`Lock '${p}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(a.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),l(a,p))}async function l(a,p){a.info(`Lock '${p}': Deleting a stale lock.`);try{await f.promises.unlink(p)}catch(t){}return o(a,p,!0)}}),define(me[265],ge([0,1,33,14,34]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let k=class extends I.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,y,P){return this.createTerminalFromOptions({name:C,shellPath:y,shellArgs:P})}createTerminalFromOptions(C,y){const P=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),C,C.name);return this._terminals.push(P),P.create(C,this._serializeParentTerminal(C,y)),P.value}_serializeParentTerminal(C,y){if(y=y||{},C.location&&typeof C.location=="object"&&"parentTerminal"in C.location){const P=C.location.parentTerminal;if(P){const n=this._terminals.find(T=>T.value===P);n&&(y.resolvedExtHostIdentifier=n._id)}}else C.location&&typeof C.location!="object"?y.location=C.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}};k=Ve([Be(0,L.IExtHostRpcService)],k),e.ExtHostTerminalService=k}),define(me[266],ge([0,1,5,14,6,27,2,39,22,28,7,11,52,3,195,78,12]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class A{constructor(d,w,D){this.remoteAddress=d,this.localAddress=w,this._dispose=D,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(u){const d=u.trim().split(`
`),w=[];return d.forEach(m=>{const S=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(m);S&&S.length>=3&&w.push({pid:parseInt(S[1],10),socket:parseInt(S[2],10)})}),w.reduce((m,S)=>(m[S.socket]=S,m),{})}e.getSockets=E;function l(...u){const d=[].concat(...u.map(p));return[...new Map(d.filter(w=>w.st==="0A").map(w=>{const D=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:a(D[0]),port:parseInt(D[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=l;function a(u){let d="";if(u.length===8)for(let w=u.length-2;w>=0;w-=2)d+=parseInt(u.substr(w,2),16),w!==0&&(d+=".");else for(let w=u.length-4;w>=0;w-=4)d+=parseInt(u.substr(w,4),16).toString(16),w!==0&&(d+=":");return d}e.parseIpAddress=a;function p(u){const d=u.trim().split(`
`),w=d.shift().trim().split(/\s+/).filter(m=>m!=="rx_queue"&&m!=="tm->when");return d.map(m=>m.trim().split(/\s+/).reduce((S,b,F)=>(S[w[F]||F]=b,S),{}))}e.loadConnectionTable=p;function t(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/vs/server/main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function r(u){const d=u.trim().split(`
`),w=[];return d.forEach(D=>{const m=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);m&&m.length>=4&&w.push({pid:parseInt(m[1],10),ppid:parseInt(m[2]),cmd:m[3]})}),w}e.getRootProcesses=r;async function s(u,d,w){const D=w.reduce((S,b)=>(S[b.pid]=b,S),{}),m=[];return u.forEach(({socket:S,ip:b,port:F})=>{const N=d[S]?d[S].pid:void 0,G=N?D[N]?.cmd:void 0;N&&G&&!t(G)&&m.push({host:b,port:F,detail:G,pid:N})}),m}e.findPorts=s;function i(u,d,w){const D=new Map,m=r(d);for(const S of u){const b=w.get(S.port);if(b){D.set(S.port,b);continue}const F=m.find(N=>N.cmd.includes(`${S.port}`));if(F){let N=F,G;do G=m.find(K=>K.ppid===N.pid),G&&(N=G);while(G);D.set(S.port,{host:S.ip,port:S.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else D.set(S.port,{host:S.ip,port:S.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=i;let g=class extends I.Disposable{constructor(d,w,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(f.MainContext.MainThreadTunnelService),T.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(w,d.displayName);if(D){const m=new A(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(m),m}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,w){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:d,provider:w}),this._proxy.$registerPortsAttributesProvider(d,D),new n.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(d,w,D,m,S){const b=[];for(const N of d){const G=this._portAttributesProviders.get(N);if(!G)return[];b.push(...await Promise.all(w.map(async K=>G.provider.providePortAttributes(K,D,m,S))))}const F=b.filter(N=>!!N);return F.length>0?F.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let w=new v.MovingAverage,D;for(;this._candidateFindingEnabled;){const m=new Date().getTime(),S=(await this.findCandidatePorts()).filter(F=>(0,o.isLocalhost)(F.host)||(0,o.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${S.map(F=>F.port).join(", ")}`);const b=new Date().getTime()-m;w.update(b),(!D||JSON.stringify(D)!==JSON.stringify(S))&&(D=S,await this._proxy.$onFoundNewCandidates(D)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,w){if(this._extensionTunnels.has(d.host)){const D=this._extensionTunnels.get(d.host);D.has(d.port)&&(w&&D.get(d.port).disposeListener.dispose(),await D.get(d.port).tunnel.dispose(),D.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(d,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const m=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const S=this._register(m.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(m.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:m,disposeListener:S}),c.TunnelDto.fromApiTunnel(m)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const w=await Promise.all(d.map(m=>this._showCandidatePort(m.host,m.port,m.detail??""))),D=d.filter((m,S)=>w[S]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(m=>m.port).join(", ")} to ${D.map(m=>m.port).join(", ")}`),D}async findCandidatePorts(){let d="",w="";try{d=await P.Promises.readFile("/proc/net/tcp","utf8"),w=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const D=l(d,w),m=await new Promise(U=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,$,B)=>{U($)})}),S=E(m),b=await P.Promises.readdir("/proc"),F=[];for(let U of b)try{const O=Number(U),$=y.joinPath(R.URI.file("/proc"),U);if((await P.Promises.stat($.fsPath)).isDirectory()&&!isNaN(O)){const x=await P.Promises.readlink(y.joinPath($,"cwd").fsPath),j=await P.Promises.readFile(y.joinPath($,"cmdline").fsPath,"utf8");F.push({pid:O,cwd:x,cmd:j})}}catch(O){}const N=[],G=D.filter(U=>{const O=S[U.socket];return O||N.push(U),O}),K=s(G,S,F);let M;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(O=>{(0,C.exec)("ps -F -A -l | grep root",($,B,x)=>{O(B)})});this._foundRootPorts=i(N,U,this._foundRootPorts),M=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${M.join(", ")}`)}return K.then(U=>M?U.concat(M):U)}};g=Ve([Be(0,L.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,_.ILogService)],g),e.ExtHostTunnelService=g}),define(me[267],ge([0,1,17,23,21,16,3,6,103,231,66]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(m,S){try{return JSON.stringify(m,S)}catch(b){return"null"}}const h="$$ref$$",o={[h]:-1};class v{constructor(S,b){this.jsonString=S,this.referencedBuffers=b}}function _(m,S=null,b=!1){const F=[];return{jsonString:(b?c:JSON.stringify)(m,(G,K)=>{if(typeof K=="undefined")return o;if(typeof K=="object"){if(K instanceof L.VSBuffer){const M=F.push(K)-1;return{[h]:M}}if(S)return S(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=_;function A(m,S,b){return JSON.parse(m,(F,N)=>{if(N){const G=N[h];if(typeof G=="number")return S[G];if(b&&N.$mid===1)return b.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=A;function E(m,S){return JSON.stringify(m,S)}function l(m){return m?(S,b)=>b&&b.$mid===1?m.transformOutgoing(b):b:null}var a;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends C.Disposable{constructor(S,b=null,F=null){super();this[T]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=b,this._uriTransformer=F,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,G=n.ProxyIdentifier.count;N<G;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,y.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:b,sid:F}=S;return this._proxies[b]||(this._proxies[b]=this._createProxy(b,F)),this._proxies[b]}_createProxy(S,b){let F={get:(N,G)=>(typeof G=="string"&&!N[G]&&G.charCodeAt(0)===36&&(N[G]=(...K)=>this._remoteCall(S,G,K)),G===s?b:N[G])};return new Proxy(Object.create(null),F)}set(S,b){return this._locals[S.nid]=b,b}assertRegistered(S){for(let b=0,F=S.length;b<F;b++){const N=S[b];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const b=S.byteLength,F=g.read(S,0),N=F.readUInt8(),G=F.readUInt32();switch(N){case 1:case 2:{let{rpcId:K,method:M,args:U}=d.deserializeRequestJSONArgs(F);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(b,G,K,M,U,N===2);break}case 3:case 4:{let{rpcId:K,method:M,args:U}=d.deserializeRequestMixedArgs(F);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(b,G,K,M,U,N===4);break}case 5:{this._logger&&this._logger.logIncoming(b,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(b,G);break}case 7:{this._receiveReply(b,G,void 0);break}case 9:{let K=d.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(b,G,K);break}case 10:{const K=d.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(b,G,K);break}case 8:{let K=d.deserializeReplyOKVSBuffer(F);this._receiveReply(b,G,K);break}case 11:{let K=d.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(b,G,K);break}case 12:{this._receiveReplyErr(b,G,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,b,F,N,G,K){this._logger&&this._logger.logIncoming(S,b,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${N}(`,G);const M=String(b);let U,O;if(K){const B=new I.CancellationTokenSource;G.push(B.token),U=this._invokeHandler(F,N,G),O=()=>B.cancel()}else U=this._invokeHandler(F,N,G),O=t;this._cancelInvokedHandlers[M]=O;const $=d.serializeAcknowledged(b);this._logger&&this._logger.logOutgoing($.byteLength,b,1,"ack"),this._protocol.send($),U.then(B=>{delete this._cancelInvokedHandlers[M];const x=d.serializeReplyOK(b,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,b,1,"reply:",B),this._protocol.send(x)},B=>{delete this._cancelInvokedHandlers[M];const x=d.serializeReplyErr(b,B);this._logger&&this._logger.logOutgoing(x.byteLength,b,1,"replyErr:",B),this._protocol.send(x)})}_receiveCancel(S,b){this._logger&&this._logger.logIncoming(S,b,1,"receiveCancel");const F=String(b);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(S,b,F){this._logger&&this._logger.logIncoming(S,b,0,"receiveReply:",F);const N=String(b);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],G.resolveOk(F)}_receiveReplyErr(S,b,F){this._logger&&this._logger.logIncoming(S,b,0,"receiveReplyErr:",F);const N=String(b);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const G=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(S,b,F){try{return Promise.resolve(this._doInvokeHandler(S,b,F))}catch(N){return Promise.reject(N)}}_doInvokeHandler(S,b,F){const N=this._locals[S];if(!N)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(S));let G=N[b];if(typeof G!="function")throw new Error("Unknown method "+b+" on actor "+(0,n.getStringIdentifierForProxy)(S));return G.apply(N,F)}_remoteCall(S,b,F){if(this._isDisposed)return Promise.reject(k.canceled());let N=null;if(F.length>0&&I.CancellationToken.isCancellationToken(F[F.length-1])&&(N=F.pop()),N&&N.isCancellationRequested)return Promise.reject(k.canceled());const G=d.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,M=String(K),U=new P.LazyPromise;N&&N.onCancellationRequested(()=>{const $=d.serializeCancel(K);this._logger&&this._logger.logOutgoing($.byteLength,K,0,"cancel"),this._protocol.send(d.serializeCancel(K))}),this._pendingRPCReplies[M]=U,this._onWillSendRequest(K);const O=d.serializeRequest(K,S,b,G,!!N);return this._logger&&this._logger.logOutgoing(O.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(S)}.${b}(`,F),this._protocol.send(O),U}}e.RPCProtocol=i,T=r,i.UNRESPONSIVE_TIME=3*1e3;class g{constructor(S,b){this._buff=S,this._offset=b}static alloc(S,b,F){let N=new g(L.VSBuffer.alloc(F+1+4),0);return N.writeUInt8(S),N.writeUInt32(b),N}static read(S,b){return new g(S,b)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,F}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,F}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,b}static sizeMixedArray(S){let b=0;b+=1;for(let F=0,N=S.length;F<N;F++){const G=S[F];switch(b+=1,G.type){case 1:b+=this.sizeLongString(G.value);break;case 2:b+=this.sizeVSBuffer(G.value);break;case 3:b+=this.sizeUInt32,b+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)b+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return b}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let b=0,F=S.length;b<F;b++){const N=S[b];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let G=0;G<N.buffers.length;++G)this.writeBuffer(N.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let b=new Array(S);for(let F=0;F<S;F++)switch(this.readUInt8()){case 1:b[F]=this.readLongString();break;case 2:b[F]=this.readVSBuffer();break;case 3:const G=this.readUInt32(),K=this.readLongString(),M=[];for(let U=0;U<G;++U)M.push(this.readVSBuffer());b[F]=new n.SerializableObjectWithBuffers(A(K,M,null));break;case 4:b[F]=void 0;break}return b}}g.sizeUInt32=4;var u;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(u||(u={}));class d{static _useMixedArgSerialization(S){for(let b=0,F=S.length;b<F;b++)if(S[b]instanceof L.VSBuffer||S[b]instanceof n.SerializableObjectWithBuffers||typeof S[b]=="undefined")return!0;return!1}static serializeRequestArguments(S,b){if(this._useMixedArgSerialization(S)){const F=[];for(let N=0,G=S.length;N<G;N++){const K=S[N];if(K instanceof L.VSBuffer)F[N]={type:2,value:K};else if(typeof K=="undefined")F[N]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:U}=_(K.value,b);F[N]={type:3,value:L.VSBuffer.fromString(M),buffers:U}}else F[N]={type:1,value:L.VSBuffer.fromString(E(K,b))}}return{type:1,args:F}}return{type:0,args:E(S,b)}}static serializeRequest(S,b,F,N,G){switch(N.type){case 0:return this._requestJSONArgs(S,b,F,N.args,G);case 1:return this._requestMixedArgs(S,b,F,N.args,G)}}static _requestJSONArgs(S,b,F,N,G){const K=L.VSBuffer.fromString(F),M=L.VSBuffer.fromString(N);let U=0;U+=g.sizeUInt8(),U+=g.sizeShortString(K),U+=g.sizeLongString(M);let O=g.alloc(G?2:1,S,U);return O.writeUInt8(b),O.writeShortString(K),O.writeLongString(M),O.buffer}static deserializeRequestJSONArgs(S){const b=S.readUInt8(),F=S.readShortString(),N=S.readLongString();return{rpcId:b,method:F,args:JSON.parse(N)}}static _requestMixedArgs(S,b,F,N,G){const K=L.VSBuffer.fromString(F);let M=0;M+=g.sizeUInt8(),M+=g.sizeShortString(K),M+=g.sizeMixedArray(N);let U=g.alloc(G?4:3,S,M);return U.writeUInt8(b),U.writeShortString(K),U.writeMixedArray(N),U.buffer}static deserializeRequestMixedArgs(S){const b=S.readUInt8(),F=S.readShortString(),N=S.readMixedArray(),G=new Array(N.length);for(let K=0,M=N.length;K<M;K++){const U=N[K];typeof U=="string"?G[K]=JSON.parse(U):G[K]=U}return{rpcId:b,method:F,args:G}}static serializeAcknowledged(S){return g.alloc(5,S,0).buffer}static serializeCancel(S){return g.alloc(6,S,0).buffer}static serializeReplyOK(S,b,F){if(typeof b=="undefined")return this._serializeReplyOKEmpty(S);if(b instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(S,b);if(b instanceof n.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:G}=_(b.value,F,!0);return this._serializeReplyOKJSONWithBuffers(S,N,G)}else return this._serializeReplyOKJSON(S,c(b,F))}static _serializeReplyOKEmpty(S){return g.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,b){let F=0;F+=g.sizeVSBuffer(b);let N=g.alloc(8,S,F);return N.writeVSBuffer(b),N.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,b){const F=L.VSBuffer.fromString(b);let N=0;N+=g.sizeLongString(F);let G=g.alloc(9,S,N);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(S,b,F){const N=L.VSBuffer.fromString(b);let G=0;G+=g.sizeUInt32,G+=g.sizeLongString(N);for(const M of F)G+=g.sizeVSBuffer(M);let K=g.alloc(10,S,G);K.writeUInt32(F.length),K.writeLongString(N);for(const M of F)K.writeBuffer(M);return K.buffer}static deserializeReplyOKJSON(S){const b=S.readLongString();return JSON.parse(b)}static deserializeReplyOKJSONWithBuffers(S,b){const F=S.readUInt32(),N=S.readLongString(),G=[];for(let K=0;K<F;++K)G.push(S.readVSBuffer());return new n.SerializableObjectWithBuffers(A(N,G,b))}static serializeReplyErr(S,b){return b?this._serializeReplyErrEror(S,b):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,b){const F=L.VSBuffer.fromString(c(k.transformErrorForSerialization(b),null));let N=0;N+=g.sizeLongString(F);let G=g.alloc(11,S,N);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(S){const b=S.readLongString();return JSON.parse(b)}static _serializeReplyErrEmpty(S){return g.alloc(12,S,0).buffer}}var w;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var D;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(D||(D={}))}),define(me[268],ge([0,1,4]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(me[269],ge([0,1,10,8,11,2,4,86,43,226,268]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let T=class Wn{constructor(h,o,v,_){this.localUserHome=h,this.remoteAgentService=o,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||I.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||h})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,o){if(h.remoteAuthority)return f.Schemas.vscodeRemote;const v=(0,C.getVirtualWorkspaceScheme)(o.getWorkspace());if(v)return v;const _=o.getWorkspace().folders[0];if(_)return _.uri.scheme;const A=o.getWorkspace().configuration;return A?A.scheme:f.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?L.win32:L.posix)}async fileURI(h){let o="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const _=h.indexOf("/",2);_===-1?(o=h.substring(2),h="/"):(o=h.substring(2,_),h=h.substring(_)||"/")}return k.URI.from({scheme:f.Schemas.file,authority:o,path:h,query:"",fragment:""})}};T=Ve([Be(1,n.IRemoteAgentService),Be(2,P.IWorkbenchEnvironmentService),Be(3,y.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(R,C){this.line=R,this.character=C}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,C){return new f(0,0)}with(R){return new f(0,0)}}e.Position=f;class L{constructor(R,C,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(R,C),this.end=new f(y,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var I;(function(k){k[k.Information=1]="Information",k[k.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,25,29,9,4,8,16,71,13]),function(J,e,f,L,I,k,R,C,y,P,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",h=" characters skipped \u27EB",o=(c.length+h.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var v;(function($){$[$.file=0]="file",$[$.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var _;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function A($){return!!$.preview}e.resultIsMatch=A;function E($){return!!$.resource}e.isFileMatch=E;function l($){return!!$.message}e.isProgressMessage=l;var a;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=p;class t{constructor(B,x,j){this.ranges=x;const H=Array.isArray(x)?x:[x];if(j&&j.matchLines===1&&r(H)){B=(0,R.getNLines)(B,j.matchLines);let Q="",X=0,fe=0;const _e=Math.floor(j.charsPerLine/5),ye=[];for(const Le of H){const ze=Math.max(Le.startColumn-_e,0),xe=Le.startColumn+j.charsPerLine;if(ze>fe+_e+o){const Ge=c+(ze-fe)+h;Q+=Ge+B.slice(ze,xe),X+=ze-(fe+Ge.length)}else Q+=B.slice(fe,xe);ye.push(new i(0,Le.startColumn-X,Le.endColumn-X)),fe=xe}this.preview={text:Q,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const Q=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:B,matches:(0,f.mapArrayOrNot)(x,X=>new s(X.startLineNumber-Q,X.startColumn,X.endLineNumber-Q,X.endColumn))}}}}e.TextSearchMatch=t;function r($){const B=$[0].startLineNumber;for(const x of $)if(x.startLineNumber!==B||x.endLineNumber!==B)return!1;return!0}class s{constructor(B,x,j,H){this.startLineNumber=B,this.startColumn=x,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=s;class i extends s{constructor(B,x,j){super(B,x,B,j)}}e.OneLineRange=i;var g;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function u($,B=!0){const x=$&&$.files&&$.files.exclude,j=B&&$&&$.search&&$.search.exclude;if(!x&&!j)return;if(!x||!j)return x||j;let H=Object.create(null);return H=I.mixin(H,I.deepClone(x)),H=I.mixin(H,I.deepClone(j),!0),H}e.getExcludes=u;function d($,B){return $.excludePattern&&L.match($.excludePattern,B)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&L.match($.includePattern,B)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(x=>{const j=x.folder.fsPath;if(k.isEqualOrParent(B,j)){const H=y.relative(j,B);return!x.includePattern||!!L.match(x.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var w;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(B,x){super(B);this.code=x}}e.SearchError=D;function m($){const B=$.message;if((0,P.isPromiseCanceledError)($))return new D(B,w.canceled);try{const x=JSON.parse(B);return new D(x.message,x.code)}catch(x){return new D(B,w.other)}}e.deserializeSearchError=m;function S($){const B={message:$.message,code:$.code};return new Error(JSON.stringify(B))}e.serializeSearchError=S;function b($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=b;function F($){return $.type==="success"}e.isSerializedSearchSuccess=F;function N($){return!!$.path}e.isSerializedFileMatch=N;function G($,B){const x=$.searchPath?$.searchPath:$.relativePath;return(0,R.fuzzyContains)(x,B)}e.isFilePatternMatch=G;class K{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function M($,B){const x={...$||{},...B||{}};return Object.keys(x).filter(j=>{const H=x[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class U{constructor(B,x){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=B.includePattern;x.includePattern&&(j?j={...j,...x.includePattern}:j=x.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}includedInQuerySync(B,x,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,x,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,x,j))}includedInQuery(B,x,j){const H=this._parsedExcludeExpression(B,x,j),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,x,j):!0;return(0,T.isPromise)(H)?H.then(X=>X?!1:Q()):Q()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=U;function O($){for(const B in $)if(typeof $[B]!="boolean")return!0;return!1}}),define(me[37],ge([0,1,20,17,21,3,24,10,78,22,9,13,2,169,4,12,191,43,64,27,14,7,31,5]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a,p,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(S,b,F){return new P.ExtUri(N=>d(N,F)).isEqual(S,b)}function i(S,b,F){return s(S.uri,b.uri,F)?0:(0,n.compare)(S.uri.toString(),b.uri.toString())}function g(S,b,F){return S.index!==b.index?S.index<b.index?-1:1:s(S.uri,b.uri,F)?(0,n.compare)(S.name,b.name):(0,n.compare)(S.uri.toString(),b.uri.toString())}function u(S,b,F,N){const G=S.slice(0).sort((M,U)=>F(M,U,N)),K=b.slice(0).sort((M,U)=>F(M,U,N));return(0,f.delta)(G,K,(M,U)=>F(M,U,N))}function d(S,b){const F=b.getCapabilities(S.scheme);return!(F&&F&1024)}class w extends A.Workspace{constructor(b,F,N,G,K,M){super(b,N.map(U=>new A.WorkspaceFolder(U)),G,M);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(M),N.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(b,F,N,G){if(!b)return{workspace:null,added:[],removed:[]};const{id:K,name:M,folders:U,configuration:O,isUntitled:$}=b,B=[],x=F;F?U.forEach((X,fe)=>{const _e=c.URI.revive(X.uri),ye=w._findFolder(N||F,_e,G);ye?(ye.name=X.name,ye.index=X.index,B.push(ye)):B.push({uri:_e,name:X.name,index:fe})}):B.push(...U.map(({uri:X,name:fe,index:_e})=>({uri:c.URI.revive(X),name:fe,index:_e}))),B.sort((X,fe)=>X.index<fe.index?-1:1);const j=new w(K,M,B,O?c.URI.revive(O):null,!!$,X=>d(X,G)),{added:H,removed:Q}=u(x?x.workspaceFolders:[],j.workspaceFolders,i,G);return{workspace:j,added:H,removed:Q}}static _findFolder(b,F,N){for(let G=0;G<b.folders.length;G++){const K=b.workspaceFolders[G];if(s(K.uri,F,N))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(b,F){return F&&this._structure.get(b)&&(b=(0,P.dirname)(b)),this._structure.findSubstr(b)}resolveWorkspaceFolder(b){return this._structure.get(b)}}let D=class{constructor(b,F,N,G){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=N,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=b.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=b.getProxy(r.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new w(K.id,K.name,[],K.configuration?c.URI.revive(K.configuration):null,!!K.isUntitled,M=>d(M,N)):void 0}$initializeWorkspace(b,F){this._trusted=F,this.$acceptWorkspaceData(b),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(b,F,N,...G){const K=[];if(Array.isArray(G)&&G.forEach(B=>{c.URI.isUri(B.uri)&&!K.some(x=>s(x.uri,B.uri,this._extHostFileSystemInfo))&&K.push({uri:B.uri,name:B.name||(0,P.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[F,N].some(B=>typeof B!="number"||B<0)||N===0&&K.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+N>M.length)return!1;const U=M.slice(0);U.splice(F,N,...K.map(B=>({uri:B.uri,name:B.name||(0,P.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<U.length;B++){const x=U[B];if(U.some((j,H)=>H!==B&&s(x.uri,j.uri,this._extHostFileSystemInfo)))return!1}U.forEach((B,x)=>B.index=x);const{added:O,removed:$}=u(M,U,g,this._extHostFileSystemInfo);if(O.length===0&&$.length===0)return!1;if(this._proxy){const B=b.displayName||b.name;this._proxy.$updateWorkspaceFolders(B,F,N,K).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,h.localize)(0,null,B,x.toString()),{extension:b},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(b,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async getWorkspaceFolder2(b,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(b,F)}async resolveWorkspaceFolder(b){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(b)}getPath(){if(!this._actualWorkspace)return;const{folders:b}=this._actualWorkspace;if(b.length!==0)return b[0].uri.fsPath}getRelativePath(b,F){let N,G="";if(typeof b=="string"?(N=c.URI.file(b),G=b):typeof b!="undefined"&&(N=b,G=b.fsPath),!N)return G;const K=this.getWorkspaceFolder(N,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let M=(0,P.relativePath)(K.uri,N);return F&&K.name&&(M=`${K.name}/${M}`),M}trySetWorkspaceFolders(b){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:b,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(b){const{workspace:F,added:N,removed:G}=w.toExtHostWorkspace(b,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:G}))}findFiles(b,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let M;if(F===null?M=!1:F&&(typeof F=="string"?M=F:M=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:O}=m(b);return this._proxy.$startFileSearch((0,T.withUndefinedAsNull)(U),(0,T.withUndefinedAsNull)(O),(0,T.withUndefinedAsNull)(M),(0,T.withUndefinedAsNull)(N),K).then($=>Array.isArray($)?$.map(B=>c.URI.revive(B)):[])}async findTextInFiles(b,F,N,G,K=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),U=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:O,folder:$}=m(F.include),B=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,x={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:U,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:O,excludePattern:B},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const Q=c.URI.revive(H.resource);H.results.forEach(X=>{(0,t.resultIsMatch)(X)?N({uri:Q,preview:{text:X.preview.text,matches:(0,f.mapArrayOrNot)(X.preview.matches,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,f.mapArrayOrNot)(X.ranges,fe=>new p.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):N({uri:Q,text:X.text,lineNumber:X.lineNumber})})},K.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(b,(0,T.withUndefinedAsNull)($),x,M,K);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(b,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](b)}saveAll(b){return this._proxy.$saveAll(b)}resolveProxy(b){return this._proxy.$resolveProxy(b)}get trusted(){return this._trusted}requestWorkspaceTrust(b){return this._proxy.$requestWorkspaceTrust(b)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=Ve([Be(0,a.IExtHostRpcService),Be(1,l.IExtHostInitDataService),Be(2,E.IExtHostFileSystemInfo),Be(3,v.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function m(S){let b,F;return S&&(typeof S=="string"?b=S:(b=S.pattern,F=S.baseFolder||c.URI.file(S.base))),{includePattern:b,folder:F}}}),define(me[38],ge([0,1,25,3,37,5,7,194,85,13,17,4,14,12,2]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(r,s){if(s){const i=s.split(".");let g=r;for(let u=0;g&&u<i.length;u++)g=g[i[u]];return g}}function _(r){return r instanceof o.URI}function A(r){return r&&r.uri instanceof o.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&r.uri instanceof o.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function a(r){if(_(r))return{resource:r};if(A(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(l(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(s,i,g){this._proxy=s.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=g,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(s,i))}};p=Ve([Be(0,c.IExtHostRpcService),Be(1,I.IExtHostWorkspace),Be(2,h.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,i,g,u){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=u,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(g),this._configurationScopes=this._toMap(g.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const g={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,g))}getConfiguration(s,i,g){const u=a(i)||{},d=this._toReadonlyValue(s?v(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,u,g?.identifier);function w(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(m){return typeof v(d,m)!="undefined"},get:(m,S)=>{this._validateConfigurationAccess(s?`${s}.${m}`:m,u,g?.identifier);let b=v(d,m);if(typeof b=="undefined")b=S;else{let F;const N=(G,K)=>{let M;const U=()=>{F=F||(0,f.deepClone)(d),M=M||v(F,K)};return(0,P.isObject)(G)?new Proxy(G,{get:(O,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return U(),()=>M;if(F)return M=M||v(F,K),M[$];const B=O[$];return typeof $=="string"?N(B,`${K}.${$}`):B},set:(O,$,B)=>(U(),M&&(M[$]=B),!0),deleteProperty:(O,$)=>(U(),M&&delete M[$],!0),defineProperty:(O,$,B)=>(U(),M&&Object.defineProperty(M,$,B),!0)}):G};b=N(b,m)}return b},update:(m,S,b,F)=>{m=s?`${s}.${m}`:m;const N=w(b);return S!==void 0?this._proxy.$updateConfigurationOption(N,m,S,u,F):this._proxy.$removeConfigurationOption(N,m,u,F)},inspect:m=>{m=s?`${s}.${m}`:m;const S=(0,f.deepClone)(this._configuration.inspect(m,u,this._extHostWorkspace.workspace));if(S)return{key:m,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof d=="object"&&(0,f.mixin)(D,d,!1),Object.freeze(D)}_toReadonlyValue(s){const i=g=>(0,P.isObject)(g)?new Proxy(g,{get:(u,d)=>i(u[d]),set:(u,d,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(u,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(u,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return i(s)}_validateConfigurationAccess(s,i,g){const u=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),d=g?`[${g.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const g=new C.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,d)=>g.affectsConfiguration(u,a(d))})}_toMap(s){return s.reduce((i,g)=>(i.set(g[0],g[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[72],ge([0,1,2,17,3,5,7,37,45,38,21,34,14,27,4,10,11,12,67,216,16]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function M($){if($){const B=$;return B&&!!B.process}else return!1}K.is=M;function U($){if($==null)return;const B={process:$.process,args:$.args};return $.options&&(B.options=s.from($.options)),B}K.from=U;function O($){if($!=null)return new R.ProcessExecution($.process,$.args,$.options)}K.to=O})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var g;(function(K){function M(O){if(O!=null)return O}K.from=M;function U(O){if(O!=null)return O}K.to=U})(g=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(K){function M($){if($){const B=$;return B&&(!!B.commandLine||!!B.command)}else return!1}K.is=M;function U($){if($==null)return;const B={};return $.commandLine!==void 0?B.commandLine=$.commandLine:(B.command=$.command,B.args=$.args),$.options&&(B.options=g.from($.options)),B}K.from=U;function O($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new R.ShellExecution($.commandLine,$.options):new R.ShellExecution($.command,$.args?$.args:[],$.options)}K.to=O})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(K){function M($){if($){let B=$;return B&&B.customExecution==="customExecution"}else return!1}K.is=M;function U($){return{customExecution:"customExecution"}}K.from=U;function O($,B){return B.get($)}K.to=O})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(K){function M(U,O){let $;return U.scope!==void 0&&typeof U.scope!="number"?$=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&O&&O.workspaceFile?$=O.workspaceFile:$=l.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:$}}K.from=M})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(K){function M(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}K.from=M})(D=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function(K){function M($,B){if($==null)return[];const x=[];for(let j of $){const H=U(j,B);H&&x.push(H)}return x}K.fromMany=M;function U($,B){if($==null)return;let x;$.execution instanceof R.ProcessExecution?x=i.from($.execution):$.execution instanceof R.ShellExecution?x=u.from($.execution):$.execution&&$.execution instanceof R.CustomExecution&&(x=d.from($.execution));const j=t.from($.definition);let H;return $.scope?typeof $.scope=="number"?H=$.scope:H=$.scope.uri:H=R.TaskScope.Workspace,!j||!H?void 0:{_id:$._id,definition:j,name:$.name,source:{extensionId:B.identifier.value,label:$.source,scope:H},execution:x,isBackground:$.isBackground,group:D.from($.group),presentationOptions:r.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}K.from=U;async function O($,B,x){if($==null)return;let j;i.is($.execution)?j=i.to($.execution):u.is($.execution)?j=u.to($.execution):d.is($.execution)&&(j=d.to($._id,x));const H=t.to($.definition);let Q;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Q=$.source.scope:Q=await B.resolveWorkspaceFolder(f.URI.revive($.source.scope)):Q=R.TaskScope.Workspace),!H||!Q)return;const X=new R.Task(H,Q,$.name,$.source.label,j,$.problemMatchers);return $.isBackground!==void 0&&(X.isBackground=$.isBackground),$.group!==void 0&&(X.group=R.TaskGroup.from($.group._id),X.group&&(X.group=new R.TaskGroup(X.group.id,X.group.label),$.group.isDefault&&(X.group.isDefault=$.group.isDefault))),$.presentationOptions&&(X.presentationOptions=r.to($.presentationOptions)),$._id&&(X._id=$._id),$.detail&&(X.detail=$.detail),X}K.to=O})(m=e.TaskDTO||(e.TaskDTO={}));var S;(function(K){function M(O){return O}K.from=M;function U(O){if(!!O)return Object.assign(Object.create(null),O)}K.to=U})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class b{constructor(M,U,O){this._id=U,this._task=O,p.set(this,void 0),st(this,p,M,"f")}get task(){return this._task}terminate(){He(this,p,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}p=new WeakMap;var F;(function(K){function M(U){return{id:U._id,task:void 0}}K.from=M})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(M,U,O,$,B,x,j,H){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=M.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=$,this._configurationService=B,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,U,O){if(!O)return new R.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:U,provider:O,extension:M}),this._proxy.$registerTaskProvider($,U),new R.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(M,U){this._proxy.$registerTaskSystem(M,U)}fetchTasks(M){return this._proxy.$fetchTasks(S.from(M)).then(async U=>{const O=[];for(let $ of U){const B=await m.to($,this._workspaceProvider,this._providedCustomExecutions2);B&&O.push(B)}return O})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(U=>M.push(U)),M}terminateTask(M){if(!(M instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,U,O){const $=this._providedCustomExecutions2.get(M.id);if($){if(this._activeCustomExecutions2.get(M.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(M.id,$),this._terminalService.attachPtyToTerminal(U,await $.callback(O))}this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const U=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const U=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:U,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const U=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:M.exitCode})}$provideTasks(M,U){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));const $=[],B=(0,L.asPromise)(()=>O.provider.provideTasks(n.CancellationToken.None)).then(x=>this.provideTasksInternal(U,$,O,x));return new Promise(x=>{B.then(j=>{Promise.all($).then(()=>{x(j)})})})}async $resolveTask(M,U){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));if(U.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${O.type}].`);const $=await m.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask($,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,O);const x=m.from(B,O.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(x.execution)&&await this.addCustomExecution(x,B,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,U,O){const $=await this._proxy.$createTaskId(M);!O&&!this._providedCustomExecutions2.has($)&&this._notProvidedCustomExecutions.add($),this._providedCustomExecutions2.set($,U.execution)}async getTaskExecution(M,U){if(typeof M=="string"){const B=this._taskExecutionPromises.get(M);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let O=this._taskExecutionPromises.get(M.id);if(O)return O;const $=new Promise(async(B,x)=>{const j=U||await m.to(M.task,this._workspaceProvider,this._providedCustomExecutions2);j?B(new b(this,M.id,j)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(M.id,$),$.then(B=>(this._taskExecutions.set(M.id,B),B),B=>Promise.reject(B))}checkDeprecation(M,U){M._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let O=this._notProvidedCustomExecutions.values(),$=O.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=O.next()}};N=Ve([Be(0,c.IExtHostRpcService),Be(1,h.IExtHostInitDataService),Be(2,C.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,T.IExtHostTerminalService),Be(6,A.ILogService),Be(7,E.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let G=class extends N{constructor(M,U,O,$,B,x,j,H){super(M,U,O,$,B,x,j,H);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(M,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const O=m.from(U,M);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.addCustomExecution(O,U,!1);else throw new a.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),U);return this._proxy.$executeTask(O).catch(B=>{throw new Error(B)}),$}provideTasksInternal(M,U,O,$){const B=[];if($)for(let x of $){this.checkDeprecation(x,O),(!x.definition||!M[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const j=m.from(x,O.extension);j&&d.is(j.execution)?(B.push(j),U.push(this.addCustomExecution(j,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async resolveTaskInternal(M){if(d.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,U,O){}};G=Ve([Be(0,c.IExtHostRpcService),Be(1,h.IExtHostInitDataService),Be(2,C.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,T.IExtHostTerminalService),Be(6,A.ILogService),Be(7,E.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(me[270],ge([0,1,20,55,30,80,24,10,8,22,9,13,2,145,175,120,43,128,269,31]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(w,D,m,S){this.configurationService=w,this.workspaceContextService=D,this.editorGroupsService=m,this.pathService=S}text(w,D,m={}){w=this.getContentPattern(w,m);const S=this.configurationService.getValue(),b=D&&D.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(D?.map(_.toWorkspaceFolder),m),type:2,contentPattern:w,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:S.search.usePCRE2||b||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles}}getContentPattern(w,D){const m=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const S={...w,wordSeparators:m.editor.wordSeparators};return this.isCaseSensitive(w,D)&&(S.isCaseSensitive=!0),this.isMultiline(w)&&(S.isMultiline=!0),S}file(w,D={}){return{...this.commonQuery(w,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}handleIncludeExclude(w,D){return w?(w=Array.isArray(w)?w.map(i):i(w),D?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],D={}){const m=this.handleIncludeExclude(D.includePattern,D.expandPatterns),S=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),b=w.length>1,F=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,D,S)):w.map(K=>this.getFolderQueryForRoot(K,D,S,b))).filter(K=>!!K),N={_reason:D._reason,folderQueries:F,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:S.pattern,includePattern:m.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const M=f.coalesce(f.flatten(this.editorGroupsService.groups.map(O=>O.editors.map($=>$.resource)))).filter(O=>(0,l.pathIncludedInQuery)(N,O.fsPath)),U=this.commonQueryFromFileList(M);return{...N,...U}}const G=D.extraFileResources&&D.extraFileResources.filter(K=>(0,l.pathIncludedInQuery)(N,K.fsPath));return N.extraFileResources=G&&G.length?G:void 0,N}commonQueryFromFileList(w){const D=[],m=new R.ResourceMap,S={};let b=!1;return w.forEach(F=>{if(F.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let K=m.get(G);K||(b=!0,K={folder:G,includePattern:{}},D.push(K),m.set(G,K));const M=y.relative(G.fsPath,F.fsPath);(0,T.assertIsDefined)(K.includePattern)[M.replace(/\\/g,"/")]=!0}else F.fsPath&&(b=!0,S[F.fsPath]=!0)}),{folderQueries:D,includePattern:S,usingSearchPaths:!0,excludePattern:b?void 0:{"**/*":!0}}}isCaseSensitive(w,D){if(D.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,h.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const D=U=>y.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),S=(Array.isArray(w)?w:r(w)).map(U=>{const O=this.pathService.resolvedUserHome;return O?(0,k.untildify)(U,O.scheme===C.Schemas.file?O.fsPath:O.path):U}),b=L.groupBy(S,U=>D(U)?"searchPaths":"exprSegments"),F=(b.exprSegments||[]).map(U=>n.rtrim(U,"/")).map(U=>n.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),N={},G=this.expandSearchPathPatterns(b.searchPaths||[]);G&&G.length&&(N.searchPaths=G);const K=f.flatten(F),M=t(...K);return M&&(N.pattern=M),N}getExcludesForFolder(w,D){return D.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const D=f.flatten(w.map(S=>{let{pathPortion:b,globPortion:F}=p(S);F&&(F=g(F));const N=this.expandOneSearchPath(b);return f.flatten(N.map(G=>this.resolveOneSearchPathPattern(G,F)))})),m=new Map;return D.forEach(S=>{const b=S.searchPath.toString(),F=m.get(b);F?S.pattern&&(F.pattern=F.pattern||{},F.pattern[S.pattern]=!0):m.set(b,{searchPath:S.searchPath,pattern:S.pattern?t(S.pattern):void 0})}),Array.from(m.values())}expandOneSearchPath(w){if(y.isAbsolute(w)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==C.Schemas.file?[{searchPath:D[0].uri.with({path:w})}]:[{searchPath:c.URI.file(y.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const S=y.posix.resolve(D.path,w);return[{searchPath:D.with({path:S})}]}const m=g(w);return[{searchPath:D,pattern:m}]}else{if(w==="./"||w===".\\")return[];{const D=w.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(b=>{const F=D.match(new RegExp(`^${n.escapeRegExpCharacters(b.name)}(?:/(.*)|$)`));return F?{match:F,folder:b}:null}).filter(T.isDefined);if(S.length)return S.map(b=>{const F=b.match[1];return{searchPath:b.folder.uri,pattern:F&&g(F)}});{const b=w.match(/\.[\/\\](.+)[\/\\]?/),F=b?b[1]:w,N=o.localize(0,null,F);throw new Error(N)}}}}resolveOneSearchPathPattern(w,D){const m=w.pattern&&D?`${w.pattern}/${D}`:w.pattern||D,S=[{searchPath:w.searchPath,pattern:m}];return m&&!m.endsWith("**")&&S.push({searchPath:w.searchPath,pattern:m+"/**"}),S}getFolderQueryForSearchPath(w,D,m){const S=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),D,m,!1);return S?{...S,includePattern:w.pattern}:null}getFolderQueryForRoot(w,D,m,S){let b;const F=c.URI.isUri(w)?w:w.uri;if(m.searchPaths){const U=m.searchPaths.filter(O=>(0,P.isEqual)(O.searchPath,F))[0];if(U&&!U.pattern)return null;U&&(b=U.pattern)}const N=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(N,D)||{},...b||{}},M=c.URI.isUri(w)?(0,P.basename)(w):w.name;return{folder:F,folderName:S?M:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!N.search.followSymlinks}}};a=Ve([Be(0,v.IConfigurationService),Be(1,_.IWorkspaceContextService),Be(2,A.IEditorGroupsService),Be(3,E.IPathService)],a),e.QueryBuilder=a;function p(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const D=w.index,m=d.substr(0,D).match(/[/|\\][^/\\]*$/);if(m){let S=d.substr(0,m.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:d.substr((m.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((w,D)=>(w[D]=!0,w),Object.create(null)):void 0}function r(d){return I.splitGlobAware(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function s(d){return[`**/${d}/**`,`**/${d}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function i(d){return d.replace(/\\/g,"/")}function g(d){return i(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(d,w){d=f.distinct(d,S=>S.toString());const D=[],m=w.getWorkspace();return d&&d.forEach(S=>{let b;if(w.getWorkbenchState()===2)b=(0,P.relativePath)(m.folders[0].uri,S),b&&b!=="."&&(b="./"+b);else{const F=w.getWorkspaceFolder(S);if(F){const N=F.name;if(m.folders.filter(K=>K.name===N).length===1){const K=(0,P.relativePath)(F.uri,S);K===""?b=`./${F.name}`:b=`./${F.name}/${K}`}else b=S.fsPath}}b&&D.push(b)}),D}e.resolveResourcesForSearchIncludes=u}),define(me[271],ge([0,1,22,2,21,16,4,270,31,43]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function T(v,_){const A=_.activationEvents;if(!A)return Promise.resolve(void 0);const E=[],l=[];for(const i of A)if(/^workspaceContains:/.test(i)){const g=i.substr("workspaceContains:".length);g.indexOf("*")>=0||g.indexOf("?")>=0||v.forceUsingSearch?l.push(g):E.push(g)}if(E.length===0&&l.length===0)return Promise.resolve(void 0);let a;const p=new Promise((i,g)=>{a=i}),t=i=>a({activationEvent:i}),r=Promise.all(E.map(i=>c(v,i,t))).then(()=>{}),s=h(v,_.identifier,l,t);return Promise.all([r,s]).then(()=>{a(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function c(v,_,A){for(const E of v.folders)if(await v.exists(f.joinPath(L.URI.revive(E),_))){A(`workspaceContains:${_}`);return}}async function h(v,_,A,E){if(A.length===0)return Promise.resolve(void 0);const l=new I.CancellationTokenSource,a=v.checkExists(v.folders,A,l.token),p=setTimeout(async()=>{l.cancel(),E(`workspaceContainsTimeout:${A.join(",")}`)},n);let t=!1;try{t=await a}catch(r){k.isPromiseCanceledError(r)||k.onUnexpectedError(r)}l.dispose(),clearTimeout(p),t&&E(`workspaceContains:${A.join(",")}`)}function o(v,_,A,E){const l=v.get(R.IInstantiationService),a=v.get(y.ISearchService),t=l.createInstance(C.QueryBuilder).file(_.map(r=>(0,P.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:A,exists:!0});return a.fileSearch(t,E).then(r=>!!r.limitHit,r=>k.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=o});var st=this&&this.__classPrivateFieldSet||function(J,e,f,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!I:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(J,f):I?I.value=f:e.set(J,f),f},He=this&&this.__classPrivateFieldGet||function(J,e,f,L){if(f==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?L:f==="a"?L.call(J):L?L.value:e.get(J)};define(me[40],ge([0,1,164,8,73,22,17,6,24,2,12,5,38,229,93,37,36,227,16,26,23,202,7,121,4,27,69,14,84,52,34,3,271,91,204]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a,p,t,r,s,i,g,u,d,w,D,m,S,b,F){"use strict";var N,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let M=class Hn extends C.Disposable{constructor(B,x,j,H,Q,X,fe,_e,ye,Le){super();this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=j,this._initData=fe,this._extHostWorkspace=H,this._extHostConfiguration=Q,this._logService=X,this._extHostTunnelService=ye,this._extHostTerminalService=Le,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(T.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(T.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(T.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new b.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=B.createChild(new d.ServiceCollection([o.IExtHostStorage,this._storage],[b.IExtHostSecretState,this._secretState]));const ze=new Set;this._initData.hostExtensions.forEach(xe=>ze.add(l.ExtensionIdentifier.toKey(xe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(xe,Ge,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(xe,E.transformErrorForSerialization(Ge),z)},actualActivateExtension:async(xe,Ge)=>{if(ze.has(l.ExtensionIdentifier.toKey(xe)))return await this._mainThreadExtensionsProxy.$activateExtension(xe,Ge),new h.HostExtension;const z=this._registry.getExtensionDescription(xe);return this._activateExtension(z,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){E.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(x){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,x){return this._activator.activateByEvent(B,x)}_activateById(B,x){return this._activator.activateById(B,x)}activateByIdWithErrors(B,x){return this._activateById(B,x).then(()=>{const j=this._activator.getActivatedExtension(B);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=y.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(j=>{if(!!this._getEntryPoint(j))return this._hostUtils.realpath(j.extensionLocation.fsPath).then(H=>B.set(P.URI.file(H).fsPath,j))});this._extensionPathIndex=Promise.all(x).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return x;const j=this._activator.getActivatedExtension(B);if(!j)return x;try{typeof j.module.deactivate=="function"&&(x=Promise.resolve(j.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,C.dispose)(j.subscriptions)}catch(H){this._logService.error(H)}return x}async _activateExtension(B,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,x).then(j=>{const H=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,x),this._logExtensionActivationTimes(B,x,"success",H),j},j=>{throw this._logExtensionActivationTimes(B,x,"failure"),j})}_logExtensionActivationTimes(B,x,j,H){const Q=U(B,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...H||{},outcome:j})}_doActivateExtension(B,x){const j=U(B,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const H=this._getEntryPoint(B);if(!H)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const Q=new h.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,k.joinPath)(B.extensionLocation,H),Q),this._loadExtensionContext(B)]).then(X=>(I.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Hn._callActivate(this._logService,B.identifier,X[0],X[1],Q))).then(X=>(I.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),X))}_loadExtensionContext(B){const x=new p.ExtensionGlobalMemento(B,this._storage),j=new p.ExtensionMemento(B.identifier.value,!1,this._storage),H=new F.ExtensionSecrets(B,this._secretState),Q=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([x.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let _e;return Object.freeze({globalState:x,workspaceState:j,secrets:H,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(B.extensionLocation.fsPath,ye)},get storagePath(){return fe._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(B).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return P.URI.joinPath(fe._initData.logsLocation,B.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(B)},get globalStorageUri(){return fe._storagePath.globalValue(B)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new O(fe,B.identifier,B,X)),_e},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(B),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,x,j,H,Q){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,x,j,H,Q).then(X=>new h.ActivatedExtension(!1,null,Q.build(),j,X,H.subscriptions))}static _callActivateOptional(B,x,j,H,Q){if(typeof j.activate=="function")try{Q.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${x.value}`);const X=typeof global=="object"?global:self,fe=j.activate.apply(X,[H]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(fe).then(_e=>(Q.activateResolveStop(),_e))}catch(X){return Promise.reject(X)}else return Promise.resolve(j)}_activateOneStartupFinished(B,x){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:x}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const x of B.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(B,x)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(x),H=Promise.all([B,j]).then(()=>{});return Promise.race([H,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(B,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,x){if(this.isActivated(x.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:B.map(X=>X.uri),forceUsingSearch:j,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,fe,_e)=>this._mainThreadWorkspaceProxy.$checkExists(X,fe,_e)},Q=await(0,S.checkActivateWorkspaceContainsExtension)(H,x);if(!!Q)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Q.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:x}=this._initData.environment;if(!B||!x)throw new Error(f.localize(0,null));const j=await this._loadCommonJSModule(null,x,new h.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(f.localize(1,null,x.toString()));return new Promise((H,Q)=>{const X=(ye,Le)=>{ye?Q(ye):H(typeof Le=="number"&&Le>0?1:0)},fe=(0,k.originalFSPath)(x),_e=j.run(fe,X);_e&&_e.then&&_e.then(()=>{H(0)}).catch(ye=>{Q(ye.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,x){return this._resolvers[B]=x,(0,C.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const x=B.indexOf("+");if(x===-1)throw new Error("Not an authority that can be resolved!");const j=B.substr(0,x);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(B,x){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(B);if(!H)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),I.mark(`code/extHost/willResolveAuthority/${j}`);const Q=await H.resolve(B,{resolveAttempt:x});I.mark(`code/extHost/didResolveAuthorityOK/${j}`);const X={authority:B,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},fe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:X,options:fe,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(I.mark(`code/extHost/didResolveAuthorityError/${j}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(B,x){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(B);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const Q=P.URI.revive(x);if(typeof H.getCanonicalURI=="undefined")return Q;const X=await(0,R.asPromise)(()=>H.getCanonicalURI(Q));return X||Q}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,x){return x===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(B,!1))}async $activate(B,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,x),!0):!1}async $deltaExtensions(B,x){B.forEach(H=>H.extensionLocation=P.URI.revive(H.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(x.map(async H=>{const Q=this._registry.getExtensionDescription(H);if(!Q)return;const X=await this._hostUtils.realpath(Q.extensionLocation.fsPath);j.delete(P.URI.file(X).fsPath)})),await Promise.all(B.map(async H=>{const Q=await this._hostUtils.realpath(H.extensionLocation.fsPath);j.set(P.URI.file(Q).fsPath,H)})),this._registry.deltaExtensions(B,x),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let x=a.VSBuffer.alloc(B),j=Math.random()%256;for(let H=0;H<B;H++)x.writeUInt8(j,H);return x}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};M=Ve([Be(0,s.IInstantiationService),Be(1,e.IHostUtils),Be(2,u.IExtHostRpcService),Be(3,v.IExtHostWorkspace),Be(4,c.IExtHostConfiguration),Be(5,n.ILogService),Be(6,i.IExtHostInitDataService),Be(7,g.IExtensionStoragePaths),Be(8,w.IExtHostTunnelService),Be(9,D.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function U($,B){return{id:$.identifier.value,name:$.name,extensionVersion:$.version,publisherDisplayName:$.publisher,activationEvents:$.activationEvents?$.activationEvents.join(","):null,isBuiltin:$.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class O{constructor(B,x,j,H){N.set(this,void 0),G.set(this,void 0),K.set(this,void 0),st(this,N,B,"f"),st(this,G,x,"f"),st(this,K,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,k.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=H}get isActive(){return He(this,N,"f").isActivated(He(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,N,"f").getExtensionExports(He(this,K,"f"))}activate(){return He(this,N,"f").activateByIdWithErrors(He(this,K,"f"),{startup:!1,extensionId:He(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,N=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[53],ge([0,1,8,2,3,17,5,7,124,37,40,45,218,38,212,14,4,13,32,51]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let a=class{constructor(d,w,D,m,S,b){this._workspaceService=w,this._extensionService=D,this._editorsService=m,this._configurationService=S,this._editorTabs=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=d.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(N=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,w){const D=d;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let m=`debug:${encodeURIComponent(D.path||"")}`,S="?";return w&&(m+=`${S}session=${encodeURIComponent(w.id)}`,S="&"),m+=`${S}ref=${D.sourceReference}`,L.URI.parse(m)}else{if(D.path)return L.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const w=[];for(const D of d.getAllExtensionDescriptions())if(D.contributes){const m=D.contributes.debuggers;if(m&&m.length>0)for(const S of m)(0,o.isDebuggerMainContribution)(S)&&w.push(S.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(w=>d.push(w)),d}addBreakpoints(d){this.startBreakpoints();const w=d.filter(S=>{const b=S.id;return this._breakpoints.has(b)?!1:(this._breakpoints.set(b,S),!0)});this.fireBreakpointChanges(w,[],[]);const D=[],m=new Map;for(const S of w)if(S instanceof C.SourceBreakpoint){let b=m.get(S.location.uri.toString());b||(b={type:"sourceMulti",uri:S.location.uri,lines:[]},m.set(S.location.uri.toString(),b),D.push(b)),b.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof C.FunctionBreakpoint&&D.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(d){this.startBreakpoints();const w=d.filter(b=>this._breakpoints.delete(b.id));this.fireBreakpointChanges([],w,[]);const D=w.filter(b=>b instanceof C.SourceBreakpoint).map(b=>b.id),m=w.filter(b=>b instanceof C.FunctionBreakpoint).map(b=>b.id),S=w.filter(b=>b instanceof C.DataBreakpoint).map(b=>b.id);return this._debugServiceProxy.$unregisterBreakpoints(D,m,S)}startDebugging(d,w,D){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,w,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,debugUI:D.debugUI})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,w,D){if(!w)return new C.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:m,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,D,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,m),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(d,w,D){if(!D)return new C.Disposable(()=>{});if(!this.definesDebugType(d,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:m,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,m),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(d,w){if(!w)return new C.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:D,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==w)})}async $runInTerminal(d,w){return Promise.resolve(void 0)}async $substituteVariables(d,w){if(!this._variableResolver){const[S,b]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,b)}let D;const m=await this.getFolder(d);return m&&(D={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,w)}createDebugAdapter(d,w){if(d.type==="implementation")return new i(d.implementation)}createSignService(){}async $startDASession(d,w){const D=this,m=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const b=this.convertToDto(S),F=this.createDebugAdapter(b,m);if(!F)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const N=F;return this._debugAdapters.set(d,N),this.getDebugAdapterTrackers(m).then(G=>(G&&this._debugAdaptersTrackers.set(d,G),N.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const M=K,U={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(M.arguments.value);U.body={signature:O},N.sendResponse(U)}else throw new Error("no signer")}catch(O){U.success=!1,U.message=O.message,N.sendResponse(U)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,o.convertToVSCPaths)(K,!0),D._debugServiceProxy.$acceptDAMessage(d,K)}),N.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(d,K.name,K.message,K.stack)}),N.onExit(K=>{G&&G.onExit&&G.onExit((0,A.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,A.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),N.startSession()))})}$sendDAMessage(d,w){w=(0,o.convertToDAPaths)(w,!1);const D=this._debugAdaptersTrackers.get(d);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(w);const m=this._debugAdapters.get(d);m&&m.sendMessage(w)}$stopDASession(d){const w=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),w&&w.onWillStopSession&&w.onWillStopSession();const D=this._debugAdapters.get(d);return this._debugAdapters.delete(d),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const w=[],D=[],m=[];if(d.added)for(const S of d.added){const b=S.id;if(b&&!this._breakpoints.has(b)){let F;if(S.type==="function")F=new C.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")F=new C.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const N=L.URI.revive(S.uri);F=new C.SourceBreakpoint(new C.Location(N,new C.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}F._id=b,this._breakpoints.set(b,F),w.push(F)}}if(d.removed)for(const S of d.removed){const b=this._breakpoints.get(S);b&&(this._breakpoints.delete(S),D.push(b))}if(d.changed){for(const S of d.changed)if(S.id){const b=this._breakpoints.get(S.id);if(b){if(b instanceof C.FunctionBreakpoint&&S.type==="function"){const F=b;F.enabled=S.enabled,F.condition=S.condition,F.hitCondition=S.hitCondition,F.logMessage=S.logMessage,F.functionName=S.functionName}else if(b instanceof C.SourceBreakpoint&&S.type==="source"){const F=b;F.enabled=S.enabled,F.condition=S.condition,F.hitCondition=S.hitCondition,F.logMessage=S.logMessage,F.location=new C.Location(L.URI.revive(S.uri),new C.Position(S.line,S.character))}m.push(b)}}}this.fireBreakpointChanges(w,D,m)}$provideDebugConfigurations(d,w,D){return(0,k.asPromise)(async()=>{const m=this.getConfigProviderByHandle(d);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(w);return m.provideDebugConfigurations(S,D)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(d,w,D,m){return(0,k.asPromise)(async()=>{const S=this.getConfigProviderByHandle(d);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.getFolder(w);return S.resolveDebugConfiguration(b,D,m)})}$resolveDebugConfigurationWithSubstitutedVariables(d,w,D,m){return(0,k.asPromise)(async()=>{const S=this.getConfigProviderByHandle(d);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.getFolder(w);return S.resolveDebugConfigurationWithSubstitutedVariables(b,D,m)})}async $provideDebugAdapter(d,w){const D=this.getAdapterDescriptorFactoryByHandle(d);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(w);return this.getAdapterDescriptor(D,m).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(d){const w=await this.getSession(d);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(d){const w=await this.getSession(d);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,w){const D=await this.getSession(d);D&&D._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(d,w){const m={session:await this.getSession(d),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const w=this._adapterFactories.filter(D=>D.type===d);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(d){const w=this._adapterFactories.filter(D=>D.handle===d);if(w.length>0)return w[0].factory}getConfigProviderByHandle(d){const w=this._configProviders.filter(D=>D.handle===d);if(w.length>0)return w[0].provider}definesDebugType(d,w){if(d.contributes){const D=d.contributes.debuggers;if(D&&D.length>0){for(const m of D)if(m.label&&m.type&&m.type===w)return!0}}return!1}getDebugAdapterTrackers(d){const D=d.configuration.type,m=this._trackerFactories.filter(S=>S.type===D||S.type==="*").map(S=>(0,k.asPromise)(()=>S.factory.createDebugAdapterTracker(d)).then(b=>b,b=>null));return Promise.race([Promise.all(m).then(S=>{const b=S.filter(F=>!!F);if(b.length>0)return new s(b)}),new Promise((S,b)=>{const F=setTimeout(()=>{clearTimeout(F),b(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(d,w){const D=w.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new C.DebugAdapterServer(D));if(d){const S=await this._extensionService.getExtensionRegistry();return(0,k.asPromise)(()=>d.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,S))).then(b=>{if(b)return b})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,m))}daExecutableFromPackage(d,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,w,D){(d.length>0||w.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:w,changed:D}))}async getSession(d){if(d)if(typeof d=="string"){const w=this._debugSessions.get(d);if(w)return w}else{let w=this._debugSessions.get(d.id);if(!w){const D=await this.getFolder(d.folderUri),m=d.parent?this._debugSessions.get(d.parent):void 0;w=new p(this._debugServiceProxy,d.id,d.type,d.name,D,d.configuration,m),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(d){if(d){const w=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};a=Ve([Be(0,v.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,n.IExtHostExtensionService),Be(3,T.IExtHostDocumentsAndEditors),Be(4,h.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],a),e.ExtHostDebugServiceBase=a;class p{constructor(d,w,D,m,S,b,F){this._debugServiceProxy=d,this._id=w,this._type=D,this._name=m,this._workspaceFolder=S,this._configuration=b,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,w)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(w){d.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends c.AbstractVariableResolverService{constructor(d,w,D,m,S){function b(){if(w){const F=w.activeEditor();if(F)return F.document.uri;const N=m.tabs.filter(G=>G.isActive);if(N.length>0)return N[0].resource}}super({getFolderUri:F=>{const N=d.filter(G=>G.name===F);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(F,N)=>D.getConfiguration(void 0,F).get(N),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=b();if(F)return f.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const F=b();if(F){const N=S.getWorkspaceFolder(F);if(N)return f.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(w){const F=w.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(w){const F=w.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class s{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(w=>w.onError?w.onError(d):void 0)}onExit(d,w){this.trackers.forEach(D=>D.onExit?D.onExit(d,w):void 0)}}class i extends y.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let g=class extends a{constructor(d,w,D,m,S,b){super(d,w,D,m,S,b)}createVariableResolver(d,w,D){return new r(d,w,D,this._editorTabs)}};g=Ve([Be(0,v.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,n.IExtHostExtensionService),Be(3,T.IExtHostDocumentsAndEditors),Be(4,h.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],g),e.WorkerExtHostDebugService=g}),define(me[272],ge([0,1,73,2,5,38,36,26,14,27,4,40,32,12]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(l,a,p,t,r,s,i){this._apiFactory=l,this._extensionRegistry=a,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,a,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,a,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let a of l.nodeModuleName)this._factories.set(a,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(a=>l.alternativeModuleName(a))}};o=Ve([Be(2,n.IInstantiationService),Be(3,k.IExtHostConfiguration),Be(4,T.IExtHostExtensionService),Be(5,P.IExtHostInitDataService),Be(6,h.ILogService)],o),e.RequireInterceptor=o;class v{constructor(l,a,p,t,r){this._apiFactory=l,this._extensionPaths=a,this._extensionRegistry=p,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,a){const p=this._extensionPaths.findSubstr(a.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(l,a){this.nodeModuleName="keytar";const{environment:p}=a,t=l.getProxy(I.MainContext.MainThreadKeytar);if(p.appRoot){let r=p.appRoot.fsPath;c.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(l,a){return this._impl}alternativeModuleName(l){const a=l.length;if(a<=7||!this.alternativeNames)return;const p=a-7;if((l.charAt(p)==="/"||l.charAt(p)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};_=Ve([Be(0,y.IExtHostRpcService),Be(1,P.IExtHostInitDataService)],_);let A=class{constructor(l,a,p){this._extensionPaths=l,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(I.MainContext.MainThreadTelemetry);const t=p.getProxy(I.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=L.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(l,a,p){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(l),this._impl}callOriginal(l,a){return this.sendNoForwardTelemetry(),this._original(l,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=Ve([Be(2,y.IExtHostRpcService)],A)}),define(me[273],ge([0,1,170,11,7,213,37,40,45,38,34,14,53,196,17,214,51]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends c.ExtHostDebugServiceBase{constructor(a,p,t,r,s,i,g){super(a,p,t,r,s,g);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(a,p){switch(a.type){case"server":return new k.SocketDebugAdapter(a);case"pipeServer":return new k.NamedPipeDebugAdapter(a);case"executable":return new k.ExecutableDebugAdapter(a,p.type)}return super.createDebugAdapter(a,p)}daExecutableFromPackage(a,p){const t=k.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),a.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new h.SignService}async $runInTerminal(a,p){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(b=>{this._integratedTerminalInstances.onTerminalClosed(b)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),i=a.title||f.localize(0,null),g=JSON.stringify({shell:r,shellArgs:s});let u=await this._integratedTerminalInstances.checkout(g,i),d,w=!1;if(u)d=a.cwd;else{const b={shellPath:r,shellArgs:s,cwd:a.cwd,name:i,iconPath:new I.ThemeIcon("debug")};w=!0,u=this._terminalService.createTerminalFromOptions(b,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,g)}u.show(!0);const D=await u.processId;w?await new Promise(b=>setTimeout(b,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?u.sendText("cls"):r.indexOf("bash")>=0?u.sendText("clear"):L.isWindows?u.sendText("cls"):u.sendText("clear"));const m=(0,v.prepareCommand)(r,a.args,d,a.env);u.sendText(m);const S=this.onDidTerminateDebugSession(b=>{b.id===p&&(this._integratedTerminalInstances.free(u),S.dispose())});return D}else if(a.kind==="external")return(0,v.runInExternalTerminal)(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,p)}createVariableResolver(a,p,t){return new c.ExtHostVariableResolverService(a,p,t,this._editorTabs,this._workspaceService)}};A=Ve([Be(0,T.IExtHostRpcService),Be(1,R.IExtHostWorkspace),Be(2,C.IExtHostExtensionService),Be(3,y.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,n.IExtHostTerminalService),Be(6,_.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class E{constructor(){this._terminalInstances=new Map}async checkout(a,p){const r=[...this._terminalInstances.entries()].map(([s,i])=>(0,o.createCancelablePromise)(async g=>{if(s.name!==p||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await s.processId))return null;const u=Date.now();return i.lastUsedAt+E.minUseDelay>u||g.isCancellationRequested||i.config!==a?null:(i.lastUsedAt=u,s)}));return await(0,o.firstParallel)(r,s=>!!s)}insert(a,p){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:p})}free(a){const p=this._terminalInstances.get(a);p&&(p.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}E.minUseDelay=1e3}),define(me[274],ge([0,1,8,2,113,37,53,45,38,43,34,14,27,72,10,12,67,51,22,60]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let a=class extends h.ExtHostTaskBase{constructor(t,r,s,i,g,u,d,w,D){super(t,r,s,i,g,u,d,w);this.workspaceService=s,this.editorTabs=D,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(o.Schemas.file,{scheme:o.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const s=r;if(!r.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const i=h.TaskHandleDTO.from(s,this.workspaceService),g=await this._proxy.$getTaskExecution(i);if(g.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(g,r);return this._proxy.$executeTask(i).catch(()=>{}),u}else{const i=h.TaskDTO.from(r,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,r,!1);const g=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),r);return this._proxy.$executeTask(i).catch(()=>{}),g}}provideTasksInternal(t,r,s,i){const g=[];if(i)for(let u of i){this.checkDeprecation(u,s),(!u.definition||!t[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const d=h.TaskDTO.from(u,s.extension);d&&(g.push(d),h.CustomExecutionDTO.is(d.execution)&&r.push(this.addCustomExecution(d,u,!0)))}return{tasks:g,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const s=L.URI.file((0,l.homedir)());r=new P.WorkspaceFolder({uri:s,name:E.basename(s),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const s=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},g=await this._workspaceProvider.resolveWorkspaceFolder(s),u=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(u),w=g?{uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let D of r.variables)i.variables[D]=await d.resolveAsync(w,D);if(r.process!==void 0){let D;if(r.process.path!==void 0){D=r.process.path.split(f.delimiter);for(let m=0;m<D.length;m++)D[m]=await d.resolveAsync(w,D[m])}i.process=await I.win32.findExecutable(await d.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await d.resolveAsync(w,r.process.cwd):void 0,D)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,s){return I.win32.findExecutable(t,r,s)}};a=Ve([Be(0,T.IExtHostRpcService),Be(1,c.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,y.IExtHostConfiguration),Be(5,n.IExtHostTerminalService),Be(6,v.ILogService),Be(7,_.IExtHostApiDeprecationService),Be(8,A.IExtHostEditorTabs)],a),e.ExtHostTask=a}),define(me[275],ge([0,1,17,16,73,6,2,5,267,12,82,84,27,190,14,65,40,34]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(a,p,t,r){this._disposables=new k.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new y.RPCProtocol(a,null,r),p=E._transform(p,this._rpcProtocol);const s=new T.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),s.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),s.set(v.IURITransformerService,new v.URITransformerService(r)),s.set(_.IHostUtils,t);const i=new h.InstantiationService(s,!0),g=i.invokeFunction(D=>D.get(A.IExtHostTerminalService));this._disposables.add(g),this._logService=i.invokeFunction(D=>D.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(D=>D.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(m,S)=>{let b="",F,N;for(const G of S)b+=`
	at ${G.toString()}`,N=G.getFileName(),!F&&N&&(F=D.findSubstr(N));return u.set(m,F),`${m.name||"Error"}: ${m.message||""}${b}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(D=>{const m=L.transformErrorForSerialization(D),S=u.get(D);S?d.$onExtensionRuntimeError(S.identifier,m):w.$onUnexpectedError(m)})}terminate(a){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,f.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(a,p){a.extensions.forEach(r=>r.extensionLocation=R.URI.revive(p.transformIncomingURIs(r.extensionLocation))),a.environment.appRoot=R.URI.revive(p.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(r=>R.URI.revive(p.transformIncomingURIs(r)))),a.environment.extensionTestsLocationURI=R.URI.revive(p.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=R.URI.revive(p.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=R.URI.revive(p.transformIncomingURIs(a.logsLocation)),a.logFile=R.URI.revive(p.transformIncomingURIs(a.logFile)),a.workspace=p.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=E}),define(me[276],ge([0,1,8,21,61,30,22,46,31]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(c,h,o){this.config=c,this.provider=h,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&k.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&k.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const h=this.config.folderQueries||[];return new Promise((o,v)=>{const _=A=>{this.resultCount++,c(A)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const E=A.toString(),l=f.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,l)||this.matchFile(_,{base:A,basename:l})}),Promise.all(h.map(A=>this.searchInFolder(A,_))).then(A=>{o({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{v(new Error((0,I.toErrorMessage)(A)))})})}async searchInFolder(c,h){const o=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(c),_=this.initDirectoryTree(),A=new y.QueryGlobTester(this.config,c),E=!A.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(o),l=C.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,o.token),p=l.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(r=>{const s=f.posix.relative(c.folder.path,r.path);if(E){const i=f.basename(r.path);this.matchFile(h,{base:c.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(_,c.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,A,h),{providerTime:p,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(c){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),o=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:o,includes:h,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},h,o,v){if(o===this.filePattern){const A=f.basename(this.filePattern);this.matchFile(v,{base:h,relativePath:this.filePattern,basename:A})}function _(A){const E=f.basename(A),l=f.dirname(A);let a=c[l];a||(a=c[l]=[],_(l)),a.push({base:h,relativePath:A,basename:E})}_(o)}matchDirectoryTree({rootEntries:c,pathToEntries:h},o,v){const _=this,A=this.filePattern;function E(l){const a=k.hasSiblingFn(()=>l.map(p=>p.basename));for(let p=0,t=l.length;p<t;p++){const r=l[p],{relativePath:s,basename:i}=r;if(!o.includedInQuerySync(s,i,A!==i?a:void 0))continue;const g=h[s];if(g)E(g);else{if(s===A)continue;_.matchFile(v,r)}if(_.isLimitHit)break}}E(c)}matchFile(c,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(h))}}class n{constructor(){this.sessions=new Map}fileSearch(c,h,o,v){const _=this.getSessionTokenSource(c.cacheKey),A=new P(c,h,_&&_.token);let E=0;const l=a=>{E+=a.length,o(a.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(A,n.BATCH_SIZE,l,v).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:a.stats}}))}clearCache(c){const h=this.getSessionTokenSource(c);h&&h.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:R.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,h,o,v){v.onCancellationRequested(()=>{c.cancel()});const _=E=>{E&&(A.push(E),h>0&&A.length>=h&&(o(A),A=[]))};let A=[];return c.search(_).then(E=>(A.length&&o(A),E),E=>(A.length&&o(A),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,20,21,61,30,10,8,22,13,2,31]),function(J,e,f,L,I,k,R,C,y,P,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(l,a,p,t){this.query=l,this.provider=a,this.fileUtils=p,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,a){const p=this.query.folderQueries||[],t=new L.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new o(l);let i=!1;const g=(u,d)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(u);_(u)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const D=this.resultSize(u);this.resultCount+=D,(D>0||!_(u))&&this.collector.add(u,d)}};Promise.all(p.map((u,d)=>this.searchInFolder(u,w=>g(w,d),t.token))).then(u=>{t.dispose(),this.collector.flush();const d=u.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||d,messages:(0,f.flatten)(u.map(w=>w?.message?(0,P.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},u=>{t.dispose();const d=(0,I.toErrorMessage)(u);s(new Error(d))})})}resultSize(l){return _(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,a){const p=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:p.slice(0,a),preview:{matches:t.slice(0,a),text:l.preview.text},uri:l.uri}}async searchInFolder(l,a,p){const t=new T.QueryGlobTester(this.query,l),r=[],s={report:u=>{if(!this.validateProviderResult(u))return;const d=l.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(u.uri))):void 0,w=y.relativePath(l.folder,u.uri);if(w){const D=t.includedInQuery(w,C.basename(w),d);(0,P.isPromise)(D)?r.push(D.then(m=>{m&&a(u)})):D&&a(u)}}},i=this.getSearchOptionsForFolder(l),g=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,s,p);return r.length&&await Promise.all(r),g}validateProviderResult(l){if(_(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const a=(0,T.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),p=(0,T.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:n.URI.from(l.folder),excludes:p,includes:a,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class o{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,a=>this.sendItems(a))}add(l,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!y.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=o;function v(E){return _(E)?{preview:{matches:(0,f.mapArrayOrNot)(E.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:E.preview.text},ranges:(0,f.mapArrayOrNot)(E.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class A{constructor(l,a){this.maxBatchSize=l,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,a){!l||this.addItemToBatch(l,a)}addItems(l,a){!l||this.addItemsToBatch(l,a)}addItemToBatch(l,a){this.batch.push(l),this.batchSize+=a,this.onUpdate()}addItemsToBatch(l,a){this.batch=this.batch.concat(l),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,276,14,65,12,2,133]),function(J,e,f,L,I,k,R,C,y,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let T=class{constructor(v,_,A){this.extHostRpc=v,this._uriTransformer=_,this._logService=A,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const A=this._handlePool++;return this._textSearchProvider.set(A,_),this._proxy.$registerTextSearchProvider(A,this._transformScheme(v)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const A=this._handlePool++;return this._fileSearchProvider.set(A,_),this._proxy.$registerFileSearchProvider(A,this._transformScheme(v)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(v,_,A,E){const l=c(A),a=this._fileSearchProvider.get(v);if(a)return this._fileSearchManager.fileSearch(l,a,p=>{this._proxy.$handleFileMatch(v,_,p.map(t=>t.resource))},E);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,A,E){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const a=c(A);return this.createTextSearchManager(a,l).search(t=>this._proxy.$handleTextMatch(v,_,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(v,_){return new n.TextSearchManager(v,_,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};T=Ve([Be(0,R.IExtHostRpcService),Be(1,C.IURITransformerService),Be(2,y.ILogService)],T),e.ExtHostSearch=T;function c(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(h),extraFileResources:o.extraFileResources&&o.extraFileResources.map(v=>P.URI.revive(v))}}e.reviveQuery=c;function h(o){return{...o,folder:P.URI.revive(o.folder)}}}),define(me[277],ge([0,1,21,16,3,48,2,114,109,146,81,42,5,235,234,44,236,38,237,238,239,220,240,45,40,241,221,244,245,246,68,223,251,252,253,93,34,255,224,15,7,258,70,132,37,36,55,209,243,86,131,72,53,74,12,65,14,27,247,206,52,67,232,256,205,69,92,261,259,260,233,64,254,257,91,51,122,249,71,250,10,192,248,203,242]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a,p,t,r,s,i,g,u,d,w,D,m,S,b,F,N,G,K,M,U,O,$,B,x,j,H,Q,X,fe,_e,ye,Le,ze,xe,Ge,z,ee,re,ae,Y,oe,ve,Me,je,Ke,Se,nt,Z,te,pe,Ue,Ye,it,ft,pt,St,Ct,ue,Ie,Ne,Qe,We,at,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(Ye.IExtHostFileSystemInfo),we=ne.get(nt.IExtHostConsumerFileSystem),Fe=ne.get(s.IExtHostExtensionService),qe=ne.get(j.IExtHostWorkspace),$e=ne.get(Ct.IExtHostTelemetry),Je=ne.get(A.IExtHostConfiguration),tt=ne.get(z.IURITransformerService),le=ne.get(ee.IExtHostRpcService),Ee=ne.get(N.IExtHostStorage),ce=ne.get(Se.IExtensionStoragePaths),q=ne.get(Ge.ILogService),Ae=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(x.IExtHostWindow),Xe=ne.get(pt.IExtHostSecretState),ot=ne.get(St.IExtHostEditorTabs);le.set(c.ExtHostContext.ExtHostFileSystemInfo,be),le.set(c.ExtHostContext.ExtHostLogService,q),le.set(c.ExtHostContext.ExtHostWorkspace,qe),le.set(c.ExtHostContext.ExtHostConfiguration,Je),le.set(c.ExtHostContext.ExtHostExtensionService,Fe),le.set(c.ExtHostContext.ExtHostStorage,Ee),le.set(c.ExtHostContext.ExtHostTunnelService,Ae),le.set(c.ExtHostContext.ExtHostWindow,Ze),le.set(c.ExtHostContext.ExtHostSecretState,Xe),le.set(c.ExtHostContext.ExtHostTelemetry,$e),le.set(c.ExtHostContext.ExtHostEditorTabs,ot);const vt=le.set(c.ExtHostContext.ExtHostDecorations,ne.get(ye.IExtHostDecorations)),Et=le.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(r.IExtHostDocumentsAndEditors)),lt=le.set(c.ExtHostContext.ExtHostCommands,ne.get(v.IExtHostCommands)),dt=le.set(c.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),mt=le.set(c.ExtHostContext.ExtHostDebugService,ne.get(ze.IExtHostDebugService)),Lt=le.set(c.ExtHostContext.ExtHostSearch,ne.get(xe.IExtHostSearch)),yt=le.set(c.ExtHostContext.ExtHostTask,ne.get(Le.IExtHostTask)),Nt=le.set(c.ExtHostContext.ExtHostOutputService,ne.get(D.IExtHostOutputService)),un=le.set(c.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(le)),It=le.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(le,Et)),Bt=le.set(c.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(le,Et,q)),en=le.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(q,It,le.getProxy(c.MainContext.MainThreadBulkEdits))),wt=le.set(c.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(le,lt,Et,It,ce)),Qt=le.set(c.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(q,wt)),Ht=le.set(c.ExtHostContext.ExtHostNotebookEditors,new at.ExtHostNotebookEditors(q,le,wt)),tn=le.set(c.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(le,de,wt,q)),nn=le.set(c.ExtHostContext.ExtHostNotebookRenderers,new Ne.ExtHostNotebookRenderers(le,wt)),Pt=le.set(c.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(le,Et)),Xt=le.set(c.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(le.getProxy(c.MainContext.MainThreadTreeViews),lt,q)),wn=le.set(c.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(le.getProxy(c.MainContext.MainThreadEditorInsets),Pt,de)),$t=le.set(c.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(le,q)),gt=le.set(c.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(le,tt,It,lt,$t,q,Pe)),rn=le.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(le,gt)),Ft=le.set(c.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(le,q,Et)),zt=le.set(c.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(le,qe,lt)),Yt=le.set(c.ExtHostContext.ExtHostSCM,new b.ExtHostSCM(le,lt,q)),sn=le.set(c.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(le,lt,It)),dn=le.set(c.ExtHostContext.ExtHostProgress,new m.ExtHostProgress(le.getProxy(c.MainContext.MainThreadProgress))),bn=le.set(c.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(le)),hn=le.set(c.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(le)),on=le.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(le)),En=le.set(c.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(le,lt)),Vt=le.set(c.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(le,{remote:de.remote},qe,q,Pe)),jt=le.set(c.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(le,Vt,qe)),_n=le.set(c.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(le,It,ce,Vt,jt)),Sn=le.set(c.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(le,Vt)),qt=le.set(c.ExtHostContext.ExtHostTesting,new it.ExtHostTesting(le,lt)),yn=le.set(c.ExtHostContext.ExtHostUriOpeners,new ft.ExtHostUriOpeners(le));le.set(c.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(le,wt,Et,lt));const Jt=(0,Q.values)(c.ExtHostContext);le.assertRegistered(Jt);const Dn=new Ue.ExtHostBulkEdits(le,Et),Cn=new o.ExtHostClipboard(le),Gt=new w.ExtHostMessageService(le,q),fn=new l.ExtHostDialogs(le),Wt=new F.ExtHostStatusBar(le,lt.converter),Rt=new d.ExtHostLanguages(le,It);return h.ExtHostApiCommands.register(lt),function(Oe,Tt,Kt){const bt=function(){let ie=!Oe.isUnderDevelopment;function he(Te){ie||(q.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(ct){if(Array.isArray(ct))ct.forEach(Te);else if(typeof ct=="string")he(ct);else{const _t=ct;typeof _t.scheme=="undefined"&&he(ct),!Oe.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,H.throwProposedApiError)(Oe)}return ct}}(),kn={getSession(ie,he,Te){return Te?.forceNewSession&&(0,H.checkProposedApiEnabled)(Oe),on.getSession(Oe,ie,he,Te)},get onDidChangeSessions(){return on.onDidChangeSessions},registerAuthenticationProvider(ie,he,Te,ct){return on.registerAuthenticationProvider(ie,he,Te,ct)}},In={registerCommand(ie,he,Te){return lt.registerCommand(!0,ie,he,Te)},registerTextEditorCommand(ie,he,Te){return lt.registerCommand(!0,ie,(...ct)=>{const _t=Pt.getActiveTextEditor();if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return _t.edit(kt=>{he.apply(Te,[_t,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,he,Te)=>((0,H.checkProposedApiEnabled)(Oe),lt.registerCommand(!0,ie,async(...ct)=>{const _t=Et.activeEditor(!0);if(!_t){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(_t.id);he.apply(Te,[kt,...ct])})),executeCommand(ie,...he){return lt.executeCommand(ie,...he)},getCommands(ie=!1){return lt.getCommands(ie)}},mn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return $e.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return $e.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return un.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(he){if((0,We.matchesScheme)(ie,Qe.Schemas.http)||(0,We.matchesScheme)(ie,Qe.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=de.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pn={createTestController(ie,he){return qt.createTestController(ie,he)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Oe),qt.createTestObserver()},runTests(ie){return(0,H.checkProposedApiEnabled)(Oe),qt.runTests(ie)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Oe),qt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Oe),qt.results}},An={getExtension(ie){const he=Tt.getExtensionDescription(ie);if(he)return new s.Extension(Fe,Oe.identifier,he,gn)},get all(){return Tt.getAllExtensionDescriptions().map(ie=>new s.Extension(Fe,Oe.identifier,ie,gn))},get onDidChange(){return Tt.onDidChange}},an={createDiagnosticCollection(ie){return $t.createDiagnosticCollection(Oe.identifier,ie)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:ie=>$t.getDiagnostics(ie),getLanguages(){return Rt.getLanguages()},setTextDocumentLanguage(ie,he){return Rt.changeLanguage(ie.uri,he)},match(ie,he){return(0,n.score)(U.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Te){return gt.registerCodeActionProvider(Oe,bt(ie),he,Te)},registerCodeLensProvider(ie,he){return gt.registerCodeLensProvider(Oe,bt(ie),he)},registerDefinitionProvider(ie,he){return gt.registerDefinitionProvider(Oe,bt(ie),he)},registerDeclarationProvider(ie,he){return gt.registerDeclarationProvider(Oe,bt(ie),he)},registerImplementationProvider(ie,he){return gt.registerImplementationProvider(Oe,bt(ie),he)},registerTypeDefinitionProvider(ie,he){return gt.registerTypeDefinitionProvider(Oe,bt(ie),he)},registerHoverProvider(ie,he){return gt.registerHoverProvider(Oe,bt(ie),he,Oe.identifier)},registerEvaluatableExpressionProvider(ie,he){return gt.registerEvaluatableExpressionProvider(Oe,bt(ie),he,Oe.identifier)},registerInlineValuesProvider(ie,he){return gt.registerInlineValuesProvider(Oe,bt(ie),he,Oe.identifier)},registerDocumentHighlightProvider(ie,he){return gt.registerDocumentHighlightProvider(Oe,bt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return gt.registerLinkedEditingRangeProvider(Oe,bt(ie),he)},registerReferenceProvider(ie,he){return gt.registerReferenceProvider(Oe,bt(ie),he)},registerRenameProvider(ie,he){return gt.registerRenameProvider(Oe,bt(ie),he)},registerDocumentSymbolProvider(ie,he,Te){return gt.registerDocumentSymbolProvider(Oe,bt(ie),he,Te)},registerWorkspaceSymbolProvider(ie){return gt.registerWorkspaceSymbolProvider(Oe,ie)},registerDocumentFormattingEditProvider(ie,he){return gt.registerDocumentFormattingEditProvider(Oe,bt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return gt.registerDocumentRangeFormattingEditProvider(Oe,bt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Te,...ct){return gt.registerOnTypeFormattingEditProvider(Oe,bt(ie),he,[Te].concat(ct))},registerDocumentSemanticTokensProvider(ie,he,Te){return gt.registerDocumentSemanticTokensProvider(Oe,bt(ie),he,Te)},registerDocumentRangeSemanticTokensProvider(ie,he,Te){return gt.registerDocumentRangeSemanticTokensProvider(Oe,bt(ie),he,Te)},registerSignatureHelpProvider(ie,he,Te,...ct){return typeof Te=="object"?gt.registerSignatureHelpProvider(Oe,bt(ie),he,Te):gt.registerSignatureHelpProvider(Oe,bt(ie),he,typeof Te=="undefined"?[]:[Te,...ct])},registerCompletionItemProvider(ie,he,...Te){return gt.registerCompletionItemProvider(Oe,bt(ie),he,Te)},registerInlineCompletionItemProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),gt.registerInlineCompletionsProvider(Oe,bt(ie),he)},registerDocumentLinkProvider(ie,he){return gt.registerDocumentLinkProvider(Oe,bt(ie),he)},registerColorProvider(ie,he){return gt.registerColorProvider(Oe,bt(ie),he)},registerFoldingRangeProvider(ie,he){return gt.registerFoldingRangeProvider(Oe,bt(ie),he)},registerSelectionRangeProvider(ie,he){return gt.registerSelectionRangeProvider(Oe,ie,he)},registerCallHierarchyProvider(ie,he){return gt.registerCallHierarchyProvider(Oe,ie,he)},setLanguageConfiguration:(ie,he)=>gt.setLanguageConfiguration(Oe,ie,he),getTokenInformationAtPosition(ie,he){return(0,H.checkProposedApiEnabled)(Oe),Rt.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),gt.registerInlayHintsProvider(Oe,ie,he)},registerTypeHierarchyProvider(ie,he){return(0,H.checkProposedApiEnabled)(Oe),gt.registerTypeHierarchyProvider(Oe,ie,he)},createLanguageStatusItem(ie){return(0,H.checkProposedApiEnabled)(Oe),Rt.createLanguageStatusItem(ie)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ie,he,Te){const ct=await(R.URI.isUri(ie)?Promise.resolve(pn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,he,Te)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Oe,ie)},onDidChangeActiveTextEditor(ie,he,Te){return Pt.onDidChangeActiveTextEditor(ie,he,Te)},onDidChangeVisibleTextEditors(ie,he,Te){return Pt.onDidChangeVisibleTextEditors(ie,he,Te)},onDidChangeTextEditorSelection(ie,he,Te){return Pt.onDidChangeTextEditorSelection(ie,he,Te)},onDidChangeTextEditorOptions(ie,he,Te){return Pt.onDidChangeTextEditorOptions(ie,he,Te)},onDidChangeTextEditorVisibleRanges(ie,he,Te){return Pt.onDidChangeTextEditorVisibleRanges(ie,he,Te)},onDidChangeTextEditorViewColumn(ie,he,Te){return Pt.onDidChangeTextEditorViewColumn(ie,he,Te)},onDidCloseTerminal(ie,he,Te){return dt.onDidCloseTerminal(ie,he,Te)},onDidOpenTerminal(ie,he,Te){return dt.onDidOpenTerminal(ie,he,Te)},onDidChangeActiveTerminal(ie,he,Te){return dt.onDidChangeActiveTerminal(ie,he,Te)},onDidChangeTerminalDimensions(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),dt.onDidChangeTerminalDimensions(ie,he,Te)},onDidChangeTerminalState(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),dt.onDidChangeTerminalState(ie,he,Te)},onDidWriteTerminalData(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),dt.onDidWriteTerminalData(ie,he,Te)},get state(){return Ze.state},onDidChangeWindowState(ie,he,Te){return Ze.onDidChangeWindowState(ie,he,Te)},showInformationMessage(ie,...he){return Gt.showMessage(Oe,k.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return Gt.showMessage(Oe,k.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return Gt.showMessage(Oe,k.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Te){return zt.showQuickPick(ie,!!Oe.enableProposedApi,he,Te)},showWorkspaceFolderPick(ie){return zt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return zt.showInput(ie,he)},showOpenDialog(ie){return fn.showOpenDialog(ie)},showSaveDialog(ie){return fn.showSaveDialog(ie)},createStatusBarItem(ie,he,Te){let ct,_t,kt;return typeof ie=="string"?(ct=ie,_t=he,kt=Te):(_t=ie,kt=he),Wt.createStatusBarEntry(Oe,ct,_t,kt)},setStatusBarMessage(ie,he){return Wt.setStatusBarMessage(ie,he)},withScmProgress(ie){return Pe.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:O.ProgressLocation.SourceControl},(he,Te)=>ie({report(ct){}}))},withProgress(ie,he){return dn.withProgress(Oe,ie,he)},createOutputChannel(ie){return Nt.createOutputChannel(ie,Oe)},createWebviewPanel(ie,he,Te,ct){return jt.createWebviewPanel(Oe,ie,he,Te,ct)},createWebviewTextEditorInset(ie,he,Te,ct){return(0,H.checkProposedApiEnabled)(Oe),wn.createWebviewEditorInset(ie,he,Te,ct,Oe)},createTerminal(ie,he,Te){return typeof ie=="object"?("location"in ie&&(0,H.checkProposedApiEnabled)(Oe),"pty"in ie?dt.createExtensionTerminal(ie):dt.createTerminalFromOptions(ie)):dt.createTerminal(ie,he,Te)},registerTerminalLinkProvider(ie){return dt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return dt.registerProfileProvider(Oe,ie,he)},registerTreeDataProvider(ie,he){return Xt.registerTreeDataProvider(ie,he,Oe)},createTreeView(ie,he){return Xt.createTreeView(ie,he,Oe)},registerWebviewPanelSerializer:(ie,he)=>jt.registerWebviewPanelSerializer(Oe,ie,he),registerCustomEditorProvider:(ie,he,Te={})=>_n.registerCustomEditorProvider(Oe,ie,he,Te),registerFileDecorationProvider(ie){return vt.registerFileDecorationProvider(ie,Oe.identifier)},registerUriHandler(ie){return un.registerUriHandler(Oe.identifier,ie)},createQuickPick(){return zt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return zt.createInputBox(Oe.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Te){return hn.onDidChangeActiveColorTheme(ie,he,Te)},registerWebviewViewProvider(ie,he,Te){return Sn.registerWebviewViewProvider(Oe,ie,he,Te?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Oe),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeActiveNotebookEditor(ie,he,Te)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorSelection(ie,he,Te)},onDidChangeNotebookEditorVisibleRanges(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),Ht.onDidChangeNotebookEditorVisibleRanges(ie,he,Te)},showNotebookDocument(ie,he){return(0,H.checkProposedApiEnabled)(Oe),wt.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ie,he,Te)},get openEditors(){return(0,H.checkProposedApiEnabled)(Oe),ot.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Oe),ot.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,H.checkProposedApiEnabled)(Oe),u.InlineCompletionController.get(ie)}},pn={get rootPath(){return Pe.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return qe.getWorkspaceFolder(ie)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(ie){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,he,...Te)=>qe.updateWorkspaceFolders(Oe,ie,he||0,...Te),onDidChangeWorkspaceFolders:function(ie,he,Te){return qe.onDidChangeWorkspace(ie,he,Te)},asRelativePath:(ie,he)=>qe.getRelativePath(ie,he),findFiles:(ie,he,Te,ct)=>qe.findFiles(U.GlobPattern.from(ie),U.GlobPattern.from(he),Te,Oe.identifier,ct),findTextInFiles:(ie,he,Te,ct)=>{let _t,kt;return typeof he=="object"?(_t=he,kt=Te):(_t={},kt=he,ct=Te),qe.findTextInFiles(ie,_t||{},kt,Oe.identifier,ct)},saveAll:ie=>qe.saveAll(ie),applyEdit(ie){return Dn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Te,ct)=>Ft.createFileSystemWatcher(U.GlobPattern.from(ie),he,Te,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let he;const Te=ie;if(typeof ie=="string")he=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))he=Promise.resolve(ie);else if(!Te||typeof Te=="object")he=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ct=>It.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(ie,he,Te)=>It.onDidAddDocument(ie,he,Te),onDidCloseTextDocument:(ie,he,Te)=>It.onDidRemoveDocument(ie,he,Te),onDidChangeTextDocument:(ie,he,Te)=>It.onDidChangeDocument(ie,he,Te),onDidSaveTextDocument:(ie,he,Te)=>It.onDidSaveDocument(ie,he,Te),onWillSaveTextDocument:(ie,he,Te)=>en.getOnWillSaveTextDocumentEvent(Oe)(ie,he,Te),get notebookDocuments(){return wt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Te;if(R.URI.isUri(ie))Te=ie,await wt.openNotebookDocument(ie);else if(typeof ie=="string")Te=R.URI.revive(await wt.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Te,ct){return wt.registerNotebookSerializer(Oe,ie,he,Te,Oe.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,he,Te,ct)=>((0,H.checkProposedApiEnabled)(Oe),wt.registerNotebookContentProvider(Oe,ie,he,Te,Oe.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,he,Te)=>Kt.onDidChangeConfiguration(ie,he,Te),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Kt.getConfiguration(ie,he,Oe)},registerTextDocumentContentProvider(ie,he){return Bt.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Pe.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Oe,ie,he)),registerFileSystemProvider(ie,he,Te){return rn.registerFileSystemProvider(Oe.identifier,ie,he,Te,Oe.enableProposedApi)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Lt.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Lt.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,H.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Te)=>Ft.onDidCreateFile(ie,he,Te),onDidDeleteFiles:(ie,he,Te)=>Ft.onDidDeleteFile(ie,he,Te),onDidRenameFiles:(ie,he,Te)=>Ft.onDidRenameFile(ie,he,Te),onWillCreateFiles:(ie,he,Te)=>Ft.getOnWillCreateFileEvent(Oe)(ie,he,Te),onWillDeleteFiles:(ie,he,Te)=>Ft.getOnWillDeleteFileEvent(Oe)(ie,he,Te),onWillRenameFiles:(ie,he,Te)=>Ft.getOnWillRenameFileEvent(Oe)(ie,he,Te),openTunnel:ie=>((0,H.checkProposedApiEnabled)(Oe),Ae.openTunnel(Oe,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,H.checkProposedApiEnabled)(Oe),Ae.getTunnels()},onDidChangeTunnels:(ie,he,Te)=>((0,H.checkProposedApiEnabled)(Oe),Ae.onDidChangeTunnels(ie,he,Te)),registerPortAttributesProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),Ae.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,H.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ie,he,Oe.identifier,lt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:ie=>((0,H.checkProposedApiEnabled)(Oe),qe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Te)=>qe.onDidGrantWorkspaceTrust(ie,he,Te)},Rn={get inputBox(){return Pe.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Oe)},createSourceControl(ie,he,Te){return Yt.createSourceControl(Oe,ie,he,Te)}},Ln={createCommentController(ie,he){return sn.createCommentController(Oe,ie,he)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,he,Te){return mt.onDidStartDebugSession(ie,he,Te)},onDidTerminateDebugSession(ie,he,Te){return mt.onDidTerminateDebugSession(ie,he,Te)},onDidChangeActiveDebugSession(ie,he,Te){return mt.onDidChangeActiveDebugSession(ie,he,Te)},onDidReceiveDebugSessionCustomEvent(ie,he,Te){return mt.onDidReceiveDebugSessionCustomEvent(ie,he,Te)},onDidChangeBreakpoints(ie,he,Te){return mt.onDidChangeBreakpoints(ie,he,Te)},registerDebugConfigurationProvider(ie,he,Te){return mt.registerDebugConfigurationProvider(ie,he,Te||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return mt.registerDebugAdapterDescriptorFactory(Oe,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return mt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(ie,he,{parentSession:Te}):mt.startDebugging(ie,he,Te||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return mt.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>yt.registerTaskProvider(Oe,ie,he),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Oe,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,he,Te)=>yt.onDidStartTask(ie,he,Te),onDidEndTask:(ie,he,Te)=>yt.onDidEndTask(ie,he,Te),onDidStartTaskProcess:(ie,he,Te)=>yt.onDidStartTaskProcess(ie,he,Te),onDidEndTaskProcess:(ie,he,Te)=>yt.onDidEndTaskProcess(ie,he,Te)},On={createNotebookController(ie,he,Te,ct,_t){return tn.createNotebookController(Oe,ie,he,Te,ct,Oe.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>wt.registerNotebookCellStatusBarItemProvider(Oe,ie,he),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,H.checkProposedApiEnabled)(Oe),Ht.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return nn.createRendererMessaging(Oe,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),Qt.onDidChangeNotebookDocumentMetadata(ie,he,Te)},onDidChangeNotebookCells(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeNotebookCells(ie,he,Te)},onDidChangeNotebookCellExecutionState(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeNotebookCellExecutionState(ie,he,Te)},onDidChangeCellOutputs(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeCellOutputs(ie,he,Te)},onDidChangeCellMetadata(ie,he,Te){return(0,H.checkProposedApiEnabled)(Oe),wt.onDidChangeCellMetadata(ie,he,Te)},createConcatTextDocument(ie,he){return(0,H.checkProposedApiEnabled)(Oe),new Ke.ExtHostNotebookConcatDocument(wt,It,ie,he)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:mn,extensions:An,languages:an,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:pn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:P.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:c.UIKind,Uri:R.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[278],ge([0,1,82,68,37,131,38,44,45,34,72,53,74,93,52,67,132,92,64,91,122,51]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,f.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,f.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,f.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,f.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService),(0,f.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations),(0,f.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,f.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,f.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,f.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,f.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,f.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,f.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,f.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,f.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,f.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,71]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=R;function C(T,c,h,o){const v=(0,f.mapArrayOrNot)(h,y),_=new I.TextSearchMatch(c,v,o),A=_.preview.matches;return{ranges:(0,f.mapArrayOrNot)(v,P),uri:T,preview:{text:_.preview.text,matches:(0,f.mapArrayOrNot)(A,P)}}}e.createTextSearchResult=C;function y(T){return new I.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function P(T){return new k.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let n=class{constructor(c,h){this.prefix=c,this.logService=h}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};n=Ve([Be(1,L.ILogService)],n),e.OutputChannel=n}),define(me[279],ge([0,1,96,23]),function(J,e,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const k=512,R=512,C=512*8,y=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((g,u)=>{J(["iconv-lite-umd"],g,u)})).getDecoder(h(r));else{const i=new TextDecoder;s={write(g){return i.decode(g,{stream:!0})},end(){return i.decode()}}}return new P(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function n(t,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?C:R;return new Promise((i,g)=>{const u=(0,f.newWriteableStream)(S=>S.join("")),d=[];let w=0,D;const m=async()=>{try{const S=await p({buffer:L.VSBuffer.concat(d),bytesRead:w},r.guessEncoding);S.encoding=await r.overwriteEncoding(S.encoding),D=await P.create(S.encoding);const b=D.write(L.VSBuffer.concat(d).buffer);u.write(b),d.length=0,w=0,i({stream:u,detected:S})}catch(S){g(S)}};(0,f.listenStream)(t,{onData:async S=>{D?u.write(D.write(S.buffer)):(d.push(S),w+=S.byteLength,w>=s&&(t.pause(),await m(),setTimeout(()=>t.resume())))},onError:S=>u.error(S),onEnd:async()=>{D||await m(),u.end(D?.end())}})})}e.toDecodeStream=n;async function T(t,r,s){const g=(await new Promise((w,D)=>{J(["iconv-lite-umd"],w,D)})).getEncoder(h(r),s);let u=!1,d=!1;return{read(){if(d)return null;const w=t.read();if(typeof w!="string"){if(d=!0,!u&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=g.end();return D&&D.length>0?(u=!0,L.VSBuffer.wrap(D)):null}return u=!0,L.VSBuffer.wrap(g.write(w))}}}e.toEncodeReadable=T;async function c(t){return(await new Promise((s,i)=>{J(["iconv-lite-umd"],s,i)})).encodingExists(h(t))}e.encodingExists=c;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function o(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const g=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&g===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const v=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((d,w)=>{J(["jschardet"],d,w)}),s=t.slice(0,y),i=l(s.buffer),g=r.detect(i);if(!g||!g.encoding)return null;const u=g.encoding.toLowerCase();return 0<=v.indexOf(u)?null:E(g.encoding)}const A={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return A[r]||r}function l(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=a;function p({buffer:t,bytesRead:r},s){let i=o(t,r),g=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let u=!0,d=!0,w=!1;for(let D=0;D<r&&D<k;D++){const m=D%2==1,S=t.readUInt8(D)===0;if(S&&(w=!0),u&&(m&&!S||!m&&S)&&(u=!1),d&&(m&&S||!m&&!S)&&(d=!1),S&&!u&&!d)break}w&&(u?i=e.UTF16le:d?i=e.UTF16be:g=!0)}return s&&!g&&!i&&t?_(t.slice(0,r)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:g,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,279,28,133]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class k extends I.TextSearchManager{constructor(C,y,P=L,n="searchProcess"){super(C,y,{readdir:T=>P.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,f.toCanonicalName)(T)},n)}}e.NativeTextSearchManager=k}),define(me[280],ge([0,1,281,295,296,2,297]),function(J,e,f,L,I,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(T,c,h,o,v,_){const A=_.environment.useHostProxy,E=typeof A=="boolean"?A:!_.remote.isRemote,l=(0,R.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(p,t,...r)=>{switch(p){case R.LogLevel.Trace:o.trace(t,...r);break;case R.LogLevel.Debug:o.debug(t,...r);break;case R.LogLevel.Info:o.info(t,...r);break;case R.LogLevel.Warning:o.warn(t,...r);break;case R.LogLevel.Error:o.error(t,...r);break;case R.LogLevel.Critical:o.critical(t,...r);break;case R.LogLevel.Off:break;default:s(p,t,r);break}function s(i,g,...u){o.error("Unknown log level",i),o.error(g,...u)}},getLogLevel:()=>o.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:E,env:process.env}),a=y(c,l);return n(h,a)}e.connectProxyResolver=C;function y(T,c){const h={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(v=>{h.config=T.getConfiguration("http").get("proxySupport")||"off"});const o={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(v=>{o.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,R.createHttpPatch)(f,c,{config:"off"},o,!0)),on:Object.assign({},f,(0,R.createHttpPatch)(f,c,{config:"on"},o,!0)),override:Object.assign({},f,(0,R.createHttpPatch)(f,c,{config:"override"},o,!0)),onRequest:Object.assign({},f,(0,R.createHttpPatch)(f,c,h,o,!0)),default:Object.assign(f,(0,R.createHttpPatch)(f,c,h,o,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"off"},o,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"on"},o,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"override"},o,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,c,h,o,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,c,h,o,!1))},tls:Object.assign(I,(0,R.createTlsPatch)(I))}}const P=new Map;function n(T,c){return T.getExtensionPathIndex().then(h=>{const o=J.__$__nodeRequire("module"),v=o._load;o._load=function(A,E,l){if(A==="tls")return c.tls;if(A!=="http"&&A!=="https")return v.apply(this,arguments);const a=c[A],p=h.findSubstr(k.URI.file(E.filename).fsPath);let t=P.get(p);if(t||P.set(p,t={}),!t[A]){let r=a.default;p&&p.enableProposedApi&&(r=a[p.proxySupport]||a.onRequest),t[A]={...r}}return t[A]}})}}),define(me[282],ge([0,1,39,8,79,29,11,9,94,283]),function(J,e,f,L,I,k,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(l,a,p,t){const r=c(l,a,p,t),s=a.folder.fsPath;return{cmd:f.spawn(n,r.args,{cwd:s}),rgDiskPath:n,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=T;function c(l,a,p,t){const r=["--files","--hidden","--case-sensitive"];o([a],p,!1).forEach(i=>{const g=(0,y.anchorGlob)(i);if(r.push("-g",g),R.isMacintosh){const u=(0,I.normalizeNFD)(g);u!==g&&r.push("-g",u)}});const s=h([a],t,void 0,!1);return s.globArgs.forEach(i=>{const g=`!${(0,y.anchorGlob)(i)}`;if(r.push("-g",g),R.isMacintosh){const u=(0,I.normalizeNFD)(g);u!==g&&r.push("-g",u)}}),a.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),a.ignoreSymlinks||r.push("--follow"),l.exists&&r.push("--quiet"),r.push("--no-config"),a.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function h(l,a,p,t=!0){const r=[];let s={};return l.forEach(i=>{const g=Object.assign({},i.excludePattern||{},a||{}),u=v(g,t?i.folder.fsPath:void 0,p);r.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=h;function o(l,a,p=!0){const t=[];return l.forEach(r=>{const s=Object.assign({},a||{},r.includePattern||{}),i=v(s,p?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=o;function v(l,a,p){const t=[],r={};return Object.keys(l).forEach(s=>{if(p&&p.has(s)||!s)return;const i=l[s];s=A(a?_(a,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(E(s))):i&&i.when&&(r[s]=i)}),{globArgs:t,siblingClauses:r}}function _(l,a){return L.isAbsolute(a)?a:L.join(l,a)}e.getAbsoluteGlob=_;function A(l){return l=C.rtrim(l,"\\"),C.rtrim(l,"/")}function E(l){return k.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=E}),define(me[284],ge([0,1,39,49,8,104,20,61,30,79,29,11,46,9,13,28,31,282,101]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(s=>s())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(g=>{const u=Object.assign({},g.excludePattern||{},this.config.excludePattern||{}),d=g.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==d).forEach(w=>{(0,n.isEqualOrParent)(w,d)&&(u[I.relative(d,w)]=!0)}),this.folderExcludePatterns.set(d,new t(u,d))})}cancel(){this.isCanceled=!0}walk(i,g,u,d,w){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);g.forEach(D=>{const m=I.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,m)||this.matchFile(u,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(D,m)=>{this.call(this.cmdTraversal,this,D,u,d,S=>{if(S){const b=(0,C.toErrorMessage)(S);console.error(b),this.errors.push(b),m(S,void 0)}else m(null,void 0)})},(D,m)=>{this.fileWalkSW.stop();const S=D?R.coalesce(D)[0]:null;w(S,this.isLimitHit)})}parallel(i,g,u){const d=new Array(i.length),w=new Array(i.length);let D=!1,m=0;if(i.length===0)return u(null,[]);i.forEach((S,b)=>{g(S,(F,N)=>{if(F?(D=!0,d[b]=null,w[b]=F):(d[b]=N,w[b]=null),++m===i.length)return u(D?w:null,d)})})}call(i,g,...u){try{i.apply(g,u)}catch(d){u[u.length-1](d)}}cmdTraversal(i,g,u,d){const w=i.folder.fsPath,D=T.isMacintosh;let m;const S=()=>m&&m.kill();l.add(S);let b=O=>{l.delete(S),b=()=>{},d(O)},F="";const N=this.initDirectoryTree();let G;const K=(0,A.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);m=K.cmd,G=!Object.keys(K.siblingClauses).length;const M=K.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let U=`${K.rgDiskPath} ${M}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),u({message:U}),this.cmdResultCount=0,this.collectStdout(m,"utf8",u,(O,$,B)=>{if(O){b(O);return}if(this.isLimitHit){b();return}const j=(F+(D?P.normalizeNFC($||""):$)).split(`
`);if(B){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else F=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,G){for(const H of j)if(this.matchFile(g,{base:w,relativePath:H,searchPath:this.getSearchPath(i,H)}),this.isLimitHit){S();break}(B||this.isLimitHit)&&b();return}this.addDirectoryEntries(i,N,w,j,g),B&&(this.matchDirectoryTree(N,w,g),b())})}spawnFindCmd(i){const g=this.folderExcludePatterns.get(i.folder.fsPath),u=g.getBasenameTerms(),d=g.getPathTerms(),w=["-L","."];if(u.length||d.length){w.push("-not","(","(");for(const D of u)w.push("-name",D),w.push("-o");for(const D of d)w.push("-path",D),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),f.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,g,u){let d="";this.collectStdout(i,g,()=>{},(w,D,m)=>{if(w){u(w);return}d+=D,m&&u(null,d)})}collectStdout(i,g,u,d){let w=(S,b,F)=>{(S||F)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),d(S,b,F)},D=!1;i.stdout?(this.forwardData(i.stdout,g,w),i.stdout.once("data",()=>D=!0)):u({message:"stdout is null"});let m;i.stderr?m=this.collectData(i.stderr):u({message:"stderr is null"}),i.on("error",S=>{w(S)}),i.on("close",S=>{let b;!D&&(b=this.decodeData(m,g))&&r(b)?w(new Error(`command failed with error code ${S}: ${this.decodeData(m,g)}`)):(this.exists&&S===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,g,u){const d=new k.StringDecoder(g);return i.on("data",w=>{u(null,d.write(w))}),d}collectData(i){const g=[];return i.on("data",u=>{g.push(u)}),g}decodeData(i,g){const u=new k.StringDecoder(g);return i.map(d=>u.write(d)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:g},u,d,w){d.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const D=m=>{const S=I.basename(m),b=I.dirname(m);let F=g[b];F||(F=g[b]=[],D(b)),F.push({base:u,relativePath:m,basename:S,searchPath:this.getSearchPath(i,m)})};d.forEach(D)}matchDirectoryTree({rootEntries:i,pathToEntries:g},u,d){const w=this,D=this.folderExcludePatterns.get(u),m=this.filePattern;function S(b){w.directoriesWalked++;const F=y.hasSiblingFn(()=>b.map(N=>N.basename));for(let N=0,G=b.length;N<G;N++){const K=b[N],{relativePath:M,basename:U}=K;if(D.test(M,U,m!==U?F:void 0))continue;const O=g[M];if(O)S(O);else{if(w.filesWalked++,M===m)continue;w.matchFile(d,K)}if(w.isLimitHit)break}}S(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,g,u,d,w){const D=i.folder,m=y.hasSiblingFn(()=>u);this.parallel(u,(S,b)=>{if(this.isCanceled||this.isLimitHit)return b(null);const F=g?[g,S].join(I.sep):S;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,S,this.config.filePattern!==S?m:void 0))return b(null);const N=[D.fsPath,F].join(I.sep);L.lstat(N,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return b(null);this.statLinkIfNeeded(N,K,(M,U)=>M||this.isCanceled||this.isLimitHit?b(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,K,(O,$)=>O||this.isCanceled||this.isLimitHit||($=$||"",this.walkedPaths[$])?b(null):(this.walkedPaths[$]=!0,v.Promises.readdir(N).then(B=>{if(this.isCanceled||this.isLimitHit)return b(null);this.doWalk(i,F,B,d,x=>b(x||null))},B=>{b(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&o.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(d,{base:D.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),b(null,void 0)))})},S=>{const b=S&&R.coalesce(S);return w(b&&b.length>0?b[0]:void 0)})}matchFile(i,g){this.isFileMatch(g)&&(!this.includePattern||this.includePattern(g.relativePath,I.basename(g.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(g))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,g,u){return g.isSymbolicLink()?L.stat(i,u):u(null,g)}realPathIfNeeded(i,g,u){return g.isSymbolicLink()?L.realpath(i,(d,w)=>d?u(d):u(null,w)):u(null,i)}getSearchPath(i,g){return i.folderName?I.join(i.folderName,g):g}}e.FileWalker=a;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,g,u){this.walker.walk(this.folderQueries,this.extraFiles,i,g,(d,w)=>{u(d,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,g){this.expression=i,this.root=g,this.init(i)}init(i){let g,u;Object.keys(i).filter(d=>i[d]).forEach(d=>{I.isAbsolute(d)?(g=g||y.getEmptyExpression(),g[d]=i[d]):(u=u||y.getEmptyExpression(),u[d]=i[d])}),this.absoluteParsedExpr=g&&y.parse(g,{trimForExclusions:!0}),this.relativeParsedExpr=u&&y.parse(u,{trimForExclusions:!0})}test(i,g,u){return this.relativeParsedExpr&&this.relativeParsedExpr(i,g,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),g,u)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function r(s){const i=s.trim().split(`
`),g=i[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return h.uppercaseFirstLetter(i[i.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}e.rgErrorMsgForDisplay=r}),define(me[135],ge([0,1,39,298,104,20,55,30,8,9,2,31,71,299,283,94]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=o.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(D){this.outputChannel=D}provideTextSearchResults(D,m,S,b){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify({...m,folder:m.folder.toString()})}`),new Promise((F,N)=>{b.onCancellationRequested(()=>x());const G=r(D,m),K=m.folder.fsPath,M=G.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${K}`);let U=f.spawn(_,G,{cwd:K});U.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),N((0,T.serializeSearchError)(new T.SearchError(fe&&fe.message,T.SearchErrorCode.rgProcessError)))});let O=!1;const $=new a(m.maxResults,K,m.previewOptions);$.on("result",fe=>{O=!0,H="",S.report(fe)});let B=!1;const x=()=>{B=!0,U&&U.kill(),$&&$.cancel()};let j=!1;$.on("hitLimit",()=>{j=!0,x()});let H="";U.stdout.on("data",fe=>{$.handleData(fe),O||(H+=fe)});let Q=!1;U.stdout.once("data",()=>Q=!0);let X="";U.stderr.on("data",fe=>{const _e=fe.toString();this.outputChannel.appendLine(_e),X+=_e}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),B)F({limitHit:j});else{$.flush(),U=null;let fe;X&&!Q&&(fe=E(X))?N((0,T.serializeSearchError)(new T.SearchError(fe.message,fe.code))):F({limitHit:j})}})})}}e.RipgrepTextSearchEngine=A;function E(w){const D=w.split(`
`),m=D[0].trim();if(D.some(b=>b.startsWith("regex parse error")))return new T.SearchError(l(D),T.SearchErrorCode.regexParseError);const S=m.match(/grep config error: unknown encoding: (.*)/);if(S)return new T.SearchError(`Unknown encoding: ${S[1]}`,T.SearchErrorCode.unknownEncoding);if(m.startsWith("error parsing glob"))return new T.SearchError(m.charAt(0).toUpperCase()+m.substr(1),T.SearchErrorCode.globParseError);if(m.startsWith("the literal"))return new T.SearchError(m.charAt(0).toUpperCase()+m.substr(1),T.SearchErrorCode.invalidLiteral);if(m.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(m,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function l(w){const D=["Regex parse error"],m=w.filter(S=>S.startsWith("PCRE2:"));if(m.length>=1){const S=m[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const b=S.split(":")[1];D.push(":"+b)}}return D.join("")}e.buildRegexParseError=l;class a extends L.EventEmitter{constructor(D,m,S){super();this.maxResults=D,this.rootFolder=m,this.previewOptions=S,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,m){return super.on(D,m),this}handleData(D){if(this.isDone)return;const m=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(m)}handleDecodedData(D){let m=D.indexOf(`
`);const S=this.remainder+D;if(m>=0)m+=this.remainder.length;else{this.remainder=S;return}let b=0;for(;m>=0;)this.handleLine(S.substring(b,m).trim()),b=m+1,m=S.indexOf(`
`,b);this.remainder=S.substring(b)}handleLine(D){if(this.isDone||!D)return;let m;try{m=JSON.parse(D)}catch(S){throw new Error(`malformed line from rg: ${D}`)}if(m.type==="match"){const S=p(m.data.path),b=n.URI.file(y.join(this.rootFolder,S)),F=this.createTextSearchMatch(m.data,b);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(m.type==="context"){const S=p(m.data.path),b=n.URI.file(y.join(this.rootFolder,S));this.createTextSearchContext(m.data,b).forEach(N=>this.onResult(N))}}createTextSearchMatch(D,m){const S=D.line_number-1,b=p(D.lines),F=Buffer.from(b);let N=0,G=0,K=S;D.submatches.length===0&&D.submatches.push(b.length?{start:0,end:1,match:{text:b[0]}}:{start:0,end:0,match:{text:""}});const M=(0,k.coalesce)(D.submatches.map((U,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const $=p(U.match),B=F.slice(N,U.start).toString().length,x=G+B,j=t($),H=K,Q=j.numLines+H,X=j.numLines>0?j.lastLineLength:j.lastLineLength+x;return N=U.end,G=X,K=Q,new c.Range(H,x,Q,X)}));return(0,v.createTextSearchResult)(m,b,M,this.previewOptions)}createTextSearchContext(D,m){const S=p(D.lines),b=D.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((F,N)=>({text:F,uri:m,lineNumber:b+N}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=a;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const D=/\n/g;let m=0,S=-1,b;for(;b=D.exec(w);)m++,S=b.index;const F=S>=0?w.length-S-1:w.length;return{numLines:m,lastLineLength:F}}function r(w,D){const m=["--hidden"];m.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:b}=(0,R.groupBy)(D.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(b&&b.length){const N=new Set;b.forEach(G=>{N.add(G)}),m.push("-g","!*"),N.forEach(G=>{s(G).map(v.anchorGlob).forEach(K=>{m.push("-g",K)})})}S&&S.length&&S.forEach(N=>{m.push("-g",N)}),D.excludes.map(v.anchorGlob).forEach(N=>m.push("-g",`!${N}`)),D.maxFileSize&&m.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?m.push("--no-ignore-parent"):m.push("--no-ignore"),D.followSymlinks&&m.push("--follow"),D.encoding&&D.encoding!=="utf8"&&m.push("--encoding",D.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,P.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),D.usePCRE2&&m.push("--pcre2"),m.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),m.push("--auto-hybrid-regex"));let F;if(w.isWordMatch){const G=(0,P.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");m.push("--regexp",G)}else if(w.isRegExp){let N=u(w.pattern);N=d(N),m.push("--regexp",N)}else F=w.pattern,m.push("--fixed-strings");return m.push("--no-config"),D.useGlobalIgnoreFiles||m.push("--no-ignore-global"),m.push("--json"),w.isMultiline&&m.push("--multiline"),D.beforeContext&&m.push("--before-context",D.beforeContext+""),D.afterContext&&m.push("--after-context",D.afterContext+""),m.push("--"),F&&m.push(F),m.push("."),m}function s(w){const D=(0,C.splitGlobAware)(w,"/");return D.map((m,S)=>D.slice(0,S+1).join("/"))}e.spreadGlobComponents=s;function i(w){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(D);)w=w.replace(D,"$1\\x{$2}");const m=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(m);)w=w.replace(m,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const g=w=>w.type==="Assertion"&&w.kind==="lookbehind";function u(w){let D;try{D=new h.RegExpParser().parsePattern(w)}catch{return w}let m="",S=0;const b=(G,K,M)=>{m+=w.slice(S,G)+M,S=K},F=[];return new h.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)b(G.start,G.end,"\\r?\\n");else if(!F.some(g))if(K.type==="CharacterClass")if(K.negate){const M=w.slice(K.start+2,G.start)+w.slice(G.end,K.end-1);b(K.start,K.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=w.slice(K.start+1,G.start)+w.slice(G.end,K.end-1);b(K.start,K.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else K.type==="Quantifier"&&b(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){g(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(D),m+=w.slice(S),m}e.fixRegexNewline=u;function d(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[285],ge([0,1,21,135,118,10]),function(J,e,f,L,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,n,T,c){const h=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===k.Schemas.userData){const o={...n,folder:n.folder.with({scheme:k.Schemas.file})},v=new I.Progress(_=>T.report({..._,uri:_.uri.with({scheme:n.folder.scheme})}));return this.withToken(c,_=>h.provideTextSearchResults(P,o,v,_))}else return this.withToken(c,o=>h.provideTextSearchResults(P,n,T,o))}async withToken(P,n){const T=C(P);this.inProgress.add(T);const c=await n(T.token);return this.inProgress.delete(T),c}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=R;function C(y){const P=new f.CancellationTokenSource;return y.onCancellationRequested(()=>P.cancel()),P}}),define(me[286],ge([0,1,28,135,134]),function(J,e,f,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class k{constructor(y){this.query=y}search(y,P,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(h){n({message:h})}},c=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(T),f);return new Promise((h,o)=>c.search(v=>{P(v.map(R))},y).then(v=>h({limitHit:v.limitHit,type:"success",stats:v.stats}),o))}}e.TextSearchEngineAdapter=k;function R(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((y,P)=>{if(P.ranges){const n=P;return y+(Array.isArray(n.ranges)?n.ranges.length:1)}else return y+1},0)}}}),define(me[287],ge([0,1,49,300,20,17,16,3,101,8,46,2,42,31,284,286]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(f);class _{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let r;const s=l(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,k.createCancelablePromise)(g=>this.doFileSearchWithEngine(o.Engine,s,u=>i.fire(u),g)),r.then(g=>i.fire(g),g=>i.fire({type:"error",error:{message:g.message,stack:g.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const s=l(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,k.createCancelablePromise)(g=>this.ripgrepTextSearch(s,u=>i.fire(u),g)),r.then(g=>i.fire(g),g=>i.fire({type:"error",error:{message:g.message,stack:g.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(o.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,i,g=_.BATCH_SIZE){let u=0;const d=D=>{Array.isArray(D)?(u+=D.length,s(D.map(m=>this.rawMatchToSearchItem(m)))):D.relativePath?(u++,s(this.rawMatchToSearchItem(D))):s(D)};if(r.sortByScore){let D=this.trySortedSearchFromCache(r,d,i);if(!D){const m=r.maxResults?Object.assign({},r,{maxResults:null}):r,S=new t(m);D=this.doSortedSearch(S,r,s,d,i)}return new Promise((m,S)=>{D.then(([b,F])=>{const N=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(N,s,g),m(b)},S)})}const w=new t(r);return this.doSearch(w,d,g,i).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.processType,fromCache:!1,resultCount:u,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,i,g){const u=new C.Emitter;let d=(0,k.createCancelablePromise)(D=>{let m=[];const S=b=>{Array.isArray(b)?m=b:(i(b),u.fire(b))};return this.doSearch(t,S,-1,D).then(b=>[b,m])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const D={promise:d,event:u.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=D,d.then(()=>{D.resolved=!0},m=>{delete w.resultsToSearchCache[r.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([D,m])=>{const S=w?w.scorerCache:Object.create(null),b=(typeof r.maxResults!="number"||r.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(r,m,S,g).then(F=>{const N=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:r.folderQueries.length,resultCount:F.length},messages:D.messages,limitHit:D.limitHit||typeof r.maxResults=="number"&&m.length>r.maxResults},F]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new A)}trySortedSearchFromCache(t,r,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const g=this.getResultsFromCache(i,t.filePattern||"",r,s);if(g)return g.then(([u,d,w])=>{const D=n.StopWatch.create(!1);return this.sortResults(t,d,i.scorerCache,s).then(m=>{const S=D.elapsed(),b={fromCache:!0,detailStats:w,type:this.processType,resultCount:d.length,sortingTime:S};return[{type:"success",limitHit:u.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:b},m]})})}sortResults(t,r,s,i){const g=(0,y.prepareQuery)(t.filePattern||""),u=(w,D)=>(0,y.compareItemsByFuzzyScore)(w,D,g,!0,E,s),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(r,u,d,1e4,i)}sendProgress(t,r,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)r(t.slice(i,i+s));else r(t)}getResultsFromCache(t,r,s,i){const g=n.StopWatch.create(!1),u=r.indexOf(P.sep)>=0;let d;for(const S in t.resultsToSearchCache)if(r.startsWith(S)){if(u&&S.indexOf(P.sep)<0&&S!=="")continue;const b=t.resultsToSearchCache[S];d={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!d)return null;const w=g.elapsed(),D=n.StopWatch.create(!1),m=d.event(s);return i&&i.onCancellationRequested(()=>{m.dispose()}),d.promise.then(([S,b])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],N=(0,y.prepareQuery)(r).normalizedLowercase;for(const G of b)!(0,h.isFilePatternMatch)(G,N)||F.push(G);return[S,F,{cacheWasResolved:d.resolved,cacheLookupTime:w,cacheFilterTime:D.elapsed(),cacheEntryCount:b.length}]})}doSearch(t,r,s,i){return new Promise((g,u)=>{let d=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(s?(d.push(w),s>0&&d.length>=s&&(r(d),d=[])):r(w))},w=>{r(w)},(w,D)=>{d.length&&r(d),w?u(w):g(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class A{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(p){return(0,P.basename)(p.relativePath)}getItemDescription(p){return(0,P.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(a),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>T.URI.revive(t))}}function a(p){return{...p,folder:T.URI.revive(p.folder)}}}),define(me[288],ge([0,1,6,10,2,28,12,27,14,74,65,31,287,285,94,134]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends P.ExtHostSearch{constructor(E,l,a,p){super(E,a,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new o.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new h.RipgrepSearchProvider(t)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new o.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new h.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,l){const a=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(E)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(E,l,a,p){const t=(0,P.reviveQuery)(a);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,l,t,p):super.$provideFileSearchResults(E,l,a,p)}doInternalFileSearch(E,l,a,p){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,l,r.map(s=>I.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,p)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,l){return new v.NativeTextSearchManager(E,l,void 0,"textSearchProvider")}};_=Ve([Be(0,y.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,n.IURITransformerService),Be(3,R.ILogService)],_),e.NativeExtHostSearch=_}),define(me[136],ge([0,1,301,125,60,23,16,3,6,8,11,33,106,107,302]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const w=D=>d(k.VSBuffer.wrap(D));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(d){const w=D=>{d({type:0,hadError:D,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,R.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((d,w)=>{if(this.socket.bufferSize===0){d();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),d()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=v;var _;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var A;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(A||(A={}));class E extends y.Disposable{constructor(d,w,D,m){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=m,w?(this._zlibInflate=o.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",S=>{console.error(S),(0,R.onUnexpectedError)(S),this._onClose.fire({type:0,hadError:!0,error:S})}),this._zlibInflate.on("data",S=>{this._pendingInflateData.push(S)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=o.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",S=>{console.error(S),(0,R.onUnexpectedError)(S),this._onClose.fire({type:0,hadError:!0,error:S})}),this._zlibDeflate.on("data",S=>{this._pendingDeflateData.push(S)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(S=>this._acceptChunk(S))),this._register(this.socket.onClose(S=>this._onClose.fire(S)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(k.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,w){let D=2;d.byteLength<126?D+=0:d.byteLength<2**16?D+=2:D+=8;const m=k.VSBuffer.alloc(D);if(w?m.writeUInt8(194,0):m.writeUInt8(130,0),d.byteLength<126)m.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){m.writeUInt8(126,1);let S=1;m.writeUInt8(d.byteLength>>>8&255,++S),m.writeUInt8(d.byteLength>>>0&255,++S)}else{m.writeUInt8(127,1);let S=1;m.writeUInt8(0,++S),m.writeUInt8(0,++S),m.writeUInt8(0,++S),m.writeUInt8(0,++S),m.writeUInt8(d.byteLength>>>24&255,++S),m.writeUInt8(d.byteLength>>>16&255,++S),m.writeUInt8(d.byteLength>>>8&255,++S),m.writeUInt8(d.byteLength>>>0&255,++S)}this._totalOutgoingWireBytes+=m.byteLength+d.byteLength,this.socket.write(k.VSBuffer.concat([m,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),m=(w.readUInt8(0)&128)>>>7,S=w.readUInt8(1),b=(S&128)>>>7,F=S&127;this._state.state=2,this._state.readLen=2+(b?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=m,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),D=w.readUInt8(1),m=(D&128)>>>7;let S=D&127,b=1;S===126?S=w.readUInt8(++b)*2**8+w.readUInt8(++b):S===127&&(S=w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*0+w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b));let F=0;m&&(F=w.readUInt8(++b)*2**24+w.readUInt8(++b)*2**16+w.readUInt8(++b)*2**8+w.readUInt8(++b)),this._state.state=3,this._state.readLen=S,this._state.mask=F}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);l(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(k.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function l(u,d){if(d===0)return;let w=u.byteLength>>>2;for(let N=0;N<w;N++){const G=u.readUInt32BE(N*4);u.writeUInt32BE(G^d,N*4)}let D=w*4,m=u.byteLength-D;const S=d>>>24&255,b=d>>>16&255,F=d>>>8&255;m>=1&&u.writeUInt8(u.readUInt8(D)^S,D),m>=2&&u.writeUInt8(u.readUInt8(D+1)^b,D+1),m>=3&&u.writeUInt8(u.readUInt8(D+2)^F,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function p(){const u=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):d=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${u}.sock`),r(d),d}e.createRandomIPCHandle=p;function t(u,d,w){const D=(0,f.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${w}-${d}-sock`;let m;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?m=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${w}-${d}.sock`):m=(0,P.join)(u,`${w}-${d}.sock`),r(m),m}e.createStaticIPCHandle=t;function r(u){const d=a[n.platform];typeof d=="number"&&u.length>=d&&console.warn(`WARNING: IPC handle "${u}" is longer than ${d} chars, try a shorter --user-data-dir`)}class s extends c.IPCServer{constructor(d){super(s.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const w=C.Event.fromNodeEventEmitter(d,"connection");return C.Event.map(w,D=>({protocol:new h.Protocol(new v(D)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(u){return new Promise((d,w)=>{const D=(0,L.createServer)();D.on("error",w),D.listen(u,()=>{D.removeListener("error",w),d(new s(D))})})}e.serve=i;function g(u,d){return new Promise((w,D)=>{const m=(0,L.createConnection)(u,()=>{m.removeListener("error",D),w(h.Client.fromSocket(new v(m),d))});m.once("error",D)})}e.connect=g}),define(me[289],ge([0,1,136,281,49,44,2,201,12]),function(J,e,f,L,I,k,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(c,h,o){this._commands=c,this.logService=h,this._ipcHandlePath=o,this._server=L.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(h.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,h){const o=[];c.setEncoding("utf8"),c.on("data",v=>o.push(v)),c.on("end",()=>{const v=JSON.parse(o.join(""));switch(v.type){case"open":this.open(v,h);break;case"openExternal":this.openExternal(v,h);break;case"status":this.getStatus(v,h);break;case"extensionManagement":this.manageExtensions(v,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),h.end();break}})}open(c,h){let{fileURIs:o,folderURIs:v,forceNewWindow:_,diffMode:A,addMode:E,forceReuseWindow:l,gotoLineMode:a,waitMarkerFilePath:p}=c;const t=[];if(Array.isArray(v))for(const r of v)try{t.push({folderUri:R.URI.parse(r)})}catch(s){}if(Array.isArray(o))for(const r of o)try{(0,C.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:R.URI.parse(r)}):t.push({fileUri:R.URI.parse(r)})}catch(s){}if(t.length){const r=p?R.URI.file(p):void 0,i={forceNewWindow:_,diffMode:A,addMode:E,gotoLineMode:a,forceReuseWindow:l,preferNewWindow:!l&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}h.writeHead(200),h.end()}async openExternal(c,h){for(const o of c.uris){const v=R.URI.parse(o),_=v.scheme==="file"?v:o;await this._commands.executeCommand("_remoteCLI.openExternal",_)}h.writeHead(200),h.end()}async manageExtensions(c,h){try{const o=A=>A?.map(E=>/\.vsix$/i.test(E)?R.URI.parse(E):E),v={list:c.list,install:o(c.install),uninstall:o(c.uninstall),force:c.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);h.writeHead(200),h.write(_)}catch(o){h.writeHead(500),h.write(String(o),v=>{v&&this.logService.error(v)})}h.end()}async getStatus(c,h){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(o),h.end()}catch(o){h.writeHead(500),h.write(String(o),v=>{v&&this.logService.error(v)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let n=class extends P{constructor(c,h){super(c,h,(0,f.createRandomIPCHandle)())}};n=Ve([Be(0,k.IExtHostCommands),Be(1,y.ILogService)],n),e.CLIServer=n}),define(me[290],ge([0,1,73,277,272,5,280,40,262,2,10,7,289,105]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class o extends I.RequireInterceptor{_installInterceptor(){const A=this,E=J.__$__nodeRequire("module"),l=E._load;E._load=function(p,t,r){for(let s of A._alternatives){let i=s(p);if(i){p=i;break}}return A._factories.has(p)?A._factories.get(p).load(p,P.URI.file((0,h.realpathSync)(t.filename)),s=>l.apply(this,[s,t,r])):l.apply(this,arguments)}}}class v extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(o,A,this._registry).install(),f.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const a=process.send,p=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?a.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,E,l){if(E.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let a=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{A&&f.mark(`code/extHost/willLoadExtensionCode/${A.value}`),a=J.__$__nodeRequire(E.fsPath)}catch(p){return Promise.reject(p)}finally{A&&f.mark(`code/extHost/didLoadExtensionCode/${A.value}`),l.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const E in A){const l=A[E];l===null?delete process.env[E]:process.env[E]=l}}}e.ExtHostExtensionService=v}),define(me[291],ge([0,1,82,263,265,274,273,288,290,230,266,53,40,68,74,72,34,52,12,69,264]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_,A,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(c.IExtHostExtensionService,y.ExtHostExtensionService),(0,f.registerSingleton)(E.ILogService,P.ExtHostLogService),(0,f.registerSingleton)(l.IExtensionStoragePaths,a.ExtensionStoragePaths),(0,f.registerSingleton)(T.IExtHostDebugService,R.ExtHostDebugService),(0,f.registerSingleton)(h.IExtHostOutputService,L.ExtHostOutputService2),(0,f.registerSingleton)(o.IExtHostSearch,C.NativeExtHostSearch),(0,f.registerSingleton)(v.IExtHostTask,k.ExtHostTask),(0,f.registerSingleton)(_.IExtHostTerminalService,I.ExtHostTerminalService),(0,f.registerSingleton)(A.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[292],ge([0,1,125,303,73,16,107,136,193,228,275,23,103,28,105,17,114,278,291]),function(J,e,f,L,I,k,R,C,y,P,n,T,c,h,o,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const A=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),g=i._load;i._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return g.apply(this,arguments)}})();const E=process.exit.bind(process);function l(i){process.exit=function(g){if(i)E(g);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)}}let a=function(i){E()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,g)=>{let u=null,d=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,D=3e5,m=new v.RunOnceScheduler(()=>a("renderer disconnected for too long (1)"),w),S=new v.RunOnceScheduler(()=>a("renderer disconnected for too long (2)"),D);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=T.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new C.NodeSocket(N);else{const M=T.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket(N),F.permessageDeflate,M,!1)}u?(m.cancel(),S.cancel(),u.beginAcceptReconnection(K,G),u.endAcceptReconnection()):(clearTimeout(d),u=new R.PersistentProtocol(K,G),u.onDidDispose(()=>a("renderer disconnected")),i(u),u.onSocketClose(()=>{m.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(S.isScheduled())return;m.isScheduled()&&S.schedule()}});const b={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(b)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((g,u)=>{const d=f.createConnection(i,()=>{d.removeListener("error",u),g(new R.PersistentProtocol(new C.NodeSocket(d)))});d.once("error",u),d.on("close",()=>{a("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(g=>{(0,P.isMessageOfType)(g,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(g)})}send(g){this._terminating||i.send(g)}drain(){return i.drain()}}}function r(i){return new Promise(g=>{const u=i.onMessage(d=>{u.dispose();const w=JSON.parse(d.toString()),D=w.commit,m=y.default.commit;D&&m&&D!==m&&E(55);const S=[];process.on("unhandledRejection",(N,G)=>{S.push(G),setTimeout(()=>{const K=S.indexOf(G);K>=0&&G.catch(M=>{S.splice(K,1),(0,k.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),(0,k.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const G=S.indexOf(N);G>=0&&S.splice(G,1)}),process.on("uncaughtException",function(N){(0,k.onUnexpectedError)(N)});let b=0;setInterval(function(){try{process.kill(w.parentPid,0),b=0}catch(N){N&&N.code==="EPERM"?(b++,b>=3&&a(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):a(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(w.parentPid)}catch(N){(0,k.onUnexpectedError)(N)}i.send((0,P.createMessageOfType)(0)),g({protocol:i,initData:w})});i.send((0,P.createMessageOfType)(1))})}async function s(){I.mark("code/extHost/willConnectToRenderer");const i=await t();I.mark("code/extHost/didConnectToRenderer");const g=await r(i);I.mark("code/extHost/didWaitForInitData");const{initData:u}=g;l(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,_.boolean)(A.skipWorkspaceStorageLock,!1);const d=new class{exit(S){E(S)}exists(S){return h.Promises.exists(S)}realpath(S){return(0,o.realpath)(S)}};let w=null;if(u.remote.authority&&A.uriTransformerPath)try{const S=J.__$__nodeRequire(A.uriTransformerPath)(u.remote.authority);w=new c.URITransformer(S)}catch(m){console.error(m)}const D=new n.ExtensionHostMain(g.protocol,u,d,w);a=m=>D.terminate(m)}e.startExtensionHostProcess=s}),define(me[304],ge([0,1,292]),function(J,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/83bd43bc519d15e50c4272c6cf5c1479df196a4d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
